// $ANTLR 3.2 Sep 23, 2009 14:05:07 org/deri/xsparql/rewriter/XSPARQLRewriter.g 2012-02-17 16:16:55

  package org.deri.xsparql.rewriter;

  import java.util.logging.Logger;
  import java.util.LinkedList;
  import java.util.UUID;
  import java.net.URL;
  import java.util.Iterator;

  import org.deri.xsparql.rewriter.Pair;
  import org.deri.sql.SQLQuery;


import org.antlr.runtime.*;
import org.antlr.runtime.tree.*;import java.util.Stack;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;

/**
 *
 * Copyright (C) 2011, NUI Galway.
 * All rights reserved.
 *
 * The software in this package is published under the terms of the BSD style license a copy of which has been included
 * with this distribution in the bsb_license.txt file and/or available on NUI Galway Server at
 * http://xsparql.deri.ie/license/bsd_license.txt
 *
 * Created: 09 February 2011, Reasoning and Querying Unit (URQ), Digital Enterprise Research Institute (DERI) on behalf of
 * NUI Galway.
 */
public class XSPARQLRewriter extends TreeParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "VAR", "ENDELM", "INTEGER", "LCURLY", "RCURLY", "NCNAME", "QSTRING", "DOT", "AT", "ASSIGN", "CARET", "CARETCARET", "COLON", "COMMA", "SLASH", "LBRACKET", "RBRACKET", "LPAR", "RPAR", "SEMICOLON", "STAR", "DOTDOT", "SLASHSLASH", "LESSTHAN", "GREATERTHAN", "PLUS", "MINUS", "UNIONSYMBOL", "QUESTIONMARK", "LESSTHANLESSTHAN", "GREATERTHANEQUALS", "LESSTHANEQUALS", "HAFENEQUALS", "EQUALS", "COLONCOLON", "BLANK_NODE_LABEL", "BNODE_CONSTRUCT", "IRI_CONSTRUCT", "ASK", "DESCRIBE", "SELECT", "PNAME_NS", "PNAME_LN", "CDATASTART", "CDATAELMEND", "RCURLYGREATERTHAN", "LESSTHANLCURLY", "ORSYMBOL", "ANDSYMBOL", "NOT", "WHITESPACE", "IRIREF", "NCNAMEELM", "ENDTAG", "A", "IS", "EQ", "NE", "LT", "GE", "LE", "GT", "FOR", "FROM", "LIMIT", "OFFSET", "LET", "ORDER", "BY", "ATS", "IN", "AS", "DESCENDING", "ASCENDING", "STABLE", "IF", "THEN", "ELSE", "RETURN", "CONSTRUCT", "WHERE", "GREATEST", "LEAST", "COLLATION", "CHILD", "DESCENDANT", "ATTRIBUTE", "SELF", "DESCENDANTORSELF", "FOLLOWINGSIBLING", "FOLLOWING", "PARENT", "ANCESTOR", "PRECEDINGSIBLING", "PRECEDING", "ANCESTORORSELF", "ORDERED", "UNORDERED", "DECLARE", "NAMESPACE", "DEFAULT", "ELEMENT", "FUNCTION", "BASEURI", "PREFIX", "BASE", "AND", "OR", "TO", "DIV", "IDIV", "MOD", "UNION", "INTERSECT", "EXCEPT", "INSTANCE", "TREAT", "CASTABLE", "CAST", "OF", "EMPTYSEQUENCE", "ITEM", "NODE", "DOCUMENTNODE", "TEXT", "COMMENT", "PROCESSINGINSTRUCTION", "SCHEMAATTRIBUTE", "SCHEMAELEMENT", "DOCUMENT", "NAMED", "OPTIONAL", "FILTER", "STR", "LANG", "LANGMATCHES", "DATATYPE", "BOUND", "ISIRI", "ISURI", "ISBLANK", "ISLITERAL", "REGEX", "TRUE", "FALSE", "GRAPH", "GREATERTHANGREATERTHAN", "DISTINCT", "GROUP", "HAVING", "ENDPOINT", "ROW", "T_NAMESPACE", "T_XML_ELEMENT", "T_XML_CONTENT", "T_XML_ATTRIBUTE", "T_FLWOR", "T_FUNCTION_DECL", "T_PARAMS", "T_FORLET", "T_WHERE", "T_SPARQL_FOR", "T_SPARQL_WHERE", "T_FOR", "T_LET", "T_CONSTRUCT", "T_ORDER", "T_RETURN", "T_UNION", "T_SQL_FOR", "T_SQL_WHERE", "T_SQL_FROM", "T_VAR", "T_TABLE", "T_BLANK", "T_ANON_BLANK", "T_EMPTY_ANON_BLANK", "T_SUBJECT", "T_VERB", "T_OBJECT", "T_MAIN", "T_PAR", "T_INSTANCEOF", "T_TYPE", "T_CASTAS", "T_CASTABLEAS", "T_TREATAS", "T_VARIABLE_DECL", "T_EXTERNAL_VARIABLE_DECL", "T_OPTION_DECL", "T_FUNCTION_CALL", "T_PARAM", "T_ORDER_BY", "T_STABLE_ORDER_BY", "T_GROUP_BY", "T_HAVING", "BOUNDARYSPACE", "STRIP", "VARIABLE", "IMPORT", "EXTERNAL", "NOPRESERVE", "PRESERVE", "CONSTRUCTION", "MODULE", "INHERIT", "NOINHERIT", "SCHEMA", "EMPTY", "ORDERING", "COPYNAMESPACES", "XQUERY", "VERSION", "ENCODING", "OPTION", "LAX", "CASE", "EVERY", "TYPESWITCH", "SATISFIES", "VALIDATE", "SOME", "STRICT", "ASC", "DESC", "T_MODULE_DECL", "T_VERSION", "T_BOUNDARYSPACE_DECL", "T_DEFAULT_DECL", "T_ORDER_DECL", "T_EMPTY_ORDER_DECL", "T_DEFAULT_COLLATION_DECL", "T_BASEURI_DECL", "T_MODULE_IMPORT", "T_SCHEMA_IMPORT", "T_QUERY_BODY", "T_BODY_PART", "XPATH", "T_LITERAL_CONSTRUCT", "T_IRI_CONSTRUCT", "T_EPILOGUE", "DECIMAL", "REWRITEVNODE", "REWRITEVNODE1", "DELETEVNODE", "T_QSTRING", "NOTHING", "T_XML_CONTENTS"
    };
    public static final int FUNCTION=106;
    public static final int ENDTAG=57;
    public static final int STAR=24;
    public static final int ROW=155;
    public static final int GRAPH=149;
    public static final int T_MODULE_DECL=229;
    public static final int MOD=115;
    public static final int T_BLANK=178;
    public static final int BNODE_CONSTRUCT=40;
    public static final int T_INSTANCEOF=186;
    public static final int REGEX=146;
    public static final int PNAME_LN=46;
    public static final int T_FOR=167;
    public static final int CONSTRUCT=83;
    public static final int T_RETURN=171;
    public static final int T_ORDER_BY=196;
    public static final int NOT=53;
    public static final int T_EPILOGUE=244;
    public static final int EXCEPT=118;
    public static final int EOF=-1;
    public static final int T_ORDER_DECL=233;
    public static final int T_XML_CONTENT=158;
    public static final int LBRACKET=19;
    public static final int T_OBJECT=183;
    public static final int ISLITERAL=145;
    public static final int IMPORT=203;
    public static final int IRIREF=55;
    public static final int GREATERTHANEQUALS=34;
    public static final int PRECEDING=98;
    public static final int RETURN=82;
    public static final int ELEMENT=105;
    public static final int COPYNAMESPACES=214;
    public static final int T_PARAMS=162;
    public static final int EQ=60;
    public static final int BOUND=141;
    public static final int GREATERTHANGREATERTHAN=150;
    public static final int CHILD=88;
    public static final int GE=63;
    public static final int A=58;
    public static final int STRICT=226;
    public static final int T_FUNCTION_DECL=161;
    public static final int PRESERVE=206;
    public static final int ASC=227;
    public static final int LESSTHANEQUALS=35;
    public static final int ELSE=81;
    public static final int ASK=42;
    public static final int TYPESWITCH=222;
    public static final int WHITESPACE=54;
    public static final int LCURLY=7;
    public static final int SEMICOLON=23;
    public static final int T_FORLET=163;
    public static final int T_SQL_FROM=175;
    public static final int REWRITEVNODE1=247;
    public static final int EMPTY=212;
    public static final int GROUP=152;
    public static final int INTERSECT=117;
    public static final int NCNAME=9;
    public static final int XPATH=241;
    public static final int T_WHERE=164;
    public static final int DESCRIBE=43;
    public static final int GT=65;
    public static final int DATATYPE=140;
    public static final int T_QSTRING=249;
    public static final int T_FLWOR=160;
    public static final int LANG=138;
    public static final int T_VERSION=230;
    public static final int OPTION=218;
    public static final int T_STABLE_ORDER_BY=197;
    public static final int T_CASTAS=188;
    public static final int T_BOUNDARYSPACE_DECL=231;
    public static final int T_VERB=182;
    public static final int VERSION=216;
    public static final int SATISFIES=223;
    public static final int IDIV=114;
    public static final int DESCENDANTORSELF=92;
    public static final int ATS=73;
    public static final int ASCENDING=77;
    public static final int AT=12;
    public static final int STR=137;
    public static final int AS=75;
    public static final int PARENT=95;
    public static final int CONSTRUCTION=207;
    public static final int SLASH=18;
    public static final int THEN=80;
    public static final int DOCUMENT=133;
    public static final int COLLATION=87;
    public static final int OFFSET=69;
    public static final int T_CONSTRUCT=169;
    public static final int ANCESTOR=96;
    public static final int PLUS=29;
    public static final int QSTRING=10;
    public static final int T_SUBJECT=181;
    public static final int CASTABLE=121;
    public static final int T_GROUP_BY=198;
    public static final int INTEGER=6;
    public static final int BY=72;
    public static final int LESSTHAN=27;
    public static final int EMPTYSEQUENCE=124;
    public static final int PRECEDINGSIBLING=97;
    public static final int ENDPOINT=154;
    public static final int T_SQL_WHERE=174;
    public static final int ITEM=125;
    public static final int TO=112;
    public static final int T_TREATAS=190;
    public static final int INHERIT=209;
    public static final int PNAME_NS=45;
    public static final int HAVING=153;
    public static final int ENDELM=5;
    public static final int MINUS=30;
    public static final int TEXT=128;
    public static final int MODULE=208;
    public static final int ORDERED=100;
    public static final int UNION=116;
    public static final int T_IRI_CONSTRUCT=243;
    public static final int T_DEFAULT_COLLATION_DECL=235;
    public static final int COLON=16;
    public static final int SCHEMA=211;
    public static final int T_CASTABLEAS=189;
    public static final int DECIMAL=245;
    public static final int VALIDATE=224;
    public static final int INSTANCE=119;
    public static final int PROCESSINGINSTRUCTION=130;
    public static final int NOINHERIT=210;
    public static final int LESSTHANLCURLY=50;
    public static final int RCURLY=8;
    public static final int T_PARAM=195;
    public static final int DECLARE=102;
    public static final int T_ANON_BLANK=179;
    public static final int DIV=113;
    public static final int DESCENDING=76;
    public static final int SELF=91;
    public static final int CAST=122;
    public static final int PREFIX=108;
    public static final int EXTERNAL=204;
    public static final int LT=62;
    public static final int UNIONSYMBOL=31;
    public static final int FOLLOWINGSIBLING=93;
    public static final int ORSYMBOL=51;
    public static final int CASE=220;
    public static final int ENCODING=217;
    public static final int EQUALS=37;
    public static final int SCHEMAATTRIBUTE=131;
    public static final int LPAR=21;
    public static final int T_VAR=176;
    public static final int CARET=14;
    public static final int LANGMATCHES=139;
    public static final int BASE=109;
    public static final int T_MODULE_IMPORT=237;
    public static final int VAR=4;
    public static final int T_NAMESPACE=156;
    public static final int T_SPARQL_WHERE=166;
    public static final int COMMENT=129;
    public static final int SELECT=44;
    public static final int ISIRI=142;
    public static final int NE=61;
    public static final int GREATERTHAN=28;
    public static final int BOUNDARYSPACE=200;
    public static final int REWRITEVNODE=246;
    public static final int NODE=126;
    public static final int CDATASTART=47;
    public static final int T_ORDER=170;
    public static final int GREATEST=85;
    public static final int BLANK_NODE_LABEL=39;
    public static final int T_MAIN=184;
    public static final int EVERY=221;
    public static final int T_FUNCTION_CALL=194;
    public static final int CDATAELMEND=48;
    public static final int OF=123;
    public static final int T_VARIABLE_DECL=191;
    public static final int NAMESPACE=103;
    public static final int ISBLANK=144;
    public static final int T_BASEURI_DECL=236;
    public static final int T_PAR=185;
    public static final int COLONCOLON=38;
    public static final int T_XML_ELEMENT=157;
    public static final int VARIABLE=202;
    public static final int SLASHSLASH=26;
    public static final int T_XML_CONTENTS=251;
    public static final int NOPRESERVE=205;
    public static final int T_EXTERNAL_VARIABLE_DECL=192;
    public static final int NAMED=134;
    public static final int OR=111;
    public static final int FILTER=136;
    public static final int RCURLYGREATERTHAN=49;
    public static final int IRI_CONSTRUCT=41;
    public static final int CARETCARET=15;
    public static final int FROM=67;
    public static final int FALSE=148;
    public static final int DISTINCT=151;
    public static final int WHERE=84;
    public static final int LAX=219;
    public static final int HAFENEQUALS=36;
    public static final int ORDER=71;
    public static final int LIMIT=68;
    public static final int T_HAVING=199;
    public static final int ATTRIBUTE=90;
    public static final int FOR=66;
    public static final int DOTDOT=25;
    public static final int AND=110;
    public static final int FOLLOWING=94;
    public static final int T_XML_ATTRIBUTE=159;
    public static final int IF=79;
    public static final int ISURI=143;
    public static final int SCHEMAELEMENT=132;
    public static final int IN=74;
    public static final int COMMA=17;
    public static final int IS=59;
    public static final int SOME=225;
    public static final int QUESTIONMARK=32;
    public static final int T_SCHEMA_IMPORT=238;
    public static final int T_BODY_PART=240;
    public static final int NOTHING=250;
    public static final int T_QUERY_BODY=239;
    public static final int STRIP=201;
    public static final int RBRACKET=20;
    public static final int DOT=11;
    public static final int STABLE=78;
    public static final int T_OPTION_DECL=193;
    public static final int XQUERY=215;
    public static final int DELETEVNODE=248;
    public static final int ANDSYMBOL=52;
    public static final int DEFAULT=104;
    public static final int NCNAMEELM=56;
    public static final int DESCENDANT=89;
    public static final int T_SPARQL_FOR=165;
    public static final int T_LITERAL_CONSTRUCT=242;
    public static final int TRUE=147;
    public static final int BASEURI=107;
    public static final int T_TABLE=177;
    public static final int UNORDERED=101;
    public static final int OPTIONAL=135;
    public static final int T_TYPE=187;
    public static final int T_UNION=172;
    public static final int T_LET=168;
    public static final int T_EMPTY_ORDER_DECL=234;
    public static final int ORDERING=213;
    public static final int ASSIGN=13;
    public static final int T_EMPTY_ANON_BLANK=180;
    public static final int T_SQL_FOR=173;
    public static final int DOCUMENTNODE=127;
    public static final int LESSTHANLESSTHAN=33;
    public static final int LEAST=86;
    public static final int RPAR=22;
    public static final int T_DEFAULT_DECL=232;
    public static final int DESC=228;
    public static final int ANCESTORORSELF=99;
    public static final int TREAT=120;
    public static final int LE=64;
    public static final int LET=70;

    // delegates
    // delegators

    protected static class VariableScope_scope {
        Map<String, Types> variables;
        List<String> positions;
        boolean scopedDataset;
        boolean sparqlClause;
    }
    protected Stack VariableScope_stack = new Stack();


        public XSPARQLRewriter(TreeNodeStream input) {
            this(input, new RecognizerSharedState());
        }
        public XSPARQLRewriter(TreeNodeStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        
    protected TreeAdaptor adaptor = new CommonTreeAdaptor();

    public void setTreeAdaptor(TreeAdaptor adaptor) {
        this.adaptor = adaptor;
    }
    public TreeAdaptor getTreeAdaptor() {
        return adaptor;
    }

    public String[] getTokenNames() { return XSPARQLRewriter.tokenNames; }
    public String getGrammarFileName() { return "org/deri/xsparql/rewriter/XSPARQLRewriter.g"; }


      private static final Logger logger = Logger.getLogger(XSPARQLRewriter.class.getClass().getName());

      /** Types for variables */
      private enum Types {
       XQUERY, SPARQL, SQL, SQL_ROW, RDF_GRAPH 
     }

      /** Handle namespaces */
      private final Map<String, String> namespaces = new HashMap<String, String>();

      /** global stack for scoped datasets */
      private final Stack<ScopedDataset> scopedDataset = new Stack<ScopedDataset>();

      /** final part of the tree, used for postprocesssing, e.g. delete scopedDatasets */
      private final CommonTree epilogue = (CommonTree) adaptor.nil();
      
      /**
       * use validating XQuery engine
       */
      private boolean validatingXQuery = false;
      
      public void setValidatingXQuery(boolean b) {
        this.validatingXQuery = b;
      }
      
      private boolean warnIfNestedConstruct = false;
      
      public void setWarnIfNestedConstruct(boolean warnIfNestedConstruct) {
        this.warnIfNestedConstruct = warnIfNestedConstruct;
      }
      
      private String sparqlmethod;
      
      public void setSPARQLMethod(String sparqlmethod) {
        this.sparqlmethod = sparqlmethod;
      }
      
      private String endpointURI;
      
      public void setEndpointURI(String endpointURI) {
        this.endpointURI = endpointURI;
      }
      
      /*
       * Create a debug version of the rewritten query
       * The debug version will print all the SPARQL queries on the stdout before sending to the SPARQL engine
       */
      private boolean debugVersion = false;
      
      public void setDebugVersion(boolean debugVersion) {
        this.debugVersion = debugVersion;
      }
      
      
      /**
       * XQuery engine to be used for evaluation/code production.
       */
      private String xqueryEngine = "saxon-he";
    	
      public void setXQueryEngine(String xqueryEngine) {
        this.xqueryEngine = xqueryEngine;
      }

      /** Add a namespace prefix and the corresponding IRI */
      private void addNamespace(final String name, final String iri) {
        logger.entering(this.getClass().getCanonicalName(), "addNamespace", new String[]{name, iri});

        namespaces.put(name, iri);
      }

      /** Get a string containing the SPARQL namespace declarations */
      private String getSPARQLNamespaces() {
         final StringBuffer sb = new StringBuffer();
         for(String key : namespaces.keySet()) {
            sb.append("PREFIX ");
            sb.append(key);
            if(!key.equals(":")) {
               sb.append(":");
            }
            sb.append(" <");
            sb.append(namespaces.get(key));
            sb.append("> ");
            sb.append(System.getProperties().getProperty("line.separator"));
         }

         return sb.toString();
      }


      private String getRDFNamespaceDecls() {
         final StringBuffer sb = new StringBuffer();
         for(String key : namespaces.keySet()) {
            sb.append("@prefix ");
            sb.append(key);
            if(!key.equals(":")) {
               sb.append(":");
            }
            sb.append(" <");
            sb.append(namespaces.get(key));
            sb.append("> . ");
            sb.append(System.getProperties().getProperty("line.separator"));
         }

         // if there are any prefixes, put a separator in the output
         if (sb.length() > 0) {
           sb.append(System.getProperties().getProperty("line.separator"));
         }
         
         return sb.toString();
      }

      // Create new temporary variables

      private int auxresultscounter = 0;
      private String getNewAuxResultsVariable() {
        logger.entering(this.getClass().getCanonicalName(), "getNewAuxResultsVariable");
        return "$_aux_results" + auxresultscounter++;
      }

      private int auxresultcounter = 0;
      private String getNewAuxResultVariable() {
        logger.entering(this.getClass().getCanonicalName(), "auxresultcounter");
        return "$_aux_result" + auxresultcounter++;
      }

      private int posvarcnt = 0;
      
      @Deprecated
      private String getNewPosVariableName() {
        logger.entering(this.getClass().getCanonicalName(), "getNewPosVariableName");
        return "$_pos" + posvarcnt++;
      }

      private int rdftermcnt = 0;
      private String getNewTempRdfTermVariable() {
        logger.entering(this.getClass().getCanonicalName(), "getNewTempRdfTermVariable");
        return "$_rdf" + rdftermcnt++;
      }

      // Variable scoping

      private void addVariableToScope(final String name) {
        addVariableToScope(name, Types.XQUERY);
      }

      private void addVariableToScope(final String name, final Types type) {
        logger.info(this.getClass().getCanonicalName() + " addVariableToScope "+ name);

        ((VariableScope_scope)VariableScope_stack.peek()).variables.put(name, type);
      }


      private void addVariablesToScope(final List<?> variables, final Types type) {
        logger.entering(this.getClass().getCanonicalName(), "addVariablesToScope");
        String text;
        for(Object o : variables) {
           final CommonTree tree = (CommonTree) o;
           
           if (type == Types.SQL) {
             int c = tree.getChildCount();
             text = ((CommonTree) tree.getChild(c-1)).getText();
           } else {
             if(tree.getChildCount() > 0 && ((CommonTree) tree.getChild(1)).getType() == T_FUNCTION_CALL)   // function_call
               text = tree.getChild(3).getText();
             else
               text  = tree.getText();
           }

           addVariableToScope(text, type);
        }
      }

      @Deprecated
      private void addVariablesStringToScope(final List<String> variables, final Types type) {
        logger.entering(this.getClass().getCanonicalName(), "addVariablesStringToScope");

        for(String o : variables) {
           addVariableToScope("$"+o, type);
        }
      }


      private void addPositionVariableToScope(final String name) {
        logger.entering(this.getClass().getCanonicalName(), "addPositionVariableToScope", name);
        ((VariableScope_scope)VariableScope_stack.peek()).positions.add(name);
      }

      private boolean isBound(final String name, Types type) {
        logger.info(this.getClass().getCanonicalName() +" isBoundType "+ name+type);
        
        Types t = containsVar(name, 1);
        if (t != null) {
         return t.equals(type);
        } else {
          return false;
        }
      }
      
      private boolean isBoundEarlier(final String name, Types type) {
        logger.info(this.getClass().getCanonicalName()+ "isBoundEarlierType"+ name+type);

        Types t = containsVar(name, 2);
        if (t != null) {
         return t.equals(type);
        } else {
          return false;
        }
      }

      private boolean isBound(final String name) {
        logger.info(this.getClass().getCanonicalName()+ "isBound"+ name);
        return containsVar(name, 1) != null;
      }
      
      private boolean isBoundEarlier(final String name) {
        logger.info(this.getClass().getCanonicalName()+ "isBoundEarlier"+ name);
        return containsVar(name, 2) != null;
      }



      private Types containsVar(final String name, int pos) {
        logger.entering(this.getClass().getCanonicalName(), "isBound", name);
        for(int s=VariableScope_stack.size()-pos; s >= 0; s--) {
          if(((VariableScope_scope)VariableScope_stack.elementAt(s)).variables.containsKey(name)) {
            logger.exiting(this.getClass().getCanonicalName(), "isBound", "true");

           // Iterator iterator = ((VariableScope_scope)VariableScope_stack.elementAt(s)).variables.keySet().iterator();
           // while (iterator.hasNext()) {
           //    String key = iterator.next().toString();
           //    String value = ((VariableScope_scope)VariableScope_stack.elementAt(s)).variables.get(key).toString();
           //    System.out.println("VariableScope["+ s +"]: "+key + " " + value);
           // }

            return ((VariableScope_scope)VariableScope_stack.elementAt(s)).variables.get(name);
          }
        }
        logger.exiting(this.getClass().getCanonicalName(), "isBound", "false");
        return null;
      }

      private CommonTree getPositionVarList() {
        CommonTree ret = (CommonTree) adaptor.nil();
        
        for(int s=0; s < VariableScope_stack.size(); s++) {
          for(String name : ((VariableScope_scope)VariableScope_stack.elementAt(s)).positions) {
            adaptor.addChild(ret, (CommonTree)adaptor.create(QSTRING, "_"));
            adaptor.addChild(ret, (CommonTree)adaptor.create(VAR, name));
          }
        }
        
        return ret;
      }

      // CONSTANTS
      private static final String xsparqlNamespace = "http://xsparql.deri.org/demo/xquery/xsparql.xquery";


      private static final String xsparqlAbbrev = "_xsparql";
      private static final String javaExternalAbbrev = "_java";
      private String javaExternalURL;
      private static final String serializeFunction = xsparqlAbbrev + ":_serialize";
      private static final String rdfTermFunction = xsparqlAbbrev + ":_rdf_term";
      private static final String bindingTermFunction = xsparqlAbbrev+":_binding_term";

      private static String sparqlFunctionScopedCreate = xsparqlAbbrev+":createScopedDataset";
      private static String sparqlFunctionScopedInner = xsparqlAbbrev+":sparqlScopedDataset";
      private static String sparqlFunctionScopedDelete = xsparqlAbbrev+":deleteScopedDataset";
      private static String sparqlFunctionScopedPop = xsparqlAbbrev+":scopedDatasetPopResults";

      private String sparqlResultsFunctionNode;
      private static String storeGraphFunction;

      private static final String schemaAbbrev = "_sparql_result";
      private static final String schemaNamespace = "http://www.w3.org/2005/sparql-results#";
      private static String schemaURL = "http://xsparql.deri.org/demo/xquery/sparql.xsd";

      private static final String validSubjectFunction = xsparqlAbbrev+":_validSubject";
      private static final String validPredicateFunction = xsparqlAbbrev+":_validPredicate";
      private static final String validObjectFunction = xsparqlAbbrev+":_validObject";

      private static final String sparqlNamespaceAbbrev = "xsparql";
      private static final String sparqlFunctionsNamespace = "http://xsparql.deri.org/demo/xquery/sparql-functions.xquery";
      
      /*
      * set the library to be used
      */
      private String xsparqlLibURL = "http://xsparql.deri.org/demo/xquery/xsparql-types.xquery";
      private String sparqlLibURL  = "http://xsparql.deri.org/demo/xquery/sparql-functions.xquery";


      public void setLibraryVersion() {

        URL local = XSPARQLRewriter.class.getResource("/xquery/xsparql-types.xquery");
        if (local != null) {
          xsparqlLibURL = local.toString();
        }

        local = XSPARQLRewriter.class.getResource("/xquery/sparql-functions.xquery");
        if (local != null) {
          sparqlLibURL = local.toString();
        }

        if (!this.validatingXQuery) {
          local = XSPARQLRewriter.class.getResource("/xquery/xsparql.xquery");
          if (local != null) {
            xsparqlLibURL = local.toString();
          } else {
            xsparqlLibURL = "http://xsparql.deri.org/demo/xquery/xsparql.xquery";
          }
        }

    //    if(Configuration.debugVersion()) {
    //      local = XSPARQLRewriter.class.getResource("/xquery/xsparql-types.debug.xquery");
    //      if (local != null) {
    //        xsparqlLibURL = local.toString();
    //      } else {
    //        xsparqlLibURL = "http://xsparql.deri.org/demo/xquery/xsparql-types.debug.xquery";
    //      }
    //    } 

      }
      

      public CommonTree createSchemaImport() {
        CommonTree ret = (CommonTree) adaptor.nil();
        
        //    ^(T_SCHEMA_IMPORT ^(NAMESPACE NCNAME[schemaAbbrev]) QSTRING[schemaNamespace] ^(AT QSTRING[schemaURL]))
        if (this.validatingXQuery) {
          URL local = XSPARQLRewriter.class.getResource("/xquery/sparql.xsd");
          if (local != null) {
            schemaURL = local.toString();
          }

          CommonTree at = (CommonTree) adaptor.create(AT, "AT");
          adaptor.addChild(at, adaptor.create(QSTRING, schemaURL));

          CommonTree ns = (CommonTree) adaptor.create(NAMESPACE, "NAMESPACE");
          adaptor.addChild(ns, adaptor.create(NCNAME, schemaAbbrev));

          ret = (CommonTree) adaptor.create(T_SCHEMA_IMPORT, "T_SCHEMA_IMPORT");
          adaptor.addChild(ret, ns);
          adaptor.addChild(ret, adaptor.create(QSTRING, schemaNamespace));
          adaptor.addChild(ret, at);
        }

        return ret;
      }       

      private SQLQuery sqlQuery = null;

      /**
       * set the database connection
       */
      public void setDBconnection(SQLQuery q) {
        this.sqlQuery = q;
      }

      private String evaluationFunction = "";
      private String iterationFunction = "";

      private String SQLevaluationFunction = "";
      private String SQLiterationFunction = "";


      /**
       * set the evaluation method for SPARQL queries:
       *     arq = using saxon integrated (no need for an endpoint)
       *     joseki =  using a SPARQL endpoint (default)
       */
      public void setEvaluationMethod() {

        String externalFunctionAbbrev = "";

        // defaults, use joseki
        this.iterationFunction = xsparqlAbbrev+":_sparqlResults";
        this.evaluationFunction = xsparqlAbbrev+":_sparql";

        this.SQLevaluationFunction = xsparqlAbbrev+":_sqlQuery";
        this.SQLiterationFunction = xsparqlAbbrev+":_sqlResults";

        // Qexo engine
        if (this.xqueryEngine.equals("qexo")) {
          this.javaExternalURL = "class:org.deri.xquery.qexo.Sparql";

          if (this.sparqlmethod.equals("arq")) {
            this.evaluationFunction = javaExternalAbbrev+":sparqlResultsIterator";
            this.sparqlResultsFunctionNode = xsparqlAbbrev+":_sparqlResultsFromNode";
            this.iterationFunction = "iterator-items";
            externalFunctionAbbrev = javaExternalAbbrev;
          } 
        } 

        // saxon engine
        if (this.xqueryEngine.equals("saxon-he") || this.xqueryEngine.equals("saxon-ee")) {
          this.javaExternalURL = "java:org.deri.xquery.saxon.Sparql";
          externalFunctionAbbrev = xsparqlAbbrev;

          if (this.sparqlmethod.equals("arq")) {
            this.evaluationFunction = externalFunctionAbbrev+":_sparqlQuery";
            this.sparqlResultsFunctionNode = xsparqlAbbrev+":_sparqlResultsFromNode";
            this.iterationFunction = sparqlResultsFunctionNode; 

          }
        }

        sparqlFunctionScopedCreate = externalFunctionAbbrev+":createScopedDataset";
        sparqlFunctionScopedInner = externalFunctionAbbrev+":sparqlScopedDataset";
        sparqlFunctionScopedDelete = externalFunctionAbbrev+":deleteScopedDataset";
        sparqlFunctionScopedPop = externalFunctionAbbrev+":scopedDatasetPopResults";
        storeGraphFunction = externalFunctionAbbrev+":turtleGraphToURI";
      
      }


      // stores the variable as a joinVariable for the scoped Dataset and creates a
      // tree with with text of the variable as a string
      public CommonTree addJoinVar(int tok, String text) {
        ((sparqlForClause_scope)sparqlForClause_stack.peek()).joinVars += text+",";

        return new CommonTree(new CommonToken(tok, text));
      }       

      public CommonTree endpointURI(String endpoint) {
        CommonTree ret = (CommonTree) adaptor.nil();

        if(endpoint != null) {
          ret = new CommonTree(new CommonToken(QSTRING, endpoint));
        } else if(this.endpointURI != null) {
          ret = new CommonTree(new CommonToken(QSTRING, this.endpointURI));
        }

        return ret;
      }       


      public void changeTreeToScopedDataset() {
        logger.info("Entering changeTreeToScopedDataset");

        logger.info(scopedDataset.peek().toString());
        ScopedDataset sd = scopedDataset.peek();

        CommonTree functionTree = sd.getFunctionTree();
        if(!functionTree.isNil()) {
          Token tk1 = functionTree.getToken();
          tk1.setText(sparqlFunctionScopedCreate);
        }
        
        CommonTree resultsTree = sd.getResultsTree();
        if(!resultsTree.isNil()) {
          Token tk2 = resultsTree.getToken();
          tk2.setText(sparqlResultsFunctionNode);
        }

        String id = sd.getId();
        CommonTree idTree = sd.getIdTree();
        if(!idTree.isNil()) {
          Token tk3 = idTree.getToken();
          tk3.setText(id);
          tk3.setType(QSTRING);
        }
        
        // add the delete call to the epilogue
        if(!functionTree.isNil() && !resultsTree.isNil() && !idTree.isNil()) {
          CommonTree part = (CommonTree) adaptor.create(T_BODY_PART, "T_BODY_PART");
          adaptor.addChild(epilogue, part);

          CommonTree del = (CommonTree) adaptor.create(XPATH, "XPATH");
          adaptor.addChild(part, del);

          CommonTree func = (CommonTree) adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL");
          adaptor.addChild(del, func);

          CommonTree params = (CommonTree) adaptor.create(T_PARAMS, "T_PARAMS");
          CommonTree xpath = (CommonTree) adaptor.create(XPATH, "XPATH");
          adaptor.addChild(xpath, adaptor.create(QSTRING, id));
          adaptor.addChild(params, xpath);
          
          adaptor.addChild(func, adaptor.create(NCNAME, sparqlFunctionScopedDelete));
          adaptor.addChild(func, params);
        }
      }


      // returns the tree with the variable and saves the info that there has been
      // at least one unbound variable
      public CommonTree unboundVar(String var) {
        ((sparqlForClause_scope)sparqlForClause_stack.peek()).containsVars = true;

        return new CommonTree(new CommonToken(VAR, var));
      }       


      // If there is at least an unbound var return a tree with the variables, 
      // otherwise return a tree with the string *
      private CommonTree getVarList(final List<?> variables) {
        logger.info("Entering getVarList");

        CommonTree res = (CommonTree) adaptor.nil();
        
         for(Object o : variables) {
            if(((CommonTree) o).getType() == NOTHING) { continue; }
              CommonTree t = (CommonTree) adaptor.create(new CommonToken(REWRITEVNODE1));
              adaptor.addChild(t, (CommonTree) o);
              adaptor.addChild(res, t);
            }

          if(res.getChildCount() == 0) 
          {
            res = (CommonTree) adaptor.create(new CommonToken(REWRITEVNODE1));
            adaptor.addChild(res, adaptor.create(VAR, "*"));
          } 

        return res;
      } 


      // inserts a function call to the pop function if there was a scopeddataset
      private CommonTree generatePop() {
        logger.info("Entering generatePop");

        CommonTree res = (CommonTree) adaptor.nil();
        
        logger.info("generatePop: "+((VariableScope_scope)VariableScope_stack.peek()).scopedDataset+", "+((VariableScope_scope)VariableScope_stack.peek()).sparqlClause);

        if(((VariableScope_scope)VariableScope_stack.peek()).sparqlClause && ((VariableScope_scope)VariableScope_stack.peek()).scopedDataset) 
          {
            res = (CommonTree) adaptor.create(T_FLWOR, "T_FLWOR");
            CommonTree xpath = (CommonTree) adaptor.create(XPATH, "XPATH");
            CommonTree func = (CommonTree) adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL");
            CommonTree params = (CommonTree) adaptor.create(T_PARAMS, "T_PARAMS");
            adaptor.addChild(params, adaptor.create(QSTRING, scopedDataset.peek().getId()));

            adaptor.addChild(func, adaptor.create(NCNAME, sparqlFunctionScopedPop));
            adaptor.addChild(func, params);

            adaptor.addChild(xpath, (CommonTree) adaptor.create(NCNAME, ","));
            adaptor.addChild(xpath, func);
            adaptor.addChild(res, xpath);
          } 

        return res;
      } 


      private CommonTree getVarNodes(final List<String> variables, String auxVariable) {

        CommonTree res = (CommonTree) adaptor.nil();
        
        for(String o : variables) {
          CommonTree v = (CommonTree) adaptor.create(new CommonToken(T_VAR));
          adaptor.addChild(v, adaptor.create(new CommonToken(QSTRING, o)));
          adaptor.addChild(v, adaptor.create(new CommonToken(VAR, o)));

          CommonTree t = (CommonTree) adaptor.create(new CommonToken(REWRITEVNODE, auxVariable));
          adaptor.addChild(t, v);
          adaptor.addChild(res, t);
        }

        return res;
      } 
      
      private CommonTree getVars(final List<String> variables) {

        CommonTree res = (CommonTree) adaptor.nil();
        
        for(String o : variables) {
          adaptor.addChild(res, adaptor.create(new CommonToken(VAR, "$"+o)));
       }

        return res;
      } 

    // format the select line correctly
    protected String concat(List<String> list, String separator) {
        String res = "";
        String sep = "";
        for (String s : list) {
          res += sep + format(s) + " AS \"\"" + s +"\"\"";
          sep = separator;
        }
         
        return res;
      }


    protected String format(String relation) {
      logger.info("format: "+relation);
      if (relation.matches("\\.")) {
        logger.info("format-true");
        String[] split = relation.split("\\.");
        return "\"\"" + split[0] +"\"\".\"\"" + split[1] +"\"\"" ;
      } else {
        logger.info("format-false");
        return relation;
      }

    }




    public static class root_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "root"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:801:1: root : ( versionDecl )? ( libraryModule | mainModule ) ;
    public final XSPARQLRewriter.root_return root() throws RecognitionException {
        XSPARQLRewriter.root_return retval = new XSPARQLRewriter.root_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.versionDecl_return versionDecl1 = null;

        XSPARQLRewriter.libraryModule_return libraryModule2 = null;

        XSPARQLRewriter.mainModule_return mainModule3 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:802:3: ( ( versionDecl )? ( libraryModule | mainModule ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:802:5: ( versionDecl )? ( libraryModule | mainModule )
            {
            root_0 = (CommonTree)adaptor.nil();

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:802:5: ( versionDecl )?
            int alt1=2;
            switch ( input.LA(1) ) {
                case T_VERSION:
                    {
                    alt1=1;
                    }
                    break;
            }

            switch (alt1) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: versionDecl
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_versionDecl_in_root924);
                    versionDecl1=versionDecl();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, versionDecl1.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:802:18: ( libraryModule | mainModule )
            int alt2=2;
            switch ( input.LA(1) ) {
            case T_MODULE_DECL:
                {
                alt2=1;
                }
                break;
            case T_MAIN:
                {
                alt2=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 2, 0, input);

                throw nvae;
            }

            switch (alt2) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:802:19: libraryModule
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_libraryModule_in_root928);
                    libraryModule2=libraryModule();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, libraryModule2.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:802:35: mainModule
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_mainModule_in_root932);
                    mainModule3=mainModule();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, mainModule3.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "root"

    public static class versionDecl_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "versionDecl"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:805:1: versionDecl : ^( T_VERSION stringliteral ^( ENCODING ( stringliteral )? ) ) ;
    public final XSPARQLRewriter.versionDecl_return versionDecl() throws RecognitionException {
        XSPARQLRewriter.versionDecl_return retval = new XSPARQLRewriter.versionDecl_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_VERSION4=null;
        CommonTree ENCODING6=null;
        XSPARQLRewriter.stringliteral_return stringliteral5 = null;

        XSPARQLRewriter.stringliteral_return stringliteral7 = null;


        CommonTree T_VERSION4_tree=null;
        CommonTree ENCODING6_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:806:3: ( ^( T_VERSION stringliteral ^( ENCODING ( stringliteral )? ) ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:806:5: ^( T_VERSION stringliteral ^( ENCODING ( stringliteral )? ) )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_VERSION4=(CommonTree)match(input,T_VERSION,FOLLOW_T_VERSION_in_versionDecl947); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_VERSION4_tree = (CommonTree)adaptor.dupNode(T_VERSION4);

            root_1 = (CommonTree)adaptor.becomeRoot(T_VERSION4_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_stringliteral_in_versionDecl949);
            stringliteral5=stringliteral();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, stringliteral5.getTree());
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_2 = _last;
            CommonTree _first_2 = null;
            CommonTree root_2 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            ENCODING6=(CommonTree)match(input,ENCODING,FOLLOW_ENCODING_in_versionDecl952); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            ENCODING6_tree = (CommonTree)adaptor.dupNode(ENCODING6);

            root_2 = (CommonTree)adaptor.becomeRoot(ENCODING6_tree, root_2);
            }


            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); if (state.failed) return retval;
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:806:42: ( stringliteral )?
                int alt3=2;
                switch ( input.LA(1) ) {
                    case QSTRING:
                        {
                        alt3=1;
                        }
                        break;
                }

                switch (alt3) {
                    case 1 :
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: stringliteral
                        {
                        _last = (CommonTree)input.LT(1);
                        pushFollow(FOLLOW_stringliteral_in_versionDecl954);
                        stringliteral7=stringliteral();

                        state._fsp--;
                        if (state.failed) return retval;
                        if ( state.backtracking==0 ) 
                        adaptor.addChild(root_2, stringliteral7.getTree());

                        if ( state.backtracking==0 ) {
                        }
                        }
                        break;

                }


                match(input, Token.UP, null); if (state.failed) return retval;
            }adaptor.addChild(root_1, root_2);_last = _save_last_2;
            }


            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "versionDecl"

    public static class mainModule_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "mainModule"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:809:1: mainModule : ^( T_MAIN prolog queryBody ) ;
    public final XSPARQLRewriter.mainModule_return mainModule() throws RecognitionException {
        VariableScope_stack.push(new VariableScope_scope());

        XSPARQLRewriter.mainModule_return retval = new XSPARQLRewriter.mainModule_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_MAIN8=null;
        XSPARQLRewriter.prolog_return prolog9 = null;

        XSPARQLRewriter.queryBody_return queryBody10 = null;


        CommonTree T_MAIN8_tree=null;


          // initialize global scopes
          ((VariableScope_scope)VariableScope_stack.peek()).variables = new HashMap<String,Types>();
          ((VariableScope_scope)VariableScope_stack.peek()).positions = new LinkedList<String>();
          logger.info("Creating new variable scope: mainModule");

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:817:3: ( ^( T_MAIN prolog queryBody ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:817:5: ^( T_MAIN prolog queryBody )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_MAIN8=(CommonTree)match(input,T_MAIN,FOLLOW_T_MAIN_in_mainModule982); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_MAIN8_tree = (CommonTree)adaptor.dupNode(T_MAIN8);

            root_1 = (CommonTree)adaptor.becomeRoot(T_MAIN8_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_prolog_in_mainModule984);
            prolog9=prolog();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, prolog9.getTree());
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_queryBody_in_mainModule986);
            queryBody10=queryBody();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, queryBody10.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
            VariableScope_stack.pop();

        }
        return retval;
    }
    // $ANTLR end "mainModule"

    public static class libraryModule_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "libraryModule"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:820:1: libraryModule : moduleDecl prolog ;
    public final XSPARQLRewriter.libraryModule_return libraryModule() throws RecognitionException {
        XSPARQLRewriter.libraryModule_return retval = new XSPARQLRewriter.libraryModule_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.moduleDecl_return moduleDecl11 = null;

        XSPARQLRewriter.prolog_return prolog12 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:821:3: ( moduleDecl prolog )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:821:6: moduleDecl prolog
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_moduleDecl_in_libraryModule1001);
            moduleDecl11=moduleDecl();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, moduleDecl11.getTree());
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_prolog_in_libraryModule1003);
            prolog12=prolog();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, prolog12.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "libraryModule"

    public static class moduleDecl_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "moduleDecl"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:824:1: moduleDecl : ^( T_MODULE_DECL NCNAME uriliteral ) ;
    public final XSPARQLRewriter.moduleDecl_return moduleDecl() throws RecognitionException {
        XSPARQLRewriter.moduleDecl_return retval = new XSPARQLRewriter.moduleDecl_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_MODULE_DECL13=null;
        CommonTree NCNAME14=null;
        XSPARQLRewriter.uriliteral_return uriliteral15 = null;


        CommonTree T_MODULE_DECL13_tree=null;
        CommonTree NCNAME14_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:825:3: ( ^( T_MODULE_DECL NCNAME uriliteral ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:825:5: ^( T_MODULE_DECL NCNAME uriliteral )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_MODULE_DECL13=(CommonTree)match(input,T_MODULE_DECL,FOLLOW_T_MODULE_DECL_in_moduleDecl1017); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_MODULE_DECL13_tree = (CommonTree)adaptor.dupNode(T_MODULE_DECL13);

            root_1 = (CommonTree)adaptor.becomeRoot(T_MODULE_DECL13_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            NCNAME14=(CommonTree)match(input,NCNAME,FOLLOW_NCNAME_in_moduleDecl1019); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            NCNAME14_tree = (CommonTree)adaptor.dupNode(NCNAME14);

            adaptor.addChild(root_1, NCNAME14_tree);
            }
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_uriliteral_in_moduleDecl1021);
            uriliteral15=uriliteral();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, uriliteral15.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "moduleDecl"

    public static class prolog_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "prolog"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:828:1: prolog : ( baseDecl )? ( prolog1 )* ( prolog2 )* -> ( baseDecl )? COMMENT[\"modules imported by default\"] ^( T_MODULE_IMPORT ^( NAMESPACE NCNAME[xsparqlAbbrev] ) QSTRING[xsparqlNamespace] ^( AT QSTRING[xsparqlLibURL] ) ) ^( T_MODULE_IMPORT ^( NAMESPACE NCNAME[sparqlNamespaceAbbrev] ) QSTRING[sparqlFunctionsNamespace] ^( AT QSTRING[sparqlLibURL] ) ) ( prolog1 )* COMMENT[\"SPARQL prefix namespaces\"] ^( T_VARIABLE_DECL VAR[\"\\$_sparql_prefixes\"] ^( T_TYPE ) QSTRING[getSPARQLNamespaces()] ) ( prolog2 )* ;
    public final XSPARQLRewriter.prolog_return prolog() throws RecognitionException {
        XSPARQLRewriter.prolog_return retval = new XSPARQLRewriter.prolog_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.baseDecl_return baseDecl16 = null;

        XSPARQLRewriter.prolog1_return prolog117 = null;

        XSPARQLRewriter.prolog2_return prolog218 = null;


        RewriteRuleSubtreeStream stream_baseDecl=new RewriteRuleSubtreeStream(adaptor,"rule baseDecl");
        RewriteRuleSubtreeStream stream_prolog2=new RewriteRuleSubtreeStream(adaptor,"rule prolog2");
        RewriteRuleSubtreeStream stream_prolog1=new RewriteRuleSubtreeStream(adaptor,"rule prolog1");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:829:3: ( ( baseDecl )? ( prolog1 )* ( prolog2 )* -> ( baseDecl )? COMMENT[\"modules imported by default\"] ^( T_MODULE_IMPORT ^( NAMESPACE NCNAME[xsparqlAbbrev] ) QSTRING[xsparqlNamespace] ^( AT QSTRING[xsparqlLibURL] ) ) ^( T_MODULE_IMPORT ^( NAMESPACE NCNAME[sparqlNamespaceAbbrev] ) QSTRING[sparqlFunctionsNamespace] ^( AT QSTRING[sparqlLibURL] ) ) ( prolog1 )* COMMENT[\"SPARQL prefix namespaces\"] ^( T_VARIABLE_DECL VAR[\"\\$_sparql_prefixes\"] ^( T_TYPE ) QSTRING[getSPARQLNamespaces()] ) ( prolog2 )* )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:829:5: ( baseDecl )? ( prolog1 )* ( prolog2 )*
            {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:829:5: ( baseDecl )?
            int alt4=2;
            switch ( input.LA(1) ) {
                case T_NAMESPACE:
                    {
                    switch ( input.LA(2) ) {
                        case DOWN:
                            {
                            switch ( input.LA(3) ) {
                                case DEFAULT:
                                    {
                                    switch ( input.LA(4) ) {
                                        case IRIREF:
                                            {
                                            alt4=1;
                                            }
                                            break;
                                    }

                                    }
                                    break;
                            }

                            }
                            break;
                    }

                    }
                    break;
            }

            switch (alt4) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: baseDecl
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_baseDecl_in_prolog1035);
                    baseDecl16=baseDecl();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_baseDecl.add(baseDecl16.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:830:5: ( prolog1 )*
            loop5:
            do {
                int alt5=2;
                switch ( input.LA(1) ) {
                case DECLARE:
                case T_NAMESPACE:
                case COPYNAMESPACES:
                case T_BOUNDARYSPACE_DECL:
                case T_DEFAULT_DECL:
                case T_ORDER_DECL:
                case T_EMPTY_ORDER_DECL:
                case T_DEFAULT_COLLATION_DECL:
                case T_BASEURI_DECL:
                case T_MODULE_IMPORT:
                case T_SCHEMA_IMPORT:
                    {
                    alt5=1;
                    }
                    break;

                }

                switch (alt5) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: prolog1
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_prolog1_in_prolog1042);
            	    prolog117=prolog1();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_prolog1.add(prolog117.getTree());

            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    break loop5;
                }
            } while (true);

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:831:5: ( prolog2 )*
            loop6:
            do {
                int alt6=2;
                switch ( input.LA(1) ) {
                case T_FUNCTION_DECL:
                case T_VARIABLE_DECL:
                case T_EXTERNAL_VARIABLE_DECL:
                case T_OPTION_DECL:
                    {
                    alt6=1;
                    }
                    break;

                }

                switch (alt6) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: prolog2
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_prolog2_in_prolog1049);
            	    prolog218=prolog2();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_prolog2.add(prolog218.getTree());

            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    break loop6;
                }
            } while (true);



            // AST REWRITE
            // elements: prolog2, prolog1, baseDecl
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 832:3: -> ( baseDecl )? COMMENT[\"modules imported by default\"] ^( T_MODULE_IMPORT ^( NAMESPACE NCNAME[xsparqlAbbrev] ) QSTRING[xsparqlNamespace] ^( AT QSTRING[xsparqlLibURL] ) ) ^( T_MODULE_IMPORT ^( NAMESPACE NCNAME[sparqlNamespaceAbbrev] ) QSTRING[sparqlFunctionsNamespace] ^( AT QSTRING[sparqlLibURL] ) ) ( prolog1 )* COMMENT[\"SPARQL prefix namespaces\"] ^( T_VARIABLE_DECL VAR[\"\\$_sparql_prefixes\"] ^( T_TYPE ) QSTRING[getSPARQLNamespaces()] ) ( prolog2 )*
            {
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:833:5: ( baseDecl )?
                if ( stream_baseDecl.hasNext() ) {
                    adaptor.addChild(root_0, stream_baseDecl.nextTree());

                }
                stream_baseDecl.reset();
                adaptor.addChild(root_0, (CommonTree)adaptor.create(COMMENT, "modules imported by default"));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:835:5: ^( T_MODULE_IMPORT ^( NAMESPACE NCNAME[xsparqlAbbrev] ) QSTRING[xsparqlNamespace] ^( AT QSTRING[xsparqlLibURL] ) )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_MODULE_IMPORT, "T_MODULE_IMPORT"), root_1);

                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:835:23: ^( NAMESPACE NCNAME[xsparqlAbbrev] )
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(NAMESPACE, "NAMESPACE"), root_2);

                adaptor.addChild(root_2, (CommonTree)adaptor.create(NCNAME, xsparqlAbbrev));

                adaptor.addChild(root_1, root_2);
                }
                adaptor.addChild(root_1, (CommonTree)adaptor.create(QSTRING, xsparqlNamespace));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:835:84: ^( AT QSTRING[xsparqlLibURL] )
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(AT, "AT"), root_2);

                adaptor.addChild(root_2, (CommonTree)adaptor.create(QSTRING, xsparqlLibURL));

                adaptor.addChild(root_1, root_2);
                }

                adaptor.addChild(root_0, root_1);
                }
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:836:5: ^( T_MODULE_IMPORT ^( NAMESPACE NCNAME[sparqlNamespaceAbbrev] ) QSTRING[sparqlFunctionsNamespace] ^( AT QSTRING[sparqlLibURL] ) )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_MODULE_IMPORT, "T_MODULE_IMPORT"), root_1);

                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:836:23: ^( NAMESPACE NCNAME[sparqlNamespaceAbbrev] )
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(NAMESPACE, "NAMESPACE"), root_2);

                adaptor.addChild(root_2, (CommonTree)adaptor.create(NCNAME, sparqlNamespaceAbbrev));

                adaptor.addChild(root_1, root_2);
                }
                adaptor.addChild(root_1, (CommonTree)adaptor.create(QSTRING, sparqlFunctionsNamespace));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:836:100: ^( AT QSTRING[sparqlLibURL] )
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(AT, "AT"), root_2);

                adaptor.addChild(root_2, (CommonTree)adaptor.create(QSTRING, sparqlLibURL));

                adaptor.addChild(root_1, root_2);
                }

                adaptor.addChild(root_0, root_1);
                }
                adaptor.addChild(root_0,  createSchemaImport() );
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:838:5: ( prolog1 )*
                while ( stream_prolog1.hasNext() ) {
                    adaptor.addChild(root_0, stream_prolog1.nextTree());

                }
                stream_prolog1.reset();
                adaptor.addChild(root_0, (CommonTree)adaptor.create(COMMENT, "SPARQL prefix namespaces"));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:841:5: ^( T_VARIABLE_DECL VAR[\"\\$_sparql_prefixes\"] ^( T_TYPE ) QSTRING[getSPARQLNamespaces()] )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_VARIABLE_DECL, "T_VARIABLE_DECL"), root_1);

                adaptor.addChild(root_1, (CommonTree)adaptor.create(VAR, "$_sparql_prefixes"));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:841:49: ^( T_TYPE )
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_TYPE, "T_TYPE"), root_2);

                adaptor.addChild(root_1, root_2);
                }
                adaptor.addChild(root_1, (CommonTree)adaptor.create(QSTRING, getSPARQLNamespaces()));

                adaptor.addChild(root_0, root_1);
                }
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:842:5: ( prolog2 )*
                while ( stream_prolog2.hasNext() ) {
                    adaptor.addChild(root_0, stream_prolog2.nextTree());

                }
                stream_prolog2.reset();

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "prolog"

    public static class prolog1_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "prolog1"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:845:1: prolog1 : ( defaultNamespaceDecl | namespaceDecl | setter | importa | prefixDecl );
    public final XSPARQLRewriter.prolog1_return prolog1() throws RecognitionException {
        XSPARQLRewriter.prolog1_return retval = new XSPARQLRewriter.prolog1_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.defaultNamespaceDecl_return defaultNamespaceDecl19 = null;

        XSPARQLRewriter.namespaceDecl_return namespaceDecl20 = null;

        XSPARQLRewriter.setter_return setter21 = null;

        XSPARQLRewriter.importa_return importa22 = null;

        XSPARQLRewriter.prefixDecl_return prefixDecl23 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:846:3: ( defaultNamespaceDecl | namespaceDecl | setter | importa | prefixDecl )
            int alt7=5;
            switch ( input.LA(1) ) {
            case T_DEFAULT_DECL:
                {
                alt7=1;
                }
                break;
            case T_NAMESPACE:
                {
                switch ( input.LA(2) ) {
                case DOWN:
                    {
                    switch ( input.LA(3) ) {
                    case NCNAME:
                        {
                        alt7=2;
                        }
                        break;
                    case PNAME_NS:
                    case DEFAULT:
                        {
                        alt7=5;
                        }
                        break;
                    default:
                        if (state.backtracking>0) {state.failed=true; return retval;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 7, 5, input);

                        throw nvae;
                    }

                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 7, 2, input);

                    throw nvae;
                }

                }
                break;
            case DECLARE:
            case COPYNAMESPACES:
            case T_BOUNDARYSPACE_DECL:
            case T_ORDER_DECL:
            case T_EMPTY_ORDER_DECL:
            case T_DEFAULT_COLLATION_DECL:
            case T_BASEURI_DECL:
                {
                alt7=3;
                }
                break;
            case T_MODULE_IMPORT:
            case T_SCHEMA_IMPORT:
                {
                alt7=4;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 7, 0, input);

                throw nvae;
            }

            switch (alt7) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:846:5: defaultNamespaceDecl
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_defaultNamespaceDecl_in_prolog11177);
                    defaultNamespaceDecl19=defaultNamespaceDecl();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, defaultNamespaceDecl19.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:847:5: namespaceDecl
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_namespaceDecl_in_prolog11183);
                    namespaceDecl20=namespaceDecl();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, namespaceDecl20.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:848:5: setter
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_setter_in_prolog11189);
                    setter21=setter();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, setter21.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:849:5: importa
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_importa_in_prolog11195);
                    importa22=importa();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, importa22.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 5 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:850:5: prefixDecl
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_prefixDecl_in_prolog11201);
                    prefixDecl23=prefixDecl();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, prefixDecl23.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "prolog1"

    public static class prolog2_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "prolog2"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:853:1: prolog2 : ( varDecl | functionDecl | optionDecl );
    public final XSPARQLRewriter.prolog2_return prolog2() throws RecognitionException {
        XSPARQLRewriter.prolog2_return retval = new XSPARQLRewriter.prolog2_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.varDecl_return varDecl24 = null;

        XSPARQLRewriter.functionDecl_return functionDecl25 = null;

        XSPARQLRewriter.optionDecl_return optionDecl26 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:854:3: ( varDecl | functionDecl | optionDecl )
            int alt8=3;
            switch ( input.LA(1) ) {
            case T_VARIABLE_DECL:
            case T_EXTERNAL_VARIABLE_DECL:
                {
                alt8=1;
                }
                break;
            case T_FUNCTION_DECL:
                {
                alt8=2;
                }
                break;
            case T_OPTION_DECL:
                {
                alt8=3;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 8, 0, input);

                throw nvae;
            }

            switch (alt8) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:854:5: varDecl
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_varDecl_in_prolog21214);
                    varDecl24=varDecl();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, varDecl24.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:855:5: functionDecl
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_functionDecl_in_prolog21220);
                    functionDecl25=functionDecl();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, functionDecl25.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:856:5: optionDecl
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_optionDecl_in_prolog21226);
                    optionDecl26=optionDecl();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, optionDecl26.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "prolog2"

    public static class setter_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "setter"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:859:1: setter : ( boundarySpaceDecl | defaultCollationDecl | baseURIDecl | constructionDecl | orderingModeDecl | emptyOrderDecl | copyNamespacesDecl );
    public final XSPARQLRewriter.setter_return setter() throws RecognitionException {
        XSPARQLRewriter.setter_return retval = new XSPARQLRewriter.setter_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.boundarySpaceDecl_return boundarySpaceDecl27 = null;

        XSPARQLRewriter.defaultCollationDecl_return defaultCollationDecl28 = null;

        XSPARQLRewriter.baseURIDecl_return baseURIDecl29 = null;

        XSPARQLRewriter.constructionDecl_return constructionDecl30 = null;

        XSPARQLRewriter.orderingModeDecl_return orderingModeDecl31 = null;

        XSPARQLRewriter.emptyOrderDecl_return emptyOrderDecl32 = null;

        XSPARQLRewriter.copyNamespacesDecl_return copyNamespacesDecl33 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:860:3: ( boundarySpaceDecl | defaultCollationDecl | baseURIDecl | constructionDecl | orderingModeDecl | emptyOrderDecl | copyNamespacesDecl )
            int alt9=7;
            switch ( input.LA(1) ) {
            case T_BOUNDARYSPACE_DECL:
                {
                alt9=1;
                }
                break;
            case T_DEFAULT_COLLATION_DECL:
                {
                alt9=2;
                }
                break;
            case T_BASEURI_DECL:
                {
                alt9=3;
                }
                break;
            case DECLARE:
                {
                alt9=4;
                }
                break;
            case T_ORDER_DECL:
                {
                alt9=5;
                }
                break;
            case T_EMPTY_ORDER_DECL:
                {
                alt9=6;
                }
                break;
            case COPYNAMESPACES:
                {
                alt9=7;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 9, 0, input);

                throw nvae;
            }

            switch (alt9) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:860:5: boundarySpaceDecl
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_boundarySpaceDecl_in_setter1239);
                    boundarySpaceDecl27=boundarySpaceDecl();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, boundarySpaceDecl27.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:861:5: defaultCollationDecl
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_defaultCollationDecl_in_setter1245);
                    defaultCollationDecl28=defaultCollationDecl();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, defaultCollationDecl28.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:862:5: baseURIDecl
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_baseURIDecl_in_setter1251);
                    baseURIDecl29=baseURIDecl();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, baseURIDecl29.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:863:5: constructionDecl
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_constructionDecl_in_setter1257);
                    constructionDecl30=constructionDecl();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, constructionDecl30.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 5 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:864:5: orderingModeDecl
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_orderingModeDecl_in_setter1263);
                    orderingModeDecl31=orderingModeDecl();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, orderingModeDecl31.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 6 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:865:5: emptyOrderDecl
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_emptyOrderDecl_in_setter1269);
                    emptyOrderDecl32=emptyOrderDecl();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, emptyOrderDecl32.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 7 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:866:5: copyNamespacesDecl
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_copyNamespacesDecl_in_setter1275);
                    copyNamespacesDecl33=copyNamespacesDecl();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, copyNamespacesDecl33.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "setter"

    public static class importa_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "importa"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:869:1: importa : ( schemaImport | moduleImport );
    public final XSPARQLRewriter.importa_return importa() throws RecognitionException {
        XSPARQLRewriter.importa_return retval = new XSPARQLRewriter.importa_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.schemaImport_return schemaImport34 = null;

        XSPARQLRewriter.moduleImport_return moduleImport35 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:870:3: ( schemaImport | moduleImport )
            int alt10=2;
            switch ( input.LA(1) ) {
            case T_SCHEMA_IMPORT:
                {
                alt10=1;
                }
                break;
            case T_MODULE_IMPORT:
                {
                alt10=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 10, 0, input);

                throw nvae;
            }

            switch (alt10) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:870:5: schemaImport
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_schemaImport_in_importa1288);
                    schemaImport34=schemaImport();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, schemaImport34.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:870:20: moduleImport
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_moduleImport_in_importa1292);
                    moduleImport35=moduleImport();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, moduleImport35.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "importa"

    public static class namespaceDecl_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "namespaceDecl"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:873:1: namespaceDecl : ^( T_NAMESPACE name= NCNAME irix= QSTRING ) ;
    public final XSPARQLRewriter.namespaceDecl_return namespaceDecl() throws RecognitionException {
        XSPARQLRewriter.namespaceDecl_return retval = new XSPARQLRewriter.namespaceDecl_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree name=null;
        CommonTree irix=null;
        CommonTree T_NAMESPACE36=null;

        CommonTree name_tree=null;
        CommonTree irix_tree=null;
        CommonTree T_NAMESPACE36_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:874:3: ( ^( T_NAMESPACE name= NCNAME irix= QSTRING ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:874:5: ^( T_NAMESPACE name= NCNAME irix= QSTRING )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_NAMESPACE36=(CommonTree)match(input,T_NAMESPACE,FOLLOW_T_NAMESPACE_in_namespaceDecl1306); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_NAMESPACE36_tree = (CommonTree)adaptor.dupNode(T_NAMESPACE36);

            root_1 = (CommonTree)adaptor.becomeRoot(T_NAMESPACE36_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            name=(CommonTree)match(input,NCNAME,FOLLOW_NCNAME_in_namespaceDecl1310); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            name_tree = (CommonTree)adaptor.dupNode(name);

            adaptor.addChild(root_1, name_tree);
            }
            _last = (CommonTree)input.LT(1);
            irix=(CommonTree)match(input,QSTRING,FOLLOW_QSTRING_in_namespaceDecl1314); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            irix_tree = (CommonTree)adaptor.dupNode(irix);

            adaptor.addChild(root_1, irix_tree);
            }

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }

            if ( state.backtracking==0 ) {
              addNamespace((name!=null?name.getText():null), (irix!=null?irix.getText():null));
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "namespaceDecl"

    public static class boundarySpaceDecl_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "boundarySpaceDecl"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:877:1: boundarySpaceDecl : ^( T_BOUNDARYSPACE_DECL ( PRESERVE | STRIP ) ) ;
    public final XSPARQLRewriter.boundarySpaceDecl_return boundarySpaceDecl() throws RecognitionException {
        XSPARQLRewriter.boundarySpaceDecl_return retval = new XSPARQLRewriter.boundarySpaceDecl_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_BOUNDARYSPACE_DECL37=null;
        CommonTree set38=null;

        CommonTree T_BOUNDARYSPACE_DECL37_tree=null;
        CommonTree set38_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:878:3: ( ^( T_BOUNDARYSPACE_DECL ( PRESERVE | STRIP ) ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:878:5: ^( T_BOUNDARYSPACE_DECL ( PRESERVE | STRIP ) )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_BOUNDARYSPACE_DECL37=(CommonTree)match(input,T_BOUNDARYSPACE_DECL,FOLLOW_T_BOUNDARYSPACE_DECL_in_boundarySpaceDecl1331); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_BOUNDARYSPACE_DECL37_tree = (CommonTree)adaptor.dupNode(T_BOUNDARYSPACE_DECL37);

            root_1 = (CommonTree)adaptor.becomeRoot(T_BOUNDARYSPACE_DECL37_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            set38=(CommonTree)input.LT(1);
            if ( input.LA(1)==STRIP||input.LA(1)==PRESERVE ) {
                input.consume();

                if ( state.backtracking==0 ) {
                set38_tree = (CommonTree)adaptor.dupNode(set38);

                adaptor.addChild(root_1, set38_tree);
                }
                state.errorRecovery=false;state.failed=false;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }


            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "boundarySpaceDecl"

    public static class defaultNamespaceDecl_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "defaultNamespaceDecl"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:881:1: defaultNamespaceDecl : ^( T_DEFAULT_DECL ( ELEMENT | FUNCTION ) NAMESPACE irix= QSTRING ) ;
    public final XSPARQLRewriter.defaultNamespaceDecl_return defaultNamespaceDecl() throws RecognitionException {
        XSPARQLRewriter.defaultNamespaceDecl_return retval = new XSPARQLRewriter.defaultNamespaceDecl_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree irix=null;
        CommonTree T_DEFAULT_DECL39=null;
        CommonTree set40=null;
        CommonTree NAMESPACE41=null;

        CommonTree irix_tree=null;
        CommonTree T_DEFAULT_DECL39_tree=null;
        CommonTree set40_tree=null;
        CommonTree NAMESPACE41_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:882:3: ( ^( T_DEFAULT_DECL ( ELEMENT | FUNCTION ) NAMESPACE irix= QSTRING ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:882:5: ^( T_DEFAULT_DECL ( ELEMENT | FUNCTION ) NAMESPACE irix= QSTRING )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_DEFAULT_DECL39=(CommonTree)match(input,T_DEFAULT_DECL,FOLLOW_T_DEFAULT_DECL_in_defaultNamespaceDecl1352); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_DEFAULT_DECL39_tree = (CommonTree)adaptor.dupNode(T_DEFAULT_DECL39);

            root_1 = (CommonTree)adaptor.becomeRoot(T_DEFAULT_DECL39_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            set40=(CommonTree)input.LT(1);
            if ( (input.LA(1)>=ELEMENT && input.LA(1)<=FUNCTION) ) {
                input.consume();

                if ( state.backtracking==0 ) {
                set40_tree = (CommonTree)adaptor.dupNode(set40);

                adaptor.addChild(root_1, set40_tree);
                }
                state.errorRecovery=false;state.failed=false;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }

            _last = (CommonTree)input.LT(1);
            NAMESPACE41=(CommonTree)match(input,NAMESPACE,FOLLOW_NAMESPACE_in_defaultNamespaceDecl1360); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            NAMESPACE41_tree = (CommonTree)adaptor.dupNode(NAMESPACE41);

            adaptor.addChild(root_1, NAMESPACE41_tree);
            }
            _last = (CommonTree)input.LT(1);
            irix=(CommonTree)match(input,QSTRING,FOLLOW_QSTRING_in_defaultNamespaceDecl1364); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            irix_tree = (CommonTree)adaptor.dupNode(irix);

            adaptor.addChild(root_1, irix_tree);
            }

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }

            if ( state.backtracking==0 ) {
              addNamespace(":", (irix!=null?irix.getText():null));
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "defaultNamespaceDecl"

    public static class optionDecl_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "optionDecl"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:885:1: optionDecl : ^( T_OPTION_DECL qname stringliteral ) ;
    public final XSPARQLRewriter.optionDecl_return optionDecl() throws RecognitionException {
        XSPARQLRewriter.optionDecl_return retval = new XSPARQLRewriter.optionDecl_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_OPTION_DECL42=null;
        XSPARQLRewriter.qname_return qname43 = null;

        XSPARQLRewriter.stringliteral_return stringliteral44 = null;


        CommonTree T_OPTION_DECL42_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:886:3: ( ^( T_OPTION_DECL qname stringliteral ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:886:5: ^( T_OPTION_DECL qname stringliteral )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_OPTION_DECL42=(CommonTree)match(input,T_OPTION_DECL,FOLLOW_T_OPTION_DECL_in_optionDecl1381); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_OPTION_DECL42_tree = (CommonTree)adaptor.dupNode(T_OPTION_DECL42);

            root_1 = (CommonTree)adaptor.becomeRoot(T_OPTION_DECL42_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_qname_in_optionDecl1383);
            qname43=qname();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, qname43.getTree());
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_stringliteral_in_optionDecl1385);
            stringliteral44=stringliteral();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, stringliteral44.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "optionDecl"

    public static class orderingModeDecl_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "orderingModeDecl"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:889:1: orderingModeDecl : ^( T_ORDER_DECL ( ORDERED | UNORDERED ) ) ;
    public final XSPARQLRewriter.orderingModeDecl_return orderingModeDecl() throws RecognitionException {
        XSPARQLRewriter.orderingModeDecl_return retval = new XSPARQLRewriter.orderingModeDecl_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_ORDER_DECL45=null;
        CommonTree set46=null;

        CommonTree T_ORDER_DECL45_tree=null;
        CommonTree set46_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:890:3: ( ^( T_ORDER_DECL ( ORDERED | UNORDERED ) ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:890:5: ^( T_ORDER_DECL ( ORDERED | UNORDERED ) )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_ORDER_DECL45=(CommonTree)match(input,T_ORDER_DECL,FOLLOW_T_ORDER_DECL_in_orderingModeDecl1400); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_ORDER_DECL45_tree = (CommonTree)adaptor.dupNode(T_ORDER_DECL45);

            root_1 = (CommonTree)adaptor.becomeRoot(T_ORDER_DECL45_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            set46=(CommonTree)input.LT(1);
            if ( (input.LA(1)>=ORDERED && input.LA(1)<=UNORDERED) ) {
                input.consume();

                if ( state.backtracking==0 ) {
                set46_tree = (CommonTree)adaptor.dupNode(set46);

                adaptor.addChild(root_1, set46_tree);
                }
                state.errorRecovery=false;state.failed=false;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }


            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "orderingModeDecl"

    public static class emptyOrderDecl_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "emptyOrderDecl"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:893:1: emptyOrderDecl : ^( T_EMPTY_ORDER_DECL ( GREATEST | LEAST ) ) ;
    public final XSPARQLRewriter.emptyOrderDecl_return emptyOrderDecl() throws RecognitionException {
        XSPARQLRewriter.emptyOrderDecl_return retval = new XSPARQLRewriter.emptyOrderDecl_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_EMPTY_ORDER_DECL47=null;
        CommonTree set48=null;

        CommonTree T_EMPTY_ORDER_DECL47_tree=null;
        CommonTree set48_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:894:3: ( ^( T_EMPTY_ORDER_DECL ( GREATEST | LEAST ) ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:894:5: ^( T_EMPTY_ORDER_DECL ( GREATEST | LEAST ) )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_EMPTY_ORDER_DECL47=(CommonTree)match(input,T_EMPTY_ORDER_DECL,FOLLOW_T_EMPTY_ORDER_DECL_in_emptyOrderDecl1421); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_EMPTY_ORDER_DECL47_tree = (CommonTree)adaptor.dupNode(T_EMPTY_ORDER_DECL47);

            root_1 = (CommonTree)adaptor.becomeRoot(T_EMPTY_ORDER_DECL47_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            set48=(CommonTree)input.LT(1);
            if ( (input.LA(1)>=GREATEST && input.LA(1)<=LEAST) ) {
                input.consume();

                if ( state.backtracking==0 ) {
                set48_tree = (CommonTree)adaptor.dupNode(set48);

                adaptor.addChild(root_1, set48_tree);
                }
                state.errorRecovery=false;state.failed=false;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }


            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "emptyOrderDecl"

    public static class copyNamespacesDecl_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "copyNamespacesDecl"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:897:1: copyNamespacesDecl : ^( COPYNAMESPACES preserveMode inheritMode ) ;
    public final XSPARQLRewriter.copyNamespacesDecl_return copyNamespacesDecl() throws RecognitionException {
        XSPARQLRewriter.copyNamespacesDecl_return retval = new XSPARQLRewriter.copyNamespacesDecl_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree COPYNAMESPACES49=null;
        XSPARQLRewriter.preserveMode_return preserveMode50 = null;

        XSPARQLRewriter.inheritMode_return inheritMode51 = null;


        CommonTree COPYNAMESPACES49_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:898:3: ( ^( COPYNAMESPACES preserveMode inheritMode ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:898:5: ^( COPYNAMESPACES preserveMode inheritMode )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            COPYNAMESPACES49=(CommonTree)match(input,COPYNAMESPACES,FOLLOW_COPYNAMESPACES_in_copyNamespacesDecl1442); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            COPYNAMESPACES49_tree = (CommonTree)adaptor.dupNode(COPYNAMESPACES49);

            root_1 = (CommonTree)adaptor.becomeRoot(COPYNAMESPACES49_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_preserveMode_in_copyNamespacesDecl1444);
            preserveMode50=preserveMode();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, preserveMode50.getTree());
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_inheritMode_in_copyNamespacesDecl1446);
            inheritMode51=inheritMode();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, inheritMode51.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "copyNamespacesDecl"

    public static class preserveMode_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "preserveMode"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:901:1: preserveMode : ( PRESERVE | NOPRESERVE );
    public final XSPARQLRewriter.preserveMode_return preserveMode() throws RecognitionException {
        XSPARQLRewriter.preserveMode_return retval = new XSPARQLRewriter.preserveMode_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree set52=null;

        CommonTree set52_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:902:3: ( PRESERVE | NOPRESERVE )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            set52=(CommonTree)input.LT(1);
            if ( (input.LA(1)>=NOPRESERVE && input.LA(1)<=PRESERVE) ) {
                input.consume();

                if ( state.backtracking==0 ) {
                set52_tree = (CommonTree)adaptor.dupNode(set52);

                adaptor.addChild(root_0, set52_tree);
                }
                state.errorRecovery=false;state.failed=false;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }

            if ( state.backtracking==0 ) {
            } 

            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "preserveMode"

    public static class inheritMode_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "inheritMode"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:906:1: inheritMode : ( INHERIT | NOINHERIT );
    public final XSPARQLRewriter.inheritMode_return inheritMode() throws RecognitionException {
        XSPARQLRewriter.inheritMode_return retval = new XSPARQLRewriter.inheritMode_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree set53=null;

        CommonTree set53_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:907:3: ( INHERIT | NOINHERIT )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            set53=(CommonTree)input.LT(1);
            if ( (input.LA(1)>=INHERIT && input.LA(1)<=NOINHERIT) ) {
                input.consume();

                if ( state.backtracking==0 ) {
                set53_tree = (CommonTree)adaptor.dupNode(set53);

                adaptor.addChild(root_0, set53_tree);
                }
                state.errorRecovery=false;state.failed=false;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }

            if ( state.backtracking==0 ) {
            } 

            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "inheritMode"

    public static class defaultCollationDecl_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "defaultCollationDecl"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:911:1: defaultCollationDecl : ^( T_DEFAULT_COLLATION_DECL uriliteral ) ;
    public final XSPARQLRewriter.defaultCollationDecl_return defaultCollationDecl() throws RecognitionException {
        XSPARQLRewriter.defaultCollationDecl_return retval = new XSPARQLRewriter.defaultCollationDecl_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_DEFAULT_COLLATION_DECL54=null;
        XSPARQLRewriter.uriliteral_return uriliteral55 = null;


        CommonTree T_DEFAULT_COLLATION_DECL54_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:912:3: ( ^( T_DEFAULT_COLLATION_DECL uriliteral ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:912:5: ^( T_DEFAULT_COLLATION_DECL uriliteral )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_DEFAULT_COLLATION_DECL54=(CommonTree)match(input,T_DEFAULT_COLLATION_DECL,FOLLOW_T_DEFAULT_COLLATION_DECL_in_defaultCollationDecl1499); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_DEFAULT_COLLATION_DECL54_tree = (CommonTree)adaptor.dupNode(T_DEFAULT_COLLATION_DECL54);

            root_1 = (CommonTree)adaptor.becomeRoot(T_DEFAULT_COLLATION_DECL54_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_uriliteral_in_defaultCollationDecl1501);
            uriliteral55=uriliteral();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, uriliteral55.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "defaultCollationDecl"

    public static class baseURIDecl_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "baseURIDecl"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:915:1: baseURIDecl : ^( T_BASEURI_DECL QSTRING ) ;
    public final XSPARQLRewriter.baseURIDecl_return baseURIDecl() throws RecognitionException {
        XSPARQLRewriter.baseURIDecl_return retval = new XSPARQLRewriter.baseURIDecl_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_BASEURI_DECL56=null;
        CommonTree QSTRING57=null;

        CommonTree T_BASEURI_DECL56_tree=null;
        CommonTree QSTRING57_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:916:3: ( ^( T_BASEURI_DECL QSTRING ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:916:5: ^( T_BASEURI_DECL QSTRING )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_BASEURI_DECL56=(CommonTree)match(input,T_BASEURI_DECL,FOLLOW_T_BASEURI_DECL_in_baseURIDecl1516); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_BASEURI_DECL56_tree = (CommonTree)adaptor.dupNode(T_BASEURI_DECL56);

            root_1 = (CommonTree)adaptor.becomeRoot(T_BASEURI_DECL56_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            QSTRING57=(CommonTree)match(input,QSTRING,FOLLOW_QSTRING_in_baseURIDecl1518); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            QSTRING57_tree = (CommonTree)adaptor.dupNode(QSTRING57);

            adaptor.addChild(root_1, QSTRING57_tree);
            }

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "baseURIDecl"

    public static class schemaImport_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "schemaImport"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:919:1: schemaImport : ^( T_SCHEMA_IMPORT ^( SCHEMA ( schemaPrefix )? ) uriliteral ^( AT ( uriliteral )* ) ) ;
    public final XSPARQLRewriter.schemaImport_return schemaImport() throws RecognitionException {
        XSPARQLRewriter.schemaImport_return retval = new XSPARQLRewriter.schemaImport_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_SCHEMA_IMPORT58=null;
        CommonTree SCHEMA59=null;
        CommonTree AT62=null;
        XSPARQLRewriter.schemaPrefix_return schemaPrefix60 = null;

        XSPARQLRewriter.uriliteral_return uriliteral61 = null;

        XSPARQLRewriter.uriliteral_return uriliteral63 = null;


        CommonTree T_SCHEMA_IMPORT58_tree=null;
        CommonTree SCHEMA59_tree=null;
        CommonTree AT62_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:920:3: ( ^( T_SCHEMA_IMPORT ^( SCHEMA ( schemaPrefix )? ) uriliteral ^( AT ( uriliteral )* ) ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:920:5: ^( T_SCHEMA_IMPORT ^( SCHEMA ( schemaPrefix )? ) uriliteral ^( AT ( uriliteral )* ) )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_SCHEMA_IMPORT58=(CommonTree)match(input,T_SCHEMA_IMPORT,FOLLOW_T_SCHEMA_IMPORT_in_schemaImport1533); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_SCHEMA_IMPORT58_tree = (CommonTree)adaptor.dupNode(T_SCHEMA_IMPORT58);

            root_1 = (CommonTree)adaptor.becomeRoot(T_SCHEMA_IMPORT58_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_2 = _last;
            CommonTree _first_2 = null;
            CommonTree root_2 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            SCHEMA59=(CommonTree)match(input,SCHEMA,FOLLOW_SCHEMA_in_schemaImport1536); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            SCHEMA59_tree = (CommonTree)adaptor.dupNode(SCHEMA59);

            root_2 = (CommonTree)adaptor.becomeRoot(SCHEMA59_tree, root_2);
            }


            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); if (state.failed) return retval;
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:920:32: ( schemaPrefix )?
                int alt11=2;
                switch ( input.LA(1) ) {
                    case NCNAME:
                    case DEFAULT:
                        {
                        alt11=1;
                        }
                        break;
                }

                switch (alt11) {
                    case 1 :
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: schemaPrefix
                        {
                        _last = (CommonTree)input.LT(1);
                        pushFollow(FOLLOW_schemaPrefix_in_schemaImport1538);
                        schemaPrefix60=schemaPrefix();

                        state._fsp--;
                        if (state.failed) return retval;
                        if ( state.backtracking==0 ) 
                        adaptor.addChild(root_2, schemaPrefix60.getTree());

                        if ( state.backtracking==0 ) {
                        }
                        }
                        break;

                }


                match(input, Token.UP, null); if (state.failed) return retval;
            }adaptor.addChild(root_1, root_2);_last = _save_last_2;
            }

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_uriliteral_in_schemaImport1542);
            uriliteral61=uriliteral();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, uriliteral61.getTree());
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_2 = _last;
            CommonTree _first_2 = null;
            CommonTree root_2 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            AT62=(CommonTree)match(input,AT,FOLLOW_AT_in_schemaImport1545); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            AT62_tree = (CommonTree)adaptor.dupNode(AT62);

            root_2 = (CommonTree)adaptor.becomeRoot(AT62_tree, root_2);
            }


            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); if (state.failed) return retval;
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:920:63: ( uriliteral )*
                loop12:
                do {
                    int alt12=2;
                    switch ( input.LA(1) ) {
                    case QSTRING:
                        {
                        alt12=1;
                        }
                        break;

                    }

                    switch (alt12) {
                	case 1 :
                	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: uriliteral
                	    {
                	    _last = (CommonTree)input.LT(1);
                	    pushFollow(FOLLOW_uriliteral_in_schemaImport1547);
                	    uriliteral63=uriliteral();

                	    state._fsp--;
                	    if (state.failed) return retval;
                	    if ( state.backtracking==0 ) 
                	    adaptor.addChild(root_2, uriliteral63.getTree());

                	    if ( state.backtracking==0 ) {
                	    }
                	    }
                	    break;

                	default :
                	    break loop12;
                    }
                } while (true);


                match(input, Token.UP, null); if (state.failed) return retval;
            }adaptor.addChild(root_1, root_2);_last = _save_last_2;
            }


            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "schemaImport"

    public static class schemaPrefix_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "schemaPrefix"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:923:1: schemaPrefix : ( NCNAME | DEFAULT );
    public final XSPARQLRewriter.schemaPrefix_return schemaPrefix() throws RecognitionException {
        XSPARQLRewriter.schemaPrefix_return retval = new XSPARQLRewriter.schemaPrefix_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree set64=null;

        CommonTree set64_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:924:3: ( NCNAME | DEFAULT )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            set64=(CommonTree)input.LT(1);
            if ( input.LA(1)==NCNAME||input.LA(1)==DEFAULT ) {
                input.consume();

                if ( state.backtracking==0 ) {
                set64_tree = (CommonTree)adaptor.dupNode(set64);

                adaptor.addChild(root_0, set64_tree);
                }
                state.errorRecovery=false;state.failed=false;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }

            if ( state.backtracking==0 ) {
            } 

            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "schemaPrefix"

    public static class moduleImport_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "moduleImport"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:928:1: moduleImport : ^( T_MODULE_IMPORT ^( NAMESPACE ( NCNAME )? ) uriliteral ^( AT ( uriliteral )* ) ) ;
    public final XSPARQLRewriter.moduleImport_return moduleImport() throws RecognitionException {
        XSPARQLRewriter.moduleImport_return retval = new XSPARQLRewriter.moduleImport_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_MODULE_IMPORT65=null;
        CommonTree NAMESPACE66=null;
        CommonTree NCNAME67=null;
        CommonTree AT69=null;
        XSPARQLRewriter.uriliteral_return uriliteral68 = null;

        XSPARQLRewriter.uriliteral_return uriliteral70 = null;


        CommonTree T_MODULE_IMPORT65_tree=null;
        CommonTree NAMESPACE66_tree=null;
        CommonTree NCNAME67_tree=null;
        CommonTree AT69_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:929:3: ( ^( T_MODULE_IMPORT ^( NAMESPACE ( NCNAME )? ) uriliteral ^( AT ( uriliteral )* ) ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:929:5: ^( T_MODULE_IMPORT ^( NAMESPACE ( NCNAME )? ) uriliteral ^( AT ( uriliteral )* ) )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_MODULE_IMPORT65=(CommonTree)match(input,T_MODULE_IMPORT,FOLLOW_T_MODULE_IMPORT_in_moduleImport1583); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_MODULE_IMPORT65_tree = (CommonTree)adaptor.dupNode(T_MODULE_IMPORT65);

            root_1 = (CommonTree)adaptor.becomeRoot(T_MODULE_IMPORT65_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_2 = _last;
            CommonTree _first_2 = null;
            CommonTree root_2 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            NAMESPACE66=(CommonTree)match(input,NAMESPACE,FOLLOW_NAMESPACE_in_moduleImport1586); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            NAMESPACE66_tree = (CommonTree)adaptor.dupNode(NAMESPACE66);

            root_2 = (CommonTree)adaptor.becomeRoot(NAMESPACE66_tree, root_2);
            }


            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); if (state.failed) return retval;
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:929:35: ( NCNAME )?
                int alt13=2;
                switch ( input.LA(1) ) {
                    case NCNAME:
                        {
                        alt13=1;
                        }
                        break;
                }

                switch (alt13) {
                    case 1 :
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: NCNAME
                        {
                        _last = (CommonTree)input.LT(1);
                        NCNAME67=(CommonTree)match(input,NCNAME,FOLLOW_NCNAME_in_moduleImport1588); if (state.failed) return retval;
                        if ( state.backtracking==0 ) {
                        NCNAME67_tree = (CommonTree)adaptor.dupNode(NCNAME67);

                        adaptor.addChild(root_2, NCNAME67_tree);
                        }

                        if ( state.backtracking==0 ) {
                        }
                        }
                        break;

                }


                match(input, Token.UP, null); if (state.failed) return retval;
            }adaptor.addChild(root_1, root_2);_last = _save_last_2;
            }

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_uriliteral_in_moduleImport1592);
            uriliteral68=uriliteral();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, uriliteral68.getTree());
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_2 = _last;
            CommonTree _first_2 = null;
            CommonTree root_2 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            AT69=(CommonTree)match(input,AT,FOLLOW_AT_in_moduleImport1595); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            AT69_tree = (CommonTree)adaptor.dupNode(AT69);

            root_2 = (CommonTree)adaptor.becomeRoot(AT69_tree, root_2);
            }


            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); if (state.failed) return retval;
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:929:60: ( uriliteral )*
                loop14:
                do {
                    int alt14=2;
                    switch ( input.LA(1) ) {
                    case QSTRING:
                        {
                        alt14=1;
                        }
                        break;

                    }

                    switch (alt14) {
                	case 1 :
                	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: uriliteral
                	    {
                	    _last = (CommonTree)input.LT(1);
                	    pushFollow(FOLLOW_uriliteral_in_moduleImport1597);
                	    uriliteral70=uriliteral();

                	    state._fsp--;
                	    if (state.failed) return retval;
                	    if ( state.backtracking==0 ) 
                	    adaptor.addChild(root_2, uriliteral70.getTree());

                	    if ( state.backtracking==0 ) {
                	    }
                	    }
                	    break;

                	default :
                	    break loop14;
                    }
                } while (true);


                match(input, Token.UP, null); if (state.failed) return retval;
            }adaptor.addChild(root_1, root_2);_last = _save_last_2;
            }


            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "moduleImport"

    public static class varDecl_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "varDecl"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:932:1: varDecl : ( ^( T_VARIABLE_DECL var= VAR ^( T_TYPE ( typeDeclaration )? ) exprSingle ) | ^( T_EXTERNAL_VARIABLE_DECL var= VAR ^( T_TYPE ( typeDeclaration )? ) ) );
    public final XSPARQLRewriter.varDecl_return varDecl() throws RecognitionException {
        XSPARQLRewriter.varDecl_return retval = new XSPARQLRewriter.varDecl_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree var=null;
        CommonTree T_VARIABLE_DECL71=null;
        CommonTree T_TYPE72=null;
        CommonTree T_EXTERNAL_VARIABLE_DECL75=null;
        CommonTree T_TYPE76=null;
        XSPARQLRewriter.typeDeclaration_return typeDeclaration73 = null;

        XSPARQLRewriter.exprSingle_return exprSingle74 = null;

        XSPARQLRewriter.typeDeclaration_return typeDeclaration77 = null;


        CommonTree var_tree=null;
        CommonTree T_VARIABLE_DECL71_tree=null;
        CommonTree T_TYPE72_tree=null;
        CommonTree T_EXTERNAL_VARIABLE_DECL75_tree=null;
        CommonTree T_TYPE76_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:933:3: ( ^( T_VARIABLE_DECL var= VAR ^( T_TYPE ( typeDeclaration )? ) exprSingle ) | ^( T_EXTERNAL_VARIABLE_DECL var= VAR ^( T_TYPE ( typeDeclaration )? ) ) )
            int alt17=2;
            switch ( input.LA(1) ) {
            case T_VARIABLE_DECL:
                {
                alt17=1;
                }
                break;
            case T_EXTERNAL_VARIABLE_DECL:
                {
                alt17=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 17, 0, input);

                throw nvae;
            }

            switch (alt17) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:933:5: ^( T_VARIABLE_DECL var= VAR ^( T_TYPE ( typeDeclaration )? ) exprSingle )
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_VARIABLE_DECL71=(CommonTree)match(input,T_VARIABLE_DECL,FOLLOW_T_VARIABLE_DECL_in_varDecl1614); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    T_VARIABLE_DECL71_tree = (CommonTree)adaptor.dupNode(T_VARIABLE_DECL71);

                    root_1 = (CommonTree)adaptor.becomeRoot(T_VARIABLE_DECL71_tree, root_1);
                    }


                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    var=(CommonTree)match(input,VAR,FOLLOW_VAR_in_varDecl1618); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    var_tree = (CommonTree)adaptor.dupNode(var);

                    adaptor.addChild(root_1, var_tree);
                    }
                    if ( state.backtracking==0 ) {
                      addVariableToScope((var!=null?var.getText():null));
                    }
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_2 = _last;
                    CommonTree _first_2 = null;
                    CommonTree root_2 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_TYPE72=(CommonTree)match(input,T_TYPE,FOLLOW_T_TYPE_in_varDecl1623); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    T_TYPE72_tree = (CommonTree)adaptor.dupNode(T_TYPE72);

                    root_2 = (CommonTree)adaptor.becomeRoot(T_TYPE72_tree, root_2);
                    }


                    if ( input.LA(1)==Token.DOWN ) {
                        match(input, Token.DOWN, null); if (state.failed) return retval;
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:933:73: ( typeDeclaration )?
                        int alt15=2;
                        switch ( input.LA(1) ) {
                            case NCNAME:
                            case PNAME_NS:
                            case PNAME_LN:
                            case A:
                            case FROM:
                            case ATTRIBUTE:
                            case ELEMENT:
                            case TO:
                            case EMPTYSEQUENCE:
                            case ITEM:
                            case NODE:
                            case DOCUMENTNODE:
                            case TEXT:
                            case COMMENT:
                            case PROCESSINGINSTRUCTION:
                            case SCHEMAATTRIBUTE:
                            case SCHEMAELEMENT:
                            case ROW:
                                {
                                alt15=1;
                                }
                                break;
                        }

                        switch (alt15) {
                            case 1 :
                                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: typeDeclaration
                                {
                                _last = (CommonTree)input.LT(1);
                                pushFollow(FOLLOW_typeDeclaration_in_varDecl1625);
                                typeDeclaration73=typeDeclaration();

                                state._fsp--;
                                if (state.failed) return retval;
                                if ( state.backtracking==0 ) 
                                adaptor.addChild(root_2, typeDeclaration73.getTree());

                                if ( state.backtracking==0 ) {
                                }
                                }
                                break;

                        }


                        match(input, Token.UP, null); if (state.failed) return retval;
                    }adaptor.addChild(root_1, root_2);_last = _save_last_2;
                    }

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_exprSingle_in_varDecl1629);
                    exprSingle74=exprSingle();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, exprSingle74.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:934:5: ^( T_EXTERNAL_VARIABLE_DECL var= VAR ^( T_TYPE ( typeDeclaration )? ) )
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_EXTERNAL_VARIABLE_DECL75=(CommonTree)match(input,T_EXTERNAL_VARIABLE_DECL,FOLLOW_T_EXTERNAL_VARIABLE_DECL_in_varDecl1637); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    T_EXTERNAL_VARIABLE_DECL75_tree = (CommonTree)adaptor.dupNode(T_EXTERNAL_VARIABLE_DECL75);

                    root_1 = (CommonTree)adaptor.becomeRoot(T_EXTERNAL_VARIABLE_DECL75_tree, root_1);
                    }


                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    var=(CommonTree)match(input,VAR,FOLLOW_VAR_in_varDecl1641); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    var_tree = (CommonTree)adaptor.dupNode(var);

                    adaptor.addChild(root_1, var_tree);
                    }
                    if ( state.backtracking==0 ) {
                      addVariableToScope((var!=null?var.getText():null));
                    }
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_2 = _last;
                    CommonTree _first_2 = null;
                    CommonTree root_2 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_TYPE76=(CommonTree)match(input,T_TYPE,FOLLOW_T_TYPE_in_varDecl1646); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    T_TYPE76_tree = (CommonTree)adaptor.dupNode(T_TYPE76);

                    root_2 = (CommonTree)adaptor.becomeRoot(T_TYPE76_tree, root_2);
                    }


                    if ( input.LA(1)==Token.DOWN ) {
                        match(input, Token.DOWN, null); if (state.failed) return retval;
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:934:82: ( typeDeclaration )?
                        int alt16=2;
                        switch ( input.LA(1) ) {
                            case NCNAME:
                            case PNAME_NS:
                            case PNAME_LN:
                            case A:
                            case FROM:
                            case ATTRIBUTE:
                            case ELEMENT:
                            case TO:
                            case EMPTYSEQUENCE:
                            case ITEM:
                            case NODE:
                            case DOCUMENTNODE:
                            case TEXT:
                            case COMMENT:
                            case PROCESSINGINSTRUCTION:
                            case SCHEMAATTRIBUTE:
                            case SCHEMAELEMENT:
                            case ROW:
                                {
                                alt16=1;
                                }
                                break;
                        }

                        switch (alt16) {
                            case 1 :
                                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: typeDeclaration
                                {
                                _last = (CommonTree)input.LT(1);
                                pushFollow(FOLLOW_typeDeclaration_in_varDecl1648);
                                typeDeclaration77=typeDeclaration();

                                state._fsp--;
                                if (state.failed) return retval;
                                if ( state.backtracking==0 ) 
                                adaptor.addChild(root_2, typeDeclaration77.getTree());

                                if ( state.backtracking==0 ) {
                                }
                                }
                                break;

                        }


                        match(input, Token.UP, null); if (state.failed) return retval;
                    }adaptor.addChild(root_1, root_2);_last = _save_last_2;
                    }


                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "varDecl"

    public static class constructionDecl_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "constructionDecl"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:937:1: constructionDecl : DECLARE CONSTRUCTION ( STRIP | PRESERVE ) ;
    public final XSPARQLRewriter.constructionDecl_return constructionDecl() throws RecognitionException {
        XSPARQLRewriter.constructionDecl_return retval = new XSPARQLRewriter.constructionDecl_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree DECLARE78=null;
        CommonTree CONSTRUCTION79=null;
        CommonTree set80=null;

        CommonTree DECLARE78_tree=null;
        CommonTree CONSTRUCTION79_tree=null;
        CommonTree set80_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:938:3: ( DECLARE CONSTRUCTION ( STRIP | PRESERVE ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:938:5: DECLARE CONSTRUCTION ( STRIP | PRESERVE )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            DECLARE78=(CommonTree)match(input,DECLARE,FOLLOW_DECLARE_in_constructionDecl1664); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            DECLARE78_tree = (CommonTree)adaptor.dupNode(DECLARE78);

            adaptor.addChild(root_0, DECLARE78_tree);
            }
            _last = (CommonTree)input.LT(1);
            CONSTRUCTION79=(CommonTree)match(input,CONSTRUCTION,FOLLOW_CONSTRUCTION_in_constructionDecl1666); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            CONSTRUCTION79_tree = (CommonTree)adaptor.dupNode(CONSTRUCTION79);

            adaptor.addChild(root_0, CONSTRUCTION79_tree);
            }
            _last = (CommonTree)input.LT(1);
            set80=(CommonTree)input.LT(1);
            if ( input.LA(1)==STRIP||input.LA(1)==PRESERVE ) {
                input.consume();

                if ( state.backtracking==0 ) {
                set80_tree = (CommonTree)adaptor.dupNode(set80);

                adaptor.addChild(root_0, set80_tree);
                }
                state.errorRecovery=false;state.failed=false;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "constructionDecl"

    public static class functionDecl_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "functionDecl"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:941:1: functionDecl : ^( T_FUNCTION_DECL qname ^( T_PARAMS ( paramList )? ) ( ^( AS sequenceType ) )? ( enclosedExpr | EXTERNAL ) ) ;
    public final XSPARQLRewriter.functionDecl_return functionDecl() throws RecognitionException {
        VariableScope_stack.push(new VariableScope_scope());

        XSPARQLRewriter.functionDecl_return retval = new XSPARQLRewriter.functionDecl_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_FUNCTION_DECL81=null;
        CommonTree T_PARAMS83=null;
        CommonTree AS85=null;
        CommonTree EXTERNAL88=null;
        XSPARQLRewriter.qname_return qname82 = null;

        XSPARQLRewriter.paramList_return paramList84 = null;

        XSPARQLRewriter.sequenceType_return sequenceType86 = null;

        XSPARQLRewriter.enclosedExpr_return enclosedExpr87 = null;


        CommonTree T_FUNCTION_DECL81_tree=null;
        CommonTree T_PARAMS83_tree=null;
        CommonTree AS85_tree=null;
        CommonTree EXTERNAL88_tree=null;


          ((VariableScope_scope)VariableScope_stack.peek()).variables = new HashMap<String,Types>();
          logger.info("Creating new variable scope: functionDecl");

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:947:3: ( ^( T_FUNCTION_DECL qname ^( T_PARAMS ( paramList )? ) ( ^( AS sequenceType ) )? ( enclosedExpr | EXTERNAL ) ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:947:5: ^( T_FUNCTION_DECL qname ^( T_PARAMS ( paramList )? ) ( ^( AS sequenceType ) )? ( enclosedExpr | EXTERNAL ) )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_FUNCTION_DECL81=(CommonTree)match(input,T_FUNCTION_DECL,FOLLOW_T_FUNCTION_DECL_in_functionDecl1699); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_FUNCTION_DECL81_tree = (CommonTree)adaptor.dupNode(T_FUNCTION_DECL81);

            root_1 = (CommonTree)adaptor.becomeRoot(T_FUNCTION_DECL81_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_qname_in_functionDecl1701);
            qname82=qname();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, qname82.getTree());
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_2 = _last;
            CommonTree _first_2 = null;
            CommonTree root_2 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_PARAMS83=(CommonTree)match(input,T_PARAMS,FOLLOW_T_PARAMS_in_functionDecl1704); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_PARAMS83_tree = (CommonTree)adaptor.dupNode(T_PARAMS83);

            root_2 = (CommonTree)adaptor.becomeRoot(T_PARAMS83_tree, root_2);
            }


            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); if (state.failed) return retval;
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:947:40: ( paramList )?
                int alt18=2;
                switch ( input.LA(1) ) {
                    case T_PARAM:
                        {
                        alt18=1;
                        }
                        break;
                }

                switch (alt18) {
                    case 1 :
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: paramList
                        {
                        _last = (CommonTree)input.LT(1);
                        pushFollow(FOLLOW_paramList_in_functionDecl1706);
                        paramList84=paramList();

                        state._fsp--;
                        if (state.failed) return retval;
                        if ( state.backtracking==0 ) 
                        adaptor.addChild(root_2, paramList84.getTree());

                        if ( state.backtracking==0 ) {
                        }
                        }
                        break;

                }


                match(input, Token.UP, null); if (state.failed) return retval;
            }adaptor.addChild(root_1, root_2);_last = _save_last_2;
            }

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:947:52: ( ^( AS sequenceType ) )?
            int alt19=2;
            switch ( input.LA(1) ) {
                case AS:
                    {
                    alt19=1;
                    }
                    break;
            }

            switch (alt19) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:947:53: ^( AS sequenceType )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_2 = _last;
                    CommonTree _first_2 = null;
                    CommonTree root_2 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    AS85=(CommonTree)match(input,AS,FOLLOW_AS_in_functionDecl1712); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    AS85_tree = (CommonTree)adaptor.dupNode(AS85);

                    root_2 = (CommonTree)adaptor.becomeRoot(AS85_tree, root_2);
                    }


                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_sequenceType_in_functionDecl1714);
                    sequenceType86=sequenceType();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_2, sequenceType86.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_1, root_2);_last = _save_last_2;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:947:74: ( enclosedExpr | EXTERNAL )
            int alt20=2;
            switch ( input.LA(1) ) {
            case LCURLY:
            case STAR:
            case LESSTHAN:
            case GREATERTHAN:
            case PLUS:
            case MINUS:
            case UNIONSYMBOL:
            case LESSTHANLESSTHAN:
            case GREATERTHANEQUALS:
            case LESSTHANEQUALS:
            case HAFENEQUALS:
            case EQUALS:
            case IS:
            case EQ:
            case NE:
            case LT:
            case GE:
            case LE:
            case GT:
            case IF:
            case AND:
            case OR:
            case TO:
            case DIV:
            case IDIV:
            case MOD:
            case UNION:
            case INTERSECT:
            case EXCEPT:
            case GREATERTHANGREATERTHAN:
            case T_FLWOR:
            case T_INSTANCEOF:
            case T_CASTAS:
            case T_CASTABLEAS:
            case T_TREATAS:
            case EVERY:
            case TYPESWITCH:
            case VALIDATE:
            case SOME:
            case XPATH:
                {
                alt20=1;
                }
                break;
            case EXTERNAL:
                {
                alt20=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 20, 0, input);

                throw nvae;
            }

            switch (alt20) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:947:75: enclosedExpr
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_enclosedExpr_in_functionDecl1720);
                    enclosedExpr87=enclosedExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, enclosedExpr87.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:947:90: EXTERNAL
                    {
                    _last = (CommonTree)input.LT(1);
                    EXTERNAL88=(CommonTree)match(input,EXTERNAL,FOLLOW_EXTERNAL_in_functionDecl1724); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    EXTERNAL88_tree = (CommonTree)adaptor.dupNode(EXTERNAL88);

                    adaptor.addChild(root_1, EXTERNAL88_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }


            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
            VariableScope_stack.pop();

        }
        return retval;
    }
    // $ANTLR end "functionDecl"

    public static class paramList_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "paramList"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:950:1: paramList : ( param )+ ;
    public final XSPARQLRewriter.paramList_return paramList() throws RecognitionException {
        XSPARQLRewriter.paramList_return retval = new XSPARQLRewriter.paramList_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.param_return param89 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:951:3: ( ( param )+ )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:951:5: ( param )+
            {
            root_0 = (CommonTree)adaptor.nil();

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:951:5: ( param )+
            int cnt21=0;
            loop21:
            do {
                int alt21=2;
                switch ( input.LA(1) ) {
                case T_PARAM:
                    {
                    alt21=1;
                    }
                    break;

                }

                switch (alt21) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: param
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_param_in_paramList1739);
            	    param89=param();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) 
            	    adaptor.addChild(root_0, param89.getTree());

            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    if ( cnt21 >= 1 ) break loop21;
            	    if (state.backtracking>0) {state.failed=true; return retval;}
                        EarlyExitException eee =
                            new EarlyExitException(21, input);
                        throw eee;
                }
                cnt21++;
            } while (true);


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "paramList"

    public static class param_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "param"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:954:1: param : ^( T_PARAM var= VAR ^( T_TYPE ( typeDeclaration )? ) ) ;
    public final XSPARQLRewriter.param_return param() throws RecognitionException {
        XSPARQLRewriter.param_return retval = new XSPARQLRewriter.param_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree var=null;
        CommonTree T_PARAM90=null;
        CommonTree T_TYPE91=null;
        XSPARQLRewriter.typeDeclaration_return typeDeclaration92 = null;


        CommonTree var_tree=null;
        CommonTree T_PARAM90_tree=null;
        CommonTree T_TYPE91_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:955:3: ( ^( T_PARAM var= VAR ^( T_TYPE ( typeDeclaration )? ) ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:955:5: ^( T_PARAM var= VAR ^( T_TYPE ( typeDeclaration )? ) )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_PARAM90=(CommonTree)match(input,T_PARAM,FOLLOW_T_PARAM_in_param1754); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_PARAM90_tree = (CommonTree)adaptor.dupNode(T_PARAM90);

            root_1 = (CommonTree)adaptor.becomeRoot(T_PARAM90_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            var=(CommonTree)match(input,VAR,FOLLOW_VAR_in_param1758); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            var_tree = (CommonTree)adaptor.dupNode(var);

            adaptor.addChild(root_1, var_tree);
            }
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_2 = _last;
            CommonTree _first_2 = null;
            CommonTree root_2 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_TYPE91=(CommonTree)match(input,T_TYPE,FOLLOW_T_TYPE_in_param1761); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_TYPE91_tree = (CommonTree)adaptor.dupNode(T_TYPE91);

            root_2 = (CommonTree)adaptor.becomeRoot(T_TYPE91_tree, root_2);
            }


            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); if (state.failed) return retval;
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:955:32: ( typeDeclaration )?
                int alt22=2;
                switch ( input.LA(1) ) {
                    case NCNAME:
                    case PNAME_NS:
                    case PNAME_LN:
                    case A:
                    case FROM:
                    case ATTRIBUTE:
                    case ELEMENT:
                    case TO:
                    case EMPTYSEQUENCE:
                    case ITEM:
                    case NODE:
                    case DOCUMENTNODE:
                    case TEXT:
                    case COMMENT:
                    case PROCESSINGINSTRUCTION:
                    case SCHEMAATTRIBUTE:
                    case SCHEMAELEMENT:
                    case ROW:
                        {
                        alt22=1;
                        }
                        break;
                }

                switch (alt22) {
                    case 1 :
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: typeDeclaration
                        {
                        _last = (CommonTree)input.LT(1);
                        pushFollow(FOLLOW_typeDeclaration_in_param1763);
                        typeDeclaration92=typeDeclaration();

                        state._fsp--;
                        if (state.failed) return retval;
                        if ( state.backtracking==0 ) 
                        adaptor.addChild(root_2, typeDeclaration92.getTree());

                        if ( state.backtracking==0 ) {
                        }
                        }
                        break;

                }


                match(input, Token.UP, null); if (state.failed) return retval;
            }adaptor.addChild(root_1, root_2);_last = _save_last_2;
            }


            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }

            if ( state.backtracking==0 ) {
              addVariableToScope((var!=null?var.getText():null));
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "param"

    public static class enclosedExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "enclosedExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:958:1: enclosedExpr : expr ;
    public final XSPARQLRewriter.enclosedExpr_return enclosedExpr() throws RecognitionException {
        XSPARQLRewriter.enclosedExpr_return retval = new XSPARQLRewriter.enclosedExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.expr_return expr93 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:959:3: ( expr )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:959:5: expr
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_expr_in_enclosedExpr1781);
            expr93=expr();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, expr93.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "enclosedExpr"

    public static class enclosedExpr__return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "enclosedExpr_"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:962:1: enclosedExpr_ : LCURLY expr RCURLY ;
    public final XSPARQLRewriter.enclosedExpr__return enclosedExpr_() throws RecognitionException {
        XSPARQLRewriter.enclosedExpr__return retval = new XSPARQLRewriter.enclosedExpr__return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree LCURLY94=null;
        CommonTree RCURLY96=null;
        XSPARQLRewriter.expr_return expr95 = null;


        CommonTree LCURLY94_tree=null;
        CommonTree RCURLY96_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:963:3: ( LCURLY expr RCURLY )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:963:5: LCURLY expr RCURLY
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            LCURLY94=(CommonTree)match(input,LCURLY,FOLLOW_LCURLY_in_enclosedExpr_1794); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            LCURLY94_tree = (CommonTree)adaptor.dupNode(LCURLY94);

            adaptor.addChild(root_0, LCURLY94_tree);
            }
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_expr_in_enclosedExpr_1796);
            expr95=expr();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, expr95.getTree());
            _last = (CommonTree)input.LT(1);
            RCURLY96=(CommonTree)match(input,RCURLY,FOLLOW_RCURLY_in_enclosedExpr_1798); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            RCURLY96_tree = (CommonTree)adaptor.dupNode(RCURLY96);

            adaptor.addChild(root_0, RCURLY96_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "enclosedExpr_"

    public static class queryBody_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "queryBody"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:966:1: queryBody : ^( T_QUERY_BODY ( ^( T_BODY_PART exprSingle ) )+ epilogue ) -> {XSPARQL.graphoutput}? ^( T_QUERY_BODY ^( T_BODY_PART COMMENT[\"N3 namespace declaration\"] QSTRING[getRDFNamespaceDecls()] ) ( ^( T_BODY_PART exprSingle ) )+ ) -> ^( T_QUERY_BODY ( ^( T_BODY_PART exprSingle ) )+ epilogue ) ;
    public final XSPARQLRewriter.queryBody_return queryBody() throws RecognitionException {
        XSPARQLRewriter.queryBody_return retval = new XSPARQLRewriter.queryBody_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_QUERY_BODY97=null;
        CommonTree T_BODY_PART98=null;
        XSPARQLRewriter.exprSingle_return exprSingle99 = null;

        XSPARQLRewriter.epilogue_return epilogue100 = null;


        CommonTree T_QUERY_BODY97_tree=null;
        CommonTree T_BODY_PART98_tree=null;
        RewriteRuleNodeStream stream_T_QUERY_BODY=new RewriteRuleNodeStream(adaptor,"token T_QUERY_BODY");
        RewriteRuleNodeStream stream_T_BODY_PART=new RewriteRuleNodeStream(adaptor,"token T_BODY_PART");
        RewriteRuleSubtreeStream stream_epilogue=new RewriteRuleSubtreeStream(adaptor,"rule epilogue");
        RewriteRuleSubtreeStream stream_exprSingle=new RewriteRuleSubtreeStream(adaptor,"rule exprSingle");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:967:3: ( ^( T_QUERY_BODY ( ^( T_BODY_PART exprSingle ) )+ epilogue ) -> {XSPARQL.graphoutput}? ^( T_QUERY_BODY ^( T_BODY_PART COMMENT[\"N3 namespace declaration\"] QSTRING[getRDFNamespaceDecls()] ) ( ^( T_BODY_PART exprSingle ) )+ ) -> ^( T_QUERY_BODY ( ^( T_BODY_PART exprSingle ) )+ epilogue ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:967:5: ^( T_QUERY_BODY ( ^( T_BODY_PART exprSingle ) )+ epilogue )
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_QUERY_BODY97=(CommonTree)match(input,T_QUERY_BODY,FOLLOW_T_QUERY_BODY_in_queryBody1812); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_T_QUERY_BODY.add(T_QUERY_BODY97);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:967:20: ( ^( T_BODY_PART exprSingle ) )+
            int cnt23=0;
            loop23:
            do {
                int alt23=2;
                switch ( input.LA(1) ) {
                case T_BODY_PART:
                    {
                    alt23=1;
                    }
                    break;

                }

                switch (alt23) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:967:21: ^( T_BODY_PART exprSingle )
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    {
            	    CommonTree _save_last_2 = _last;
            	    CommonTree _first_2 = null;
            	    CommonTree root_2 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            	    T_BODY_PART98=(CommonTree)match(input,T_BODY_PART,FOLLOW_T_BODY_PART_in_queryBody1816); if (state.failed) return retval; 
            	    if ( state.backtracking==0 ) stream_T_BODY_PART.add(T_BODY_PART98);



            	    match(input, Token.DOWN, null); if (state.failed) return retval;
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_exprSingle_in_queryBody1818);
            	    exprSingle99=exprSingle();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_exprSingle.add(exprSingle99.getTree());

            	    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_1, root_2);_last = _save_last_2;
            	    }


            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    if ( cnt23 >= 1 ) break loop23;
            	    if (state.backtracking>0) {state.failed=true; return retval;}
                        EarlyExitException eee =
                            new EarlyExitException(23, input);
                        throw eee;
                }
                cnt23++;
            } while (true);

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_epilogue_in_queryBody1823);
            epilogue100=epilogue();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_epilogue.add(epilogue100.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }



            // AST REWRITE
            // elements: T_BODY_PART, T_QUERY_BODY, T_BODY_PART, T_BODY_PART, T_QUERY_BODY, epilogue, exprSingle, exprSingle
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 968:3: -> {XSPARQL.graphoutput}? ^( T_QUERY_BODY ^( T_BODY_PART COMMENT[\"N3 namespace declaration\"] QSTRING[getRDFNamespaceDecls()] ) ( ^( T_BODY_PART exprSingle ) )+ )
            if (XSPARQL.graphoutput) {
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:969:6: ^( T_QUERY_BODY ^( T_BODY_PART COMMENT[\"N3 namespace declaration\"] QSTRING[getRDFNamespaceDecls()] ) ( ^( T_BODY_PART exprSingle ) )+ )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot(stream_T_QUERY_BODY.nextNode(), root_1);

                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:970:8: ^( T_BODY_PART COMMENT[\"N3 namespace declaration\"] QSTRING[getRDFNamespaceDecls()] )
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot(stream_T_BODY_PART.nextNode(), root_2);

                adaptor.addChild(root_2, (CommonTree)adaptor.create(COMMENT, "N3 namespace declaration"));
                adaptor.addChild(root_2, (CommonTree)adaptor.create(QSTRING, getRDFNamespaceDecls()));

                adaptor.addChild(root_1, root_2);
                }
                if ( !(stream_T_BODY_PART.hasNext()||stream_exprSingle.hasNext()) ) {
                    throw new RewriteEarlyExitException();
                }
                while ( stream_T_BODY_PART.hasNext()||stream_exprSingle.hasNext() ) {
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:974:9: ^( T_BODY_PART exprSingle )
                    {
                    CommonTree root_2 = (CommonTree)adaptor.nil();
                    root_2 = (CommonTree)adaptor.becomeRoot(stream_T_BODY_PART.nextNode(), root_2);

                    adaptor.addChild(root_2, stream_exprSingle.nextTree());

                    adaptor.addChild(root_1, root_2);
                    }

                }
                stream_T_BODY_PART.reset();
                stream_exprSingle.reset();

                adaptor.addChild(root_0, root_1);
                }

            }
            else // 976:3: -> ^( T_QUERY_BODY ( ^( T_BODY_PART exprSingle ) )+ epilogue )
            {
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:976:7: ^( T_QUERY_BODY ( ^( T_BODY_PART exprSingle ) )+ epilogue )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot(stream_T_QUERY_BODY.nextNode(), root_1);

                if ( !(stream_T_BODY_PART.hasNext()||stream_exprSingle.hasNext()) ) {
                    throw new RewriteEarlyExitException();
                }
                while ( stream_T_BODY_PART.hasNext()||stream_exprSingle.hasNext() ) {
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:976:23: ^( T_BODY_PART exprSingle )
                    {
                    CommonTree root_2 = (CommonTree)adaptor.nil();
                    root_2 = (CommonTree)adaptor.becomeRoot(stream_T_BODY_PART.nextNode(), root_2);

                    adaptor.addChild(root_2, stream_exprSingle.nextTree());

                    adaptor.addChild(root_1, root_2);
                    }

                }
                stream_T_BODY_PART.reset();
                stream_exprSingle.reset();
                adaptor.addChild(root_1, stream_epilogue.nextTree());

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "queryBody"

    public static class epilogue_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "epilogue"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:980:1: epilogue : T_EPILOGUE -> { epilogue.getChildCount() > 0 }? -> DELETEVNODE[\"epilogue\"] ;
    public final XSPARQLRewriter.epilogue_return epilogue() throws RecognitionException {
        XSPARQLRewriter.epilogue_return retval = new XSPARQLRewriter.epilogue_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_EPILOGUE101=null;

        CommonTree T_EPILOGUE101_tree=null;
        RewriteRuleNodeStream stream_T_EPILOGUE=new RewriteRuleNodeStream(adaptor,"token T_EPILOGUE");

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:981:3: ( T_EPILOGUE -> { epilogue.getChildCount() > 0 }? -> DELETEVNODE[\"epilogue\"] )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:981:5: T_EPILOGUE
            {
            _last = (CommonTree)input.LT(1);
            T_EPILOGUE101=(CommonTree)match(input,T_EPILOGUE,FOLLOW_T_EPILOGUE_in_epilogue1948); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_T_EPILOGUE.add(T_EPILOGUE101);



            // AST REWRITE
            // elements: 
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 982:3: -> { epilogue.getChildCount() > 0 }?
            if ( epilogue.getChildCount() > 0 ) {
                adaptor.addChild(root_0,  epilogue );

            }
            else // 983:3: -> DELETEVNODE[\"epilogue\"]
            {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(DELETEVNODE, "epilogue"));

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "epilogue"

    public static class expr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "expr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:987:1: expr options {backtrack=false; } : ( exprSingle )+ ;
    public final XSPARQLRewriter.expr_return expr() throws RecognitionException {
        XSPARQLRewriter.expr_return retval = new XSPARQLRewriter.expr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.exprSingle_return exprSingle102 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:992:3: ( ( exprSingle )+ )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:992:5: ( exprSingle )+
            {
            root_0 = (CommonTree)adaptor.nil();

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:992:5: ( exprSingle )+
            int cnt24=0;
            loop24:
            do {
                int alt24=2;
                alt24 = dfa24.predict(input);
                switch (alt24) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: exprSingle
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_exprSingle_in_expr1987);
            	    exprSingle102=exprSingle();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) 
            	    adaptor.addChild(root_0, exprSingle102.getTree());

            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    if ( cnt24 >= 1 ) break loop24;
            	    if (state.backtracking>0) {state.failed=true; return retval;}
                        EarlyExitException eee =
                            new EarlyExitException(24, input);
                        throw eee;
                }
                cnt24++;
            } while (true);


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "expr"

    protected static class exprSingle_scope {
        boolean isConstruct;
    }
    protected Stack exprSingle_stack = new Stack();

    public static class exprSingle_return extends TreeRuleReturnScope {
        public Types type;
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "exprSingle"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:995:1: exprSingle returns [Types type] : ( flworExpr | quantifiedExpr | typeSwitchExpr | orExpr | ifExpr );
    public final XSPARQLRewriter.exprSingle_return exprSingle() throws RecognitionException {
        exprSingle_stack.push(new exprSingle_scope());
        XSPARQLRewriter.exprSingle_return retval = new XSPARQLRewriter.exprSingle_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.flworExpr_return flworExpr103 = null;

        XSPARQLRewriter.quantifiedExpr_return quantifiedExpr104 = null;

        XSPARQLRewriter.typeSwitchExpr_return typeSwitchExpr105 = null;

        XSPARQLRewriter.orExpr_return orExpr106 = null;

        XSPARQLRewriter.ifExpr_return ifExpr107 = null;




            logger.info("exprSingle");
            ((exprSingle_scope)exprSingle_stack.peek()).isConstruct = false;
            retval.type = Types.XQUERY;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1005:3: ( flworExpr | quantifiedExpr | typeSwitchExpr | orExpr | ifExpr )
            int alt25=5;
            switch ( input.LA(1) ) {
            case T_FLWOR:
                {
                alt25=1;
                }
                break;
            case EVERY:
            case SOME:
                {
                alt25=2;
                }
                break;
            case TYPESWITCH:
                {
                alt25=3;
                }
                break;
            case LCURLY:
            case STAR:
            case LESSTHAN:
            case GREATERTHAN:
            case PLUS:
            case MINUS:
            case UNIONSYMBOL:
            case LESSTHANLESSTHAN:
            case GREATERTHANEQUALS:
            case LESSTHANEQUALS:
            case HAFENEQUALS:
            case EQUALS:
            case IS:
            case EQ:
            case NE:
            case LT:
            case GE:
            case LE:
            case GT:
            case AND:
            case OR:
            case TO:
            case DIV:
            case IDIV:
            case MOD:
            case UNION:
            case INTERSECT:
            case EXCEPT:
            case GREATERTHANGREATERTHAN:
            case T_INSTANCEOF:
            case T_CASTAS:
            case T_CASTABLEAS:
            case T_TREATAS:
            case VALIDATE:
            case XPATH:
                {
                alt25=4;
                }
                break;
            case IF:
                {
                alt25=5;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 25, 0, input);

                throw nvae;
            }

            switch (alt25) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1005:5: flworExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_flworExpr_in_exprSingle2018);
                    flworExpr103=flworExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, flworExpr103.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1006:5: quantifiedExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_quantifiedExpr_in_exprSingle2024);
                    quantifiedExpr104=quantifiedExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, quantifiedExpr104.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1007:5: typeSwitchExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_typeSwitchExpr_in_exprSingle2030);
                    typeSwitchExpr105=typeSwitchExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, typeSwitchExpr105.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1008:5: orExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_orExpr_in_exprSingle2036);
                    orExpr106=orExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, orExpr106.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 5 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1009:5: ifExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_ifExpr_in_exprSingle2042);
                    ifExpr107=ifExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, ifExpr107.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
            if ( state.backtracking==0 ) {
               if (((exprSingle_scope)exprSingle_stack.peek()).isConstruct) { retval.type = Types.RDF_GRAPH; }  
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
            exprSingle_stack.pop();
        }
        return retval;
    }
    // $ANTLR end "exprSingle"

    public static class flworExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "flworExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1012:1: flworExpr : ^( T_FLWOR forletClause ( returnClause )? ) ;
    public final XSPARQLRewriter.flworExpr_return flworExpr() throws RecognitionException {
        VariableScope_stack.push(new VariableScope_scope());

        XSPARQLRewriter.flworExpr_return retval = new XSPARQLRewriter.flworExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_FLWOR108=null;
        XSPARQLRewriter.forletClause_return forletClause109 = null;

        XSPARQLRewriter.returnClause_return returnClause110 = null;


        CommonTree T_FLWOR108_tree=null;


          ((VariableScope_scope)VariableScope_stack.peek()).variables = new HashMap<String,Types>();
          ((VariableScope_scope)VariableScope_stack.peek()).positions = new LinkedList<String>();
          ((VariableScope_scope)VariableScope_stack.peek()).scopedDataset = true;
          ((VariableScope_scope)VariableScope_stack.peek()).sparqlClause = false;
          logger.info("Creating new variable scope: flworExpr");

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1021:3: ( ^( T_FLWOR forletClause ( returnClause )? ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1021:5: ^( T_FLWOR forletClause ( returnClause )? )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_FLWOR108=(CommonTree)match(input,T_FLWOR,FOLLOW_T_FLWOR_in_flworExpr2066); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_FLWOR108_tree = (CommonTree)adaptor.dupNode(T_FLWOR108);

            root_1 = (CommonTree)adaptor.becomeRoot(T_FLWOR108_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_forletClause_in_flworExpr2068);
            forletClause109=forletClause();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, forletClause109.getTree());
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1022:7: ( returnClause )?
            int alt26=2;
            switch ( input.LA(1) ) {
                case T_CONSTRUCT:
                case T_RETURN:
                    {
                    alt26=1;
                    }
                    break;
            }

            switch (alt26) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: returnClause
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_returnClause_in_flworExpr2077);
                    returnClause110=returnClause();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, returnClause110.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }


            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
            VariableScope_stack.pop();

        }
        return retval;
    }
    // $ANTLR end "flworExpr"

    public static class returnClause_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "returnClause"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1026:1: returnClause : ( ^( T_RETURN exprSingle ) -> ^( T_RETURN exprSingle ) | ^(c= T_CONSTRUCT constructTemplate ) -> COMMENT[\"SPARQL CONSTRUCT \" + $c.text + \" from \" + $c.line + \":\" + $c.pos] ^( T_RETURN[$c.token, \"return\"] ^( T_FUNCTION_CALL[$c.token, \"T_FUNCTION_CALL\"] NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR constructTemplate ) ) ) ) );
    public final XSPARQLRewriter.returnClause_return returnClause() throws RecognitionException {
        XSPARQLRewriter.returnClause_return retval = new XSPARQLRewriter.returnClause_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree c=null;
        CommonTree T_RETURN111=null;
        XSPARQLRewriter.exprSingle_return exprSingle112 = null;

        XSPARQLRewriter.constructTemplate_return constructTemplate113 = null;


        CommonTree c_tree=null;
        CommonTree T_RETURN111_tree=null;
        RewriteRuleNodeStream stream_T_RETURN=new RewriteRuleNodeStream(adaptor,"token T_RETURN");
        RewriteRuleNodeStream stream_T_CONSTRUCT=new RewriteRuleNodeStream(adaptor,"token T_CONSTRUCT");
        RewriteRuleSubtreeStream stream_constructTemplate=new RewriteRuleSubtreeStream(adaptor,"rule constructTemplate");
        RewriteRuleSubtreeStream stream_exprSingle=new RewriteRuleSubtreeStream(adaptor,"rule exprSingle");

          logger.info("returnClause");

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1031:3: ( ^( T_RETURN exprSingle ) -> ^( T_RETURN exprSingle ) | ^(c= T_CONSTRUCT constructTemplate ) -> COMMENT[\"SPARQL CONSTRUCT \" + $c.text + \" from \" + $c.line + \":\" + $c.pos] ^( T_RETURN[$c.token, \"return\"] ^( T_FUNCTION_CALL[$c.token, \"T_FUNCTION_CALL\"] NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR constructTemplate ) ) ) ) )
            int alt27=2;
            switch ( input.LA(1) ) {
            case T_RETURN:
                {
                alt27=1;
                }
                break;
            case T_CONSTRUCT:
                {
                alt27=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 27, 0, input);

                throw nvae;
            }

            switch (alt27) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1031:5: ^( T_RETURN exprSingle )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_RETURN111=(CommonTree)match(input,T_RETURN,FOLLOW_T_RETURN_in_returnClause2109); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_RETURN.add(T_RETURN111);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_exprSingle_in_returnClause2111);
                    exprSingle112=exprSingle();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_exprSingle.add(exprSingle112.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: T_RETURN, exprSingle
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 1031:28: -> ^( T_RETURN exprSingle )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1031:31: ^( T_RETURN exprSingle )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot(stream_T_RETURN.nextNode(), root_1);

                        adaptor.addChild(root_1, stream_exprSingle.nextTree());
                        adaptor.addChild(root_1,  generatePop() );

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1032:5: ^(c= T_CONSTRUCT constructTemplate )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    c=(CommonTree)match(input,T_CONSTRUCT,FOLLOW_T_CONSTRUCT_in_returnClause2131); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_CONSTRUCT.add(c);



                    if ( input.LA(1)==Token.DOWN ) {
                        match(input, Token.DOWN, null); if (state.failed) return retval;
                        _last = (CommonTree)input.LT(1);
                        pushFollow(FOLLOW_constructTemplate_in_returnClause2134);
                        constructTemplate113=constructTemplate();

                        state._fsp--;
                        if (state.failed) return retval;
                        if ( state.backtracking==0 ) stream_constructTemplate.add(constructTemplate113.getTree());
                        if ( state.backtracking==0 ) {
                           ((exprSingle_scope)exprSingle_stack.peek()).isConstruct = true; 
                        }

                        match(input, Token.UP, null); if (state.failed) return retval;
                    }adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: constructTemplate
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 1033:3: -> COMMENT[\"SPARQL CONSTRUCT \" + $c.text + \" from \" + $c.line + \":\" + $c.pos] ^( T_RETURN[$c.token, \"return\"] ^( T_FUNCTION_CALL[$c.token, \"T_FUNCTION_CALL\"] NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR constructTemplate ) ) ) )
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(COMMENT, "SPARQL CONSTRUCT " + (c!=null?c.getText():null) + " from " + (c!=null?c.getLine():0) + ":" + (c!=null?c.getCharPositionInLine():0)));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1034:6: ^( T_RETURN[$c.token, \"return\"] ^( T_FUNCTION_CALL[$c.token, \"T_FUNCTION_CALL\"] NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR constructTemplate ) ) ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_RETURN, c.token, "return"), root_1);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1035:8: ^( T_FUNCTION_CALL[$c.token, \"T_FUNCTION_CALL\"] NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR constructTemplate ) ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, c.token, "T_FUNCTION_CALL"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(NCNAME, serializeFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1036:10: ^( T_PARAMS ^( T_PAR constructTemplate ) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_3);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1036:21: ^( T_PAR constructTemplate )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_4);

                        adaptor.addChild(root_4, stream_constructTemplate.nextTree());

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }
                        adaptor.addChild(root_1, generatePop());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
            if ( state.backtracking==0 ) {
               if(((VariableScope_scope)VariableScope_stack.peek()).sparqlClause) { scopedDataset.pop(); }
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "returnClause"

    public static class forletClause_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "forletClause"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1042:1: forletClause : ( forClause ( ^( T_WHERE whereClause ) )? ( ^( T_ORDER orderByClause ) )? | sparqlForClause | sqlForClause | letClause ( ^( T_WHERE whereClause ) )? ( ^( T_ORDER orderByClause ) )? );
    public final XSPARQLRewriter.forletClause_return forletClause() throws RecognitionException {
        XSPARQLRewriter.forletClause_return retval = new XSPARQLRewriter.forletClause_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_WHERE115=null;
        CommonTree T_ORDER117=null;
        CommonTree T_WHERE122=null;
        CommonTree T_ORDER124=null;
        XSPARQLRewriter.forClause_return forClause114 = null;

        XSPARQLRewriter.whereClause_return whereClause116 = null;

        XSPARQLRewriter.orderByClause_return orderByClause118 = null;

        XSPARQLRewriter.sparqlForClause_return sparqlForClause119 = null;

        XSPARQLRewriter.sqlForClause_return sqlForClause120 = null;

        XSPARQLRewriter.letClause_return letClause121 = null;

        XSPARQLRewriter.whereClause_return whereClause123 = null;

        XSPARQLRewriter.orderByClause_return orderByClause125 = null;


        CommonTree T_WHERE115_tree=null;
        CommonTree T_ORDER117_tree=null;
        CommonTree T_WHERE122_tree=null;
        CommonTree T_ORDER124_tree=null;

         logger.info("forletClause"); 
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1044:3: ( forClause ( ^( T_WHERE whereClause ) )? ( ^( T_ORDER orderByClause ) )? | sparqlForClause | sqlForClause | letClause ( ^( T_WHERE whereClause ) )? ( ^( T_ORDER orderByClause ) )? )
            int alt32=4;
            switch ( input.LA(1) ) {
            case T_FOR:
                {
                alt32=1;
                }
                break;
            case T_SPARQL_FOR:
                {
                alt32=2;
                }
                break;
            case T_SQL_FOR:
                {
                alt32=3;
                }
                break;
            case T_LET:
                {
                alt32=4;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 32, 0, input);

                throw nvae;
            }

            switch (alt32) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1044:5: forClause ( ^( T_WHERE whereClause ) )? ( ^( T_ORDER orderByClause ) )?
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_forClause_in_forletClause2234);
                    forClause114=forClause();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, forClause114.getTree());
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1044:15: ( ^( T_WHERE whereClause ) )?
                    int alt28=2;
                    switch ( input.LA(1) ) {
                        case T_WHERE:
                            {
                            alt28=1;
                            }
                            break;
                    }

                    switch (alt28) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1044:16: ^( T_WHERE whereClause )
                            {
                            _last = (CommonTree)input.LT(1);
                            {
                            CommonTree _save_last_1 = _last;
                            CommonTree _first_1 = null;
                            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                            T_WHERE115=(CommonTree)match(input,T_WHERE,FOLLOW_T_WHERE_in_forletClause2238); if (state.failed) return retval;
                            if ( state.backtracking==0 ) {
                            T_WHERE115_tree = (CommonTree)adaptor.dupNode(T_WHERE115);

                            root_1 = (CommonTree)adaptor.becomeRoot(T_WHERE115_tree, root_1);
                            }


                            match(input, Token.DOWN, null); if (state.failed) return retval;
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_whereClause_in_forletClause2240);
                            whereClause116=whereClause();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) 
                            adaptor.addChild(root_1, whereClause116.getTree());

                            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                            }


                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }

                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1044:41: ( ^( T_ORDER orderByClause ) )?
                    int alt29=2;
                    switch ( input.LA(1) ) {
                        case T_ORDER:
                            {
                            alt29=1;
                            }
                            break;
                    }

                    switch (alt29) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1044:42: ^( T_ORDER orderByClause )
                            {
                            _last = (CommonTree)input.LT(1);
                            {
                            CommonTree _save_last_1 = _last;
                            CommonTree _first_1 = null;
                            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                            T_ORDER117=(CommonTree)match(input,T_ORDER,FOLLOW_T_ORDER_in_forletClause2247); if (state.failed) return retval;
                            if ( state.backtracking==0 ) {
                            T_ORDER117_tree = (CommonTree)adaptor.dupNode(T_ORDER117);

                            root_1 = (CommonTree)adaptor.becomeRoot(T_ORDER117_tree, root_1);
                            }


                            match(input, Token.DOWN, null); if (state.failed) return retval;
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_orderByClause_in_forletClause2249);
                            orderByClause118=orderByClause();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) 
                            adaptor.addChild(root_1, orderByClause118.getTree());

                            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                            }


                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1045:5: sparqlForClause
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_sparqlForClause_in_forletClause2258);
                    sparqlForClause119=sparqlForClause();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, sparqlForClause119.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1046:5: sqlForClause
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_sqlForClause_in_forletClause2264);
                    sqlForClause120=sqlForClause();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, sqlForClause120.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1047:5: letClause ( ^( T_WHERE whereClause ) )? ( ^( T_ORDER orderByClause ) )?
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_letClause_in_forletClause2270);
                    letClause121=letClause();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, letClause121.getTree());
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1047:15: ( ^( T_WHERE whereClause ) )?
                    int alt30=2;
                    switch ( input.LA(1) ) {
                        case T_WHERE:
                            {
                            alt30=1;
                            }
                            break;
                    }

                    switch (alt30) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1047:16: ^( T_WHERE whereClause )
                            {
                            _last = (CommonTree)input.LT(1);
                            {
                            CommonTree _save_last_1 = _last;
                            CommonTree _first_1 = null;
                            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                            T_WHERE122=(CommonTree)match(input,T_WHERE,FOLLOW_T_WHERE_in_forletClause2274); if (state.failed) return retval;
                            if ( state.backtracking==0 ) {
                            T_WHERE122_tree = (CommonTree)adaptor.dupNode(T_WHERE122);

                            root_1 = (CommonTree)adaptor.becomeRoot(T_WHERE122_tree, root_1);
                            }


                            match(input, Token.DOWN, null); if (state.failed) return retval;
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_whereClause_in_forletClause2276);
                            whereClause123=whereClause();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) 
                            adaptor.addChild(root_1, whereClause123.getTree());

                            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                            }


                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }

                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1047:41: ( ^( T_ORDER orderByClause ) )?
                    int alt31=2;
                    switch ( input.LA(1) ) {
                        case T_ORDER:
                            {
                            alt31=1;
                            }
                            break;
                    }

                    switch (alt31) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1047:42: ^( T_ORDER orderByClause )
                            {
                            _last = (CommonTree)input.LT(1);
                            {
                            CommonTree _save_last_1 = _last;
                            CommonTree _first_1 = null;
                            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                            T_ORDER124=(CommonTree)match(input,T_ORDER,FOLLOW_T_ORDER_in_forletClause2283); if (state.failed) return retval;
                            if ( state.backtracking==0 ) {
                            T_ORDER124_tree = (CommonTree)adaptor.dupNode(T_ORDER124);

                            root_1 = (CommonTree)adaptor.becomeRoot(T_ORDER124_tree, root_1);
                            }


                            match(input, Token.DOWN, null); if (state.failed) return retval;
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_orderByClause_in_forletClause2285);
                            orderByClause125=orderByClause();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) 
                            adaptor.addChild(root_1, orderByClause125.getTree());

                            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                            }


                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "forletClause"

    public static class distinct_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "distinct"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1050:1: distinct : DISTINCT -> QSTRING[ \" DISTINCT \" ] ;
    public final XSPARQLRewriter.distinct_return distinct() throws RecognitionException {
        XSPARQLRewriter.distinct_return retval = new XSPARQLRewriter.distinct_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree DISTINCT126=null;

        CommonTree DISTINCT126_tree=null;
        RewriteRuleNodeStream stream_DISTINCT=new RewriteRuleNodeStream(adaptor,"token DISTINCT");

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1050:9: ( DISTINCT -> QSTRING[ \" DISTINCT \" ] )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1051:3: DISTINCT
            {
            _last = (CommonTree)input.LT(1);
            DISTINCT126=(CommonTree)match(input,DISTINCT,FOLLOW_DISTINCT_in_distinct2301); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_DISTINCT.add(DISTINCT126);



            // AST REWRITE
            // elements: 
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 1051:12: -> QSTRING[ \" DISTINCT \" ]
            {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, " DISTINCT "));

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "distinct"

    protected static class sqlForClause_scope {
        List<Pair<String,String>> relationsAlias;
        List<String> relations;
    }
    protected Stack sqlForClause_stack = new Stack();

    public static class sqlForClause_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "sqlForClause"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1063:1: sqlForClause : ( ^(fo= T_SQL_FOR ( distinct )? (var+= sqlVarOrFunction )+ ) relationClause ( sqlWhereClause )? -> COMMENT[$fo.token, \"SQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? ( $var)+ relationClause ( sqlWhereClause )? ) ) ) ) ) ^( T_FOR VAR[auxResult] ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) ) ) ( ^( REWRITEVNODE[$fo.token, auxResult] $var) )+ | ^(fo= T_SQL_FOR ( distinct )? s= STAR ) relationClause ( sqlWhereClause )? -> COMMENT[$fo.token, \"SQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? QSTRING[concat($sqlForClause::relations, \", \")+\" \"] relationClause ( sqlWhereClause )? ) ) ) ) ) ^( T_FOR VAR[auxResult] ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) ) ) | ^(fo= T_SQL_FOR ( distinct )? ROW v= VAR ) ^( T_SQL_FROM ^( T_FUNCTION_CALL qname ^( T_PARAMS sqlVarOrString ) ) ) -> COMMENT[$fo.token, \"SQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS sqlVarOrString ) ) ) ^( T_FOR $v ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) ) ) | ^(fo= T_SQL_FOR ( distinct )? ROW v= VAR ) relationClause ( sqlWhereClause )? -> COMMENT[$fo.token, \"SQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? QSTRING[\" * \"] relationClause ( sqlWhereClause )? ) ) ) ) ) ^( T_FOR $v ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) ) ) );
    public final XSPARQLRewriter.sqlForClause_return sqlForClause() throws RecognitionException {
        sqlForClause_stack.push(new sqlForClause_scope());
        XSPARQLRewriter.sqlForClause_return retval = new XSPARQLRewriter.sqlForClause_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree fo=null;
        CommonTree s=null;
        CommonTree v=null;
        CommonTree ROW134=null;
        CommonTree T_SQL_FROM135=null;
        CommonTree T_FUNCTION_CALL136=null;
        CommonTree T_PARAMS138=null;
        CommonTree ROW141=null;
        List list_var=null;
        XSPARQLRewriter.distinct_return distinct127 = null;

        XSPARQLRewriter.relationClause_return relationClause128 = null;

        XSPARQLRewriter.sqlWhereClause_return sqlWhereClause129 = null;

        XSPARQLRewriter.distinct_return distinct130 = null;

        XSPARQLRewriter.relationClause_return relationClause131 = null;

        XSPARQLRewriter.sqlWhereClause_return sqlWhereClause132 = null;

        XSPARQLRewriter.distinct_return distinct133 = null;

        XSPARQLRewriter.qname_return qname137 = null;

        XSPARQLRewriter.sqlVarOrString_return sqlVarOrString139 = null;

        XSPARQLRewriter.distinct_return distinct140 = null;

        XSPARQLRewriter.relationClause_return relationClause142 = null;

        XSPARQLRewriter.sqlWhereClause_return sqlWhereClause143 = null;

        RuleReturnScope var = null;
        CommonTree fo_tree=null;
        CommonTree s_tree=null;
        CommonTree v_tree=null;
        CommonTree ROW134_tree=null;
        CommonTree T_SQL_FROM135_tree=null;
        CommonTree T_FUNCTION_CALL136_tree=null;
        CommonTree T_PARAMS138_tree=null;
        CommonTree ROW141_tree=null;
        RewriteRuleNodeStream stream_T_SQL_FOR=new RewriteRuleNodeStream(adaptor,"token T_SQL_FOR");
        RewriteRuleNodeStream stream_T_FUNCTION_CALL=new RewriteRuleNodeStream(adaptor,"token T_FUNCTION_CALL");
        RewriteRuleNodeStream stream_T_PARAMS=new RewriteRuleNodeStream(adaptor,"token T_PARAMS");
        RewriteRuleNodeStream stream_VAR=new RewriteRuleNodeStream(adaptor,"token VAR");
        RewriteRuleNodeStream stream_STAR=new RewriteRuleNodeStream(adaptor,"token STAR");
        RewriteRuleNodeStream stream_ROW=new RewriteRuleNodeStream(adaptor,"token ROW");
        RewriteRuleNodeStream stream_T_SQL_FROM=new RewriteRuleNodeStream(adaptor,"token T_SQL_FROM");
        RewriteRuleSubtreeStream stream_sqlVarOrFunction=new RewriteRuleSubtreeStream(adaptor,"rule sqlVarOrFunction");
        RewriteRuleSubtreeStream stream_sqlWhereClause=new RewriteRuleSubtreeStream(adaptor,"rule sqlWhereClause");
        RewriteRuleSubtreeStream stream_qname=new RewriteRuleSubtreeStream(adaptor,"rule qname");
        RewriteRuleSubtreeStream stream_relationClause=new RewriteRuleSubtreeStream(adaptor,"rule relationClause");
        RewriteRuleSubtreeStream stream_sqlVarOrString=new RewriteRuleSubtreeStream(adaptor,"rule sqlVarOrString");
        RewriteRuleSubtreeStream stream_distinct=new RewriteRuleSubtreeStream(adaptor,"rule distinct");

          String auxResults = getNewAuxResultsVariable();
          String auxResult = getNewAuxResultVariable();
          String auxResultPos = auxResult + "_pos";
          
          ((sqlForClause_scope)sqlForClause_stack.peek()).relationsAlias = new LinkedList<Pair<String,String>>();
          ((sqlForClause_scope)sqlForClause_stack.peek()).relations = new LinkedList<String>();
         
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1076:3: ( ^(fo= T_SQL_FOR ( distinct )? (var+= sqlVarOrFunction )+ ) relationClause ( sqlWhereClause )? -> COMMENT[$fo.token, \"SQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? ( $var)+ relationClause ( sqlWhereClause )? ) ) ) ) ) ^( T_FOR VAR[auxResult] ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) ) ) ( ^( REWRITEVNODE[$fo.token, auxResult] $var) )+ | ^(fo= T_SQL_FOR ( distinct )? s= STAR ) relationClause ( sqlWhereClause )? -> COMMENT[$fo.token, \"SQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? QSTRING[concat($sqlForClause::relations, \", \")+\" \"] relationClause ( sqlWhereClause )? ) ) ) ) ) ^( T_FOR VAR[auxResult] ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) ) ) | ^(fo= T_SQL_FOR ( distinct )? ROW v= VAR ) ^( T_SQL_FROM ^( T_FUNCTION_CALL qname ^( T_PARAMS sqlVarOrString ) ) ) -> COMMENT[$fo.token, \"SQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS sqlVarOrString ) ) ) ^( T_FOR $v ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) ) ) | ^(fo= T_SQL_FOR ( distinct )? ROW v= VAR ) relationClause ( sqlWhereClause )? -> COMMENT[$fo.token, \"SQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? QSTRING[\" * \"] relationClause ( sqlWhereClause )? ) ) ) ) ) ^( T_FOR $v ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) ) ) )
            int alt41=4;
            alt41 = dfa41.predict(input);
            switch (alt41) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1076:5: ^(fo= T_SQL_FOR ( distinct )? (var+= sqlVarOrFunction )+ ) relationClause ( sqlWhereClause )?
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    fo=(CommonTree)match(input,T_SQL_FOR,FOLLOW_T_SQL_FOR_in_sqlForClause2338); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_SQL_FOR.add(fo);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1076:20: ( distinct )?
                    int alt33=2;
                    switch ( input.LA(1) ) {
                        case DISTINCT:
                            {
                            alt33=1;
                            }
                            break;
                    }

                    switch (alt33) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: distinct
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_distinct_in_sqlForClause2340);
                            distinct127=distinct();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_distinct.add(distinct127.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }

                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1076:33: (var+= sqlVarOrFunction )+
                    int cnt34=0;
                    loop34:
                    do {
                        int alt34=2;
                        switch ( input.LA(1) ) {
                        case COMMA:
                        case LPAR:
                        case T_VAR:
                            {
                            alt34=1;
                            }
                            break;

                        }

                        switch (alt34) {
                    	case 1 :
                    	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: var+= sqlVarOrFunction
                    	    {
                    	    _last = (CommonTree)input.LT(1);
                    	    _last = (CommonTree)input.LT(1);
                    	    pushFollow(FOLLOW_sqlVarOrFunction_in_sqlForClause2345);
                    	    var=sqlVarOrFunction();

                    	    state._fsp--;
                    	    if (state.failed) return retval;
                    	    if ( state.backtracking==0 ) stream_sqlVarOrFunction.add(var.getTree());
                    	    if (list_var==null) list_var=new ArrayList();
                    	    list_var.add(var.getTree());


                    	    if ( state.backtracking==0 ) {
                    	    }
                    	    }
                    	    break;

                    	default :
                    	    if ( cnt34 >= 1 ) break loop34;
                    	    if (state.backtracking>0) {state.failed=true; return retval;}
                                EarlyExitException eee =
                                    new EarlyExitException(34, input);
                                throw eee;
                        }
                        cnt34++;
                    } while (true);


                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }

                    if ( state.backtracking==0 ) {
                       addVariablesToScope(list_var, Types.SQL); 
                                                                              addPositionVariableToScope(auxResultPos); 
                    }
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_relationClause_in_sqlForClause2359);
                    relationClause128=relationClause();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_relationClause.add(relationClause128.getTree());
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1078:23: ( sqlWhereClause )?
                    int alt35=2;
                    switch ( input.LA(1) ) {
                        case WHERE:
                            {
                            alt35=1;
                            }
                            break;
                    }

                    switch (alt35) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: sqlWhereClause
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_sqlWhereClause_in_sqlForClause2361);
                            sqlWhereClause129=sqlWhereClause();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_sqlWhereClause.add(sqlWhereClause129.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }



                    // AST REWRITE
                    // elements: var, distinct, var, sqlWhereClause, relationClause
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: var
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
                    RewriteRuleSubtreeStream stream_var=new RewriteRuleSubtreeStream(adaptor,"token var",list_var);
                    root_0 = (CommonTree)adaptor.nil();
                    // 1079:5: -> COMMENT[$fo.token, \"SQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? ( $var)+ relationClause ( sqlWhereClause )? ) ) ) ) ) ^( T_FOR VAR[auxResult] ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) ) ) ( ^( REWRITEVNODE[$fo.token, auxResult] $var) )+
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(COMMENT, fo.token, "SQL FOR from " + (fo!=null?fo.getLine():0) + ":" + (fo!=null?fo.getCharPositionInLine():0)));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1080:5: ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? ( $var)+ relationClause ( sqlWhereClause )? ) ) ) ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_LET, "T_LET"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(VAR, auxResults));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1081:7: ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? ( $var)+ relationClause ( sqlWhereClause )? ) ) ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(NCNAME, SQLevaluationFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1083:9: ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? ( $var)+ relationClause ( sqlWhereClause )? ) ) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_3);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1084:11: ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? ( $var)+ relationClause ( sqlWhereClause )? ) )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_4);

                        adaptor.addChild(root_4, (CommonTree)adaptor.create(NCNAME, "fn:concat"));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1086:13: ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? ( $var)+ relationClause ( sqlWhereClause )? )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(QSTRING, " SELECT "));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1088:15: ( distinct )?
                        if ( stream_distinct.hasNext() ) {
                            adaptor.addChild(root_5, stream_distinct.nextTree());

                        }
                        stream_distinct.reset();
                        if ( !(stream_var.hasNext()) ) {
                            throw new RewriteEarlyExitException();
                        }
                        while ( stream_var.hasNext() ) {
                            adaptor.addChild(root_5, stream_var.nextTree());

                        }
                        stream_var.reset();
                        adaptor.addChild(root_5, stream_relationClause.nextTree());
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1091:15: ( sqlWhereClause )?
                        if ( stream_sqlWhereClause.hasNext() ) {
                            adaptor.addChild(root_5, stream_sqlWhereClause.nextTree());

                        }
                        stream_sqlWhereClause.reset();

                        adaptor.addChild(root_4, root_5);
                        }

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1098:5: ^( T_FOR VAR[auxResult] ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FOR, "T_FOR"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(VAR, auxResult));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1100:7: ^( AT VAR[auxResultPos] )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(AT, "AT"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(VAR, auxResultPos));

                        adaptor.addChild(root_1, root_2);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1103:7: ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(IN, "IN"), root_2);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1104:9: ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_3);

                        adaptor.addChild(root_3, (CommonTree)adaptor.create(NCNAME, SQLiterationFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1106:11: ^( T_PARAMS VAR[auxResults] )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_4);

                        adaptor.addChild(root_4, (CommonTree)adaptor.create(VAR, auxResults));

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }
                        if ( !(stream_var.hasNext()) ) {
                            throw new RewriteEarlyExitException();
                        }
                        while ( stream_var.hasNext() ) {
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1112:5: ^( REWRITEVNODE[$fo.token, auxResult] $var)
                            {
                            CommonTree root_1 = (CommonTree)adaptor.nil();
                            root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(REWRITEVNODE, fo.token, auxResult), root_1);

                            adaptor.addChild(root_1, stream_var.nextTree());

                            adaptor.addChild(root_0, root_1);
                            }

                        }
                        stream_var.reset();

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1114:5: ^(fo= T_SQL_FOR ( distinct )? s= STAR ) relationClause ( sqlWhereClause )?
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    fo=(CommonTree)match(input,T_SQL_FOR,FOLLOW_T_SQL_FOR_in_sqlForClause2793); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_SQL_FOR.add(fo);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1114:20: ( distinct )?
                    int alt36=2;
                    switch ( input.LA(1) ) {
                        case DISTINCT:
                            {
                            alt36=1;
                            }
                            break;
                    }

                    switch (alt36) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: distinct
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_distinct_in_sqlForClause2795);
                            distinct130=distinct();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_distinct.add(distinct130.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }

                    _last = (CommonTree)input.LT(1);
                    s=(CommonTree)match(input,STAR,FOLLOW_STAR_in_sqlForClause2800); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_STAR.add(s);


                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_relationClause_in_sqlForClause2804);
                    relationClause131=relationClause();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_relationClause.add(relationClause131.getTree());
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1114:54: ( sqlWhereClause )?
                    int alt37=2;
                    switch ( input.LA(1) ) {
                        case WHERE:
                            {
                            alt37=1;
                            }
                            break;
                    }

                    switch (alt37) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: sqlWhereClause
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_sqlWhereClause_in_sqlForClause2806);
                            sqlWhereClause132=sqlWhereClause();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_sqlWhereClause.add(sqlWhereClause132.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }

                    if ( state.backtracking==0 ) {
                       if (sqlQuery != null) {
                              ((sqlForClause_scope)sqlForClause_stack.peek()).relations = sqlQuery.getRelationAttributes(((sqlForClause_scope)sqlForClause_stack.peek()).relationsAlias); 
                              addVariablesStringToScope(((sqlForClause_scope)sqlForClause_stack.peek()).relations, Types.SQL); 
                              addPositionVariableToScope(auxResultPos); 
                            } else {
                              logger.severe("Unable to connect to the database!");
                              System.exit(1);
                            }

                          
                    }


                    // AST REWRITE
                    // elements: distinct, relationClause, sqlWhereClause
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 1125:3: -> COMMENT[$fo.token, \"SQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? QSTRING[concat($sqlForClause::relations, \", \")+\" \"] relationClause ( sqlWhereClause )? ) ) ) ) ) ^( T_FOR VAR[auxResult] ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) ) )
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(COMMENT, fo.token, "SQL FOR from " + (fo!=null?fo.getLine():0) + ":" + (fo!=null?fo.getCharPositionInLine():0)));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1126:5: ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? QSTRING[concat($sqlForClause::relations, \", \")+\" \"] relationClause ( sqlWhereClause )? ) ) ) ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_LET, "T_LET"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(VAR, auxResults));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1127:7: ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? QSTRING[concat($sqlForClause::relations, \", \")+\" \"] relationClause ( sqlWhereClause )? ) ) ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(NCNAME, SQLevaluationFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1129:9: ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? QSTRING[concat($sqlForClause::relations, \", \")+\" \"] relationClause ( sqlWhereClause )? ) ) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_3);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1130:11: ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? QSTRING[concat($sqlForClause::relations, \", \")+\" \"] relationClause ( sqlWhereClause )? ) )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_4);

                        adaptor.addChild(root_4, (CommonTree)adaptor.create(NCNAME, "fn:concat"));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1132:13: ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? QSTRING[concat($sqlForClause::relations, \", \")+\" \"] relationClause ( sqlWhereClause )? )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(QSTRING, " SELECT "));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1134:15: ( distinct )?
                        if ( stream_distinct.hasNext() ) {
                            adaptor.addChild(root_5, stream_distinct.nextTree());

                        }
                        stream_distinct.reset();
                        adaptor.addChild(root_5, (CommonTree)adaptor.create(QSTRING, concat(((sqlForClause_scope)sqlForClause_stack.peek()).relations, ", ")+" "));
                        adaptor.addChild(root_5, stream_relationClause.nextTree());
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1137:15: ( sqlWhereClause )?
                        if ( stream_sqlWhereClause.hasNext() ) {
                            adaptor.addChild(root_5, stream_sqlWhereClause.nextTree());

                        }
                        stream_sqlWhereClause.reset();

                        adaptor.addChild(root_4, root_5);
                        }

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1144:5: ^( T_FOR VAR[auxResult] ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FOR, "T_FOR"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(VAR, auxResult));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1146:7: ^( AT VAR[auxResultPos] )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(AT, "AT"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(VAR, auxResultPos));

                        adaptor.addChild(root_1, root_2);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1149:7: ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(IN, "IN"), root_2);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1150:9: ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_3);

                        adaptor.addChild(root_3, (CommonTree)adaptor.create(NCNAME, SQLiterationFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1152:11: ^( T_PARAMS VAR[auxResults] )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_4);

                        adaptor.addChild(root_4, (CommonTree)adaptor.create(VAR, auxResults));

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }
                        adaptor.addChild(root_0, getVarNodes(((sqlForClause_scope)sqlForClause_stack.peek()).relations, auxResult));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1162:5: ^(fo= T_SQL_FOR ( distinct )? ROW v= VAR ) ^( T_SQL_FROM ^( T_FUNCTION_CALL qname ^( T_PARAMS sqlVarOrString ) ) )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    fo=(CommonTree)match(input,T_SQL_FOR,FOLLOW_T_SQL_FOR_in_sqlForClause3232); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_SQL_FOR.add(fo);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1162:20: ( distinct )?
                    int alt38=2;
                    switch ( input.LA(1) ) {
                        case DISTINCT:
                            {
                            alt38=1;
                            }
                            break;
                    }

                    switch (alt38) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: distinct
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_distinct_in_sqlForClause3234);
                            distinct133=distinct();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_distinct.add(distinct133.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }

                    _last = (CommonTree)input.LT(1);
                    ROW134=(CommonTree)match(input,ROW,FOLLOW_ROW_in_sqlForClause3237); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_ROW.add(ROW134);

                    _last = (CommonTree)input.LT(1);
                    v=(CommonTree)match(input,VAR,FOLLOW_VAR_in_sqlForClause3241); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_VAR.add(v);


                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }

                    if ( state.backtracking==0 ) {
                       addVariableToScope((v!=null?v.getText():null), Types.SQL_ROW); addPositionVariableToScope(auxResultPos); 
                    }
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_SQL_FROM135=(CommonTree)match(input,T_SQL_FROM,FOLLOW_T_SQL_FROM_in_sqlForClause3255); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_SQL_FROM.add(T_SQL_FROM135);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_2 = _last;
                    CommonTree _first_2 = null;
                    CommonTree root_2 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_FUNCTION_CALL136=(CommonTree)match(input,T_FUNCTION_CALL,FOLLOW_T_FUNCTION_CALL_in_sqlForClause3258); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_FUNCTION_CALL.add(T_FUNCTION_CALL136);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_qname_in_sqlForClause3260);
                    qname137=qname();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_qname.add(qname137.getTree());
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_3 = _last;
                    CommonTree _first_3 = null;
                    CommonTree root_3 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_PARAMS138=(CommonTree)match(input,T_PARAMS,FOLLOW_T_PARAMS_in_sqlForClause3263); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_PARAMS.add(T_PARAMS138);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_sqlVarOrString_in_sqlForClause3265);
                    sqlVarOrString139=sqlVarOrString();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_sqlVarOrString.add(sqlVarOrString139.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_2, root_3);_last = _save_last_3;
                    }


                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_1, root_2);_last = _save_last_2;
                    }


                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: T_FUNCTION_CALL, T_FUNCTION_CALL, v, VAR, sqlVarOrString, T_PARAMS, VAR, T_PARAMS, VAR
                    // token labels: v
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleNodeStream stream_v=new RewriteRuleNodeStream(adaptor,"token v",v);
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 1164:3: -> COMMENT[$fo.token, \"SQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS sqlVarOrString ) ) ) ^( T_FOR $v ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) ) )
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(COMMENT, fo.token, "SQL FOR from " + (fo!=null?fo.getLine():0) + ":" + (fo!=null?fo.getCharPositionInLine():0)));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1165:5: ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS sqlVarOrString ) ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_LET, "T_LET"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(VAR, auxResults));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1166:7: ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS sqlVarOrString ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot(stream_T_FUNCTION_CALL.nextNode(), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(NCNAME, SQLevaluationFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1168:9: ^( T_PARAMS sqlVarOrString )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot(stream_T_PARAMS.nextNode(), root_3);

                        adaptor.addChild(root_3, stream_sqlVarOrString.nextTree());

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1173:5: ^( T_FOR $v ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FOR, "T_FOR"), root_1);

                        adaptor.addChild(root_1, stream_v.nextNode());
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1175:7: ^( AT VAR[auxResultPos] )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(AT, "AT"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(VAR, auxResultPos));

                        adaptor.addChild(root_1, root_2);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1178:7: ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(IN, "IN"), root_2);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1179:9: ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot(stream_T_FUNCTION_CALL.nextNode(), root_3);

                        adaptor.addChild(root_3, (CommonTree)adaptor.create(NCNAME, SQLiterationFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1181:11: ^( T_PARAMS VAR[auxResults] )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot(stream_T_PARAMS.nextNode(), root_4);

                        adaptor.addChild(root_4, (CommonTree)adaptor.create(VAR, auxResults));

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1189:5: ^(fo= T_SQL_FOR ( distinct )? ROW v= VAR ) relationClause ( sqlWhereClause )?
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    fo=(CommonTree)match(input,T_SQL_FOR,FOLLOW_T_SQL_FOR_in_sqlForClause3526); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_SQL_FOR.add(fo);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1189:20: ( distinct )?
                    int alt39=2;
                    switch ( input.LA(1) ) {
                        case DISTINCT:
                            {
                            alt39=1;
                            }
                            break;
                    }

                    switch (alt39) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: distinct
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_distinct_in_sqlForClause3528);
                            distinct140=distinct();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_distinct.add(distinct140.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }

                    _last = (CommonTree)input.LT(1);
                    ROW141=(CommonTree)match(input,ROW,FOLLOW_ROW_in_sqlForClause3531); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_ROW.add(ROW141);

                    _last = (CommonTree)input.LT(1);
                    v=(CommonTree)match(input,VAR,FOLLOW_VAR_in_sqlForClause3535); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_VAR.add(v);


                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }

                    if ( state.backtracking==0 ) {
                      addVariableToScope((v!=null?v.getText():null), Types.SQL_ROW); addPositionVariableToScope(auxResultPos);
                    }
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_relationClause_in_sqlForClause3550);
                    relationClause142=relationClause();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_relationClause.add(relationClause142.getTree());
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1190:26: ( sqlWhereClause )?
                    int alt40=2;
                    switch ( input.LA(1) ) {
                        case WHERE:
                            {
                            alt40=1;
                            }
                            break;
                    }

                    switch (alt40) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: sqlWhereClause
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_sqlWhereClause_in_sqlForClause3552);
                            sqlWhereClause143=sqlWhereClause();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_sqlWhereClause.add(sqlWhereClause143.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }



                    // AST REWRITE
                    // elements: sqlWhereClause, VAR, distinct, VAR, v, VAR, relationClause
                    // token labels: v
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleNodeStream stream_v=new RewriteRuleNodeStream(adaptor,"token v",v);
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 1191:3: -> COMMENT[$fo.token, \"SQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? QSTRING[\" * \"] relationClause ( sqlWhereClause )? ) ) ) ) ) ^( T_FOR $v ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) ) )
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(COMMENT, fo.token, "SQL FOR from " + (fo!=null?fo.getLine():0) + ":" + (fo!=null?fo.getCharPositionInLine():0)));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1192:5: ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? QSTRING[\" * \"] relationClause ( sqlWhereClause )? ) ) ) ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_LET, "T_LET"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(VAR, auxResults));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1193:7: ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? QSTRING[\" * \"] relationClause ( sqlWhereClause )? ) ) ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(NCNAME, SQLevaluationFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1195:9: ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? QSTRING[\" * \"] relationClause ( sqlWhereClause )? ) ) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_3);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1196:11: ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? QSTRING[\" * \"] relationClause ( sqlWhereClause )? ) )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_4);

                        adaptor.addChild(root_4, (CommonTree)adaptor.create(NCNAME, "fn:concat"));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1198:13: ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? QSTRING[\" * \"] relationClause ( sqlWhereClause )? )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(QSTRING, " SELECT "));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1200:15: ( distinct )?
                        if ( stream_distinct.hasNext() ) {
                            adaptor.addChild(root_5, stream_distinct.nextTree());

                        }
                        stream_distinct.reset();
                        adaptor.addChild(root_5, (CommonTree)adaptor.create(QSTRING, " * "));
                        adaptor.addChild(root_5, stream_relationClause.nextTree());
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1203:15: ( sqlWhereClause )?
                        if ( stream_sqlWhereClause.hasNext() ) {
                            adaptor.addChild(root_5, stream_sqlWhereClause.nextTree());

                        }
                        stream_sqlWhereClause.reset();

                        adaptor.addChild(root_4, root_5);
                        }

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1210:5: ^( T_FOR $v ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FOR, "T_FOR"), root_1);

                        adaptor.addChild(root_1, stream_v.nextNode());
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1212:7: ^( AT VAR[auxResultPos] )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(AT, "AT"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(VAR, auxResultPos));

                        adaptor.addChild(root_1, root_2);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1215:7: ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(IN, "IN"), root_2);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1216:9: ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_3);

                        adaptor.addChild(root_3, (CommonTree)adaptor.create(NCNAME, SQLiterationFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1218:11: ^( T_PARAMS VAR[auxResults] )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_4);

                        adaptor.addChild(root_4, (CommonTree)adaptor.create(VAR, auxResults));

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
            sqlForClause_stack.pop();
        }
        return retval;
    }
    // $ANTLR end "sqlForClause"

    public static class sqlVarOrString_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "sqlVarOrString"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1228:1: sqlVarOrString : ^( T_TABLE v= sqlQuerySpec ) -> $v;
    public final XSPARQLRewriter.sqlVarOrString_return sqlVarOrString() throws RecognitionException {
        XSPARQLRewriter.sqlVarOrString_return retval = new XSPARQLRewriter.sqlVarOrString_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_TABLE144=null;
        XSPARQLRewriter.sqlQuerySpec_return v = null;


        CommonTree T_TABLE144_tree=null;
        RewriteRuleNodeStream stream_T_TABLE=new RewriteRuleNodeStream(adaptor,"token T_TABLE");
        RewriteRuleSubtreeStream stream_sqlQuerySpec=new RewriteRuleSubtreeStream(adaptor,"rule sqlQuerySpec");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1229:3: ( ^( T_TABLE v= sqlQuerySpec ) -> $v)
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1229:5: ^( T_TABLE v= sqlQuerySpec )
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_TABLE144=(CommonTree)match(input,T_TABLE,FOLLOW_T_TABLE_in_sqlVarOrString3968); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_T_TABLE.add(T_TABLE144);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_sqlQuerySpec_in_sqlVarOrString3972);
            v=sqlQuerySpec();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_sqlQuerySpec.add(v.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }



            // AST REWRITE
            // elements: v
            // token labels: 
            // rule labels: v, retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_v=new RewriteRuleSubtreeStream(adaptor,"rule v",v!=null?v.tree:null);
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 1230:3: -> $v
            {
                adaptor.addChild(root_0, stream_v.nextTree());

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "sqlVarOrString"

    public static class sqlQuerySpec_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "sqlQuerySpec"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1234:1: sqlQuerySpec : (v= qname -> QSTRING[$v.text] | VAR );
    public final XSPARQLRewriter.sqlQuerySpec_return sqlQuerySpec() throws RecognitionException {
        XSPARQLRewriter.sqlQuerySpec_return retval = new XSPARQLRewriter.sqlQuerySpec_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree VAR145=null;
        XSPARQLRewriter.qname_return v = null;


        CommonTree VAR145_tree=null;
        RewriteRuleSubtreeStream stream_qname=new RewriteRuleSubtreeStream(adaptor,"rule qname");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1235:3: (v= qname -> QSTRING[$v.text] | VAR )
            int alt42=2;
            switch ( input.LA(1) ) {
            case NCNAME:
            case PNAME_NS:
            case PNAME_LN:
            case A:
            case FROM:
            case TO:
            case ITEM:
            case COMMENT:
            case ROW:
                {
                alt42=1;
                }
                break;
            case VAR:
                {
                alt42=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 42, 0, input);

                throw nvae;
            }

            switch (alt42) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1235:5: v= qname
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_qname_in_sqlQuerySpec3998);
                    v=qname();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_qname.add(v.getTree());


                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 1235:13: -> QSTRING[$v.text]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, (v!=null?(input.getTokenStream().toString(
                          input.getTreeAdaptor().getTokenStartIndex(v.start),
                          input.getTreeAdaptor().getTokenStopIndex(v.start))):null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1236:5: VAR
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    VAR145=(CommonTree)match(input,VAR,FOLLOW_VAR_in_sqlQuerySpec4009); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    VAR145_tree = (CommonTree)adaptor.dupNode(VAR145);

                    adaptor.addChild(root_0, VAR145_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "sqlQuerySpec"

    public static class sqlVarOrFunction_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "sqlVarOrFunction"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1243:1: sqlVarOrFunction : ( ^( T_VAR ( COMMA )? q= qname ) -> ^( T_VAR ( COMMA )? QSTRING[$q.text] VAR[\"\\$\"+$q.text] ) | ^( T_VAR ( COMMA )? q= qname v2= VAR ) -> ^( T_VAR ( COMMA )? QSTRING[$q.text] VAR ) | ( COMMA )? LPAR functionCall AS v3= VAR RPAR );
    public final XSPARQLRewriter.sqlVarOrFunction_return sqlVarOrFunction() throws RecognitionException {
        XSPARQLRewriter.sqlVarOrFunction_return retval = new XSPARQLRewriter.sqlVarOrFunction_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree v2=null;
        CommonTree v3=null;
        CommonTree T_VAR146=null;
        CommonTree COMMA147=null;
        CommonTree T_VAR148=null;
        CommonTree COMMA149=null;
        CommonTree COMMA150=null;
        CommonTree LPAR151=null;
        CommonTree AS153=null;
        CommonTree RPAR154=null;
        XSPARQLRewriter.qname_return q = null;

        XSPARQLRewriter.functionCall_return functionCall152 = null;


        CommonTree v2_tree=null;
        CommonTree v3_tree=null;
        CommonTree T_VAR146_tree=null;
        CommonTree COMMA147_tree=null;
        CommonTree T_VAR148_tree=null;
        CommonTree COMMA149_tree=null;
        CommonTree COMMA150_tree=null;
        CommonTree LPAR151_tree=null;
        CommonTree AS153_tree=null;
        CommonTree RPAR154_tree=null;
        RewriteRuleNodeStream stream_VAR=new RewriteRuleNodeStream(adaptor,"token VAR");
        RewriteRuleNodeStream stream_COMMA=new RewriteRuleNodeStream(adaptor,"token COMMA");
        RewriteRuleNodeStream stream_T_VAR=new RewriteRuleNodeStream(adaptor,"token T_VAR");
        RewriteRuleSubtreeStream stream_qname=new RewriteRuleSubtreeStream(adaptor,"rule qname");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1244:3: ( ^( T_VAR ( COMMA )? q= qname ) -> ^( T_VAR ( COMMA )? QSTRING[$q.text] VAR[\"\\$\"+$q.text] ) | ^( T_VAR ( COMMA )? q= qname v2= VAR ) -> ^( T_VAR ( COMMA )? QSTRING[$q.text] VAR ) | ( COMMA )? LPAR functionCall AS v3= VAR RPAR )
            int alt46=3;
            alt46 = dfa46.predict(input);
            switch (alt46) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1244:5: ^( T_VAR ( COMMA )? q= qname )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_VAR146=(CommonTree)match(input,T_VAR,FOLLOW_T_VAR_in_sqlVarOrFunction4031); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_VAR.add(T_VAR146);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1244:13: ( COMMA )?
                    int alt43=2;
                    switch ( input.LA(1) ) {
                        case COMMA:
                            {
                            alt43=1;
                            }
                            break;
                    }

                    switch (alt43) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: COMMA
                            {
                            _last = (CommonTree)input.LT(1);
                            COMMA147=(CommonTree)match(input,COMMA,FOLLOW_COMMA_in_sqlVarOrFunction4033); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_COMMA.add(COMMA147);


                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_qname_in_sqlVarOrFunction4038);
                    q=qname();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_qname.add(q.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: COMMA, T_VAR
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 1245:5: -> ^( T_VAR ( COMMA )? QSTRING[$q.text] VAR[\"\\$\"+$q.text] )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1245:8: ^( T_VAR ( COMMA )? QSTRING[$q.text] VAR[\"\\$\"+$q.text] )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot(stream_T_VAR.nextNode(), root_1);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1245:16: ( COMMA )?
                        if ( stream_COMMA.hasNext() ) {
                            adaptor.addChild(root_1, stream_COMMA.nextNode());

                        }
                        stream_COMMA.reset();
                        adaptor.addChild(root_1, (CommonTree)adaptor.create(QSTRING, (q!=null?(input.getTokenStream().toString(
                          input.getTreeAdaptor().getTokenStartIndex(q.start),
                          input.getTreeAdaptor().getTokenStopIndex(q.start))):null)));
                        adaptor.addChild(root_1, (CommonTree)adaptor.create(VAR, "$"+(q!=null?(input.getTokenStream().toString(
                          input.getTreeAdaptor().getTokenStartIndex(q.start),
                          input.getTreeAdaptor().getTokenStopIndex(q.start))):null)));

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1246:5: ^( T_VAR ( COMMA )? q= qname v2= VAR )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_VAR148=(CommonTree)match(input,T_VAR,FOLLOW_T_VAR_in_sqlVarOrFunction4066); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_VAR.add(T_VAR148);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1246:13: ( COMMA )?
                    int alt44=2;
                    switch ( input.LA(1) ) {
                        case COMMA:
                            {
                            alt44=1;
                            }
                            break;
                    }

                    switch (alt44) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: COMMA
                            {
                            _last = (CommonTree)input.LT(1);
                            COMMA149=(CommonTree)match(input,COMMA,FOLLOW_COMMA_in_sqlVarOrFunction4068); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_COMMA.add(COMMA149);


                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_qname_in_sqlVarOrFunction4073);
                    q=qname();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_qname.add(q.getTree());
                    _last = (CommonTree)input.LT(1);
                    v2=(CommonTree)match(input,VAR,FOLLOW_VAR_in_sqlVarOrFunction4077); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_VAR.add(v2);


                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: VAR, COMMA, T_VAR
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 1247:5: -> ^( T_VAR ( COMMA )? QSTRING[$q.text] VAR )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1247:8: ^( T_VAR ( COMMA )? QSTRING[$q.text] VAR )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot(stream_T_VAR.nextNode(), root_1);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1247:16: ( COMMA )?
                        if ( stream_COMMA.hasNext() ) {
                            adaptor.addChild(root_1, stream_COMMA.nextNode());

                        }
                        stream_COMMA.reset();
                        adaptor.addChild(root_1, (CommonTree)adaptor.create(QSTRING, (q!=null?(input.getTokenStream().toString(
                          input.getTreeAdaptor().getTokenStartIndex(q.start),
                          input.getTreeAdaptor().getTokenStopIndex(q.start))):null)));
                        adaptor.addChild(root_1, stream_VAR.nextNode());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1248:5: ( COMMA )? LPAR functionCall AS v3= VAR RPAR
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1248:5: ( COMMA )?
                    int alt45=2;
                    switch ( input.LA(1) ) {
                        case COMMA:
                            {
                            alt45=1;
                            }
                            break;
                    }

                    switch (alt45) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: COMMA
                            {
                            _last = (CommonTree)input.LT(1);
                            COMMA150=(CommonTree)match(input,COMMA,FOLLOW_COMMA_in_sqlVarOrFunction4103); if (state.failed) return retval;
                            if ( state.backtracking==0 ) {
                            COMMA150_tree = (CommonTree)adaptor.dupNode(COMMA150);

                            adaptor.addChild(root_0, COMMA150_tree);
                            }

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }

                    _last = (CommonTree)input.LT(1);
                    LPAR151=(CommonTree)match(input,LPAR,FOLLOW_LPAR_in_sqlVarOrFunction4106); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    LPAR151_tree = (CommonTree)adaptor.dupNode(LPAR151);

                    adaptor.addChild(root_0, LPAR151_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_functionCall_in_sqlVarOrFunction4108);
                    functionCall152=functionCall();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, functionCall152.getTree());
                    _last = (CommonTree)input.LT(1);
                    AS153=(CommonTree)match(input,AS,FOLLOW_AS_in_sqlVarOrFunction4110); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    AS153_tree = (CommonTree)adaptor.dupNode(AS153);

                    adaptor.addChild(root_0, AS153_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    v3=(CommonTree)match(input,VAR,FOLLOW_VAR_in_sqlVarOrFunction4114); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    v3_tree = (CommonTree)adaptor.dupNode(v3);

                    adaptor.addChild(root_0, v3_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    RPAR154=(CommonTree)match(input,RPAR,FOLLOW_RPAR_in_sqlVarOrFunction4116); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    RPAR154_tree = (CommonTree)adaptor.dupNode(RPAR154);

                    adaptor.addChild(root_0, RPAR154_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "sqlVarOrFunction"

    public static class relationClause_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "relationClause"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1252:1: relationClause : ^( T_SQL_FROM rdbSourceSelector ( COMMA rdbSourceSelector )* ) -> QSTRING[\"from \"] rdbSourceSelector ( QSTRING[\", \"] rdbSourceSelector )* ;
    public final XSPARQLRewriter.relationClause_return relationClause() throws RecognitionException {
        XSPARQLRewriter.relationClause_return retval = new XSPARQLRewriter.relationClause_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_SQL_FROM155=null;
        CommonTree COMMA157=null;
        XSPARQLRewriter.rdbSourceSelector_return rdbSourceSelector156 = null;

        XSPARQLRewriter.rdbSourceSelector_return rdbSourceSelector158 = null;


        CommonTree T_SQL_FROM155_tree=null;
        CommonTree COMMA157_tree=null;
        RewriteRuleNodeStream stream_COMMA=new RewriteRuleNodeStream(adaptor,"token COMMA");
        RewriteRuleNodeStream stream_T_SQL_FROM=new RewriteRuleNodeStream(adaptor,"token T_SQL_FROM");
        RewriteRuleSubtreeStream stream_rdbSourceSelector=new RewriteRuleSubtreeStream(adaptor,"rule rdbSourceSelector");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1253:3: ( ^( T_SQL_FROM rdbSourceSelector ( COMMA rdbSourceSelector )* ) -> QSTRING[\"from \"] rdbSourceSelector ( QSTRING[\", \"] rdbSourceSelector )* )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1253:5: ^( T_SQL_FROM rdbSourceSelector ( COMMA rdbSourceSelector )* )
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_SQL_FROM155=(CommonTree)match(input,T_SQL_FROM,FOLLOW_T_SQL_FROM_in_relationClause4129); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_T_SQL_FROM.add(T_SQL_FROM155);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_rdbSourceSelector_in_relationClause4131);
            rdbSourceSelector156=rdbSourceSelector();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_rdbSourceSelector.add(rdbSourceSelector156.getTree());
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1253:36: ( COMMA rdbSourceSelector )*
            loop47:
            do {
                int alt47=2;
                switch ( input.LA(1) ) {
                case COMMA:
                    {
                    alt47=1;
                    }
                    break;

                }

                switch (alt47) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1253:37: COMMA rdbSourceSelector
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    COMMA157=(CommonTree)match(input,COMMA,FOLLOW_COMMA_in_relationClause4134); if (state.failed) return retval; 
            	    if ( state.backtracking==0 ) stream_COMMA.add(COMMA157);

            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_rdbSourceSelector_in_relationClause4136);
            	    rdbSourceSelector158=rdbSourceSelector();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_rdbSourceSelector.add(rdbSourceSelector158.getTree());

            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    break loop47;
                }
            } while (true);


            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }



            // AST REWRITE
            // elements: rdbSourceSelector, rdbSourceSelector
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 1254:5: -> QSTRING[\"from \"] rdbSourceSelector ( QSTRING[\", \"] rdbSourceSelector )*
            {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, "from "));
                adaptor.addChild(root_0, stream_rdbSourceSelector.nextTree());
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1254:43: ( QSTRING[\", \"] rdbSourceSelector )*
                while ( stream_rdbSourceSelector.hasNext() ) {
                    adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, ", "));
                    adaptor.addChild(root_0, stream_rdbSourceSelector.nextTree());

                }
                stream_rdbSourceSelector.reset();

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "relationClause"

    public static class rdbSourceSelector_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "rdbSourceSelector"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1257:1: rdbSourceSelector : ^( T_TABLE v= relationSchemaName (alias= relationAlias )? ) -> $v ( QSTRING[\" \"] $alias)? ;
    public final XSPARQLRewriter.rdbSourceSelector_return rdbSourceSelector() throws RecognitionException {
        XSPARQLRewriter.rdbSourceSelector_return retval = new XSPARQLRewriter.rdbSourceSelector_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_TABLE159=null;
        XSPARQLRewriter.relationSchemaName_return v = null;

        XSPARQLRewriter.relationAlias_return alias = null;


        CommonTree T_TABLE159_tree=null;
        RewriteRuleNodeStream stream_T_TABLE=new RewriteRuleNodeStream(adaptor,"token T_TABLE");
        RewriteRuleSubtreeStream stream_relationSchemaName=new RewriteRuleSubtreeStream(adaptor,"rule relationSchemaName");
        RewriteRuleSubtreeStream stream_relationAlias=new RewriteRuleSubtreeStream(adaptor,"rule relationAlias");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1258:3: ( ^( T_TABLE v= relationSchemaName (alias= relationAlias )? ) -> $v ( QSTRING[\" \"] $alias)? )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1258:5: ^( T_TABLE v= relationSchemaName (alias= relationAlias )? )
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_TABLE159=(CommonTree)match(input,T_TABLE,FOLLOW_T_TABLE_in_rdbSourceSelector4173); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_T_TABLE.add(T_TABLE159);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_relationSchemaName_in_rdbSourceSelector4177);
            v=relationSchemaName();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_relationSchemaName.add(v.getTree());
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1258:41: (alias= relationAlias )?
            int alt48=2;
            switch ( input.LA(1) ) {
                case VAR:
                case NCNAME:
                case PNAME_NS:
                case PNAME_LN:
                case A:
                case FROM:
                case TO:
                case ITEM:
                case COMMENT:
                case ROW:
                    {
                    alt48=1;
                    }
                    break;
            }

            switch (alt48) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: alias= relationAlias
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_relationAlias_in_rdbSourceSelector4181);
                    alias=relationAlias();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_relationAlias.add(alias.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }


            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }

            if ( state.backtracking==0 ) {
               ((sqlForClause_scope)sqlForClause_stack.peek()).relationsAlias.add(new Pair<String,String>((v!=null?(input.getTokenStream().toString(
                input.getTreeAdaptor().getTokenStartIndex(v.start),
                input.getTreeAdaptor().getTokenStopIndex(v.start))):null), (alias!=null?(input.getTokenStream().toString(
                input.getTreeAdaptor().getTokenStartIndex(alias.start),
                input.getTreeAdaptor().getTokenStopIndex(alias.start))):null))); 
            }


            // AST REWRITE
            // elements: v, alias
            // token labels: 
            // rule labels: v, retval, alias
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_v=new RewriteRuleSubtreeStream(adaptor,"rule v",v!=null?v.tree:null);
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
            RewriteRuleSubtreeStream stream_alias=new RewriteRuleSubtreeStream(adaptor,"rule alias",alias!=null?alias.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 1260:3: -> $v ( QSTRING[\" \"] $alias)?
            {
                adaptor.addChild(root_0, stream_v.nextTree());
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1260:9: ( QSTRING[\" \"] $alias)?
                if ( stream_alias.hasNext() ) {
                    adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, " "));
                    adaptor.addChild(root_0, stream_alias.nextTree());

                }
                stream_alias.reset();

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "rdbSourceSelector"

    public static class relationSchemaName_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "relationSchemaName"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1264:1: relationSchemaName : (p1= qname DOT q1= qname -> QSTRING[\"\\\"\\\"\"+$p1.text+\"\\\"\\\".\\\"\\\"\"+$q1.text+\"\\\"\\\"\"] | relationAlias | p2= relationAlias DOT q2= relationAlias -> ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS $p2 QSTRING[\".\"] $q2) ) );
    public final XSPARQLRewriter.relationSchemaName_return relationSchemaName() throws RecognitionException {
        XSPARQLRewriter.relationSchemaName_return retval = new XSPARQLRewriter.relationSchemaName_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree DOT160=null;
        CommonTree DOT162=null;
        XSPARQLRewriter.qname_return p1 = null;

        XSPARQLRewriter.qname_return q1 = null;

        XSPARQLRewriter.relationAlias_return p2 = null;

        XSPARQLRewriter.relationAlias_return q2 = null;

        XSPARQLRewriter.relationAlias_return relationAlias161 = null;


        CommonTree DOT160_tree=null;
        CommonTree DOT162_tree=null;
        RewriteRuleNodeStream stream_DOT=new RewriteRuleNodeStream(adaptor,"token DOT");
        RewriteRuleSubtreeStream stream_qname=new RewriteRuleSubtreeStream(adaptor,"rule qname");
        RewriteRuleSubtreeStream stream_relationAlias=new RewriteRuleSubtreeStream(adaptor,"rule relationAlias");
         logger.info("relationSchemaName"); 
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1266:3: (p1= qname DOT q1= qname -> QSTRING[\"\\\"\\\"\"+$p1.text+\"\\\"\\\".\\\"\\\"\"+$q1.text+\"\\\"\\\"\"] | relationAlias | p2= relationAlias DOT q2= relationAlias -> ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS $p2 QSTRING[\".\"] $q2) ) )
            int alt49=3;
            alt49 = dfa49.predict(input);
            switch (alt49) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1266:5: p1= qname DOT q1= qname
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_qname_in_relationSchemaName4229);
                    p1=qname();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_qname.add(p1.getTree());
                    _last = (CommonTree)input.LT(1);
                    DOT160=(CommonTree)match(input,DOT,FOLLOW_DOT_in_relationSchemaName4231); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_DOT.add(DOT160);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_qname_in_relationSchemaName4235);
                    q1=qname();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_qname.add(q1.getTree());


                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 1266:27: -> QSTRING[\"\\\"\\\"\"+$p1.text+\"\\\"\\\".\\\"\\\"\"+$q1.text+\"\\\"\\\"\"]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, "\"\""+(p1!=null?(input.getTokenStream().toString(
                          input.getTreeAdaptor().getTokenStartIndex(p1.start),
                          input.getTreeAdaptor().getTokenStopIndex(p1.start))):null)+"\"\".\"\""+(q1!=null?(input.getTokenStream().toString(
                          input.getTreeAdaptor().getTokenStartIndex(q1.start),
                          input.getTreeAdaptor().getTokenStopIndex(q1.start))):null)+"\"\""));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1267:5: relationAlias
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_relationAlias_in_relationSchemaName4246);
                    relationAlias161=relationAlias();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, relationAlias161.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1268:5: p2= relationAlias DOT q2= relationAlias
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_relationAlias_in_relationSchemaName4257);
                    p2=relationAlias();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_relationAlias.add(p2.getTree());
                    _last = (CommonTree)input.LT(1);
                    DOT162=(CommonTree)match(input,DOT,FOLLOW_DOT_in_relationSchemaName4259); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_DOT.add(DOT162);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_relationAlias_in_relationSchemaName4263);
                    q2=relationAlias();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_relationAlias.add(q2.getTree());


                    // AST REWRITE
                    // elements: p2, q2
                    // token labels: 
                    // rule labels: retval, q2, p2
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
                    RewriteRuleSubtreeStream stream_q2=new RewriteRuleSubtreeStream(adaptor,"rule q2",q2!=null?q2.tree:null);
                    RewriteRuleSubtreeStream stream_p2=new RewriteRuleSubtreeStream(adaptor,"rule p2",p2!=null?p2.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 1268:43: -> ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS $p2 QSTRING[\".\"] $q2) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1269:5: ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS $p2 QSTRING[\".\"] $q2) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(NCNAME, "fn:concat"));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1269:43: ^( T_PARAMS $p2 QSTRING[\".\"] $q2)
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_2);

                        adaptor.addChild(root_2, stream_p2.nextTree());
                        adaptor.addChild(root_2, (CommonTree)adaptor.create(QSTRING, "."));
                        adaptor.addChild(root_2, stream_q2.nextTree());

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "relationSchemaName"

    public static class relationAlias_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "relationAlias"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1273:1: relationAlias : (v= qname -> QSTRING[\"\\\"\\\"\"+$v.text+\"\\\"\\\"\"] | var= VAR -> ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\"\\\"\\\"\"] $var QSTRING[\"\\\"\\\"\"] ) ) );
    public final XSPARQLRewriter.relationAlias_return relationAlias() throws RecognitionException {
        XSPARQLRewriter.relationAlias_return retval = new XSPARQLRewriter.relationAlias_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree var=null;
        XSPARQLRewriter.qname_return v = null;


        CommonTree var_tree=null;
        RewriteRuleNodeStream stream_VAR=new RewriteRuleNodeStream(adaptor,"token VAR");
        RewriteRuleSubtreeStream stream_qname=new RewriteRuleSubtreeStream(adaptor,"rule qname");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1274:3: (v= qname -> QSTRING[\"\\\"\\\"\"+$v.text+\"\\\"\\\"\"] | var= VAR -> ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\"\\\"\\\"\"] $var QSTRING[\"\\\"\\\"\"] ) ) )
            int alt50=2;
            switch ( input.LA(1) ) {
            case NCNAME:
            case PNAME_NS:
            case PNAME_LN:
            case A:
            case FROM:
            case TO:
            case ITEM:
            case COMMENT:
            case ROW:
                {
                alt50=1;
                }
                break;
            case VAR:
                {
                alt50=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 50, 0, input);

                throw nvae;
            }

            switch (alt50) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1274:5: v= qname
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_qname_in_relationAlias4307);
                    v=qname();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_qname.add(v.getTree());


                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 1274:13: -> QSTRING[\"\\\"\\\"\"+$v.text+\"\\\"\\\"\"]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, "\"\""+(v!=null?(input.getTokenStream().toString(
                          input.getTreeAdaptor().getTokenStartIndex(v.start),
                          input.getTreeAdaptor().getTokenStopIndex(v.start))):null)+"\"\""));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1275:5: var= VAR
                    {
                    _last = (CommonTree)input.LT(1);
                    var=(CommonTree)match(input,VAR,FOLLOW_VAR_in_relationAlias4320); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_VAR.add(var);



                    // AST REWRITE
                    // elements: var
                    // token labels: var
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleNodeStream stream_var=new RewriteRuleNodeStream(adaptor,"token var",var);
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 1275:14: -> ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\"\\\"\\\"\"] $var QSTRING[\"\\\"\\\"\"] ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1275:17: ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\"\\\"\\\"\"] $var QSTRING[\"\\\"\\\"\"] ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(NCNAME, "fn:concat"));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1275:55: ^( T_PARAMS QSTRING[\"\\\"\\\"\"] $var QSTRING[\"\\\"\\\"\"] )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(QSTRING, "\"\""));
                        adaptor.addChild(root_2, stream_var.nextNode());
                        adaptor.addChild(root_2, (CommonTree)adaptor.create(QSTRING, "\"\""));

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "relationAlias"

    public static class sqlWhereClause_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "sqlWhereClause"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1278:1: sqlWhereClause : ^( WHERE sqlWhereSpecList ) -> QSTRING[\" where \"] sqlWhereSpecList ;
    public final XSPARQLRewriter.sqlWhereClause_return sqlWhereClause() throws RecognitionException {
        XSPARQLRewriter.sqlWhereClause_return retval = new XSPARQLRewriter.sqlWhereClause_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree WHERE163=null;
        XSPARQLRewriter.sqlWhereSpecList_return sqlWhereSpecList164 = null;


        CommonTree WHERE163_tree=null;
        RewriteRuleNodeStream stream_WHERE=new RewriteRuleNodeStream(adaptor,"token WHERE");
        RewriteRuleSubtreeStream stream_sqlWhereSpecList=new RewriteRuleSubtreeStream(adaptor,"rule sqlWhereSpecList");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1279:3: ( ^( WHERE sqlWhereSpecList ) -> QSTRING[\" where \"] sqlWhereSpecList )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1279:5: ^( WHERE sqlWhereSpecList )
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            WHERE163=(CommonTree)match(input,WHERE,FOLLOW_WHERE_in_sqlWhereClause4359); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_WHERE.add(WHERE163);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_sqlWhereSpecList_in_sqlWhereClause4361);
            sqlWhereSpecList164=sqlWhereSpecList();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_sqlWhereSpecList.add(sqlWhereSpecList164.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }



            // AST REWRITE
            // elements: sqlWhereSpecList
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 1280:3: -> QSTRING[\" where \"] sqlWhereSpecList
            {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, " where "));
                adaptor.addChild(root_0, stream_sqlWhereSpecList.nextTree());

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "sqlWhereClause"

    public static class sqlWhereSpecList_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "sqlWhereSpecList"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1283:1: sqlWhereSpecList : sqlAttrSpecList (b= sqlBooleanOp sqlWhereSpecList )* -> sqlAttrSpecList ( QSTRING[\" \"] QSTRING[$b.text] QSTRING[\" \"] sqlWhereSpecList )* ;
    public final XSPARQLRewriter.sqlWhereSpecList_return sqlWhereSpecList() throws RecognitionException {
        XSPARQLRewriter.sqlWhereSpecList_return retval = new XSPARQLRewriter.sqlWhereSpecList_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.sqlBooleanOp_return b = null;

        XSPARQLRewriter.sqlAttrSpecList_return sqlAttrSpecList165 = null;

        XSPARQLRewriter.sqlWhereSpecList_return sqlWhereSpecList166 = null;


        RewriteRuleSubtreeStream stream_sqlWhereSpecList=new RewriteRuleSubtreeStream(adaptor,"rule sqlWhereSpecList");
        RewriteRuleSubtreeStream stream_sqlAttrSpecList=new RewriteRuleSubtreeStream(adaptor,"rule sqlAttrSpecList");
        RewriteRuleSubtreeStream stream_sqlBooleanOp=new RewriteRuleSubtreeStream(adaptor,"rule sqlBooleanOp");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1284:2: ( sqlAttrSpecList (b= sqlBooleanOp sqlWhereSpecList )* -> sqlAttrSpecList ( QSTRING[\" \"] QSTRING[$b.text] QSTRING[\" \"] sqlWhereSpecList )* )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1284:4: sqlAttrSpecList (b= sqlBooleanOp sqlWhereSpecList )*
            {
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_sqlAttrSpecList_in_sqlWhereSpecList4386);
            sqlAttrSpecList165=sqlAttrSpecList();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_sqlAttrSpecList.add(sqlAttrSpecList165.getTree());
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1284:20: (b= sqlBooleanOp sqlWhereSpecList )*
            loop51:
            do {
                int alt51=2;
                switch ( input.LA(1) ) {
                case AND:
                case OR:
                    {
                    int LA51_2 = input.LA(2);

                    if ( (synpred77_XSPARQLRewriter()) ) {
                        alt51=1;
                    }


                    }
                    break;

                }

                switch (alt51) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1284:21: b= sqlBooleanOp sqlWhereSpecList
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_sqlBooleanOp_in_sqlWhereSpecList4391);
            	    b=sqlBooleanOp();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_sqlBooleanOp.add(b.getTree());
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_sqlWhereSpecList_in_sqlWhereSpecList4393);
            	    sqlWhereSpecList166=sqlWhereSpecList();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_sqlWhereSpecList.add(sqlWhereSpecList166.getTree());

            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    break loop51;
                }
            } while (true);



            // AST REWRITE
            // elements: sqlAttrSpecList, sqlWhereSpecList
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 1285:2: -> sqlAttrSpecList ( QSTRING[\" \"] QSTRING[$b.text] QSTRING[\" \"] sqlWhereSpecList )*
            {
                adaptor.addChild(root_0, stream_sqlAttrSpecList.nextTree());
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1285:21: ( QSTRING[\" \"] QSTRING[$b.text] QSTRING[\" \"] sqlWhereSpecList )*
                while ( stream_sqlWhereSpecList.hasNext() ) {
                    adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, " "));
                    adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, (b!=null?(input.getTokenStream().toString(
                      input.getTreeAdaptor().getTokenStartIndex(b.start),
                      input.getTreeAdaptor().getTokenStopIndex(b.start))):null)));
                    adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, " "));
                    adaptor.addChild(root_0, stream_sqlWhereSpecList.nextTree());

                }
                stream_sqlWhereSpecList.reset();

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "sqlWhereSpecList"

    public static class sqlAttrSpecList_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "sqlAttrSpecList"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1289:1: sqlAttrSpecList : ( sqlAttrSpec g= generalComp sqlAttrSpec -> sqlAttrSpec QSTRING[\" \"] QSTRING[$g.text] QSTRING[\" \"] sqlAttrSpec | l= LPAR sqlWhereSpecList r= RPAR -> QSTRING[$l.text] sqlWhereSpecList QSTRING[$r.text] );
    public final XSPARQLRewriter.sqlAttrSpecList_return sqlAttrSpecList() throws RecognitionException {
        XSPARQLRewriter.sqlAttrSpecList_return retval = new XSPARQLRewriter.sqlAttrSpecList_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree l=null;
        CommonTree r=null;
        XSPARQLRewriter.generalComp_return g = null;

        XSPARQLRewriter.sqlAttrSpec_return sqlAttrSpec167 = null;

        XSPARQLRewriter.sqlAttrSpec_return sqlAttrSpec168 = null;

        XSPARQLRewriter.sqlWhereSpecList_return sqlWhereSpecList169 = null;


        CommonTree l_tree=null;
        CommonTree r_tree=null;
        RewriteRuleNodeStream stream_RPAR=new RewriteRuleNodeStream(adaptor,"token RPAR");
        RewriteRuleNodeStream stream_LPAR=new RewriteRuleNodeStream(adaptor,"token LPAR");
        RewriteRuleSubtreeStream stream_generalComp=new RewriteRuleSubtreeStream(adaptor,"rule generalComp");
        RewriteRuleSubtreeStream stream_sqlWhereSpecList=new RewriteRuleSubtreeStream(adaptor,"rule sqlWhereSpecList");
        RewriteRuleSubtreeStream stream_sqlAttrSpec=new RewriteRuleSubtreeStream(adaptor,"rule sqlAttrSpec");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1290:3: ( sqlAttrSpec g= generalComp sqlAttrSpec -> sqlAttrSpec QSTRING[\" \"] QSTRING[$g.text] QSTRING[\" \"] sqlAttrSpec | l= LPAR sqlWhereSpecList r= RPAR -> QSTRING[$l.text] sqlWhereSpecList QSTRING[$r.text] )
            int alt52=2;
            switch ( input.LA(1) ) {
            case VAR:
            case INTEGER:
            case LCURLY:
            case NCNAME:
            case QSTRING:
            case STAR:
            case LESSTHAN:
            case GREATERTHAN:
            case PLUS:
            case MINUS:
            case UNIONSYMBOL:
            case LESSTHANLESSTHAN:
            case GREATERTHANEQUALS:
            case LESSTHANEQUALS:
            case HAFENEQUALS:
            case EQUALS:
            case PNAME_NS:
            case PNAME_LN:
            case A:
            case IS:
            case EQ:
            case NE:
            case LT:
            case GE:
            case LE:
            case GT:
            case FROM:
            case IF:
            case AND:
            case OR:
            case TO:
            case DIV:
            case IDIV:
            case MOD:
            case UNION:
            case INTERSECT:
            case EXCEPT:
            case ITEM:
            case COMMENT:
            case GREATERTHANGREATERTHAN:
            case ROW:
            case T_FLWOR:
            case T_INSTANCEOF:
            case T_CASTAS:
            case T_CASTABLEAS:
            case T_TREATAS:
            case EVERY:
            case TYPESWITCH:
            case VALIDATE:
            case SOME:
            case XPATH:
            case DECIMAL:
                {
                alt52=1;
                }
                break;
            case LPAR:
                {
                alt52=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 52, 0, input);

                throw nvae;
            }

            switch (alt52) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1290:5: sqlAttrSpec g= generalComp sqlAttrSpec
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_sqlAttrSpec_in_sqlAttrSpecList4431);
                    sqlAttrSpec167=sqlAttrSpec();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_sqlAttrSpec.add(sqlAttrSpec167.getTree());
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_generalComp_in_sqlAttrSpecList4435);
                    g=generalComp();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_generalComp.add(g.getTree());
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_sqlAttrSpec_in_sqlAttrSpecList4437);
                    sqlAttrSpec168=sqlAttrSpec();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_sqlAttrSpec.add(sqlAttrSpec168.getTree());


                    // AST REWRITE
                    // elements: sqlAttrSpec, sqlAttrSpec
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 1291:2: -> sqlAttrSpec QSTRING[\" \"] QSTRING[$g.text] QSTRING[\" \"] sqlAttrSpec
                    {
                        adaptor.addChild(root_0, stream_sqlAttrSpec.nextTree());
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, " "));
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, (g!=null?(input.getTokenStream().toString(
                          input.getTreeAdaptor().getTokenStartIndex(g.start),
                          input.getTreeAdaptor().getTokenStopIndex(g.start))):null)));
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, " "));
                        adaptor.addChild(root_0, stream_sqlAttrSpec.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1292:5: l= LPAR sqlWhereSpecList r= RPAR
                    {
                    _last = (CommonTree)input.LT(1);
                    l=(CommonTree)match(input,LPAR,FOLLOW_LPAR_in_sqlAttrSpecList4462); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_LPAR.add(l);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_sqlWhereSpecList_in_sqlAttrSpecList4464);
                    sqlWhereSpecList169=sqlWhereSpecList();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_sqlWhereSpecList.add(sqlWhereSpecList169.getTree());
                    _last = (CommonTree)input.LT(1);
                    r=(CommonTree)match(input,RPAR,FOLLOW_RPAR_in_sqlAttrSpecList4468); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_RPAR.add(r);



                    // AST REWRITE
                    // elements: sqlWhereSpecList
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 1293:3: -> QSTRING[$l.text] sqlWhereSpecList QSTRING[$r.text]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, (l!=null?l.getText():null)));
                        adaptor.addChild(root_0, stream_sqlWhereSpecList.nextTree());
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, (r!=null?r.getText():null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "sqlAttrSpecList"

    public static class sqlBooleanOp_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "sqlBooleanOp"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1296:1: sqlBooleanOp : ( AND | OR );
    public final XSPARQLRewriter.sqlBooleanOp_return sqlBooleanOp() throws RecognitionException {
        XSPARQLRewriter.sqlBooleanOp_return retval = new XSPARQLRewriter.sqlBooleanOp_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree set170=null;

        CommonTree set170_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1297:3: ( AND | OR )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            set170=(CommonTree)input.LT(1);
            if ( (input.LA(1)>=AND && input.LA(1)<=OR) ) {
                input.consume();

                if ( state.backtracking==0 ) {
                set170_tree = (CommonTree)adaptor.dupNode(set170);

                adaptor.addChild(root_0, set170_tree);
                }
                state.errorRecovery=false;state.failed=false;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }

            if ( state.backtracking==0 ) {
            } 

            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "sqlBooleanOp"

    public static class sqlAttrSpec_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "sqlAttrSpec"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1300:1: sqlAttrSpec : (v= qname -> QSTRING[$v.text] | VAR -> ^( T_FUNCTION_CALL NCNAME[\"_xsparql:_sql_binding_term\"] ^( T_PARAMS VAR ) ) | nl= numericliteral -> QSTRING[$nl.text] | sl= stringliteral -> QSTRING[\"'\"+$sl.text+\"'\"] | enclosedExpr );
    public final XSPARQLRewriter.sqlAttrSpec_return sqlAttrSpec() throws RecognitionException {
        XSPARQLRewriter.sqlAttrSpec_return retval = new XSPARQLRewriter.sqlAttrSpec_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree VAR171=null;
        XSPARQLRewriter.qname_return v = null;

        XSPARQLRewriter.numericliteral_return nl = null;

        XSPARQLRewriter.stringliteral_return sl = null;

        XSPARQLRewriter.enclosedExpr_return enclosedExpr172 = null;


        CommonTree VAR171_tree=null;
        RewriteRuleNodeStream stream_VAR=new RewriteRuleNodeStream(adaptor,"token VAR");
        RewriteRuleSubtreeStream stream_qname=new RewriteRuleSubtreeStream(adaptor,"rule qname");
        RewriteRuleSubtreeStream stream_stringliteral=new RewriteRuleSubtreeStream(adaptor,"rule stringliteral");
        RewriteRuleSubtreeStream stream_numericliteral=new RewriteRuleSubtreeStream(adaptor,"rule numericliteral");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1301:3: (v= qname -> QSTRING[$v.text] | VAR -> ^( T_FUNCTION_CALL NCNAME[\"_xsparql:_sql_binding_term\"] ^( T_PARAMS VAR ) ) | nl= numericliteral -> QSTRING[$nl.text] | sl= stringliteral -> QSTRING[\"'\"+$sl.text+\"'\"] | enclosedExpr )
            int alt53=5;
            switch ( input.LA(1) ) {
            case NCNAME:
            case PNAME_NS:
            case PNAME_LN:
            case A:
            case FROM:
            case ITEM:
            case COMMENT:
            case ROW:
                {
                alt53=1;
                }
                break;
            case TO:
                {
                switch ( input.LA(2) ) {
                case DOWN:
                    {
                    alt53=5;
                    }
                    break;
                case EOF:
                case UP:
                case RPAR:
                case LESSTHAN:
                case GREATERTHAN:
                case GREATERTHANEQUALS:
                case LESSTHANEQUALS:
                case HAFENEQUALS:
                case EQUALS:
                case AND:
                case OR:
                    {
                    alt53=1;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 53, 2, input);

                    throw nvae;
                }

                }
                break;
            case VAR:
                {
                alt53=2;
                }
                break;
            case INTEGER:
            case DECIMAL:
                {
                alt53=3;
                }
                break;
            case QSTRING:
                {
                alt53=4;
                }
                break;
            case LCURLY:
            case STAR:
            case LESSTHAN:
            case GREATERTHAN:
            case PLUS:
            case MINUS:
            case UNIONSYMBOL:
            case LESSTHANLESSTHAN:
            case GREATERTHANEQUALS:
            case LESSTHANEQUALS:
            case HAFENEQUALS:
            case EQUALS:
            case IS:
            case EQ:
            case NE:
            case LT:
            case GE:
            case LE:
            case GT:
            case IF:
            case AND:
            case OR:
            case DIV:
            case IDIV:
            case MOD:
            case UNION:
            case INTERSECT:
            case EXCEPT:
            case GREATERTHANGREATERTHAN:
            case T_FLWOR:
            case T_INSTANCEOF:
            case T_CASTAS:
            case T_CASTABLEAS:
            case T_TREATAS:
            case EVERY:
            case TYPESWITCH:
            case VALIDATE:
            case SOME:
            case XPATH:
                {
                alt53=5;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 53, 0, input);

                throw nvae;
            }

            switch (alt53) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1301:5: v= qname
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_qname_in_sqlAttrSpec4513);
                    v=qname();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_qname.add(v.getTree());


                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 1301:13: -> QSTRING[$v.text]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, (v!=null?(input.getTokenStream().toString(
                          input.getTreeAdaptor().getTokenStartIndex(v.start),
                          input.getTreeAdaptor().getTokenStopIndex(v.start))):null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1302:5: VAR
                    {
                    _last = (CommonTree)input.LT(1);
                    VAR171=(CommonTree)match(input,VAR,FOLLOW_VAR_in_sqlAttrSpec4524); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_VAR.add(VAR171);



                    // AST REWRITE
                    // elements: VAR
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 1302:9: -> ^( T_FUNCTION_CALL NCNAME[\"_xsparql:_sql_binding_term\"] ^( T_PARAMS VAR ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1302:12: ^( T_FUNCTION_CALL NCNAME[\"_xsparql:_sql_binding_term\"] ^( T_PARAMS VAR ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(NCNAME, "_xsparql:_sql_binding_term"));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1304:15: ^( T_PARAMS VAR )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_2);

                        adaptor.addChild(root_2, stream_VAR.nextNode());

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1306:5: nl= numericliteral
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_numericliteral_in_sqlAttrSpec4589);
                    nl=numericliteral();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_numericliteral.add(nl.getTree());


                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 1306:23: -> QSTRING[$nl.text]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, (nl!=null?(input.getTokenStream().toString(
                          input.getTreeAdaptor().getTokenStartIndex(nl.start),
                          input.getTreeAdaptor().getTokenStopIndex(nl.start))):null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1307:5: sl= stringliteral
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_stringliteral_in_sqlAttrSpec4602);
                    sl=stringliteral();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_stringliteral.add(sl.getTree());


                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 1307:22: -> QSTRING[\"'\"+$sl.text+\"'\"]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, "'"+(sl!=null?(input.getTokenStream().toString(
                          input.getTreeAdaptor().getTokenStartIndex(sl.start),
                          input.getTreeAdaptor().getTokenStopIndex(sl.start))):null)+"'"));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 5 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1308:5: enclosedExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_enclosedExpr_in_sqlAttrSpec4613);
                    enclosedExpr172=enclosedExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, enclosedExpr172.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "sqlAttrSpec"

    public static class generalComp_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "generalComp"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1311:1: generalComp : ( EQUALS | LESSTHAN | GREATERTHAN | LESSTHANEQUALS | GREATERTHANEQUALS | HAFENEQUALS );
    public final XSPARQLRewriter.generalComp_return generalComp() throws RecognitionException {
        XSPARQLRewriter.generalComp_return retval = new XSPARQLRewriter.generalComp_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree set173=null;

        CommonTree set173_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1312:3: ( EQUALS | LESSTHAN | GREATERTHAN | LESSTHANEQUALS | GREATERTHANEQUALS | HAFENEQUALS )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            set173=(CommonTree)input.LT(1);
            if ( (input.LA(1)>=LESSTHAN && input.LA(1)<=GREATERTHAN)||(input.LA(1)>=GREATERTHANEQUALS && input.LA(1)<=EQUALS) ) {
                input.consume();

                if ( state.backtracking==0 ) {
                set173_tree = (CommonTree)adaptor.dupNode(set173);

                adaptor.addChild(root_0, set173_tree);
                }
                state.errorRecovery=false;state.failed=false;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }

            if ( state.backtracking==0 ) {
            } 

            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "generalComp"

    protected static class sparqlForClause_scope {
        String joinVars;
        boolean containsVars;
        String evaluationFunction;
        String iterationFunction;
        String endpointURI;
    }
    protected Stack sparqlForClause_stack = new Stack();

    public static class sparqlForClause_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "sparqlForClause"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1323:1: sparqlForClause : ^(fo= T_SPARQL_FOR ( distinct )? (var+= varOrFunction )+ ) ( datasetClause )* (e= endpointClause )? sWhereClause ( solutionmodifier )? -> { $VariableScope::scopedDataset }? COMMENT[$fo.token, \"XSPARQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[sparqlFunctionScopedInner] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) ) QSTRING[scopedDataset.peek().getId()] QSTRING[$sparqlForClause::joinVars.replaceAll(\",$\", \"\")] VAR[scopedDataset.peek().getVar()] ) ) ) ^( T_FOR VAR[auxResult] ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[sparqlResultsFunctionNode] ^( T_PARAMS VAR[auxResults] ) ) ) ) ( ^( REWRITEVNODE[$fo.token, auxResult] $var) )+ -> {this.debugVersion}? COMMENT[$fo.token, \"XSPARQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:trace\"] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) ) QSTRING[\"XSPARQL FOR from \" + $fo.line + \":\" + $fo.pos] ) ) ) ) ) ^( T_FOR VAR[auxResult] ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL ^( T_PARAMS VAR[auxResults] ) ) ) ) ( ^( REWRITEVNODE[$fo.token, auxResult] $var) )+ -> COMMENT[$fo.token, \"XSPARQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) ) ) ) ) ^( T_FOR VAR[auxResult] ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL ^( T_PARAMS VAR[auxResults] ) ) ) ) ( ^( REWRITEVNODE[$fo.token, auxResult] $var) )+ ;
    public final XSPARQLRewriter.sparqlForClause_return sparqlForClause() throws RecognitionException {
        sparqlForClause_stack.push(new sparqlForClause_scope());
        XSPARQLRewriter.sparqlForClause_return retval = new XSPARQLRewriter.sparqlForClause_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree fo=null;
        List list_var=null;
        XSPARQLRewriter.endpointClause_return e = null;

        XSPARQLRewriter.distinct_return distinct174 = null;

        XSPARQLRewriter.datasetClause_return datasetClause175 = null;

        XSPARQLRewriter.sWhereClause_return sWhereClause176 = null;

        XSPARQLRewriter.solutionmodifier_return solutionmodifier177 = null;

        RuleReturnScope var = null;
        CommonTree fo_tree=null;
        RewriteRuleNodeStream stream_T_SPARQL_FOR=new RewriteRuleNodeStream(adaptor,"token T_SPARQL_FOR");
        RewriteRuleSubtreeStream stream_endpointClause=new RewriteRuleSubtreeStream(adaptor,"rule endpointClause");
        RewriteRuleSubtreeStream stream_datasetClause=new RewriteRuleSubtreeStream(adaptor,"rule datasetClause");
        RewriteRuleSubtreeStream stream_varOrFunction=new RewriteRuleSubtreeStream(adaptor,"rule varOrFunction");
        RewriteRuleSubtreeStream stream_sWhereClause=new RewriteRuleSubtreeStream(adaptor,"rule sWhereClause");
        RewriteRuleSubtreeStream stream_solutionmodifier=new RewriteRuleSubtreeStream(adaptor,"rule solutionmodifier");
        RewriteRuleSubtreeStream stream_distinct=new RewriteRuleSubtreeStream(adaptor,"rule distinct");

          String auxResults = getNewAuxResultsVariable();
          String auxResult = getNewAuxResultVariable();
          String auxResultPos = auxResult + "_pos";
          
          CommonTree sparqlFunctionTree = (CommonTree) adaptor.nil();
          CommonTree sparqlResultsFunctionTree = (CommonTree) adaptor.nil();
          CommonTree sparqlResultsIdTree = (CommonTree) adaptor.nil();
          
          ((VariableScope_scope)VariableScope_stack.peek()).sparqlClause = true; 
          ((sparqlForClause_scope)sparqlForClause_stack.peek()).joinVars = "";
          ((sparqlForClause_scope)sparqlForClause_stack.peek()).containsVars = false;

          ((sparqlForClause_scope)sparqlForClause_stack.peek()).iterationFunction = iterationFunction;
          ((sparqlForClause_scope)sparqlForClause_stack.peek()).evaluationFunction = evaluationFunction;
          logger.info("sparqlForClause");



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1366:3: ( ^(fo= T_SPARQL_FOR ( distinct )? (var+= varOrFunction )+ ) ( datasetClause )* (e= endpointClause )? sWhereClause ( solutionmodifier )? -> { $VariableScope::scopedDataset }? COMMENT[$fo.token, \"XSPARQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[sparqlFunctionScopedInner] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) ) QSTRING[scopedDataset.peek().getId()] QSTRING[$sparqlForClause::joinVars.replaceAll(\",$\", \"\")] VAR[scopedDataset.peek().getVar()] ) ) ) ^( T_FOR VAR[auxResult] ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[sparqlResultsFunctionNode] ^( T_PARAMS VAR[auxResults] ) ) ) ) ( ^( REWRITEVNODE[$fo.token, auxResult] $var) )+ -> {this.debugVersion}? COMMENT[$fo.token, \"XSPARQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:trace\"] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) ) QSTRING[\"XSPARQL FOR from \" + $fo.line + \":\" + $fo.pos] ) ) ) ) ) ^( T_FOR VAR[auxResult] ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL ^( T_PARAMS VAR[auxResults] ) ) ) ) ( ^( REWRITEVNODE[$fo.token, auxResult] $var) )+ -> COMMENT[$fo.token, \"XSPARQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) ) ) ) ) ^( T_FOR VAR[auxResult] ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL ^( T_PARAMS VAR[auxResults] ) ) ) ) ( ^( REWRITEVNODE[$fo.token, auxResult] $var) )+ )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1366:5: ^(fo= T_SPARQL_FOR ( distinct )? (var+= varOrFunction )+ ) ( datasetClause )* (e= endpointClause )? sWhereClause ( solutionmodifier )?
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            fo=(CommonTree)match(input,T_SPARQL_FOR,FOLLOW_T_SPARQL_FOR_in_sparqlForClause4689); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_T_SPARQL_FOR.add(fo);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1366:23: ( distinct )?
            int alt54=2;
            switch ( input.LA(1) ) {
                case DISTINCT:
                    {
                    alt54=1;
                    }
                    break;
            }

            switch (alt54) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: distinct
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_distinct_in_sparqlForClause4691);
                    distinct174=distinct();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_distinct.add(distinct174.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1366:36: (var+= varOrFunction )+
            int cnt55=0;
            loop55:
            do {
                int alt55=2;
                switch ( input.LA(1) ) {
                case VAR:
                case LPAR:
                    {
                    alt55=1;
                    }
                    break;

                }

                switch (alt55) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: var+= varOrFunction
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_varOrFunction_in_sparqlForClause4696);
            	    var=varOrFunction();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_varOrFunction.add(var.getTree());
            	    if (list_var==null) list_var=new ArrayList();
            	    list_var.add(var.getTree());


            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    if ( cnt55 >= 1 ) break loop55;
            	    if (state.backtracking>0) {state.failed=true; return retval;}
                        EarlyExitException eee =
                            new EarlyExitException(55, input);
                        throw eee;
                }
                cnt55++;
            } while (true);

            if ( state.backtracking==0 ) {
               addVariablesToScope(list_var, Types.SPARQL); 
              //                                                      addGeneratedVariablesToScope(list_var); 
                                                                    addPositionVariableToScope(auxResultPos); 
            }

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1369:8: ( datasetClause )*
            loop56:
            do {
                int alt56=2;
                switch ( input.LA(1) ) {
                case FROM:
                    {
                    alt56=1;
                    }
                    break;

                }

                switch (alt56) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: datasetClause
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_datasetClause_in_sparqlForClause4708);
            	    datasetClause175=datasetClause();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_datasetClause.add(datasetClause175.getTree());

            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    break loop56;
                }
            } while (true);

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1369:24: (e= endpointClause )?
            int alt57=2;
            switch ( input.LA(1) ) {
                case ENDPOINT:
                    {
                    alt57=1;
                    }
                    break;
            }

            switch (alt57) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: e= endpointClause
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_endpointClause_in_sparqlForClause4713);
                    e=endpointClause();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_endpointClause.add(e.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_sWhereClause_in_sparqlForClause4716);
            sWhereClause176=sWhereClause();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_sWhereClause.add(sWhereClause176.getTree());
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1369:54: ( solutionmodifier )?
            int alt58=2;
            switch ( input.LA(1) ) {
                case LIMIT:
                case OFFSET:
                case ORDER:
                case T_GROUP_BY:
                case T_HAVING:
                    {
                    alt58=1;
                    }
                    break;
                case T_RETURN:
                    {
                    int LA58_2 = input.LA(2);

                    if ( (synpred93_XSPARQLRewriter()) ) {
                        alt58=1;
                    }
                    }
                    break;
                case T_CONSTRUCT:
                    {
                    int LA58_3 = input.LA(2);

                    if ( (synpred93_XSPARQLRewriter()) ) {
                        alt58=1;
                    }
                    }
                    break;
                case UP:
                    {
                    int LA58_4 = input.LA(2);

                    if ( (synpred93_XSPARQLRewriter()) ) {
                        alt58=1;
                    }
                    }
                    break;
                case EOF:
                    {
                    int LA58_5 = input.LA(2);

                    if ( (synpred93_XSPARQLRewriter()) ) {
                        alt58=1;
                    }
                    }
                    break;
            }

            switch (alt58) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: solutionmodifier
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_solutionmodifier_in_sparqlForClause4718);
                    solutionmodifier177=solutionmodifier();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_solutionmodifier.add(solutionmodifier177.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }



            // AST REWRITE
            // elements: datasetClause, sWhereClause, distinct, sWhereClause, var, sWhereClause, datasetClause, distinct, solutionmodifier, distinct, var, solutionmodifier, datasetClause, var, solutionmodifier
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: var
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
            RewriteRuleSubtreeStream stream_var=new RewriteRuleSubtreeStream(adaptor,"token var",list_var);
            root_0 = (CommonTree)adaptor.nil();
            // 1372:3: -> { $VariableScope::scopedDataset }? COMMENT[$fo.token, \"XSPARQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[sparqlFunctionScopedInner] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) ) QSTRING[scopedDataset.peek().getId()] QSTRING[$sparqlForClause::joinVars.replaceAll(\",$\", \"\")] VAR[scopedDataset.peek().getVar()] ) ) ) ^( T_FOR VAR[auxResult] ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[sparqlResultsFunctionNode] ^( T_PARAMS VAR[auxResults] ) ) ) ) ( ^( REWRITEVNODE[$fo.token, auxResult] $var) )+
            if ( ((VariableScope_scope)VariableScope_stack.peek()).scopedDataset ) {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(COMMENT, fo.token, "XSPARQL FOR from " + (fo!=null?fo.getLine():0) + ":" + (fo!=null?fo.getCharPositionInLine():0)));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1374:6: ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[sparqlFunctionScopedInner] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) ) QSTRING[scopedDataset.peek().getId()] QSTRING[$sparqlForClause::joinVars.replaceAll(\",$\", \"\")] VAR[scopedDataset.peek().getVar()] ) ) )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_LET, "T_LET"), root_1);

                adaptor.addChild(root_1, (CommonTree)adaptor.create(VAR, auxResults));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1375:13: ^( T_FUNCTION_CALL NCNAME[sparqlFunctionScopedInner] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) ) QSTRING[scopedDataset.peek().getId()] QSTRING[$sparqlForClause::joinVars.replaceAll(\",$\", \"\")] VAR[scopedDataset.peek().getVar()] ) )
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_2);

                adaptor.addChild(root_2, (CommonTree)adaptor.create(NCNAME, sparqlFunctionScopedInner));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1377:15: ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) ) QSTRING[scopedDataset.peek().getId()] QSTRING[$sparqlForClause::joinVars.replaceAll(\",$\", \"\")] VAR[scopedDataset.peek().getVar()] )
                {
                CommonTree root_3 = (CommonTree)adaptor.nil();
                root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_3);

                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1378:16: ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) )
                {
                CommonTree root_4 = (CommonTree)adaptor.nil();
                root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_4);

                adaptor.addChild(root_4, (CommonTree)adaptor.create(NCNAME, "fn:concat"));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1380:15: ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? )
                {
                CommonTree root_5 = (CommonTree)adaptor.nil();
                root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_5);

                adaptor.addChild(root_5, (CommonTree)adaptor.create(VAR, "$_sparql_prefixes"));
                adaptor.addChild(root_5, (CommonTree)adaptor.create(QSTRING, " SELECT "));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1384:18: ( distinct )?
                if ( stream_distinct.hasNext() ) {
                    adaptor.addChild(root_5, stream_distinct.nextTree());

                }
                stream_distinct.reset();
                adaptor.addChild(root_5, getVarList(list_var));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1386:18: ( datasetClause )*
                while ( stream_datasetClause.hasNext() ) {
                    adaptor.addChild(root_5, stream_datasetClause.nextTree());

                }
                stream_datasetClause.reset();
                adaptor.addChild(root_5, stream_sWhereClause.nextTree());
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1388:18: ( solutionmodifier )?
                if ( stream_solutionmodifier.hasNext() ) {
                    adaptor.addChild(root_5, stream_solutionmodifier.nextTree());

                }
                stream_solutionmodifier.reset();

                adaptor.addChild(root_4, root_5);
                }

                adaptor.addChild(root_3, root_4);
                }
                adaptor.addChild(root_3, (CommonTree)adaptor.create(QSTRING, scopedDataset.peek().getId()));
                adaptor.addChild(root_3, (CommonTree)adaptor.create(QSTRING, ((sparqlForClause_scope)sparqlForClause_stack.peek()).joinVars.replaceAll(",$", "")));
                adaptor.addChild(root_3, (CommonTree)adaptor.create(VAR, scopedDataset.peek().getVar()));

                adaptor.addChild(root_2, root_3);
                }

                adaptor.addChild(root_1, root_2);
                }

                adaptor.addChild(root_0, root_1);
                }
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1397:5: ^( T_FOR VAR[auxResult] ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[sparqlResultsFunctionNode] ^( T_PARAMS VAR[auxResults] ) ) ) )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FOR, "T_FOR"), root_1);

                adaptor.addChild(root_1, (CommonTree)adaptor.create(VAR, auxResult));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1399:7: ^( AT VAR[auxResultPos] )
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(AT, "AT"), root_2);

                adaptor.addChild(root_2, (CommonTree)adaptor.create(VAR, auxResultPos));

                adaptor.addChild(root_1, root_2);
                }
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1402:7: ^( IN ^( T_FUNCTION_CALL NCNAME[sparqlResultsFunctionNode] ^( T_PARAMS VAR[auxResults] ) ) )
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(IN, "IN"), root_2);

                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1403:9: ^( T_FUNCTION_CALL NCNAME[sparqlResultsFunctionNode] ^( T_PARAMS VAR[auxResults] ) )
                {
                CommonTree root_3 = (CommonTree)adaptor.nil();
                root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_3);

                adaptor.addChild(root_3, (CommonTree)adaptor.create(NCNAME, sparqlResultsFunctionNode));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1405:11: ^( T_PARAMS VAR[auxResults] )
                {
                CommonTree root_4 = (CommonTree)adaptor.nil();
                root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_4);

                adaptor.addChild(root_4, (CommonTree)adaptor.create(VAR, auxResults));

                adaptor.addChild(root_3, root_4);
                }

                adaptor.addChild(root_2, root_3);
                }

                adaptor.addChild(root_1, root_2);
                }

                adaptor.addChild(root_0, root_1);
                }
                if ( !(stream_var.hasNext()) ) {
                    throw new RewriteEarlyExitException();
                }
                while ( stream_var.hasNext() ) {
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1411:5: ^( REWRITEVNODE[$fo.token, auxResult] $var)
                    {
                    CommonTree root_1 = (CommonTree)adaptor.nil();
                    root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(REWRITEVNODE, fo.token, auxResult), root_1);

                    adaptor.addChild(root_1, stream_var.nextTree());

                    adaptor.addChild(root_0, root_1);
                    }

                }
                stream_var.reset();

            }
            else // 1414:3: -> {this.debugVersion}? COMMENT[$fo.token, \"XSPARQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:trace\"] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) ) QSTRING[\"XSPARQL FOR from \" + $fo.line + \":\" + $fo.pos] ) ) ) ) ) ^( T_FOR VAR[auxResult] ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL ^( T_PARAMS VAR[auxResults] ) ) ) ) ( ^( REWRITEVNODE[$fo.token, auxResult] $var) )+
            if (this.debugVersion) {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(COMMENT, fo.token, "XSPARQL FOR from " + (fo!=null?fo.getLine():0) + ":" + (fo!=null?fo.getCharPositionInLine():0)));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1416:6: ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:trace\"] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) ) QSTRING[\"XSPARQL FOR from \" + $fo.line + \":\" + $fo.pos] ) ) ) ) )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_LET, "T_LET"), root_1);

                adaptor.addChild(root_1, (CommonTree)adaptor.create(VAR, auxResults));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1417:8: ^( T_FUNCTION_CALL ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:trace\"] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) ) QSTRING[\"XSPARQL FOR from \" + $fo.line + \":\" + $fo.pos] ) ) ) )
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_2);

                adaptor.addChild(root_2,  sparqlFunctionTree = new CommonTree(new CommonToken(NCNAME, ((sparqlForClause_scope)sparqlForClause_stack.peek()).evaluationFunction)) );
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1419:10: ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:trace\"] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) ) QSTRING[\"XSPARQL FOR from \" + $fo.line + \":\" + $fo.pos] ) ) )
                {
                CommonTree root_3 = (CommonTree)adaptor.nil();
                root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_3);

                adaptor.addChild(root_3,  endpointURI(((sparqlForClause_scope)sparqlForClause_stack.peek()).endpointURI) );
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1420:12: ^( T_FUNCTION_CALL NCNAME[\"fn:trace\"] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) ) QSTRING[\"XSPARQL FOR from \" + $fo.line + \":\" + $fo.pos] ) )
                {
                CommonTree root_4 = (CommonTree)adaptor.nil();
                root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_4);

                adaptor.addChild(root_4, (CommonTree)adaptor.create(NCNAME, "fn:trace"));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1422:14: ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) ) QSTRING[\"XSPARQL FOR from \" + $fo.line + \":\" + $fo.pos] )
                {
                CommonTree root_5 = (CommonTree)adaptor.nil();
                root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_5);

                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1423:16: ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) )
                {
                CommonTree root_6 = (CommonTree)adaptor.nil();
                root_6 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_6);

                adaptor.addChild(root_6, (CommonTree)adaptor.create(NCNAME, "fn:concat"));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1425:18: ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? )
                {
                CommonTree root_7 = (CommonTree)adaptor.nil();
                root_7 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_7);

                adaptor.addChild(root_7, (CommonTree)adaptor.create(VAR, "$_sparql_prefixes"));
                adaptor.addChild(root_7, (CommonTree)adaptor.create(QSTRING, " SELECT "));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1429:20: ( distinct )?
                if ( stream_distinct.hasNext() ) {
                    adaptor.addChild(root_7, stream_distinct.nextTree());

                }
                stream_distinct.reset();
                adaptor.addChild(root_7, getVarList(list_var));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1430:20: ( datasetClause )*
                while ( stream_datasetClause.hasNext() ) {
                    adaptor.addChild(root_7, stream_datasetClause.nextTree());

                }
                stream_datasetClause.reset();
                adaptor.addChild(root_7, stream_sWhereClause.nextTree());
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1432:20: ( solutionmodifier )?
                if ( stream_solutionmodifier.hasNext() ) {
                    adaptor.addChild(root_7, stream_solutionmodifier.nextTree());

                }
                stream_solutionmodifier.reset();

                adaptor.addChild(root_6, root_7);
                }

                adaptor.addChild(root_5, root_6);
                }
                adaptor.addChild(root_5,  sparqlResultsIdTree = new CommonTree(new CommonToken(DELETEVNODE, "deleteNode")) );
                adaptor.addChild(root_5, (CommonTree)adaptor.create(QSTRING, "XSPARQL FOR from " + (fo!=null?fo.getLine():0) + ":" + (fo!=null?fo.getCharPositionInLine():0)));

                adaptor.addChild(root_4, root_5);
                }

                adaptor.addChild(root_3, root_4);
                }

                adaptor.addChild(root_2, root_3);
                }

                adaptor.addChild(root_1, root_2);
                }

                adaptor.addChild(root_0, root_1);
                }
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1442:6: ^( T_FOR VAR[auxResult] ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL ^( T_PARAMS VAR[auxResults] ) ) ) )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FOR, "T_FOR"), root_1);

                adaptor.addChild(root_1, (CommonTree)adaptor.create(VAR, auxResult));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1444:8: ^( AT VAR[auxResultPos] )
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(AT, "AT"), root_2);

                adaptor.addChild(root_2, (CommonTree)adaptor.create(VAR, auxResultPos));

                adaptor.addChild(root_1, root_2);
                }
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1447:8: ^( IN ^( T_FUNCTION_CALL ^( T_PARAMS VAR[auxResults] ) ) )
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(IN, "IN"), root_2);

                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1448:10: ^( T_FUNCTION_CALL ^( T_PARAMS VAR[auxResults] ) )
                {
                CommonTree root_3 = (CommonTree)adaptor.nil();
                root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_3);

                adaptor.addChild(root_3,  sparqlResultsFunctionTree = new CommonTree(new CommonToken(NCNAME, ((sparqlForClause_scope)sparqlForClause_stack.peek()).iterationFunction)) );
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1450:12: ^( T_PARAMS VAR[auxResults] )
                {
                CommonTree root_4 = (CommonTree)adaptor.nil();
                root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_4);

                adaptor.addChild(root_4, (CommonTree)adaptor.create(VAR, auxResults));

                adaptor.addChild(root_3, root_4);
                }

                adaptor.addChild(root_2, root_3);
                }

                adaptor.addChild(root_1, root_2);
                }

                adaptor.addChild(root_0, root_1);
                }
                if ( !(stream_var.hasNext()) ) {
                    throw new RewriteEarlyExitException();
                }
                while ( stream_var.hasNext() ) {
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1456:6: ^( REWRITEVNODE[$fo.token, auxResult] $var)
                    {
                    CommonTree root_1 = (CommonTree)adaptor.nil();
                    root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(REWRITEVNODE, fo.token, auxResult), root_1);

                    adaptor.addChild(root_1, stream_var.nextTree());

                    adaptor.addChild(root_0, root_1);
                    }

                }
                stream_var.reset();

            }
            else // 1458:3: -> COMMENT[$fo.token, \"XSPARQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) ) ) ) ) ^( T_FOR VAR[auxResult] ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL ^( T_PARAMS VAR[auxResults] ) ) ) ) ( ^( REWRITEVNODE[$fo.token, auxResult] $var) )+
            {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(COMMENT, fo.token, "XSPARQL FOR from " + (fo!=null?fo.getLine():0) + ":" + (fo!=null?fo.getCharPositionInLine():0)));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1459:6: ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) ) ) ) )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_LET, "T_LET"), root_1);

                adaptor.addChild(root_1, (CommonTree)adaptor.create(VAR, auxResults));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1460:8: ^( T_FUNCTION_CALL ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) ) ) )
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_2);

                adaptor.addChild(root_2,  sparqlFunctionTree = new CommonTree(new CommonToken(NCNAME, ((sparqlForClause_scope)sparqlForClause_stack.peek()).evaluationFunction)) );
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1462:10: ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) ) )
                {
                CommonTree root_3 = (CommonTree)adaptor.nil();
                root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_3);

                adaptor.addChild(root_3,  endpointURI(((sparqlForClause_scope)sparqlForClause_stack.peek()).endpointURI) );
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1463:12: ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? ) )
                {
                CommonTree root_4 = (CommonTree)adaptor.nil();
                root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_4);

                adaptor.addChild(root_4, (CommonTree)adaptor.create(NCNAME, "fn:concat"));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1465:14: ^( T_PARAMS VAR[\"\\$_sparql_prefixes\"] QSTRING[\" SELECT \"] ( distinct )? ( datasetClause )* sWhereClause ( solutionmodifier )? )
                {
                CommonTree root_5 = (CommonTree)adaptor.nil();
                root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_5);

                adaptor.addChild(root_5, (CommonTree)adaptor.create(VAR, "$_sparql_prefixes"));
                adaptor.addChild(root_5, (CommonTree)adaptor.create(QSTRING, " SELECT "));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1469:16: ( distinct )?
                if ( stream_distinct.hasNext() ) {
                    adaptor.addChild(root_5, stream_distinct.nextTree());

                }
                stream_distinct.reset();
                adaptor.addChild(root_5, getVarList(list_var));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1470:16: ( datasetClause )*
                while ( stream_datasetClause.hasNext() ) {
                    adaptor.addChild(root_5, stream_datasetClause.nextTree());

                }
                stream_datasetClause.reset();
                adaptor.addChild(root_5, stream_sWhereClause.nextTree());
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1472:16: ( solutionmodifier )?
                if ( stream_solutionmodifier.hasNext() ) {
                    adaptor.addChild(root_5, stream_solutionmodifier.nextTree());

                }
                stream_solutionmodifier.reset();

                adaptor.addChild(root_4, root_5);
                }

                adaptor.addChild(root_3, root_4);
                }
                adaptor.addChild(root_3,  sparqlResultsIdTree = new CommonTree(new CommonToken(DELETEVNODE, "deleteNode")) );

                adaptor.addChild(root_2, root_3);
                }

                adaptor.addChild(root_1, root_2);
                }

                adaptor.addChild(root_0, root_1);
                }
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1479:6: ^( T_FOR VAR[auxResult] ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL ^( T_PARAMS VAR[auxResults] ) ) ) )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FOR, "T_FOR"), root_1);

                adaptor.addChild(root_1, (CommonTree)adaptor.create(VAR, auxResult));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1481:8: ^( AT VAR[auxResultPos] )
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(AT, "AT"), root_2);

                adaptor.addChild(root_2, (CommonTree)adaptor.create(VAR, auxResultPos));

                adaptor.addChild(root_1, root_2);
                }
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1484:8: ^( IN ^( T_FUNCTION_CALL ^( T_PARAMS VAR[auxResults] ) ) )
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(IN, "IN"), root_2);

                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1485:10: ^( T_FUNCTION_CALL ^( T_PARAMS VAR[auxResults] ) )
                {
                CommonTree root_3 = (CommonTree)adaptor.nil();
                root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_3);

                adaptor.addChild(root_3,  sparqlResultsFunctionTree = new CommonTree(new CommonToken(NCNAME, ((sparqlForClause_scope)sparqlForClause_stack.peek()).iterationFunction)) );
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1487:12: ^( T_PARAMS VAR[auxResults] )
                {
                CommonTree root_4 = (CommonTree)adaptor.nil();
                root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_4);

                adaptor.addChild(root_4, (CommonTree)adaptor.create(VAR, auxResults));

                adaptor.addChild(root_3, root_4);
                }

                adaptor.addChild(root_2, root_3);
                }

                adaptor.addChild(root_1, root_2);
                }

                adaptor.addChild(root_0, root_1);
                }
                if ( !(stream_var.hasNext()) ) {
                    throw new RewriteEarlyExitException();
                }
                while ( stream_var.hasNext() ) {
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1493:6: ^( REWRITEVNODE[$fo.token, auxResult] $var)
                    {
                    CommonTree root_1 = (CommonTree)adaptor.nil();
                    root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(REWRITEVNODE, fo.token, auxResult), root_1);

                    adaptor.addChild(root_1, stream_var.nextTree());

                    adaptor.addChild(root_0, root_1);
                    }

                }
                stream_var.reset();

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
            if ( state.backtracking==0 ) {

                logger.info("Creating new variable scope: sparqlForClause-1");

                if(((VariableScope_scope)VariableScope_stack.peek()).scopedDataset) {
                  changeTreeToScopedDataset();
                } 

                ScopedDataset sd = new ScopedDataset (((VariableScope_scope)VariableScope_stack.peek()).scopedDataset, 
                                                      ((VariableScope_scope)VariableScope_stack.peek()).scopedDataset?scopedDataset.peek().getId():UUID.randomUUID().toString(), 
                                                      sparqlFunctionTree, 
                                                      sparqlResultsFunctionTree, 
                                                      sparqlResultsIdTree, 
                                                      auxResultPos); 
                scopedDataset.add(sd); 

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
            sparqlForClause_stack.pop();
        }
        return retval;
    }
    // $ANTLR end "sparqlForClause"

    public static class endpointClause_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "endpointClause"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1496:1: endpointClause : ENDPOINT e= sourceSelector ;
    public final XSPARQLRewriter.endpointClause_return endpointClause() throws RecognitionException {
        XSPARQLRewriter.endpointClause_return retval = new XSPARQLRewriter.endpointClause_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree ENDPOINT178=null;
        XSPARQLRewriter.sourceSelector_return e = null;


        CommonTree ENDPOINT178_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1497:3: ( ENDPOINT e= sourceSelector )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1497:5: ENDPOINT e= sourceSelector
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            ENDPOINT178=(CommonTree)match(input,ENDPOINT,FOLLOW_ENDPOINT_in_endpointClause6368); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            ENDPOINT178_tree = (CommonTree)adaptor.dupNode(ENDPOINT178);

            adaptor.addChild(root_0, ENDPOINT178_tree);
            }
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_sourceSelector_in_endpointClause6372);
            e=sourceSelector();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, e.getTree());
            if ( state.backtracking==0 ) {
               ((sparqlForClause_scope)sparqlForClause_stack.peek()).iterationFunction = xsparqlAbbrev+":_sparqlResults";
                                              ((sparqlForClause_scope)sparqlForClause_stack.peek()).evaluationFunction = xsparqlAbbrev+":_sparql";
                                              ((sparqlForClause_scope)sparqlForClause_stack.peek()).endpointURI = (e!=null?(input.getTokenStream().toString(
                input.getTreeAdaptor().getTokenStartIndex(e.start),
                input.getTreeAdaptor().getTokenStopIndex(e.start))):null);
                
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "endpointClause"

    public static class varOrFunction_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "varOrFunction"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1503:1: varOrFunction : (v= VAR -> {isBoundEarlier($v.text)}? NOTHING[$v.text] -> | LPAR functionCall AS v= VAR RPAR -> LPAR functionCall AS RPAR );
    public final XSPARQLRewriter.varOrFunction_return varOrFunction() throws RecognitionException {
        XSPARQLRewriter.varOrFunction_return retval = new XSPARQLRewriter.varOrFunction_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree v=null;
        CommonTree LPAR179=null;
        CommonTree AS181=null;
        CommonTree RPAR182=null;
        XSPARQLRewriter.functionCall_return functionCall180 = null;


        CommonTree v_tree=null;
        CommonTree LPAR179_tree=null;
        CommonTree AS181_tree=null;
        CommonTree RPAR182_tree=null;
        RewriteRuleNodeStream stream_AS=new RewriteRuleNodeStream(adaptor,"token AS");
        RewriteRuleNodeStream stream_RPAR=new RewriteRuleNodeStream(adaptor,"token RPAR");
        RewriteRuleNodeStream stream_VAR=new RewriteRuleNodeStream(adaptor,"token VAR");
        RewriteRuleNodeStream stream_LPAR=new RewriteRuleNodeStream(adaptor,"token LPAR");
        RewriteRuleSubtreeStream stream_functionCall=new RewriteRuleSubtreeStream(adaptor,"rule functionCall");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1504:3: (v= VAR -> {isBoundEarlier($v.text)}? NOTHING[$v.text] -> | LPAR functionCall AS v= VAR RPAR -> LPAR functionCall AS RPAR )
            int alt59=2;
            switch ( input.LA(1) ) {
            case VAR:
                {
                alt59=1;
                }
                break;
            case LPAR:
                {
                alt59=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 59, 0, input);

                throw nvae;
            }

            switch (alt59) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1504:5: v= VAR
                    {
                    _last = (CommonTree)input.LT(1);
                    v=(CommonTree)match(input,VAR,FOLLOW_VAR_in_varOrFunction6389); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_VAR.add(v);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 1505:3: -> {isBoundEarlier($v.text)}? NOTHING[$v.text]
                    if (isBoundEarlier((v!=null?v.getText():null))) {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(NOTHING, (v!=null?v.getText():null)));

                    }
                    else // 1506:3: ->
                    {
                        adaptor.addChild(root_0,  unboundVar((v!=null?v.getText():null)) );

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1507:5: LPAR functionCall AS v= VAR RPAR
                    {
                    _last = (CommonTree)input.LT(1);
                    LPAR179=(CommonTree)match(input,LPAR,FOLLOW_LPAR_in_varOrFunction6412); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_LPAR.add(LPAR179);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_functionCall_in_varOrFunction6414);
                    functionCall180=functionCall();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_functionCall.add(functionCall180.getTree());
                    _last = (CommonTree)input.LT(1);
                    AS181=(CommonTree)match(input,AS,FOLLOW_AS_in_varOrFunction6416); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_AS.add(AS181);

                    _last = (CommonTree)input.LT(1);
                    v=(CommonTree)match(input,VAR,FOLLOW_VAR_in_varOrFunction6420); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_VAR.add(v);

                    _last = (CommonTree)input.LT(1);
                    RPAR182=(CommonTree)match(input,RPAR,FOLLOW_RPAR_in_varOrFunction6422); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_RPAR.add(RPAR182);



                    // AST REWRITE
                    // elements: functionCall, RPAR, AS, LPAR
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 1508:3: -> LPAR functionCall AS RPAR
                    {
                        adaptor.addChild(root_0, stream_LPAR.nextNode());
                        adaptor.addChild(root_0, stream_functionCall.nextTree());
                        adaptor.addChild(root_0, stream_AS.nextNode());
                        adaptor.addChild(root_0,  unboundVar((v!=null?v.getText():null)) );
                        adaptor.addChild(root_0, stream_RPAR.nextNode());

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "varOrFunction"

    public static class forClause_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "forClause"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1511:1: forClause : ( singleForClause )+ ;
    public final XSPARQLRewriter.forClause_return forClause() throws RecognitionException {
        XSPARQLRewriter.forClause_return retval = new XSPARQLRewriter.forClause_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.singleForClause_return singleForClause183 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1512:3: ( ( singleForClause )+ )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1512:5: ( singleForClause )+
            {
            root_0 = (CommonTree)adaptor.nil();

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1512:5: ( singleForClause )+
            int cnt60=0;
            loop60:
            do {
                int alt60=2;
                switch ( input.LA(1) ) {
                case T_FOR:
                    {
                    alt60=1;
                    }
                    break;

                }

                switch (alt60) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: singleForClause
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_singleForClause_in_forClause6448);
            	    singleForClause183=singleForClause();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) 
            	    adaptor.addChild(root_0, singleForClause183.getTree());

            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    if ( cnt60 >= 1 ) break loop60;
            	    if (state.backtracking>0) {state.failed=true; return retval;}
                        EarlyExitException eee =
                            new EarlyExitException(60, input);
                        throw eee;
                }
                cnt60++;
            } while (true);


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "forClause"

    public static class singleForClause_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "singleForClause"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1515:1: singleForClause : ^( T_FOR var= VAR ( ^( T_TYPE typeDeclaration ) )? optionalPosClause[$var.text] ) ;
    public final XSPARQLRewriter.singleForClause_return singleForClause() throws RecognitionException {
        XSPARQLRewriter.singleForClause_return retval = new XSPARQLRewriter.singleForClause_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree var=null;
        CommonTree T_FOR184=null;
        CommonTree T_TYPE185=null;
        XSPARQLRewriter.typeDeclaration_return typeDeclaration186 = null;

        XSPARQLRewriter.optionalPosClause_return optionalPosClause187 = null;


        CommonTree var_tree=null;
        CommonTree T_FOR184_tree=null;
        CommonTree T_TYPE185_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1516:3: ( ^( T_FOR var= VAR ( ^( T_TYPE typeDeclaration ) )? optionalPosClause[$var.text] ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1516:5: ^( T_FOR var= VAR ( ^( T_TYPE typeDeclaration ) )? optionalPosClause[$var.text] )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_FOR184=(CommonTree)match(input,T_FOR,FOLLOW_T_FOR_in_singleForClause6463); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_FOR184_tree = (CommonTree)adaptor.dupNode(T_FOR184);

            root_1 = (CommonTree)adaptor.becomeRoot(T_FOR184_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            var=(CommonTree)match(input,VAR,FOLLOW_VAR_in_singleForClause6467); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            var_tree = (CommonTree)adaptor.dupNode(var);

            adaptor.addChild(root_1, var_tree);
            }
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1516:21: ( ^( T_TYPE typeDeclaration ) )?
            int alt61=2;
            switch ( input.LA(1) ) {
                case T_TYPE:
                    {
                    alt61=1;
                    }
                    break;
            }

            switch (alt61) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1516:22: ^( T_TYPE typeDeclaration )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_2 = _last;
                    CommonTree _first_2 = null;
                    CommonTree root_2 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_TYPE185=(CommonTree)match(input,T_TYPE,FOLLOW_T_TYPE_in_singleForClause6471); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    T_TYPE185_tree = (CommonTree)adaptor.dupNode(T_TYPE185);

                    root_2 = (CommonTree)adaptor.becomeRoot(T_TYPE185_tree, root_2);
                    }


                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_typeDeclaration_in_singleForClause6473);
                    typeDeclaration186=typeDeclaration();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_2, typeDeclaration186.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_1, root_2);_last = _save_last_2;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_optionalPosClause_in_singleForClause6478);
            optionalPosClause187=optionalPosClause((var!=null?var.getText():null));

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, optionalPosClause187.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "singleForClause"

    public static class optionalPosClause_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "optionalPosClause"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1520:1: optionalPosClause[String var] : ( ^( IN exprSingle ) -> ^( AT VAR[$var + \"_pos\"] ) ^( IN exprSingle ) | ^(a= AT p= positionalVar ) ^( IN exprSingle ) -> ^( $a $p) ^( IN exprSingle ) );
    public final XSPARQLRewriter.optionalPosClause_return optionalPosClause(String var) throws RecognitionException {
        XSPARQLRewriter.optionalPosClause_return retval = new XSPARQLRewriter.optionalPosClause_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree a=null;
        CommonTree IN188=null;
        CommonTree IN190=null;
        XSPARQLRewriter.positionalVar_return p = null;

        XSPARQLRewriter.exprSingle_return exprSingle189 = null;

        XSPARQLRewriter.exprSingle_return exprSingle191 = null;


        CommonTree a_tree=null;
        CommonTree IN188_tree=null;
        CommonTree IN190_tree=null;
        RewriteRuleNodeStream stream_AT=new RewriteRuleNodeStream(adaptor,"token AT");
        RewriteRuleNodeStream stream_IN=new RewriteRuleNodeStream(adaptor,"token IN");
        RewriteRuleSubtreeStream stream_positionalVar=new RewriteRuleSubtreeStream(adaptor,"rule positionalVar");
        RewriteRuleSubtreeStream stream_exprSingle=new RewriteRuleSubtreeStream(adaptor,"rule exprSingle");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1521:3: ( ^( IN exprSingle ) -> ^( AT VAR[$var + \"_pos\"] ) ^( IN exprSingle ) | ^(a= AT p= positionalVar ) ^( IN exprSingle ) -> ^( $a $p) ^( IN exprSingle ) )
            int alt62=2;
            switch ( input.LA(1) ) {
            case IN:
                {
                alt62=1;
                }
                break;
            case AT:
                {
                alt62=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 62, 0, input);

                throw nvae;
            }

            switch (alt62) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1521:5: ^( IN exprSingle )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    IN188=(CommonTree)match(input,IN,FOLLOW_IN_in_optionalPosClause6497); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_IN.add(IN188);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_exprSingle_in_optionalPosClause6499);
                    exprSingle189=exprSingle();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_exprSingle.add(exprSingle189.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }

                    if ( state.backtracking==0 ) {
                      addPositionVariableToScope(var + "_pos");
                    }


                    // AST REWRITE
                    // elements: exprSingle, IN
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 1522:3: -> ^( AT VAR[$var + \"_pos\"] ) ^( IN exprSingle )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1522:6: ^( AT VAR[$var + \"_pos\"] )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(AT, "AT"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(VAR, var + "_pos"));

                        adaptor.addChild(root_0, root_1);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1522:31: ^( IN exprSingle )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot(stream_IN.nextNode(), root_1);

                        adaptor.addChild(root_1, stream_exprSingle.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1523:5: ^(a= AT p= positionalVar ) ^( IN exprSingle )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    a=(CommonTree)match(input,AT,FOLLOW_AT_in_optionalPosClause6528); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_AT.add(a);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_positionalVar_in_optionalPosClause6532);
                    p=positionalVar();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_positionalVar.add(p.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    IN190=(CommonTree)match(input,IN,FOLLOW_IN_in_optionalPosClause6536); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_IN.add(IN190);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_exprSingle_in_optionalPosClause6538);
                    exprSingle191=exprSingle();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_exprSingle.add(exprSingle191.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }

                    if ( state.backtracking==0 ) {
                      addPositionVariableToScope((p!=null?(input.getTokenStream().toString(
                        input.getTreeAdaptor().getTokenStartIndex(p.start),
                        input.getTreeAdaptor().getTokenStopIndex(p.start))):null));
                    }


                    // AST REWRITE
                    // elements: exprSingle, p, a, IN
                    // token labels: a
                    // rule labels: retval, p
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleNodeStream stream_a=new RewriteRuleNodeStream(adaptor,"token a",a);
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
                    RewriteRuleSubtreeStream stream_p=new RewriteRuleSubtreeStream(adaptor,"rule p",p!=null?p.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 1524:3: -> ^( $a $p) ^( IN exprSingle )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1524:6: ^( $a $p)
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot(stream_a.nextNode(), root_1);

                        adaptor.addChild(root_1, stream_p.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1524:15: ^( IN exprSingle )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot(stream_IN.nextNode(), root_1);

                        adaptor.addChild(root_1, stream_exprSingle.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "optionalPosClause"

    public static class positionalVar_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "positionalVar"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1527:1: positionalVar : VAR ;
    public final XSPARQLRewriter.positionalVar_return positionalVar() throws RecognitionException {
        XSPARQLRewriter.positionalVar_return retval = new XSPARQLRewriter.positionalVar_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree VAR192=null;

        CommonTree VAR192_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1528:3: ( VAR )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1528:5: VAR
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            VAR192=(CommonTree)match(input,VAR,FOLLOW_VAR_in_positionalVar6572); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            VAR192_tree = (CommonTree)adaptor.dupNode(VAR192);

            adaptor.addChild(root_0, VAR192_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "positionalVar"

    public static class letClause_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "letClause"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1531:1: letClause : ( singleLetClause )+ ;
    public final XSPARQLRewriter.letClause_return letClause() throws RecognitionException {
        XSPARQLRewriter.letClause_return retval = new XSPARQLRewriter.letClause_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.singleLetClause_return singleLetClause193 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1532:3: ( ( singleLetClause )+ )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1532:5: ( singleLetClause )+
            {
            root_0 = (CommonTree)adaptor.nil();

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1532:5: ( singleLetClause )+
            int cnt63=0;
            loop63:
            do {
                int alt63=2;
                switch ( input.LA(1) ) {
                case T_LET:
                    {
                    alt63=1;
                    }
                    break;

                }

                switch (alt63) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1532:6: singleLetClause
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_singleLetClause_in_letClause6586);
            	    singleLetClause193=singleLetClause();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) 
            	    adaptor.addChild(root_0, singleLetClause193.getTree());

            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    if ( cnt63 >= 1 ) break loop63;
            	    if (state.backtracking>0) {state.failed=true; return retval;}
                        EarlyExitException eee =
                            new EarlyExitException(63, input);
                        throw eee;
                }
                cnt63++;
            } while (true);


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "letClause"

    public static class singleLetClause_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "singleLetClause"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1535:1: singleLetClause : ^( T_LET ^(var= VAR ( typeDeclaration )? ) exprSingle ) -> { $exprSingle.type.equals(Types.RDF_GRAPH) }? ^( T_LET ^( $var ( typeDeclaration )? ) ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS exprSingle ) ) ) ^( T_RETURN ^( T_FLWOR ^( T_LET VAR[\"\\$_\" + Helper.removeLeading($var.text,\"\\$\")+\"_graph\"] ^( T_FUNCTION_CALL NCNAME[storeGraphFunction] ^( T_PARAMS QSTRING[getRDFNamespaceDecls()] $var) ) ) ) ) -> ^( T_LET ^( $var ( typeDeclaration )? ) exprSingle ) ;
    public final XSPARQLRewriter.singleLetClause_return singleLetClause() throws RecognitionException {
        XSPARQLRewriter.singleLetClause_return retval = new XSPARQLRewriter.singleLetClause_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree var=null;
        CommonTree T_LET194=null;
        XSPARQLRewriter.typeDeclaration_return typeDeclaration195 = null;

        XSPARQLRewriter.exprSingle_return exprSingle196 = null;


        CommonTree var_tree=null;
        CommonTree T_LET194_tree=null;
        RewriteRuleNodeStream stream_T_LET=new RewriteRuleNodeStream(adaptor,"token T_LET");
        RewriteRuleNodeStream stream_VAR=new RewriteRuleNodeStream(adaptor,"token VAR");
        RewriteRuleSubtreeStream stream_exprSingle=new RewriteRuleSubtreeStream(adaptor,"rule exprSingle");
        RewriteRuleSubtreeStream stream_typeDeclaration=new RewriteRuleSubtreeStream(adaptor,"rule typeDeclaration");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1536:3: ( ^( T_LET ^(var= VAR ( typeDeclaration )? ) exprSingle ) -> { $exprSingle.type.equals(Types.RDF_GRAPH) }? ^( T_LET ^( $var ( typeDeclaration )? ) ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS exprSingle ) ) ) ^( T_RETURN ^( T_FLWOR ^( T_LET VAR[\"\\$_\" + Helper.removeLeading($var.text,\"\\$\")+\"_graph\"] ^( T_FUNCTION_CALL NCNAME[storeGraphFunction] ^( T_PARAMS QSTRING[getRDFNamespaceDecls()] $var) ) ) ) ) -> ^( T_LET ^( $var ( typeDeclaration )? ) exprSingle ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1536:5: ^( T_LET ^(var= VAR ( typeDeclaration )? ) exprSingle )
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_LET194=(CommonTree)match(input,T_LET,FOLLOW_T_LET_in_singleLetClause6602); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_T_LET.add(T_LET194);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_2 = _last;
            CommonTree _first_2 = null;
            CommonTree root_2 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            var=(CommonTree)match(input,VAR,FOLLOW_VAR_in_singleLetClause6614); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_VAR.add(var);



            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); if (state.failed) return retval;
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1537:17: ( typeDeclaration )?
                int alt64=2;
                switch ( input.LA(1) ) {
                    case NCNAME:
                    case PNAME_NS:
                    case PNAME_LN:
                    case A:
                    case FROM:
                    case ATTRIBUTE:
                    case ELEMENT:
                    case TO:
                    case EMPTYSEQUENCE:
                    case ITEM:
                    case NODE:
                    case DOCUMENTNODE:
                    case TEXT:
                    case COMMENT:
                    case PROCESSINGINSTRUCTION:
                    case SCHEMAATTRIBUTE:
                    case SCHEMAELEMENT:
                    case ROW:
                        {
                        alt64=1;
                        }
                        break;
                }

                switch (alt64) {
                    case 1 :
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: typeDeclaration
                        {
                        _last = (CommonTree)input.LT(1);
                        pushFollow(FOLLOW_typeDeclaration_in_singleLetClause6616);
                        typeDeclaration195=typeDeclaration();

                        state._fsp--;
                        if (state.failed) return retval;
                        if ( state.backtracking==0 ) stream_typeDeclaration.add(typeDeclaration195.getTree());

                        if ( state.backtracking==0 ) {
                        }
                        }
                        break;

                }


                match(input, Token.UP, null); if (state.failed) return retval;
            }adaptor.addChild(root_1, root_2);_last = _save_last_2;
            }

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_exprSingle_in_singleLetClause6626);
            exprSingle196=exprSingle();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_exprSingle.add(exprSingle196.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }

            if ( state.backtracking==0 ) {
               addVariableToScope((var!=null?var.getText():null)); 
                      if ( (exprSingle196!=null?exprSingle196.type:null).equals(Types.RDF_GRAPH) ) {
                        addVariableToScope("$_" + Helper.removeLeading((var!=null?var.getText():null),"$")+"_graph");
                      } 
                      if(this.warnIfNestedConstruct) {
                        logger.severe("The evaluation will probably NOT work because you are using a nested construct and want to evaluate that on a SPARQL endpoint which is not located on your host. That doesn't work! If you want to evaluate a nested constuct, then the XQuery engine and the SPARQL engine have to be running on the same host.");
                      }
                    
            }


            // AST REWRITE
            // elements: VAR, T_LET, exprSingle, typeDeclaration, var, exprSingle, var, T_LET, T_LET, typeDeclaration, var
            // token labels: var
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleNodeStream stream_var=new RewriteRuleNodeStream(adaptor,"token var",var);
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 1547:3: -> { $exprSingle.type.equals(Types.RDF_GRAPH) }? ^( T_LET ^( $var ( typeDeclaration )? ) ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS exprSingle ) ) ) ^( T_RETURN ^( T_FLWOR ^( T_LET VAR[\"\\$_\" + Helper.removeLeading($var.text,\"\\$\")+\"_graph\"] ^( T_FUNCTION_CALL NCNAME[storeGraphFunction] ^( T_PARAMS QSTRING[getRDFNamespaceDecls()] $var) ) ) ) )
            if ( (exprSingle196!=null?exprSingle196.type:null).equals(Types.RDF_GRAPH) ) {
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1547:52: ^( T_LET ^( $var ( typeDeclaration )? ) ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS exprSingle ) ) )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot(stream_T_LET.nextNode(), root_1);

                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1547:60: ^( $var ( typeDeclaration )? )
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot(stream_var.nextNode(), root_2);

                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1547:67: ( typeDeclaration )?
                if ( stream_typeDeclaration.hasNext() ) {
                    adaptor.addChild(root_2, stream_typeDeclaration.nextTree());

                }
                stream_typeDeclaration.reset();

                adaptor.addChild(root_1, root_2);
                }
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1547:85: ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS exprSingle ) )
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_2);

                adaptor.addChild(root_2, (CommonTree)adaptor.create(NCNAME, serializeFunction));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1547:129: ^( T_PARAMS exprSingle )
                {
                CommonTree root_3 = (CommonTree)adaptor.nil();
                root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_3);

                adaptor.addChild(root_3, stream_exprSingle.nextTree());

                adaptor.addChild(root_2, root_3);
                }

                adaptor.addChild(root_1, root_2);
                }

                adaptor.addChild(root_0, root_1);
                }
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1547:154: ^( T_RETURN ^( T_FLWOR ^( T_LET VAR[\"\\$_\" + Helper.removeLeading($var.text,\"\\$\")+\"_graph\"] ^( T_FUNCTION_CALL NCNAME[storeGraphFunction] ^( T_PARAMS QSTRING[getRDFNamespaceDecls()] $var) ) ) ) )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_RETURN, "T_RETURN"), root_1);

                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1547:165: ^( T_FLWOR ^( T_LET VAR[\"\\$_\" + Helper.removeLeading($var.text,\"\\$\")+\"_graph\"] ^( T_FUNCTION_CALL NCNAME[storeGraphFunction] ^( T_PARAMS QSTRING[getRDFNamespaceDecls()] $var) ) ) )
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FLWOR, "T_FLWOR"), root_2);

                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1547:175: ^( T_LET VAR[\"\\$_\" + Helper.removeLeading($var.text,\"\\$\")+\"_graph\"] ^( T_FUNCTION_CALL NCNAME[storeGraphFunction] ^( T_PARAMS QSTRING[getRDFNamespaceDecls()] $var) ) )
                {
                CommonTree root_3 = (CommonTree)adaptor.nil();
                root_3 = (CommonTree)adaptor.becomeRoot(stream_T_LET.nextNode(), root_3);

                adaptor.addChild(root_3, (CommonTree)adaptor.create(VAR, "$_" + Helper.removeLeading((var!=null?var.getText():null),"$")+"_graph"));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1547:242: ^( T_FUNCTION_CALL NCNAME[storeGraphFunction] ^( T_PARAMS QSTRING[getRDFNamespaceDecls()] $var) )
                {
                CommonTree root_4 = (CommonTree)adaptor.nil();
                root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_4);

                adaptor.addChild(root_4, (CommonTree)adaptor.create(NCNAME, storeGraphFunction));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1547:287: ^( T_PARAMS QSTRING[getRDFNamespaceDecls()] $var)
                {
                CommonTree root_5 = (CommonTree)adaptor.nil();
                root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_5);

                adaptor.addChild(root_5, (CommonTree)adaptor.create(QSTRING, getRDFNamespaceDecls()));
                adaptor.addChild(root_5, stream_var.nextNode());

                adaptor.addChild(root_4, root_5);
                }

                adaptor.addChild(root_3, root_4);
                }

                adaptor.addChild(root_2, root_3);
                }

                adaptor.addChild(root_1, root_2);
                }

                adaptor.addChild(root_0, root_1);
                }

            }
            else // 1548:3: -> ^( T_LET ^( $var ( typeDeclaration )? ) exprSingle )
            {
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1548:6: ^( T_LET ^( $var ( typeDeclaration )? ) exprSingle )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot(stream_T_LET.nextNode(), root_1);

                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1548:14: ^( $var ( typeDeclaration )? )
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot(stream_var.nextNode(), root_2);

                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1548:21: ( typeDeclaration )?
                if ( stream_typeDeclaration.hasNext() ) {
                    adaptor.addChild(root_2, stream_typeDeclaration.nextTree());

                }
                stream_typeDeclaration.reset();

                adaptor.addChild(root_1, root_2);
                }
                adaptor.addChild(root_1, stream_exprSingle.nextTree());

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "singleLetClause"

    public static class whereClause_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "whereClause"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1551:1: whereClause : ^( WHERE exprSingle ) -> exprSingle ;
    public final XSPARQLRewriter.whereClause_return whereClause() throws RecognitionException {
        XSPARQLRewriter.whereClause_return retval = new XSPARQLRewriter.whereClause_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree WHERE197=null;
        XSPARQLRewriter.exprSingle_return exprSingle198 = null;


        CommonTree WHERE197_tree=null;
        RewriteRuleNodeStream stream_WHERE=new RewriteRuleNodeStream(adaptor,"token WHERE");
        RewriteRuleSubtreeStream stream_exprSingle=new RewriteRuleSubtreeStream(adaptor,"rule exprSingle");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1552:3: ( ^( WHERE exprSingle ) -> exprSingle )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1552:5: ^( WHERE exprSingle )
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            WHERE197=(CommonTree)match(input,WHERE,FOLLOW_WHERE_in_whereClause6730); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_WHERE.add(WHERE197);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_exprSingle_in_whereClause6732);
            exprSingle198=exprSingle();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_exprSingle.add(exprSingle198.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }



            // AST REWRITE
            // elements: exprSingle
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 1552:25: -> exprSingle
            {
                adaptor.addChild(root_0, stream_exprSingle.nextTree());

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "whereClause"

    public static class orderByClause_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "orderByClause"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1555:1: orderByClause : ( ^( T_ORDER_BY orderSpecList ) | ^( T_STABLE_ORDER_BY orderSpecList ) );
    public final XSPARQLRewriter.orderByClause_return orderByClause() throws RecognitionException {
        XSPARQLRewriter.orderByClause_return retval = new XSPARQLRewriter.orderByClause_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_ORDER_BY199=null;
        CommonTree T_STABLE_ORDER_BY201=null;
        XSPARQLRewriter.orderSpecList_return orderSpecList200 = null;

        XSPARQLRewriter.orderSpecList_return orderSpecList202 = null;


        CommonTree T_ORDER_BY199_tree=null;
        CommonTree T_STABLE_ORDER_BY201_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1556:3: ( ^( T_ORDER_BY orderSpecList ) | ^( T_STABLE_ORDER_BY orderSpecList ) )
            int alt65=2;
            switch ( input.LA(1) ) {
            case T_ORDER_BY:
                {
                alt65=1;
                }
                break;
            case T_STABLE_ORDER_BY:
                {
                alt65=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 65, 0, input);

                throw nvae;
            }

            switch (alt65) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1556:5: ^( T_ORDER_BY orderSpecList )
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_ORDER_BY199=(CommonTree)match(input,T_ORDER_BY,FOLLOW_T_ORDER_BY_in_orderByClause6751); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    T_ORDER_BY199_tree = (CommonTree)adaptor.dupNode(T_ORDER_BY199);

                    root_1 = (CommonTree)adaptor.becomeRoot(T_ORDER_BY199_tree, root_1);
                    }


                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_orderSpecList_in_orderByClause6753);
                    orderSpecList200=orderSpecList();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, orderSpecList200.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1557:5: ^( T_STABLE_ORDER_BY orderSpecList )
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_STABLE_ORDER_BY201=(CommonTree)match(input,T_STABLE_ORDER_BY,FOLLOW_T_STABLE_ORDER_BY_in_orderByClause6761); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    T_STABLE_ORDER_BY201_tree = (CommonTree)adaptor.dupNode(T_STABLE_ORDER_BY201);

                    root_1 = (CommonTree)adaptor.becomeRoot(T_STABLE_ORDER_BY201_tree, root_1);
                    }


                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_orderSpecList_in_orderByClause6763);
                    orderSpecList202=orderSpecList();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, orderSpecList202.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "orderByClause"

    public static class orderSpecList_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "orderSpecList"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1560:1: orderSpecList : ( orderSpec )+ ;
    public final XSPARQLRewriter.orderSpecList_return orderSpecList() throws RecognitionException {
        XSPARQLRewriter.orderSpecList_return retval = new XSPARQLRewriter.orderSpecList_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.orderSpec_return orderSpec203 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1561:3: ( ( orderSpec )+ )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1561:5: ( orderSpec )+
            {
            root_0 = (CommonTree)adaptor.nil();

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1561:5: ( orderSpec )+
            int cnt66=0;
            loop66:
            do {
                int alt66=2;
                switch ( input.LA(1) ) {
                case LCURLY:
                case STAR:
                case LESSTHAN:
                case GREATERTHAN:
                case PLUS:
                case MINUS:
                case UNIONSYMBOL:
                case LESSTHANLESSTHAN:
                case GREATERTHANEQUALS:
                case LESSTHANEQUALS:
                case HAFENEQUALS:
                case EQUALS:
                case IS:
                case EQ:
                case NE:
                case LT:
                case GE:
                case LE:
                case GT:
                case IF:
                case AND:
                case OR:
                case TO:
                case DIV:
                case IDIV:
                case MOD:
                case UNION:
                case INTERSECT:
                case EXCEPT:
                case GREATERTHANGREATERTHAN:
                case T_FLWOR:
                case T_INSTANCEOF:
                case T_CASTAS:
                case T_CASTABLEAS:
                case T_TREATAS:
                case EVERY:
                case TYPESWITCH:
                case VALIDATE:
                case SOME:
                case XPATH:
                    {
                    alt66=1;
                    }
                    break;

                }

                switch (alt66) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: orderSpec
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_orderSpec_in_orderSpecList6777);
            	    orderSpec203=orderSpec();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) 
            	    adaptor.addChild(root_0, orderSpec203.getTree());

            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    if ( cnt66 >= 1 ) break loop66;
            	    if (state.backtracking>0) {state.failed=true; return retval;}
                        EarlyExitException eee =
                            new EarlyExitException(66, input);
                        throw eee;
                }
                cnt66++;
            } while (true);


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "orderSpecList"

    public static class orderSpec_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "orderSpec"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1564:1: orderSpec : exprSingle orderModifier ;
    public final XSPARQLRewriter.orderSpec_return orderSpec() throws RecognitionException {
        XSPARQLRewriter.orderSpec_return retval = new XSPARQLRewriter.orderSpec_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.exprSingle_return exprSingle204 = null;

        XSPARQLRewriter.orderModifier_return orderModifier205 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1565:3: ( exprSingle orderModifier )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1565:6: exprSingle orderModifier
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_exprSingle_in_orderSpec6792);
            exprSingle204=exprSingle();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, exprSingle204.getTree());
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_orderModifier_in_orderSpec6794);
            orderModifier205=orderModifier();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, orderModifier205.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "orderSpec"

    public static class orderModifier_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "orderModifier"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1568:1: orderModifier : ( ASCENDING | DESCENDING )? ( EMPTY ( GREATEST | LEAST ) )? ( COLLATION uriliteral )? ;
    public final XSPARQLRewriter.orderModifier_return orderModifier() throws RecognitionException {
        XSPARQLRewriter.orderModifier_return retval = new XSPARQLRewriter.orderModifier_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree set206=null;
        CommonTree EMPTY207=null;
        CommonTree set208=null;
        CommonTree COLLATION209=null;
        XSPARQLRewriter.uriliteral_return uriliteral210 = null;


        CommonTree set206_tree=null;
        CommonTree EMPTY207_tree=null;
        CommonTree set208_tree=null;
        CommonTree COLLATION209_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1569:3: ( ( ASCENDING | DESCENDING )? ( EMPTY ( GREATEST | LEAST ) )? ( COLLATION uriliteral )? )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1569:5: ( ASCENDING | DESCENDING )? ( EMPTY ( GREATEST | LEAST ) )? ( COLLATION uriliteral )?
            {
            root_0 = (CommonTree)adaptor.nil();

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1569:5: ( ASCENDING | DESCENDING )?
            int alt67=2;
            switch ( input.LA(1) ) {
                case DESCENDING:
                case ASCENDING:
                    {
                    alt67=1;
                    }
                    break;
            }

            switch (alt67) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:
                    {
                    _last = (CommonTree)input.LT(1);
                    set206=(CommonTree)input.LT(1);
                    if ( (input.LA(1)>=DESCENDING && input.LA(1)<=ASCENDING) ) {
                        input.consume();

                        if ( state.backtracking==0 ) {
                        set206_tree = (CommonTree)adaptor.dupNode(set206);

                        adaptor.addChild(root_0, set206_tree);
                        }
                        state.errorRecovery=false;state.failed=false;
                    }
                    else {
                        if (state.backtracking>0) {state.failed=true; return retval;}
                        MismatchedSetException mse = new MismatchedSetException(null,input);
                        throw mse;
                    }


                    }
                    break;

            }

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1569:31: ( EMPTY ( GREATEST | LEAST ) )?
            int alt68=2;
            switch ( input.LA(1) ) {
                case EMPTY:
                    {
                    alt68=1;
                    }
                    break;
            }

            switch (alt68) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1569:32: EMPTY ( GREATEST | LEAST )
                    {
                    _last = (CommonTree)input.LT(1);
                    EMPTY207=(CommonTree)match(input,EMPTY,FOLLOW_EMPTY_in_orderModifier6817); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    EMPTY207_tree = (CommonTree)adaptor.dupNode(EMPTY207);

                    adaptor.addChild(root_0, EMPTY207_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    set208=(CommonTree)input.LT(1);
                    if ( (input.LA(1)>=GREATEST && input.LA(1)<=LEAST) ) {
                        input.consume();

                        if ( state.backtracking==0 ) {
                        set208_tree = (CommonTree)adaptor.dupNode(set208);

                        adaptor.addChild(root_0, set208_tree);
                        }
                        state.errorRecovery=false;state.failed=false;
                    }
                    else {
                        if (state.backtracking>0) {state.failed=true; return retval;}
                        MismatchedSetException mse = new MismatchedSetException(null,input);
                        throw mse;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1569:59: ( COLLATION uriliteral )?
            int alt69=2;
            switch ( input.LA(1) ) {
                case COLLATION:
                    {
                    alt69=1;
                    }
                    break;
            }

            switch (alt69) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1569:60: COLLATION uriliteral
                    {
                    _last = (CommonTree)input.LT(1);
                    COLLATION209=(CommonTree)match(input,COLLATION,FOLLOW_COLLATION_in_orderModifier6830); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    COLLATION209_tree = (CommonTree)adaptor.dupNode(COLLATION209);

                    adaptor.addChild(root_0, COLLATION209_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_uriliteral_in_orderModifier6832);
                    uriliteral210=uriliteral();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, uriliteral210.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "orderModifier"

    public static class quantifiedExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "quantifiedExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1572:1: quantifiedExpr : ^( ( SOME | EVERY ) ( ^( T_VAR VAR ( ^( T_TYPE typeDeclaration ) )? ^( IN exprSingle ) ) )+ ^( SATISFIES exprSingle ) ) ;
    public final XSPARQLRewriter.quantifiedExpr_return quantifiedExpr() throws RecognitionException {
        XSPARQLRewriter.quantifiedExpr_return retval = new XSPARQLRewriter.quantifiedExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree set211=null;
        CommonTree T_VAR212=null;
        CommonTree VAR213=null;
        CommonTree T_TYPE214=null;
        CommonTree IN216=null;
        CommonTree SATISFIES218=null;
        XSPARQLRewriter.typeDeclaration_return typeDeclaration215 = null;

        XSPARQLRewriter.exprSingle_return exprSingle217 = null;

        XSPARQLRewriter.exprSingle_return exprSingle219 = null;


        CommonTree set211_tree=null;
        CommonTree T_VAR212_tree=null;
        CommonTree VAR213_tree=null;
        CommonTree T_TYPE214_tree=null;
        CommonTree IN216_tree=null;
        CommonTree SATISFIES218_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1573:3: ( ^( ( SOME | EVERY ) ( ^( T_VAR VAR ( ^( T_TYPE typeDeclaration ) )? ^( IN exprSingle ) ) )+ ^( SATISFIES exprSingle ) ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1573:5: ^( ( SOME | EVERY ) ( ^( T_VAR VAR ( ^( T_TYPE typeDeclaration ) )? ^( IN exprSingle ) ) )+ ^( SATISFIES exprSingle ) )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();set211=(CommonTree)input.LT(1);
            if ( input.LA(1)==EVERY||input.LA(1)==SOME ) {
                input.consume();

                if ( state.backtracking==0 ) {
                set211_tree = (CommonTree)adaptor.dupNode(set211);

                root_1 = (CommonTree)adaptor.becomeRoot(set211_tree, root_1);
                }
                state.errorRecovery=false;state.failed=false;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }



            match(input, Token.DOWN, null); if (state.failed) return retval;
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1573:20: ( ^( T_VAR VAR ( ^( T_TYPE typeDeclaration ) )? ^( IN exprSingle ) ) )+
            int cnt71=0;
            loop71:
            do {
                int alt71=2;
                switch ( input.LA(1) ) {
                case T_VAR:
                    {
                    alt71=1;
                    }
                    break;

                }

                switch (alt71) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1573:21: ^( T_VAR VAR ( ^( T_TYPE typeDeclaration ) )? ^( IN exprSingle ) )
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    {
            	    CommonTree _save_last_2 = _last;
            	    CommonTree _first_2 = null;
            	    CommonTree root_2 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            	    T_VAR212=(CommonTree)match(input,T_VAR,FOLLOW_T_VAR_in_quantifiedExpr6856); if (state.failed) return retval;
            	    if ( state.backtracking==0 ) {
            	    T_VAR212_tree = (CommonTree)adaptor.dupNode(T_VAR212);

            	    root_2 = (CommonTree)adaptor.becomeRoot(T_VAR212_tree, root_2);
            	    }


            	    match(input, Token.DOWN, null); if (state.failed) return retval;
            	    _last = (CommonTree)input.LT(1);
            	    VAR213=(CommonTree)match(input,VAR,FOLLOW_VAR_in_quantifiedExpr6858); if (state.failed) return retval;
            	    if ( state.backtracking==0 ) {
            	    VAR213_tree = (CommonTree)adaptor.dupNode(VAR213);

            	    adaptor.addChild(root_2, VAR213_tree);
            	    }
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1573:33: ( ^( T_TYPE typeDeclaration ) )?
            	    int alt70=2;
            	    switch ( input.LA(1) ) {
            	        case T_TYPE:
            	            {
            	            alt70=1;
            	            }
            	            break;
            	    }

            	    switch (alt70) {
            	        case 1 :
            	            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1573:34: ^( T_TYPE typeDeclaration )
            	            {
            	            _last = (CommonTree)input.LT(1);
            	            {
            	            CommonTree _save_last_3 = _last;
            	            CommonTree _first_3 = null;
            	            CommonTree root_3 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            	            T_TYPE214=(CommonTree)match(input,T_TYPE,FOLLOW_T_TYPE_in_quantifiedExpr6862); if (state.failed) return retval;
            	            if ( state.backtracking==0 ) {
            	            T_TYPE214_tree = (CommonTree)adaptor.dupNode(T_TYPE214);

            	            root_3 = (CommonTree)adaptor.becomeRoot(T_TYPE214_tree, root_3);
            	            }


            	            match(input, Token.DOWN, null); if (state.failed) return retval;
            	            _last = (CommonTree)input.LT(1);
            	            pushFollow(FOLLOW_typeDeclaration_in_quantifiedExpr6864);
            	            typeDeclaration215=typeDeclaration();

            	            state._fsp--;
            	            if (state.failed) return retval;
            	            if ( state.backtracking==0 ) 
            	            adaptor.addChild(root_3, typeDeclaration215.getTree());

            	            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_2, root_3);_last = _save_last_3;
            	            }


            	            if ( state.backtracking==0 ) {
            	            }
            	            }
            	            break;

            	    }

            	    _last = (CommonTree)input.LT(1);
            	    {
            	    CommonTree _save_last_3 = _last;
            	    CommonTree _first_3 = null;
            	    CommonTree root_3 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            	    IN216=(CommonTree)match(input,IN,FOLLOW_IN_in_quantifiedExpr6870); if (state.failed) return retval;
            	    if ( state.backtracking==0 ) {
            	    IN216_tree = (CommonTree)adaptor.dupNode(IN216);

            	    root_3 = (CommonTree)adaptor.becomeRoot(IN216_tree, root_3);
            	    }


            	    match(input, Token.DOWN, null); if (state.failed) return retval;
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_exprSingle_in_quantifiedExpr6872);
            	    exprSingle217=exprSingle();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) 
            	    adaptor.addChild(root_3, exprSingle217.getTree());

            	    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_2, root_3);_last = _save_last_3;
            	    }


            	    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_1, root_2);_last = _save_last_2;
            	    }


            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    if ( cnt71 >= 1 ) break loop71;
            	    if (state.backtracking>0) {state.failed=true; return retval;}
                        EarlyExitException eee =
                            new EarlyExitException(71, input);
                        throw eee;
                }
                cnt71++;
            } while (true);

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_2 = _last;
            CommonTree _first_2 = null;
            CommonTree root_2 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            SATISFIES218=(CommonTree)match(input,SATISFIES,FOLLOW_SATISFIES_in_quantifiedExpr6879); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            SATISFIES218_tree = (CommonTree)adaptor.dupNode(SATISFIES218);

            root_2 = (CommonTree)adaptor.becomeRoot(SATISFIES218_tree, root_2);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_exprSingle_in_quantifiedExpr6881);
            exprSingle219=exprSingle();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_2, exprSingle219.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_1, root_2);_last = _save_last_2;
            }


            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "quantifiedExpr"

    public static class typeSwitchExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "typeSwitchExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1576:1: typeSwitchExpr : ^( TYPESWITCH expr ( caseClause )+ ( VAR )? exprSingle ) ;
    public final XSPARQLRewriter.typeSwitchExpr_return typeSwitchExpr() throws RecognitionException {
        XSPARQLRewriter.typeSwitchExpr_return retval = new XSPARQLRewriter.typeSwitchExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree TYPESWITCH220=null;
        CommonTree VAR223=null;
        XSPARQLRewriter.expr_return expr221 = null;

        XSPARQLRewriter.caseClause_return caseClause222 = null;

        XSPARQLRewriter.exprSingle_return exprSingle224 = null;


        CommonTree TYPESWITCH220_tree=null;
        CommonTree VAR223_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1577:3: ( ^( TYPESWITCH expr ( caseClause )+ ( VAR )? exprSingle ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1577:5: ^( TYPESWITCH expr ( caseClause )+ ( VAR )? exprSingle )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            TYPESWITCH220=(CommonTree)match(input,TYPESWITCH,FOLLOW_TYPESWITCH_in_typeSwitchExpr6897); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            TYPESWITCH220_tree = (CommonTree)adaptor.dupNode(TYPESWITCH220);

            root_1 = (CommonTree)adaptor.becomeRoot(TYPESWITCH220_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_expr_in_typeSwitchExpr6899);
            expr221=expr();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, expr221.getTree());
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1577:23: ( caseClause )+
            int cnt72=0;
            loop72:
            do {
                int alt72=2;
                switch ( input.LA(1) ) {
                case CASE:
                    {
                    alt72=1;
                    }
                    break;

                }

                switch (alt72) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: caseClause
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_caseClause_in_typeSwitchExpr6901);
            	    caseClause222=caseClause();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) 
            	    adaptor.addChild(root_1, caseClause222.getTree());

            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    if ( cnt72 >= 1 ) break loop72;
            	    if (state.backtracking>0) {state.failed=true; return retval;}
                        EarlyExitException eee =
                            new EarlyExitException(72, input);
                        throw eee;
                }
                cnt72++;
            } while (true);

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1577:35: ( VAR )?
            int alt73=2;
            switch ( input.LA(1) ) {
                case VAR:
                    {
                    alt73=1;
                    }
                    break;
            }

            switch (alt73) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: VAR
                    {
                    _last = (CommonTree)input.LT(1);
                    VAR223=(CommonTree)match(input,VAR,FOLLOW_VAR_in_typeSwitchExpr6904); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    VAR223_tree = (CommonTree)adaptor.dupNode(VAR223);

                    adaptor.addChild(root_1, VAR223_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_exprSingle_in_typeSwitchExpr6907);
            exprSingle224=exprSingle();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, exprSingle224.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "typeSwitchExpr"

    public static class caseClause_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "caseClause"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1580:1: caseClause : CASE ( VAR AS )? sequenceType RETURN exprSingle ;
    public final XSPARQLRewriter.caseClause_return caseClause() throws RecognitionException {
        XSPARQLRewriter.caseClause_return retval = new XSPARQLRewriter.caseClause_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree CASE225=null;
        CommonTree VAR226=null;
        CommonTree AS227=null;
        CommonTree RETURN229=null;
        XSPARQLRewriter.sequenceType_return sequenceType228 = null;

        XSPARQLRewriter.exprSingle_return exprSingle230 = null;


        CommonTree CASE225_tree=null;
        CommonTree VAR226_tree=null;
        CommonTree AS227_tree=null;
        CommonTree RETURN229_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1581:3: ( CASE ( VAR AS )? sequenceType RETURN exprSingle )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1581:5: CASE ( VAR AS )? sequenceType RETURN exprSingle
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            CASE225=(CommonTree)match(input,CASE,FOLLOW_CASE_in_caseClause6921); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            CASE225_tree = (CommonTree)adaptor.dupNode(CASE225);

            adaptor.addChild(root_0, CASE225_tree);
            }
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1581:10: ( VAR AS )?
            int alt74=2;
            switch ( input.LA(1) ) {
                case VAR:
                    {
                    alt74=1;
                    }
                    break;
            }

            switch (alt74) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1581:11: VAR AS
                    {
                    _last = (CommonTree)input.LT(1);
                    VAR226=(CommonTree)match(input,VAR,FOLLOW_VAR_in_caseClause6924); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    VAR226_tree = (CommonTree)adaptor.dupNode(VAR226);

                    adaptor.addChild(root_0, VAR226_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    AS227=(CommonTree)match(input,AS,FOLLOW_AS_in_caseClause6926); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    AS227_tree = (CommonTree)adaptor.dupNode(AS227);

                    adaptor.addChild(root_0, AS227_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_sequenceType_in_caseClause6930);
            sequenceType228=sequenceType();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, sequenceType228.getTree());
            _last = (CommonTree)input.LT(1);
            RETURN229=(CommonTree)match(input,RETURN,FOLLOW_RETURN_in_caseClause6932); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            RETURN229_tree = (CommonTree)adaptor.dupNode(RETURN229);

            adaptor.addChild(root_0, RETURN229_tree);
            }
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_exprSingle_in_caseClause6934);
            exprSingle230=exprSingle();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, exprSingle230.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "caseClause"

    public static class ifExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "ifExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1584:1: ifExpr : ^( IF exprSingle exprSingle exprSingle ) ;
    public final XSPARQLRewriter.ifExpr_return ifExpr() throws RecognitionException {
        XSPARQLRewriter.ifExpr_return retval = new XSPARQLRewriter.ifExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree IF231=null;
        XSPARQLRewriter.exprSingle_return exprSingle232 = null;

        XSPARQLRewriter.exprSingle_return exprSingle233 = null;

        XSPARQLRewriter.exprSingle_return exprSingle234 = null;


        CommonTree IF231_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1586:3: ( ^( IF exprSingle exprSingle exprSingle ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1586:5: ^( IF exprSingle exprSingle exprSingle )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            IF231=(CommonTree)match(input,IF,FOLLOW_IF_in_ifExpr6949); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            IF231_tree = (CommonTree)adaptor.dupNode(IF231);

            root_1 = (CommonTree)adaptor.becomeRoot(IF231_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_exprSingle_in_ifExpr6951);
            exprSingle232=exprSingle();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, exprSingle232.getTree());
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_exprSingle_in_ifExpr6953);
            exprSingle233=exprSingle();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, exprSingle233.getTree());
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_exprSingle_in_ifExpr6955);
            exprSingle234=exprSingle();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, exprSingle234.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "ifExpr"

    public static class orExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "orExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1589:1: orExpr : ( andExpr | ^( OR orExpr andExpr ) );
    public final XSPARQLRewriter.orExpr_return orExpr() throws RecognitionException {
        XSPARQLRewriter.orExpr_return retval = new XSPARQLRewriter.orExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree OR236=null;
        XSPARQLRewriter.andExpr_return andExpr235 = null;

        XSPARQLRewriter.orExpr_return orExpr237 = null;

        XSPARQLRewriter.andExpr_return andExpr238 = null;


        CommonTree OR236_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1590:3: ( andExpr | ^( OR orExpr andExpr ) )
            int alt75=2;
            switch ( input.LA(1) ) {
            case LCURLY:
            case STAR:
            case LESSTHAN:
            case GREATERTHAN:
            case PLUS:
            case MINUS:
            case UNIONSYMBOL:
            case LESSTHANLESSTHAN:
            case GREATERTHANEQUALS:
            case LESSTHANEQUALS:
            case HAFENEQUALS:
            case EQUALS:
            case IS:
            case EQ:
            case NE:
            case LT:
            case GE:
            case LE:
            case GT:
            case AND:
            case TO:
            case DIV:
            case IDIV:
            case MOD:
            case UNION:
            case INTERSECT:
            case EXCEPT:
            case GREATERTHANGREATERTHAN:
            case T_INSTANCEOF:
            case T_CASTAS:
            case T_CASTABLEAS:
            case T_TREATAS:
            case VALIDATE:
            case XPATH:
                {
                alt75=1;
                }
                break;
            case OR:
                {
                alt75=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 75, 0, input);

                throw nvae;
            }

            switch (alt75) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1590:5: andExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_andExpr_in_orExpr6969);
                    andExpr235=andExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, andExpr235.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1591:5: ^( OR orExpr andExpr )
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    OR236=(CommonTree)match(input,OR,FOLLOW_OR_in_orExpr6976); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    OR236_tree = (CommonTree)adaptor.dupNode(OR236);

                    root_1 = (CommonTree)adaptor.becomeRoot(OR236_tree, root_1);
                    }


                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_orExpr_in_orExpr6978);
                    orExpr237=orExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, orExpr237.getTree());
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_andExpr_in_orExpr6980);
                    andExpr238=andExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, andExpr238.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "orExpr"

    public static class andExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "andExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1594:1: andExpr : ( comparisonExpr | ^( AND andExpr comparisonExpr ) );
    public final XSPARQLRewriter.andExpr_return andExpr() throws RecognitionException {
        XSPARQLRewriter.andExpr_return retval = new XSPARQLRewriter.andExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree AND240=null;
        XSPARQLRewriter.comparisonExpr_return comparisonExpr239 = null;

        XSPARQLRewriter.andExpr_return andExpr241 = null;

        XSPARQLRewriter.comparisonExpr_return comparisonExpr242 = null;


        CommonTree AND240_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1595:3: ( comparisonExpr | ^( AND andExpr comparisonExpr ) )
            int alt76=2;
            switch ( input.LA(1) ) {
            case LCURLY:
            case STAR:
            case LESSTHAN:
            case GREATERTHAN:
            case PLUS:
            case MINUS:
            case UNIONSYMBOL:
            case LESSTHANLESSTHAN:
            case GREATERTHANEQUALS:
            case LESSTHANEQUALS:
            case HAFENEQUALS:
            case EQUALS:
            case IS:
            case EQ:
            case NE:
            case LT:
            case GE:
            case LE:
            case GT:
            case TO:
            case DIV:
            case IDIV:
            case MOD:
            case UNION:
            case INTERSECT:
            case EXCEPT:
            case GREATERTHANGREATERTHAN:
            case T_INSTANCEOF:
            case T_CASTAS:
            case T_CASTABLEAS:
            case T_TREATAS:
            case VALIDATE:
            case XPATH:
                {
                alt76=1;
                }
                break;
            case AND:
                {
                alt76=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 76, 0, input);

                throw nvae;
            }

            switch (alt76) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1595:5: comparisonExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_comparisonExpr_in_andExpr6994);
                    comparisonExpr239=comparisonExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, comparisonExpr239.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1596:5: ^( AND andExpr comparisonExpr )
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    AND240=(CommonTree)match(input,AND,FOLLOW_AND_in_andExpr7001); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    AND240_tree = (CommonTree)adaptor.dupNode(AND240);

                    root_1 = (CommonTree)adaptor.becomeRoot(AND240_tree, root_1);
                    }


                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_andExpr_in_andExpr7003);
                    andExpr241=andExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, andExpr241.getTree());
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_comparisonExpr_in_andExpr7005);
                    comparisonExpr242=comparisonExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, comparisonExpr242.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "andExpr"

    public static class comparisonExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "comparisonExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1599:1: comparisonExpr : ( rangeExpr | ^( ( EQ | NE | LT | LE | GT | GE | EQUALS | LESSTHAN | GREATERTHAN | LESSTHANEQUALS | GREATERTHANEQUALS | HAFENEQUALS | LESSTHANLESSTHAN | GREATERTHANGREATERTHAN | IS ) rangeExpr rangeExpr ) );
    public final XSPARQLRewriter.comparisonExpr_return comparisonExpr() throws RecognitionException {
        XSPARQLRewriter.comparisonExpr_return retval = new XSPARQLRewriter.comparisonExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree set244=null;
        XSPARQLRewriter.rangeExpr_return rangeExpr243 = null;

        XSPARQLRewriter.rangeExpr_return rangeExpr245 = null;

        XSPARQLRewriter.rangeExpr_return rangeExpr246 = null;


        CommonTree set244_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1600:3: ( rangeExpr | ^( ( EQ | NE | LT | LE | GT | GE | EQUALS | LESSTHAN | GREATERTHAN | LESSTHANEQUALS | GREATERTHANEQUALS | HAFENEQUALS | LESSTHANLESSTHAN | GREATERTHANGREATERTHAN | IS ) rangeExpr rangeExpr ) )
            int alt77=2;
            switch ( input.LA(1) ) {
            case LCURLY:
            case STAR:
            case PLUS:
            case MINUS:
            case UNIONSYMBOL:
            case TO:
            case DIV:
            case IDIV:
            case MOD:
            case UNION:
            case INTERSECT:
            case EXCEPT:
            case T_INSTANCEOF:
            case T_CASTAS:
            case T_CASTABLEAS:
            case T_TREATAS:
            case VALIDATE:
            case XPATH:
                {
                alt77=1;
                }
                break;
            case LESSTHAN:
            case GREATERTHAN:
            case LESSTHANLESSTHAN:
            case GREATERTHANEQUALS:
            case LESSTHANEQUALS:
            case HAFENEQUALS:
            case EQUALS:
            case IS:
            case EQ:
            case NE:
            case LT:
            case GE:
            case LE:
            case GT:
            case GREATERTHANGREATERTHAN:
                {
                alt77=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 77, 0, input);

                throw nvae;
            }

            switch (alt77) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1600:5: rangeExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_rangeExpr_in_comparisonExpr7019);
                    rangeExpr243=rangeExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, rangeExpr243.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1601:5: ^( ( EQ | NE | LT | LE | GT | GE | EQUALS | LESSTHAN | GREATERTHAN | LESSTHANEQUALS | GREATERTHANEQUALS | HAFENEQUALS | LESSTHANLESSTHAN | GREATERTHANGREATERTHAN | IS ) rangeExpr rangeExpr )
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();set244=(CommonTree)input.LT(1);
                    if ( (input.LA(1)>=LESSTHAN && input.LA(1)<=GREATERTHAN)||(input.LA(1)>=LESSTHANLESSTHAN && input.LA(1)<=EQUALS)||(input.LA(1)>=IS && input.LA(1)<=GT)||input.LA(1)==GREATERTHANGREATERTHAN ) {
                        input.consume();

                        if ( state.backtracking==0 ) {
                        set244_tree = (CommonTree)adaptor.dupNode(set244);

                        root_1 = (CommonTree)adaptor.becomeRoot(set244_tree, root_1);
                        }
                        state.errorRecovery=false;state.failed=false;
                    }
                    else {
                        if (state.backtracking>0) {state.failed=true; return retval;}
                        MismatchedSetException mse = new MismatchedSetException(null,input);
                        throw mse;
                    }



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_rangeExpr_in_comparisonExpr7191);
                    rangeExpr245=rangeExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, rangeExpr245.getTree());
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_rangeExpr_in_comparisonExpr7193);
                    rangeExpr246=rangeExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, rangeExpr246.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "comparisonExpr"

    public static class rangeExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "rangeExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1622:1: rangeExpr : ( additiveExpr | ^( TO rangeExpr additiveExpr ) );
    public final XSPARQLRewriter.rangeExpr_return rangeExpr() throws RecognitionException {
        XSPARQLRewriter.rangeExpr_return retval = new XSPARQLRewriter.rangeExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree TO248=null;
        XSPARQLRewriter.additiveExpr_return additiveExpr247 = null;

        XSPARQLRewriter.rangeExpr_return rangeExpr249 = null;

        XSPARQLRewriter.additiveExpr_return additiveExpr250 = null;


        CommonTree TO248_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1623:3: ( additiveExpr | ^( TO rangeExpr additiveExpr ) )
            int alt78=2;
            switch ( input.LA(1) ) {
            case LCURLY:
            case STAR:
            case PLUS:
            case MINUS:
            case UNIONSYMBOL:
            case DIV:
            case IDIV:
            case MOD:
            case UNION:
            case INTERSECT:
            case EXCEPT:
            case T_INSTANCEOF:
            case T_CASTAS:
            case T_CASTABLEAS:
            case T_TREATAS:
            case VALIDATE:
            case XPATH:
                {
                alt78=1;
                }
                break;
            case TO:
                {
                alt78=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 78, 0, input);

                throw nvae;
            }

            switch (alt78) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1623:5: additiveExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_additiveExpr_in_rangeExpr7212);
                    additiveExpr247=additiveExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, additiveExpr247.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1624:5: ^( TO rangeExpr additiveExpr )
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    TO248=(CommonTree)match(input,TO,FOLLOW_TO_in_rangeExpr7219); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    TO248_tree = (CommonTree)adaptor.dupNode(TO248);

                    root_1 = (CommonTree)adaptor.becomeRoot(TO248_tree, root_1);
                    }


                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_rangeExpr_in_rangeExpr7221);
                    rangeExpr249=rangeExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, rangeExpr249.getTree());
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_additiveExpr_in_rangeExpr7223);
                    additiveExpr250=additiveExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, additiveExpr250.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "rangeExpr"

    public static class additiveExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "additiveExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1627:1: additiveExpr : ( multiplicativeExpr | ^( ( PLUS | MINUS ) additiveExpr multiplicativeExpr ) );
    public final XSPARQLRewriter.additiveExpr_return additiveExpr() throws RecognitionException {
        XSPARQLRewriter.additiveExpr_return retval = new XSPARQLRewriter.additiveExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree set252=null;
        XSPARQLRewriter.multiplicativeExpr_return multiplicativeExpr251 = null;

        XSPARQLRewriter.additiveExpr_return additiveExpr253 = null;

        XSPARQLRewriter.multiplicativeExpr_return multiplicativeExpr254 = null;


        CommonTree set252_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1628:3: ( multiplicativeExpr | ^( ( PLUS | MINUS ) additiveExpr multiplicativeExpr ) )
            int alt79=2;
            switch ( input.LA(1) ) {
            case PLUS:
            case MINUS:
                {
                switch ( input.LA(2) ) {
                case DOWN:
                    {
                    alt79=2;
                    }
                    break;
                case LCURLY:
                case PLUS:
                case MINUS:
                case VALIDATE:
                case XPATH:
                    {
                    alt79=1;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 79, 1, input);

                    throw nvae;
                }

                }
                break;
            case LCURLY:
            case STAR:
            case UNIONSYMBOL:
            case DIV:
            case IDIV:
            case MOD:
            case UNION:
            case INTERSECT:
            case EXCEPT:
            case T_INSTANCEOF:
            case T_CASTAS:
            case T_CASTABLEAS:
            case T_TREATAS:
            case VALIDATE:
            case XPATH:
                {
                alt79=1;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 79, 0, input);

                throw nvae;
            }

            switch (alt79) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1628:5: multiplicativeExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_multiplicativeExpr_in_additiveExpr7237);
                    multiplicativeExpr251=multiplicativeExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, multiplicativeExpr251.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1629:5: ^( ( PLUS | MINUS ) additiveExpr multiplicativeExpr )
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();set252=(CommonTree)input.LT(1);
                    if ( (input.LA(1)>=PLUS && input.LA(1)<=MINUS) ) {
                        input.consume();

                        if ( state.backtracking==0 ) {
                        set252_tree = (CommonTree)adaptor.dupNode(set252);

                        root_1 = (CommonTree)adaptor.becomeRoot(set252_tree, root_1);
                        }
                        state.errorRecovery=false;state.failed=false;
                    }
                    else {
                        if (state.backtracking>0) {state.failed=true; return retval;}
                        MismatchedSetException mse = new MismatchedSetException(null,input);
                        throw mse;
                    }



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_additiveExpr_in_additiveExpr7250);
                    additiveExpr253=additiveExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, additiveExpr253.getTree());
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_multiplicativeExpr_in_additiveExpr7252);
                    multiplicativeExpr254=multiplicativeExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, multiplicativeExpr254.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "additiveExpr"

    public static class multiplicativeExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "multiplicativeExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1631:1: multiplicativeExpr : ( unionExpr | ^( ( STAR | DIV | IDIV | MOD ) multiplicativeExpr unionExpr ) );
    public final XSPARQLRewriter.multiplicativeExpr_return multiplicativeExpr() throws RecognitionException {
        XSPARQLRewriter.multiplicativeExpr_return retval = new XSPARQLRewriter.multiplicativeExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree set256=null;
        XSPARQLRewriter.unionExpr_return unionExpr255 = null;

        XSPARQLRewriter.multiplicativeExpr_return multiplicativeExpr257 = null;

        XSPARQLRewriter.unionExpr_return unionExpr258 = null;


        CommonTree set256_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1632:3: ( unionExpr | ^( ( STAR | DIV | IDIV | MOD ) multiplicativeExpr unionExpr ) )
            int alt80=2;
            switch ( input.LA(1) ) {
            case LCURLY:
            case PLUS:
            case MINUS:
            case UNIONSYMBOL:
            case UNION:
            case INTERSECT:
            case EXCEPT:
            case T_INSTANCEOF:
            case T_CASTAS:
            case T_CASTABLEAS:
            case T_TREATAS:
            case VALIDATE:
            case XPATH:
                {
                alt80=1;
                }
                break;
            case STAR:
            case DIV:
            case IDIV:
            case MOD:
                {
                alt80=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 80, 0, input);

                throw nvae;
            }

            switch (alt80) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1632:5: unionExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_unionExpr_in_multiplicativeExpr7263);
                    unionExpr255=unionExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, unionExpr255.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1633:5: ^( ( STAR | DIV | IDIV | MOD ) multiplicativeExpr unionExpr )
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();set256=(CommonTree)input.LT(1);
                    if ( input.LA(1)==STAR||(input.LA(1)>=DIV && input.LA(1)<=MOD) ) {
                        input.consume();

                        if ( state.backtracking==0 ) {
                        set256_tree = (CommonTree)adaptor.dupNode(set256);

                        root_1 = (CommonTree)adaptor.becomeRoot(set256_tree, root_1);
                        }
                        state.errorRecovery=false;state.failed=false;
                    }
                    else {
                        if (state.backtracking>0) {state.failed=true; return retval;}
                        MismatchedSetException mse = new MismatchedSetException(null,input);
                        throw mse;
                    }



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_multiplicativeExpr_in_multiplicativeExpr7286);
                    multiplicativeExpr257=multiplicativeExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, multiplicativeExpr257.getTree());
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_unionExpr_in_multiplicativeExpr7288);
                    unionExpr258=unionExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, unionExpr258.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "multiplicativeExpr"

    public static class unionExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "unionExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1636:1: unionExpr : ( intersectExceptExpr | ^( ( UNION | UNIONSYMBOL ) unionExpr intersectExceptExpr ) );
    public final XSPARQLRewriter.unionExpr_return unionExpr() throws RecognitionException {
        XSPARQLRewriter.unionExpr_return retval = new XSPARQLRewriter.unionExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree set260=null;
        XSPARQLRewriter.intersectExceptExpr_return intersectExceptExpr259 = null;

        XSPARQLRewriter.unionExpr_return unionExpr261 = null;

        XSPARQLRewriter.intersectExceptExpr_return intersectExceptExpr262 = null;


        CommonTree set260_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1637:3: ( intersectExceptExpr | ^( ( UNION | UNIONSYMBOL ) unionExpr intersectExceptExpr ) )
            int alt81=2;
            switch ( input.LA(1) ) {
            case LCURLY:
            case PLUS:
            case MINUS:
            case INTERSECT:
            case EXCEPT:
            case T_INSTANCEOF:
            case T_CASTAS:
            case T_CASTABLEAS:
            case T_TREATAS:
            case VALIDATE:
            case XPATH:
                {
                alt81=1;
                }
                break;
            case UNIONSYMBOL:
            case UNION:
                {
                alt81=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 81, 0, input);

                throw nvae;
            }

            switch (alt81) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1637:5: intersectExceptExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_intersectExceptExpr_in_unionExpr7302);
                    intersectExceptExpr259=intersectExceptExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, intersectExceptExpr259.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1638:5: ^( ( UNION | UNIONSYMBOL ) unionExpr intersectExceptExpr )
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();set260=(CommonTree)input.LT(1);
                    if ( input.LA(1)==UNIONSYMBOL||input.LA(1)==UNION ) {
                        input.consume();

                        if ( state.backtracking==0 ) {
                        set260_tree = (CommonTree)adaptor.dupNode(set260);

                        root_1 = (CommonTree)adaptor.becomeRoot(set260_tree, root_1);
                        }
                        state.errorRecovery=false;state.failed=false;
                    }
                    else {
                        if (state.backtracking>0) {state.failed=true; return retval;}
                        MismatchedSetException mse = new MismatchedSetException(null,input);
                        throw mse;
                    }



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_unionExpr_in_unionExpr7317);
                    unionExpr261=unionExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, unionExpr261.getTree());
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_intersectExceptExpr_in_unionExpr7319);
                    intersectExceptExpr262=intersectExceptExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, intersectExceptExpr262.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "unionExpr"

    public static class intersectExceptExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "intersectExceptExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1641:1: intersectExceptExpr : ( instanceOfExpr | ^( ( INTERSECT | EXCEPT ) intersectExceptExpr instanceOfExpr ) );
    public final XSPARQLRewriter.intersectExceptExpr_return intersectExceptExpr() throws RecognitionException {
        XSPARQLRewriter.intersectExceptExpr_return retval = new XSPARQLRewriter.intersectExceptExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree set264=null;
        XSPARQLRewriter.instanceOfExpr_return instanceOfExpr263 = null;

        XSPARQLRewriter.intersectExceptExpr_return intersectExceptExpr265 = null;

        XSPARQLRewriter.instanceOfExpr_return instanceOfExpr266 = null;


        CommonTree set264_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1642:3: ( instanceOfExpr | ^( ( INTERSECT | EXCEPT ) intersectExceptExpr instanceOfExpr ) )
            int alt82=2;
            switch ( input.LA(1) ) {
            case LCURLY:
            case PLUS:
            case MINUS:
            case T_INSTANCEOF:
            case T_CASTAS:
            case T_CASTABLEAS:
            case T_TREATAS:
            case VALIDATE:
            case XPATH:
                {
                alt82=1;
                }
                break;
            case INTERSECT:
            case EXCEPT:
                {
                alt82=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 82, 0, input);

                throw nvae;
            }

            switch (alt82) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1642:5: instanceOfExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_instanceOfExpr_in_intersectExceptExpr7333);
                    instanceOfExpr263=instanceOfExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, instanceOfExpr263.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1643:5: ^( ( INTERSECT | EXCEPT ) intersectExceptExpr instanceOfExpr )
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();set264=(CommonTree)input.LT(1);
                    if ( (input.LA(1)>=INTERSECT && input.LA(1)<=EXCEPT) ) {
                        input.consume();

                        if ( state.backtracking==0 ) {
                        set264_tree = (CommonTree)adaptor.dupNode(set264);

                        root_1 = (CommonTree)adaptor.becomeRoot(set264_tree, root_1);
                        }
                        state.errorRecovery=false;state.failed=false;
                    }
                    else {
                        if (state.backtracking>0) {state.failed=true; return retval;}
                        MismatchedSetException mse = new MismatchedSetException(null,input);
                        throw mse;
                    }



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_intersectExceptExpr_in_intersectExceptExpr7348);
                    intersectExceptExpr265=intersectExceptExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, intersectExceptExpr265.getTree());
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_instanceOfExpr_in_intersectExceptExpr7350);
                    instanceOfExpr266=instanceOfExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, instanceOfExpr266.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "intersectExceptExpr"

    public static class instanceOfExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "instanceOfExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1646:1: instanceOfExpr : ( treatExpr | ^( T_INSTANCEOF instanceOfExpr sequenceType ) );
    public final XSPARQLRewriter.instanceOfExpr_return instanceOfExpr() throws RecognitionException {
        XSPARQLRewriter.instanceOfExpr_return retval = new XSPARQLRewriter.instanceOfExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_INSTANCEOF268=null;
        XSPARQLRewriter.treatExpr_return treatExpr267 = null;

        XSPARQLRewriter.instanceOfExpr_return instanceOfExpr269 = null;

        XSPARQLRewriter.sequenceType_return sequenceType270 = null;


        CommonTree T_INSTANCEOF268_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1647:3: ( treatExpr | ^( T_INSTANCEOF instanceOfExpr sequenceType ) )
            int alt83=2;
            switch ( input.LA(1) ) {
            case LCURLY:
            case PLUS:
            case MINUS:
            case T_CASTAS:
            case T_CASTABLEAS:
            case T_TREATAS:
            case VALIDATE:
            case XPATH:
                {
                alt83=1;
                }
                break;
            case T_INSTANCEOF:
                {
                alt83=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 83, 0, input);

                throw nvae;
            }

            switch (alt83) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1647:5: treatExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_treatExpr_in_instanceOfExpr7364);
                    treatExpr267=treatExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, treatExpr267.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1648:5: ^( T_INSTANCEOF instanceOfExpr sequenceType )
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_INSTANCEOF268=(CommonTree)match(input,T_INSTANCEOF,FOLLOW_T_INSTANCEOF_in_instanceOfExpr7371); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    T_INSTANCEOF268_tree = (CommonTree)adaptor.dupNode(T_INSTANCEOF268);

                    root_1 = (CommonTree)adaptor.becomeRoot(T_INSTANCEOF268_tree, root_1);
                    }


                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_instanceOfExpr_in_instanceOfExpr7373);
                    instanceOfExpr269=instanceOfExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, instanceOfExpr269.getTree());
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_sequenceType_in_instanceOfExpr7375);
                    sequenceType270=sequenceType();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, sequenceType270.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "instanceOfExpr"

    public static class treatExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "treatExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1651:1: treatExpr : ( castableExpr | ^( T_TREATAS treatExpr sequenceType ) );
    public final XSPARQLRewriter.treatExpr_return treatExpr() throws RecognitionException {
        XSPARQLRewriter.treatExpr_return retval = new XSPARQLRewriter.treatExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_TREATAS272=null;
        XSPARQLRewriter.castableExpr_return castableExpr271 = null;

        XSPARQLRewriter.treatExpr_return treatExpr273 = null;

        XSPARQLRewriter.sequenceType_return sequenceType274 = null;


        CommonTree T_TREATAS272_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1652:3: ( castableExpr | ^( T_TREATAS treatExpr sequenceType ) )
            int alt84=2;
            switch ( input.LA(1) ) {
            case LCURLY:
            case PLUS:
            case MINUS:
            case T_CASTAS:
            case T_CASTABLEAS:
            case VALIDATE:
            case XPATH:
                {
                alt84=1;
                }
                break;
            case T_TREATAS:
                {
                alt84=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 84, 0, input);

                throw nvae;
            }

            switch (alt84) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1652:5: castableExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_castableExpr_in_treatExpr7389);
                    castableExpr271=castableExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, castableExpr271.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1653:5: ^( T_TREATAS treatExpr sequenceType )
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_TREATAS272=(CommonTree)match(input,T_TREATAS,FOLLOW_T_TREATAS_in_treatExpr7396); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    T_TREATAS272_tree = (CommonTree)adaptor.dupNode(T_TREATAS272);

                    root_1 = (CommonTree)adaptor.becomeRoot(T_TREATAS272_tree, root_1);
                    }


                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_treatExpr_in_treatExpr7398);
                    treatExpr273=treatExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, treatExpr273.getTree());
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_sequenceType_in_treatExpr7400);
                    sequenceType274=sequenceType();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, sequenceType274.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "treatExpr"

    public static class castableExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "castableExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1656:1: castableExpr : ( castExpr | ^( T_CASTABLEAS castableExpr singleType ) );
    public final XSPARQLRewriter.castableExpr_return castableExpr() throws RecognitionException {
        XSPARQLRewriter.castableExpr_return retval = new XSPARQLRewriter.castableExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_CASTABLEAS276=null;
        XSPARQLRewriter.castExpr_return castExpr275 = null;

        XSPARQLRewriter.castableExpr_return castableExpr277 = null;

        XSPARQLRewriter.singleType_return singleType278 = null;


        CommonTree T_CASTABLEAS276_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1657:3: ( castExpr | ^( T_CASTABLEAS castableExpr singleType ) )
            int alt85=2;
            switch ( input.LA(1) ) {
            case LCURLY:
            case PLUS:
            case MINUS:
            case T_CASTAS:
            case VALIDATE:
            case XPATH:
                {
                alt85=1;
                }
                break;
            case T_CASTABLEAS:
                {
                alt85=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 85, 0, input);

                throw nvae;
            }

            switch (alt85) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1657:5: castExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_castExpr_in_castableExpr7414);
                    castExpr275=castExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, castExpr275.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1658:5: ^( T_CASTABLEAS castableExpr singleType )
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_CASTABLEAS276=(CommonTree)match(input,T_CASTABLEAS,FOLLOW_T_CASTABLEAS_in_castableExpr7421); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    T_CASTABLEAS276_tree = (CommonTree)adaptor.dupNode(T_CASTABLEAS276);

                    root_1 = (CommonTree)adaptor.becomeRoot(T_CASTABLEAS276_tree, root_1);
                    }


                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_castableExpr_in_castableExpr7423);
                    castableExpr277=castableExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, castableExpr277.getTree());
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_singleType_in_castableExpr7425);
                    singleType278=singleType();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, singleType278.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "castableExpr"

    public static class castExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "castExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1661:1: castExpr : ( unaryExpr | ^( T_CASTAS castExpr singleType ) );
    public final XSPARQLRewriter.castExpr_return castExpr() throws RecognitionException {
        XSPARQLRewriter.castExpr_return retval = new XSPARQLRewriter.castExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_CASTAS280=null;
        XSPARQLRewriter.unaryExpr_return unaryExpr279 = null;

        XSPARQLRewriter.castExpr_return castExpr281 = null;

        XSPARQLRewriter.singleType_return singleType282 = null;


        CommonTree T_CASTAS280_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1662:3: ( unaryExpr | ^( T_CASTAS castExpr singleType ) )
            int alt86=2;
            switch ( input.LA(1) ) {
            case LCURLY:
            case PLUS:
            case MINUS:
            case VALIDATE:
            case XPATH:
                {
                alt86=1;
                }
                break;
            case T_CASTAS:
                {
                alt86=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 86, 0, input);

                throw nvae;
            }

            switch (alt86) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1662:5: unaryExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_unaryExpr_in_castExpr7439);
                    unaryExpr279=unaryExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, unaryExpr279.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1663:5: ^( T_CASTAS castExpr singleType )
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_CASTAS280=(CommonTree)match(input,T_CASTAS,FOLLOW_T_CASTAS_in_castExpr7446); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    T_CASTAS280_tree = (CommonTree)adaptor.dupNode(T_CASTAS280);

                    root_1 = (CommonTree)adaptor.becomeRoot(T_CASTAS280_tree, root_1);
                    }


                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_castExpr_in_castExpr7448);
                    castExpr281=castExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, castExpr281.getTree());
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_singleType_in_castExpr7450);
                    singleType282=singleType();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, singleType282.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "castExpr"

    public static class unaryExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "unaryExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1666:1: unaryExpr : ( MINUS | PLUS )* valueExpr ;
    public final XSPARQLRewriter.unaryExpr_return unaryExpr() throws RecognitionException {
        XSPARQLRewriter.unaryExpr_return retval = new XSPARQLRewriter.unaryExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree set283=null;
        XSPARQLRewriter.valueExpr_return valueExpr284 = null;


        CommonTree set283_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1667:3: ( ( MINUS | PLUS )* valueExpr )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1667:5: ( MINUS | PLUS )* valueExpr
            {
            root_0 = (CommonTree)adaptor.nil();

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1667:5: ( MINUS | PLUS )*
            loop87:
            do {
                int alt87=2;
                switch ( input.LA(1) ) {
                case PLUS:
                case MINUS:
                    {
                    alt87=1;
                    }
                    break;

                }

                switch (alt87) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    set283=(CommonTree)input.LT(1);
            	    if ( (input.LA(1)>=PLUS && input.LA(1)<=MINUS) ) {
            	        input.consume();

            	        if ( state.backtracking==0 ) {
            	        set283_tree = (CommonTree)adaptor.dupNode(set283);

            	        adaptor.addChild(root_0, set283_tree);
            	        }
            	        state.errorRecovery=false;state.failed=false;
            	    }
            	    else {
            	        if (state.backtracking>0) {state.failed=true; return retval;}
            	        MismatchedSetException mse = new MismatchedSetException(null,input);
            	        throw mse;
            	    }


            	    }
            	    break;

            	default :
            	    break loop87;
                }
            } while (true);

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_valueExpr_in_unaryExpr7473);
            valueExpr284=valueExpr();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, valueExpr284.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "unaryExpr"

    public static class valueExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "valueExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1670:1: valueExpr : ( pathExpr | validateExpr | extensionExpr );
    public final XSPARQLRewriter.valueExpr_return valueExpr() throws RecognitionException {
        XSPARQLRewriter.valueExpr_return retval = new XSPARQLRewriter.valueExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.pathExpr_return pathExpr285 = null;

        XSPARQLRewriter.validateExpr_return validateExpr286 = null;

        XSPARQLRewriter.extensionExpr_return extensionExpr287 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1671:3: ( pathExpr | validateExpr | extensionExpr )
            int alt88=3;
            switch ( input.LA(1) ) {
            case XPATH:
                {
                alt88=1;
                }
                break;
            case VALIDATE:
                {
                alt88=2;
                }
                break;
            case LCURLY:
                {
                alt88=3;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 88, 0, input);

                throw nvae;
            }

            switch (alt88) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1671:5: pathExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_pathExpr_in_valueExpr7486);
                    pathExpr285=pathExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, pathExpr285.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1672:5: validateExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_validateExpr_in_valueExpr7492);
                    validateExpr286=validateExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, validateExpr286.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1673:5: extensionExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_extensionExpr_in_valueExpr7498);
                    extensionExpr287=extensionExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, extensionExpr287.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "valueExpr"

    public static class validateExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "validateExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1676:1: validateExpr : VALIDATE ( validationMode )? expr ;
    public final XSPARQLRewriter.validateExpr_return validateExpr() throws RecognitionException {
        XSPARQLRewriter.validateExpr_return retval = new XSPARQLRewriter.validateExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree VALIDATE288=null;
        XSPARQLRewriter.validationMode_return validationMode289 = null;

        XSPARQLRewriter.expr_return expr290 = null;


        CommonTree VALIDATE288_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1677:3: ( VALIDATE ( validationMode )? expr )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1677:5: VALIDATE ( validationMode )? expr
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            VALIDATE288=(CommonTree)match(input,VALIDATE,FOLLOW_VALIDATE_in_validateExpr7511); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            VALIDATE288_tree = (CommonTree)adaptor.dupNode(VALIDATE288);

            adaptor.addChild(root_0, VALIDATE288_tree);
            }
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1677:14: ( validationMode )?
            int alt89=2;
            switch ( input.LA(1) ) {
                case LAX:
                case STRICT:
                    {
                    alt89=1;
                    }
                    break;
            }

            switch (alt89) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: validationMode
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_validationMode_in_validateExpr7513);
                    validationMode289=validationMode();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, validationMode289.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_expr_in_validateExpr7516);
            expr290=expr();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, expr290.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "validateExpr"

    public static class validationMode_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "validationMode"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1680:1: validationMode : ( LAX | STRICT );
    public final XSPARQLRewriter.validationMode_return validationMode() throws RecognitionException {
        XSPARQLRewriter.validationMode_return retval = new XSPARQLRewriter.validationMode_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree set291=null;

        CommonTree set291_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1681:3: ( LAX | STRICT )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            set291=(CommonTree)input.LT(1);
            if ( input.LA(1)==LAX||input.LA(1)==STRICT ) {
                input.consume();

                if ( state.backtracking==0 ) {
                set291_tree = (CommonTree)adaptor.dupNode(set291);

                adaptor.addChild(root_0, set291_tree);
                }
                state.errorRecovery=false;state.failed=false;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }

            if ( state.backtracking==0 ) {
            } 

            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "validationMode"

    public static class extensionExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "extensionExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1685:1: extensionExpr : LCURLY ( expr )? RCURLY ;
    public final XSPARQLRewriter.extensionExpr_return extensionExpr() throws RecognitionException {
        XSPARQLRewriter.extensionExpr_return retval = new XSPARQLRewriter.extensionExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree LCURLY292=null;
        CommonTree RCURLY294=null;
        XSPARQLRewriter.expr_return expr293 = null;


        CommonTree LCURLY292_tree=null;
        CommonTree RCURLY294_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1686:3: ( LCURLY ( expr )? RCURLY )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1687:5: LCURLY ( expr )? RCURLY
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            LCURLY292=(CommonTree)match(input,LCURLY,FOLLOW_LCURLY_in_extensionExpr7553); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            LCURLY292_tree = (CommonTree)adaptor.dupNode(LCURLY292);

            adaptor.addChild(root_0, LCURLY292_tree);
            }
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1687:12: ( expr )?
            int alt90=2;
            switch ( input.LA(1) ) {
                case LCURLY:
                case STAR:
                case LESSTHAN:
                case GREATERTHAN:
                case PLUS:
                case MINUS:
                case UNIONSYMBOL:
                case LESSTHANLESSTHAN:
                case GREATERTHANEQUALS:
                case LESSTHANEQUALS:
                case HAFENEQUALS:
                case EQUALS:
                case IS:
                case EQ:
                case NE:
                case LT:
                case GE:
                case LE:
                case GT:
                case IF:
                case AND:
                case OR:
                case TO:
                case DIV:
                case IDIV:
                case MOD:
                case UNION:
                case INTERSECT:
                case EXCEPT:
                case GREATERTHANGREATERTHAN:
                case T_FLWOR:
                case T_INSTANCEOF:
                case T_CASTAS:
                case T_CASTABLEAS:
                case T_TREATAS:
                case EVERY:
                case TYPESWITCH:
                case VALIDATE:
                case SOME:
                case XPATH:
                    {
                    alt90=1;
                    }
                    break;
            }

            switch (alt90) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: expr
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_expr_in_extensionExpr7555);
                    expr293=expr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, expr293.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            _last = (CommonTree)input.LT(1);
            RCURLY294=(CommonTree)match(input,RCURLY,FOLLOW_RCURLY_in_extensionExpr7558); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            RCURLY294_tree = (CommonTree)adaptor.dupNode(RCURLY294);

            adaptor.addChild(root_0, RCURLY294_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "extensionExpr"

    public static class pathExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "pathExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1690:1: pathExpr : ( ^( XPATH SLASH SLASH relativePathExpr ) | ^( XPATH SLASH relativePathExpr ) | ^( XPATH SLASH ) | ^( XPATH relativePathExpr ) );
    public final XSPARQLRewriter.pathExpr_return pathExpr() throws RecognitionException {
        XSPARQLRewriter.pathExpr_return retval = new XSPARQLRewriter.pathExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree XPATH295=null;
        CommonTree SLASH296=null;
        CommonTree SLASH297=null;
        CommonTree XPATH299=null;
        CommonTree SLASH300=null;
        CommonTree XPATH302=null;
        CommonTree SLASH303=null;
        CommonTree XPATH304=null;
        XSPARQLRewriter.relativePathExpr_return relativePathExpr298 = null;

        XSPARQLRewriter.relativePathExpr_return relativePathExpr301 = null;

        XSPARQLRewriter.relativePathExpr_return relativePathExpr305 = null;


        CommonTree XPATH295_tree=null;
        CommonTree SLASH296_tree=null;
        CommonTree SLASH297_tree=null;
        CommonTree XPATH299_tree=null;
        CommonTree SLASH300_tree=null;
        CommonTree XPATH302_tree=null;
        CommonTree SLASH303_tree=null;
        CommonTree XPATH304_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1691:3: ( ^( XPATH SLASH SLASH relativePathExpr ) | ^( XPATH SLASH relativePathExpr ) | ^( XPATH SLASH ) | ^( XPATH relativePathExpr ) )
            int alt91=4;
            switch ( input.LA(1) ) {
            case XPATH:
                {
                switch ( input.LA(2) ) {
                case DOWN:
                    {
                    switch ( input.LA(3) ) {
                    case SLASH:
                        {
                        switch ( input.LA(4) ) {
                        case SLASH:
                            {
                            alt91=1;
                            }
                            break;
                        case UP:
                            {
                            alt91=3;
                            }
                            break;
                        case VAR:
                        case INTEGER:
                        case NCNAME:
                        case QSTRING:
                        case DOT:
                        case AT:
                        case STAR:
                        case DOTDOT:
                        case PNAME_NS:
                        case PNAME_LN:
                        case A:
                        case FROM:
                        case CHILD:
                        case DESCENDANT:
                        case ATTRIBUTE:
                        case SELF:
                        case DESCENDANTORSELF:
                        case FOLLOWINGSIBLING:
                        case FOLLOWING:
                        case PARENT:
                        case ANCESTOR:
                        case PRECEDINGSIBLING:
                        case PRECEDING:
                        case ANCESTORORSELF:
                        case ORDERED:
                        case UNORDERED:
                        case ELEMENT:
                        case TO:
                        case ITEM:
                        case NODE:
                        case DOCUMENTNODE:
                        case TEXT:
                        case COMMENT:
                        case PROCESSINGINSTRUCTION:
                        case SCHEMAATTRIBUTE:
                        case SCHEMAELEMENT:
                        case DOCUMENT:
                        case ROW:
                        case T_XML_ELEMENT:
                        case T_PAR:
                        case T_FUNCTION_CALL:
                        case DECIMAL:
                            {
                            alt91=2;
                            }
                            break;
                        default:
                            if (state.backtracking>0) {state.failed=true; return retval;}
                            NoViableAltException nvae =
                                new NoViableAltException("", 91, 3, input);

                            throw nvae;
                        }

                        }
                        break;
                    case VAR:
                    case INTEGER:
                    case NCNAME:
                    case QSTRING:
                    case DOT:
                    case AT:
                    case STAR:
                    case DOTDOT:
                    case PNAME_NS:
                    case PNAME_LN:
                    case A:
                    case FROM:
                    case CHILD:
                    case DESCENDANT:
                    case ATTRIBUTE:
                    case SELF:
                    case DESCENDANTORSELF:
                    case FOLLOWINGSIBLING:
                    case FOLLOWING:
                    case PARENT:
                    case ANCESTOR:
                    case PRECEDINGSIBLING:
                    case PRECEDING:
                    case ANCESTORORSELF:
                    case ORDERED:
                    case UNORDERED:
                    case ELEMENT:
                    case TO:
                    case ITEM:
                    case NODE:
                    case DOCUMENTNODE:
                    case TEXT:
                    case COMMENT:
                    case PROCESSINGINSTRUCTION:
                    case SCHEMAATTRIBUTE:
                    case SCHEMAELEMENT:
                    case DOCUMENT:
                    case ROW:
                    case T_XML_ELEMENT:
                    case T_PAR:
                    case T_FUNCTION_CALL:
                    case DECIMAL:
                        {
                        alt91=4;
                        }
                        break;
                    default:
                        if (state.backtracking>0) {state.failed=true; return retval;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 91, 2, input);

                        throw nvae;
                    }

                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 91, 1, input);

                    throw nvae;
                }

                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 91, 0, input);

                throw nvae;
            }

            switch (alt91) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1691:5: ^( XPATH SLASH SLASH relativePathExpr )
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    XPATH295=(CommonTree)match(input,XPATH,FOLLOW_XPATH_in_pathExpr7572); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    XPATH295_tree = (CommonTree)adaptor.dupNode(XPATH295);

                    root_1 = (CommonTree)adaptor.becomeRoot(XPATH295_tree, root_1);
                    }


                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    SLASH296=(CommonTree)match(input,SLASH,FOLLOW_SLASH_in_pathExpr7574); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    SLASH296_tree = (CommonTree)adaptor.dupNode(SLASH296);

                    adaptor.addChild(root_1, SLASH296_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    SLASH297=(CommonTree)match(input,SLASH,FOLLOW_SLASH_in_pathExpr7576); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    SLASH297_tree = (CommonTree)adaptor.dupNode(SLASH297);

                    adaptor.addChild(root_1, SLASH297_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_relativePathExpr_in_pathExpr7578);
                    relativePathExpr298=relativePathExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, relativePathExpr298.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1692:5: ^( XPATH SLASH relativePathExpr )
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    XPATH299=(CommonTree)match(input,XPATH,FOLLOW_XPATH_in_pathExpr7586); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    XPATH299_tree = (CommonTree)adaptor.dupNode(XPATH299);

                    root_1 = (CommonTree)adaptor.becomeRoot(XPATH299_tree, root_1);
                    }


                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    SLASH300=(CommonTree)match(input,SLASH,FOLLOW_SLASH_in_pathExpr7588); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    SLASH300_tree = (CommonTree)adaptor.dupNode(SLASH300);

                    adaptor.addChild(root_1, SLASH300_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_relativePathExpr_in_pathExpr7590);
                    relativePathExpr301=relativePathExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, relativePathExpr301.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1693:5: ^( XPATH SLASH )
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    XPATH302=(CommonTree)match(input,XPATH,FOLLOW_XPATH_in_pathExpr7598); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    XPATH302_tree = (CommonTree)adaptor.dupNode(XPATH302);

                    root_1 = (CommonTree)adaptor.becomeRoot(XPATH302_tree, root_1);
                    }


                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    SLASH303=(CommonTree)match(input,SLASH,FOLLOW_SLASH_in_pathExpr7600); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    SLASH303_tree = (CommonTree)adaptor.dupNode(SLASH303);

                    adaptor.addChild(root_1, SLASH303_tree);
                    }

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1694:5: ^( XPATH relativePathExpr )
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    XPATH304=(CommonTree)match(input,XPATH,FOLLOW_XPATH_in_pathExpr7608); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    XPATH304_tree = (CommonTree)adaptor.dupNode(XPATH304);

                    root_1 = (CommonTree)adaptor.becomeRoot(XPATH304_tree, root_1);
                    }


                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_relativePathExpr_in_pathExpr7610);
                    relativePathExpr305=relativePathExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, relativePathExpr305.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "pathExpr"

    protected static class relativePathExpr_scope {
        boolean rdbVar;
    }
    protected Stack relativePathExpr_stack = new Stack();

    public static class relativePathExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "relativePathExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1697:1: relativePathExpr : stepExpr ( SLASH ( SLASH )? stepExpr )* ;
    public final XSPARQLRewriter.relativePathExpr_return relativePathExpr() throws RecognitionException {
        relativePathExpr_stack.push(new relativePathExpr_scope());
        XSPARQLRewriter.relativePathExpr_return retval = new XSPARQLRewriter.relativePathExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree SLASH307=null;
        CommonTree SLASH308=null;
        XSPARQLRewriter.stepExpr_return stepExpr306 = null;

        XSPARQLRewriter.stepExpr_return stepExpr309 = null;


        CommonTree SLASH307_tree=null;
        CommonTree SLASH308_tree=null;


          ((relativePathExpr_scope)relativePathExpr_stack.peek()).rdbVar = false;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1704:3: ( stepExpr ( SLASH ( SLASH )? stepExpr )* )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1704:5: stepExpr ( SLASH ( SLASH )? stepExpr )*
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_stepExpr_in_relativePathExpr7633);
            stepExpr306=stepExpr();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, stepExpr306.getTree());
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1704:14: ( SLASH ( SLASH )? stepExpr )*
            loop93:
            do {
                int alt93=2;
                switch ( input.LA(1) ) {
                case SLASH:
                    {
                    alt93=1;
                    }
                    break;

                }

                switch (alt93) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1704:15: SLASH ( SLASH )? stepExpr
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    SLASH307=(CommonTree)match(input,SLASH,FOLLOW_SLASH_in_relativePathExpr7636); if (state.failed) return retval;
            	    if ( state.backtracking==0 ) {
            	    SLASH307_tree = (CommonTree)adaptor.dupNode(SLASH307);

            	    adaptor.addChild(root_0, SLASH307_tree);
            	    }
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1704:21: ( SLASH )?
            	    int alt92=2;
            	    switch ( input.LA(1) ) {
            	        case SLASH:
            	            {
            	            alt92=1;
            	            }
            	            break;
            	    }

            	    switch (alt92) {
            	        case 1 :
            	            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: SLASH
            	            {
            	            _last = (CommonTree)input.LT(1);
            	            SLASH308=(CommonTree)match(input,SLASH,FOLLOW_SLASH_in_relativePathExpr7638); if (state.failed) return retval;
            	            if ( state.backtracking==0 ) {
            	            SLASH308_tree = (CommonTree)adaptor.dupNode(SLASH308);

            	            adaptor.addChild(root_0, SLASH308_tree);
            	            }

            	            if ( state.backtracking==0 ) {
            	            }
            	            }
            	            break;

            	    }

            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_stepExpr_in_relativePathExpr7641);
            	    stepExpr309=stepExpr();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) 
            	    adaptor.addChild(root_0, stepExpr309.getTree());

            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    break loop93;
                }
            } while (true);


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
            relativePathExpr_stack.pop();
        }
        return retval;
    }
    // $ANTLR end "relativePathExpr"

    public static class stepExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "stepExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1710:1: stepExpr : ( filterExpr | axisStep );
    public final XSPARQLRewriter.stepExpr_return stepExpr() throws RecognitionException {
        XSPARQLRewriter.stepExpr_return retval = new XSPARQLRewriter.stepExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.filterExpr_return filterExpr310 = null;

        XSPARQLRewriter.axisStep_return axisStep311 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1711:3: ( filterExpr | axisStep )
            int alt94=2;
            switch ( input.LA(1) ) {
            case VAR:
            case INTEGER:
            case QSTRING:
            case DOT:
            case ORDERED:
            case UNORDERED:
            case DOCUMENT:
            case T_XML_ELEMENT:
            case T_PAR:
            case T_FUNCTION_CALL:
            case DECIMAL:
                {
                alt94=1;
                }
                break;
            case ELEMENT:
                {
                switch ( input.LA(2) ) {
                case LPAR:
                    {
                    alt94=2;
                    }
                    break;
                case LCURLY:
                case NCNAME:
                case PNAME_NS:
                case PNAME_LN:
                case A:
                case FROM:
                case TO:
                case ITEM:
                case COMMENT:
                case ROW:
                    {
                    alt94=1;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 94, 2, input);

                    throw nvae;
                }

                }
                break;
            case ATTRIBUTE:
                {
                switch ( input.LA(2) ) {
                case LPAR:
                case COLONCOLON:
                    {
                    alt94=2;
                    }
                    break;
                case LCURLY:
                case NCNAME:
                case STAR:
                case LESSTHAN:
                case GREATERTHAN:
                case PLUS:
                case MINUS:
                case UNIONSYMBOL:
                case LESSTHANLESSTHAN:
                case GREATERTHANEQUALS:
                case LESSTHANEQUALS:
                case HAFENEQUALS:
                case EQUALS:
                case PNAME_NS:
                case PNAME_LN:
                case A:
                case IS:
                case EQ:
                case NE:
                case LT:
                case GE:
                case LE:
                case GT:
                case FROM:
                case IF:
                case AND:
                case OR:
                case TO:
                case DIV:
                case IDIV:
                case MOD:
                case UNION:
                case INTERSECT:
                case EXCEPT:
                case ITEM:
                case COMMENT:
                case GREATERTHANGREATERTHAN:
                case ROW:
                case T_FLWOR:
                case T_INSTANCEOF:
                case T_CASTAS:
                case T_CASTABLEAS:
                case T_TREATAS:
                case EVERY:
                case TYPESWITCH:
                case VALIDATE:
                case SOME:
                case XPATH:
                    {
                    alt94=1;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 94, 3, input);

                    throw nvae;
                }

                }
                break;
            case TEXT:
                {
                switch ( input.LA(2) ) {
                case LPAR:
                    {
                    alt94=2;
                    }
                    break;
                case LCURLY:
                    {
                    alt94=1;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 94, 4, input);

                    throw nvae;
                }

                }
                break;
            case COMMENT:
                {
                switch ( input.LA(2) ) {
                case EOF:
                case UP:
                case SLASH:
                case LBRACKET:
                case LPAR:
                    {
                    alt94=2;
                    }
                    break;
                case LCURLY:
                case STAR:
                case LESSTHAN:
                case GREATERTHAN:
                case PLUS:
                case MINUS:
                case UNIONSYMBOL:
                case LESSTHANLESSTHAN:
                case GREATERTHANEQUALS:
                case LESSTHANEQUALS:
                case HAFENEQUALS:
                case EQUALS:
                case IS:
                case EQ:
                case NE:
                case LT:
                case GE:
                case LE:
                case GT:
                case IF:
                case AND:
                case OR:
                case TO:
                case DIV:
                case IDIV:
                case MOD:
                case UNION:
                case INTERSECT:
                case EXCEPT:
                case GREATERTHANGREATERTHAN:
                case T_FLWOR:
                case T_INSTANCEOF:
                case T_CASTAS:
                case T_CASTABLEAS:
                case T_TREATAS:
                case EVERY:
                case TYPESWITCH:
                case VALIDATE:
                case SOME:
                case XPATH:
                    {
                    alt94=1;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 94, 5, input);

                    throw nvae;
                }

                }
                break;
            case PROCESSINGINSTRUCTION:
                {
                switch ( input.LA(2) ) {
                case LPAR:
                    {
                    alt94=2;
                    }
                    break;
                case LCURLY:
                case NCNAME:
                case STAR:
                case LESSTHAN:
                case GREATERTHAN:
                case PLUS:
                case MINUS:
                case UNIONSYMBOL:
                case LESSTHANLESSTHAN:
                case GREATERTHANEQUALS:
                case LESSTHANEQUALS:
                case HAFENEQUALS:
                case EQUALS:
                case IS:
                case EQ:
                case NE:
                case LT:
                case GE:
                case LE:
                case GT:
                case IF:
                case AND:
                case OR:
                case TO:
                case DIV:
                case IDIV:
                case MOD:
                case UNION:
                case INTERSECT:
                case EXCEPT:
                case GREATERTHANGREATERTHAN:
                case T_FLWOR:
                case T_INSTANCEOF:
                case T_CASTAS:
                case T_CASTABLEAS:
                case T_TREATAS:
                case EVERY:
                case TYPESWITCH:
                case VALIDATE:
                case SOME:
                case XPATH:
                    {
                    alt94=1;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 94, 6, input);

                    throw nvae;
                }

                }
                break;
            case NCNAME:
            case AT:
            case STAR:
            case DOTDOT:
            case PNAME_NS:
            case PNAME_LN:
            case A:
            case FROM:
            case CHILD:
            case DESCENDANT:
            case SELF:
            case DESCENDANTORSELF:
            case FOLLOWINGSIBLING:
            case FOLLOWING:
            case PARENT:
            case ANCESTOR:
            case PRECEDINGSIBLING:
            case PRECEDING:
            case ANCESTORORSELF:
            case TO:
            case ITEM:
            case NODE:
            case DOCUMENTNODE:
            case SCHEMAATTRIBUTE:
            case SCHEMAELEMENT:
            case ROW:
                {
                alt94=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 94, 0, input);

                throw nvae;
            }

            switch (alt94) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1711:5: filterExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_filterExpr_in_stepExpr7659);
                    filterExpr310=filterExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, filterExpr310.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1712:5: axisStep
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_axisStep_in_stepExpr7665);
                    axisStep311=axisStep();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, axisStep311.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "stepExpr"

    public static class axisStep_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "axisStep"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1715:1: axisStep : ( reverseStep | forwardStep ) predicateList ;
    public final XSPARQLRewriter.axisStep_return axisStep() throws RecognitionException {
        XSPARQLRewriter.axisStep_return retval = new XSPARQLRewriter.axisStep_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.reverseStep_return reverseStep312 = null;

        XSPARQLRewriter.forwardStep_return forwardStep313 = null;

        XSPARQLRewriter.predicateList_return predicateList314 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1716:3: ( ( reverseStep | forwardStep ) predicateList )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1716:5: ( reverseStep | forwardStep ) predicateList
            {
            root_0 = (CommonTree)adaptor.nil();

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1716:5: ( reverseStep | forwardStep )
            int alt95=2;
            switch ( input.LA(1) ) {
            case DOTDOT:
            case PARENT:
            case ANCESTOR:
            case PRECEDINGSIBLING:
            case PRECEDING:
            case ANCESTORORSELF:
                {
                alt95=1;
                }
                break;
            case NCNAME:
            case AT:
            case STAR:
            case PNAME_NS:
            case PNAME_LN:
            case A:
            case FROM:
            case CHILD:
            case DESCENDANT:
            case ATTRIBUTE:
            case SELF:
            case DESCENDANTORSELF:
            case FOLLOWINGSIBLING:
            case FOLLOWING:
            case ELEMENT:
            case TO:
            case ITEM:
            case NODE:
            case DOCUMENTNODE:
            case TEXT:
            case COMMENT:
            case PROCESSINGINSTRUCTION:
            case SCHEMAATTRIBUTE:
            case SCHEMAELEMENT:
            case ROW:
                {
                alt95=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 95, 0, input);

                throw nvae;
            }

            switch (alt95) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1716:6: reverseStep
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_reverseStep_in_axisStep7679);
                    reverseStep312=reverseStep();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, reverseStep312.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1716:20: forwardStep
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_forwardStep_in_axisStep7683);
                    forwardStep313=forwardStep();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, forwardStep313.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_predicateList_in_axisStep7686);
            predicateList314=predicateList();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, predicateList314.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "axisStep"

    public static class forwardStep_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "forwardStep"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1719:1: forwardStep : ( forwardAxis nodeTest | abbrevForwardStep );
    public final XSPARQLRewriter.forwardStep_return forwardStep() throws RecognitionException {
        XSPARQLRewriter.forwardStep_return retval = new XSPARQLRewriter.forwardStep_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.forwardAxis_return forwardAxis315 = null;

        XSPARQLRewriter.nodeTest_return nodeTest316 = null;

        XSPARQLRewriter.abbrevForwardStep_return abbrevForwardStep317 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1720:3: ( forwardAxis nodeTest | abbrevForwardStep )
            int alt96=2;
            switch ( input.LA(1) ) {
            case CHILD:
            case DESCENDANT:
            case SELF:
            case DESCENDANTORSELF:
            case FOLLOWINGSIBLING:
            case FOLLOWING:
                {
                alt96=1;
                }
                break;
            case ATTRIBUTE:
                {
                switch ( input.LA(2) ) {
                case COLONCOLON:
                    {
                    alt96=1;
                    }
                    break;
                case LPAR:
                    {
                    alt96=2;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 96, 2, input);

                    throw nvae;
                }

                }
                break;
            case NCNAME:
            case AT:
            case STAR:
            case PNAME_NS:
            case PNAME_LN:
            case A:
            case FROM:
            case ELEMENT:
            case TO:
            case ITEM:
            case NODE:
            case DOCUMENTNODE:
            case TEXT:
            case COMMENT:
            case PROCESSINGINSTRUCTION:
            case SCHEMAATTRIBUTE:
            case SCHEMAELEMENT:
            case ROW:
                {
                alt96=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 96, 0, input);

                throw nvae;
            }

            switch (alt96) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1720:5: forwardAxis nodeTest
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_forwardAxis_in_forwardStep7699);
                    forwardAxis315=forwardAxis();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, forwardAxis315.getTree());
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_nodeTest_in_forwardStep7701);
                    nodeTest316=nodeTest();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, nodeTest316.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1721:5: abbrevForwardStep
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_abbrevForwardStep_in_forwardStep7707);
                    abbrevForwardStep317=abbrevForwardStep();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, abbrevForwardStep317.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "forwardStep"

    public static class forwardAxis_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "forwardAxis"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1724:1: forwardAxis : ( CHILD COLONCOLON | DESCENDANT COLONCOLON | ATTRIBUTE COLONCOLON | SELF COLONCOLON | DESCENDANTORSELF COLONCOLON | FOLLOWINGSIBLING COLONCOLON | FOLLOWING COLONCOLON );
    public final XSPARQLRewriter.forwardAxis_return forwardAxis() throws RecognitionException {
        XSPARQLRewriter.forwardAxis_return retval = new XSPARQLRewriter.forwardAxis_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree CHILD318=null;
        CommonTree COLONCOLON319=null;
        CommonTree DESCENDANT320=null;
        CommonTree COLONCOLON321=null;
        CommonTree ATTRIBUTE322=null;
        CommonTree COLONCOLON323=null;
        CommonTree SELF324=null;
        CommonTree COLONCOLON325=null;
        CommonTree DESCENDANTORSELF326=null;
        CommonTree COLONCOLON327=null;
        CommonTree FOLLOWINGSIBLING328=null;
        CommonTree COLONCOLON329=null;
        CommonTree FOLLOWING330=null;
        CommonTree COLONCOLON331=null;

        CommonTree CHILD318_tree=null;
        CommonTree COLONCOLON319_tree=null;
        CommonTree DESCENDANT320_tree=null;
        CommonTree COLONCOLON321_tree=null;
        CommonTree ATTRIBUTE322_tree=null;
        CommonTree COLONCOLON323_tree=null;
        CommonTree SELF324_tree=null;
        CommonTree COLONCOLON325_tree=null;
        CommonTree DESCENDANTORSELF326_tree=null;
        CommonTree COLONCOLON327_tree=null;
        CommonTree FOLLOWINGSIBLING328_tree=null;
        CommonTree COLONCOLON329_tree=null;
        CommonTree FOLLOWING330_tree=null;
        CommonTree COLONCOLON331_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1725:3: ( CHILD COLONCOLON | DESCENDANT COLONCOLON | ATTRIBUTE COLONCOLON | SELF COLONCOLON | DESCENDANTORSELF COLONCOLON | FOLLOWINGSIBLING COLONCOLON | FOLLOWING COLONCOLON )
            int alt97=7;
            switch ( input.LA(1) ) {
            case CHILD:
                {
                alt97=1;
                }
                break;
            case DESCENDANT:
                {
                alt97=2;
                }
                break;
            case ATTRIBUTE:
                {
                alt97=3;
                }
                break;
            case SELF:
                {
                alt97=4;
                }
                break;
            case DESCENDANTORSELF:
                {
                alt97=5;
                }
                break;
            case FOLLOWINGSIBLING:
                {
                alt97=6;
                }
                break;
            case FOLLOWING:
                {
                alt97=7;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 97, 0, input);

                throw nvae;
            }

            switch (alt97) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1725:5: CHILD COLONCOLON
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    CHILD318=(CommonTree)match(input,CHILD,FOLLOW_CHILD_in_forwardAxis7720); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    CHILD318_tree = (CommonTree)adaptor.dupNode(CHILD318);

                    adaptor.addChild(root_0, CHILD318_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    COLONCOLON319=(CommonTree)match(input,COLONCOLON,FOLLOW_COLONCOLON_in_forwardAxis7722); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    COLONCOLON319_tree = (CommonTree)adaptor.dupNode(COLONCOLON319);

                    adaptor.addChild(root_0, COLONCOLON319_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1726:5: DESCENDANT COLONCOLON
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    DESCENDANT320=(CommonTree)match(input,DESCENDANT,FOLLOW_DESCENDANT_in_forwardAxis7728); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    DESCENDANT320_tree = (CommonTree)adaptor.dupNode(DESCENDANT320);

                    adaptor.addChild(root_0, DESCENDANT320_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    COLONCOLON321=(CommonTree)match(input,COLONCOLON,FOLLOW_COLONCOLON_in_forwardAxis7730); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    COLONCOLON321_tree = (CommonTree)adaptor.dupNode(COLONCOLON321);

                    adaptor.addChild(root_0, COLONCOLON321_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1727:5: ATTRIBUTE COLONCOLON
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    ATTRIBUTE322=(CommonTree)match(input,ATTRIBUTE,FOLLOW_ATTRIBUTE_in_forwardAxis7736); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    ATTRIBUTE322_tree = (CommonTree)adaptor.dupNode(ATTRIBUTE322);

                    adaptor.addChild(root_0, ATTRIBUTE322_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    COLONCOLON323=(CommonTree)match(input,COLONCOLON,FOLLOW_COLONCOLON_in_forwardAxis7738); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    COLONCOLON323_tree = (CommonTree)adaptor.dupNode(COLONCOLON323);

                    adaptor.addChild(root_0, COLONCOLON323_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1728:5: SELF COLONCOLON
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    SELF324=(CommonTree)match(input,SELF,FOLLOW_SELF_in_forwardAxis7744); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    SELF324_tree = (CommonTree)adaptor.dupNode(SELF324);

                    adaptor.addChild(root_0, SELF324_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    COLONCOLON325=(CommonTree)match(input,COLONCOLON,FOLLOW_COLONCOLON_in_forwardAxis7746); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    COLONCOLON325_tree = (CommonTree)adaptor.dupNode(COLONCOLON325);

                    adaptor.addChild(root_0, COLONCOLON325_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 5 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1729:5: DESCENDANTORSELF COLONCOLON
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    DESCENDANTORSELF326=(CommonTree)match(input,DESCENDANTORSELF,FOLLOW_DESCENDANTORSELF_in_forwardAxis7752); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    DESCENDANTORSELF326_tree = (CommonTree)adaptor.dupNode(DESCENDANTORSELF326);

                    adaptor.addChild(root_0, DESCENDANTORSELF326_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    COLONCOLON327=(CommonTree)match(input,COLONCOLON,FOLLOW_COLONCOLON_in_forwardAxis7754); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    COLONCOLON327_tree = (CommonTree)adaptor.dupNode(COLONCOLON327);

                    adaptor.addChild(root_0, COLONCOLON327_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 6 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1730:5: FOLLOWINGSIBLING COLONCOLON
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    FOLLOWINGSIBLING328=(CommonTree)match(input,FOLLOWINGSIBLING,FOLLOW_FOLLOWINGSIBLING_in_forwardAxis7760); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    FOLLOWINGSIBLING328_tree = (CommonTree)adaptor.dupNode(FOLLOWINGSIBLING328);

                    adaptor.addChild(root_0, FOLLOWINGSIBLING328_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    COLONCOLON329=(CommonTree)match(input,COLONCOLON,FOLLOW_COLONCOLON_in_forwardAxis7762); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    COLONCOLON329_tree = (CommonTree)adaptor.dupNode(COLONCOLON329);

                    adaptor.addChild(root_0, COLONCOLON329_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 7 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1731:5: FOLLOWING COLONCOLON
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    FOLLOWING330=(CommonTree)match(input,FOLLOWING,FOLLOW_FOLLOWING_in_forwardAxis7768); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    FOLLOWING330_tree = (CommonTree)adaptor.dupNode(FOLLOWING330);

                    adaptor.addChild(root_0, FOLLOWING330_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    COLONCOLON331=(CommonTree)match(input,COLONCOLON,FOLLOW_COLONCOLON_in_forwardAxis7770); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    COLONCOLON331_tree = (CommonTree)adaptor.dupNode(COLONCOLON331);

                    adaptor.addChild(root_0, COLONCOLON331_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "forwardAxis"

    public static class abbrevForwardStep_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "abbrevForwardStep"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1734:1: abbrevForwardStep : ( AT )? nodeTest ;
    public final XSPARQLRewriter.abbrevForwardStep_return abbrevForwardStep() throws RecognitionException {
        XSPARQLRewriter.abbrevForwardStep_return retval = new XSPARQLRewriter.abbrevForwardStep_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree AT332=null;
        XSPARQLRewriter.nodeTest_return nodeTest333 = null;


        CommonTree AT332_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1735:3: ( ( AT )? nodeTest )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1735:5: ( AT )? nodeTest
            {
            root_0 = (CommonTree)adaptor.nil();

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1735:5: ( AT )?
            int alt98=2;
            switch ( input.LA(1) ) {
                case AT:
                    {
                    alt98=1;
                    }
                    break;
            }

            switch (alt98) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: AT
                    {
                    _last = (CommonTree)input.LT(1);
                    AT332=(CommonTree)match(input,AT,FOLLOW_AT_in_abbrevForwardStep7783); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    AT332_tree = (CommonTree)adaptor.dupNode(AT332);

                    adaptor.addChild(root_0, AT332_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_nodeTest_in_abbrevForwardStep7786);
            nodeTest333=nodeTest();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, nodeTest333.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "abbrevForwardStep"

    public static class reverseStep_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "reverseStep"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1738:1: reverseStep : ( reverseAxis nodeTest | abbrevReverseStep );
    public final XSPARQLRewriter.reverseStep_return reverseStep() throws RecognitionException {
        XSPARQLRewriter.reverseStep_return retval = new XSPARQLRewriter.reverseStep_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.reverseAxis_return reverseAxis334 = null;

        XSPARQLRewriter.nodeTest_return nodeTest335 = null;

        XSPARQLRewriter.abbrevReverseStep_return abbrevReverseStep336 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1739:3: ( reverseAxis nodeTest | abbrevReverseStep )
            int alt99=2;
            switch ( input.LA(1) ) {
            case PARENT:
            case ANCESTOR:
            case PRECEDINGSIBLING:
            case PRECEDING:
            case ANCESTORORSELF:
                {
                alt99=1;
                }
                break;
            case DOTDOT:
                {
                alt99=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 99, 0, input);

                throw nvae;
            }

            switch (alt99) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1739:5: reverseAxis nodeTest
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_reverseAxis_in_reverseStep7799);
                    reverseAxis334=reverseAxis();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, reverseAxis334.getTree());
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_nodeTest_in_reverseStep7801);
                    nodeTest335=nodeTest();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, nodeTest335.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1740:5: abbrevReverseStep
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_abbrevReverseStep_in_reverseStep7807);
                    abbrevReverseStep336=abbrevReverseStep();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, abbrevReverseStep336.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "reverseStep"

    public static class reverseAxis_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "reverseAxis"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1743:1: reverseAxis : ( PARENT COLONCOLON | ANCESTOR COLONCOLON | PRECEDINGSIBLING COLONCOLON | PRECEDING COLONCOLON | ANCESTORORSELF COLONCOLON );
    public final XSPARQLRewriter.reverseAxis_return reverseAxis() throws RecognitionException {
        XSPARQLRewriter.reverseAxis_return retval = new XSPARQLRewriter.reverseAxis_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree PARENT337=null;
        CommonTree COLONCOLON338=null;
        CommonTree ANCESTOR339=null;
        CommonTree COLONCOLON340=null;
        CommonTree PRECEDINGSIBLING341=null;
        CommonTree COLONCOLON342=null;
        CommonTree PRECEDING343=null;
        CommonTree COLONCOLON344=null;
        CommonTree ANCESTORORSELF345=null;
        CommonTree COLONCOLON346=null;

        CommonTree PARENT337_tree=null;
        CommonTree COLONCOLON338_tree=null;
        CommonTree ANCESTOR339_tree=null;
        CommonTree COLONCOLON340_tree=null;
        CommonTree PRECEDINGSIBLING341_tree=null;
        CommonTree COLONCOLON342_tree=null;
        CommonTree PRECEDING343_tree=null;
        CommonTree COLONCOLON344_tree=null;
        CommonTree ANCESTORORSELF345_tree=null;
        CommonTree COLONCOLON346_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1744:3: ( PARENT COLONCOLON | ANCESTOR COLONCOLON | PRECEDINGSIBLING COLONCOLON | PRECEDING COLONCOLON | ANCESTORORSELF COLONCOLON )
            int alt100=5;
            switch ( input.LA(1) ) {
            case PARENT:
                {
                alt100=1;
                }
                break;
            case ANCESTOR:
                {
                alt100=2;
                }
                break;
            case PRECEDINGSIBLING:
                {
                alt100=3;
                }
                break;
            case PRECEDING:
                {
                alt100=4;
                }
                break;
            case ANCESTORORSELF:
                {
                alt100=5;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 100, 0, input);

                throw nvae;
            }

            switch (alt100) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1744:5: PARENT COLONCOLON
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    PARENT337=(CommonTree)match(input,PARENT,FOLLOW_PARENT_in_reverseAxis7820); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    PARENT337_tree = (CommonTree)adaptor.dupNode(PARENT337);

                    adaptor.addChild(root_0, PARENT337_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    COLONCOLON338=(CommonTree)match(input,COLONCOLON,FOLLOW_COLONCOLON_in_reverseAxis7822); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    COLONCOLON338_tree = (CommonTree)adaptor.dupNode(COLONCOLON338);

                    adaptor.addChild(root_0, COLONCOLON338_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1745:5: ANCESTOR COLONCOLON
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    ANCESTOR339=(CommonTree)match(input,ANCESTOR,FOLLOW_ANCESTOR_in_reverseAxis7828); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    ANCESTOR339_tree = (CommonTree)adaptor.dupNode(ANCESTOR339);

                    adaptor.addChild(root_0, ANCESTOR339_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    COLONCOLON340=(CommonTree)match(input,COLONCOLON,FOLLOW_COLONCOLON_in_reverseAxis7830); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    COLONCOLON340_tree = (CommonTree)adaptor.dupNode(COLONCOLON340);

                    adaptor.addChild(root_0, COLONCOLON340_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1746:5: PRECEDINGSIBLING COLONCOLON
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    PRECEDINGSIBLING341=(CommonTree)match(input,PRECEDINGSIBLING,FOLLOW_PRECEDINGSIBLING_in_reverseAxis7836); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    PRECEDINGSIBLING341_tree = (CommonTree)adaptor.dupNode(PRECEDINGSIBLING341);

                    adaptor.addChild(root_0, PRECEDINGSIBLING341_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    COLONCOLON342=(CommonTree)match(input,COLONCOLON,FOLLOW_COLONCOLON_in_reverseAxis7838); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    COLONCOLON342_tree = (CommonTree)adaptor.dupNode(COLONCOLON342);

                    adaptor.addChild(root_0, COLONCOLON342_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1747:5: PRECEDING COLONCOLON
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    PRECEDING343=(CommonTree)match(input,PRECEDING,FOLLOW_PRECEDING_in_reverseAxis7844); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    PRECEDING343_tree = (CommonTree)adaptor.dupNode(PRECEDING343);

                    adaptor.addChild(root_0, PRECEDING343_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    COLONCOLON344=(CommonTree)match(input,COLONCOLON,FOLLOW_COLONCOLON_in_reverseAxis7846); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    COLONCOLON344_tree = (CommonTree)adaptor.dupNode(COLONCOLON344);

                    adaptor.addChild(root_0, COLONCOLON344_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 5 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1748:5: ANCESTORORSELF COLONCOLON
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    ANCESTORORSELF345=(CommonTree)match(input,ANCESTORORSELF,FOLLOW_ANCESTORORSELF_in_reverseAxis7852); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    ANCESTORORSELF345_tree = (CommonTree)adaptor.dupNode(ANCESTORORSELF345);

                    adaptor.addChild(root_0, ANCESTORORSELF345_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    COLONCOLON346=(CommonTree)match(input,COLONCOLON,FOLLOW_COLONCOLON_in_reverseAxis7854); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    COLONCOLON346_tree = (CommonTree)adaptor.dupNode(COLONCOLON346);

                    adaptor.addChild(root_0, COLONCOLON346_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "reverseAxis"

    public static class abbrevReverseStep_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "abbrevReverseStep"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1751:1: abbrevReverseStep : DOTDOT ;
    public final XSPARQLRewriter.abbrevReverseStep_return abbrevReverseStep() throws RecognitionException {
        XSPARQLRewriter.abbrevReverseStep_return retval = new XSPARQLRewriter.abbrevReverseStep_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree DOTDOT347=null;

        CommonTree DOTDOT347_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1752:3: ( DOTDOT )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1752:5: DOTDOT
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            DOTDOT347=(CommonTree)match(input,DOTDOT,FOLLOW_DOTDOT_in_abbrevReverseStep7867); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            DOTDOT347_tree = (CommonTree)adaptor.dupNode(DOTDOT347);

            adaptor.addChild(root_0, DOTDOT347_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "abbrevReverseStep"

    public static class nodeTest_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "nodeTest"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1755:1: nodeTest : ( kindTest | nameTest );
    public final XSPARQLRewriter.nodeTest_return nodeTest() throws RecognitionException {
        XSPARQLRewriter.nodeTest_return retval = new XSPARQLRewriter.nodeTest_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.kindTest_return kindTest348 = null;

        XSPARQLRewriter.nameTest_return nameTest349 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1756:3: ( kindTest | nameTest )
            int alt101=2;
            switch ( input.LA(1) ) {
            case ATTRIBUTE:
            case ELEMENT:
            case NODE:
            case DOCUMENTNODE:
            case TEXT:
            case PROCESSINGINSTRUCTION:
            case SCHEMAATTRIBUTE:
            case SCHEMAELEMENT:
                {
                alt101=1;
                }
                break;
            case COMMENT:
                {
                switch ( input.LA(2) ) {
                case LPAR:
                    {
                    alt101=1;
                    }
                    break;
                case EOF:
                case UP:
                case SLASH:
                case LBRACKET:
                    {
                    alt101=2;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 101, 2, input);

                    throw nvae;
                }

                }
                break;
            case NCNAME:
            case STAR:
            case PNAME_NS:
            case PNAME_LN:
            case A:
            case FROM:
            case TO:
            case ITEM:
            case ROW:
                {
                alt101=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 101, 0, input);

                throw nvae;
            }

            switch (alt101) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1756:5: kindTest
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_kindTest_in_nodeTest7880);
                    kindTest348=kindTest();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, kindTest348.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1757:5: nameTest
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_nameTest_in_nodeTest7886);
                    nameTest349=nameTest();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, nameTest349.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "nodeTest"

    public static class nameTest_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "nameTest"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1760:1: nameTest : ( qname | wildCard );
    public final XSPARQLRewriter.nameTest_return nameTest() throws RecognitionException {
        XSPARQLRewriter.nameTest_return retval = new XSPARQLRewriter.nameTest_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.qname_return qname350 = null;

        XSPARQLRewriter.wildCard_return wildCard351 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1761:3: ( qname | wildCard )
            int alt102=2;
            switch ( input.LA(1) ) {
            case PNAME_NS:
            case PNAME_LN:
            case A:
            case FROM:
            case TO:
            case ITEM:
            case COMMENT:
            case ROW:
                {
                alt102=1;
                }
                break;
            case NCNAME:
                {
                switch ( input.LA(2) ) {
                case COLON:
                    {
                    alt102=2;
                    }
                    break;
                case EOF:
                case UP:
                case SLASH:
                case LBRACKET:
                    {
                    alt102=1;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 102, 2, input);

                    throw nvae;
                }

                }
                break;
            case STAR:
                {
                alt102=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 102, 0, input);

                throw nvae;
            }

            switch (alt102) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1761:5: qname
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_qname_in_nameTest7899);
                    qname350=qname();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, qname350.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1762:5: wildCard
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_wildCard_in_nameTest7905);
                    wildCard351=wildCard();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, wildCard351.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "nameTest"

    public static class wildCard_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "wildCard"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1765:1: wildCard : ( STAR | STAR COLON NCNAME | NCNAME COLON STAR );
    public final XSPARQLRewriter.wildCard_return wildCard() throws RecognitionException {
        XSPARQLRewriter.wildCard_return retval = new XSPARQLRewriter.wildCard_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree STAR352=null;
        CommonTree STAR353=null;
        CommonTree COLON354=null;
        CommonTree NCNAME355=null;
        CommonTree NCNAME356=null;
        CommonTree COLON357=null;
        CommonTree STAR358=null;

        CommonTree STAR352_tree=null;
        CommonTree STAR353_tree=null;
        CommonTree COLON354_tree=null;
        CommonTree NCNAME355_tree=null;
        CommonTree NCNAME356_tree=null;
        CommonTree COLON357_tree=null;
        CommonTree STAR358_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1766:3: ( STAR | STAR COLON NCNAME | NCNAME COLON STAR )
            int alt103=3;
            switch ( input.LA(1) ) {
            case STAR:
                {
                switch ( input.LA(2) ) {
                case COLON:
                    {
                    alt103=2;
                    }
                    break;
                case EOF:
                case UP:
                case SLASH:
                case LBRACKET:
                    {
                    alt103=1;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 103, 1, input);

                    throw nvae;
                }

                }
                break;
            case NCNAME:
                {
                alt103=3;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 103, 0, input);

                throw nvae;
            }

            switch (alt103) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1766:5: STAR
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    STAR352=(CommonTree)match(input,STAR,FOLLOW_STAR_in_wildCard7918); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    STAR352_tree = (CommonTree)adaptor.dupNode(STAR352);

                    adaptor.addChild(root_0, STAR352_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1767:5: STAR COLON NCNAME
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    STAR353=(CommonTree)match(input,STAR,FOLLOW_STAR_in_wildCard7924); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    STAR353_tree = (CommonTree)adaptor.dupNode(STAR353);

                    adaptor.addChild(root_0, STAR353_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    COLON354=(CommonTree)match(input,COLON,FOLLOW_COLON_in_wildCard7926); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    COLON354_tree = (CommonTree)adaptor.dupNode(COLON354);

                    adaptor.addChild(root_0, COLON354_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    NCNAME355=(CommonTree)match(input,NCNAME,FOLLOW_NCNAME_in_wildCard7928); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    NCNAME355_tree = (CommonTree)adaptor.dupNode(NCNAME355);

                    adaptor.addChild(root_0, NCNAME355_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1768:5: NCNAME COLON STAR
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    NCNAME356=(CommonTree)match(input,NCNAME,FOLLOW_NCNAME_in_wildCard7934); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    NCNAME356_tree = (CommonTree)adaptor.dupNode(NCNAME356);

                    adaptor.addChild(root_0, NCNAME356_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    COLON357=(CommonTree)match(input,COLON,FOLLOW_COLON_in_wildCard7936); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    COLON357_tree = (CommonTree)adaptor.dupNode(COLON357);

                    adaptor.addChild(root_0, COLON357_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    STAR358=(CommonTree)match(input,STAR,FOLLOW_STAR_in_wildCard7938); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    STAR358_tree = (CommonTree)adaptor.dupNode(STAR358);

                    adaptor.addChild(root_0, STAR358_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "wildCard"

    public static class filterExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "filterExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1771:1: filterExpr : primaryExpr predicateList ;
    public final XSPARQLRewriter.filterExpr_return filterExpr() throws RecognitionException {
        XSPARQLRewriter.filterExpr_return retval = new XSPARQLRewriter.filterExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.primaryExpr_return primaryExpr359 = null;

        XSPARQLRewriter.predicateList_return predicateList360 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1772:3: ( primaryExpr predicateList )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1772:5: primaryExpr predicateList
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_primaryExpr_in_filterExpr7951);
            primaryExpr359=primaryExpr();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, primaryExpr359.getTree());
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_predicateList_in_filterExpr7953);
            predicateList360=predicateList();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, predicateList360.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "filterExpr"

    public static class predicateList_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "predicateList"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1775:1: predicateList : ( predicate )* ;
    public final XSPARQLRewriter.predicateList_return predicateList() throws RecognitionException {
        XSPARQLRewriter.predicateList_return retval = new XSPARQLRewriter.predicateList_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.predicate_return predicate361 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1776:3: ( ( predicate )* )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1776:5: ( predicate )*
            {
            root_0 = (CommonTree)adaptor.nil();

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1776:5: ( predicate )*
            loop104:
            do {
                int alt104=2;
                switch ( input.LA(1) ) {
                case LBRACKET:
                    {
                    alt104=1;
                    }
                    break;

                }

                switch (alt104) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: predicate
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_predicate_in_predicateList7966);
            	    predicate361=predicate();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) 
            	    adaptor.addChild(root_0, predicate361.getTree());

            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    break loop104;
                }
            } while (true);


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "predicateList"

    public static class predicate_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "predicate"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1779:1: predicate : LBRACKET expr RBRACKET ;
    public final XSPARQLRewriter.predicate_return predicate() throws RecognitionException {
        XSPARQLRewriter.predicate_return retval = new XSPARQLRewriter.predicate_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree LBRACKET362=null;
        CommonTree RBRACKET364=null;
        XSPARQLRewriter.expr_return expr363 = null;


        CommonTree LBRACKET362_tree=null;
        CommonTree RBRACKET364_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1780:3: ( LBRACKET expr RBRACKET )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1780:5: LBRACKET expr RBRACKET
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            LBRACKET362=(CommonTree)match(input,LBRACKET,FOLLOW_LBRACKET_in_predicate7980); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            LBRACKET362_tree = (CommonTree)adaptor.dupNode(LBRACKET362);

            adaptor.addChild(root_0, LBRACKET362_tree);
            }
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_expr_in_predicate7982);
            expr363=expr();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, expr363.getTree());
            _last = (CommonTree)input.LT(1);
            RBRACKET364=(CommonTree)match(input,RBRACKET,FOLLOW_RBRACKET_in_predicate7984); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            RBRACKET364_tree = (CommonTree)adaptor.dupNode(RBRACKET364);

            adaptor.addChild(root_0, RBRACKET364_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "predicate"

    public static class primaryExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "primaryExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1783:1: primaryExpr : ( varRef | literal | parenthesizedExpr | contextItemExpr | functionCall | orderedExpr | unorderedExpr | constructor );
    public final XSPARQLRewriter.primaryExpr_return primaryExpr() throws RecognitionException {
        XSPARQLRewriter.primaryExpr_return retval = new XSPARQLRewriter.primaryExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.varRef_return varRef365 = null;

        XSPARQLRewriter.literal_return literal366 = null;

        XSPARQLRewriter.parenthesizedExpr_return parenthesizedExpr367 = null;

        XSPARQLRewriter.contextItemExpr_return contextItemExpr368 = null;

        XSPARQLRewriter.functionCall_return functionCall369 = null;

        XSPARQLRewriter.orderedExpr_return orderedExpr370 = null;

        XSPARQLRewriter.unorderedExpr_return unorderedExpr371 = null;

        XSPARQLRewriter.constructor_return constructor372 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1784:3: ( varRef | literal | parenthesizedExpr | contextItemExpr | functionCall | orderedExpr | unorderedExpr | constructor )
            int alt105=8;
            switch ( input.LA(1) ) {
            case VAR:
                {
                alt105=1;
                }
                break;
            case INTEGER:
            case QSTRING:
            case DECIMAL:
                {
                alt105=2;
                }
                break;
            case T_PAR:
                {
                alt105=3;
                }
                break;
            case DOT:
                {
                alt105=4;
                }
                break;
            case T_FUNCTION_CALL:
                {
                alt105=5;
                }
                break;
            case ORDERED:
                {
                alt105=6;
                }
                break;
            case UNORDERED:
                {
                alt105=7;
                }
                break;
            case ATTRIBUTE:
            case ELEMENT:
            case TEXT:
            case COMMENT:
            case PROCESSINGINSTRUCTION:
            case DOCUMENT:
            case T_XML_ELEMENT:
                {
                alt105=8;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 105, 0, input);

                throw nvae;
            }

            switch (alt105) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1784:5: varRef
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_varRef_in_primaryExpr7997);
                    varRef365=varRef();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, varRef365.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1785:5: literal
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_literal_in_primaryExpr8003);
                    literal366=literal();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, literal366.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1786:5: parenthesizedExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_parenthesizedExpr_in_primaryExpr8009);
                    parenthesizedExpr367=parenthesizedExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, parenthesizedExpr367.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1787:5: contextItemExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_contextItemExpr_in_primaryExpr8015);
                    contextItemExpr368=contextItemExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, contextItemExpr368.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 5 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1788:5: functionCall
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_functionCall_in_primaryExpr8021);
                    functionCall369=functionCall();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, functionCall369.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 6 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1789:5: orderedExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_orderedExpr_in_primaryExpr8027);
                    orderedExpr370=orderedExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, orderedExpr370.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 7 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1790:5: unorderedExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_unorderedExpr_in_primaryExpr8033);
                    unorderedExpr371=unorderedExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, unorderedExpr371.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 8 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1791:5: constructor
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_constructor_in_primaryExpr8039);
                    constructor372=constructor();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, constructor372.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "primaryExpr"

    public static class literal_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "literal"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1794:1: literal : ( numericliteral | stringliteral );
    public final XSPARQLRewriter.literal_return literal() throws RecognitionException {
        XSPARQLRewriter.literal_return retval = new XSPARQLRewriter.literal_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.numericliteral_return numericliteral373 = null;

        XSPARQLRewriter.stringliteral_return stringliteral374 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1795:3: ( numericliteral | stringliteral )
            int alt106=2;
            switch ( input.LA(1) ) {
            case INTEGER:
            case DECIMAL:
                {
                alt106=1;
                }
                break;
            case QSTRING:
                {
                alt106=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 106, 0, input);

                throw nvae;
            }

            switch (alt106) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1795:5: numericliteral
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_numericliteral_in_literal8052);
                    numericliteral373=numericliteral();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, numericliteral373.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1796:5: stringliteral
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_stringliteral_in_literal8058);
                    stringliteral374=stringliteral();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, stringliteral374.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "literal"

    public static class numericliteral_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "numericliteral"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1799:1: numericliteral : ( integerLiteral | decimalLiteral );
    public final XSPARQLRewriter.numericliteral_return numericliteral() throws RecognitionException {
        XSPARQLRewriter.numericliteral_return retval = new XSPARQLRewriter.numericliteral_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.integerLiteral_return integerLiteral375 = null;

        XSPARQLRewriter.decimalLiteral_return decimalLiteral376 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1800:3: ( integerLiteral | decimalLiteral )
            int alt107=2;
            switch ( input.LA(1) ) {
            case INTEGER:
                {
                alt107=1;
                }
                break;
            case DECIMAL:
                {
                alt107=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 107, 0, input);

                throw nvae;
            }

            switch (alt107) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1800:5: integerLiteral
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_integerLiteral_in_numericliteral8071);
                    integerLiteral375=integerLiteral();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, integerLiteral375.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1801:5: decimalLiteral
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_decimalLiteral_in_numericliteral8077);
                    decimalLiteral376=decimalLiteral();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, decimalLiteral376.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "numericliteral"

    public static class varRef_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "varRef"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1805:1: varRef : v= VAR -> { isBound($v.text, Types.SPARQL) || $relativePathExpr::rdbVar }? ^( T_FUNCTION_CALL NCNAME[\"_xsparql:_typeData\"] ^( T_PARAMS $v) ) -> $v;
    public final XSPARQLRewriter.varRef_return varRef() throws RecognitionException {
        XSPARQLRewriter.varRef_return retval = new XSPARQLRewriter.varRef_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree v=null;

        CommonTree v_tree=null;
        RewriteRuleNodeStream stream_VAR=new RewriteRuleNodeStream(adaptor,"token VAR");

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1806:3: (v= VAR -> { isBound($v.text, Types.SPARQL) || $relativePathExpr::rdbVar }? ^( T_FUNCTION_CALL NCNAME[\"_xsparql:_typeData\"] ^( T_PARAMS $v) ) -> $v)
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1806:5: v= VAR
            {
            _last = (CommonTree)input.LT(1);
            v=(CommonTree)match(input,VAR,FOLLOW_VAR_in_varRef8096); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_VAR.add(v);

            if ( state.backtracking==0 ) {
               ((relativePathExpr_scope)relativePathExpr_stack.peek()).rdbVar = isBound((v!=null?v.getText():null), Types.SQL); 
            }


            // AST REWRITE
            // elements: v, v
            // token labels: v
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleNodeStream stream_v=new RewriteRuleNodeStream(adaptor,"token v",v);
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 1807:5: -> { isBound($v.text, Types.SPARQL) || $relativePathExpr::rdbVar }? ^( T_FUNCTION_CALL NCNAME[\"_xsparql:_typeData\"] ^( T_PARAMS $v) )
            if ( isBound((v!=null?v.getText():null), Types.SPARQL) || ((relativePathExpr_scope)relativePathExpr_stack.peek()).rdbVar ) {
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1807:73: ^( T_FUNCTION_CALL NCNAME[\"_xsparql:_typeData\"] ^( T_PARAMS $v) )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_1);

                adaptor.addChild(root_1, (CommonTree)adaptor.create(NCNAME, "_xsparql:_typeData"));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1807:120: ^( T_PARAMS $v)
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_2);

                adaptor.addChild(root_2, stream_v.nextNode());

                adaptor.addChild(root_1, root_2);
                }

                adaptor.addChild(root_0, root_1);
                }

            }
            else // 1808:5: -> $v
            {
                adaptor.addChild(root_0, stream_v.nextNode());

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "varRef"

    public static class varName_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "varName"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1811:1: varName : qname ;
    public final XSPARQLRewriter.varName_return varName() throws RecognitionException {
        XSPARQLRewriter.varName_return retval = new XSPARQLRewriter.varName_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.qname_return qname377 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1812:3: ( qname )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1812:5: qname
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_qname_in_varName8143);
            qname377=qname();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, qname377.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "varName"

    public static class parenthesizedExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "parenthesizedExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1815:1: parenthesizedExpr : ^( T_PAR ( expr )? ) ;
    public final XSPARQLRewriter.parenthesizedExpr_return parenthesizedExpr() throws RecognitionException {
        XSPARQLRewriter.parenthesizedExpr_return retval = new XSPARQLRewriter.parenthesizedExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_PAR378=null;
        XSPARQLRewriter.expr_return expr379 = null;


        CommonTree T_PAR378_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1816:3: ( ^( T_PAR ( expr )? ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1816:5: ^( T_PAR ( expr )? )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_PAR378=(CommonTree)match(input,T_PAR,FOLLOW_T_PAR_in_parenthesizedExpr8157); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_PAR378_tree = (CommonTree)adaptor.dupNode(T_PAR378);

            root_1 = (CommonTree)adaptor.becomeRoot(T_PAR378_tree, root_1);
            }


            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); if (state.failed) return retval;
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1816:13: ( expr )?
                int alt108=2;
                switch ( input.LA(1) ) {
                    case LCURLY:
                    case STAR:
                    case LESSTHAN:
                    case GREATERTHAN:
                    case PLUS:
                    case MINUS:
                    case UNIONSYMBOL:
                    case LESSTHANLESSTHAN:
                    case GREATERTHANEQUALS:
                    case LESSTHANEQUALS:
                    case HAFENEQUALS:
                    case EQUALS:
                    case IS:
                    case EQ:
                    case NE:
                    case LT:
                    case GE:
                    case LE:
                    case GT:
                    case IF:
                    case AND:
                    case OR:
                    case TO:
                    case DIV:
                    case IDIV:
                    case MOD:
                    case UNION:
                    case INTERSECT:
                    case EXCEPT:
                    case GREATERTHANGREATERTHAN:
                    case T_FLWOR:
                    case T_INSTANCEOF:
                    case T_CASTAS:
                    case T_CASTABLEAS:
                    case T_TREATAS:
                    case EVERY:
                    case TYPESWITCH:
                    case VALIDATE:
                    case SOME:
                    case XPATH:
                        {
                        alt108=1;
                        }
                        break;
                }

                switch (alt108) {
                    case 1 :
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: expr
                        {
                        _last = (CommonTree)input.LT(1);
                        pushFollow(FOLLOW_expr_in_parenthesizedExpr8159);
                        expr379=expr();

                        state._fsp--;
                        if (state.failed) return retval;
                        if ( state.backtracking==0 ) 
                        adaptor.addChild(root_1, expr379.getTree());

                        if ( state.backtracking==0 ) {
                        }
                        }
                        break;

                }


                match(input, Token.UP, null); if (state.failed) return retval;
            }adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "parenthesizedExpr"

    public static class contextItemExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "contextItemExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1819:1: contextItemExpr : DOT ;
    public final XSPARQLRewriter.contextItemExpr_return contextItemExpr() throws RecognitionException {
        XSPARQLRewriter.contextItemExpr_return retval = new XSPARQLRewriter.contextItemExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree DOT380=null;

        CommonTree DOT380_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1820:3: ( DOT )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1820:5: DOT
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            DOT380=(CommonTree)match(input,DOT,FOLLOW_DOT_in_contextItemExpr8174); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            DOT380_tree = (CommonTree)adaptor.dupNode(DOT380);

            adaptor.addChild(root_0, DOT380_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "contextItemExpr"

    public static class orderedExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "orderedExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1823:1: orderedExpr : ORDERED expr ;
    public final XSPARQLRewriter.orderedExpr_return orderedExpr() throws RecognitionException {
        XSPARQLRewriter.orderedExpr_return retval = new XSPARQLRewriter.orderedExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree ORDERED381=null;
        XSPARQLRewriter.expr_return expr382 = null;


        CommonTree ORDERED381_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1824:3: ( ORDERED expr )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1824:5: ORDERED expr
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            ORDERED381=(CommonTree)match(input,ORDERED,FOLLOW_ORDERED_in_orderedExpr8187); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            ORDERED381_tree = (CommonTree)adaptor.dupNode(ORDERED381);

            adaptor.addChild(root_0, ORDERED381_tree);
            }
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_expr_in_orderedExpr8189);
            expr382=expr();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, expr382.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "orderedExpr"

    public static class unorderedExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "unorderedExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1827:1: unorderedExpr : UNORDERED expr ;
    public final XSPARQLRewriter.unorderedExpr_return unorderedExpr() throws RecognitionException {
        XSPARQLRewriter.unorderedExpr_return retval = new XSPARQLRewriter.unorderedExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree UNORDERED383=null;
        XSPARQLRewriter.expr_return expr384 = null;


        CommonTree UNORDERED383_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1828:3: ( UNORDERED expr )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1828:5: UNORDERED expr
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            UNORDERED383=(CommonTree)match(input,UNORDERED,FOLLOW_UNORDERED_in_unorderedExpr8202); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            UNORDERED383_tree = (CommonTree)adaptor.dupNode(UNORDERED383);

            adaptor.addChild(root_0, UNORDERED383_tree);
            }
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_expr_in_unorderedExpr8204);
            expr384=expr();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, expr384.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "unorderedExpr"

    public static class functionCall_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "functionCall"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1831:1: functionCall : ^( T_FUNCTION_CALL qname ^( T_PARAMS ( exprSingle )* ) ) ;
    public final XSPARQLRewriter.functionCall_return functionCall() throws RecognitionException {
        XSPARQLRewriter.functionCall_return retval = new XSPARQLRewriter.functionCall_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_FUNCTION_CALL385=null;
        CommonTree T_PARAMS387=null;
        XSPARQLRewriter.qname_return qname386 = null;

        XSPARQLRewriter.exprSingle_return exprSingle388 = null;


        CommonTree T_FUNCTION_CALL385_tree=null;
        CommonTree T_PARAMS387_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1832:3: ( ^( T_FUNCTION_CALL qname ^( T_PARAMS ( exprSingle )* ) ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1832:6: ^( T_FUNCTION_CALL qname ^( T_PARAMS ( exprSingle )* ) )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_FUNCTION_CALL385=(CommonTree)match(input,T_FUNCTION_CALL,FOLLOW_T_FUNCTION_CALL_in_functionCall8219); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_FUNCTION_CALL385_tree = (CommonTree)adaptor.dupNode(T_FUNCTION_CALL385);

            root_1 = (CommonTree)adaptor.becomeRoot(T_FUNCTION_CALL385_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_qname_in_functionCall8221);
            qname386=qname();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, qname386.getTree());
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_2 = _last;
            CommonTree _first_2 = null;
            CommonTree root_2 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_PARAMS387=(CommonTree)match(input,T_PARAMS,FOLLOW_T_PARAMS_in_functionCall8224); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_PARAMS387_tree = (CommonTree)adaptor.dupNode(T_PARAMS387);

            root_2 = (CommonTree)adaptor.becomeRoot(T_PARAMS387_tree, root_2);
            }


            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); if (state.failed) return retval;
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1832:41: ( exprSingle )*
                loop109:
                do {
                    int alt109=2;
                    switch ( input.LA(1) ) {
                    case LCURLY:
                    case STAR:
                    case LESSTHAN:
                    case GREATERTHAN:
                    case PLUS:
                    case MINUS:
                    case UNIONSYMBOL:
                    case LESSTHANLESSTHAN:
                    case GREATERTHANEQUALS:
                    case LESSTHANEQUALS:
                    case HAFENEQUALS:
                    case EQUALS:
                    case IS:
                    case EQ:
                    case NE:
                    case LT:
                    case GE:
                    case LE:
                    case GT:
                    case IF:
                    case AND:
                    case OR:
                    case TO:
                    case DIV:
                    case IDIV:
                    case MOD:
                    case UNION:
                    case INTERSECT:
                    case EXCEPT:
                    case GREATERTHANGREATERTHAN:
                    case T_FLWOR:
                    case T_INSTANCEOF:
                    case T_CASTAS:
                    case T_CASTABLEAS:
                    case T_TREATAS:
                    case EVERY:
                    case TYPESWITCH:
                    case VALIDATE:
                    case SOME:
                    case XPATH:
                        {
                        alt109=1;
                        }
                        break;

                    }

                    switch (alt109) {
                	case 1 :
                	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: exprSingle
                	    {
                	    _last = (CommonTree)input.LT(1);
                	    pushFollow(FOLLOW_exprSingle_in_functionCall8226);
                	    exprSingle388=exprSingle();

                	    state._fsp--;
                	    if (state.failed) return retval;
                	    if ( state.backtracking==0 ) 
                	    adaptor.addChild(root_2, exprSingle388.getTree());

                	    if ( state.backtracking==0 ) {
                	    }
                	    }
                	    break;

                	default :
                	    break loop109;
                    }
                } while (true);


                match(input, Token.UP, null); if (state.failed) return retval;
            }adaptor.addChild(root_1, root_2);_last = _save_last_2;
            }


            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "functionCall"

    public static class constructor_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "constructor"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1835:1: constructor : ( directConstructor | computedConstructor );
    public final XSPARQLRewriter.constructor_return constructor() throws RecognitionException {
        XSPARQLRewriter.constructor_return retval = new XSPARQLRewriter.constructor_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.directConstructor_return directConstructor389 = null;

        XSPARQLRewriter.computedConstructor_return computedConstructor390 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1836:3: ( directConstructor | computedConstructor )
            int alt110=2;
            switch ( input.LA(1) ) {
            case T_XML_ELEMENT:
                {
                alt110=1;
                }
                break;
            case ATTRIBUTE:
            case ELEMENT:
            case TEXT:
            case COMMENT:
            case PROCESSINGINSTRUCTION:
            case DOCUMENT:
                {
                alt110=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 110, 0, input);

                throw nvae;
            }

            switch (alt110) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1836:5: directConstructor
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_directConstructor_in_constructor8242);
                    directConstructor389=directConstructor();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, directConstructor389.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1837:5: computedConstructor
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_computedConstructor_in_constructor8248);
                    computedConstructor390=computedConstructor();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, computedConstructor390.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "constructor"

    public static class directConstructor_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "directConstructor"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1840:1: directConstructor : dirElemConstructor ;
    public final XSPARQLRewriter.directConstructor_return directConstructor() throws RecognitionException {
        XSPARQLRewriter.directConstructor_return retval = new XSPARQLRewriter.directConstructor_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.dirElemConstructor_return dirElemConstructor391 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1841:3: ( dirElemConstructor )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1841:5: dirElemConstructor
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_dirElemConstructor_in_directConstructor8261);
            dirElemConstructor391=dirElemConstructor();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, dirElemConstructor391.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "directConstructor"

    public static class dirElemConstructor_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "dirElemConstructor"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1846:1: dirElemConstructor : ^( T_XML_ELEMENT qname ( dirAttributeList )? ( ^( T_XML_CONTENT dirElemContent ) )* ) ;
    public final XSPARQLRewriter.dirElemConstructor_return dirElemConstructor() throws RecognitionException {
        XSPARQLRewriter.dirElemConstructor_return retval = new XSPARQLRewriter.dirElemConstructor_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_XML_ELEMENT392=null;
        CommonTree T_XML_CONTENT395=null;
        XSPARQLRewriter.qname_return qname393 = null;

        XSPARQLRewriter.dirAttributeList_return dirAttributeList394 = null;

        XSPARQLRewriter.dirElemContent_return dirElemContent396 = null;


        CommonTree T_XML_ELEMENT392_tree=null;
        CommonTree T_XML_CONTENT395_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1847:3: ( ^( T_XML_ELEMENT qname ( dirAttributeList )? ( ^( T_XML_CONTENT dirElemContent ) )* ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1847:5: ^( T_XML_ELEMENT qname ( dirAttributeList )? ( ^( T_XML_CONTENT dirElemContent ) )* )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_XML_ELEMENT392=(CommonTree)match(input,T_XML_ELEMENT,FOLLOW_T_XML_ELEMENT_in_dirElemConstructor8277); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_XML_ELEMENT392_tree = (CommonTree)adaptor.dupNode(T_XML_ELEMENT392);

            root_1 = (CommonTree)adaptor.becomeRoot(T_XML_ELEMENT392_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_qname_in_dirElemConstructor8279);
            qname393=qname();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, qname393.getTree());
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1847:27: ( dirAttributeList )?
            int alt111=2;
            switch ( input.LA(1) ) {
                case T_XML_ATTRIBUTE:
                    {
                    alt111=1;
                    }
                    break;
            }

            switch (alt111) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: dirAttributeList
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_dirAttributeList_in_dirElemConstructor8281);
                    dirAttributeList394=dirAttributeList();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_1, dirAttributeList394.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1847:45: ( ^( T_XML_CONTENT dirElemContent ) )*
            loop112:
            do {
                int alt112=2;
                switch ( input.LA(1) ) {
                case T_XML_CONTENT:
                    {
                    alt112=1;
                    }
                    break;

                }

                switch (alt112) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1847:46: ^( T_XML_CONTENT dirElemContent )
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    {
            	    CommonTree _save_last_2 = _last;
            	    CommonTree _first_2 = null;
            	    CommonTree root_2 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            	    T_XML_CONTENT395=(CommonTree)match(input,T_XML_CONTENT,FOLLOW_T_XML_CONTENT_in_dirElemConstructor8286); if (state.failed) return retval;
            	    if ( state.backtracking==0 ) {
            	    T_XML_CONTENT395_tree = (CommonTree)adaptor.dupNode(T_XML_CONTENT395);

            	    root_2 = (CommonTree)adaptor.becomeRoot(T_XML_CONTENT395_tree, root_2);
            	    }


            	    match(input, Token.DOWN, null); if (state.failed) return retval;
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_dirElemContent_in_dirElemConstructor8288);
            	    dirElemContent396=dirElemContent();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) 
            	    adaptor.addChild(root_2, dirElemContent396.getTree());

            	    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_1, root_2);_last = _save_last_2;
            	    }


            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    break loop112;
                }
            } while (true);


            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "dirElemConstructor"

    public static class dirAttributeList_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "dirAttributeList"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1850:1: dirAttributeList : ( dirAttribute )+ ;
    public final XSPARQLRewriter.dirAttributeList_return dirAttributeList() throws RecognitionException {
        XSPARQLRewriter.dirAttributeList_return retval = new XSPARQLRewriter.dirAttributeList_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.dirAttribute_return dirAttribute397 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1851:3: ( ( dirAttribute )+ )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1851:6: ( dirAttribute )+
            {
            root_0 = (CommonTree)adaptor.nil();

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1851:6: ( dirAttribute )+
            int cnt113=0;
            loop113:
            do {
                int alt113=2;
                switch ( input.LA(1) ) {
                case T_XML_ATTRIBUTE:
                    {
                    alt113=1;
                    }
                    break;

                }

                switch (alt113) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: dirAttribute
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_dirAttribute_in_dirAttributeList8307);
            	    dirAttribute397=dirAttribute();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) 
            	    adaptor.addChild(root_0, dirAttribute397.getTree());

            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    if ( cnt113 >= 1 ) break loop113;
            	    if (state.backtracking>0) {state.failed=true; return retval;}
                        EarlyExitException eee =
                            new EarlyExitException(113, input);
                        throw eee;
                }
                cnt113++;
            } while (true);


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "dirAttributeList"

    public static class dirAttribute_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "dirAttribute"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1854:1: dirAttribute : ^( T_XML_ATTRIBUTE qname dirAttributeValue ) ;
    public final XSPARQLRewriter.dirAttribute_return dirAttribute() throws RecognitionException {
        XSPARQLRewriter.dirAttribute_return retval = new XSPARQLRewriter.dirAttribute_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_XML_ATTRIBUTE398=null;
        XSPARQLRewriter.qname_return qname399 = null;

        XSPARQLRewriter.dirAttributeValue_return dirAttributeValue400 = null;


        CommonTree T_XML_ATTRIBUTE398_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1855:3: ( ^( T_XML_ATTRIBUTE qname dirAttributeValue ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1855:5: ^( T_XML_ATTRIBUTE qname dirAttributeValue )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_XML_ATTRIBUTE398=(CommonTree)match(input,T_XML_ATTRIBUTE,FOLLOW_T_XML_ATTRIBUTE_in_dirAttribute8322); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_XML_ATTRIBUTE398_tree = (CommonTree)adaptor.dupNode(T_XML_ATTRIBUTE398);

            root_1 = (CommonTree)adaptor.becomeRoot(T_XML_ATTRIBUTE398_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_qname_in_dirAttribute8324);
            qname399=qname();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, qname399.getTree());
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_dirAttributeValue_in_dirAttribute8326);
            dirAttributeValue400=dirAttributeValue();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, dirAttributeValue400.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "dirAttribute"

    public static class dirAttributeValue_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "dirAttributeValue"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1858:1: dirAttributeValue : ( enclosedExpr | QSTRING );
    public final XSPARQLRewriter.dirAttributeValue_return dirAttributeValue() throws RecognitionException {
        XSPARQLRewriter.dirAttributeValue_return retval = new XSPARQLRewriter.dirAttributeValue_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree QSTRING402=null;
        XSPARQLRewriter.enclosedExpr_return enclosedExpr401 = null;


        CommonTree QSTRING402_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1859:3: ( enclosedExpr | QSTRING )
            int alt114=2;
            switch ( input.LA(1) ) {
            case LCURLY:
            case STAR:
            case LESSTHAN:
            case GREATERTHAN:
            case PLUS:
            case MINUS:
            case UNIONSYMBOL:
            case LESSTHANLESSTHAN:
            case GREATERTHANEQUALS:
            case LESSTHANEQUALS:
            case HAFENEQUALS:
            case EQUALS:
            case IS:
            case EQ:
            case NE:
            case LT:
            case GE:
            case LE:
            case GT:
            case IF:
            case AND:
            case OR:
            case TO:
            case DIV:
            case IDIV:
            case MOD:
            case UNION:
            case INTERSECT:
            case EXCEPT:
            case GREATERTHANGREATERTHAN:
            case T_FLWOR:
            case T_INSTANCEOF:
            case T_CASTAS:
            case T_CASTABLEAS:
            case T_TREATAS:
            case EVERY:
            case TYPESWITCH:
            case VALIDATE:
            case SOME:
            case XPATH:
                {
                alt114=1;
                }
                break;
            case QSTRING:
                {
                alt114=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 114, 0, input);

                throw nvae;
            }

            switch (alt114) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1859:5: enclosedExpr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_enclosedExpr_in_dirAttributeValue8340);
                    enclosedExpr401=enclosedExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, enclosedExpr401.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1860:5: QSTRING
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    QSTRING402=(CommonTree)match(input,QSTRING,FOLLOW_QSTRING_in_dirAttributeValue8346); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    QSTRING402_tree = (CommonTree)adaptor.dupNode(QSTRING402);

                    adaptor.addChild(root_0, QSTRING402_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "dirAttributeValue"

    public static class dirElemContent_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "dirElemContent"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1863:1: dirElemContent : ( directConstructor | commonContent | WHITESPACE | NCNAMEELM | cDataSection );
    public final XSPARQLRewriter.dirElemContent_return dirElemContent() throws RecognitionException {
        XSPARQLRewriter.dirElemContent_return retval = new XSPARQLRewriter.dirElemContent_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree WHITESPACE405=null;
        CommonTree NCNAMEELM406=null;
        XSPARQLRewriter.directConstructor_return directConstructor403 = null;

        XSPARQLRewriter.commonContent_return commonContent404 = null;

        XSPARQLRewriter.cDataSection_return cDataSection407 = null;


        CommonTree WHITESPACE405_tree=null;
        CommonTree NCNAMEELM406_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1864:3: ( directConstructor | commonContent | WHITESPACE | NCNAMEELM | cDataSection )
            int alt115=5;
            switch ( input.LA(1) ) {
            case T_XML_ELEMENT:
                {
                alt115=1;
                }
                break;
            case LCURLY:
            case RCURLY:
                {
                alt115=2;
                }
                break;
            case WHITESPACE:
                {
                alt115=3;
                }
                break;
            case NCNAMEELM:
                {
                alt115=4;
                }
                break;
            case CDATASTART:
                {
                alt115=5;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 115, 0, input);

                throw nvae;
            }

            switch (alt115) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1864:5: directConstructor
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_directConstructor_in_dirElemContent8359);
                    directConstructor403=directConstructor();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, directConstructor403.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1865:5: commonContent
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_commonContent_in_dirElemContent8365);
                    commonContent404=commonContent();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, commonContent404.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1866:5: WHITESPACE
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    WHITESPACE405=(CommonTree)match(input,WHITESPACE,FOLLOW_WHITESPACE_in_dirElemContent8371); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    WHITESPACE405_tree = (CommonTree)adaptor.dupNode(WHITESPACE405);

                    adaptor.addChild(root_0, WHITESPACE405_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1867:5: NCNAMEELM
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    NCNAMEELM406=(CommonTree)match(input,NCNAMEELM,FOLLOW_NCNAMEELM_in_dirElemContent8378); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    NCNAMEELM406_tree = (CommonTree)adaptor.dupNode(NCNAMEELM406);

                    adaptor.addChild(root_0, NCNAMEELM406_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 5 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1868:5: cDataSection
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_cDataSection_in_dirElemContent8385);
                    cDataSection407=cDataSection();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, cDataSection407.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "dirElemContent"

    public static class commonContent_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "commonContent"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1871:1: commonContent : ( LCURLY expr RCURLY -> ^( T_XML_CONTENTS expr ) | LCURLY LCURLY | RCURLY RCURLY );
    public final XSPARQLRewriter.commonContent_return commonContent() throws RecognitionException {
        XSPARQLRewriter.commonContent_return retval = new XSPARQLRewriter.commonContent_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree LCURLY408=null;
        CommonTree RCURLY410=null;
        CommonTree LCURLY411=null;
        CommonTree LCURLY412=null;
        CommonTree RCURLY413=null;
        CommonTree RCURLY414=null;
        XSPARQLRewriter.expr_return expr409 = null;


        CommonTree LCURLY408_tree=null;
        CommonTree RCURLY410_tree=null;
        CommonTree LCURLY411_tree=null;
        CommonTree LCURLY412_tree=null;
        CommonTree RCURLY413_tree=null;
        CommonTree RCURLY414_tree=null;
        RewriteRuleNodeStream stream_LCURLY=new RewriteRuleNodeStream(adaptor,"token LCURLY");
        RewriteRuleNodeStream stream_RCURLY=new RewriteRuleNodeStream(adaptor,"token RCURLY");
        RewriteRuleSubtreeStream stream_expr=new RewriteRuleSubtreeStream(adaptor,"rule expr");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1872:3: ( LCURLY expr RCURLY -> ^( T_XML_CONTENTS expr ) | LCURLY LCURLY | RCURLY RCURLY )
            int alt116=3;
            switch ( input.LA(1) ) {
            case LCURLY:
                {
                switch ( input.LA(2) ) {
                case LCURLY:
                    {
                    switch ( input.LA(3) ) {
                    case LCURLY:
                    case RCURLY:
                    case STAR:
                    case LESSTHAN:
                    case GREATERTHAN:
                    case PLUS:
                    case MINUS:
                    case UNIONSYMBOL:
                    case LESSTHANLESSTHAN:
                    case GREATERTHANEQUALS:
                    case LESSTHANEQUALS:
                    case HAFENEQUALS:
                    case EQUALS:
                    case IS:
                    case EQ:
                    case NE:
                    case LT:
                    case GE:
                    case LE:
                    case GT:
                    case IF:
                    case AND:
                    case OR:
                    case TO:
                    case DIV:
                    case IDIV:
                    case MOD:
                    case UNION:
                    case INTERSECT:
                    case EXCEPT:
                    case GREATERTHANGREATERTHAN:
                    case T_FLWOR:
                    case T_INSTANCEOF:
                    case T_CASTAS:
                    case T_CASTABLEAS:
                    case T_TREATAS:
                    case EVERY:
                    case TYPESWITCH:
                    case VALIDATE:
                    case SOME:
                    case XPATH:
                        {
                        alt116=1;
                        }
                        break;
                    case EOF:
                    case UP:
                        {
                        alt116=2;
                        }
                        break;
                    default:
                        if (state.backtracking>0) {state.failed=true; return retval;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 116, 3, input);

                        throw nvae;
                    }

                    }
                    break;
                case STAR:
                case LESSTHAN:
                case GREATERTHAN:
                case PLUS:
                case MINUS:
                case UNIONSYMBOL:
                case LESSTHANLESSTHAN:
                case GREATERTHANEQUALS:
                case LESSTHANEQUALS:
                case HAFENEQUALS:
                case EQUALS:
                case IS:
                case EQ:
                case NE:
                case LT:
                case GE:
                case LE:
                case GT:
                case IF:
                case AND:
                case OR:
                case TO:
                case DIV:
                case IDIV:
                case MOD:
                case UNION:
                case INTERSECT:
                case EXCEPT:
                case GREATERTHANGREATERTHAN:
                case T_FLWOR:
                case T_INSTANCEOF:
                case T_CASTAS:
                case T_CASTABLEAS:
                case T_TREATAS:
                case EVERY:
                case TYPESWITCH:
                case VALIDATE:
                case SOME:
                case XPATH:
                    {
                    alt116=1;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 116, 1, input);

                    throw nvae;
                }

                }
                break;
            case RCURLY:
                {
                alt116=3;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 116, 0, input);

                throw nvae;
            }

            switch (alt116) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1872:5: LCURLY expr RCURLY
                    {
                    _last = (CommonTree)input.LT(1);
                    LCURLY408=(CommonTree)match(input,LCURLY,FOLLOW_LCURLY_in_commonContent8398); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_LCURLY.add(LCURLY408);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_expr_in_commonContent8400);
                    expr409=expr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_expr.add(expr409.getTree());
                    _last = (CommonTree)input.LT(1);
                    RCURLY410=(CommonTree)match(input,RCURLY,FOLLOW_RCURLY_in_commonContent8402); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_RCURLY.add(RCURLY410);



                    // AST REWRITE
                    // elements: expr
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 1872:24: -> ^( T_XML_CONTENTS expr )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1872:27: ^( T_XML_CONTENTS expr )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_XML_CONTENTS, "T_XML_CONTENTS"), root_1);

                        adaptor.addChild(root_1, stream_expr.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1873:5: LCURLY LCURLY
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    LCURLY411=(CommonTree)match(input,LCURLY,FOLLOW_LCURLY_in_commonContent8416); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    LCURLY411_tree = (CommonTree)adaptor.dupNode(LCURLY411);

                    adaptor.addChild(root_0, LCURLY411_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    LCURLY412=(CommonTree)match(input,LCURLY,FOLLOW_LCURLY_in_commonContent8418); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    LCURLY412_tree = (CommonTree)adaptor.dupNode(LCURLY412);

                    adaptor.addChild(root_0, LCURLY412_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1874:5: RCURLY RCURLY
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    RCURLY413=(CommonTree)match(input,RCURLY,FOLLOW_RCURLY_in_commonContent8424); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    RCURLY413_tree = (CommonTree)adaptor.dupNode(RCURLY413);

                    adaptor.addChild(root_0, RCURLY413_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    RCURLY414=(CommonTree)match(input,RCURLY,FOLLOW_RCURLY_in_commonContent8426); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    RCURLY414_tree = (CommonTree)adaptor.dupNode(RCURLY414);

                    adaptor.addChild(root_0, RCURLY414_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "commonContent"

    public static class cDataSection_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "cDataSection"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1877:1: cDataSection : CDATASTART CDATAELMEND ;
    public final XSPARQLRewriter.cDataSection_return cDataSection() throws RecognitionException {
        XSPARQLRewriter.cDataSection_return retval = new XSPARQLRewriter.cDataSection_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree CDATASTART415=null;
        CommonTree CDATAELMEND416=null;

        CommonTree CDATASTART415_tree=null;
        CommonTree CDATAELMEND416_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1878:3: ( CDATASTART CDATAELMEND )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1878:5: CDATASTART CDATAELMEND
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            CDATASTART415=(CommonTree)match(input,CDATASTART,FOLLOW_CDATASTART_in_cDataSection8439); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            CDATASTART415_tree = (CommonTree)adaptor.dupNode(CDATASTART415);

            adaptor.addChild(root_0, CDATASTART415_tree);
            }
            _last = (CommonTree)input.LT(1);
            CDATAELMEND416=(CommonTree)match(input,CDATAELMEND,FOLLOW_CDATAELMEND_in_cDataSection8441); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            CDATAELMEND416_tree = (CommonTree)adaptor.dupNode(CDATAELMEND416);

            adaptor.addChild(root_0, CDATAELMEND416_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "cDataSection"

    public static class computedConstructor_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "computedConstructor"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1881:1: computedConstructor : ( compDocConstructor | compElemConstructor | compAttrConstructor | compTextConstructor | compCommentConstructor | compPIConstructor );
    public final XSPARQLRewriter.computedConstructor_return computedConstructor() throws RecognitionException {
        XSPARQLRewriter.computedConstructor_return retval = new XSPARQLRewriter.computedConstructor_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.compDocConstructor_return compDocConstructor417 = null;

        XSPARQLRewriter.compElemConstructor_return compElemConstructor418 = null;

        XSPARQLRewriter.compAttrConstructor_return compAttrConstructor419 = null;

        XSPARQLRewriter.compTextConstructor_return compTextConstructor420 = null;

        XSPARQLRewriter.compCommentConstructor_return compCommentConstructor421 = null;

        XSPARQLRewriter.compPIConstructor_return compPIConstructor422 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1882:3: ( compDocConstructor | compElemConstructor | compAttrConstructor | compTextConstructor | compCommentConstructor | compPIConstructor )
            int alt117=6;
            switch ( input.LA(1) ) {
            case DOCUMENT:
                {
                alt117=1;
                }
                break;
            case ELEMENT:
                {
                alt117=2;
                }
                break;
            case ATTRIBUTE:
                {
                alt117=3;
                }
                break;
            case TEXT:
                {
                alt117=4;
                }
                break;
            case COMMENT:
                {
                alt117=5;
                }
                break;
            case PROCESSINGINSTRUCTION:
                {
                alt117=6;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 117, 0, input);

                throw nvae;
            }

            switch (alt117) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1882:5: compDocConstructor
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_compDocConstructor_in_computedConstructor8454);
                    compDocConstructor417=compDocConstructor();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, compDocConstructor417.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1883:5: compElemConstructor
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_compElemConstructor_in_computedConstructor8460);
                    compElemConstructor418=compElemConstructor();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, compElemConstructor418.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1884:5: compAttrConstructor
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_compAttrConstructor_in_computedConstructor8466);
                    compAttrConstructor419=compAttrConstructor();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, compAttrConstructor419.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1885:5: compTextConstructor
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_compTextConstructor_in_computedConstructor8472);
                    compTextConstructor420=compTextConstructor();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, compTextConstructor420.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 5 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1886:5: compCommentConstructor
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_compCommentConstructor_in_computedConstructor8478);
                    compCommentConstructor421=compCommentConstructor();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, compCommentConstructor421.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 6 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1887:5: compPIConstructor
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_compPIConstructor_in_computedConstructor8484);
                    compPIConstructor422=compPIConstructor();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, compPIConstructor422.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "computedConstructor"

    public static class compDocConstructor_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "compDocConstructor"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1890:1: compDocConstructor : DOCUMENT enclosedExpr ;
    public final XSPARQLRewriter.compDocConstructor_return compDocConstructor() throws RecognitionException {
        XSPARQLRewriter.compDocConstructor_return retval = new XSPARQLRewriter.compDocConstructor_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree DOCUMENT423=null;
        XSPARQLRewriter.enclosedExpr_return enclosedExpr424 = null;


        CommonTree DOCUMENT423_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1891:3: ( DOCUMENT enclosedExpr )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1891:5: DOCUMENT enclosedExpr
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            DOCUMENT423=(CommonTree)match(input,DOCUMENT,FOLLOW_DOCUMENT_in_compDocConstructor8497); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            DOCUMENT423_tree = (CommonTree)adaptor.dupNode(DOCUMENT423);

            adaptor.addChild(root_0, DOCUMENT423_tree);
            }
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_enclosedExpr_in_compDocConstructor8499);
            enclosedExpr424=enclosedExpr();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, enclosedExpr424.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "compDocConstructor"

    public static class compElemConstructor_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "compElemConstructor"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1894:1: compElemConstructor : ELEMENT ( qname | enclosedExpr_ ) LCURLY ( contentExpr )? RCURLY ;
    public final XSPARQLRewriter.compElemConstructor_return compElemConstructor() throws RecognitionException {
        XSPARQLRewriter.compElemConstructor_return retval = new XSPARQLRewriter.compElemConstructor_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree ELEMENT425=null;
        CommonTree LCURLY428=null;
        CommonTree RCURLY430=null;
        XSPARQLRewriter.qname_return qname426 = null;

        XSPARQLRewriter.enclosedExpr__return enclosedExpr_427 = null;

        XSPARQLRewriter.contentExpr_return contentExpr429 = null;


        CommonTree ELEMENT425_tree=null;
        CommonTree LCURLY428_tree=null;
        CommonTree RCURLY430_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1895:3: ( ELEMENT ( qname | enclosedExpr_ ) LCURLY ( contentExpr )? RCURLY )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1895:5: ELEMENT ( qname | enclosedExpr_ ) LCURLY ( contentExpr )? RCURLY
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            ELEMENT425=(CommonTree)match(input,ELEMENT,FOLLOW_ELEMENT_in_compElemConstructor8512); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            ELEMENT425_tree = (CommonTree)adaptor.dupNode(ELEMENT425);

            adaptor.addChild(root_0, ELEMENT425_tree);
            }
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1895:13: ( qname | enclosedExpr_ )
            int alt118=2;
            switch ( input.LA(1) ) {
            case NCNAME:
            case PNAME_NS:
            case PNAME_LN:
            case A:
            case FROM:
            case TO:
            case ITEM:
            case COMMENT:
            case ROW:
                {
                alt118=1;
                }
                break;
            case LCURLY:
                {
                alt118=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 118, 0, input);

                throw nvae;
            }

            switch (alt118) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1895:15: qname
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_qname_in_compElemConstructor8516);
                    qname426=qname();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, qname426.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1895:23: enclosedExpr_
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_enclosedExpr__in_compElemConstructor8520);
                    enclosedExpr_427=enclosedExpr_();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, enclosedExpr_427.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            _last = (CommonTree)input.LT(1);
            LCURLY428=(CommonTree)match(input,LCURLY,FOLLOW_LCURLY_in_compElemConstructor8523); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            LCURLY428_tree = (CommonTree)adaptor.dupNode(LCURLY428);

            adaptor.addChild(root_0, LCURLY428_tree);
            }
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1895:45: ( contentExpr )?
            int alt119=2;
            switch ( input.LA(1) ) {
                case LCURLY:
                case STAR:
                case LESSTHAN:
                case GREATERTHAN:
                case PLUS:
                case MINUS:
                case UNIONSYMBOL:
                case LESSTHANLESSTHAN:
                case GREATERTHANEQUALS:
                case LESSTHANEQUALS:
                case HAFENEQUALS:
                case EQUALS:
                case IS:
                case EQ:
                case NE:
                case LT:
                case GE:
                case LE:
                case GT:
                case IF:
                case AND:
                case OR:
                case TO:
                case DIV:
                case IDIV:
                case MOD:
                case UNION:
                case INTERSECT:
                case EXCEPT:
                case GREATERTHANGREATERTHAN:
                case T_FLWOR:
                case T_INSTANCEOF:
                case T_CASTAS:
                case T_CASTABLEAS:
                case T_TREATAS:
                case EVERY:
                case TYPESWITCH:
                case VALIDATE:
                case SOME:
                case XPATH:
                    {
                    alt119=1;
                    }
                    break;
            }

            switch (alt119) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: contentExpr
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_contentExpr_in_compElemConstructor8525);
                    contentExpr429=contentExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, contentExpr429.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            _last = (CommonTree)input.LT(1);
            RCURLY430=(CommonTree)match(input,RCURLY,FOLLOW_RCURLY_in_compElemConstructor8528); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            RCURLY430_tree = (CommonTree)adaptor.dupNode(RCURLY430);

            adaptor.addChild(root_0, RCURLY430_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "compElemConstructor"

    public static class contentExpr_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "contentExpr"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1898:1: contentExpr : expr ;
    public final XSPARQLRewriter.contentExpr_return contentExpr() throws RecognitionException {
        XSPARQLRewriter.contentExpr_return retval = new XSPARQLRewriter.contentExpr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.expr_return expr431 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1899:3: ( expr )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1899:5: expr
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_expr_in_contentExpr8541);
            expr431=expr();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, expr431.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "contentExpr"

    public static class compAttrConstructor_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "compAttrConstructor"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1902:1: compAttrConstructor : ATTRIBUTE ( qname | enclosedExpr ) LCURLY ( expr )? RCURLY ;
    public final XSPARQLRewriter.compAttrConstructor_return compAttrConstructor() throws RecognitionException {
        XSPARQLRewriter.compAttrConstructor_return retval = new XSPARQLRewriter.compAttrConstructor_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree ATTRIBUTE432=null;
        CommonTree LCURLY435=null;
        CommonTree RCURLY437=null;
        XSPARQLRewriter.qname_return qname433 = null;

        XSPARQLRewriter.enclosedExpr_return enclosedExpr434 = null;

        XSPARQLRewriter.expr_return expr436 = null;


        CommonTree ATTRIBUTE432_tree=null;
        CommonTree LCURLY435_tree=null;
        CommonTree RCURLY437_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1903:3: ( ATTRIBUTE ( qname | enclosedExpr ) LCURLY ( expr )? RCURLY )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1903:5: ATTRIBUTE ( qname | enclosedExpr ) LCURLY ( expr )? RCURLY
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            ATTRIBUTE432=(CommonTree)match(input,ATTRIBUTE,FOLLOW_ATTRIBUTE_in_compAttrConstructor8554); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            ATTRIBUTE432_tree = (CommonTree)adaptor.dupNode(ATTRIBUTE432);

            adaptor.addChild(root_0, ATTRIBUTE432_tree);
            }
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1903:15: ( qname | enclosedExpr )
            int alt120=2;
            switch ( input.LA(1) ) {
            case NCNAME:
            case PNAME_NS:
            case PNAME_LN:
            case A:
            case FROM:
            case ITEM:
            case COMMENT:
            case ROW:
                {
                alt120=1;
                }
                break;
            case TO:
                {
                switch ( input.LA(2) ) {
                case DOWN:
                    {
                    alt120=2;
                    }
                    break;
                case LCURLY:
                    {
                    alt120=1;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 120, 2, input);

                    throw nvae;
                }

                }
                break;
            case LCURLY:
            case STAR:
            case LESSTHAN:
            case GREATERTHAN:
            case PLUS:
            case MINUS:
            case UNIONSYMBOL:
            case LESSTHANLESSTHAN:
            case GREATERTHANEQUALS:
            case LESSTHANEQUALS:
            case HAFENEQUALS:
            case EQUALS:
            case IS:
            case EQ:
            case NE:
            case LT:
            case GE:
            case LE:
            case GT:
            case IF:
            case AND:
            case OR:
            case DIV:
            case IDIV:
            case MOD:
            case UNION:
            case INTERSECT:
            case EXCEPT:
            case GREATERTHANGREATERTHAN:
            case T_FLWOR:
            case T_INSTANCEOF:
            case T_CASTAS:
            case T_CASTABLEAS:
            case T_TREATAS:
            case EVERY:
            case TYPESWITCH:
            case VALIDATE:
            case SOME:
            case XPATH:
                {
                alt120=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 120, 0, input);

                throw nvae;
            }

            switch (alt120) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1903:16: qname
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_qname_in_compAttrConstructor8557);
                    qname433=qname();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, qname433.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1903:24: enclosedExpr
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_enclosedExpr_in_compAttrConstructor8561);
                    enclosedExpr434=enclosedExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, enclosedExpr434.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            _last = (CommonTree)input.LT(1);
            LCURLY435=(CommonTree)match(input,LCURLY,FOLLOW_LCURLY_in_compAttrConstructor8564); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            LCURLY435_tree = (CommonTree)adaptor.dupNode(LCURLY435);

            adaptor.addChild(root_0, LCURLY435_tree);
            }
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1903:45: ( expr )?
            int alt121=2;
            switch ( input.LA(1) ) {
                case LCURLY:
                case STAR:
                case LESSTHAN:
                case GREATERTHAN:
                case PLUS:
                case MINUS:
                case UNIONSYMBOL:
                case LESSTHANLESSTHAN:
                case GREATERTHANEQUALS:
                case LESSTHANEQUALS:
                case HAFENEQUALS:
                case EQUALS:
                case IS:
                case EQ:
                case NE:
                case LT:
                case GE:
                case LE:
                case GT:
                case IF:
                case AND:
                case OR:
                case TO:
                case DIV:
                case IDIV:
                case MOD:
                case UNION:
                case INTERSECT:
                case EXCEPT:
                case GREATERTHANGREATERTHAN:
                case T_FLWOR:
                case T_INSTANCEOF:
                case T_CASTAS:
                case T_CASTABLEAS:
                case T_TREATAS:
                case EVERY:
                case TYPESWITCH:
                case VALIDATE:
                case SOME:
                case XPATH:
                    {
                    alt121=1;
                    }
                    break;
            }

            switch (alt121) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: expr
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_expr_in_compAttrConstructor8566);
                    expr436=expr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, expr436.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            _last = (CommonTree)input.LT(1);
            RCURLY437=(CommonTree)match(input,RCURLY,FOLLOW_RCURLY_in_compAttrConstructor8569); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            RCURLY437_tree = (CommonTree)adaptor.dupNode(RCURLY437);

            adaptor.addChild(root_0, RCURLY437_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "compAttrConstructor"

    public static class compTextConstructor_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "compTextConstructor"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1906:1: compTextConstructor : TEXT enclosedExpr_ ;
    public final XSPARQLRewriter.compTextConstructor_return compTextConstructor() throws RecognitionException {
        XSPARQLRewriter.compTextConstructor_return retval = new XSPARQLRewriter.compTextConstructor_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree TEXT438=null;
        XSPARQLRewriter.enclosedExpr__return enclosedExpr_439 = null;


        CommonTree TEXT438_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1907:3: ( TEXT enclosedExpr_ )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1907:5: TEXT enclosedExpr_
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            TEXT438=(CommonTree)match(input,TEXT,FOLLOW_TEXT_in_compTextConstructor8582); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            TEXT438_tree = (CommonTree)adaptor.dupNode(TEXT438);

            adaptor.addChild(root_0, TEXT438_tree);
            }
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_enclosedExpr__in_compTextConstructor8584);
            enclosedExpr_439=enclosedExpr_();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, enclosedExpr_439.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "compTextConstructor"

    public static class compCommentConstructor_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "compCommentConstructor"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1910:1: compCommentConstructor : COMMENT enclosedExpr ;
    public final XSPARQLRewriter.compCommentConstructor_return compCommentConstructor() throws RecognitionException {
        XSPARQLRewriter.compCommentConstructor_return retval = new XSPARQLRewriter.compCommentConstructor_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree COMMENT440=null;
        XSPARQLRewriter.enclosedExpr_return enclosedExpr441 = null;


        CommonTree COMMENT440_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1911:3: ( COMMENT enclosedExpr )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1911:5: COMMENT enclosedExpr
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            COMMENT440=(CommonTree)match(input,COMMENT,FOLLOW_COMMENT_in_compCommentConstructor8597); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            COMMENT440_tree = (CommonTree)adaptor.dupNode(COMMENT440);

            adaptor.addChild(root_0, COMMENT440_tree);
            }
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_enclosedExpr_in_compCommentConstructor8599);
            enclosedExpr441=enclosedExpr();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, enclosedExpr441.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "compCommentConstructor"

    public static class compPIConstructor_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "compPIConstructor"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1914:1: compPIConstructor : PROCESSINGINSTRUCTION ( NCNAME | enclosedExpr ) LCURLY ( expr )? RCURLY ;
    public final XSPARQLRewriter.compPIConstructor_return compPIConstructor() throws RecognitionException {
        XSPARQLRewriter.compPIConstructor_return retval = new XSPARQLRewriter.compPIConstructor_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree PROCESSINGINSTRUCTION442=null;
        CommonTree NCNAME443=null;
        CommonTree LCURLY445=null;
        CommonTree RCURLY447=null;
        XSPARQLRewriter.enclosedExpr_return enclosedExpr444 = null;

        XSPARQLRewriter.expr_return expr446 = null;


        CommonTree PROCESSINGINSTRUCTION442_tree=null;
        CommonTree NCNAME443_tree=null;
        CommonTree LCURLY445_tree=null;
        CommonTree RCURLY447_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1915:3: ( PROCESSINGINSTRUCTION ( NCNAME | enclosedExpr ) LCURLY ( expr )? RCURLY )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1915:5: PROCESSINGINSTRUCTION ( NCNAME | enclosedExpr ) LCURLY ( expr )? RCURLY
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            PROCESSINGINSTRUCTION442=(CommonTree)match(input,PROCESSINGINSTRUCTION,FOLLOW_PROCESSINGINSTRUCTION_in_compPIConstructor8612); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            PROCESSINGINSTRUCTION442_tree = (CommonTree)adaptor.dupNode(PROCESSINGINSTRUCTION442);

            adaptor.addChild(root_0, PROCESSINGINSTRUCTION442_tree);
            }
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1915:27: ( NCNAME | enclosedExpr )
            int alt122=2;
            switch ( input.LA(1) ) {
            case NCNAME:
                {
                alt122=1;
                }
                break;
            case LCURLY:
            case STAR:
            case LESSTHAN:
            case GREATERTHAN:
            case PLUS:
            case MINUS:
            case UNIONSYMBOL:
            case LESSTHANLESSTHAN:
            case GREATERTHANEQUALS:
            case LESSTHANEQUALS:
            case HAFENEQUALS:
            case EQUALS:
            case IS:
            case EQ:
            case NE:
            case LT:
            case GE:
            case LE:
            case GT:
            case IF:
            case AND:
            case OR:
            case TO:
            case DIV:
            case IDIV:
            case MOD:
            case UNION:
            case INTERSECT:
            case EXCEPT:
            case GREATERTHANGREATERTHAN:
            case T_FLWOR:
            case T_INSTANCEOF:
            case T_CASTAS:
            case T_CASTABLEAS:
            case T_TREATAS:
            case EVERY:
            case TYPESWITCH:
            case VALIDATE:
            case SOME:
            case XPATH:
                {
                alt122=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 122, 0, input);

                throw nvae;
            }

            switch (alt122) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1915:29: NCNAME
                    {
                    _last = (CommonTree)input.LT(1);
                    NCNAME443=(CommonTree)match(input,NCNAME,FOLLOW_NCNAME_in_compPIConstructor8616); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    NCNAME443_tree = (CommonTree)adaptor.dupNode(NCNAME443);

                    adaptor.addChild(root_0, NCNAME443_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1915:38: enclosedExpr
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_enclosedExpr_in_compPIConstructor8620);
                    enclosedExpr444=enclosedExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, enclosedExpr444.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            _last = (CommonTree)input.LT(1);
            LCURLY445=(CommonTree)match(input,LCURLY,FOLLOW_LCURLY_in_compPIConstructor8623); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            LCURLY445_tree = (CommonTree)adaptor.dupNode(LCURLY445);

            adaptor.addChild(root_0, LCURLY445_tree);
            }
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1915:59: ( expr )?
            int alt123=2;
            switch ( input.LA(1) ) {
                case LCURLY:
                case STAR:
                case LESSTHAN:
                case GREATERTHAN:
                case PLUS:
                case MINUS:
                case UNIONSYMBOL:
                case LESSTHANLESSTHAN:
                case GREATERTHANEQUALS:
                case LESSTHANEQUALS:
                case HAFENEQUALS:
                case EQUALS:
                case IS:
                case EQ:
                case NE:
                case LT:
                case GE:
                case LE:
                case GT:
                case IF:
                case AND:
                case OR:
                case TO:
                case DIV:
                case IDIV:
                case MOD:
                case UNION:
                case INTERSECT:
                case EXCEPT:
                case GREATERTHANGREATERTHAN:
                case T_FLWOR:
                case T_INSTANCEOF:
                case T_CASTAS:
                case T_CASTABLEAS:
                case T_TREATAS:
                case EVERY:
                case TYPESWITCH:
                case VALIDATE:
                case SOME:
                case XPATH:
                    {
                    alt123=1;
                    }
                    break;
            }

            switch (alt123) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: expr
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_expr_in_compPIConstructor8625);
                    expr446=expr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, expr446.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            _last = (CommonTree)input.LT(1);
            RCURLY447=(CommonTree)match(input,RCURLY,FOLLOW_RCURLY_in_compPIConstructor8628); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            RCURLY447_tree = (CommonTree)adaptor.dupNode(RCURLY447);

            adaptor.addChild(root_0, RCURLY447_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "compPIConstructor"

    public static class singleType_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "singleType"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1918:1: singleType : atomicType ( QUESTIONMARK )? ;
    public final XSPARQLRewriter.singleType_return singleType() throws RecognitionException {
        XSPARQLRewriter.singleType_return retval = new XSPARQLRewriter.singleType_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree QUESTIONMARK449=null;
        XSPARQLRewriter.atomicType_return atomicType448 = null;


        CommonTree QUESTIONMARK449_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1919:3: ( atomicType ( QUESTIONMARK )? )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1919:5: atomicType ( QUESTIONMARK )?
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_atomicType_in_singleType8641);
            atomicType448=atomicType();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, atomicType448.getTree());
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1919:16: ( QUESTIONMARK )?
            int alt124=2;
            switch ( input.LA(1) ) {
                case QUESTIONMARK:
                    {
                    alt124=1;
                    }
                    break;
            }

            switch (alt124) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: QUESTIONMARK
                    {
                    _last = (CommonTree)input.LT(1);
                    QUESTIONMARK449=(CommonTree)match(input,QUESTIONMARK,FOLLOW_QUESTIONMARK_in_singleType8643); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    QUESTIONMARK449_tree = (CommonTree)adaptor.dupNode(QUESTIONMARK449);

                    adaptor.addChild(root_0, QUESTIONMARK449_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "singleType"

    public static class typeDeclaration_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "typeDeclaration"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1922:1: typeDeclaration : sequenceType ;
    public final XSPARQLRewriter.typeDeclaration_return typeDeclaration() throws RecognitionException {
        XSPARQLRewriter.typeDeclaration_return retval = new XSPARQLRewriter.typeDeclaration_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.sequenceType_return sequenceType450 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1923:3: ( sequenceType )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1923:5: sequenceType
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_sequenceType_in_typeDeclaration8657);
            sequenceType450=sequenceType();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, sequenceType450.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "typeDeclaration"

    public static class sequenceType_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "sequenceType"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1926:1: sequenceType : ( EMPTYSEQUENCE LPAR RPAR | itemType ( occurrenceIndicator )? );
    public final XSPARQLRewriter.sequenceType_return sequenceType() throws RecognitionException {
        XSPARQLRewriter.sequenceType_return retval = new XSPARQLRewriter.sequenceType_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree EMPTYSEQUENCE451=null;
        CommonTree LPAR452=null;
        CommonTree RPAR453=null;
        XSPARQLRewriter.itemType_return itemType454 = null;

        XSPARQLRewriter.occurrenceIndicator_return occurrenceIndicator455 = null;


        CommonTree EMPTYSEQUENCE451_tree=null;
        CommonTree LPAR452_tree=null;
        CommonTree RPAR453_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1927:3: ( EMPTYSEQUENCE LPAR RPAR | itemType ( occurrenceIndicator )? )
            int alt126=2;
            switch ( input.LA(1) ) {
            case EMPTYSEQUENCE:
                {
                alt126=1;
                }
                break;
            case NCNAME:
            case PNAME_NS:
            case PNAME_LN:
            case A:
            case FROM:
            case ATTRIBUTE:
            case ELEMENT:
            case TO:
            case ITEM:
            case NODE:
            case DOCUMENTNODE:
            case TEXT:
            case COMMENT:
            case PROCESSINGINSTRUCTION:
            case SCHEMAATTRIBUTE:
            case SCHEMAELEMENT:
            case ROW:
                {
                alt126=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 126, 0, input);

                throw nvae;
            }

            switch (alt126) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1927:5: EMPTYSEQUENCE LPAR RPAR
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    EMPTYSEQUENCE451=(CommonTree)match(input,EMPTYSEQUENCE,FOLLOW_EMPTYSEQUENCE_in_sequenceType8670); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    EMPTYSEQUENCE451_tree = (CommonTree)adaptor.dupNode(EMPTYSEQUENCE451);

                    adaptor.addChild(root_0, EMPTYSEQUENCE451_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    LPAR452=(CommonTree)match(input,LPAR,FOLLOW_LPAR_in_sequenceType8672); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    LPAR452_tree = (CommonTree)adaptor.dupNode(LPAR452);

                    adaptor.addChild(root_0, LPAR452_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    RPAR453=(CommonTree)match(input,RPAR,FOLLOW_RPAR_in_sequenceType8674); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    RPAR453_tree = (CommonTree)adaptor.dupNode(RPAR453);

                    adaptor.addChild(root_0, RPAR453_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1928:5: itemType ( occurrenceIndicator )?
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_itemType_in_sequenceType8680);
                    itemType454=itemType();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, itemType454.getTree());
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1928:14: ( occurrenceIndicator )?
                    int alt125=2;
                    switch ( input.LA(1) ) {
                        case STAR:
                        case PLUS:
                        case QUESTIONMARK:
                            {
                            alt125=1;
                            }
                            break;
                    }

                    switch (alt125) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: occurrenceIndicator
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_occurrenceIndicator_in_sequenceType8682);
                            occurrenceIndicator455=occurrenceIndicator();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) 
                            adaptor.addChild(root_0, occurrenceIndicator455.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "sequenceType"

    public static class occurrenceIndicator_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "occurrenceIndicator"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1931:1: occurrenceIndicator : ( QUESTIONMARK | STAR | PLUS );
    public final XSPARQLRewriter.occurrenceIndicator_return occurrenceIndicator() throws RecognitionException {
        XSPARQLRewriter.occurrenceIndicator_return retval = new XSPARQLRewriter.occurrenceIndicator_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree set456=null;

        CommonTree set456_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1932:3: ( QUESTIONMARK | STAR | PLUS )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            set456=(CommonTree)input.LT(1);
            if ( input.LA(1)==STAR||input.LA(1)==PLUS||input.LA(1)==QUESTIONMARK ) {
                input.consume();

                if ( state.backtracking==0 ) {
                set456_tree = (CommonTree)adaptor.dupNode(set456);

                adaptor.addChild(root_0, set456_tree);
                }
                state.errorRecovery=false;state.failed=false;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }

            if ( state.backtracking==0 ) {
            } 

            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "occurrenceIndicator"

    public static class itemType_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "itemType"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1935:1: itemType : ( ITEM LPAR RPAR | atomicType | kindTest );
    public final XSPARQLRewriter.itemType_return itemType() throws RecognitionException {
        XSPARQLRewriter.itemType_return retval = new XSPARQLRewriter.itemType_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree ITEM457=null;
        CommonTree LPAR458=null;
        CommonTree RPAR459=null;
        XSPARQLRewriter.atomicType_return atomicType460 = null;

        XSPARQLRewriter.kindTest_return kindTest461 = null;


        CommonTree ITEM457_tree=null;
        CommonTree LPAR458_tree=null;
        CommonTree RPAR459_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1936:3: ( ITEM LPAR RPAR | atomicType | kindTest )
            int alt127=3;
            switch ( input.LA(1) ) {
            case ITEM:
                {
                switch ( input.LA(2) ) {
                case LPAR:
                    {
                    alt127=1;
                    }
                    break;
                case EOF:
                case UP:
                case STAR:
                case PLUS:
                case QUESTIONMARK:
                case RETURN:
                    {
                    alt127=2;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 127, 1, input);

                    throw nvae;
                }

                }
                break;
            case NCNAME:
            case PNAME_NS:
            case PNAME_LN:
            case A:
            case FROM:
            case TO:
            case ROW:
                {
                alt127=2;
                }
                break;
            case COMMENT:
                {
                switch ( input.LA(2) ) {
                case LPAR:
                    {
                    alt127=3;
                    }
                    break;
                case EOF:
                case UP:
                case STAR:
                case PLUS:
                case QUESTIONMARK:
                case RETURN:
                    {
                    alt127=2;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 127, 3, input);

                    throw nvae;
                }

                }
                break;
            case ATTRIBUTE:
            case ELEMENT:
            case NODE:
            case DOCUMENTNODE:
            case TEXT:
            case PROCESSINGINSTRUCTION:
            case SCHEMAATTRIBUTE:
            case SCHEMAELEMENT:
                {
                alt127=3;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 127, 0, input);

                throw nvae;
            }

            switch (alt127) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1936:5: ITEM LPAR RPAR
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    ITEM457=(CommonTree)match(input,ITEM,FOLLOW_ITEM_in_itemType8717); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    ITEM457_tree = (CommonTree)adaptor.dupNode(ITEM457);

                    adaptor.addChild(root_0, ITEM457_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    LPAR458=(CommonTree)match(input,LPAR,FOLLOW_LPAR_in_itemType8719); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    LPAR458_tree = (CommonTree)adaptor.dupNode(LPAR458);

                    adaptor.addChild(root_0, LPAR458_tree);
                    }
                    _last = (CommonTree)input.LT(1);
                    RPAR459=(CommonTree)match(input,RPAR,FOLLOW_RPAR_in_itemType8721); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    RPAR459_tree = (CommonTree)adaptor.dupNode(RPAR459);

                    adaptor.addChild(root_0, RPAR459_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1937:5: atomicType
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_atomicType_in_itemType8727);
                    atomicType460=atomicType();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, atomicType460.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1938:5: kindTest
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_kindTest_in_itemType8733);
                    kindTest461=kindTest();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, kindTest461.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "itemType"

    public static class atomicType_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "atomicType"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1941:1: atomicType : qname ;
    public final XSPARQLRewriter.atomicType_return atomicType() throws RecognitionException {
        XSPARQLRewriter.atomicType_return retval = new XSPARQLRewriter.atomicType_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.qname_return qname462 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1942:3: ( qname )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1942:5: qname
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_qname_in_atomicType8746);
            qname462=qname();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, qname462.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "atomicType"

    public static class kindTest_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "kindTest"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1945:1: kindTest : ( documentTest | elementTest | attributeTest | schemaElementTest | schemaAttributeTest | piTest | commentTest | textTest | anyKindTest );
    public final XSPARQLRewriter.kindTest_return kindTest() throws RecognitionException {
        XSPARQLRewriter.kindTest_return retval = new XSPARQLRewriter.kindTest_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.documentTest_return documentTest463 = null;

        XSPARQLRewriter.elementTest_return elementTest464 = null;

        XSPARQLRewriter.attributeTest_return attributeTest465 = null;

        XSPARQLRewriter.schemaElementTest_return schemaElementTest466 = null;

        XSPARQLRewriter.schemaAttributeTest_return schemaAttributeTest467 = null;

        XSPARQLRewriter.piTest_return piTest468 = null;

        XSPARQLRewriter.commentTest_return commentTest469 = null;

        XSPARQLRewriter.textTest_return textTest470 = null;

        XSPARQLRewriter.anyKindTest_return anyKindTest471 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1946:3: ( documentTest | elementTest | attributeTest | schemaElementTest | schemaAttributeTest | piTest | commentTest | textTest | anyKindTest )
            int alt128=9;
            switch ( input.LA(1) ) {
            case DOCUMENTNODE:
                {
                alt128=1;
                }
                break;
            case ELEMENT:
                {
                alt128=2;
                }
                break;
            case ATTRIBUTE:
                {
                alt128=3;
                }
                break;
            case SCHEMAELEMENT:
                {
                alt128=4;
                }
                break;
            case SCHEMAATTRIBUTE:
                {
                alt128=5;
                }
                break;
            case PROCESSINGINSTRUCTION:
                {
                alt128=6;
                }
                break;
            case COMMENT:
                {
                alt128=7;
                }
                break;
            case TEXT:
                {
                alt128=8;
                }
                break;
            case NODE:
                {
                alt128=9;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 128, 0, input);

                throw nvae;
            }

            switch (alt128) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1946:5: documentTest
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_documentTest_in_kindTest8759);
                    documentTest463=documentTest();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, documentTest463.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1947:5: elementTest
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_elementTest_in_kindTest8765);
                    elementTest464=elementTest();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, elementTest464.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1948:5: attributeTest
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_attributeTest_in_kindTest8771);
                    attributeTest465=attributeTest();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, attributeTest465.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1949:5: schemaElementTest
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_schemaElementTest_in_kindTest8777);
                    schemaElementTest466=schemaElementTest();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, schemaElementTest466.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 5 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1950:5: schemaAttributeTest
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_schemaAttributeTest_in_kindTest8783);
                    schemaAttributeTest467=schemaAttributeTest();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, schemaAttributeTest467.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 6 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1951:5: piTest
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_piTest_in_kindTest8789);
                    piTest468=piTest();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, piTest468.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 7 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1952:5: commentTest
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_commentTest_in_kindTest8795);
                    commentTest469=commentTest();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, commentTest469.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 8 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1953:5: textTest
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_textTest_in_kindTest8801);
                    textTest470=textTest();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, textTest470.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 9 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1954:5: anyKindTest
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_anyKindTest_in_kindTest8807);
                    anyKindTest471=anyKindTest();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, anyKindTest471.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "kindTest"

    public static class anyKindTest_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "anyKindTest"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1957:1: anyKindTest : NODE LPAR RPAR ;
    public final XSPARQLRewriter.anyKindTest_return anyKindTest() throws RecognitionException {
        XSPARQLRewriter.anyKindTest_return retval = new XSPARQLRewriter.anyKindTest_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree NODE472=null;
        CommonTree LPAR473=null;
        CommonTree RPAR474=null;

        CommonTree NODE472_tree=null;
        CommonTree LPAR473_tree=null;
        CommonTree RPAR474_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1958:3: ( NODE LPAR RPAR )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1958:5: NODE LPAR RPAR
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            NODE472=(CommonTree)match(input,NODE,FOLLOW_NODE_in_anyKindTest8820); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            NODE472_tree = (CommonTree)adaptor.dupNode(NODE472);

            adaptor.addChild(root_0, NODE472_tree);
            }
            _last = (CommonTree)input.LT(1);
            LPAR473=(CommonTree)match(input,LPAR,FOLLOW_LPAR_in_anyKindTest8822); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            LPAR473_tree = (CommonTree)adaptor.dupNode(LPAR473);

            adaptor.addChild(root_0, LPAR473_tree);
            }
            _last = (CommonTree)input.LT(1);
            RPAR474=(CommonTree)match(input,RPAR,FOLLOW_RPAR_in_anyKindTest8824); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            RPAR474_tree = (CommonTree)adaptor.dupNode(RPAR474);

            adaptor.addChild(root_0, RPAR474_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "anyKindTest"

    public static class documentTest_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "documentTest"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1961:1: documentTest : DOCUMENTNODE LPAR ( elementTest | schemaElementTest )? RPAR ;
    public final XSPARQLRewriter.documentTest_return documentTest() throws RecognitionException {
        XSPARQLRewriter.documentTest_return retval = new XSPARQLRewriter.documentTest_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree DOCUMENTNODE475=null;
        CommonTree LPAR476=null;
        CommonTree RPAR479=null;
        XSPARQLRewriter.elementTest_return elementTest477 = null;

        XSPARQLRewriter.schemaElementTest_return schemaElementTest478 = null;


        CommonTree DOCUMENTNODE475_tree=null;
        CommonTree LPAR476_tree=null;
        CommonTree RPAR479_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1962:3: ( DOCUMENTNODE LPAR ( elementTest | schemaElementTest )? RPAR )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1962:5: DOCUMENTNODE LPAR ( elementTest | schemaElementTest )? RPAR
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            DOCUMENTNODE475=(CommonTree)match(input,DOCUMENTNODE,FOLLOW_DOCUMENTNODE_in_documentTest8837); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            DOCUMENTNODE475_tree = (CommonTree)adaptor.dupNode(DOCUMENTNODE475);

            adaptor.addChild(root_0, DOCUMENTNODE475_tree);
            }
            _last = (CommonTree)input.LT(1);
            LPAR476=(CommonTree)match(input,LPAR,FOLLOW_LPAR_in_documentTest8839); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            LPAR476_tree = (CommonTree)adaptor.dupNode(LPAR476);

            adaptor.addChild(root_0, LPAR476_tree);
            }
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1962:23: ( elementTest | schemaElementTest )?
            int alt129=3;
            switch ( input.LA(1) ) {
                case ELEMENT:
                    {
                    alt129=1;
                    }
                    break;
                case SCHEMAELEMENT:
                    {
                    alt129=2;
                    }
                    break;
            }

            switch (alt129) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1962:24: elementTest
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_elementTest_in_documentTest8842);
                    elementTest477=elementTest();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, elementTest477.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1962:38: schemaElementTest
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_schemaElementTest_in_documentTest8846);
                    schemaElementTest478=schemaElementTest();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, schemaElementTest478.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            _last = (CommonTree)input.LT(1);
            RPAR479=(CommonTree)match(input,RPAR,FOLLOW_RPAR_in_documentTest8850); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            RPAR479_tree = (CommonTree)adaptor.dupNode(RPAR479);

            adaptor.addChild(root_0, RPAR479_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "documentTest"

    public static class textTest_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "textTest"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1965:1: textTest : TEXT LPAR RPAR ;
    public final XSPARQLRewriter.textTest_return textTest() throws RecognitionException {
        XSPARQLRewriter.textTest_return retval = new XSPARQLRewriter.textTest_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree TEXT480=null;
        CommonTree LPAR481=null;
        CommonTree RPAR482=null;

        CommonTree TEXT480_tree=null;
        CommonTree LPAR481_tree=null;
        CommonTree RPAR482_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1966:3: ( TEXT LPAR RPAR )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1966:5: TEXT LPAR RPAR
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            TEXT480=(CommonTree)match(input,TEXT,FOLLOW_TEXT_in_textTest8863); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            TEXT480_tree = (CommonTree)adaptor.dupNode(TEXT480);

            adaptor.addChild(root_0, TEXT480_tree);
            }
            _last = (CommonTree)input.LT(1);
            LPAR481=(CommonTree)match(input,LPAR,FOLLOW_LPAR_in_textTest8865); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            LPAR481_tree = (CommonTree)adaptor.dupNode(LPAR481);

            adaptor.addChild(root_0, LPAR481_tree);
            }
            _last = (CommonTree)input.LT(1);
            RPAR482=(CommonTree)match(input,RPAR,FOLLOW_RPAR_in_textTest8867); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            RPAR482_tree = (CommonTree)adaptor.dupNode(RPAR482);

            adaptor.addChild(root_0, RPAR482_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "textTest"

    public static class commentTest_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "commentTest"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1969:1: commentTest : COMMENT LPAR RPAR ;
    public final XSPARQLRewriter.commentTest_return commentTest() throws RecognitionException {
        XSPARQLRewriter.commentTest_return retval = new XSPARQLRewriter.commentTest_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree COMMENT483=null;
        CommonTree LPAR484=null;
        CommonTree RPAR485=null;

        CommonTree COMMENT483_tree=null;
        CommonTree LPAR484_tree=null;
        CommonTree RPAR485_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1970:3: ( COMMENT LPAR RPAR )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1970:5: COMMENT LPAR RPAR
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            COMMENT483=(CommonTree)match(input,COMMENT,FOLLOW_COMMENT_in_commentTest8880); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            COMMENT483_tree = (CommonTree)adaptor.dupNode(COMMENT483);

            adaptor.addChild(root_0, COMMENT483_tree);
            }
            _last = (CommonTree)input.LT(1);
            LPAR484=(CommonTree)match(input,LPAR,FOLLOW_LPAR_in_commentTest8882); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            LPAR484_tree = (CommonTree)adaptor.dupNode(LPAR484);

            adaptor.addChild(root_0, LPAR484_tree);
            }
            _last = (CommonTree)input.LT(1);
            RPAR485=(CommonTree)match(input,RPAR,FOLLOW_RPAR_in_commentTest8884); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            RPAR485_tree = (CommonTree)adaptor.dupNode(RPAR485);

            adaptor.addChild(root_0, RPAR485_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "commentTest"

    public static class piTest_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "piTest"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1973:1: piTest : PROCESSINGINSTRUCTION LPAR ( NCNAME | stringliteral )? RPAR ;
    public final XSPARQLRewriter.piTest_return piTest() throws RecognitionException {
        XSPARQLRewriter.piTest_return retval = new XSPARQLRewriter.piTest_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree PROCESSINGINSTRUCTION486=null;
        CommonTree LPAR487=null;
        CommonTree NCNAME488=null;
        CommonTree RPAR490=null;
        XSPARQLRewriter.stringliteral_return stringliteral489 = null;


        CommonTree PROCESSINGINSTRUCTION486_tree=null;
        CommonTree LPAR487_tree=null;
        CommonTree NCNAME488_tree=null;
        CommonTree RPAR490_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1974:3: ( PROCESSINGINSTRUCTION LPAR ( NCNAME | stringliteral )? RPAR )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1974:5: PROCESSINGINSTRUCTION LPAR ( NCNAME | stringliteral )? RPAR
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            PROCESSINGINSTRUCTION486=(CommonTree)match(input,PROCESSINGINSTRUCTION,FOLLOW_PROCESSINGINSTRUCTION_in_piTest8897); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            PROCESSINGINSTRUCTION486_tree = (CommonTree)adaptor.dupNode(PROCESSINGINSTRUCTION486);

            adaptor.addChild(root_0, PROCESSINGINSTRUCTION486_tree);
            }
            _last = (CommonTree)input.LT(1);
            LPAR487=(CommonTree)match(input,LPAR,FOLLOW_LPAR_in_piTest8899); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            LPAR487_tree = (CommonTree)adaptor.dupNode(LPAR487);

            adaptor.addChild(root_0, LPAR487_tree);
            }
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1974:32: ( NCNAME | stringliteral )?
            int alt130=3;
            switch ( input.LA(1) ) {
                case NCNAME:
                    {
                    alt130=1;
                    }
                    break;
                case QSTRING:
                    {
                    alt130=2;
                    }
                    break;
            }

            switch (alt130) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1974:33: NCNAME
                    {
                    _last = (CommonTree)input.LT(1);
                    NCNAME488=(CommonTree)match(input,NCNAME,FOLLOW_NCNAME_in_piTest8902); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    NCNAME488_tree = (CommonTree)adaptor.dupNode(NCNAME488);

                    adaptor.addChild(root_0, NCNAME488_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1974:42: stringliteral
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_stringliteral_in_piTest8906);
                    stringliteral489=stringliteral();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, stringliteral489.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            _last = (CommonTree)input.LT(1);
            RPAR490=(CommonTree)match(input,RPAR,FOLLOW_RPAR_in_piTest8910); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            RPAR490_tree = (CommonTree)adaptor.dupNode(RPAR490);

            adaptor.addChild(root_0, RPAR490_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "piTest"

    public static class attributeTest_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "attributeTest"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1977:1: attributeTest : ATTRIBUTE LPAR ( attributeNameOrWildcard ( COMMA typeName )? )? RPAR ;
    public final XSPARQLRewriter.attributeTest_return attributeTest() throws RecognitionException {
        XSPARQLRewriter.attributeTest_return retval = new XSPARQLRewriter.attributeTest_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree ATTRIBUTE491=null;
        CommonTree LPAR492=null;
        CommonTree COMMA494=null;
        CommonTree RPAR496=null;
        XSPARQLRewriter.attributeNameOrWildcard_return attributeNameOrWildcard493 = null;

        XSPARQLRewriter.typeName_return typeName495 = null;


        CommonTree ATTRIBUTE491_tree=null;
        CommonTree LPAR492_tree=null;
        CommonTree COMMA494_tree=null;
        CommonTree RPAR496_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1978:3: ( ATTRIBUTE LPAR ( attributeNameOrWildcard ( COMMA typeName )? )? RPAR )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1978:5: ATTRIBUTE LPAR ( attributeNameOrWildcard ( COMMA typeName )? )? RPAR
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            ATTRIBUTE491=(CommonTree)match(input,ATTRIBUTE,FOLLOW_ATTRIBUTE_in_attributeTest8923); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            ATTRIBUTE491_tree = (CommonTree)adaptor.dupNode(ATTRIBUTE491);

            adaptor.addChild(root_0, ATTRIBUTE491_tree);
            }
            _last = (CommonTree)input.LT(1);
            LPAR492=(CommonTree)match(input,LPAR,FOLLOW_LPAR_in_attributeTest8925); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            LPAR492_tree = (CommonTree)adaptor.dupNode(LPAR492);

            adaptor.addChild(root_0, LPAR492_tree);
            }
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1978:20: ( attributeNameOrWildcard ( COMMA typeName )? )?
            int alt132=2;
            switch ( input.LA(1) ) {
                case NCNAME:
                case STAR:
                case PNAME_NS:
                case PNAME_LN:
                case A:
                case FROM:
                case TO:
                case ITEM:
                case COMMENT:
                case ROW:
                    {
                    alt132=1;
                    }
                    break;
            }

            switch (alt132) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1978:21: attributeNameOrWildcard ( COMMA typeName )?
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_attributeNameOrWildcard_in_attributeTest8928);
                    attributeNameOrWildcard493=attributeNameOrWildcard();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, attributeNameOrWildcard493.getTree());
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1978:45: ( COMMA typeName )?
                    int alt131=2;
                    switch ( input.LA(1) ) {
                        case COMMA:
                            {
                            alt131=1;
                            }
                            break;
                    }

                    switch (alt131) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1978:46: COMMA typeName
                            {
                            _last = (CommonTree)input.LT(1);
                            COMMA494=(CommonTree)match(input,COMMA,FOLLOW_COMMA_in_attributeTest8931); if (state.failed) return retval;
                            if ( state.backtracking==0 ) {
                            COMMA494_tree = (CommonTree)adaptor.dupNode(COMMA494);

                            adaptor.addChild(root_0, COMMA494_tree);
                            }
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_typeName_in_attributeTest8933);
                            typeName495=typeName();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) 
                            adaptor.addChild(root_0, typeName495.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            _last = (CommonTree)input.LT(1);
            RPAR496=(CommonTree)match(input,RPAR,FOLLOW_RPAR_in_attributeTest8939); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            RPAR496_tree = (CommonTree)adaptor.dupNode(RPAR496);

            adaptor.addChild(root_0, RPAR496_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "attributeTest"

    public static class attributeNameOrWildcard_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "attributeNameOrWildcard"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1981:1: attributeNameOrWildcard : ( attributeName | STAR );
    public final XSPARQLRewriter.attributeNameOrWildcard_return attributeNameOrWildcard() throws RecognitionException {
        XSPARQLRewriter.attributeNameOrWildcard_return retval = new XSPARQLRewriter.attributeNameOrWildcard_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree STAR498=null;
        XSPARQLRewriter.attributeName_return attributeName497 = null;


        CommonTree STAR498_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1982:3: ( attributeName | STAR )
            int alt133=2;
            switch ( input.LA(1) ) {
            case NCNAME:
            case PNAME_NS:
            case PNAME_LN:
            case A:
            case FROM:
            case TO:
            case ITEM:
            case COMMENT:
            case ROW:
                {
                alt133=1;
                }
                break;
            case STAR:
                {
                alt133=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 133, 0, input);

                throw nvae;
            }

            switch (alt133) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1982:5: attributeName
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_attributeName_in_attributeNameOrWildcard8952);
                    attributeName497=attributeName();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, attributeName497.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1982:21: STAR
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    STAR498=(CommonTree)match(input,STAR,FOLLOW_STAR_in_attributeNameOrWildcard8956); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    STAR498_tree = (CommonTree)adaptor.dupNode(STAR498);

                    adaptor.addChild(root_0, STAR498_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "attributeNameOrWildcard"

    public static class schemaAttributeTest_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "schemaAttributeTest"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1985:1: schemaAttributeTest : SCHEMAATTRIBUTE LPAR attributeDeclaration RPAR ;
    public final XSPARQLRewriter.schemaAttributeTest_return schemaAttributeTest() throws RecognitionException {
        XSPARQLRewriter.schemaAttributeTest_return retval = new XSPARQLRewriter.schemaAttributeTest_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree SCHEMAATTRIBUTE499=null;
        CommonTree LPAR500=null;
        CommonTree RPAR502=null;
        XSPARQLRewriter.attributeDeclaration_return attributeDeclaration501 = null;


        CommonTree SCHEMAATTRIBUTE499_tree=null;
        CommonTree LPAR500_tree=null;
        CommonTree RPAR502_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1986:3: ( SCHEMAATTRIBUTE LPAR attributeDeclaration RPAR )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1986:5: SCHEMAATTRIBUTE LPAR attributeDeclaration RPAR
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            SCHEMAATTRIBUTE499=(CommonTree)match(input,SCHEMAATTRIBUTE,FOLLOW_SCHEMAATTRIBUTE_in_schemaAttributeTest8969); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            SCHEMAATTRIBUTE499_tree = (CommonTree)adaptor.dupNode(SCHEMAATTRIBUTE499);

            adaptor.addChild(root_0, SCHEMAATTRIBUTE499_tree);
            }
            _last = (CommonTree)input.LT(1);
            LPAR500=(CommonTree)match(input,LPAR,FOLLOW_LPAR_in_schemaAttributeTest8971); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            LPAR500_tree = (CommonTree)adaptor.dupNode(LPAR500);

            adaptor.addChild(root_0, LPAR500_tree);
            }
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_attributeDeclaration_in_schemaAttributeTest8973);
            attributeDeclaration501=attributeDeclaration();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, attributeDeclaration501.getTree());
            _last = (CommonTree)input.LT(1);
            RPAR502=(CommonTree)match(input,RPAR,FOLLOW_RPAR_in_schemaAttributeTest8975); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            RPAR502_tree = (CommonTree)adaptor.dupNode(RPAR502);

            adaptor.addChild(root_0, RPAR502_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "schemaAttributeTest"

    public static class attributeDeclaration_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "attributeDeclaration"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1989:1: attributeDeclaration : attributeName ;
    public final XSPARQLRewriter.attributeDeclaration_return attributeDeclaration() throws RecognitionException {
        XSPARQLRewriter.attributeDeclaration_return retval = new XSPARQLRewriter.attributeDeclaration_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.attributeName_return attributeName503 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1990:3: ( attributeName )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1990:5: attributeName
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_attributeName_in_attributeDeclaration8988);
            attributeName503=attributeName();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, attributeName503.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "attributeDeclaration"

    public static class elementTest_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "elementTest"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1993:1: elementTest : ELEMENT LPAR ( elementNameOrWildcard ( COMMA typeName ( QUESTIONMARK )? )? )? RPAR ;
    public final XSPARQLRewriter.elementTest_return elementTest() throws RecognitionException {
        XSPARQLRewriter.elementTest_return retval = new XSPARQLRewriter.elementTest_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree ELEMENT504=null;
        CommonTree LPAR505=null;
        CommonTree COMMA507=null;
        CommonTree QUESTIONMARK509=null;
        CommonTree RPAR510=null;
        XSPARQLRewriter.elementNameOrWildcard_return elementNameOrWildcard506 = null;

        XSPARQLRewriter.typeName_return typeName508 = null;


        CommonTree ELEMENT504_tree=null;
        CommonTree LPAR505_tree=null;
        CommonTree COMMA507_tree=null;
        CommonTree QUESTIONMARK509_tree=null;
        CommonTree RPAR510_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1994:3: ( ELEMENT LPAR ( elementNameOrWildcard ( COMMA typeName ( QUESTIONMARK )? )? )? RPAR )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1994:5: ELEMENT LPAR ( elementNameOrWildcard ( COMMA typeName ( QUESTIONMARK )? )? )? RPAR
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            ELEMENT504=(CommonTree)match(input,ELEMENT,FOLLOW_ELEMENT_in_elementTest9001); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            ELEMENT504_tree = (CommonTree)adaptor.dupNode(ELEMENT504);

            adaptor.addChild(root_0, ELEMENT504_tree);
            }
            _last = (CommonTree)input.LT(1);
            LPAR505=(CommonTree)match(input,LPAR,FOLLOW_LPAR_in_elementTest9003); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            LPAR505_tree = (CommonTree)adaptor.dupNode(LPAR505);

            adaptor.addChild(root_0, LPAR505_tree);
            }
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1994:18: ( elementNameOrWildcard ( COMMA typeName ( QUESTIONMARK )? )? )?
            int alt136=2;
            switch ( input.LA(1) ) {
                case NCNAME:
                case STAR:
                case PNAME_NS:
                case PNAME_LN:
                case A:
                case FROM:
                case TO:
                case ITEM:
                case COMMENT:
                case ROW:
                    {
                    alt136=1;
                    }
                    break;
            }

            switch (alt136) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1994:19: elementNameOrWildcard ( COMMA typeName ( QUESTIONMARK )? )?
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_elementNameOrWildcard_in_elementTest9006);
                    elementNameOrWildcard506=elementNameOrWildcard();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, elementNameOrWildcard506.getTree());
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1994:41: ( COMMA typeName ( QUESTIONMARK )? )?
                    int alt135=2;
                    switch ( input.LA(1) ) {
                        case COMMA:
                            {
                            alt135=1;
                            }
                            break;
                    }

                    switch (alt135) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1994:42: COMMA typeName ( QUESTIONMARK )?
                            {
                            _last = (CommonTree)input.LT(1);
                            COMMA507=(CommonTree)match(input,COMMA,FOLLOW_COMMA_in_elementTest9009); if (state.failed) return retval;
                            if ( state.backtracking==0 ) {
                            COMMA507_tree = (CommonTree)adaptor.dupNode(COMMA507);

                            adaptor.addChild(root_0, COMMA507_tree);
                            }
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_typeName_in_elementTest9011);
                            typeName508=typeName();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) 
                            adaptor.addChild(root_0, typeName508.getTree());
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1994:57: ( QUESTIONMARK )?
                            int alt134=2;
                            switch ( input.LA(1) ) {
                                case QUESTIONMARK:
                                    {
                                    alt134=1;
                                    }
                                    break;
                            }

                            switch (alt134) {
                                case 1 :
                                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: QUESTIONMARK
                                    {
                                    _last = (CommonTree)input.LT(1);
                                    QUESTIONMARK509=(CommonTree)match(input,QUESTIONMARK,FOLLOW_QUESTIONMARK_in_elementTest9013); if (state.failed) return retval;
                                    if ( state.backtracking==0 ) {
                                    QUESTIONMARK509_tree = (CommonTree)adaptor.dupNode(QUESTIONMARK509);

                                    adaptor.addChild(root_0, QUESTIONMARK509_tree);
                                    }

                                    if ( state.backtracking==0 ) {
                                    }
                                    }
                                    break;

                            }


                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            _last = (CommonTree)input.LT(1);
            RPAR510=(CommonTree)match(input,RPAR,FOLLOW_RPAR_in_elementTest9020); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            RPAR510_tree = (CommonTree)adaptor.dupNode(RPAR510);

            adaptor.addChild(root_0, RPAR510_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "elementTest"

    public static class elementNameOrWildcard_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "elementNameOrWildcard"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1997:1: elementNameOrWildcard : ( elementName | STAR );
    public final XSPARQLRewriter.elementNameOrWildcard_return elementNameOrWildcard() throws RecognitionException {
        XSPARQLRewriter.elementNameOrWildcard_return retval = new XSPARQLRewriter.elementNameOrWildcard_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree STAR512=null;
        XSPARQLRewriter.elementName_return elementName511 = null;


        CommonTree STAR512_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1998:3: ( elementName | STAR )
            int alt137=2;
            switch ( input.LA(1) ) {
            case NCNAME:
            case PNAME_NS:
            case PNAME_LN:
            case A:
            case FROM:
            case TO:
            case ITEM:
            case COMMENT:
            case ROW:
                {
                alt137=1;
                }
                break;
            case STAR:
                {
                alt137=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 137, 0, input);

                throw nvae;
            }

            switch (alt137) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1998:5: elementName
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_elementName_in_elementNameOrWildcard9033);
                    elementName511=elementName();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, elementName511.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1998:19: STAR
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    STAR512=(CommonTree)match(input,STAR,FOLLOW_STAR_in_elementNameOrWildcard9037); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    STAR512_tree = (CommonTree)adaptor.dupNode(STAR512);

                    adaptor.addChild(root_0, STAR512_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "elementNameOrWildcard"

    public static class schemaElementTest_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "schemaElementTest"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2001:1: schemaElementTest : SCHEMAELEMENT LPAR elementDeclaration RPAR ;
    public final XSPARQLRewriter.schemaElementTest_return schemaElementTest() throws RecognitionException {
        XSPARQLRewriter.schemaElementTest_return retval = new XSPARQLRewriter.schemaElementTest_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree SCHEMAELEMENT513=null;
        CommonTree LPAR514=null;
        CommonTree RPAR516=null;
        XSPARQLRewriter.elementDeclaration_return elementDeclaration515 = null;


        CommonTree SCHEMAELEMENT513_tree=null;
        CommonTree LPAR514_tree=null;
        CommonTree RPAR516_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2002:3: ( SCHEMAELEMENT LPAR elementDeclaration RPAR )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2002:5: SCHEMAELEMENT LPAR elementDeclaration RPAR
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            SCHEMAELEMENT513=(CommonTree)match(input,SCHEMAELEMENT,FOLLOW_SCHEMAELEMENT_in_schemaElementTest9050); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            SCHEMAELEMENT513_tree = (CommonTree)adaptor.dupNode(SCHEMAELEMENT513);

            adaptor.addChild(root_0, SCHEMAELEMENT513_tree);
            }
            _last = (CommonTree)input.LT(1);
            LPAR514=(CommonTree)match(input,LPAR,FOLLOW_LPAR_in_schemaElementTest9052); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            LPAR514_tree = (CommonTree)adaptor.dupNode(LPAR514);

            adaptor.addChild(root_0, LPAR514_tree);
            }
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_elementDeclaration_in_schemaElementTest9054);
            elementDeclaration515=elementDeclaration();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, elementDeclaration515.getTree());
            _last = (CommonTree)input.LT(1);
            RPAR516=(CommonTree)match(input,RPAR,FOLLOW_RPAR_in_schemaElementTest9056); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            RPAR516_tree = (CommonTree)adaptor.dupNode(RPAR516);

            adaptor.addChild(root_0, RPAR516_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "schemaElementTest"

    public static class elementDeclaration_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "elementDeclaration"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2005:1: elementDeclaration : elementName ;
    public final XSPARQLRewriter.elementDeclaration_return elementDeclaration() throws RecognitionException {
        XSPARQLRewriter.elementDeclaration_return retval = new XSPARQLRewriter.elementDeclaration_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.elementName_return elementName517 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2006:3: ( elementName )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2006:5: elementName
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_elementName_in_elementDeclaration9069);
            elementName517=elementName();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, elementName517.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "elementDeclaration"

    public static class attributeName_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "attributeName"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2009:1: attributeName : qname ;
    public final XSPARQLRewriter.attributeName_return attributeName() throws RecognitionException {
        XSPARQLRewriter.attributeName_return retval = new XSPARQLRewriter.attributeName_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.qname_return qname518 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2010:3: ( qname )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2010:5: qname
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_qname_in_attributeName9082);
            qname518=qname();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, qname518.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "attributeName"

    public static class elementName_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "elementName"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2013:1: elementName : qname ;
    public final XSPARQLRewriter.elementName_return elementName() throws RecognitionException {
        XSPARQLRewriter.elementName_return retval = new XSPARQLRewriter.elementName_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.qname_return qname519 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2014:3: ( qname )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2014:5: qname
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_qname_in_elementName9095);
            qname519=qname();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, qname519.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "elementName"

    public static class typeName_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "typeName"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2017:1: typeName : qname ;
    public final XSPARQLRewriter.typeName_return typeName() throws RecognitionException {
        XSPARQLRewriter.typeName_return retval = new XSPARQLRewriter.typeName_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.qname_return qname520 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2018:3: ( qname )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2018:5: qname
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_qname_in_typeName9108);
            qname520=qname();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, qname520.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "typeName"

    public static class uriliteral_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "uriliteral"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2021:1: uriliteral : stringliteral ;
    public final XSPARQLRewriter.uriliteral_return uriliteral() throws RecognitionException {
        XSPARQLRewriter.uriliteral_return retval = new XSPARQLRewriter.uriliteral_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.stringliteral_return stringliteral521 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2022:3: ( stringliteral )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2022:5: stringliteral
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_stringliteral_in_uriliteral9121);
            stringliteral521=stringliteral();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, stringliteral521.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "uriliteral"

    public static class integerLiteral_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "integerLiteral"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2025:1: integerLiteral : INTEGER ;
    public final XSPARQLRewriter.integerLiteral_return integerLiteral() throws RecognitionException {
        XSPARQLRewriter.integerLiteral_return retval = new XSPARQLRewriter.integerLiteral_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree INTEGER522=null;

        CommonTree INTEGER522_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2026:3: ( INTEGER )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2026:5: INTEGER
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            INTEGER522=(CommonTree)match(input,INTEGER,FOLLOW_INTEGER_in_integerLiteral9134); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            INTEGER522_tree = (CommonTree)adaptor.dupNode(INTEGER522);

            adaptor.addChild(root_0, INTEGER522_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "integerLiteral"

    public static class decimalLiteral_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "decimalLiteral"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2029:1: decimalLiteral : DECIMAL ;
    public final XSPARQLRewriter.decimalLiteral_return decimalLiteral() throws RecognitionException {
        XSPARQLRewriter.decimalLiteral_return retval = new XSPARQLRewriter.decimalLiteral_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree DECIMAL523=null;

        CommonTree DECIMAL523_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2030:3: ( DECIMAL )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2030:5: DECIMAL
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            DECIMAL523=(CommonTree)match(input,DECIMAL,FOLLOW_DECIMAL_in_decimalLiteral9147); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            DECIMAL523_tree = (CommonTree)adaptor.dupNode(DECIMAL523);

            adaptor.addChild(root_0, DECIMAL523_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "decimalLiteral"

    public static class stringliteral_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "stringliteral"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2033:1: stringliteral : QSTRING ;
    public final XSPARQLRewriter.stringliteral_return stringliteral() throws RecognitionException {
        XSPARQLRewriter.stringliteral_return retval = new XSPARQLRewriter.stringliteral_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree QSTRING524=null;

        CommonTree QSTRING524_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2034:3: ( QSTRING )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2034:5: QSTRING
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            QSTRING524=(CommonTree)match(input,QSTRING,FOLLOW_QSTRING_in_stringliteral9160); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            QSTRING524_tree = (CommonTree)adaptor.dupNode(QSTRING524);

            adaptor.addChild(root_0, QSTRING524_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "stringliteral"

    public static class baseDecl_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "baseDecl"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2053:1: baseDecl : ^( T_NAMESPACE DEFAULT irix= IRIREF ) ;
    public final XSPARQLRewriter.baseDecl_return baseDecl() throws RecognitionException {
        XSPARQLRewriter.baseDecl_return retval = new XSPARQLRewriter.baseDecl_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree irix=null;
        CommonTree T_NAMESPACE525=null;
        CommonTree DEFAULT526=null;

        CommonTree irix_tree=null;
        CommonTree T_NAMESPACE525_tree=null;
        CommonTree DEFAULT526_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2054:3: ( ^( T_NAMESPACE DEFAULT irix= IRIREF ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2054:5: ^( T_NAMESPACE DEFAULT irix= IRIREF )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_NAMESPACE525=(CommonTree)match(input,T_NAMESPACE,FOLLOW_T_NAMESPACE_in_baseDecl9190); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_NAMESPACE525_tree = (CommonTree)adaptor.dupNode(T_NAMESPACE525);

            root_1 = (CommonTree)adaptor.becomeRoot(T_NAMESPACE525_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            DEFAULT526=(CommonTree)match(input,DEFAULT,FOLLOW_DEFAULT_in_baseDecl9192); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            DEFAULT526_tree = (CommonTree)adaptor.dupNode(DEFAULT526);

            adaptor.addChild(root_1, DEFAULT526_tree);
            }
            _last = (CommonTree)input.LT(1);
            irix=(CommonTree)match(input,IRIREF,FOLLOW_IRIREF_in_baseDecl9196); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            irix_tree = (CommonTree)adaptor.dupNode(irix);

            adaptor.addChild(root_1, irix_tree);
            }

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }

            if ( state.backtracking==0 ) {
              addNamespace(":", (irix!=null?irix.getText():null));
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "baseDecl"

    public static class prefixDecl_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "prefixDecl"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2057:1: prefixDecl : ( ^( T_NAMESPACE DEFAULT irix= QSTRING ) -> | ^( T_NAMESPACE p= PNAME_NS irix= QSTRING ) -> ^( T_NAMESPACE NCNAME[$p.token, $p.text] QSTRING ) );
    public final XSPARQLRewriter.prefixDecl_return prefixDecl() throws RecognitionException {
        XSPARQLRewriter.prefixDecl_return retval = new XSPARQLRewriter.prefixDecl_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree irix=null;
        CommonTree p=null;
        CommonTree T_NAMESPACE527=null;
        CommonTree DEFAULT528=null;
        CommonTree T_NAMESPACE529=null;

        CommonTree irix_tree=null;
        CommonTree p_tree=null;
        CommonTree T_NAMESPACE527_tree=null;
        CommonTree DEFAULT528_tree=null;
        CommonTree T_NAMESPACE529_tree=null;
        RewriteRuleNodeStream stream_PNAME_NS=new RewriteRuleNodeStream(adaptor,"token PNAME_NS");
        RewriteRuleNodeStream stream_T_NAMESPACE=new RewriteRuleNodeStream(adaptor,"token T_NAMESPACE");
        RewriteRuleNodeStream stream_QSTRING=new RewriteRuleNodeStream(adaptor,"token QSTRING");
        RewriteRuleNodeStream stream_DEFAULT=new RewriteRuleNodeStream(adaptor,"token DEFAULT");

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2058:3: ( ^( T_NAMESPACE DEFAULT irix= QSTRING ) -> | ^( T_NAMESPACE p= PNAME_NS irix= QSTRING ) -> ^( T_NAMESPACE NCNAME[$p.token, $p.text] QSTRING ) )
            int alt138=2;
            switch ( input.LA(1) ) {
            case T_NAMESPACE:
                {
                switch ( input.LA(2) ) {
                case DOWN:
                    {
                    switch ( input.LA(3) ) {
                    case DEFAULT:
                        {
                        alt138=1;
                        }
                        break;
                    case PNAME_NS:
                        {
                        alt138=2;
                        }
                        break;
                    default:
                        if (state.backtracking>0) {state.failed=true; return retval;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 138, 2, input);

                        throw nvae;
                    }

                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 138, 1, input);

                    throw nvae;
                }

                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 138, 0, input);

                throw nvae;
            }

            switch (alt138) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2058:5: ^( T_NAMESPACE DEFAULT irix= QSTRING )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_NAMESPACE527=(CommonTree)match(input,T_NAMESPACE,FOLLOW_T_NAMESPACE_in_prefixDecl9213); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_NAMESPACE.add(T_NAMESPACE527);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    DEFAULT528=(CommonTree)match(input,DEFAULT,FOLLOW_DEFAULT_in_prefixDecl9215); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_DEFAULT.add(DEFAULT528);

                    _last = (CommonTree)input.LT(1);
                    irix=(CommonTree)match(input,QSTRING,FOLLOW_QSTRING_in_prefixDecl9219); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_QSTRING.add(irix);


                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }

                    if ( state.backtracking==0 ) {
                      addNamespace(":", (irix!=null?irix.getText():null));
                    }


                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2058:74: ->
                    {
                        root_0 = null;
                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2059:5: ^( T_NAMESPACE p= PNAME_NS irix= QSTRING )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_NAMESPACE529=(CommonTree)match(input,T_NAMESPACE,FOLLOW_T_NAMESPACE_in_prefixDecl9232); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_NAMESPACE.add(T_NAMESPACE529);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    p=(CommonTree)match(input,PNAME_NS,FOLLOW_PNAME_NS_in_prefixDecl9236); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_PNAME_NS.add(p);

                    _last = (CommonTree)input.LT(1);
                    irix=(CommonTree)match(input,QSTRING,FOLLOW_QSTRING_in_prefixDecl9240); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_QSTRING.add(irix);


                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }

                    if ( state.backtracking==0 ) {
                      addNamespace((p!=null?p.getText():null), (irix!=null?irix.getText():null));
                    }


                    // AST REWRITE
                    // elements: QSTRING, T_NAMESPACE
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2060:3: -> ^( T_NAMESPACE NCNAME[$p.token, $p.text] QSTRING )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2060:6: ^( T_NAMESPACE NCNAME[$p.token, $p.text] QSTRING )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot(stream_T_NAMESPACE.nextNode(), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(NCNAME, p.token, (p!=null?p.getText():null)));
                        adaptor.addChild(root_1, stream_QSTRING.nextNode());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "prefixDecl"

    public static class datasetClause_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "datasetClause"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2063:1: datasetClause : ^(f= FROM (d= defaultGraphClause | e= namedGraphClause ) ) -> QSTRING[$f.token, \"\\n \" + $f.text + \" \"] ( $d)? ( $e)? ;
    public final XSPARQLRewriter.datasetClause_return datasetClause() throws RecognitionException {
        XSPARQLRewriter.datasetClause_return retval = new XSPARQLRewriter.datasetClause_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree f=null;
        XSPARQLRewriter.defaultGraphClause_return d = null;

        XSPARQLRewriter.namedGraphClause_return e = null;


        CommonTree f_tree=null;
        RewriteRuleNodeStream stream_FROM=new RewriteRuleNodeStream(adaptor,"token FROM");
        RewriteRuleSubtreeStream stream_defaultGraphClause=new RewriteRuleSubtreeStream(adaptor,"rule defaultGraphClause");
        RewriteRuleSubtreeStream stream_namedGraphClause=new RewriteRuleSubtreeStream(adaptor,"rule namedGraphClause");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2064:3: ( ^(f= FROM (d= defaultGraphClause | e= namedGraphClause ) ) -> QSTRING[$f.token, \"\\n \" + $f.text + \" \"] ( $d)? ( $e)? )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2064:5: ^(f= FROM (d= defaultGraphClause | e= namedGraphClause ) )
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            f=(CommonTree)match(input,FROM,FOLLOW_FROM_in_datasetClause9272); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_FROM.add(f);


            if ( state.backtracking==0 ) {
               ((VariableScope_scope)VariableScope_stack.peek()).scopedDataset = false; 
            }

            match(input, Token.DOWN, null); if (state.failed) return retval;
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2064:57: (d= defaultGraphClause | e= namedGraphClause )
            int alt139=2;
            switch ( input.LA(1) ) {
            case VAR:
            case IRIREF:
                {
                alt139=1;
                }
                break;
            case NAMED:
                {
                alt139=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 139, 0, input);

                throw nvae;
            }

            switch (alt139) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2064:58: d= defaultGraphClause
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_defaultGraphClause_in_datasetClause9279);
                    d=defaultGraphClause();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_defaultGraphClause.add(d.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2064:81: e= namedGraphClause
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_namedGraphClause_in_datasetClause9285);
                    e=namedGraphClause();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_namedGraphClause.add(e.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }


            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }



            // AST REWRITE
            // elements: d, e
            // token labels: 
            // rule labels: retval, d, e
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
            RewriteRuleSubtreeStream stream_d=new RewriteRuleSubtreeStream(adaptor,"rule d",d!=null?d.tree:null);
            RewriteRuleSubtreeStream stream_e=new RewriteRuleSubtreeStream(adaptor,"rule e",e!=null?e.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 2065:3: -> QSTRING[$f.token, \"\\n \" + $f.text + \" \"] ( $d)? ( $e)?
            {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, f.token, "\n " + (f!=null?f.getText():null) + " "));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2065:47: ( $d)?
                if ( stream_d.hasNext() ) {
                    adaptor.addChild(root_0, stream_d.nextTree());

                }
                stream_d.reset();
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2065:51: ( $e)?
                if ( stream_e.hasNext() ) {
                    adaptor.addChild(root_0, stream_e.nextTree());

                }
                stream_e.reset();

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "datasetClause"

    public static class defaultGraphClause_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "defaultGraphClause"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2068:1: defaultGraphClause : sourceSelector ;
    public final XSPARQLRewriter.defaultGraphClause_return defaultGraphClause() throws RecognitionException {
        XSPARQLRewriter.defaultGraphClause_return retval = new XSPARQLRewriter.defaultGraphClause_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.sourceSelector_return sourceSelector530 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2069:3: ( sourceSelector )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2069:5: sourceSelector
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_sourceSelector_in_defaultGraphClause9316);
            sourceSelector530=sourceSelector();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, sourceSelector530.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "defaultGraphClause"

    public static class namedGraphClause_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "namedGraphClause"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2072:1: namedGraphClause : n= NAMED sourceSelector -> QSTRING[$n.token, $n.text] sourceSelector ;
    public final XSPARQLRewriter.namedGraphClause_return namedGraphClause() throws RecognitionException {
        XSPARQLRewriter.namedGraphClause_return retval = new XSPARQLRewriter.namedGraphClause_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree n=null;
        XSPARQLRewriter.sourceSelector_return sourceSelector531 = null;


        CommonTree n_tree=null;
        RewriteRuleNodeStream stream_NAMED=new RewriteRuleNodeStream(adaptor,"token NAMED");
        RewriteRuleSubtreeStream stream_sourceSelector=new RewriteRuleSubtreeStream(adaptor,"rule sourceSelector");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2073:3: (n= NAMED sourceSelector -> QSTRING[$n.token, $n.text] sourceSelector )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2073:5: n= NAMED sourceSelector
            {
            _last = (CommonTree)input.LT(1);
            n=(CommonTree)match(input,NAMED,FOLLOW_NAMED_in_namedGraphClause9331); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_NAMED.add(n);

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_sourceSelector_in_namedGraphClause9333);
            sourceSelector531=sourceSelector();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_sourceSelector.add(sourceSelector531.getTree());


            // AST REWRITE
            // elements: sourceSelector
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 2074:3: -> QSTRING[$n.token, $n.text] sourceSelector
            {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, n.token, (n!=null?n.getText():null)));
                adaptor.addChild(root_0, stream_sourceSelector.nextTree());

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "namedGraphClause"

    public static class sourceSelector_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "sourceSelector"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2077:1: sourceSelector : (i= IRIREF -> QSTRING[$i.token, \"<\" + $i.text + \">\"] | v= VAR -> {isBound(\"\\$_\" + Helper.removeLeading($v.text,\"\\$\")+\"_graph\")}? QSTRING[$v.token, \"<\"] VAR[\"\\$_\" + Helper.removeLeading($v.text,\"\\$\")+\"_graph\"] QSTRING[$v.token, \">\"] -> ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $v) ) ) ) );
    public final XSPARQLRewriter.sourceSelector_return sourceSelector() throws RecognitionException {
        XSPARQLRewriter.sourceSelector_return retval = new XSPARQLRewriter.sourceSelector_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree i=null;
        CommonTree v=null;

        CommonTree i_tree=null;
        CommonTree v_tree=null;
        RewriteRuleNodeStream stream_VAR=new RewriteRuleNodeStream(adaptor,"token VAR");
        RewriteRuleNodeStream stream_IRIREF=new RewriteRuleNodeStream(adaptor,"token IRIREF");

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2078:3: (i= IRIREF -> QSTRING[$i.token, \"<\" + $i.text + \">\"] | v= VAR -> {isBound(\"\\$_\" + Helper.removeLeading($v.text,\"\\$\")+\"_graph\")}? QSTRING[$v.token, \"<\"] VAR[\"\\$_\" + Helper.removeLeading($v.text,\"\\$\")+\"_graph\"] QSTRING[$v.token, \">\"] -> ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $v) ) ) ) )
            int alt140=2;
            switch ( input.LA(1) ) {
            case IRIREF:
                {
                alt140=1;
                }
                break;
            case VAR:
                {
                alt140=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 140, 0, input);

                throw nvae;
            }

            switch (alt140) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2078:5: i= IRIREF
                    {
                    _last = (CommonTree)input.LT(1);
                    i=(CommonTree)match(input,IRIREF,FOLLOW_IRIREF_in_sourceSelector9357); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_IRIREF.add(i);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2079:3: -> QSTRING[$i.token, \"<\" + $i.text + \">\"]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, i.token, "<" + (i!=null?i.getText():null) + ">"));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2080:5: v= VAR
                    {
                    _last = (CommonTree)input.LT(1);
                    v=(CommonTree)match(input,VAR,FOLLOW_VAR_in_sourceSelector9372); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_VAR.add(v);



                    // AST REWRITE
                    // elements: v, VAR
                    // token labels: v
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleNodeStream stream_v=new RewriteRuleNodeStream(adaptor,"token v",v);
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2081:3: -> {isBound(\"\\$_\" + Helper.removeLeading($v.text,\"\\$\")+\"_graph\")}? QSTRING[$v.token, \"<\"] VAR[\"\\$_\" + Helper.removeLeading($v.text,\"\\$\")+\"_graph\"] QSTRING[$v.token, \">\"]
                    if (isBound("$_" + Helper.removeLeading((v!=null?v.getText():null),"$")+"_graph")) {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, v.token, "<"));
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(VAR, "$_" + Helper.removeLeading((v!=null?v.getText():null),"$")+"_graph"));
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, v.token, ">"));

                    }
                    else // 2082:3: -> ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $v) ) ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2082:6: ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $v) ) ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(NCNAME, rdfTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2083:9: ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $v) ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_2);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2084:15: ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $v) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_3);

                        adaptor.addChild(root_3, (CommonTree)adaptor.create(NCNAME, bindingTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2084:61: ^( T_PARAMS $v)
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_4);

                        adaptor.addChild(root_4, stream_v.nextNode());

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "sourceSelector"

    public static class sWhereClause_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "sWhereClause"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2089:1: sWhereClause : ^(w= T_SPARQL_WHERE groupGraphPattern ) -> QSTRING[$w.token, \"\\n \" + $w.text + \" \"] groupGraphPattern ;
    public final XSPARQLRewriter.sWhereClause_return sWhereClause() throws RecognitionException {
        XSPARQLRewriter.sWhereClause_return retval = new XSPARQLRewriter.sWhereClause_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree w=null;
        XSPARQLRewriter.groupGraphPattern_return groupGraphPattern532 = null;


        CommonTree w_tree=null;
        RewriteRuleNodeStream stream_T_SPARQL_WHERE=new RewriteRuleNodeStream(adaptor,"token T_SPARQL_WHERE");
        RewriteRuleSubtreeStream stream_groupGraphPattern=new RewriteRuleSubtreeStream(adaptor,"rule groupGraphPattern");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2090:3: ( ^(w= T_SPARQL_WHERE groupGraphPattern ) -> QSTRING[$w.token, \"\\n \" + $w.text + \" \"] groupGraphPattern )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2090:5: ^(w= T_SPARQL_WHERE groupGraphPattern )
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            w=(CommonTree)match(input,T_SPARQL_WHERE,FOLLOW_T_SPARQL_WHERE_in_sWhereClause9473); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_T_SPARQL_WHERE.add(w);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_groupGraphPattern_in_sWhereClause9475);
            groupGraphPattern532=groupGraphPattern();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_groupGraphPattern.add(groupGraphPattern532.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }



            // AST REWRITE
            // elements: groupGraphPattern
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 2091:3: -> QSTRING[$w.token, \"\\n \" + $w.text + \" \"] groupGraphPattern
            {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, w.token, "\n " + (w!=null?w.getText():null) + " "));
                adaptor.addChild(root_0, stream_groupGraphPattern.nextTree());

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "sWhereClause"

    public static class solutionmodifier_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "solutionmodifier"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2095:1: solutionmodifier : ( orderclause ( limitoffsetclauses )? | ( groupBy )? ( having )? ( limitoffsetclauses )? );
    public final XSPARQLRewriter.solutionmodifier_return solutionmodifier() throws RecognitionException {
        XSPARQLRewriter.solutionmodifier_return retval = new XSPARQLRewriter.solutionmodifier_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.orderclause_return orderclause533 = null;

        XSPARQLRewriter.limitoffsetclauses_return limitoffsetclauses534 = null;

        XSPARQLRewriter.groupBy_return groupBy535 = null;

        XSPARQLRewriter.having_return having536 = null;

        XSPARQLRewriter.limitoffsetclauses_return limitoffsetclauses537 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2096:3: ( orderclause ( limitoffsetclauses )? | ( groupBy )? ( having )? ( limitoffsetclauses )? )
            int alt145=2;
            switch ( input.LA(1) ) {
            case ORDER:
                {
                alt145=1;
                }
                break;
            case EOF:
            case UP:
            case LIMIT:
            case OFFSET:
            case T_CONSTRUCT:
            case T_RETURN:
            case T_GROUP_BY:
            case T_HAVING:
                {
                alt145=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 145, 0, input);

                throw nvae;
            }

            switch (alt145) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2096:5: orderclause ( limitoffsetclauses )?
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_orderclause_in_solutionmodifier9503);
                    orderclause533=orderclause();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, orderclause533.getTree());
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2096:17: ( limitoffsetclauses )?
                    int alt141=2;
                    switch ( input.LA(1) ) {
                        case LIMIT:
                        case OFFSET:
                            {
                            alt141=1;
                            }
                            break;
                    }

                    switch (alt141) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: limitoffsetclauses
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_limitoffsetclauses_in_solutionmodifier9505);
                            limitoffsetclauses534=limitoffsetclauses();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) 
                            adaptor.addChild(root_0, limitoffsetclauses534.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2097:5: ( groupBy )? ( having )? ( limitoffsetclauses )?
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2097:5: ( groupBy )?
                    int alt142=2;
                    switch ( input.LA(1) ) {
                        case T_GROUP_BY:
                            {
                            alt142=1;
                            }
                            break;
                    }

                    switch (alt142) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: groupBy
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_groupBy_in_solutionmodifier9512);
                            groupBy535=groupBy();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) 
                            adaptor.addChild(root_0, groupBy535.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }

                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2097:14: ( having )?
                    int alt143=2;
                    switch ( input.LA(1) ) {
                        case T_HAVING:
                            {
                            alt143=1;
                            }
                            break;
                    }

                    switch (alt143) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: having
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_having_in_solutionmodifier9515);
                            having536=having();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) 
                            adaptor.addChild(root_0, having536.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }

                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2097:22: ( limitoffsetclauses )?
                    int alt144=2;
                    switch ( input.LA(1) ) {
                        case LIMIT:
                        case OFFSET:
                            {
                            alt144=1;
                            }
                            break;
                    }

                    switch (alt144) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: limitoffsetclauses
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_limitoffsetclauses_in_solutionmodifier9518);
                            limitoffsetclauses537=limitoffsetclauses();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) 
                            adaptor.addChild(root_0, limitoffsetclauses537.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "solutionmodifier"

    public static class groupBy_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "groupBy"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2100:1: groupBy : ^( T_GROUP_BY VAR ) ;
    public final XSPARQLRewriter.groupBy_return groupBy() throws RecognitionException {
        XSPARQLRewriter.groupBy_return retval = new XSPARQLRewriter.groupBy_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_GROUP_BY538=null;
        CommonTree VAR539=null;

        CommonTree T_GROUP_BY538_tree=null;
        CommonTree VAR539_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2101:3: ( ^( T_GROUP_BY VAR ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2101:5: ^( T_GROUP_BY VAR )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_GROUP_BY538=(CommonTree)match(input,T_GROUP_BY,FOLLOW_T_GROUP_BY_in_groupBy9534); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_GROUP_BY538_tree = (CommonTree)adaptor.dupNode(T_GROUP_BY538);

            root_1 = (CommonTree)adaptor.becomeRoot(T_GROUP_BY538_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            VAR539=(CommonTree)match(input,VAR,FOLLOW_VAR_in_groupBy9536); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            VAR539_tree = (CommonTree)adaptor.dupNode(VAR539);

            adaptor.addChild(root_1, VAR539_tree);
            }

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "groupBy"

    public static class having_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "having"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2104:1: having : ^( T_HAVING exprSingle ) ;
    public final XSPARQLRewriter.having_return having() throws RecognitionException {
        XSPARQLRewriter.having_return retval = new XSPARQLRewriter.having_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_HAVING540=null;
        XSPARQLRewriter.exprSingle_return exprSingle541 = null;


        CommonTree T_HAVING540_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2105:3: ( ^( T_HAVING exprSingle ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2105:5: ^( T_HAVING exprSingle )
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_HAVING540=(CommonTree)match(input,T_HAVING,FOLLOW_T_HAVING_in_having9551); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_HAVING540_tree = (CommonTree)adaptor.dupNode(T_HAVING540);

            root_1 = (CommonTree)adaptor.becomeRoot(T_HAVING540_tree, root_1);
            }


            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_exprSingle_in_having9553);
            exprSingle541=exprSingle();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_1, exprSingle541.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "having"

    public static class limitoffsetclauses_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "limitoffsetclauses"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2108:1: limitoffsetclauses : ( limitclause ( offsetclause )? | offsetclause ( limitclause )? );
    public final XSPARQLRewriter.limitoffsetclauses_return limitoffsetclauses() throws RecognitionException {
        XSPARQLRewriter.limitoffsetclauses_return retval = new XSPARQLRewriter.limitoffsetclauses_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.limitclause_return limitclause542 = null;

        XSPARQLRewriter.offsetclause_return offsetclause543 = null;

        XSPARQLRewriter.offsetclause_return offsetclause544 = null;

        XSPARQLRewriter.limitclause_return limitclause545 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2109:3: ( limitclause ( offsetclause )? | offsetclause ( limitclause )? )
            int alt148=2;
            switch ( input.LA(1) ) {
            case LIMIT:
                {
                alt148=1;
                }
                break;
            case OFFSET:
                {
                alt148=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 148, 0, input);

                throw nvae;
            }

            switch (alt148) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2109:5: limitclause ( offsetclause )?
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_limitclause_in_limitoffsetclauses9567);
                    limitclause542=limitclause();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, limitclause542.getTree());
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2109:17: ( offsetclause )?
                    int alt146=2;
                    switch ( input.LA(1) ) {
                        case OFFSET:
                            {
                            alt146=1;
                            }
                            break;
                    }

                    switch (alt146) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: offsetclause
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_offsetclause_in_limitoffsetclauses9569);
                            offsetclause543=offsetclause();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) 
                            adaptor.addChild(root_0, offsetclause543.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2110:5: offsetclause ( limitclause )?
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_offsetclause_in_limitoffsetclauses9576);
                    offsetclause544=offsetclause();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, offsetclause544.getTree());
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2110:18: ( limitclause )?
                    int alt147=2;
                    switch ( input.LA(1) ) {
                        case LIMIT:
                            {
                            alt147=1;
                            }
                            break;
                    }

                    switch (alt147) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: limitclause
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_limitclause_in_limitoffsetclauses9578);
                            limitclause545=limitclause();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) 
                            adaptor.addChild(root_0, limitclause545.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "limitoffsetclauses"

    public static class orderclause_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "orderclause"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2113:1: orderclause : ^(o= ORDER orderCondition ) -> QSTRING[$o.token, $o.text + \" by \"] orderCondition ;
    public final XSPARQLRewriter.orderclause_return orderclause() throws RecognitionException {
        XSPARQLRewriter.orderclause_return retval = new XSPARQLRewriter.orderclause_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree o=null;
        XSPARQLRewriter.orderCondition_return orderCondition546 = null;


        CommonTree o_tree=null;
        RewriteRuleNodeStream stream_ORDER=new RewriteRuleNodeStream(adaptor,"token ORDER");
        RewriteRuleSubtreeStream stream_orderCondition=new RewriteRuleSubtreeStream(adaptor,"rule orderCondition");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2114:3: ( ^(o= ORDER orderCondition ) -> QSTRING[$o.token, $o.text + \" by \"] orderCondition )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2114:5: ^(o= ORDER orderCondition )
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            o=(CommonTree)match(input,ORDER,FOLLOW_ORDER_in_orderclause9595); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_ORDER.add(o);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_orderCondition_in_orderclause9597);
            orderCondition546=orderCondition();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_orderCondition.add(orderCondition546.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }



            // AST REWRITE
            // elements: orderCondition
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 2115:3: -> QSTRING[$o.token, $o.text + \" by \"] orderCondition
            {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, o.token, (o!=null?o.getText():null) + " by "));
                adaptor.addChild(root_0, stream_orderCondition.nextTree());

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "orderclause"

    public static class orderCondition_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "orderCondition"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2118:1: orderCondition : ( ( ASC | DESC ) brackettedExpression | constraint | v= VAR -> QSTRING[$v.token, $v.text+ \" \"] );
    public final XSPARQLRewriter.orderCondition_return orderCondition() throws RecognitionException {
        XSPARQLRewriter.orderCondition_return retval = new XSPARQLRewriter.orderCondition_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree v=null;
        CommonTree set547=null;
        XSPARQLRewriter.brackettedExpression_return brackettedExpression548 = null;

        XSPARQLRewriter.constraint_return constraint549 = null;


        CommonTree v_tree=null;
        CommonTree set547_tree=null;
        RewriteRuleNodeStream stream_VAR=new RewriteRuleNodeStream(adaptor,"token VAR");

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2119:3: ( ( ASC | DESC ) brackettedExpression | constraint | v= VAR -> QSTRING[$v.token, $v.text+ \" \"] )
            int alt149=3;
            switch ( input.LA(1) ) {
            case ASC:
            case DESC:
                {
                alt149=1;
                }
                break;
            case LPAR:
            case PNAME_NS:
            case PNAME_LN:
            case IRIREF:
            case STR:
            case LANG:
            case LANGMATCHES:
            case DATATYPE:
            case BOUND:
            case ISIRI:
            case ISURI:
            case ISBLANK:
            case ISLITERAL:
            case REGEX:
                {
                alt149=2;
                }
                break;
            case VAR:
                {
                alt149=3;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 149, 0, input);

                throw nvae;
            }

            switch (alt149) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2119:5: ( ASC | DESC ) brackettedExpression
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    set547=(CommonTree)input.LT(1);
                    if ( (input.LA(1)>=ASC && input.LA(1)<=DESC) ) {
                        input.consume();

                        if ( state.backtracking==0 ) {
                        set547_tree = (CommonTree)adaptor.dupNode(set547);

                        adaptor.addChild(root_0, set547_tree);
                        }
                        state.errorRecovery=false;state.failed=false;
                    }
                    else {
                        if (state.backtracking>0) {state.failed=true; return retval;}
                        MismatchedSetException mse = new MismatchedSetException(null,input);
                        throw mse;
                    }

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_brackettedExpression_in_orderCondition9628);
                    brackettedExpression548=brackettedExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, brackettedExpression548.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2120:5: constraint
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_constraint_in_orderCondition9634);
                    constraint549=constraint();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, constraint549.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2121:5: v= VAR
                    {
                    _last = (CommonTree)input.LT(1);
                    v=(CommonTree)match(input,VAR,FOLLOW_VAR_in_orderCondition9642); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_VAR.add(v);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2121:11: -> QSTRING[$v.token, $v.text+ \" \"]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, v.token, (v!=null?v.getText():null)+ " "));

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "orderCondition"

    public static class limitclause_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "limitclause"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2124:1: limitclause : ^(l= LIMIT i= INTEGER ) -> QSTRING[$l.token, $l.text + \" \" + $i.text + \" \"] ;
    public final XSPARQLRewriter.limitclause_return limitclause() throws RecognitionException {
        XSPARQLRewriter.limitclause_return retval = new XSPARQLRewriter.limitclause_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree l=null;
        CommonTree i=null;

        CommonTree l_tree=null;
        CommonTree i_tree=null;
        RewriteRuleNodeStream stream_INTEGER=new RewriteRuleNodeStream(adaptor,"token INTEGER");
        RewriteRuleNodeStream stream_LIMIT=new RewriteRuleNodeStream(adaptor,"token LIMIT");

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2125:3: ( ^(l= LIMIT i= INTEGER ) -> QSTRING[$l.token, $l.text + \" \" + $i.text + \" \"] )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2125:5: ^(l= LIMIT i= INTEGER )
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            l=(CommonTree)match(input,LIMIT,FOLLOW_LIMIT_in_limitclause9663); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_LIMIT.add(l);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            i=(CommonTree)match(input,INTEGER,FOLLOW_INTEGER_in_limitclause9667); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_INTEGER.add(i);


            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }



            // AST REWRITE
            // elements: 
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 2126:3: -> QSTRING[$l.token, $l.text + \" \" + $i.text + \" \"]
            {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, l.token, (l!=null?l.getText():null) + " " + (i!=null?i.getText():null) + " "));

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "limitclause"

    public static class offsetclause_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "offsetclause"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2129:1: offsetclause : ^(o= OFFSET i= INTEGER ) -> QSTRING[$o.token, $o.text + \" \" + $i.text + \" \"] ;
    public final XSPARQLRewriter.offsetclause_return offsetclause() throws RecognitionException {
        XSPARQLRewriter.offsetclause_return retval = new XSPARQLRewriter.offsetclause_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree o=null;
        CommonTree i=null;

        CommonTree o_tree=null;
        CommonTree i_tree=null;
        RewriteRuleNodeStream stream_INTEGER=new RewriteRuleNodeStream(adaptor,"token INTEGER");
        RewriteRuleNodeStream stream_OFFSET=new RewriteRuleNodeStream(adaptor,"token OFFSET");

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2130:3: ( ^(o= OFFSET i= INTEGER ) -> QSTRING[$o.token, $o.text + \" \" + $i.text + \" \"] )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2130:5: ^(o= OFFSET i= INTEGER )
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            o=(CommonTree)match(input,OFFSET,FOLLOW_OFFSET_in_offsetclause9691); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_OFFSET.add(o);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            i=(CommonTree)match(input,INTEGER,FOLLOW_INTEGER_in_offsetclause9695); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_INTEGER.add(i);


            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }



            // AST REWRITE
            // elements: 
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 2131:3: -> QSTRING[$o.token, $o.text + \" \" + $i.text + \" \"]
            {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, o.token, (o!=null?o.getText():null) + " " + (i!=null?i.getText():null) + " "));

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "offsetclause"

    public static class groupGraphPattern_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "groupGraphPattern"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2134:1: groupGraphPattern options {backtrack=true; } : ( singleGroupGraphPattern )+ -> QSTRING[\" { \"] ( singleGroupGraphPattern )+ QSTRING[\" } \"] ;
    public final XSPARQLRewriter.groupGraphPattern_return groupGraphPattern() throws RecognitionException {
        XSPARQLRewriter.groupGraphPattern_return retval = new XSPARQLRewriter.groupGraphPattern_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.singleGroupGraphPattern_return singleGroupGraphPattern550 = null;


        RewriteRuleSubtreeStream stream_singleGroupGraphPattern=new RewriteRuleSubtreeStream(adaptor,"rule singleGroupGraphPattern");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2138:3: ( ( singleGroupGraphPattern )+ -> QSTRING[\" { \"] ( singleGroupGraphPattern )+ QSTRING[\" } \"] )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2138:5: ( singleGroupGraphPattern )+
            {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2138:5: ( singleGroupGraphPattern )+
            int cnt150=0;
            loop150:
            do {
                int alt150=2;
                switch ( input.LA(1) ) {
                case UNION:
                case OPTIONAL:
                case FILTER:
                case GRAPH:
                case T_SUBJECT:
                    {
                    alt150=1;
                    }
                    break;

                }

                switch (alt150) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: singleGroupGraphPattern
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_singleGroupGraphPattern_in_groupGraphPattern9725);
            	    singleGroupGraphPattern550=singleGroupGraphPattern();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_singleGroupGraphPattern.add(singleGroupGraphPattern550.getTree());

            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    if ( cnt150 >= 1 ) break loop150;
            	    if (state.backtracking>0) {state.failed=true; return retval;}
                        EarlyExitException eee =
                            new EarlyExitException(150, input);
                        throw eee;
                }
                cnt150++;
            } while (true);



            // AST REWRITE
            // elements: singleGroupGraphPattern
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 2139:3: -> QSTRING[\" { \"] ( singleGroupGraphPattern )+ QSTRING[\" } \"]
            {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, " { "));
                if ( !(stream_singleGroupGraphPattern.hasNext()) ) {
                    throw new RewriteEarlyExitException();
                }
                while ( stream_singleGroupGraphPattern.hasNext() ) {
                    adaptor.addChild(root_0, stream_singleGroupGraphPattern.nextTree());

                }
                stream_singleGroupGraphPattern.reset();
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, " } "));

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "groupGraphPattern"

    public static class singleGroupGraphPattern_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "singleGroupGraphPattern"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2142:1: singleGroupGraphPattern options {backtrack=true; } : ( triplesBlock | graphPatternNotTriples | filter );
    public final XSPARQLRewriter.singleGroupGraphPattern_return singleGroupGraphPattern() throws RecognitionException {
        XSPARQLRewriter.singleGroupGraphPattern_return retval = new XSPARQLRewriter.singleGroupGraphPattern_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.triplesBlock_return triplesBlock551 = null;

        XSPARQLRewriter.graphPatternNotTriples_return graphPatternNotTriples552 = null;

        XSPARQLRewriter.filter_return filter553 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2146:3: ( triplesBlock | graphPatternNotTriples | filter )
            int alt151=3;
            switch ( input.LA(1) ) {
            case T_SUBJECT:
                {
                alt151=1;
                }
                break;
            case UNION:
            case OPTIONAL:
            case GRAPH:
                {
                alt151=2;
                }
                break;
            case FILTER:
                {
                alt151=3;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 151, 0, input);

                throw nvae;
            }

            switch (alt151) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2146:5: triplesBlock
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_triplesBlock_in_singleGroupGraphPattern9761);
                    triplesBlock551=triplesBlock();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, triplesBlock551.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2147:5: graphPatternNotTriples
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_graphPatternNotTriples_in_singleGroupGraphPattern9767);
                    graphPatternNotTriples552=graphPatternNotTriples();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, graphPatternNotTriples552.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2148:5: filter
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_filter_in_singleGroupGraphPattern9773);
                    filter553=filter();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, filter553.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "singleGroupGraphPattern"

    public static class triplesBlock_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "triplesBlock"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2151:1: triplesBlock : ( triplesSameSubject )+ ;
    public final XSPARQLRewriter.triplesBlock_return triplesBlock() throws RecognitionException {
        XSPARQLRewriter.triplesBlock_return retval = new XSPARQLRewriter.triplesBlock_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.triplesSameSubject_return triplesSameSubject554 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2152:3: ( ( triplesSameSubject )+ )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2152:5: ( triplesSameSubject )+
            {
            root_0 = (CommonTree)adaptor.nil();

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2152:5: ( triplesSameSubject )+
            int cnt152=0;
            loop152:
            do {
                int alt152=2;
                switch ( input.LA(1) ) {
                case T_SUBJECT:
                    {
                    int LA152_2 = input.LA(2);

                    if ( (synpred253_XSPARQLRewriter()) ) {
                        alt152=1;
                    }


                    }
                    break;

                }

                switch (alt152) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: triplesSameSubject
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_triplesSameSubject_in_triplesBlock9788);
            	    triplesSameSubject554=triplesSameSubject();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) 
            	    adaptor.addChild(root_0, triplesSameSubject554.getTree());

            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    if ( cnt152 >= 1 ) break loop152;
            	    if (state.backtracking>0) {state.failed=true; return retval;}
                        EarlyExitException eee =
                            new EarlyExitException(152, input);
                        throw eee;
                }
                cnt152++;
            } while (true);


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "triplesBlock"

    public static class graphPatternNotTriples_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "graphPatternNotTriples"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2155:1: graphPatternNotTriples : ( optionalGraphPattern | groupOrUnionGraphPattern | graphGraphPattern );
    public final XSPARQLRewriter.graphPatternNotTriples_return graphPatternNotTriples() throws RecognitionException {
        XSPARQLRewriter.graphPatternNotTriples_return retval = new XSPARQLRewriter.graphPatternNotTriples_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.optionalGraphPattern_return optionalGraphPattern555 = null;

        XSPARQLRewriter.groupOrUnionGraphPattern_return groupOrUnionGraphPattern556 = null;

        XSPARQLRewriter.graphGraphPattern_return graphGraphPattern557 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2156:3: ( optionalGraphPattern | groupOrUnionGraphPattern | graphGraphPattern )
            int alt153=3;
            switch ( input.LA(1) ) {
            case OPTIONAL:
                {
                alt153=1;
                }
                break;
            case UNION:
                {
                alt153=2;
                }
                break;
            case GRAPH:
                {
                alt153=3;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 153, 0, input);

                throw nvae;
            }

            switch (alt153) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2156:5: optionalGraphPattern
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_optionalGraphPattern_in_graphPatternNotTriples9802);
                    optionalGraphPattern555=optionalGraphPattern();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, optionalGraphPattern555.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2157:5: groupOrUnionGraphPattern
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_groupOrUnionGraphPattern_in_graphPatternNotTriples9808);
                    groupOrUnionGraphPattern556=groupOrUnionGraphPattern();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, groupOrUnionGraphPattern556.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2158:5: graphGraphPattern
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_graphGraphPattern_in_graphPatternNotTriples9814);
                    graphGraphPattern557=graphGraphPattern();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, graphGraphPattern557.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "graphPatternNotTriples"

    public static class optionalGraphPattern_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "optionalGraphPattern"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2161:1: optionalGraphPattern : ^(o= OPTIONAL groupGraphPattern ) -> QSTRING[$o.token, \"\\n \" + $o.text +\" \"] groupGraphPattern ;
    public final XSPARQLRewriter.optionalGraphPattern_return optionalGraphPattern() throws RecognitionException {
        XSPARQLRewriter.optionalGraphPattern_return retval = new XSPARQLRewriter.optionalGraphPattern_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree o=null;
        XSPARQLRewriter.groupGraphPattern_return groupGraphPattern558 = null;


        CommonTree o_tree=null;
        RewriteRuleNodeStream stream_OPTIONAL=new RewriteRuleNodeStream(adaptor,"token OPTIONAL");
        RewriteRuleSubtreeStream stream_groupGraphPattern=new RewriteRuleSubtreeStream(adaptor,"rule groupGraphPattern");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2162:3: ( ^(o= OPTIONAL groupGraphPattern ) -> QSTRING[$o.token, \"\\n \" + $o.text +\" \"] groupGraphPattern )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2162:5: ^(o= OPTIONAL groupGraphPattern )
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            o=(CommonTree)match(input,OPTIONAL,FOLLOW_OPTIONAL_in_optionalGraphPattern9830); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_OPTIONAL.add(o);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_groupGraphPattern_in_optionalGraphPattern9832);
            groupGraphPattern558=groupGraphPattern();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_groupGraphPattern.add(groupGraphPattern558.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }



            // AST REWRITE
            // elements: groupGraphPattern
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 2163:3: -> QSTRING[$o.token, \"\\n \" + $o.text +\" \"] groupGraphPattern
            {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, o.token, "\n " + (o!=null?o.getText():null) +" "));
                adaptor.addChild(root_0, stream_groupGraphPattern.nextTree());

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "optionalGraphPattern"

    public static class graphGraphPattern_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "graphGraphPattern"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2166:1: graphGraphPattern : ^(g= GRAPH varOrIRIref groupGraphPattern ) -> QSTRING[$g.token,\"\\n \" + $g.text + \" \"] varOrIRIref groupGraphPattern ;
    public final XSPARQLRewriter.graphGraphPattern_return graphGraphPattern() throws RecognitionException {
        XSPARQLRewriter.graphGraphPattern_return retval = new XSPARQLRewriter.graphGraphPattern_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree g=null;
        XSPARQLRewriter.varOrIRIref_return varOrIRIref559 = null;

        XSPARQLRewriter.groupGraphPattern_return groupGraphPattern560 = null;


        CommonTree g_tree=null;
        RewriteRuleNodeStream stream_GRAPH=new RewriteRuleNodeStream(adaptor,"token GRAPH");
        RewriteRuleSubtreeStream stream_varOrIRIref=new RewriteRuleSubtreeStream(adaptor,"rule varOrIRIref");
        RewriteRuleSubtreeStream stream_groupGraphPattern=new RewriteRuleSubtreeStream(adaptor,"rule groupGraphPattern");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2167:3: ( ^(g= GRAPH varOrIRIref groupGraphPattern ) -> QSTRING[$g.token,\"\\n \" + $g.text + \" \"] varOrIRIref groupGraphPattern )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2167:5: ^(g= GRAPH varOrIRIref groupGraphPattern )
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            g=(CommonTree)match(input,GRAPH,FOLLOW_GRAPH_in_graphGraphPattern9858); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_GRAPH.add(g);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_varOrIRIref_in_graphGraphPattern9860);
            varOrIRIref559=varOrIRIref();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_varOrIRIref.add(varOrIRIref559.getTree());
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_groupGraphPattern_in_graphGraphPattern9862);
            groupGraphPattern560=groupGraphPattern();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_groupGraphPattern.add(groupGraphPattern560.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }



            // AST REWRITE
            // elements: groupGraphPattern, varOrIRIref
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 2168:3: -> QSTRING[$g.token,\"\\n \" + $g.text + \" \"] varOrIRIref groupGraphPattern
            {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, g.token, "\n " + (g!=null?g.getText():null) + " "));
                adaptor.addChild(root_0, stream_varOrIRIref.nextTree());
                adaptor.addChild(root_0, stream_groupGraphPattern.nextTree());

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "graphGraphPattern"

    public static class groupOrUnionGraphPattern_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "groupOrUnionGraphPattern"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2171:1: groupOrUnionGraphPattern : ^(u= UNION ^( T_UNION g1= groupGraphPattern ) ( ^( T_UNION g2+= groupGraphPattern ) )+ ) -> QSTRING[\" { \"] $g1 ( QSTRING[$u.token,\" } \\n\" + $u.text + \" { \"] $g2)+ QSTRING[\" } \"] ;
    public final XSPARQLRewriter.groupOrUnionGraphPattern_return groupOrUnionGraphPattern() throws RecognitionException {
        XSPARQLRewriter.groupOrUnionGraphPattern_return retval = new XSPARQLRewriter.groupOrUnionGraphPattern_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree u=null;
        CommonTree T_UNION561=null;
        CommonTree T_UNION562=null;
        List list_g2=null;
        XSPARQLRewriter.groupGraphPattern_return g1 = null;

        RuleReturnScope g2 = null;
        CommonTree u_tree=null;
        CommonTree T_UNION561_tree=null;
        CommonTree T_UNION562_tree=null;
        RewriteRuleNodeStream stream_T_UNION=new RewriteRuleNodeStream(adaptor,"token T_UNION");
        RewriteRuleNodeStream stream_UNION=new RewriteRuleNodeStream(adaptor,"token UNION");
        RewriteRuleSubtreeStream stream_groupGraphPattern=new RewriteRuleSubtreeStream(adaptor,"rule groupGraphPattern");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2172:3: ( ^(u= UNION ^( T_UNION g1= groupGraphPattern ) ( ^( T_UNION g2+= groupGraphPattern ) )+ ) -> QSTRING[\" { \"] $g1 ( QSTRING[$u.token,\" } \\n\" + $u.text + \" { \"] $g2)+ QSTRING[\" } \"] )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2172:5: ^(u= UNION ^( T_UNION g1= groupGraphPattern ) ( ^( T_UNION g2+= groupGraphPattern ) )+ )
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            u=(CommonTree)match(input,UNION,FOLLOW_UNION_in_groupOrUnionGraphPattern9890); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_UNION.add(u);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_2 = _last;
            CommonTree _first_2 = null;
            CommonTree root_2 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_UNION561=(CommonTree)match(input,T_UNION,FOLLOW_T_UNION_in_groupOrUnionGraphPattern9893); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_T_UNION.add(T_UNION561);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_groupGraphPattern_in_groupOrUnionGraphPattern9897);
            g1=groupGraphPattern();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_groupGraphPattern.add(g1.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_1, root_2);_last = _save_last_2;
            }

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2172:47: ( ^( T_UNION g2+= groupGraphPattern ) )+
            int cnt154=0;
            loop154:
            do {
                int alt154=2;
                switch ( input.LA(1) ) {
                case T_UNION:
                    {
                    alt154=1;
                    }
                    break;

                }

                switch (alt154) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2172:48: ^( T_UNION g2+= groupGraphPattern )
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    {
            	    CommonTree _save_last_2 = _last;
            	    CommonTree _first_2 = null;
            	    CommonTree root_2 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            	    T_UNION562=(CommonTree)match(input,T_UNION,FOLLOW_T_UNION_in_groupOrUnionGraphPattern9902); if (state.failed) return retval; 
            	    if ( state.backtracking==0 ) stream_T_UNION.add(T_UNION562);



            	    match(input, Token.DOWN, null); if (state.failed) return retval;
            	    _last = (CommonTree)input.LT(1);
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_groupGraphPattern_in_groupOrUnionGraphPattern9906);
            	    g2=groupGraphPattern();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_groupGraphPattern.add(g2.getTree());
            	    if (list_g2==null) list_g2=new ArrayList();
            	    list_g2.add(g2.getTree());


            	    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_1, root_2);_last = _save_last_2;
            	    }


            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    if ( cnt154 >= 1 ) break loop154;
            	    if (state.backtracking>0) {state.failed=true; return retval;}
                        EarlyExitException eee =
                            new EarlyExitException(154, input);
                        throw eee;
                }
                cnt154++;
            } while (true);


            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }



            // AST REWRITE
            // elements: g2, g1
            // token labels: 
            // rule labels: retval, g1
            // token list labels: 
            // rule list labels: g2
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
            RewriteRuleSubtreeStream stream_g1=new RewriteRuleSubtreeStream(adaptor,"rule g1",g1!=null?g1.tree:null);
            RewriteRuleSubtreeStream stream_g2=new RewriteRuleSubtreeStream(adaptor,"token g2",list_g2);
            root_0 = (CommonTree)adaptor.nil();
            // 2173:3: -> QSTRING[\" { \"] $g1 ( QSTRING[$u.token,\" } \\n\" + $u.text + \" { \"] $g2)+ QSTRING[\" } \"]
            {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, " { "));
                adaptor.addChild(root_0, stream_g1.nextTree());
                if ( !(stream_g2.hasNext()) ) {
                    throw new RewriteEarlyExitException();
                }
                while ( stream_g2.hasNext() ) {
                    adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, u.token, " } \n" + (u!=null?u.getText():null) + " { "));
                    adaptor.addChild(root_0, stream_g2.nextTree());

                }
                stream_g2.reset();
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, " } "));

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "groupOrUnionGraphPattern"

    public static class filter_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "filter"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2176:1: filter : ^(f= FILTER constraint ) -> QSTRING[$f.token, \"\\n \"+$f.text] constraint ;
    public final XSPARQLRewriter.filter_return filter() throws RecognitionException {
        XSPARQLRewriter.filter_return retval = new XSPARQLRewriter.filter_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree f=null;
        XSPARQLRewriter.constraint_return constraint563 = null;


        CommonTree f_tree=null;
        RewriteRuleNodeStream stream_FILTER=new RewriteRuleNodeStream(adaptor,"token FILTER");
        RewriteRuleSubtreeStream stream_constraint=new RewriteRuleSubtreeStream(adaptor,"rule constraint");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2177:3: ( ^(f= FILTER constraint ) -> QSTRING[$f.token, \"\\n \"+$f.text] constraint )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2177:5: ^(f= FILTER constraint )
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            f=(CommonTree)match(input,FILTER,FOLLOW_FILTER_in_filter9948); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_FILTER.add(f);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_constraint_in_filter9950);
            constraint563=constraint();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_constraint.add(constraint563.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }



            // AST REWRITE
            // elements: constraint
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 2178:3: -> QSTRING[$f.token, \"\\n \"+$f.text] constraint
            {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, f.token, "\n "+(f!=null?f.getText():null)));
                adaptor.addChild(root_0, stream_constraint.nextTree());

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "filter"

    public static class constraint_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "constraint"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2181:1: constraint : ( brackettedExpression | builtInCall | sFunctionCall );
    public final XSPARQLRewriter.constraint_return constraint() throws RecognitionException {
        XSPARQLRewriter.constraint_return retval = new XSPARQLRewriter.constraint_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.brackettedExpression_return brackettedExpression564 = null;

        XSPARQLRewriter.builtInCall_return builtInCall565 = null;

        XSPARQLRewriter.sFunctionCall_return sFunctionCall566 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2182:3: ( brackettedExpression | builtInCall | sFunctionCall )
            int alt155=3;
            switch ( input.LA(1) ) {
            case LPAR:
                {
                alt155=1;
                }
                break;
            case STR:
            case LANG:
            case LANGMATCHES:
            case DATATYPE:
            case BOUND:
            case ISIRI:
            case ISURI:
            case ISBLANK:
            case ISLITERAL:
            case REGEX:
                {
                alt155=2;
                }
                break;
            case PNAME_NS:
            case PNAME_LN:
            case IRIREF:
                {
                alt155=3;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 155, 0, input);

                throw nvae;
            }

            switch (alt155) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2182:5: brackettedExpression
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_brackettedExpression_in_constraint9973);
                    brackettedExpression564=brackettedExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, brackettedExpression564.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2183:5: builtInCall
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_builtInCall_in_constraint9979);
                    builtInCall565=builtInCall();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, builtInCall565.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2184:5: sFunctionCall
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_sFunctionCall_in_constraint9985);
                    sFunctionCall566=sFunctionCall();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, sFunctionCall566.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "constraint"

    public static class sFunctionCall_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "sFunctionCall"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2187:1: sFunctionCall : iRIref ( arglist )? ;
    public final XSPARQLRewriter.sFunctionCall_return sFunctionCall() throws RecognitionException {
        XSPARQLRewriter.sFunctionCall_return retval = new XSPARQLRewriter.sFunctionCall_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.iRIref_return iRIref567 = null;

        XSPARQLRewriter.arglist_return arglist568 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2188:3: ( iRIref ( arglist )? )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2188:5: iRIref ( arglist )?
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_iRIref_in_sFunctionCall9998);
            iRIref567=iRIref();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, iRIref567.getTree());
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2188:12: ( arglist )?
            int alt156=2;
            switch ( input.LA(1) ) {
                case VAR:
                case INTEGER:
                case QSTRING:
                case SLASH:
                case LPAR:
                case STAR:
                case LESSTHAN:
                case GREATERTHAN:
                case PLUS:
                case MINUS:
                case GREATERTHANEQUALS:
                case LESSTHANEQUALS:
                case HAFENEQUALS:
                case EQUALS:
                case ORSYMBOL:
                case ANDSYMBOL:
                case NOT:
                case STR:
                case LANG:
                case LANGMATCHES:
                case DATATYPE:
                case BOUND:
                case ISIRI:
                case ISURI:
                case ISBLANK:
                case ISLITERAL:
                case REGEX:
                case TRUE:
                case FALSE:
                case T_FUNCTION_CALL:
                    {
                    alt156=1;
                    }
                    break;
            }

            switch (alt156) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: arglist
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_arglist_in_sFunctionCall10000);
                    arglist568=arglist();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, arglist568.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "sFunctionCall"

    public static class arglist_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "arglist"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2191:1: arglist options {backtrack=true; } : e1= expression (e2+= expression )* -> $e1 ( QSTRING[\",\"] $e2)* ;
    public final XSPARQLRewriter.arglist_return arglist() throws RecognitionException {
        XSPARQLRewriter.arglist_return retval = new XSPARQLRewriter.arglist_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        List list_e2=null;
        XSPARQLRewriter.expression_return e1 = null;

        RuleReturnScope e2 = null;
        RewriteRuleSubtreeStream stream_expression=new RewriteRuleSubtreeStream(adaptor,"rule expression");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2193:3: (e1= expression (e2+= expression )* -> $e1 ( QSTRING[\",\"] $e2)* )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2193:6: e1= expression (e2+= expression )*
            {
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_expression_in_arglist10024);
            e1=expression();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_expression.add(e1.getTree());
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2193:22: (e2+= expression )*
            loop157:
            do {
                int alt157=2;
                switch ( input.LA(1) ) {
                case VAR:
                case INTEGER:
                case QSTRING:
                case SLASH:
                case LPAR:
                case STAR:
                case LESSTHAN:
                case GREATERTHAN:
                case PLUS:
                case MINUS:
                case GREATERTHANEQUALS:
                case LESSTHANEQUALS:
                case HAFENEQUALS:
                case EQUALS:
                case ORSYMBOL:
                case ANDSYMBOL:
                case NOT:
                case STR:
                case LANG:
                case LANGMATCHES:
                case DATATYPE:
                case BOUND:
                case ISIRI:
                case ISURI:
                case ISBLANK:
                case ISLITERAL:
                case REGEX:
                case TRUE:
                case FALSE:
                case T_FUNCTION_CALL:
                    {
                    alt157=1;
                    }
                    break;

                }

                switch (alt157) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: e2+= expression
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_expression_in_arglist10028);
            	    e2=expression();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_expression.add(e2.getTree());
            	    if (list_e2==null) list_e2=new ArrayList();
            	    list_e2.add(e2.getTree());


            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    break loop157;
                }
            } while (true);



            // AST REWRITE
            // elements: e1, e2
            // token labels: 
            // rule labels: retval, e1
            // token list labels: 
            // rule list labels: e2
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
            RewriteRuleSubtreeStream stream_e1=new RewriteRuleSubtreeStream(adaptor,"rule e1",e1!=null?e1.tree:null);
            RewriteRuleSubtreeStream stream_e2=new RewriteRuleSubtreeStream(adaptor,"token e2",list_e2);
            root_0 = (CommonTree)adaptor.nil();
            // 2193:36: -> $e1 ( QSTRING[\",\"] $e2)*
            {
                adaptor.addChild(root_0, stream_e1.nextTree());
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2193:43: ( QSTRING[\",\"] $e2)*
                while ( stream_e2.hasNext() ) {
                    adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, ","));
                    adaptor.addChild(root_0, stream_e2.nextTree());

                }
                stream_e2.reset();

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "arglist"

    public static class constructTemplate_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "constructTemplate"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2196:1: constructTemplate : ( constructTriples )? ;
    public final XSPARQLRewriter.constructTemplate_return constructTemplate() throws RecognitionException {
        XSPARQLRewriter.constructTemplate_return retval = new XSPARQLRewriter.constructTemplate_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.constructTriples_return constructTriples569 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2197:3: ( ( constructTriples )? )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2197:5: ( constructTriples )?
            {
            root_0 = (CommonTree)adaptor.nil();

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2197:5: ( constructTriples )?
            int alt158=2;
            switch ( input.LA(1) ) {
                case LCURLY:
                case STAR:
                case LESSTHAN:
                case GREATERTHAN:
                case PLUS:
                case MINUS:
                case UNIONSYMBOL:
                case LESSTHANLESSTHAN:
                case GREATERTHANEQUALS:
                case LESSTHANEQUALS:
                case HAFENEQUALS:
                case EQUALS:
                case IS:
                case EQ:
                case NE:
                case LT:
                case GE:
                case LE:
                case GT:
                case IF:
                case AND:
                case OR:
                case TO:
                case DIV:
                case IDIV:
                case MOD:
                case UNION:
                case INTERSECT:
                case EXCEPT:
                case GREATERTHANGREATERTHAN:
                case T_FLWOR:
                case T_SUBJECT:
                case T_INSTANCEOF:
                case T_CASTAS:
                case T_CASTABLEAS:
                case T_TREATAS:
                case EVERY:
                case TYPESWITCH:
                case VALIDATE:
                case SOME:
                case XPATH:
                    {
                    alt158=1;
                    }
                    break;
            }

            switch (alt158) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: constructTriples
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_constructTriples_in_constructTemplate10056);
                    constructTriples569=constructTriples();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, constructTriples569.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "constructTemplate"

    public static class constructTriples_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "constructTriples"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2200:1: constructTriples : ( triplesSameSubject_ | enclosedExpr )+ ;
    public final XSPARQLRewriter.constructTriples_return constructTriples() throws RecognitionException {
        XSPARQLRewriter.constructTriples_return retval = new XSPARQLRewriter.constructTriples_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.triplesSameSubject__return triplesSameSubject_570 = null;

        XSPARQLRewriter.enclosedExpr_return enclosedExpr571 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2201:3: ( ( triplesSameSubject_ | enclosedExpr )+ )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2201:5: ( triplesSameSubject_ | enclosedExpr )+
            {
            root_0 = (CommonTree)adaptor.nil();

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2201:5: ( triplesSameSubject_ | enclosedExpr )+
            int cnt159=0;
            loop159:
            do {
                int alt159=3;
                switch ( input.LA(1) ) {
                case T_SUBJECT:
                    {
                    alt159=1;
                    }
                    break;
                case LCURLY:
                case STAR:
                case LESSTHAN:
                case GREATERTHAN:
                case PLUS:
                case MINUS:
                case UNIONSYMBOL:
                case LESSTHANLESSTHAN:
                case GREATERTHANEQUALS:
                case LESSTHANEQUALS:
                case HAFENEQUALS:
                case EQUALS:
                case IS:
                case EQ:
                case NE:
                case LT:
                case GE:
                case LE:
                case GT:
                case IF:
                case AND:
                case OR:
                case TO:
                case DIV:
                case IDIV:
                case MOD:
                case UNION:
                case INTERSECT:
                case EXCEPT:
                case GREATERTHANGREATERTHAN:
                case T_FLWOR:
                case T_INSTANCEOF:
                case T_CASTAS:
                case T_CASTABLEAS:
                case T_TREATAS:
                case EVERY:
                case TYPESWITCH:
                case VALIDATE:
                case SOME:
                case XPATH:
                    {
                    alt159=2;
                    }
                    break;

                }

                switch (alt159) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2201:6: triplesSameSubject_
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_triplesSameSubject__in_constructTriples10071);
            	    triplesSameSubject_570=triplesSameSubject_();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) 
            	    adaptor.addChild(root_0, triplesSameSubject_570.getTree());

            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;
            	case 2 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2201:28: enclosedExpr
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_enclosedExpr_in_constructTriples10075);
            	    enclosedExpr571=enclosedExpr();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) 
            	    adaptor.addChild(root_0, enclosedExpr571.getTree());

            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    if ( cnt159 >= 1 ) break loop159;
            	    if (state.backtracking>0) {state.failed=true; return retval;}
                        EarlyExitException eee =
                            new EarlyExitException(159, input);
                        throw eee;
                }
                cnt159++;
            } while (true);


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "constructTriples"

    public static class triplesSameSubject_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "triplesSameSubject"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2204:1: triplesSameSubject : ( ^( T_SUBJECT subject propertyListNotEmpty ) -> subject QSTRING[\" \"] propertyListNotEmpty QSTRING[\" . \\n\"] | ^( T_SUBJECT triplesNode ( propertyListNotEmpty )? ) -> triplesNode ( propertyListNotEmpty )? QSTRING[\" . \\n\"] );
    public final XSPARQLRewriter.triplesSameSubject_return triplesSameSubject() throws RecognitionException {
        XSPARQLRewriter.triplesSameSubject_return retval = new XSPARQLRewriter.triplesSameSubject_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_SUBJECT572=null;
        CommonTree T_SUBJECT575=null;
        XSPARQLRewriter.subject_return subject573 = null;

        XSPARQLRewriter.propertyListNotEmpty_return propertyListNotEmpty574 = null;

        XSPARQLRewriter.triplesNode_return triplesNode576 = null;

        XSPARQLRewriter.propertyListNotEmpty_return propertyListNotEmpty577 = null;


        CommonTree T_SUBJECT572_tree=null;
        CommonTree T_SUBJECT575_tree=null;
        RewriteRuleNodeStream stream_T_SUBJECT=new RewriteRuleNodeStream(adaptor,"token T_SUBJECT");
        RewriteRuleSubtreeStream stream_propertyListNotEmpty=new RewriteRuleSubtreeStream(adaptor,"rule propertyListNotEmpty");
        RewriteRuleSubtreeStream stream_subject=new RewriteRuleSubtreeStream(adaptor,"rule subject");
        RewriteRuleSubtreeStream stream_triplesNode=new RewriteRuleSubtreeStream(adaptor,"rule triplesNode");
        logger.info("triplesSameSubject");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2206:3: ( ^( T_SUBJECT subject propertyListNotEmpty ) -> subject QSTRING[\" \"] propertyListNotEmpty QSTRING[\" . \\n\"] | ^( T_SUBJECT triplesNode ( propertyListNotEmpty )? ) -> triplesNode ( propertyListNotEmpty )? QSTRING[\" . \\n\"] )
            int alt161=2;
            switch ( input.LA(1) ) {
            case T_SUBJECT:
                {
                switch ( input.LA(2) ) {
                case DOWN:
                    {
                    switch ( input.LA(3) ) {
                    case LPAR:
                    case T_ANON_BLANK:
                        {
                        alt161=2;
                        }
                        break;
                    case VAR:
                    case BLANK_NODE_LABEL:
                    case PNAME_NS:
                    case PNAME_LN:
                    case IRIREF:
                    case T_EMPTY_ANON_BLANK:
                        {
                        alt161=1;
                        }
                        break;
                    default:
                        if (state.backtracking>0) {state.failed=true; return retval;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 161, 2, input);

                        throw nvae;
                    }

                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 161, 1, input);

                    throw nvae;
                }

                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 161, 0, input);

                throw nvae;
            }

            switch (alt161) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2206:5: ^( T_SUBJECT subject propertyListNotEmpty )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_SUBJECT572=(CommonTree)match(input,T_SUBJECT,FOLLOW_T_SUBJECT_in_triplesSameSubject10095); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_SUBJECT.add(T_SUBJECT572);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_subject_in_triplesSameSubject10097);
                    subject573=subject();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_subject.add(subject573.getTree());
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_propertyListNotEmpty_in_triplesSameSubject10099);
                    propertyListNotEmpty574=propertyListNotEmpty();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_propertyListNotEmpty.add(propertyListNotEmpty574.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: subject, propertyListNotEmpty
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2207:3: -> subject QSTRING[\" \"] propertyListNotEmpty QSTRING[\" . \\n\"]
                    {
                        adaptor.addChild(root_0, stream_subject.nextTree());
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, " "));
                        adaptor.addChild(root_0, stream_propertyListNotEmpty.nextTree());
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, " . \n"));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2208:5: ^( T_SUBJECT triplesNode ( propertyListNotEmpty )? )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_SUBJECT575=(CommonTree)match(input,T_SUBJECT,FOLLOW_T_SUBJECT_in_triplesSameSubject10122); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_SUBJECT.add(T_SUBJECT575);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_triplesNode_in_triplesSameSubject10124);
                    triplesNode576=triplesNode();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_triplesNode.add(triplesNode576.getTree());
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2208:29: ( propertyListNotEmpty )?
                    int alt160=2;
                    switch ( input.LA(1) ) {
                        case T_VERB:
                            {
                            alt160=1;
                            }
                            break;
                    }

                    switch (alt160) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: propertyListNotEmpty
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_propertyListNotEmpty_in_triplesSameSubject10126);
                            propertyListNotEmpty577=propertyListNotEmpty();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_propertyListNotEmpty.add(propertyListNotEmpty577.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }


                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: triplesNode, propertyListNotEmpty
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2209:3: -> triplesNode ( propertyListNotEmpty )? QSTRING[\" . \\n\"]
                    {
                        adaptor.addChild(root_0, stream_triplesNode.nextTree());
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2209:18: ( propertyListNotEmpty )?
                        if ( stream_propertyListNotEmpty.hasNext() ) {
                            adaptor.addChild(root_0, stream_propertyListNotEmpty.nextTree());

                        }
                        stream_propertyListNotEmpty.reset();
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, " . \n"));

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "triplesSameSubject"

    protected static class triplesSameSubject__scope {
        CommonTree subject;
        String separator;
    }
    protected Stack triplesSameSubject__stack = new Stack();

    public static class triplesSameSubject__return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "triplesSameSubject_"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2212:1: triplesSameSubject_ options {backtrack=true; } : ^( T_SUBJECT (a= subject_ propertyListNotEmpty_ -> propertyListNotEmpty_ | b= bnode propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$b.text] ) ) ) ) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) ) | bc= blankConstruct propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] $bc) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) ) | cvar= constructVar propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] $cvar) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) ) | f= enclosedExpr propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $f) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) ) | c= iriConstruct propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[\"xsparql:createURI\"] ^( T_PARAMS $c) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) ) | g= collection propertyListNotEmpty_ | (h= T_ANON_BLANK | h= T_EMPTY_ANON_BLANK ) propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_PAR propertyListNotEmpty_ ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[\"fn:not\"] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:empty\"] ^( T_PARAMS VAR[rdfTermVar] ) ) ) ) ^( T_PAR QSTRING[\"[\"] ^( XPATH VAR[rdfTermVar] LBRACKET[\"[\"] ^( LT[\"lt\"] ^( T_FUNCTION_CALL NCNAME[\"fn:position\"] ^( T_PARAMS ) ) ^( T_FUNCTION_CALL NCNAME[\"fn:last\"] ^( T_PARAMS ) ) ) RBRACKET[\"]\"] ) QSTRING[\" ] .&#xA;\"] ) QSTRING[\"\"] ) ) ) ) ) ;
    public final XSPARQLRewriter.triplesSameSubject__return triplesSameSubject_() throws RecognitionException {
        triplesSameSubject__stack.push(new triplesSameSubject__scope());
        XSPARQLRewriter.triplesSameSubject__return retval = new XSPARQLRewriter.triplesSameSubject__return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree h=null;
        CommonTree T_SUBJECT578=null;
        XSPARQLRewriter.subject__return a = null;

        XSPARQLRewriter.bnode_return b = null;

        XSPARQLRewriter.blankConstruct_return bc = null;

        XSPARQLRewriter.constructVar_return cvar = null;

        XSPARQLRewriter.enclosedExpr_return f = null;

        XSPARQLRewriter.iriConstruct_return c = null;

        XSPARQLRewriter.collection_return g = null;

        XSPARQLRewriter.propertyListNotEmpty__return propertyListNotEmpty_579 = null;

        XSPARQLRewriter.propertyListNotEmpty__return propertyListNotEmpty_580 = null;

        XSPARQLRewriter.propertyListNotEmpty__return propertyListNotEmpty_581 = null;

        XSPARQLRewriter.propertyListNotEmpty__return propertyListNotEmpty_582 = null;

        XSPARQLRewriter.propertyListNotEmpty__return propertyListNotEmpty_583 = null;

        XSPARQLRewriter.propertyListNotEmpty__return propertyListNotEmpty_584 = null;

        XSPARQLRewriter.propertyListNotEmpty__return propertyListNotEmpty_585 = null;

        XSPARQLRewriter.propertyListNotEmpty__return propertyListNotEmpty_586 = null;


        CommonTree h_tree=null;
        CommonTree T_SUBJECT578_tree=null;
        RewriteRuleNodeStream stream_T_EMPTY_ANON_BLANK=new RewriteRuleNodeStream(adaptor,"token T_EMPTY_ANON_BLANK");
        RewriteRuleNodeStream stream_T_ANON_BLANK=new RewriteRuleNodeStream(adaptor,"token T_ANON_BLANK");
        RewriteRuleNodeStream stream_T_SUBJECT=new RewriteRuleNodeStream(adaptor,"token T_SUBJECT");
        RewriteRuleSubtreeStream stream_constructVar=new RewriteRuleSubtreeStream(adaptor,"rule constructVar");
        RewriteRuleSubtreeStream stream_bnode=new RewriteRuleSubtreeStream(adaptor,"rule bnode");
        RewriteRuleSubtreeStream stream_blankConstruct=new RewriteRuleSubtreeStream(adaptor,"rule blankConstruct");
        RewriteRuleSubtreeStream stream_subject_=new RewriteRuleSubtreeStream(adaptor,"rule subject_");
        RewriteRuleSubtreeStream stream_propertyListNotEmpty_=new RewriteRuleSubtreeStream(adaptor,"rule propertyListNotEmpty_");
        RewriteRuleSubtreeStream stream_iriConstruct=new RewriteRuleSubtreeStream(adaptor,"rule iriConstruct");
        RewriteRuleSubtreeStream stream_collection=new RewriteRuleSubtreeStream(adaptor,"rule collection");
        RewriteRuleSubtreeStream stream_enclosedExpr=new RewriteRuleSubtreeStream(adaptor,"rule enclosedExpr");

          String rdfTermVar = getNewTempRdfTermVariable();

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2223:3: ( ^( T_SUBJECT (a= subject_ propertyListNotEmpty_ -> propertyListNotEmpty_ | b= bnode propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$b.text] ) ) ) ) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) ) | bc= blankConstruct propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] $bc) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) ) | cvar= constructVar propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] $cvar) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) ) | f= enclosedExpr propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $f) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) ) | c= iriConstruct propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[\"xsparql:createURI\"] ^( T_PARAMS $c) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) ) | g= collection propertyListNotEmpty_ | (h= T_ANON_BLANK | h= T_EMPTY_ANON_BLANK ) propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_PAR propertyListNotEmpty_ ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[\"fn:not\"] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:empty\"] ^( T_PARAMS VAR[rdfTermVar] ) ) ) ) ^( T_PAR QSTRING[\"[\"] ^( XPATH VAR[rdfTermVar] LBRACKET[\"[\"] ^( LT[\"lt\"] ^( T_FUNCTION_CALL NCNAME[\"fn:position\"] ^( T_PARAMS ) ) ^( T_FUNCTION_CALL NCNAME[\"fn:last\"] ^( T_PARAMS ) ) ) RBRACKET[\"]\"] ) QSTRING[\" ] .&#xA;\"] ) QSTRING[\"\"] ) ) ) ) ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2223:5: ^( T_SUBJECT (a= subject_ propertyListNotEmpty_ -> propertyListNotEmpty_ | b= bnode propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$b.text] ) ) ) ) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) ) | bc= blankConstruct propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] $bc) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) ) | cvar= constructVar propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] $cvar) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) ) | f= enclosedExpr propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $f) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) ) | c= iriConstruct propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[\"xsparql:createURI\"] ^( T_PARAMS $c) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) ) | g= collection propertyListNotEmpty_ | (h= T_ANON_BLANK | h= T_EMPTY_ANON_BLANK ) propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_PAR propertyListNotEmpty_ ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[\"fn:not\"] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:empty\"] ^( T_PARAMS VAR[rdfTermVar] ) ) ) ) ^( T_PAR QSTRING[\"[\"] ^( XPATH VAR[rdfTermVar] LBRACKET[\"[\"] ^( LT[\"lt\"] ^( T_FUNCTION_CALL NCNAME[\"fn:position\"] ^( T_PARAMS ) ) ^( T_FUNCTION_CALL NCNAME[\"fn:last\"] ^( T_PARAMS ) ) ) RBRACKET[\"]\"] ) QSTRING[\" ] .&#xA;\"] ) QSTRING[\"\"] ) ) ) ) )
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_SUBJECT578=(CommonTree)match(input,T_SUBJECT,FOLLOW_T_SUBJECT_in_triplesSameSubject_10172); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_T_SUBJECT.add(T_SUBJECT578);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2224:7: (a= subject_ propertyListNotEmpty_ -> propertyListNotEmpty_ | b= bnode propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$b.text] ) ) ) ) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) ) | bc= blankConstruct propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] $bc) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) ) | cvar= constructVar propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] $cvar) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) ) | f= enclosedExpr propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $f) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) ) | c= iriConstruct propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[\"xsparql:createURI\"] ^( T_PARAMS $c) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) ) | g= collection propertyListNotEmpty_ | (h= T_ANON_BLANK | h= T_EMPTY_ANON_BLANK ) propertyListNotEmpty_ -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_PAR propertyListNotEmpty_ ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[\"fn:not\"] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:empty\"] ^( T_PARAMS VAR[rdfTermVar] ) ) ) ) ^( T_PAR QSTRING[\"[\"] ^( XPATH VAR[rdfTermVar] LBRACKET[\"[\"] ^( LT[\"lt\"] ^( T_FUNCTION_CALL NCNAME[\"fn:position\"] ^( T_PARAMS ) ) ^( T_FUNCTION_CALL NCNAME[\"fn:last\"] ^( T_PARAMS ) ) ) RBRACKET[\"]\"] ) QSTRING[\" ] .&#xA;\"] ) QSTRING[\"\"] ) ) ) )
            int alt163=8;
            switch ( input.LA(1) ) {
            case PNAME_NS:
            case PNAME_LN:
            case IRIREF:
            case A:
                {
                alt163=1;
                }
                break;
            case BLANK_NODE_LABEL:
                {
                alt163=2;
                }
                break;
            case BNODE_CONSTRUCT:
                {
                alt163=3;
                }
                break;
            case VAR:
                {
                alt163=4;
                }
                break;
            case LCURLY:
            case STAR:
            case LESSTHAN:
            case GREATERTHAN:
            case PLUS:
            case MINUS:
            case UNIONSYMBOL:
            case LESSTHANLESSTHAN:
            case GREATERTHANEQUALS:
            case LESSTHANEQUALS:
            case HAFENEQUALS:
            case EQUALS:
            case IS:
            case EQ:
            case NE:
            case LT:
            case GE:
            case LE:
            case GT:
            case IF:
            case AND:
            case OR:
            case TO:
            case DIV:
            case IDIV:
            case MOD:
            case UNION:
            case INTERSECT:
            case EXCEPT:
            case GREATERTHANGREATERTHAN:
            case T_FLWOR:
            case T_INSTANCEOF:
            case T_CASTAS:
            case T_CASTABLEAS:
            case T_TREATAS:
            case EVERY:
            case TYPESWITCH:
            case VALIDATE:
            case SOME:
            case XPATH:
                {
                alt163=5;
                }
                break;
            case T_IRI_CONSTRUCT:
                {
                alt163=6;
                }
                break;
            case LPAR:
                {
                alt163=7;
                }
                break;
            case T_ANON_BLANK:
            case T_EMPTY_ANON_BLANK:
                {
                alt163=8;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 163, 0, input);

                throw nvae;
            }

            switch (alt163) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2224:9: a= subject_ propertyListNotEmpty_
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_subject__in_triplesSameSubject_10184);
                    a=subject_();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_subject_.add(a.getTree());
                    if ( state.backtracking==0 ) {
                      ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).subject = (a!=null?((CommonTree)a.tree):null); ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).separator = " .&#xA;";
                    }
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_propertyListNotEmpty__in_triplesSameSubject_10192);
                    propertyListNotEmpty_579=propertyListNotEmpty_();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_propertyListNotEmpty_.add(propertyListNotEmpty_579.getTree());


                    // AST REWRITE
                    // elements: propertyListNotEmpty_
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2225:7: -> propertyListNotEmpty_
                    {
                        adaptor.addChild(root_0, stream_propertyListNotEmpty_.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2226:9: b= bnode propertyListNotEmpty_
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_bnode_in_triplesSameSubject_10214);
                    b=bnode();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_bnode.add(b.getTree());
                    if ( state.backtracking==0 ) {
                      ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).subject = new CommonTree(new CommonToken(VAR, rdfTermVar));  ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).separator = " .&#xA;";
                    }
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_propertyListNotEmpty__in_triplesSameSubject_10222);
                    propertyListNotEmpty_580=propertyListNotEmpty_();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_propertyListNotEmpty_.add(propertyListNotEmpty_580.getTree());


                    // AST REWRITE
                    // elements: propertyListNotEmpty_
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2227:7: -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$b.text] ) ) ) ) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2227:10: ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$b.text] ) ) ) ) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FLWOR, "T_FLWOR"), root_2);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2228:12: ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$b.text] ) ) ) ) ) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_LET, "T_LET"), root_3);

                        adaptor.addChild(root_3, (CommonTree)adaptor.create(VAR, rdfTermVar));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2230:14: ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$b.text] ) ) ) ) )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_4);

                        adaptor.addChild(root_4, (CommonTree)adaptor.create(NCNAME, bindingTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2232:16: ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$b.text] ) ) ) )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_5);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2233:18: ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$b.text] ) ) )
                        {
                        CommonTree root_6 = (CommonTree)adaptor.nil();
                        root_6 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_6);

                        adaptor.addChild(root_6, (CommonTree)adaptor.create(NCNAME, serializeFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2235:20: ^( T_PARAMS ^( T_PAR QSTRING[$b.text] ) )
                        {
                        CommonTree root_7 = (CommonTree)adaptor.nil();
                        root_7 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_7);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2236:22: ^( T_PAR QSTRING[$b.text] )
                        {
                        CommonTree root_8 = (CommonTree)adaptor.nil();
                        root_8 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_8);

                        adaptor.addChild(root_8, (CommonTree)adaptor.create(QSTRING, (b!=null?(input.getTokenStream().toString(
                          input.getTreeAdaptor().getTokenStartIndex(b.start),
                          input.getTreeAdaptor().getTokenStopIndex(b.start))):null)));
                        adaptor.addChild(root_8, getPositionVarList());

                        adaptor.addChild(root_7, root_8);
                        }

                        adaptor.addChild(root_6, root_7);
                        }

                        adaptor.addChild(root_5, root_6);
                        }

                        adaptor.addChild(root_4, root_5);
                        }

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2245:12: ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_RETURN, "T_RETURN"), root_3);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2246:14: ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(IF, "IF"), root_4);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2247:16: ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(NCNAME, validSubjectFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2247:63: ^( T_PARAMS VAR[rdfTermVar] )
                        {
                        CommonTree root_6 = (CommonTree)adaptor.nil();
                        root_6 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_6);

                        adaptor.addChild(root_6, (CommonTree)adaptor.create(VAR, rdfTermVar));

                        adaptor.addChild(root_5, root_6);
                        }

                        adaptor.addChild(root_4, root_5);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2248:16: ^( T_PAR propertyListNotEmpty_ )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_5);

                        adaptor.addChild(root_5, stream_propertyListNotEmpty_.nextTree());

                        adaptor.addChild(root_4, root_5);
                        }
                        adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, ""));

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2253:9: bc= blankConstruct propertyListNotEmpty_
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_blankConstruct_in_triplesSameSubject_10729);
                    bc=blankConstruct();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_blankConstruct.add(bc.getTree());
                    if ( state.backtracking==0 ) {
                      ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).subject = new CommonTree(new CommonToken(VAR, rdfTermVar));  ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).separator = " .&#xA;";
                    }
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_propertyListNotEmpty__in_triplesSameSubject_10735);
                    propertyListNotEmpty_581=propertyListNotEmpty_();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_propertyListNotEmpty_.add(propertyListNotEmpty_581.getTree());


                    // AST REWRITE
                    // elements: propertyListNotEmpty_, bc
                    // token labels: 
                    // rule labels: retval, bc
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
                    RewriteRuleSubtreeStream stream_bc=new RewriteRuleSubtreeStream(adaptor,"rule bc",bc!=null?bc.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2254:7: -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] $bc) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2254:10: ^( T_FLWOR ^( T_LET VAR[rdfTermVar] $bc) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FLWOR, "T_FLWOR"), root_2);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2255:12: ^( T_LET VAR[rdfTermVar] $bc)
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_LET, "T_LET"), root_3);

                        adaptor.addChild(root_3, (CommonTree)adaptor.create(VAR, rdfTermVar));
                        adaptor.addChild(root_3, stream_bc.nextTree());

                        adaptor.addChild(root_2, root_3);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2259:12: ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_RETURN, "T_RETURN"), root_3);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2260:14: ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(IF, "IF"), root_4);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2261:16: ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(NCNAME, validSubjectFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2261:63: ^( T_PARAMS VAR[rdfTermVar] )
                        {
                        CommonTree root_6 = (CommonTree)adaptor.nil();
                        root_6 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_6);

                        adaptor.addChild(root_6, (CommonTree)adaptor.create(VAR, rdfTermVar));

                        adaptor.addChild(root_5, root_6);
                        }

                        adaptor.addChild(root_4, root_5);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2262:16: ^( T_PAR propertyListNotEmpty_ )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_5);

                        adaptor.addChild(root_5, stream_propertyListNotEmpty_.nextTree());

                        adaptor.addChild(root_4, root_5);
                        }
                        adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, ""));

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2267:9: cvar= constructVar propertyListNotEmpty_
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_constructVar_in_triplesSameSubject_10963);
                    cvar=constructVar();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_constructVar.add(cvar.getTree());
                    if ( state.backtracking==0 ) {
                       ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).subject = new CommonTree(new CommonToken(VAR, rdfTermVar));  
                                                  ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).separator = " .&#xA;";
                    }
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_propertyListNotEmpty__in_triplesSameSubject_10976);
                    propertyListNotEmpty_582=propertyListNotEmpty_();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_propertyListNotEmpty_.add(propertyListNotEmpty_582.getTree());


                    // AST REWRITE
                    // elements: propertyListNotEmpty_, cvar
                    // token labels: 
                    // rule labels: cvar, retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_cvar=new RewriteRuleSubtreeStream(adaptor,"rule cvar",cvar!=null?cvar.tree:null);
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2270:7: -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] $cvar) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2270:10: ^( T_FLWOR ^( T_LET VAR[rdfTermVar] $cvar) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FLWOR, "T_FLWOR"), root_2);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2271:12: ^( T_LET VAR[rdfTermVar] $cvar)
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_LET, "T_LET"), root_3);

                        adaptor.addChild(root_3, (CommonTree)adaptor.create(VAR, rdfTermVar));
                        adaptor.addChild(root_3, stream_cvar.nextTree());

                        adaptor.addChild(root_2, root_3);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2275:12: ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_RETURN, "T_RETURN"), root_3);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2276:14: ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(IF, "IF"), root_4);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2277:16: ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(NCNAME, validSubjectFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2277:63: ^( T_PARAMS VAR[rdfTermVar] )
                        {
                        CommonTree root_6 = (CommonTree)adaptor.nil();
                        root_6 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_6);

                        adaptor.addChild(root_6, (CommonTree)adaptor.create(VAR, rdfTermVar));

                        adaptor.addChild(root_5, root_6);
                        }

                        adaptor.addChild(root_4, root_5);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2278:16: ^( T_PAR propertyListNotEmpty_ )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_5);

                        adaptor.addChild(root_5, stream_propertyListNotEmpty_.nextTree());

                        adaptor.addChild(root_4, root_5);
                        }
                        adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, ""));

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 5 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2283:9: f= enclosedExpr propertyListNotEmpty_
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_enclosedExpr_in_triplesSameSubject_11202);
                    f=enclosedExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_enclosedExpr.add(f.getTree());
                    if ( state.backtracking==0 ) {
                       ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).subject = new CommonTree(new CommonToken(VAR, rdfTermVar));  
                                ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).separator = " .&#xA;"; 
                    }
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_propertyListNotEmpty__in_triplesSameSubject_11224);
                    propertyListNotEmpty_583=propertyListNotEmpty_();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_propertyListNotEmpty_.add(propertyListNotEmpty_583.getTree());


                    // AST REWRITE
                    // elements: f, propertyListNotEmpty_
                    // token labels: 
                    // rule labels: f, retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_f=new RewriteRuleSubtreeStream(adaptor,"rule f",f!=null?f.tree:null);
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2287:7: -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $f) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2287:10: ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $f) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FLWOR, "T_FLWOR"), root_2);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2288:12: ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $f) ) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_LET, "T_LET"), root_3);

                        adaptor.addChild(root_3, (CommonTree)adaptor.create(VAR, rdfTermVar));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2290:15: ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $f) )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_4);

                        adaptor.addChild(root_4, (CommonTree)adaptor.create(NCNAME, bindingTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2292:12: ^( T_PARAMS $f)
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_5);

                        adaptor.addChild(root_5, stream_f.nextTree());

                        adaptor.addChild(root_4, root_5);
                        }

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2297:12: ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_RETURN, "T_RETURN"), root_3);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2298:14: ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(IF, "IF"), root_4);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2299:16: ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(NCNAME, validSubjectFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2299:63: ^( T_PARAMS VAR[rdfTermVar] )
                        {
                        CommonTree root_6 = (CommonTree)adaptor.nil();
                        root_6 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_6);

                        adaptor.addChild(root_6, (CommonTree)adaptor.create(VAR, rdfTermVar));

                        adaptor.addChild(root_5, root_6);
                        }

                        adaptor.addChild(root_4, root_5);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2300:16: ^( T_PAR propertyListNotEmpty_ )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_5);

                        adaptor.addChild(root_5, stream_propertyListNotEmpty_.nextTree());

                        adaptor.addChild(root_4, root_5);
                        }
                        adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, ""));

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 6 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2305:9: c= iriConstruct propertyListNotEmpty_
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_iriConstruct_in_triplesSameSubject_11523);
                    c=iriConstruct();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_iriConstruct.add(c.getTree());
                    if ( state.backtracking==0 ) {
                       ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).subject = new CommonTree(new CommonToken(VAR, rdfTermVar));  
                                ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).separator = " .&#xA;"; 
                    }
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_propertyListNotEmpty__in_triplesSameSubject_11545);
                    propertyListNotEmpty_584=propertyListNotEmpty_();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_propertyListNotEmpty_.add(propertyListNotEmpty_584.getTree());


                    // AST REWRITE
                    // elements: propertyListNotEmpty_, c
                    // token labels: 
                    // rule labels: retval, c
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
                    RewriteRuleSubtreeStream stream_c=new RewriteRuleSubtreeStream(adaptor,"rule c",c!=null?c.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2309:7: -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[\"xsparql:createURI\"] ^( T_PARAMS $c) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2309:10: ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[\"xsparql:createURI\"] ^( T_PARAMS $c) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FLWOR, "T_FLWOR"), root_2);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2310:12: ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[\"xsparql:createURI\"] ^( T_PARAMS $c) ) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_LET, "T_LET"), root_3);

                        adaptor.addChild(root_3, (CommonTree)adaptor.create(VAR, rdfTermVar));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2312:15: ^( T_FUNCTION_CALL NCNAME[\"xsparql:createURI\"] ^( T_PARAMS $c) )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_4);

                        adaptor.addChild(root_4, (CommonTree)adaptor.create(NCNAME, "xsparql:createURI"));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2314:17: ^( T_PARAMS $c)
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_5);

                        adaptor.addChild(root_5, stream_c.nextTree());

                        adaptor.addChild(root_4, root_5);
                        }

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2319:12: ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] ) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_RETURN, "T_RETURN"), root_3);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2320:14: ^( IF ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR propertyListNotEmpty_ ) QSTRING[\"\"] )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(IF, "IF"), root_4);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2321:16: ^( T_FUNCTION_CALL NCNAME[validSubjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(NCNAME, validSubjectFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2321:63: ^( T_PARAMS VAR[rdfTermVar] )
                        {
                        CommonTree root_6 = (CommonTree)adaptor.nil();
                        root_6 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_6);

                        adaptor.addChild(root_6, (CommonTree)adaptor.create(VAR, rdfTermVar));

                        adaptor.addChild(root_5, root_6);
                        }

                        adaptor.addChild(root_4, root_5);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2322:16: ^( T_PAR propertyListNotEmpty_ )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_5);

                        adaptor.addChild(root_5, stream_propertyListNotEmpty_.nextTree());

                        adaptor.addChild(root_4, root_5);
                        }
                        adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, ""));

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 7 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2327:9: g= collection propertyListNotEmpty_
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_collection_in_triplesSameSubject_11869);
                    g=collection();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_collection.add(g.getTree());
                    if ( state.backtracking==0 ) {
                      ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).subject = (g!=null?((CommonTree)g.tree):null);  ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).separator = " .&#xA;";
                    }
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_propertyListNotEmpty__in_triplesSameSubject_11885);
                    propertyListNotEmpty_585=propertyListNotEmpty_();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_propertyListNotEmpty_.add(propertyListNotEmpty_585.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 8 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2330:9: (h= T_ANON_BLANK | h= T_EMPTY_ANON_BLANK ) propertyListNotEmpty_
                    {
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2330:9: (h= T_ANON_BLANK | h= T_EMPTY_ANON_BLANK )
                    int alt162=2;
                    switch ( input.LA(1) ) {
                    case T_ANON_BLANK:
                        {
                        alt162=1;
                        }
                        break;
                    case T_EMPTY_ANON_BLANK:
                        {
                        alt162=2;
                        }
                        break;
                    default:
                        if (state.backtracking>0) {state.failed=true; return retval;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 162, 0, input);

                        throw nvae;
                    }

                    switch (alt162) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2330:10: h= T_ANON_BLANK
                            {
                            _last = (CommonTree)input.LT(1);
                            h=(CommonTree)match(input,T_ANON_BLANK,FOLLOW_T_ANON_BLANK_in_triplesSameSubject_11900); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_T_ANON_BLANK.add(h);


                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;
                        case 2 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2330:25: h= T_EMPTY_ANON_BLANK
                            {
                            _last = (CommonTree)input.LT(1);
                            h=(CommonTree)match(input,T_EMPTY_ANON_BLANK,FOLLOW_T_EMPTY_ANON_BLANK_in_triplesSameSubject_11904); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_T_EMPTY_ANON_BLANK.add(h);


                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }

                    if ( state.backtracking==0 ) {
                      ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).subject = new CommonTree(new CommonToken(QSTRING, ""));  ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).separator = " ; ";
                    }
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_propertyListNotEmpty__in_triplesSameSubject_11909);
                    propertyListNotEmpty_586=propertyListNotEmpty_();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_propertyListNotEmpty_.add(propertyListNotEmpty_586.getTree());


                    // AST REWRITE
                    // elements: propertyListNotEmpty_
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2331:7: -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_PAR propertyListNotEmpty_ ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[\"fn:not\"] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:empty\"] ^( T_PARAMS VAR[rdfTermVar] ) ) ) ) ^( T_PAR QSTRING[\"[\"] ^( XPATH VAR[rdfTermVar] LBRACKET[\"[\"] ^( LT[\"lt\"] ^( T_FUNCTION_CALL NCNAME[\"fn:position\"] ^( T_PARAMS ) ) ^( T_FUNCTION_CALL NCNAME[\"fn:last\"] ^( T_PARAMS ) ) ) RBRACKET[\"]\"] ) QSTRING[\" ] .&#xA;\"] ) QSTRING[\"\"] ) ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2331:10: ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_PAR propertyListNotEmpty_ ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[\"fn:not\"] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:empty\"] ^( T_PARAMS VAR[rdfTermVar] ) ) ) ) ^( T_PAR QSTRING[\"[\"] ^( XPATH VAR[rdfTermVar] LBRACKET[\"[\"] ^( LT[\"lt\"] ^( T_FUNCTION_CALL NCNAME[\"fn:position\"] ^( T_PARAMS ) ) ^( T_FUNCTION_CALL NCNAME[\"fn:last\"] ^( T_PARAMS ) ) ) RBRACKET[\"]\"] ) QSTRING[\" ] .&#xA;\"] ) QSTRING[\"\"] ) ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FLWOR, "T_FLWOR"), root_2);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2332:12: ^( T_LET VAR[rdfTermVar] ^( T_PAR propertyListNotEmpty_ ) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_LET, "T_LET"), root_3);

                        adaptor.addChild(root_3, (CommonTree)adaptor.create(VAR, rdfTermVar));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2334:15: ^( T_PAR propertyListNotEmpty_ )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_4);

                        adaptor.addChild(root_4, stream_propertyListNotEmpty_.nextTree());

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2336:12: ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[\"fn:not\"] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:empty\"] ^( T_PARAMS VAR[rdfTermVar] ) ) ) ) ^( T_PAR QSTRING[\"[\"] ^( XPATH VAR[rdfTermVar] LBRACKET[\"[\"] ^( LT[\"lt\"] ^( T_FUNCTION_CALL NCNAME[\"fn:position\"] ^( T_PARAMS ) ) ^( T_FUNCTION_CALL NCNAME[\"fn:last\"] ^( T_PARAMS ) ) ) RBRACKET[\"]\"] ) QSTRING[\" ] .&#xA;\"] ) QSTRING[\"\"] ) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_RETURN, "T_RETURN"), root_3);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2337:14: ^( IF ^( T_FUNCTION_CALL NCNAME[\"fn:not\"] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:empty\"] ^( T_PARAMS VAR[rdfTermVar] ) ) ) ) ^( T_PAR QSTRING[\"[\"] ^( XPATH VAR[rdfTermVar] LBRACKET[\"[\"] ^( LT[\"lt\"] ^( T_FUNCTION_CALL NCNAME[\"fn:position\"] ^( T_PARAMS ) ) ^( T_FUNCTION_CALL NCNAME[\"fn:last\"] ^( T_PARAMS ) ) ) RBRACKET[\"]\"] ) QSTRING[\" ] .&#xA;\"] ) QSTRING[\"\"] )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(IF, "IF"), root_4);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2338:16: ^( T_FUNCTION_CALL NCNAME[\"fn:not\"] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:empty\"] ^( T_PARAMS VAR[rdfTermVar] ) ) ) )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(NCNAME, "fn:not"));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2338:51: ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:empty\"] ^( T_PARAMS VAR[rdfTermVar] ) ) )
                        {
                        CommonTree root_6 = (CommonTree)adaptor.nil();
                        root_6 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_6);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2338:62: ^( T_FUNCTION_CALL NCNAME[\"fn:empty\"] ^( T_PARAMS VAR[rdfTermVar] ) )
                        {
                        CommonTree root_7 = (CommonTree)adaptor.nil();
                        root_7 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_7);

                        adaptor.addChild(root_7, (CommonTree)adaptor.create(NCNAME, "fn:empty"));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2338:99: ^( T_PARAMS VAR[rdfTermVar] )
                        {
                        CommonTree root_8 = (CommonTree)adaptor.nil();
                        root_8 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_8);

                        adaptor.addChild(root_8, (CommonTree)adaptor.create(VAR, rdfTermVar));

                        adaptor.addChild(root_7, root_8);
                        }

                        adaptor.addChild(root_6, root_7);
                        }

                        adaptor.addChild(root_5, root_6);
                        }

                        adaptor.addChild(root_4, root_5);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2339:17: ^( T_PAR QSTRING[\"[\"] ^( XPATH VAR[rdfTermVar] LBRACKET[\"[\"] ^( LT[\"lt\"] ^( T_FUNCTION_CALL NCNAME[\"fn:position\"] ^( T_PARAMS ) ) ^( T_FUNCTION_CALL NCNAME[\"fn:last\"] ^( T_PARAMS ) ) ) RBRACKET[\"]\"] ) QSTRING[\" ] .&#xA;\"] )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(QSTRING, "["));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2339:38: ^( XPATH VAR[rdfTermVar] LBRACKET[\"[\"] ^( LT[\"lt\"] ^( T_FUNCTION_CALL NCNAME[\"fn:position\"] ^( T_PARAMS ) ) ^( T_FUNCTION_CALL NCNAME[\"fn:last\"] ^( T_PARAMS ) ) ) RBRACKET[\"]\"] )
                        {
                        CommonTree root_6 = (CommonTree)adaptor.nil();
                        root_6 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(XPATH, "XPATH"), root_6);

                        adaptor.addChild(root_6, (CommonTree)adaptor.create(VAR, rdfTermVar));
                        adaptor.addChild(root_6, (CommonTree)adaptor.create(LBRACKET, "["));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2339:76: ^( LT[\"lt\"] ^( T_FUNCTION_CALL NCNAME[\"fn:position\"] ^( T_PARAMS ) ) ^( T_FUNCTION_CALL NCNAME[\"fn:last\"] ^( T_PARAMS ) ) )
                        {
                        CommonTree root_7 = (CommonTree)adaptor.nil();
                        root_7 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(LT, "lt"), root_7);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2339:87: ^( T_FUNCTION_CALL NCNAME[\"fn:position\"] ^( T_PARAMS ) )
                        {
                        CommonTree root_8 = (CommonTree)adaptor.nil();
                        root_8 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_8);

                        adaptor.addChild(root_8, (CommonTree)adaptor.create(NCNAME, "fn:position"));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2339:127: ^( T_PARAMS )
                        {
                        CommonTree root_9 = (CommonTree)adaptor.nil();
                        root_9 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_9);

                        adaptor.addChild(root_8, root_9);
                        }

                        adaptor.addChild(root_7, root_8);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2339:141: ^( T_FUNCTION_CALL NCNAME[\"fn:last\"] ^( T_PARAMS ) )
                        {
                        CommonTree root_8 = (CommonTree)adaptor.nil();
                        root_8 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_8);

                        adaptor.addChild(root_8, (CommonTree)adaptor.create(NCNAME, "fn:last"));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2339:177: ^( T_PARAMS )
                        {
                        CommonTree root_9 = (CommonTree)adaptor.nil();
                        root_9 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_9);

                        adaptor.addChild(root_8, root_9);
                        }

                        adaptor.addChild(root_7, root_8);
                        }

                        adaptor.addChild(root_6, root_7);
                        }
                        adaptor.addChild(root_6, (CommonTree)adaptor.create(RBRACKET, "]"));

                        adaptor.addChild(root_5, root_6);
                        }
                        adaptor.addChild(root_5, (CommonTree)adaptor.create(QSTRING, " ] .&#xA;"));

                        adaptor.addChild(root_4, root_5);
                        }
                        adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, ""));

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }


            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
            triplesSameSubject__stack.pop();
        }
        return retval;
    }
    // $ANTLR end "triplesSameSubject_"

    public static class constructVar_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "constructVar"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2348:1: constructVar : var= VAR -> {isBound(rdftermvar, Types.SPARQL)}? VAR[$var.token, rdftermvar] -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $var) ) ;
    public final XSPARQLRewriter.constructVar_return constructVar() throws RecognitionException {
        XSPARQLRewriter.constructVar_return retval = new XSPARQLRewriter.constructVar_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree var=null;

        CommonTree var_tree=null;
        RewriteRuleNodeStream stream_VAR=new RewriteRuleNodeStream(adaptor,"token VAR");


          String rdftermvar = "";

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2352:3: (var= VAR -> {isBound(rdftermvar, Types.SPARQL)}? VAR[$var.token, rdftermvar] -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $var) ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2352:5: var= VAR
            {
            _last = (CommonTree)input.LT(1);
            var=(CommonTree)match(input,VAR,FOLLOW_VAR_in_constructVar12218); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_VAR.add(var);

            if ( state.backtracking==0 ) {
               rdftermvar = (var!=null?var.getText():null); 
            }


            // AST REWRITE
            // elements: VAR, var
            // token labels: var
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleNodeStream stream_var=new RewriteRuleNodeStream(adaptor,"token var",var);
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 2353:3: -> {isBound(rdftermvar, Types.SPARQL)}? VAR[$var.token, rdftermvar]
            if (isBound(rdftermvar, Types.SPARQL)) {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(VAR, var.token, rdftermvar));

            }
            else // 2354:3: -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $var) )
            {
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2354:6: ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $var) )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_1);

                adaptor.addChild(root_1, (CommonTree)adaptor.create(NCNAME, bindingTermFunction));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2355:8: ^( T_PARAMS $var)
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_2);

                adaptor.addChild(root_2, stream_var.nextNode());

                adaptor.addChild(root_1, root_2);
                }

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "constructVar"

    public static class propertyListNotEmpty__return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "propertyListNotEmpty_"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2361:1: propertyListNotEmpty_ : (v+= verbObjectList_ )+ -> ( $v)+ ;
    public final XSPARQLRewriter.propertyListNotEmpty__return propertyListNotEmpty_() throws RecognitionException {
        XSPARQLRewriter.propertyListNotEmpty__return retval = new XSPARQLRewriter.propertyListNotEmpty__return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        List list_v=null;
        RuleReturnScope v = null;
        RewriteRuleSubtreeStream stream_verbObjectList_=new RewriteRuleSubtreeStream(adaptor,"rule verbObjectList_");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2362:3: ( (v+= verbObjectList_ )+ -> ( $v)+ )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2362:5: (v+= verbObjectList_ )+
            {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2362:6: (v+= verbObjectList_ )+
            int cnt164=0;
            loop164:
            do {
                int alt164=2;
                switch ( input.LA(1) ) {
                case T_VERB:
                    {
                    alt164=1;
                    }
                    break;

                }

                switch (alt164) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: v+= verbObjectList_
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_verbObjectList__in_propertyListNotEmpty_12296);
            	    v=verbObjectList_();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_verbObjectList_.add(v.getTree());
            	    if (list_v==null) list_v=new ArrayList();
            	    list_v.add(v.getTree());


            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    if ( cnt164 >= 1 ) break loop164;
            	    if (state.backtracking>0) {state.failed=true; return retval;}
                        EarlyExitException eee =
                            new EarlyExitException(164, input);
                        throw eee;
                }
                cnt164++;
            } while (true);



            // AST REWRITE
            // elements: v
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: v
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
            RewriteRuleSubtreeStream stream_v=new RewriteRuleSubtreeStream(adaptor,"token v",list_v);
            root_0 = (CommonTree)adaptor.nil();
            // 2363:3: -> ( $v)+
            {
                if ( !(stream_v.hasNext()) ) {
                    throw new RewriteEarlyExitException();
                }
                while ( stream_v.hasNext() ) {
                    adaptor.addChild(root_0, stream_v.nextTree());

                }
                stream_v.reset();

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "propertyListNotEmpty_"

    protected static class verbObjectList__scope {
        CommonTree verb;
    }
    protected Stack verbObjectList__stack = new Stack();

    public static class verbObjectList__return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "verbObjectList_"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2366:1: verbObjectList_ : ( ^( T_VERB ve= verb_ objectList_ ) -> objectList_ | ^( T_VERB irix= iriConstruct objectList_ ) -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[\"xsparql:createURI\"] ^( T_PARAMS $irix) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validPredicateFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR objectList_ ) QSTRING[\"\"] ) ) ) | ^( T_VERB v= constructVar objectList_ ) -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] $v) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validPredicateFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR objectList_ ) QSTRING[\"\"] ) ) ) );
    public final XSPARQLRewriter.verbObjectList__return verbObjectList_() throws RecognitionException {
        verbObjectList__stack.push(new verbObjectList__scope());
        XSPARQLRewriter.verbObjectList__return retval = new XSPARQLRewriter.verbObjectList__return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_VERB587=null;
        CommonTree T_VERB589=null;
        CommonTree T_VERB591=null;
        XSPARQLRewriter.verb__return ve = null;

        XSPARQLRewriter.iriConstruct_return irix = null;

        XSPARQLRewriter.constructVar_return v = null;

        XSPARQLRewriter.objectList__return objectList_588 = null;

        XSPARQLRewriter.objectList__return objectList_590 = null;

        XSPARQLRewriter.objectList__return objectList_592 = null;


        CommonTree T_VERB587_tree=null;
        CommonTree T_VERB589_tree=null;
        CommonTree T_VERB591_tree=null;
        RewriteRuleNodeStream stream_T_VERB=new RewriteRuleNodeStream(adaptor,"token T_VERB");
        RewriteRuleSubtreeStream stream_constructVar=new RewriteRuleSubtreeStream(adaptor,"rule constructVar");
        RewriteRuleSubtreeStream stream_objectList_=new RewriteRuleSubtreeStream(adaptor,"rule objectList_");
        RewriteRuleSubtreeStream stream_iriConstruct=new RewriteRuleSubtreeStream(adaptor,"rule iriConstruct");
        RewriteRuleSubtreeStream stream_verb_=new RewriteRuleSubtreeStream(adaptor,"rule verb_");

          String rdfTermVar = getNewTempRdfTermVariable();

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2373:3: ( ^( T_VERB ve= verb_ objectList_ ) -> objectList_ | ^( T_VERB irix= iriConstruct objectList_ ) -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[\"xsparql:createURI\"] ^( T_PARAMS $irix) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validPredicateFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR objectList_ ) QSTRING[\"\"] ) ) ) | ^( T_VERB v= constructVar objectList_ ) -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] $v) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validPredicateFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR objectList_ ) QSTRING[\"\"] ) ) ) )
            int alt165=3;
            switch ( input.LA(1) ) {
            case T_VERB:
                {
                switch ( input.LA(2) ) {
                case DOWN:
                    {
                    switch ( input.LA(3) ) {
                    case VAR:
                        {
                        alt165=3;
                        }
                        break;
                    case T_IRI_CONSTRUCT:
                        {
                        alt165=2;
                        }
                        break;
                    case PNAME_NS:
                    case PNAME_LN:
                    case IRIREF:
                    case A:
                        {
                        alt165=1;
                        }
                        break;
                    default:
                        if (state.backtracking>0) {state.failed=true; return retval;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 165, 2, input);

                        throw nvae;
                    }

                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 165, 1, input);

                    throw nvae;
                }

                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 165, 0, input);

                throw nvae;
            }

            switch (alt165) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2373:5: ^( T_VERB ve= verb_ objectList_ )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_VERB587=(CommonTree)match(input,T_VERB,FOLLOW_T_VERB_in_verbObjectList_12328); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_VERB.add(T_VERB587);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_verb__in_verbObjectList_12332);
                    ve=verb_();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_verb_.add(ve.getTree());
                    if ( state.backtracking==0 ) {
                      ((verbObjectList__scope)verbObjectList__stack.peek()).verb = (ve!=null?((CommonTree)ve.tree):null);
                    }
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_objectList__in_verbObjectList_12336);
                    objectList_588=objectList_();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_objectList_.add(objectList_588.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: objectList_
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2374:3: -> objectList_
                    {
                        adaptor.addChild(root_0, stream_objectList_.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2375:5: ^( T_VERB irix= iriConstruct objectList_ )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_VERB589=(CommonTree)match(input,T_VERB,FOLLOW_T_VERB_in_verbObjectList_12351); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_VERB.add(T_VERB589);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_iriConstruct_in_verbObjectList_12355);
                    irix=iriConstruct();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_iriConstruct.add(irix.getTree());
                    if ( state.backtracking==0 ) {
                      ((verbObjectList__scope)verbObjectList__stack.peek()).verb = new CommonTree(new CommonToken(VAR, rdfTermVar));
                    }
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_objectList__in_verbObjectList_12359);
                    objectList_590=objectList_();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_objectList_.add(objectList_590.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: irix, objectList_
                    // token labels: 
                    // rule labels: retval, irix
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
                    RewriteRuleSubtreeStream stream_irix=new RewriteRuleSubtreeStream(adaptor,"rule irix",irix!=null?irix.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2376:3: -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[\"xsparql:createURI\"] ^( T_PARAMS $irix) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validPredicateFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR objectList_ ) QSTRING[\"\"] ) ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2376:6: ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[\"xsparql:createURI\"] ^( T_PARAMS $irix) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validPredicateFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR objectList_ ) QSTRING[\"\"] ) ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FLWOR, "T_FLWOR"), root_1);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2377:8: ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[\"xsparql:createURI\"] ^( T_PARAMS $irix) ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_LET, "T_LET"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(VAR, rdfTermVar));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2379:11: ^( T_FUNCTION_CALL NCNAME[\"xsparql:createURI\"] ^( T_PARAMS $irix) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_3);

                        adaptor.addChild(root_3, (CommonTree)adaptor.create(NCNAME, "xsparql:createURI"));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2381:12: ^( T_PARAMS $irix)
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_4);

                        adaptor.addChild(root_4, stream_irix.nextTree());

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2386:8: ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validPredicateFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR objectList_ ) QSTRING[\"\"] ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_RETURN, "T_RETURN"), root_2);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2387:10: ^( IF ^( T_FUNCTION_CALL NCNAME[validPredicateFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR objectList_ ) QSTRING[\"\"] )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(IF, "IF"), root_3);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2388:12: ^( T_FUNCTION_CALL NCNAME[validPredicateFunction] ^( T_PARAMS VAR[rdfTermVar] ) )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_4);

                        adaptor.addChild(root_4, (CommonTree)adaptor.create(NCNAME, validPredicateFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2388:61: ^( T_PARAMS VAR[rdfTermVar] )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(VAR, rdfTermVar));

                        adaptor.addChild(root_4, root_5);
                        }

                        adaptor.addChild(root_3, root_4);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2389:12: ^( T_PAR objectList_ )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_4);

                        adaptor.addChild(root_4, stream_objectList_.nextTree());

                        adaptor.addChild(root_3, root_4);
                        }
                        adaptor.addChild(root_3, (CommonTree)adaptor.create(QSTRING, ""));

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2395:5: ^( T_VERB v= constructVar objectList_ )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_VERB591=(CommonTree)match(input,T_VERB,FOLLOW_T_VERB_in_verbObjectList_12604); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_VERB.add(T_VERB591);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_constructVar_in_verbObjectList_12608);
                    v=constructVar();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_constructVar.add(v.getTree());
                    if ( state.backtracking==0 ) {
                      ((verbObjectList__scope)verbObjectList__stack.peek()).verb = new CommonTree(new CommonToken(VAR, rdfTermVar));
                    }
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_objectList__in_verbObjectList_12612);
                    objectList_592=objectList_();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_objectList_.add(objectList_592.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: v, objectList_
                    // token labels: 
                    // rule labels: v, retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_v=new RewriteRuleSubtreeStream(adaptor,"rule v",v!=null?v.tree:null);
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2396:7: -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] $v) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validPredicateFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR objectList_ ) QSTRING[\"\"] ) ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2396:10: ^( T_FLWOR ^( T_LET VAR[rdfTermVar] $v) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validPredicateFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR objectList_ ) QSTRING[\"\"] ) ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FLWOR, "T_FLWOR"), root_1);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2397:12: ^( T_LET VAR[rdfTermVar] $v)
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_LET, "T_LET"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(VAR, rdfTermVar));
                        adaptor.addChild(root_2, stream_v.nextTree());

                        adaptor.addChild(root_1, root_2);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2401:12: ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validPredicateFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR objectList_ ) QSTRING[\"\"] ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_RETURN, "T_RETURN"), root_2);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2402:14: ^( IF ^( T_FUNCTION_CALL NCNAME[validPredicateFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR objectList_ ) QSTRING[\"\"] )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(IF, "IF"), root_3);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2403:16: ^( T_FUNCTION_CALL NCNAME[validPredicateFunction] ^( T_PARAMS VAR[rdfTermVar] ) )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_4);

                        adaptor.addChild(root_4, (CommonTree)adaptor.create(NCNAME, validPredicateFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2403:65: ^( T_PARAMS VAR[rdfTermVar] )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(VAR, rdfTermVar));

                        adaptor.addChild(root_4, root_5);
                        }

                        adaptor.addChild(root_3, root_4);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2404:16: ^( T_PAR objectList_ )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_4);

                        adaptor.addChild(root_4, stream_objectList_.nextTree());

                        adaptor.addChild(root_3, root_4);
                        }
                        adaptor.addChild(root_3, (CommonTree)adaptor.create(QSTRING, ""));

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
            verbObjectList__stack.pop();
        }
        return retval;
    }
    // $ANTLR end "verbObjectList_"

    public static class propertyListNotEmpty_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "propertyListNotEmpty"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2411:1: propertyListNotEmpty options {backtrack=true; } : ^( T_VERB v1= verb o1= objectList ) ( ^( T_VERB v+= verb o+= objectList ) )* -> $v1 QSTRING[\" \"] $o1 ( QSTRING[\" ; \\n\"] $v QSTRING[\" \"] $o)* ;
    public final XSPARQLRewriter.propertyListNotEmpty_return propertyListNotEmpty() throws RecognitionException {
        XSPARQLRewriter.propertyListNotEmpty_return retval = new XSPARQLRewriter.propertyListNotEmpty_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_VERB593=null;
        CommonTree T_VERB594=null;
        List list_v=null;
        List list_o=null;
        XSPARQLRewriter.verb_return v1 = null;

        XSPARQLRewriter.objectList_return o1 = null;

        RuleReturnScope v = null;
        RuleReturnScope o = null;
        CommonTree T_VERB593_tree=null;
        CommonTree T_VERB594_tree=null;
        RewriteRuleNodeStream stream_T_VERB=new RewriteRuleNodeStream(adaptor,"token T_VERB");
        RewriteRuleSubtreeStream stream_verb=new RewriteRuleSubtreeStream(adaptor,"rule verb");
        RewriteRuleSubtreeStream stream_objectList=new RewriteRuleSubtreeStream(adaptor,"rule objectList");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2415:3: ( ^( T_VERB v1= verb o1= objectList ) ( ^( T_VERB v+= verb o+= objectList ) )* -> $v1 QSTRING[\" \"] $o1 ( QSTRING[\" ; \\n\"] $v QSTRING[\" \"] $o)* )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2415:5: ^( T_VERB v1= verb o1= objectList ) ( ^( T_VERB v+= verb o+= objectList ) )*
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_VERB593=(CommonTree)match(input,T_VERB,FOLLOW_T_VERB_in_propertyListNotEmpty12851); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_T_VERB.add(T_VERB593);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_verb_in_propertyListNotEmpty12855);
            v1=verb();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_verb.add(v1.getTree());
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_objectList_in_propertyListNotEmpty12859);
            o1=objectList();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_objectList.add(o1.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2415:37: ( ^( T_VERB v+= verb o+= objectList ) )*
            loop166:
            do {
                int alt166=2;
                alt166 = dfa166.predict(input);
                switch (alt166) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2415:38: ^( T_VERB v+= verb o+= objectList )
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    {
            	    CommonTree _save_last_1 = _last;
            	    CommonTree _first_1 = null;
            	    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            	    T_VERB594=(CommonTree)match(input,T_VERB,FOLLOW_T_VERB_in_propertyListNotEmpty12864); if (state.failed) return retval; 
            	    if ( state.backtracking==0 ) stream_T_VERB.add(T_VERB594);



            	    match(input, Token.DOWN, null); if (state.failed) return retval;
            	    _last = (CommonTree)input.LT(1);
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_verb_in_propertyListNotEmpty12868);
            	    v=verb();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_verb.add(v.getTree());
            	    if (list_v==null) list_v=new ArrayList();
            	    list_v.add(v.getTree());

            	    _last = (CommonTree)input.LT(1);
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_objectList_in_propertyListNotEmpty12872);
            	    o=objectList();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_objectList.add(o.getTree());
            	    if (list_o==null) list_o=new ArrayList();
            	    list_o.add(o.getTree());


            	    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            	    }


            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    break loop166;
                }
            } while (true);



            // AST REWRITE
            // elements: o, v, o1, v1
            // token labels: 
            // rule labels: v1, retval, o1
            // token list labels: 
            // rule list labels: v, o
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_v1=new RewriteRuleSubtreeStream(adaptor,"rule v1",v1!=null?v1.tree:null);
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
            RewriteRuleSubtreeStream stream_o1=new RewriteRuleSubtreeStream(adaptor,"rule o1",o1!=null?o1.tree:null);
            RewriteRuleSubtreeStream stream_v=new RewriteRuleSubtreeStream(adaptor,"token v",list_v);
            RewriteRuleSubtreeStream stream_o=new RewriteRuleSubtreeStream(adaptor,"token o",list_o);
            root_0 = (CommonTree)adaptor.nil();
            // 2416:3: -> $v1 QSTRING[\" \"] $o1 ( QSTRING[\" ; \\n\"] $v QSTRING[\" \"] $o)*
            {
                adaptor.addChild(root_0, stream_v1.nextTree());
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, " "));
                adaptor.addChild(root_0, stream_o1.nextTree());
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2416:28: ( QSTRING[\" ; \\n\"] $v QSTRING[\" \"] $o)*
                while ( stream_o.hasNext()||stream_v.hasNext() ) {
                    adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, " ; \n"));
                    adaptor.addChild(root_0, stream_v.nextTree());
                    adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, " "));
                    adaptor.addChild(root_0, stream_o.nextTree());

                }
                stream_o.reset();
                stream_v.reset();

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "propertyListNotEmpty"

    public static class propertyList_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "propertyList"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2419:1: propertyList : ( propertyListNotEmpty )? ;
    public final XSPARQLRewriter.propertyList_return propertyList() throws RecognitionException {
        XSPARQLRewriter.propertyList_return retval = new XSPARQLRewriter.propertyList_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.propertyListNotEmpty_return propertyListNotEmpty595 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2420:3: ( ( propertyListNotEmpty )? )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2420:5: ( propertyListNotEmpty )?
            {
            root_0 = (CommonTree)adaptor.nil();

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2420:5: ( propertyListNotEmpty )?
            int alt167=2;
            switch ( input.LA(1) ) {
                case T_VERB:
                    {
                    alt167=1;
                    }
                    break;
            }

            switch (alt167) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: propertyListNotEmpty
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_propertyListNotEmpty_in_propertyList12918);
                    propertyListNotEmpty595=propertyListNotEmpty();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, propertyListNotEmpty595.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "propertyList"

    public static class propertyList__return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "propertyList_"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2423:1: propertyList_ : ( propertyListNotEmpty_ )? ;
    public final XSPARQLRewriter.propertyList__return propertyList_() throws RecognitionException {
        XSPARQLRewriter.propertyList__return retval = new XSPARQLRewriter.propertyList__return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.propertyListNotEmpty__return propertyListNotEmpty_596 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2424:3: ( ( propertyListNotEmpty_ )? )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2424:5: ( propertyListNotEmpty_ )?
            {
            root_0 = (CommonTree)adaptor.nil();

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2424:5: ( propertyListNotEmpty_ )?
            int alt168=2;
            switch ( input.LA(1) ) {
                case T_VERB:
                    {
                    alt168=1;
                    }
                    break;
            }

            switch (alt168) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: propertyListNotEmpty_
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_propertyListNotEmpty__in_propertyList_12932);
                    propertyListNotEmpty_596=propertyListNotEmpty_();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, propertyListNotEmpty_596.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "propertyList_"

    public static class objectList__return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "objectList_"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2427:1: objectList_ : ^( T_OBJECT o1= object_ ) ( ^( T_OBJECT o+= object_ ) )* -> $o1 ( $o)* ;
    public final XSPARQLRewriter.objectList__return objectList_() throws RecognitionException {
        XSPARQLRewriter.objectList__return retval = new XSPARQLRewriter.objectList__return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_OBJECT597=null;
        CommonTree T_OBJECT598=null;
        List list_o=null;
        XSPARQLRewriter.object__return o1 = null;

        RuleReturnScope o = null;
        CommonTree T_OBJECT597_tree=null;
        CommonTree T_OBJECT598_tree=null;
        RewriteRuleNodeStream stream_T_OBJECT=new RewriteRuleNodeStream(adaptor,"token T_OBJECT");
        RewriteRuleSubtreeStream stream_object_=new RewriteRuleSubtreeStream(adaptor,"rule object_");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2428:3: ( ^( T_OBJECT o1= object_ ) ( ^( T_OBJECT o+= object_ ) )* -> $o1 ( $o)* )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2428:5: ^( T_OBJECT o1= object_ ) ( ^( T_OBJECT o+= object_ ) )*
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_OBJECT597=(CommonTree)match(input,T_OBJECT,FOLLOW_T_OBJECT_in_objectList_12947); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_T_OBJECT.add(T_OBJECT597);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_object__in_objectList_12951);
            o1=object_();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_object_.add(o1.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2428:28: ( ^( T_OBJECT o+= object_ ) )*
            loop169:
            do {
                int alt169=2;
                switch ( input.LA(1) ) {
                case T_OBJECT:
                    {
                    alt169=1;
                    }
                    break;

                }

                switch (alt169) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2428:29: ^( T_OBJECT o+= object_ )
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    {
            	    CommonTree _save_last_1 = _last;
            	    CommonTree _first_1 = null;
            	    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            	    T_OBJECT598=(CommonTree)match(input,T_OBJECT,FOLLOW_T_OBJECT_in_objectList_12956); if (state.failed) return retval; 
            	    if ( state.backtracking==0 ) stream_T_OBJECT.add(T_OBJECT598);



            	    match(input, Token.DOWN, null); if (state.failed) return retval;
            	    _last = (CommonTree)input.LT(1);
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_object__in_objectList_12960);
            	    o=object_();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_object_.add(o.getTree());
            	    if (list_o==null) list_o=new ArrayList();
            	    list_o.add(o.getTree());


            	    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            	    }


            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    break loop169;
                }
            } while (true);



            // AST REWRITE
            // elements: o1, o
            // token labels: 
            // rule labels: retval, o1
            // token list labels: 
            // rule list labels: o
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
            RewriteRuleSubtreeStream stream_o1=new RewriteRuleSubtreeStream(adaptor,"rule o1",o1!=null?o1.tree:null);
            RewriteRuleSubtreeStream stream_o=new RewriteRuleSubtreeStream(adaptor,"token o",list_o);
            root_0 = (CommonTree)adaptor.nil();
            // 2429:3: -> $o1 ( $o)*
            {
                adaptor.addChild(root_0, stream_o1.nextTree());
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2429:10: ( $o)*
                while ( stream_o.hasNext() ) {
                    adaptor.addChild(root_0, stream_o.nextTree());

                }
                stream_o.reset();

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "objectList_"

    public static class objectList_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "objectList"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2432:1: objectList : ^( T_OBJECT o1= object ) ( ^( T_OBJECT o+= object ) )* -> $o1 ( QSTRING[\" , \"] $o)* ;
    public final XSPARQLRewriter.objectList_return objectList() throws RecognitionException {
        XSPARQLRewriter.objectList_return retval = new XSPARQLRewriter.objectList_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_OBJECT599=null;
        CommonTree T_OBJECT600=null;
        List list_o=null;
        XSPARQLRewriter.object_return o1 = null;

        RuleReturnScope o = null;
        CommonTree T_OBJECT599_tree=null;
        CommonTree T_OBJECT600_tree=null;
        RewriteRuleNodeStream stream_T_OBJECT=new RewriteRuleNodeStream(adaptor,"token T_OBJECT");
        RewriteRuleSubtreeStream stream_object=new RewriteRuleSubtreeStream(adaptor,"rule object");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2433:3: ( ^( T_OBJECT o1= object ) ( ^( T_OBJECT o+= object ) )* -> $o1 ( QSTRING[\" , \"] $o)* )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2433:5: ^( T_OBJECT o1= object ) ( ^( T_OBJECT o+= object ) )*
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_OBJECT599=(CommonTree)match(input,T_OBJECT,FOLLOW_T_OBJECT_in_objectList12990); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_T_OBJECT.add(T_OBJECT599);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_object_in_objectList12994);
            o1=object();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_object.add(o1.getTree());

            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2433:27: ( ^( T_OBJECT o+= object ) )*
            loop170:
            do {
                int alt170=2;
                switch ( input.LA(1) ) {
                case T_OBJECT:
                    {
                    alt170=1;
                    }
                    break;

                }

                switch (alt170) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2433:28: ^( T_OBJECT o+= object )
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    {
            	    CommonTree _save_last_1 = _last;
            	    CommonTree _first_1 = null;
            	    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            	    T_OBJECT600=(CommonTree)match(input,T_OBJECT,FOLLOW_T_OBJECT_in_objectList12999); if (state.failed) return retval; 
            	    if ( state.backtracking==0 ) stream_T_OBJECT.add(T_OBJECT600);



            	    match(input, Token.DOWN, null); if (state.failed) return retval;
            	    _last = (CommonTree)input.LT(1);
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_object_in_objectList13003);
            	    o=object();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) stream_object.add(o.getTree());
            	    if (list_o==null) list_o=new ArrayList();
            	    list_o.add(o.getTree());


            	    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            	    }


            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    break loop170;
                }
            } while (true);



            // AST REWRITE
            // elements: o, o1
            // token labels: 
            // rule labels: retval, o1
            // token list labels: 
            // rule list labels: o
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
            RewriteRuleSubtreeStream stream_o1=new RewriteRuleSubtreeStream(adaptor,"rule o1",o1!=null?o1.tree:null);
            RewriteRuleSubtreeStream stream_o=new RewriteRuleSubtreeStream(adaptor,"token o",list_o);
            root_0 = (CommonTree)adaptor.nil();
            // 2434:3: -> $o1 ( QSTRING[\" , \"] $o)*
            {
                adaptor.addChild(root_0, stream_o1.nextTree());
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2434:10: ( QSTRING[\" , \"] $o)*
                while ( stream_o.hasNext() ) {
                    adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, " , "));
                    adaptor.addChild(root_0, stream_o.nextTree());

                }
                stream_o.reset();

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "objectList"

    public static class subject__return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "subject_"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2437:1: subject_ : verb_ ;
    public final XSPARQLRewriter.subject__return subject_() throws RecognitionException {
        XSPARQLRewriter.subject__return retval = new XSPARQLRewriter.subject__return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.verb__return verb_601 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2438:3: ( verb_ )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2441:4: verb_
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_verb__in_subject_13045);
            verb_601=verb_();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, verb_601.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "subject_"

    public static class subject_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "subject"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2447:1: subject : ( resource | i= IRIREF -> QSTRING[$i.token, $i.text] | blank -> QSTRING[\"[]\"] );
    public final XSPARQLRewriter.subject_return subject() throws RecognitionException {
        XSPARQLRewriter.subject_return retval = new XSPARQLRewriter.subject_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree i=null;
        XSPARQLRewriter.resource_return resource602 = null;

        XSPARQLRewriter.blank_return blank603 = null;


        CommonTree i_tree=null;
        RewriteRuleNodeStream stream_IRIREF=new RewriteRuleNodeStream(adaptor,"token IRIREF");
        RewriteRuleSubtreeStream stream_blank=new RewriteRuleSubtreeStream(adaptor,"rule blank");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2448:3: ( resource | i= IRIREF -> QSTRING[$i.token, $i.text] | blank -> QSTRING[\"[]\"] )
            int alt171=3;
            switch ( input.LA(1) ) {
            case VAR:
            case PNAME_NS:
            case PNAME_LN:
                {
                alt171=1;
                }
                break;
            case IRIREF:
                {
                alt171=2;
                }
                break;
            case BLANK_NODE_LABEL:
            case T_EMPTY_ANON_BLANK:
                {
                alt171=3;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 171, 0, input);

                throw nvae;
            }

            switch (alt171) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2448:5: resource
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_resource_in_subject13063);
                    resource602=resource();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, resource602.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2449:5: i= IRIREF
                    {
                    _last = (CommonTree)input.LT(1);
                    i=(CommonTree)match(input,IRIREF,FOLLOW_IRIREF_in_subject13071); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_IRIREF.add(i);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2450:3: -> QSTRING[$i.token, $i.text]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, i.token, (i!=null?i.getText():null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2451:5: blank
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_blank_in_subject13084);
                    blank603=blank();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_blank.add(blank603.getTree());


                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2452:3: -> QSTRING[\"[]\"]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, "[]"));

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "subject"

    public static class resource_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "resource"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2455:1: resource : (p= PNAME_LN -> QSTRING[$p.token, $p.text] | s= PNAME_NS -> QSTRING[$s.token, $s.text] | var= VAR -> {isBoundEarlier($var.text, Types.SPARQL) && $VariableScope::scopedDataset}? -> {isBoundEarlier($var.text, Types.XQUERY) && $VariableScope::scopedDataset}? -> {isBoundEarlier($var.text, Types.SPARQL)}? ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS $var) ) -> {isBoundEarlier($var.text)}? ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $var) ) ) ) -> QSTRING[$var.token, $var.text ] );
    public final XSPARQLRewriter.resource_return resource() throws RecognitionException {
        XSPARQLRewriter.resource_return retval = new XSPARQLRewriter.resource_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree p=null;
        CommonTree s=null;
        CommonTree var=null;

        CommonTree p_tree=null;
        CommonTree s_tree=null;
        CommonTree var_tree=null;
        RewriteRuleNodeStream stream_PNAME_NS=new RewriteRuleNodeStream(adaptor,"token PNAME_NS");
        RewriteRuleNodeStream stream_PNAME_LN=new RewriteRuleNodeStream(adaptor,"token PNAME_LN");
        RewriteRuleNodeStream stream_VAR=new RewriteRuleNodeStream(adaptor,"token VAR");


          String rdftermvar = "";
          logger.info("resource");

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2460:3: (p= PNAME_LN -> QSTRING[$p.token, $p.text] | s= PNAME_NS -> QSTRING[$s.token, $s.text] | var= VAR -> {isBoundEarlier($var.text, Types.SPARQL) && $VariableScope::scopedDataset}? -> {isBoundEarlier($var.text, Types.XQUERY) && $VariableScope::scopedDataset}? -> {isBoundEarlier($var.text, Types.SPARQL)}? ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS $var) ) -> {isBoundEarlier($var.text)}? ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $var) ) ) ) -> QSTRING[$var.token, $var.text ] )
            int alt172=3;
            switch ( input.LA(1) ) {
            case PNAME_LN:
                {
                alt172=1;
                }
                break;
            case PNAME_NS:
                {
                alt172=2;
                }
                break;
            case VAR:
                {
                alt172=3;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 172, 0, input);

                throw nvae;
            }

            switch (alt172) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2460:5: p= PNAME_LN
                    {
                    _last = (CommonTree)input.LT(1);
                    p=(CommonTree)match(input,PNAME_LN,FOLLOW_PNAME_LN_in_resource13111); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_PNAME_LN.add(p);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2461:3: -> QSTRING[$p.token, $p.text]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, p.token, (p!=null?p.getText():null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2462:5: s= PNAME_NS
                    {
                    _last = (CommonTree)input.LT(1);
                    s=(CommonTree)match(input,PNAME_NS,FOLLOW_PNAME_NS_in_resource13126); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_PNAME_NS.add(s);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2463:3: -> QSTRING[$s.token, $s.text]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, s.token, (s!=null?s.getText():null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2464:5: var= VAR
                    {
                    _last = (CommonTree)input.LT(1);
                    var=(CommonTree)match(input,VAR,FOLLOW_VAR_in_resource13141); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_VAR.add(var);



                    // AST REWRITE
                    // elements: var, var
                    // token labels: var
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleNodeStream stream_var=new RewriteRuleNodeStream(adaptor,"token var",var);
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2465:3: -> {isBoundEarlier($var.text, Types.SPARQL) && $VariableScope::scopedDataset}?
                    if (isBoundEarlier((var!=null?var.getText():null), Types.SPARQL) && ((VariableScope_scope)VariableScope_stack.peek()).scopedDataset) {
                        adaptor.addChild(root_0,  addJoinVar(QSTRING, (var!=null?var.getText():null)) );

                    }
                    else // 2466:3: -> {isBoundEarlier($var.text, Types.XQUERY) && $VariableScope::scopedDataset}?
                    if (isBoundEarlier((var!=null?var.getText():null), Types.XQUERY) && ((VariableScope_scope)VariableScope_stack.peek()).scopedDataset) {
                        adaptor.addChild(root_0,  addJoinVar(QSTRING, (var!=null?var.getText():null)) );

                    }
                    else // 2467:3: -> {isBoundEarlier($var.text, Types.SPARQL)}? ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS $var) )
                    if (isBoundEarlier((var!=null?var.getText():null), Types.SPARQL)) {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2467:49: ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS $var) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(NCNAME, rdfTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2467:91: ^( T_PARAMS $var)
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_2);

                        adaptor.addChild(root_2, stream_var.nextNode());

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }
                    else // 2468:3: -> {isBoundEarlier($var.text)}? ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $var) ) ) )
                    if (isBoundEarlier((var!=null?var.getText():null))) {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2468:35: ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $var) ) ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(NCNAME, rdfTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2468:77: ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $var) ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_2);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2468:88: ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $var) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_3);

                        adaptor.addChild(root_3, (CommonTree)adaptor.create(NCNAME, bindingTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2468:134: ^( T_PARAMS $var)
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_4);

                        adaptor.addChild(root_4, stream_var.nextNode());

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }
                    else // 2469:3: -> QSTRING[$var.token, $var.text ]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, var.token, (var!=null?var.getText():null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "resource"

    public static class verb_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "verb"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2472:1: verb : ( resource | a= A -> QSTRING[$a.token, \" \" + $a.text + \" \"] );
    public final XSPARQLRewriter.verb_return verb() throws RecognitionException {
        XSPARQLRewriter.verb_return retval = new XSPARQLRewriter.verb_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree a=null;
        XSPARQLRewriter.resource_return resource604 = null;


        CommonTree a_tree=null;
        RewriteRuleNodeStream stream_A=new RewriteRuleNodeStream(adaptor,"token A");

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2473:3: ( resource | a= A -> QSTRING[$a.token, \" \" + $a.text + \" \"] )
            int alt173=2;
            switch ( input.LA(1) ) {
            case VAR:
            case PNAME_NS:
            case PNAME_LN:
                {
                alt173=1;
                }
                break;
            case A:
                {
                alt173=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 173, 0, input);

                throw nvae;
            }

            switch (alt173) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2473:5: resource
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_resource_in_verb13229);
                    resource604=resource();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, resource604.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2474:5: a= A
                    {
                    _last = (CommonTree)input.LT(1);
                    a=(CommonTree)match(input,A,FOLLOW_A_in_verb13237); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_A.add(a);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2474:9: -> QSTRING[$a.token, \" \" + $a.text + \" \"]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, a.token, " " + (a!=null?a.getText():null) + " "));

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "verb"

    public static class verb__return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "verb_"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2477:1: verb_ : ( sparqlPrefixedName | i= IRIREF -> QSTRING[$i.token, $i.text] | a= A -> QSTRING[$a.token, $a.text] );
    public final XSPARQLRewriter.verb__return verb_() throws RecognitionException {
        XSPARQLRewriter.verb__return retval = new XSPARQLRewriter.verb__return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree i=null;
        CommonTree a=null;
        XSPARQLRewriter.sparqlPrefixedName_return sparqlPrefixedName605 = null;


        CommonTree i_tree=null;
        CommonTree a_tree=null;
        RewriteRuleNodeStream stream_A=new RewriteRuleNodeStream(adaptor,"token A");
        RewriteRuleNodeStream stream_IRIREF=new RewriteRuleNodeStream(adaptor,"token IRIREF");

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2478:3: ( sparqlPrefixedName | i= IRIREF -> QSTRING[$i.token, $i.text] | a= A -> QSTRING[$a.token, $a.text] )
            int alt174=3;
            switch ( input.LA(1) ) {
            case PNAME_NS:
            case PNAME_LN:
                {
                alt174=1;
                }
                break;
            case IRIREF:
                {
                alt174=2;
                }
                break;
            case A:
                {
                alt174=3;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 174, 0, input);

                throw nvae;
            }

            switch (alt174) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2478:5: sparqlPrefixedName
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_sparqlPrefixedName_in_verb_13255);
                    sparqlPrefixedName605=sparqlPrefixedName();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, sparqlPrefixedName605.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2479:5: i= IRIREF
                    {
                    _last = (CommonTree)input.LT(1);
                    i=(CommonTree)match(input,IRIREF,FOLLOW_IRIREF_in_verb_13263); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_IRIREF.add(i);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2479:14: -> QSTRING[$i.token, $i.text]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, i.token, (i!=null?i.getText():null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2480:5: a= A
                    {
                    _last = (CommonTree)input.LT(1);
                    a=(CommonTree)match(input,A,FOLLOW_A_in_verb_13276); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_A.add(a);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2480:9: -> QSTRING[$a.token, $a.text]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, a.token, (a!=null?a.getText():null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "verb_"

    public static class object__return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "object_"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2484:1: object_ : (s= verb_ (n= namedGraph )? -> QSTRING[\" \"] QSTRING[\" \"] $s ( $n)? QSTRING[$triplesSameSubject_::separator] | cvar= constructVar (n= namedGraph )? -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] $cvar) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) ) QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) ) QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) ) ) | bb= bnode (n= namedGraph )? -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$bb.text] ) ) ) ) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] VAR[rdfTermVar] ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) ) ) | rdfLiteral (n= namedGraph )? -> ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] rdfLiteral ( $n)? QSTRING[$triplesSameSubject_::separator] ) | sNumericLiteral (n= namedGraph )? -> ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] sNumericLiteral ( $n)? QSTRING[$triplesSameSubject_::separator] ) | b= blankConstruct (n= namedGraph )? -> ^( T_FLWOR ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS $b) ) ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS $b) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) ) | literalConstruct (n= namedGraph )? -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] literalConstruct ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) ) ) | irix= iriConstruct (n= namedGraph )? -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[\"xsparql:createURI\"] ^( T_PARAMS $irix) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) ) QSTRING[\" \"] QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) ) ) | collection -> ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] collection ) | T_ANON_BLANK propertyListNotEmpty_ -> ^( T_PAR QSTRING[\" \"] QSTRING[\" [ \"] ^( XPATH ^( T_PAR propertyListNotEmpty_ ) LBRACKET[\"[\"] ^( LT[\"lt\"] ^( T_FUNCTION_CALL NCNAME[\"fn:position\"] ^( T_PARAMS ) ) ^( T_FUNCTION_CALL NCNAME[\"fn:last\"] ^( T_PARAMS ) ) ) RBRACKET[\"]\"] ) QSTRING[\" ] \"] QSTRING[$triplesSameSubject_::separator] ) | T_EMPTY_ANON_BLANK propertyListNotEmpty_ -> ^( T_PAR QSTRING[\" \"] QSTRING[\" [ ]\"] propertyListNotEmpty_ QSTRING[$triplesSameSubject_::separator] ) );
    public final XSPARQLRewriter.object__return object_() throws RecognitionException {
        XSPARQLRewriter.object__return retval = new XSPARQLRewriter.object__return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_ANON_BLANK610=null;
        CommonTree T_EMPTY_ANON_BLANK612=null;
        XSPARQLRewriter.verb__return s = null;

        XSPARQLRewriter.namedGraph_return n = null;

        XSPARQLRewriter.constructVar_return cvar = null;

        XSPARQLRewriter.bnode_return bb = null;

        XSPARQLRewriter.blankConstruct_return b = null;

        XSPARQLRewriter.iriConstruct_return irix = null;

        XSPARQLRewriter.rdfLiteral_return rdfLiteral606 = null;

        XSPARQLRewriter.sNumericLiteral_return sNumericLiteral607 = null;

        XSPARQLRewriter.literalConstruct_return literalConstruct608 = null;

        XSPARQLRewriter.collection_return collection609 = null;

        XSPARQLRewriter.propertyListNotEmpty__return propertyListNotEmpty_611 = null;

        XSPARQLRewriter.propertyListNotEmpty__return propertyListNotEmpty_613 = null;


        CommonTree T_ANON_BLANK610_tree=null;
        CommonTree T_EMPTY_ANON_BLANK612_tree=null;
        RewriteRuleNodeStream stream_T_EMPTY_ANON_BLANK=new RewriteRuleNodeStream(adaptor,"token T_EMPTY_ANON_BLANK");
        RewriteRuleNodeStream stream_T_ANON_BLANK=new RewriteRuleNodeStream(adaptor,"token T_ANON_BLANK");
        RewriteRuleSubtreeStream stream_constructVar=new RewriteRuleSubtreeStream(adaptor,"rule constructVar");
        RewriteRuleSubtreeStream stream_blankConstruct=new RewriteRuleSubtreeStream(adaptor,"rule blankConstruct");
        RewriteRuleSubtreeStream stream_rdfLiteral=new RewriteRuleSubtreeStream(adaptor,"rule rdfLiteral");
        RewriteRuleSubtreeStream stream_bnode=new RewriteRuleSubtreeStream(adaptor,"rule bnode");
        RewriteRuleSubtreeStream stream_propertyListNotEmpty_=new RewriteRuleSubtreeStream(adaptor,"rule propertyListNotEmpty_");
        RewriteRuleSubtreeStream stream_collection=new RewriteRuleSubtreeStream(adaptor,"rule collection");
        RewriteRuleSubtreeStream stream_iriConstruct=new RewriteRuleSubtreeStream(adaptor,"rule iriConstruct");
        RewriteRuleSubtreeStream stream_sNumericLiteral=new RewriteRuleSubtreeStream(adaptor,"rule sNumericLiteral");
        RewriteRuleSubtreeStream stream_namedGraph=new RewriteRuleSubtreeStream(adaptor,"rule namedGraph");
        RewriteRuleSubtreeStream stream_literalConstruct=new RewriteRuleSubtreeStream(adaptor,"rule literalConstruct");
        RewriteRuleSubtreeStream stream_verb_=new RewriteRuleSubtreeStream(adaptor,"rule verb_");

          String rdfTermVar = getNewTempRdfTermVariable();

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2488:3: (s= verb_ (n= namedGraph )? -> QSTRING[\" \"] QSTRING[\" \"] $s ( $n)? QSTRING[$triplesSameSubject_::separator] | cvar= constructVar (n= namedGraph )? -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] $cvar) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) ) QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) ) QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) ) ) | bb= bnode (n= namedGraph )? -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$bb.text] ) ) ) ) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] VAR[rdfTermVar] ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) ) ) | rdfLiteral (n= namedGraph )? -> ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] rdfLiteral ( $n)? QSTRING[$triplesSameSubject_::separator] ) | sNumericLiteral (n= namedGraph )? -> ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] sNumericLiteral ( $n)? QSTRING[$triplesSameSubject_::separator] ) | b= blankConstruct (n= namedGraph )? -> ^( T_FLWOR ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS $b) ) ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS $b) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) ) | literalConstruct (n= namedGraph )? -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] literalConstruct ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) ) ) | irix= iriConstruct (n= namedGraph )? -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[\"xsparql:createURI\"] ^( T_PARAMS $irix) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) ) QSTRING[\" \"] QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) ) ) | collection -> ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] collection ) | T_ANON_BLANK propertyListNotEmpty_ -> ^( T_PAR QSTRING[\" \"] QSTRING[\" [ \"] ^( XPATH ^( T_PAR propertyListNotEmpty_ ) LBRACKET[\"[\"] ^( LT[\"lt\"] ^( T_FUNCTION_CALL NCNAME[\"fn:position\"] ^( T_PARAMS ) ) ^( T_FUNCTION_CALL NCNAME[\"fn:last\"] ^( T_PARAMS ) ) ) RBRACKET[\"]\"] ) QSTRING[\" ] \"] QSTRING[$triplesSameSubject_::separator] ) | T_EMPTY_ANON_BLANK propertyListNotEmpty_ -> ^( T_PAR QSTRING[\" \"] QSTRING[\" [ ]\"] propertyListNotEmpty_ QSTRING[$triplesSameSubject_::separator] ) )
            int alt183=11;
            switch ( input.LA(1) ) {
            case PNAME_NS:
            case PNAME_LN:
            case IRIREF:
            case A:
                {
                alt183=1;
                }
                break;
            case VAR:
                {
                alt183=2;
                }
                break;
            case BLANK_NODE_LABEL:
                {
                alt183=3;
                }
                break;
            case QSTRING:
                {
                alt183=4;
                }
                break;
            case INTEGER:
                {
                alt183=5;
                }
                break;
            case BNODE_CONSTRUCT:
                {
                alt183=6;
                }
                break;
            case T_LITERAL_CONSTRUCT:
                {
                alt183=7;
                }
                break;
            case T_IRI_CONSTRUCT:
                {
                alt183=8;
                }
                break;
            case LPAR:
                {
                alt183=9;
                }
                break;
            case T_ANON_BLANK:
                {
                alt183=10;
                }
                break;
            case T_EMPTY_ANON_BLANK:
                {
                alt183=11;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 183, 0, input);

                throw nvae;
            }

            switch (alt183) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2488:5: s= verb_ (n= namedGraph )?
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_verb__in_object_13304);
                    s=verb_();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_verb_.add(s.getTree());
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2488:14: (n= namedGraph )?
                    int alt175=2;
                    switch ( input.LA(1) ) {
                        case PNAME_LN:
                        case IRIREF:
                        case T_IRI_CONSTRUCT:
                            {
                            alt175=1;
                            }
                            break;
                    }

                    switch (alt175) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: n= namedGraph
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_namedGraph_in_object_13308);
                            n=namedGraph();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_namedGraph.add(n.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }



                    // AST REWRITE
                    // elements: n, s
                    // token labels: 
                    // rule labels: retval, s, n
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
                    RewriteRuleSubtreeStream stream_s=new RewriteRuleSubtreeStream(adaptor,"rule s",s!=null?s.tree:null);
                    RewriteRuleSubtreeStream stream_n=new RewriteRuleSubtreeStream(adaptor,"rule n",n!=null?n.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2489:5: -> QSTRING[\" \"] QSTRING[\" \"] $s ( $n)? QSTRING[$triplesSameSubject_::separator]
                    {
                        adaptor.addChild(root_0, new CommonTree(((triplesSameSubject__scope)triplesSameSubject__stack.peek()).subject));
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, " "));
                        adaptor.addChild(root_0, new CommonTree(((verbObjectList__scope)verbObjectList__stack.peek()).verb));
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, " "));
                        adaptor.addChild(root_0, stream_s.nextTree());
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2489:126: ( $n)?
                        if ( stream_n.hasNext() ) {
                            adaptor.addChild(root_0, stream_n.nextTree());

                        }
                        stream_n.reset();
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).separator));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2491:5: cvar= constructVar (n= namedGraph )?
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_constructVar_in_object_13344);
                    cvar=constructVar();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_constructVar.add(cvar.getTree());
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2491:24: (n= namedGraph )?
                    int alt176=2;
                    switch ( input.LA(1) ) {
                        case PNAME_LN:
                        case IRIREF:
                        case T_IRI_CONSTRUCT:
                            {
                            alt176=1;
                            }
                            break;
                    }

                    switch (alt176) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: n= namedGraph
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_namedGraph_in_object_13348);
                            n=namedGraph();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_namedGraph.add(n.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }



                    // AST REWRITE
                    // elements: n, cvar
                    // token labels: 
                    // rule labels: cvar, retval, n
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_cvar=new RewriteRuleSubtreeStream(adaptor,"rule cvar",cvar!=null?cvar.tree:null);
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
                    RewriteRuleSubtreeStream stream_n=new RewriteRuleSubtreeStream(adaptor,"rule n",n!=null?n.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2492:5: -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] $cvar) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) ) QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) ) QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2492:8: ^( T_FLWOR ^( T_LET VAR[rdfTermVar] $cvar) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) ) QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) ) QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FLWOR, "T_FLWOR"), root_1);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2493:7: ^( T_LET VAR[rdfTermVar] $cvar)
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_LET, "T_LET"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(VAR, rdfTermVar));
                        adaptor.addChild(root_2, stream_cvar.nextTree());

                        adaptor.addChild(root_1, root_2);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2497:7: ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) ) QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) ) QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_RETURN, "T_RETURN"), root_2);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2498:9: ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) ) QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) ) QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(IF, "IF"), root_3);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2499:11: ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_4);

                        adaptor.addChild(root_4, (CommonTree)adaptor.create(NCNAME, validObjectFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2499:57: ^( T_PARAMS VAR[rdfTermVar] )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(VAR, rdfTermVar));

                        adaptor.addChild(root_4, root_5);
                        }

                        adaptor.addChild(root_3, root_4);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2500:11: ^( T_PAR ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) ) QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) ) QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ( $n)? QSTRING[$triplesSameSubject_::separator] )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_4);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2500:19: ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(NCNAME, rdfTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2501:21: ^( T_PARAMS )
                        {
                        CommonTree root_6 = (CommonTree)adaptor.nil();
                        root_6 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_6);

                        adaptor.addChild(root_6, new CommonTree(((triplesSameSubject__scope)triplesSameSubject__stack.peek()).subject));

                        adaptor.addChild(root_5, root_6);
                        }

                        adaptor.addChild(root_4, root_5);
                        }
                        adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, " "));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2504:19: ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(NCNAME, rdfTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2505:21: ^( T_PARAMS )
                        {
                        CommonTree root_6 = (CommonTree)adaptor.nil();
                        root_6 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_6);

                        adaptor.addChild(root_6, new CommonTree(((verbObjectList__scope)verbObjectList__stack.peek()).verb));

                        adaptor.addChild(root_5, root_6);
                        }

                        adaptor.addChild(root_4, root_5);
                        }
                        adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, " "));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2508:19: ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(NCNAME, rdfTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2508:61: ^( T_PARAMS VAR[rdfTermVar] )
                        {
                        CommonTree root_6 = (CommonTree)adaptor.nil();
                        root_6 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_6);

                        adaptor.addChild(root_6, (CommonTree)adaptor.create(VAR, rdfTermVar));

                        adaptor.addChild(root_5, root_6);
                        }

                        adaptor.addChild(root_4, root_5);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2509:19: ( $n)?
                        if ( stream_n.hasNext() ) {
                            adaptor.addChild(root_4, stream_n.nextTree());

                        }
                        stream_n.reset();
                        adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).separator));

                        adaptor.addChild(root_3, root_4);
                        }
                        adaptor.addChild(root_3, (CommonTree)adaptor.create(QSTRING, ""));

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2516:5: bb= bnode (n= namedGraph )?
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_bnode_in_object_13759);
                    bb=bnode();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_bnode.add(bb.getTree());
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2516:15: (n= namedGraph )?
                    int alt177=2;
                    switch ( input.LA(1) ) {
                        case PNAME_LN:
                        case IRIREF:
                        case T_IRI_CONSTRUCT:
                            {
                            alt177=1;
                            }
                            break;
                    }

                    switch (alt177) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: n= namedGraph
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_namedGraph_in_object_13763);
                            n=namedGraph();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_namedGraph.add(n.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }



                    // AST REWRITE
                    // elements: n
                    // token labels: 
                    // rule labels: retval, n
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
                    RewriteRuleSubtreeStream stream_n=new RewriteRuleSubtreeStream(adaptor,"rule n",n!=null?n.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2517:3: -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$bb.text] ) ) ) ) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] VAR[rdfTermVar] ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2517:7: ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$bb.text] ) ) ) ) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] VAR[rdfTermVar] ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FLWOR, "T_FLWOR"), root_1);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2518:9: ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$bb.text] ) ) ) ) ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_LET, "T_LET"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(VAR, rdfTermVar));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2520:11: ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$bb.text] ) ) ) ) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_3);

                        adaptor.addChild(root_3, (CommonTree)adaptor.create(NCNAME, bindingTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2522:13: ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$bb.text] ) ) ) )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_4);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2523:15: ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$bb.text] ) ) )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(NCNAME, serializeFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2525:17: ^( T_PARAMS ^( T_PAR QSTRING[$bb.text] ) )
                        {
                        CommonTree root_6 = (CommonTree)adaptor.nil();
                        root_6 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_6);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2526:19: ^( T_PAR QSTRING[$bb.text] )
                        {
                        CommonTree root_7 = (CommonTree)adaptor.nil();
                        root_7 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_7);

                        adaptor.addChild(root_7, (CommonTree)adaptor.create(QSTRING, (bb!=null?(input.getTokenStream().toString(
                          input.getTreeAdaptor().getTokenStartIndex(bb.start),
                          input.getTreeAdaptor().getTokenStopIndex(bb.start))):null)));
                        adaptor.addChild(root_7, getPositionVarList());

                        adaptor.addChild(root_6, root_7);
                        }

                        adaptor.addChild(root_5, root_6);
                        }

                        adaptor.addChild(root_4, root_5);
                        }

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2535:10: ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] VAR[rdfTermVar] ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_RETURN, "T_RETURN"), root_2);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2536:12: ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] VAR[rdfTermVar] ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(IF, "IF"), root_3);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2537:14: ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_4);

                        adaptor.addChild(root_4, (CommonTree)adaptor.create(NCNAME, validObjectFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2537:60: ^( T_PARAMS VAR[rdfTermVar] )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(VAR, rdfTermVar));

                        adaptor.addChild(root_4, root_5);
                        }

                        adaptor.addChild(root_3, root_4);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2538:14: ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] VAR[rdfTermVar] ( $n)? QSTRING[$triplesSameSubject_::separator] )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_4);

                        adaptor.addChild(root_4, new CommonTree(((triplesSameSubject__scope)triplesSameSubject__stack.peek()).subject));
                        adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, " "));
                        adaptor.addChild(root_4, new CommonTree(((verbObjectList__scope)verbObjectList__stack.peek()).verb));
                        adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, " "));
                        adaptor.addChild(root_4, (CommonTree)adaptor.create(VAR, rdfTermVar));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2538:153: ( $n)?
                        if ( stream_n.hasNext() ) {
                            adaptor.addChild(root_4, stream_n.nextTree());

                        }
                        stream_n.reset();
                        adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).separator));

                        adaptor.addChild(root_3, root_4);
                        }
                        adaptor.addChild(root_3, (CommonTree)adaptor.create(QSTRING, ""));

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2543:5: rdfLiteral (n= namedGraph )?
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_rdfLiteral_in_object_14213);
                    rdfLiteral606=rdfLiteral();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_rdfLiteral.add(rdfLiteral606.getTree());
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2543:17: (n= namedGraph )?
                    int alt178=2;
                    switch ( input.LA(1) ) {
                        case PNAME_LN:
                        case IRIREF:
                        case T_IRI_CONSTRUCT:
                            {
                            alt178=1;
                            }
                            break;
                    }

                    switch (alt178) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: n= namedGraph
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_namedGraph_in_object_14217);
                            n=namedGraph();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_namedGraph.add(n.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }



                    // AST REWRITE
                    // elements: n, rdfLiteral
                    // token labels: 
                    // rule labels: retval, n
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
                    RewriteRuleSubtreeStream stream_n=new RewriteRuleSubtreeStream(adaptor,"rule n",n!=null?n.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2544:3: -> ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] rdfLiteral ( $n)? QSTRING[$triplesSameSubject_::separator] )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2544:6: ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] rdfLiteral ( $n)? QSTRING[$triplesSameSubject_::separator] )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_1);

                        adaptor.addChild(root_1, new CommonTree(((triplesSameSubject__scope)triplesSameSubject__stack.peek()).subject));
                        adaptor.addChild(root_1, (CommonTree)adaptor.create(QSTRING, " "));
                        adaptor.addChild(root_1, new CommonTree(((verbObjectList__scope)verbObjectList__stack.peek()).verb));
                        adaptor.addChild(root_1, (CommonTree)adaptor.create(QSTRING, " "));
                        adaptor.addChild(root_1, stream_rdfLiteral.nextTree());
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2544:140: ( $n)?
                        if ( stream_n.hasNext() ) {
                            adaptor.addChild(root_1, stream_n.nextTree());

                        }
                        stream_n.reset();
                        adaptor.addChild(root_1, (CommonTree)adaptor.create(QSTRING, ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).separator));

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 5 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2545:5: sNumericLiteral (n= namedGraph )?
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_sNumericLiteral_in_object_14251);
                    sNumericLiteral607=sNumericLiteral();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_sNumericLiteral.add(sNumericLiteral607.getTree());
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2545:22: (n= namedGraph )?
                    int alt179=2;
                    switch ( input.LA(1) ) {
                        case PNAME_LN:
                        case IRIREF:
                        case T_IRI_CONSTRUCT:
                            {
                            alt179=1;
                            }
                            break;
                    }

                    switch (alt179) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: n= namedGraph
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_namedGraph_in_object_14255);
                            n=namedGraph();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_namedGraph.add(n.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }



                    // AST REWRITE
                    // elements: n, sNumericLiteral
                    // token labels: 
                    // rule labels: retval, n
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
                    RewriteRuleSubtreeStream stream_n=new RewriteRuleSubtreeStream(adaptor,"rule n",n!=null?n.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2546:3: -> ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] sNumericLiteral ( $n)? QSTRING[$triplesSameSubject_::separator] )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2546:6: ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] sNumericLiteral ( $n)? QSTRING[$triplesSameSubject_::separator] )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_1);

                        adaptor.addChild(root_1, new CommonTree(((triplesSameSubject__scope)triplesSameSubject__stack.peek()).subject));
                        adaptor.addChild(root_1, (CommonTree)adaptor.create(QSTRING, " "));
                        adaptor.addChild(root_1, new CommonTree(((verbObjectList__scope)verbObjectList__stack.peek()).verb));
                        adaptor.addChild(root_1, (CommonTree)adaptor.create(QSTRING, " "));
                        adaptor.addChild(root_1, stream_sNumericLiteral.nextTree());
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2546:145: ( $n)?
                        if ( stream_n.hasNext() ) {
                            adaptor.addChild(root_1, stream_n.nextTree());

                        }
                        stream_n.reset();
                        adaptor.addChild(root_1, (CommonTree)adaptor.create(QSTRING, ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).separator));

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 6 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2547:5: b= blankConstruct (n= namedGraph )?
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_blankConstruct_in_object_14291);
                    b=blankConstruct();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_blankConstruct.add(b.getTree());
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2547:23: (n= namedGraph )?
                    int alt180=2;
                    switch ( input.LA(1) ) {
                        case PNAME_LN:
                        case IRIREF:
                        case T_IRI_CONSTRUCT:
                            {
                            alt180=1;
                            }
                            break;
                    }

                    switch (alt180) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: n= namedGraph
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_namedGraph_in_object_14295);
                            n=namedGraph();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_namedGraph.add(n.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }



                    // AST REWRITE
                    // elements: n, b, b
                    // token labels: 
                    // rule labels: retval, b, n
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
                    RewriteRuleSubtreeStream stream_b=new RewriteRuleSubtreeStream(adaptor,"rule b",b!=null?b.tree:null);
                    RewriteRuleSubtreeStream stream_n=new RewriteRuleSubtreeStream(adaptor,"rule n",n!=null?n.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2548:3: -> ^( T_FLWOR ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS $b) ) ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS $b) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2548:6: ^( T_FLWOR ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS $b) ) ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS $b) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FLWOR, "T_FLWOR"), root_1);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2549:10: ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS $b) ) ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS $b) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(IF, "IF"), root_2);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2550:12: ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS $b) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_3);

                        adaptor.addChild(root_3, (CommonTree)adaptor.create(NCNAME, validObjectFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2550:58: ^( T_PARAMS $b)
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_4);

                        adaptor.addChild(root_4, stream_b.nextTree());

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2551:12: ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS $b) ) ( $n)? QSTRING[$triplesSameSubject_::separator] )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_3);

                        adaptor.addChild(root_3, new CommonTree(((triplesSameSubject__scope)triplesSameSubject__stack.peek()).subject));
                        adaptor.addChild(root_3, (CommonTree)adaptor.create(QSTRING, " "));
                        adaptor.addChild(root_3, new CommonTree(((verbObjectList__scope)verbObjectList__stack.peek()).verb));
                        adaptor.addChild(root_3, (CommonTree)adaptor.create(QSTRING, " "));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2551:135: ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS $b) )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_4);

                        adaptor.addChild(root_4, (CommonTree)adaptor.create(NCNAME, rdfTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2551:177: ^( T_PARAMS $b)
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_5);

                        adaptor.addChild(root_5, stream_b.nextTree());

                        adaptor.addChild(root_4, root_5);
                        }

                        adaptor.addChild(root_3, root_4);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2551:193: ( $n)?
                        if ( stream_n.hasNext() ) {
                            adaptor.addChild(root_3, stream_n.nextTree());

                        }
                        stream_n.reset();
                        adaptor.addChild(root_3, (CommonTree)adaptor.create(QSTRING, ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).separator));

                        adaptor.addChild(root_2, root_3);
                        }
                        adaptor.addChild(root_2, (CommonTree)adaptor.create(QSTRING, ""));

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 7 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2555:5: literalConstruct (n= namedGraph )?
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_literalConstruct_in_object_14427);
                    literalConstruct608=literalConstruct();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_literalConstruct.add(literalConstruct608.getTree());
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2555:23: (n= namedGraph )?
                    int alt181=2;
                    switch ( input.LA(1) ) {
                        case PNAME_LN:
                        case IRIREF:
                        case T_IRI_CONSTRUCT:
                            {
                            alt181=1;
                            }
                            break;
                    }

                    switch (alt181) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: n= namedGraph
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_namedGraph_in_object_14431);
                            n=namedGraph();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_namedGraph.add(n.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }



                    // AST REWRITE
                    // elements: n, literalConstruct
                    // token labels: 
                    // rule labels: retval, n
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
                    RewriteRuleSubtreeStream stream_n=new RewriteRuleSubtreeStream(adaptor,"rule n",n!=null?n.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2556:3: -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] literalConstruct ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2556:6: ^( T_FLWOR ^( T_LET VAR[rdfTermVar] literalConstruct ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FLWOR, "T_FLWOR"), root_1);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2557:8: ^( T_LET VAR[rdfTermVar] literalConstruct )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_LET, "T_LET"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(VAR, rdfTermVar));
                        adaptor.addChild(root_2, stream_literalConstruct.nextTree());

                        adaptor.addChild(root_1, root_2);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2561:8: ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_RETURN, "T_RETURN"), root_2);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2562:10: ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(IF, "IF"), root_3);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2563:12: ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_4);

                        adaptor.addChild(root_4, (CommonTree)adaptor.create(NCNAME, validObjectFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2563:58: ^( T_PARAMS VAR[rdfTermVar] )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(VAR, rdfTermVar));

                        adaptor.addChild(root_4, root_5);
                        }

                        adaptor.addChild(root_3, root_4);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2564:12: ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ( $n)? QSTRING[$triplesSameSubject_::separator] )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_4);

                        adaptor.addChild(root_4, new CommonTree(((triplesSameSubject__scope)triplesSameSubject__stack.peek()).subject));
                        adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, " "));
                        adaptor.addChild(root_4, new CommonTree(((verbObjectList__scope)verbObjectList__stack.peek()).verb));
                        adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, " "));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2564:135: ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(NCNAME, rdfTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2564:177: ^( T_PARAMS VAR[rdfTermVar] )
                        {
                        CommonTree root_6 = (CommonTree)adaptor.nil();
                        root_6 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_6);

                        adaptor.addChild(root_6, (CommonTree)adaptor.create(VAR, rdfTermVar));

                        adaptor.addChild(root_5, root_6);
                        }

                        adaptor.addChild(root_4, root_5);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2564:206: ( $n)?
                        if ( stream_n.hasNext() ) {
                            adaptor.addChild(root_4, stream_n.nextTree());

                        }
                        stream_n.reset();
                        adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).separator));

                        adaptor.addChild(root_3, root_4);
                        }
                        adaptor.addChild(root_3, (CommonTree)adaptor.create(QSTRING, ""));

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 8 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2569:5: irix= iriConstruct (n= namedGraph )?
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_iriConstruct_in_object_14630);
                    irix=iriConstruct();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_iriConstruct.add(irix.getTree());
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2569:24: (n= namedGraph )?
                    int alt182=2;
                    switch ( input.LA(1) ) {
                        case PNAME_LN:
                        case IRIREF:
                        case T_IRI_CONSTRUCT:
                            {
                            alt182=1;
                            }
                            break;
                    }

                    switch (alt182) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: n= namedGraph
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_namedGraph_in_object_14634);
                            n=namedGraph();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_namedGraph.add(n.getTree());

                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }



                    // AST REWRITE
                    // elements: n, irix
                    // token labels: 
                    // rule labels: retval, irix, n
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
                    RewriteRuleSubtreeStream stream_irix=new RewriteRuleSubtreeStream(adaptor,"rule irix",irix!=null?irix.tree:null);
                    RewriteRuleSubtreeStream stream_n=new RewriteRuleSubtreeStream(adaptor,"rule n",n!=null?n.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2570:3: -> ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[\"xsparql:createURI\"] ^( T_PARAMS $irix) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) ) QSTRING[\" \"] QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2570:6: ^( T_FLWOR ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[\"xsparql:createURI\"] ^( T_PARAMS $irix) ) ) ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) ) QSTRING[\" \"] QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FLWOR, "T_FLWOR"), root_1);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2571:8: ^( T_LET VAR[rdfTermVar] ^( T_FUNCTION_CALL NCNAME[\"xsparql:createURI\"] ^( T_PARAMS $irix) ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_LET, "T_LET"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(VAR, rdfTermVar));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2573:11: ^( T_FUNCTION_CALL NCNAME[\"xsparql:createURI\"] ^( T_PARAMS $irix) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_3);

                        adaptor.addChild(root_3, (CommonTree)adaptor.create(NCNAME, "xsparql:createURI"));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2575:12: ^( T_PARAMS $irix)
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_4);

                        adaptor.addChild(root_4, stream_irix.nextTree());

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2580:8: ^( T_RETURN ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) ) QSTRING[\" \"] QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_RETURN, "T_RETURN"), root_2);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2581:10: ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ^( T_PAR ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) ) QSTRING[\" \"] QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ( $n)? QSTRING[$triplesSameSubject_::separator] ) QSTRING[\"\"] )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(IF, "IF"), root_3);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2582:12: ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS VAR[rdfTermVar] ) )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_4);

                        adaptor.addChild(root_4, (CommonTree)adaptor.create(NCNAME, validObjectFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2582:58: ^( T_PARAMS VAR[rdfTermVar] )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(VAR, rdfTermVar));

                        adaptor.addChild(root_4, root_5);
                        }

                        adaptor.addChild(root_3, root_4);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2583:12: ^( T_PAR ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) ) QSTRING[\" \"] QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) ) ( $n)? QSTRING[$triplesSameSubject_::separator] )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_4);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2583:20: ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ) )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(NCNAME, rdfTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2583:62: ^( T_PARAMS )
                        {
                        CommonTree root_6 = (CommonTree)adaptor.nil();
                        root_6 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_6);

                        adaptor.addChild(root_6, new CommonTree(((triplesSameSubject__scope)triplesSameSubject__stack.peek()).subject));

                        adaptor.addChild(root_5, root_6);
                        }

                        adaptor.addChild(root_4, root_5);
                        }
                        adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, " "));
                        adaptor.addChild(root_4, new CommonTree(((verbObjectList__scope)verbObjectList__stack.peek()).verb));
                        adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, " "));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2583:190: ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS VAR[rdfTermVar] ) )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_5);

                        adaptor.addChild(root_5, (CommonTree)adaptor.create(NCNAME, rdfTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2583:232: ^( T_PARAMS VAR[rdfTermVar] )
                        {
                        CommonTree root_6 = (CommonTree)adaptor.nil();
                        root_6 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_6);

                        adaptor.addChild(root_6, (CommonTree)adaptor.create(VAR, rdfTermVar));

                        adaptor.addChild(root_5, root_6);
                        }

                        adaptor.addChild(root_4, root_5);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2583:261: ( $n)?
                        if ( stream_n.hasNext() ) {
                            adaptor.addChild(root_4, stream_n.nextTree());

                        }
                        stream_n.reset();
                        adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).separator));

                        adaptor.addChild(root_3, root_4);
                        }
                        adaptor.addChild(root_3, (CommonTree)adaptor.create(QSTRING, ""));

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 9 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2588:5: collection
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_collection_in_object_14915);
                    collection609=collection();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_collection.add(collection609.getTree());


                    // AST REWRITE
                    // elements: collection
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2589:3: -> ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] collection )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2589:6: ^( T_PAR QSTRING[\" \"] QSTRING[\" \"] collection )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_1);

                        adaptor.addChild(root_1, new CommonTree(((triplesSameSubject__scope)triplesSameSubject__stack.peek()).subject));
                        adaptor.addChild(root_1, (CommonTree)adaptor.create(QSTRING, " "));
                        adaptor.addChild(root_1, new CommonTree(((verbObjectList__scope)verbObjectList__stack.peek()).verb));
                        adaptor.addChild(root_1, (CommonTree)adaptor.create(QSTRING, " "));
                        adaptor.addChild(root_1, stream_collection.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 10 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2590:5: T_ANON_BLANK propertyListNotEmpty_
                    {
                    _last = (CommonTree)input.LT(1);
                    T_ANON_BLANK610=(CommonTree)match(input,T_ANON_BLANK,FOLLOW_T_ANON_BLANK_in_object_14941); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_ANON_BLANK.add(T_ANON_BLANK610);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_propertyListNotEmpty__in_object_14943);
                    propertyListNotEmpty_611=propertyListNotEmpty_();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_propertyListNotEmpty_.add(propertyListNotEmpty_611.getTree());


                    // AST REWRITE
                    // elements: propertyListNotEmpty_
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2591:3: -> ^( T_PAR QSTRING[\" \"] QSTRING[\" [ \"] ^( XPATH ^( T_PAR propertyListNotEmpty_ ) LBRACKET[\"[\"] ^( LT[\"lt\"] ^( T_FUNCTION_CALL NCNAME[\"fn:position\"] ^( T_PARAMS ) ) ^( T_FUNCTION_CALL NCNAME[\"fn:last\"] ^( T_PARAMS ) ) ) RBRACKET[\"]\"] ) QSTRING[\" ] \"] QSTRING[$triplesSameSubject_::separator] )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2591:6: ^( T_PAR QSTRING[\" \"] QSTRING[\" [ \"] ^( XPATH ^( T_PAR propertyListNotEmpty_ ) LBRACKET[\"[\"] ^( LT[\"lt\"] ^( T_FUNCTION_CALL NCNAME[\"fn:position\"] ^( T_PARAMS ) ) ^( T_FUNCTION_CALL NCNAME[\"fn:last\"] ^( T_PARAMS ) ) ) RBRACKET[\"]\"] ) QSTRING[\" ] \"] QSTRING[$triplesSameSubject_::separator] )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_1);

                        adaptor.addChild(root_1, new CommonTree(((triplesSameSubject__scope)triplesSameSubject__stack.peek()).subject));
                        adaptor.addChild(root_1, (CommonTree)adaptor.create(QSTRING, " "));
                        adaptor.addChild(root_1, new CommonTree(((verbObjectList__scope)verbObjectList__stack.peek()).verb));
                        adaptor.addChild(root_1, (CommonTree)adaptor.create(QSTRING, " [ "));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2591:132: ^( XPATH ^( T_PAR propertyListNotEmpty_ ) LBRACKET[\"[\"] ^( LT[\"lt\"] ^( T_FUNCTION_CALL NCNAME[\"fn:position\"] ^( T_PARAMS ) ) ^( T_FUNCTION_CALL NCNAME[\"fn:last\"] ^( T_PARAMS ) ) ) RBRACKET[\"]\"] )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(XPATH, "XPATH"), root_2);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2591:140: ^( T_PAR propertyListNotEmpty_ )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_3);

                        adaptor.addChild(root_3, stream_propertyListNotEmpty_.nextTree());

                        adaptor.addChild(root_2, root_3);
                        }
                        adaptor.addChild(root_2, (CommonTree)adaptor.create(LBRACKET, "["));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2591:185: ^( LT[\"lt\"] ^( T_FUNCTION_CALL NCNAME[\"fn:position\"] ^( T_PARAMS ) ) ^( T_FUNCTION_CALL NCNAME[\"fn:last\"] ^( T_PARAMS ) ) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(LT, "lt"), root_3);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2591:196: ^( T_FUNCTION_CALL NCNAME[\"fn:position\"] ^( T_PARAMS ) )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_4);

                        adaptor.addChild(root_4, (CommonTree)adaptor.create(NCNAME, "fn:position"));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2591:236: ^( T_PARAMS )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_5);

                        adaptor.addChild(root_4, root_5);
                        }

                        adaptor.addChild(root_3, root_4);
                        }
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2591:250: ^( T_FUNCTION_CALL NCNAME[\"fn:last\"] ^( T_PARAMS ) )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_4);

                        adaptor.addChild(root_4, (CommonTree)adaptor.create(NCNAME, "fn:last"));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2591:286: ^( T_PARAMS )
                        {
                        CommonTree root_5 = (CommonTree)adaptor.nil();
                        root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_5);

                        adaptor.addChild(root_4, root_5);
                        }

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }
                        adaptor.addChild(root_2, (CommonTree)adaptor.create(RBRACKET, "]"));

                        adaptor.addChild(root_1, root_2);
                        }
                        adaptor.addChild(root_1, (CommonTree)adaptor.create(QSTRING, " ] "));
                        adaptor.addChild(root_1, (CommonTree)adaptor.create(QSTRING, ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).separator));

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 11 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2592:5: T_EMPTY_ANON_BLANK propertyListNotEmpty_
                    {
                    _last = (CommonTree)input.LT(1);
                    T_EMPTY_ANON_BLANK612=(CommonTree)match(input,T_EMPTY_ANON_BLANK,FOLLOW_T_EMPTY_ANON_BLANK_in_object_15020); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_EMPTY_ANON_BLANK.add(T_EMPTY_ANON_BLANK612);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_propertyListNotEmpty__in_object_15022);
                    propertyListNotEmpty_613=propertyListNotEmpty_();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_propertyListNotEmpty_.add(propertyListNotEmpty_613.getTree());


                    // AST REWRITE
                    // elements: propertyListNotEmpty_
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2593:3: -> ^( T_PAR QSTRING[\" \"] QSTRING[\" [ ]\"] propertyListNotEmpty_ QSTRING[$triplesSameSubject_::separator] )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2593:6: ^( T_PAR QSTRING[\" \"] QSTRING[\" [ ]\"] propertyListNotEmpty_ QSTRING[$triplesSameSubject_::separator] )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_1);

                        adaptor.addChild(root_1, new CommonTree(((triplesSameSubject__scope)triplesSameSubject__stack.peek()).subject));
                        adaptor.addChild(root_1, (CommonTree)adaptor.create(QSTRING, " "));
                        adaptor.addChild(root_1, new CommonTree(((verbObjectList__scope)verbObjectList__stack.peek()).verb));
                        adaptor.addChild(root_1, (CommonTree)adaptor.create(QSTRING, " [ ]"));
                        adaptor.addChild(root_1, stream_propertyListNotEmpty_.nextTree());
                        adaptor.addChild(root_1, (CommonTree)adaptor.create(QSTRING, ((triplesSameSubject__scope)triplesSameSubject__stack.peek()).separator));

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "object_"

    public static class namedGraph_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "namedGraph"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2597:1: namedGraph : irix= iri -> ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $irix) ) ) ) ^( T_PAR QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $irix) ) ) ) ) QSTRING[\"\"] ) ;
    public final XSPARQLRewriter.namedGraph_return namedGraph() throws RecognitionException {
        XSPARQLRewriter.namedGraph_return retval = new XSPARQLRewriter.namedGraph_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.iri_return irix = null;


        RewriteRuleSubtreeStream stream_iri=new RewriteRuleSubtreeStream(adaptor,"rule iri");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2598:3: (irix= iri -> ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $irix) ) ) ) ^( T_PAR QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $irix) ) ) ) ) QSTRING[\"\"] ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2598:5: irix= iri
            {
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_iri_in_namedGraph15062);
            irix=iri();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_iri.add(irix.getTree());


            // AST REWRITE
            // elements: irix, irix
            // token labels: 
            // rule labels: retval, irix
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
            RewriteRuleSubtreeStream stream_irix=new RewriteRuleSubtreeStream(adaptor,"rule irix",irix!=null?irix.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 2599:3: -> ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $irix) ) ) ) ^( T_PAR QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $irix) ) ) ) ) QSTRING[\"\"] )
            {
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2600:10: ^( IF ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $irix) ) ) ) ^( T_PAR QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $irix) ) ) ) ) QSTRING[\"\"] )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(IF, "IF"), root_1);

                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2601:12: ^( T_FUNCTION_CALL NCNAME[validObjectFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $irix) ) ) )
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_2);

                adaptor.addChild(root_2, (CommonTree)adaptor.create(NCNAME, validObjectFunction));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2601:58: ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $irix) ) )
                {
                CommonTree root_3 = (CommonTree)adaptor.nil();
                root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_3);

                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2601:69: ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $irix) )
                {
                CommonTree root_4 = (CommonTree)adaptor.nil();
                root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_4);

                adaptor.addChild(root_4, (CommonTree)adaptor.create(NCNAME, bindingTermFunction));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2601:116: ^( T_PARAMS $irix)
                {
                CommonTree root_5 = (CommonTree)adaptor.nil();
                root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_5);

                adaptor.addChild(root_5, stream_irix.nextTree());

                adaptor.addChild(root_4, root_5);
                }

                adaptor.addChild(root_3, root_4);
                }

                adaptor.addChild(root_2, root_3);
                }

                adaptor.addChild(root_1, root_2);
                }
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2602:12: ^( T_PAR QSTRING[\" \"] ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $irix) ) ) ) )
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_2);

                adaptor.addChild(root_2, (CommonTree)adaptor.create(QSTRING, " "));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2602:33: ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $irix) ) ) )
                {
                CommonTree root_3 = (CommonTree)adaptor.nil();
                root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_3);

                adaptor.addChild(root_3, (CommonTree)adaptor.create(NCNAME, rdfTermFunction));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2602:75: ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $irix) ) )
                {
                CommonTree root_4 = (CommonTree)adaptor.nil();
                root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_4);

                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2602:86: ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $irix) )
                {
                CommonTree root_5 = (CommonTree)adaptor.nil();
                root_5 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_5);

                adaptor.addChild(root_5, (CommonTree)adaptor.create(NCNAME, bindingTermFunction));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2602:133: ^( T_PARAMS $irix)
                {
                CommonTree root_6 = (CommonTree)adaptor.nil();
                root_6 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_6);

                adaptor.addChild(root_6, stream_irix.nextTree());

                adaptor.addChild(root_5, root_6);
                }

                adaptor.addChild(root_4, root_5);
                }

                adaptor.addChild(root_3, root_4);
                }

                adaptor.addChild(root_2, root_3);
                }

                adaptor.addChild(root_1, root_2);
                }
                adaptor.addChild(root_1, (CommonTree)adaptor.create(QSTRING, ""));

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "namedGraph"

    public static class object_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "object"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2607:1: object : ( resource | blank -> QSTRING[\"[]\"] | rdfLiteral | sNumericLiteral | triplesNode );
    public final XSPARQLRewriter.object_return object() throws RecognitionException {
        XSPARQLRewriter.object_return retval = new XSPARQLRewriter.object_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.resource_return resource614 = null;

        XSPARQLRewriter.blank_return blank615 = null;

        XSPARQLRewriter.rdfLiteral_return rdfLiteral616 = null;

        XSPARQLRewriter.sNumericLiteral_return sNumericLiteral617 = null;

        XSPARQLRewriter.triplesNode_return triplesNode618 = null;


        RewriteRuleSubtreeStream stream_blank=new RewriteRuleSubtreeStream(adaptor,"rule blank");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2608:3: ( resource | blank -> QSTRING[\"[]\"] | rdfLiteral | sNumericLiteral | triplesNode )
            int alt184=5;
            switch ( input.LA(1) ) {
            case VAR:
            case PNAME_NS:
            case PNAME_LN:
                {
                alt184=1;
                }
                break;
            case BLANK_NODE_LABEL:
            case T_EMPTY_ANON_BLANK:
                {
                alt184=2;
                }
                break;
            case QSTRING:
                {
                alt184=3;
                }
                break;
            case INTEGER:
                {
                alt184=4;
                }
                break;
            case LPAR:
            case T_ANON_BLANK:
                {
                alt184=5;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 184, 0, input);

                throw nvae;
            }

            switch (alt184) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2608:5: resource
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_resource_in_object15199);
                    resource614=resource();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, resource614.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2609:5: blank
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_blank_in_object15205);
                    blank615=blank();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_blank.add(blank615.getTree());


                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2610:3: -> QSTRING[\"[]\"]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, "[]"));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2611:5: rdfLiteral
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_rdfLiteral_in_object15218);
                    rdfLiteral616=rdfLiteral();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, rdfLiteral616.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2612:5: sNumericLiteral
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_sNumericLiteral_in_object15224);
                    sNumericLiteral617=sNumericLiteral();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, sNumericLiteral617.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 5 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2613:5: triplesNode
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_triplesNode_in_object15230);
                    triplesNode618=triplesNode();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, triplesNode618.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "object"

    public static class triplesNode_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "triplesNode"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2616:1: triplesNode : ( collection | blankNodePropertyList );
    public final XSPARQLRewriter.triplesNode_return triplesNode() throws RecognitionException {
        XSPARQLRewriter.triplesNode_return retval = new XSPARQLRewriter.triplesNode_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.collection_return collection619 = null;

        XSPARQLRewriter.blankNodePropertyList_return blankNodePropertyList620 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2617:3: ( collection | blankNodePropertyList )
            int alt185=2;
            switch ( input.LA(1) ) {
            case LPAR:
                {
                alt185=1;
                }
                break;
            case T_ANON_BLANK:
                {
                alt185=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 185, 0, input);

                throw nvae;
            }

            switch (alt185) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2617:5: collection
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_collection_in_triplesNode15243);
                    collection619=collection();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, collection619.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2618:5: blankNodePropertyList
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_blankNodePropertyList_in_triplesNode15249);
                    blankNodePropertyList620=blankNodePropertyList();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, blankNodePropertyList620.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "triplesNode"

    public static class triplesNode__return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "triplesNode_"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2621:1: triplesNode_ : ( collection | blankNodePropertyList_ );
    public final XSPARQLRewriter.triplesNode__return triplesNode_() throws RecognitionException {
        XSPARQLRewriter.triplesNode__return retval = new XSPARQLRewriter.triplesNode__return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.collection_return collection621 = null;

        XSPARQLRewriter.blankNodePropertyList__return blankNodePropertyList_622 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2622:3: ( collection | blankNodePropertyList_ )
            int alt186=2;
            switch ( input.LA(1) ) {
            case LPAR:
                {
                alt186=1;
                }
                break;
            case T_ANON_BLANK:
                {
                alt186=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 186, 0, input);

                throw nvae;
            }

            switch (alt186) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2622:5: collection
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_collection_in_triplesNode_15262);
                    collection621=collection();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, collection621.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2623:5: blankNodePropertyList_
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_blankNodePropertyList__in_triplesNode_15268);
                    blankNodePropertyList_622=blankNodePropertyList_();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, blankNodePropertyList_622.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "triplesNode_"

    public static class blankNodePropertyList_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "blankNodePropertyList"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2626:1: blankNodePropertyList : T_ANON_BLANK propertyListNotEmpty -> QSTRING[\"[\"] propertyListNotEmpty QSTRING[\"]\"] ;
    public final XSPARQLRewriter.blankNodePropertyList_return blankNodePropertyList() throws RecognitionException {
        XSPARQLRewriter.blankNodePropertyList_return retval = new XSPARQLRewriter.blankNodePropertyList_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_ANON_BLANK623=null;
        XSPARQLRewriter.propertyListNotEmpty_return propertyListNotEmpty624 = null;


        CommonTree T_ANON_BLANK623_tree=null;
        RewriteRuleNodeStream stream_T_ANON_BLANK=new RewriteRuleNodeStream(adaptor,"token T_ANON_BLANK");
        RewriteRuleSubtreeStream stream_propertyListNotEmpty=new RewriteRuleSubtreeStream(adaptor,"rule propertyListNotEmpty");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2627:3: ( T_ANON_BLANK propertyListNotEmpty -> QSTRING[\"[\"] propertyListNotEmpty QSTRING[\"]\"] )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2627:5: T_ANON_BLANK propertyListNotEmpty
            {
            _last = (CommonTree)input.LT(1);
            T_ANON_BLANK623=(CommonTree)match(input,T_ANON_BLANK,FOLLOW_T_ANON_BLANK_in_blankNodePropertyList15281); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_T_ANON_BLANK.add(T_ANON_BLANK623);

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_propertyListNotEmpty_in_blankNodePropertyList15283);
            propertyListNotEmpty624=propertyListNotEmpty();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_propertyListNotEmpty.add(propertyListNotEmpty624.getTree());


            // AST REWRITE
            // elements: propertyListNotEmpty
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 2628:3: -> QSTRING[\"[\"] propertyListNotEmpty QSTRING[\"]\"]
            {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, "["));
                adaptor.addChild(root_0, stream_propertyListNotEmpty.nextTree());
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, "]"));

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "blankNodePropertyList"

    public static class blankNodePropertyList__return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "blankNodePropertyList_"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2631:1: blankNodePropertyList_ : T_ANON_BLANK propertyListNotEmpty_ ;
    public final XSPARQLRewriter.blankNodePropertyList__return blankNodePropertyList_() throws RecognitionException {
        XSPARQLRewriter.blankNodePropertyList__return retval = new XSPARQLRewriter.blankNodePropertyList__return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_ANON_BLANK625=null;
        XSPARQLRewriter.propertyListNotEmpty__return propertyListNotEmpty_626 = null;


        CommonTree T_ANON_BLANK625_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2632:3: ( T_ANON_BLANK propertyListNotEmpty_ )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2632:5: T_ANON_BLANK propertyListNotEmpty_
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            T_ANON_BLANK625=(CommonTree)match(input,T_ANON_BLANK,FOLLOW_T_ANON_BLANK_in_blankNodePropertyList_15308); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            T_ANON_BLANK625_tree = (CommonTree)adaptor.dupNode(T_ANON_BLANK625);

            adaptor.addChild(root_0, T_ANON_BLANK625_tree);
            }
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_propertyListNotEmpty__in_blankNodePropertyList_15310);
            propertyListNotEmpty_626=propertyListNotEmpty_();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, propertyListNotEmpty_626.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "blankNodePropertyList_"

    public static class collection_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "collection"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2635:1: collection : LPAR ( graphNode )+ RPAR ;
    public final XSPARQLRewriter.collection_return collection() throws RecognitionException {
        XSPARQLRewriter.collection_return retval = new XSPARQLRewriter.collection_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree LPAR627=null;
        CommonTree RPAR629=null;
        XSPARQLRewriter.graphNode_return graphNode628 = null;


        CommonTree LPAR627_tree=null;
        CommonTree RPAR629_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2636:3: ( LPAR ( graphNode )+ RPAR )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2636:5: LPAR ( graphNode )+ RPAR
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            LPAR627=(CommonTree)match(input,LPAR,FOLLOW_LPAR_in_collection15323); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            LPAR627_tree = (CommonTree)adaptor.dupNode(LPAR627);

            adaptor.addChild(root_0, LPAR627_tree);
            }
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2636:10: ( graphNode )+
            int cnt187=0;
            loop187:
            do {
                int alt187=2;
                switch ( input.LA(1) ) {
                case VAR:
                case INTEGER:
                case QSTRING:
                case LPAR:
                case PNAME_NS:
                case PNAME_LN:
                case IRIREF:
                case TRUE:
                case FALSE:
                case T_ANON_BLANK:
                    {
                    alt187=1;
                    }
                    break;

                }

                switch (alt187) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: graphNode
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_graphNode_in_collection15325);
            	    graphNode628=graphNode();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) 
            	    adaptor.addChild(root_0, graphNode628.getTree());

            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    if ( cnt187 >= 1 ) break loop187;
            	    if (state.backtracking>0) {state.failed=true; return retval;}
                        EarlyExitException eee =
                            new EarlyExitException(187, input);
                        throw eee;
                }
                cnt187++;
            } while (true);

            _last = (CommonTree)input.LT(1);
            RPAR629=(CommonTree)match(input,RPAR,FOLLOW_RPAR_in_collection15328); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            RPAR629_tree = (CommonTree)adaptor.dupNode(RPAR629);

            adaptor.addChild(root_0, RPAR629_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "collection"

    public static class graphNode_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "graphNode"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2639:1: graphNode : ( varOrTerm | triplesNode );
    public final XSPARQLRewriter.graphNode_return graphNode() throws RecognitionException {
        XSPARQLRewriter.graphNode_return retval = new XSPARQLRewriter.graphNode_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.varOrTerm_return varOrTerm630 = null;

        XSPARQLRewriter.triplesNode_return triplesNode631 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2640:3: ( varOrTerm | triplesNode )
            int alt188=2;
            switch ( input.LA(1) ) {
            case VAR:
            case INTEGER:
            case QSTRING:
            case PNAME_NS:
            case PNAME_LN:
            case IRIREF:
            case TRUE:
            case FALSE:
                {
                alt188=1;
                }
                break;
            case LPAR:
            case T_ANON_BLANK:
                {
                alt188=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 188, 0, input);

                throw nvae;
            }

            switch (alt188) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2640:5: varOrTerm
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_varOrTerm_in_graphNode15341);
                    varOrTerm630=varOrTerm();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, varOrTerm630.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2641:5: triplesNode
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_triplesNode_in_graphNode15347);
                    triplesNode631=triplesNode();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, triplesNode631.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "graphNode"

    public static class varOrTerm_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "varOrTerm"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2644:1: varOrTerm : ( VAR | graphTerm );
    public final XSPARQLRewriter.varOrTerm_return varOrTerm() throws RecognitionException {
        XSPARQLRewriter.varOrTerm_return retval = new XSPARQLRewriter.varOrTerm_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree VAR632=null;
        XSPARQLRewriter.graphTerm_return graphTerm633 = null;


        CommonTree VAR632_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2645:3: ( VAR | graphTerm )
            int alt189=2;
            switch ( input.LA(1) ) {
            case VAR:
                {
                alt189=1;
                }
                break;
            case INTEGER:
            case QSTRING:
            case PNAME_NS:
            case PNAME_LN:
            case IRIREF:
            case TRUE:
            case FALSE:
                {
                alt189=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 189, 0, input);

                throw nvae;
            }

            switch (alt189) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2645:5: VAR
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    VAR632=(CommonTree)match(input,VAR,FOLLOW_VAR_in_varOrTerm15360); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    VAR632_tree = (CommonTree)adaptor.dupNode(VAR632);

                    adaptor.addChild(root_0, VAR632_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2646:5: graphTerm
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_graphTerm_in_varOrTerm15366);
                    graphTerm633=graphTerm();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, graphTerm633.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "varOrTerm"

    public static class literalConstruct_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "literalConstruct"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2649:1: literalConstruct : ( ^( T_LITERAL_CONSTRUCT e1= enclosedExpr at= AT e2= enclosedExpr ) -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] $e1 $e2 QSTRING[\"\"] ) ) | ^( T_LITERAL_CONSTRUCT enclosedExpr c1= CARET c2= CARET iri ) -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] enclosedExpr QSTRING[\"\"] iri ) ) | ^( T_LITERAL_CONSTRUCT INTEGER AT enclosedExpr ) -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] INTEGER enclosedExpr QSTRING[\"\\\"\\\"\"] ) ) | ^( T_LITERAL_CONSTRUCT INTEGER CARET CARET iriConstruct ) -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] INTEGER QSTRING[\"\"] iriConstruct ) ) | ^( T_LITERAL_CONSTRUCT QSTRING AT enclosedExpr ) -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] QSTRING enclosedExpr QSTRING[\"\"] ) ) | ^( T_LITERAL_CONSTRUCT QSTRING c1= CARET c2= CARET iriConstruct ) -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] QSTRING QSTRING[\"\"] iriConstruct ) ) | ^( T_LITERAL_CONSTRUCT enclosedExpr ) -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS enclosedExpr ) ) );
    public final XSPARQLRewriter.literalConstruct_return literalConstruct() throws RecognitionException {
        XSPARQLRewriter.literalConstruct_return retval = new XSPARQLRewriter.literalConstruct_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree at=null;
        CommonTree c1=null;
        CommonTree c2=null;
        CommonTree T_LITERAL_CONSTRUCT634=null;
        CommonTree T_LITERAL_CONSTRUCT635=null;
        CommonTree T_LITERAL_CONSTRUCT638=null;
        CommonTree INTEGER639=null;
        CommonTree AT640=null;
        CommonTree T_LITERAL_CONSTRUCT642=null;
        CommonTree INTEGER643=null;
        CommonTree CARET644=null;
        CommonTree CARET645=null;
        CommonTree T_LITERAL_CONSTRUCT647=null;
        CommonTree QSTRING648=null;
        CommonTree AT649=null;
        CommonTree T_LITERAL_CONSTRUCT651=null;
        CommonTree QSTRING652=null;
        CommonTree T_LITERAL_CONSTRUCT654=null;
        XSPARQLRewriter.enclosedExpr_return e1 = null;

        XSPARQLRewriter.enclosedExpr_return e2 = null;

        XSPARQLRewriter.enclosedExpr_return enclosedExpr636 = null;

        XSPARQLRewriter.iri_return iri637 = null;

        XSPARQLRewriter.enclosedExpr_return enclosedExpr641 = null;

        XSPARQLRewriter.iriConstruct_return iriConstruct646 = null;

        XSPARQLRewriter.enclosedExpr_return enclosedExpr650 = null;

        XSPARQLRewriter.iriConstruct_return iriConstruct653 = null;

        XSPARQLRewriter.enclosedExpr_return enclosedExpr655 = null;


        CommonTree at_tree=null;
        CommonTree c1_tree=null;
        CommonTree c2_tree=null;
        CommonTree T_LITERAL_CONSTRUCT634_tree=null;
        CommonTree T_LITERAL_CONSTRUCT635_tree=null;
        CommonTree T_LITERAL_CONSTRUCT638_tree=null;
        CommonTree INTEGER639_tree=null;
        CommonTree AT640_tree=null;
        CommonTree T_LITERAL_CONSTRUCT642_tree=null;
        CommonTree INTEGER643_tree=null;
        CommonTree CARET644_tree=null;
        CommonTree CARET645_tree=null;
        CommonTree T_LITERAL_CONSTRUCT647_tree=null;
        CommonTree QSTRING648_tree=null;
        CommonTree AT649_tree=null;
        CommonTree T_LITERAL_CONSTRUCT651_tree=null;
        CommonTree QSTRING652_tree=null;
        CommonTree T_LITERAL_CONSTRUCT654_tree=null;
        RewriteRuleNodeStream stream_INTEGER=new RewriteRuleNodeStream(adaptor,"token INTEGER");
        RewriteRuleNodeStream stream_AT=new RewriteRuleNodeStream(adaptor,"token AT");
        RewriteRuleNodeStream stream_T_LITERAL_CONSTRUCT=new RewriteRuleNodeStream(adaptor,"token T_LITERAL_CONSTRUCT");
        RewriteRuleNodeStream stream_QSTRING=new RewriteRuleNodeStream(adaptor,"token QSTRING");
        RewriteRuleNodeStream stream_CARET=new RewriteRuleNodeStream(adaptor,"token CARET");
        RewriteRuleSubtreeStream stream_iriConstruct=new RewriteRuleSubtreeStream(adaptor,"rule iriConstruct");
        RewriteRuleSubtreeStream stream_enclosedExpr=new RewriteRuleSubtreeStream(adaptor,"rule enclosedExpr");
        RewriteRuleSubtreeStream stream_iri=new RewriteRuleSubtreeStream(adaptor,"rule iri");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2650:3: ( ^( T_LITERAL_CONSTRUCT e1= enclosedExpr at= AT e2= enclosedExpr ) -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] $e1 $e2 QSTRING[\"\"] ) ) | ^( T_LITERAL_CONSTRUCT enclosedExpr c1= CARET c2= CARET iri ) -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] enclosedExpr QSTRING[\"\"] iri ) ) | ^( T_LITERAL_CONSTRUCT INTEGER AT enclosedExpr ) -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] INTEGER enclosedExpr QSTRING[\"\\\"\\\"\"] ) ) | ^( T_LITERAL_CONSTRUCT INTEGER CARET CARET iriConstruct ) -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] INTEGER QSTRING[\"\"] iriConstruct ) ) | ^( T_LITERAL_CONSTRUCT QSTRING AT enclosedExpr ) -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] QSTRING enclosedExpr QSTRING[\"\"] ) ) | ^( T_LITERAL_CONSTRUCT QSTRING c1= CARET c2= CARET iriConstruct ) -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] QSTRING QSTRING[\"\"] iriConstruct ) ) | ^( T_LITERAL_CONSTRUCT enclosedExpr ) -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS enclosedExpr ) ) )
            int alt190=7;
            switch ( input.LA(1) ) {
            case T_LITERAL_CONSTRUCT:
                {
                int LA190_1 = input.LA(2);

                if ( (synpred316_XSPARQLRewriter()) ) {
                    alt190=1;
                }
                else if ( (synpred317_XSPARQLRewriter()) ) {
                    alt190=2;
                }
                else if ( (synpred318_XSPARQLRewriter()) ) {
                    alt190=3;
                }
                else if ( (synpred319_XSPARQLRewriter()) ) {
                    alt190=4;
                }
                else if ( (synpred320_XSPARQLRewriter()) ) {
                    alt190=5;
                }
                else if ( (synpred321_XSPARQLRewriter()) ) {
                    alt190=6;
                }
                else if ( (true) ) {
                    alt190=7;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 190, 1, input);

                    throw nvae;
                }
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 190, 0, input);

                throw nvae;
            }

            switch (alt190) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2650:5: ^( T_LITERAL_CONSTRUCT e1= enclosedExpr at= AT e2= enclosedExpr )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_LITERAL_CONSTRUCT634=(CommonTree)match(input,T_LITERAL_CONSTRUCT,FOLLOW_T_LITERAL_CONSTRUCT_in_literalConstruct15380); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_LITERAL_CONSTRUCT.add(T_LITERAL_CONSTRUCT634);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_enclosedExpr_in_literalConstruct15384);
                    e1=enclosedExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_enclosedExpr.add(e1.getTree());
                    _last = (CommonTree)input.LT(1);
                    at=(CommonTree)match(input,AT,FOLLOW_AT_in_literalConstruct15388); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_AT.add(at);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_enclosedExpr_in_literalConstruct15392);
                    e2=enclosedExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_enclosedExpr.add(e2.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: e2, e1
                    // token labels: 
                    // rule labels: retval, e1, e2
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
                    RewriteRuleSubtreeStream stream_e1=new RewriteRuleSubtreeStream(adaptor,"rule e1",e1!=null?e1.tree:null);
                    RewriteRuleSubtreeStream stream_e2=new RewriteRuleSubtreeStream(adaptor,"rule e2",e2!=null?e2.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2651:3: -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] $e1 $e2 QSTRING[\"\"] ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2651:6: ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] $e1 $e2 QSTRING[\"\"] ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(NCNAME, bindingTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2653:8: ^( T_PARAMS QSTRING[\"\"] $e1 $e2 QSTRING[\"\"] )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(QSTRING, ""));
                        adaptor.addChild(root_2, stream_e1.nextTree());
                        adaptor.addChild(root_2, stream_e2.nextTree());
                        adaptor.addChild(root_2, (CommonTree)adaptor.create(QSTRING, ""));

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2660:5: ^( T_LITERAL_CONSTRUCT enclosedExpr c1= CARET c2= CARET iri )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_LITERAL_CONSTRUCT635=(CommonTree)match(input,T_LITERAL_CONSTRUCT,FOLLOW_T_LITERAL_CONSTRUCT_in_literalConstruct15499); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_LITERAL_CONSTRUCT.add(T_LITERAL_CONSTRUCT635);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_enclosedExpr_in_literalConstruct15501);
                    enclosedExpr636=enclosedExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_enclosedExpr.add(enclosedExpr636.getTree());
                    _last = (CommonTree)input.LT(1);
                    c1=(CommonTree)match(input,CARET,FOLLOW_CARET_in_literalConstruct15505); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_CARET.add(c1);

                    _last = (CommonTree)input.LT(1);
                    c2=(CommonTree)match(input,CARET,FOLLOW_CARET_in_literalConstruct15509); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_CARET.add(c2);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_iri_in_literalConstruct15511);
                    iri637=iri();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_iri.add(iri637.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: iri, enclosedExpr
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2661:3: -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] enclosedExpr QSTRING[\"\"] iri ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2661:6: ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] enclosedExpr QSTRING[\"\"] iri ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(NCNAME, bindingTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2663:8: ^( T_PARAMS QSTRING[\"\"] enclosedExpr QSTRING[\"\"] iri )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(QSTRING, ""));
                        adaptor.addChild(root_2, stream_enclosedExpr.nextTree());
                        adaptor.addChild(root_2, (CommonTree)adaptor.create(QSTRING, ""));
                        adaptor.addChild(root_2, stream_iri.nextTree());

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2670:5: ^( T_LITERAL_CONSTRUCT INTEGER AT enclosedExpr )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_LITERAL_CONSTRUCT638=(CommonTree)match(input,T_LITERAL_CONSTRUCT,FOLLOW_T_LITERAL_CONSTRUCT_in_literalConstruct15615); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_LITERAL_CONSTRUCT.add(T_LITERAL_CONSTRUCT638);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    INTEGER639=(CommonTree)match(input,INTEGER,FOLLOW_INTEGER_in_literalConstruct15617); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_INTEGER.add(INTEGER639);

                    _last = (CommonTree)input.LT(1);
                    AT640=(CommonTree)match(input,AT,FOLLOW_AT_in_literalConstruct15619); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_AT.add(AT640);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_enclosedExpr_in_literalConstruct15621);
                    enclosedExpr641=enclosedExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_enclosedExpr.add(enclosedExpr641.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: INTEGER, enclosedExpr
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2671:3: -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] INTEGER enclosedExpr QSTRING[\"\\\"\\\"\"] ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2671:6: ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] INTEGER enclosedExpr QSTRING[\"\\\"\\\"\"] ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(NCNAME, bindingTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2673:8: ^( T_PARAMS QSTRING[\"\"] INTEGER enclosedExpr QSTRING[\"\\\"\\\"\"] )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(QSTRING, ""));
                        adaptor.addChild(root_2, stream_INTEGER.nextNode());
                        adaptor.addChild(root_2, stream_enclosedExpr.nextTree());
                        adaptor.addChild(root_2, (CommonTree)adaptor.create(QSTRING, "\"\""));

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2680:5: ^( T_LITERAL_CONSTRUCT INTEGER CARET CARET iriConstruct )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_LITERAL_CONSTRUCT642=(CommonTree)match(input,T_LITERAL_CONSTRUCT,FOLLOW_T_LITERAL_CONSTRUCT_in_literalConstruct15727); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_LITERAL_CONSTRUCT.add(T_LITERAL_CONSTRUCT642);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    INTEGER643=(CommonTree)match(input,INTEGER,FOLLOW_INTEGER_in_literalConstruct15729); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_INTEGER.add(INTEGER643);

                    _last = (CommonTree)input.LT(1);
                    CARET644=(CommonTree)match(input,CARET,FOLLOW_CARET_in_literalConstruct15731); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_CARET.add(CARET644);

                    _last = (CommonTree)input.LT(1);
                    CARET645=(CommonTree)match(input,CARET,FOLLOW_CARET_in_literalConstruct15733); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_CARET.add(CARET645);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_iriConstruct_in_literalConstruct15735);
                    iriConstruct646=iriConstruct();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_iriConstruct.add(iriConstruct646.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: iriConstruct, INTEGER
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2681:3: -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] INTEGER QSTRING[\"\"] iriConstruct ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2681:6: ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] INTEGER QSTRING[\"\"] iriConstruct ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(NCNAME, bindingTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2683:8: ^( T_PARAMS QSTRING[\"\"] INTEGER QSTRING[\"\"] iriConstruct )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(QSTRING, ""));
                        adaptor.addChild(root_2, stream_INTEGER.nextNode());
                        adaptor.addChild(root_2, (CommonTree)adaptor.create(QSTRING, ""));
                        adaptor.addChild(root_2, stream_iriConstruct.nextTree());

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 5 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2691:5: ^( T_LITERAL_CONSTRUCT QSTRING AT enclosedExpr )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_LITERAL_CONSTRUCT647=(CommonTree)match(input,T_LITERAL_CONSTRUCT,FOLLOW_T_LITERAL_CONSTRUCT_in_literalConstruct15840); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_LITERAL_CONSTRUCT.add(T_LITERAL_CONSTRUCT647);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    QSTRING648=(CommonTree)match(input,QSTRING,FOLLOW_QSTRING_in_literalConstruct15842); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_QSTRING.add(QSTRING648);

                    _last = (CommonTree)input.LT(1);
                    AT649=(CommonTree)match(input,AT,FOLLOW_AT_in_literalConstruct15844); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_AT.add(AT649);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_enclosedExpr_in_literalConstruct15846);
                    enclosedExpr650=enclosedExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_enclosedExpr.add(enclosedExpr650.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: QSTRING, QSTRING, enclosedExpr, QSTRING
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2692:3: -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] QSTRING enclosedExpr QSTRING[\"\"] ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2692:6: ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] QSTRING enclosedExpr QSTRING[\"\"] ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(NCNAME, bindingTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2694:8: ^( T_PARAMS QSTRING[\"\"] QSTRING enclosedExpr QSTRING[\"\"] )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(QSTRING, ""));
                        adaptor.addChild(root_2, stream_QSTRING.nextNode());
                        adaptor.addChild(root_2, stream_enclosedExpr.nextTree());
                        adaptor.addChild(root_2, (CommonTree)adaptor.create(QSTRING, ""));

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 6 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2701:5: ^( T_LITERAL_CONSTRUCT QSTRING c1= CARET c2= CARET iriConstruct )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_LITERAL_CONSTRUCT651=(CommonTree)match(input,T_LITERAL_CONSTRUCT,FOLLOW_T_LITERAL_CONSTRUCT_in_literalConstruct15951); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_LITERAL_CONSTRUCT.add(T_LITERAL_CONSTRUCT651);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    QSTRING652=(CommonTree)match(input,QSTRING,FOLLOW_QSTRING_in_literalConstruct15953); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_QSTRING.add(QSTRING652);

                    _last = (CommonTree)input.LT(1);
                    c1=(CommonTree)match(input,CARET,FOLLOW_CARET_in_literalConstruct15957); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_CARET.add(c1);

                    _last = (CommonTree)input.LT(1);
                    c2=(CommonTree)match(input,CARET,FOLLOW_CARET_in_literalConstruct15961); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_CARET.add(c2);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_iriConstruct_in_literalConstruct15963);
                    iriConstruct653=iriConstruct();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_iriConstruct.add(iriConstruct653.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: QSTRING, QSTRING, iriConstruct, QSTRING
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2702:3: -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] QSTRING QSTRING[\"\"] iriConstruct ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2702:6: ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[\"\"] QSTRING QSTRING[\"\"] iriConstruct ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(NCNAME, bindingTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2704:8: ^( T_PARAMS QSTRING[\"\"] QSTRING QSTRING[\"\"] iriConstruct )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(QSTRING, ""));
                        adaptor.addChild(root_2, stream_QSTRING.nextNode());
                        adaptor.addChild(root_2, (CommonTree)adaptor.create(QSTRING, ""));
                        adaptor.addChild(root_2, stream_iriConstruct.nextTree());

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 7 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2711:5: ^( T_LITERAL_CONSTRUCT enclosedExpr )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    T_LITERAL_CONSTRUCT654=(CommonTree)match(input,T_LITERAL_CONSTRUCT,FOLLOW_T_LITERAL_CONSTRUCT_in_literalConstruct16069); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_LITERAL_CONSTRUCT.add(T_LITERAL_CONSTRUCT654);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_enclosedExpr_in_literalConstruct16071);
                    enclosedExpr655=enclosedExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_enclosedExpr.add(enclosedExpr655.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: enclosedExpr
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2712:3: -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS enclosedExpr ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2712:6: ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS enclosedExpr ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(NCNAME, bindingTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2714:8: ^( T_PARAMS enclosedExpr )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_2);

                        adaptor.addChild(root_2, stream_enclosedExpr.nextTree());

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "literalConstruct"

    public static class varOrIRIref_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "varOrIRIref"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2720:1: varOrIRIref : ( VAR | iRIref );
    public final XSPARQLRewriter.varOrIRIref_return varOrIRIref() throws RecognitionException {
        XSPARQLRewriter.varOrIRIref_return retval = new XSPARQLRewriter.varOrIRIref_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree VAR656=null;
        XSPARQLRewriter.iRIref_return iRIref657 = null;


        CommonTree VAR656_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2721:3: ( VAR | iRIref )
            int alt191=2;
            switch ( input.LA(1) ) {
            case VAR:
                {
                alt191=1;
                }
                break;
            case PNAME_NS:
            case PNAME_LN:
            case IRIREF:
                {
                alt191=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 191, 0, input);

                throw nvae;
            }

            switch (alt191) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2721:5: VAR
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    VAR656=(CommonTree)match(input,VAR,FOLLOW_VAR_in_varOrIRIref16145); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    VAR656_tree = (CommonTree)adaptor.dupNode(VAR656);

                    adaptor.addChild(root_0, VAR656_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2722:5: iRIref
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_iRIref_in_varOrIRIref16151);
                    iRIref657=iRIref();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, iRIref657.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "varOrIRIref"

    public static class iriConstruct_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "iriConstruct"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2725:1: iriConstruct : ^( T_IRI_CONSTRUCT (l= LESSTHANLCURLY expr r= RCURLYGREATERTHAN -> expr | e1= enclosedExpr (c= COLON (e2= enclosedExpr -> ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR $e1 QSTRING[$c.token, $c.text] $e2) ) ) ) | q= qname -> ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR enclosedExpr QSTRING[$q.text] ) ) ) ) | q= qname c= COLON enclosedExpr -> ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$q.text] QSTRING[$c.token, $c.text] enclosedExpr ) ) ) ) ) ;
    public final XSPARQLRewriter.iriConstruct_return iriConstruct() throws RecognitionException {
        XSPARQLRewriter.iriConstruct_return retval = new XSPARQLRewriter.iriConstruct_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree l=null;
        CommonTree r=null;
        CommonTree c=null;
        CommonTree T_IRI_CONSTRUCT658=null;
        XSPARQLRewriter.enclosedExpr_return e1 = null;

        XSPARQLRewriter.enclosedExpr_return e2 = null;

        XSPARQLRewriter.qname_return q = null;

        XSPARQLRewriter.expr_return expr659 = null;

        XSPARQLRewriter.enclosedExpr_return enclosedExpr660 = null;


        CommonTree l_tree=null;
        CommonTree r_tree=null;
        CommonTree c_tree=null;
        CommonTree T_IRI_CONSTRUCT658_tree=null;
        RewriteRuleNodeStream stream_COLON=new RewriteRuleNodeStream(adaptor,"token COLON");
        RewriteRuleNodeStream stream_RCURLYGREATERTHAN=new RewriteRuleNodeStream(adaptor,"token RCURLYGREATERTHAN");
        RewriteRuleNodeStream stream_T_IRI_CONSTRUCT=new RewriteRuleNodeStream(adaptor,"token T_IRI_CONSTRUCT");
        RewriteRuleNodeStream stream_LESSTHANLCURLY=new RewriteRuleNodeStream(adaptor,"token LESSTHANLCURLY");
        RewriteRuleSubtreeStream stream_qname=new RewriteRuleSubtreeStream(adaptor,"rule qname");
        RewriteRuleSubtreeStream stream_expr=new RewriteRuleSubtreeStream(adaptor,"rule expr");
        RewriteRuleSubtreeStream stream_enclosedExpr=new RewriteRuleSubtreeStream(adaptor,"rule enclosedExpr");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2726:3: ( ^( T_IRI_CONSTRUCT (l= LESSTHANLCURLY expr r= RCURLYGREATERTHAN -> expr | e1= enclosedExpr (c= COLON (e2= enclosedExpr -> ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR $e1 QSTRING[$c.token, $c.text] $e2) ) ) ) | q= qname -> ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR enclosedExpr QSTRING[$q.text] ) ) ) ) | q= qname c= COLON enclosedExpr -> ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$q.text] QSTRING[$c.token, $c.text] enclosedExpr ) ) ) ) ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2726:5: ^( T_IRI_CONSTRUCT (l= LESSTHANLCURLY expr r= RCURLYGREATERTHAN -> expr | e1= enclosedExpr (c= COLON (e2= enclosedExpr -> ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR $e1 QSTRING[$c.token, $c.text] $e2) ) ) ) | q= qname -> ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR enclosedExpr QSTRING[$q.text] ) ) ) ) | q= qname c= COLON enclosedExpr -> ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$q.text] QSTRING[$c.token, $c.text] enclosedExpr ) ) ) ) )
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_IRI_CONSTRUCT658=(CommonTree)match(input,T_IRI_CONSTRUCT,FOLLOW_T_IRI_CONSTRUCT_in_iriConstruct16165); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_T_IRI_CONSTRUCT.add(T_IRI_CONSTRUCT658);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2727:7: (l= LESSTHANLCURLY expr r= RCURLYGREATERTHAN -> expr | e1= enclosedExpr (c= COLON (e2= enclosedExpr -> ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR $e1 QSTRING[$c.token, $c.text] $e2) ) ) ) | q= qname -> ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR enclosedExpr QSTRING[$q.text] ) ) ) ) | q= qname c= COLON enclosedExpr -> ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$q.text] QSTRING[$c.token, $c.text] enclosedExpr ) ) ) )
            int alt193=3;
            switch ( input.LA(1) ) {
            case LESSTHANLCURLY:
                {
                alt193=1;
                }
                break;
            case LCURLY:
            case STAR:
            case LESSTHAN:
            case GREATERTHAN:
            case PLUS:
            case MINUS:
            case UNIONSYMBOL:
            case LESSTHANLESSTHAN:
            case GREATERTHANEQUALS:
            case LESSTHANEQUALS:
            case HAFENEQUALS:
            case EQUALS:
            case IS:
            case EQ:
            case NE:
            case LT:
            case GE:
            case LE:
            case GT:
            case IF:
            case AND:
            case OR:
            case DIV:
            case IDIV:
            case MOD:
            case UNION:
            case INTERSECT:
            case EXCEPT:
            case GREATERTHANGREATERTHAN:
            case T_FLWOR:
            case T_INSTANCEOF:
            case T_CASTAS:
            case T_CASTABLEAS:
            case T_TREATAS:
            case EVERY:
            case TYPESWITCH:
            case VALIDATE:
            case SOME:
            case XPATH:
                {
                alt193=2;
                }
                break;
            case TO:
                {
                switch ( input.LA(2) ) {
                case DOWN:
                    {
                    alt193=2;
                    }
                    break;
                case COLON:
                    {
                    alt193=3;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 193, 3, input);

                    throw nvae;
                }

                }
                break;
            case NCNAME:
            case PNAME_NS:
            case PNAME_LN:
            case A:
            case FROM:
            case ITEM:
            case COMMENT:
            case ROW:
                {
                alt193=3;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 193, 0, input);

                throw nvae;
            }

            switch (alt193) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2727:8: l= LESSTHANLCURLY expr r= RCURLYGREATERTHAN
                    {
                    _last = (CommonTree)input.LT(1);
                    l=(CommonTree)match(input,LESSTHANLCURLY,FOLLOW_LESSTHANLCURLY_in_iriConstruct16176); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_LESSTHANLCURLY.add(l);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_expr_in_iriConstruct16178);
                    expr659=expr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_expr.add(expr659.getTree());
                    _last = (CommonTree)input.LT(1);
                    r=(CommonTree)match(input,RCURLYGREATERTHAN,FOLLOW_RCURLYGREATERTHAN_in_iriConstruct16182); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_RCURLYGREATERTHAN.add(r);



                    // AST REWRITE
                    // elements: expr
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2728:7: -> expr
                    {
                        adaptor.addChild(root_0, stream_expr.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2729:9: e1= enclosedExpr (c= COLON (e2= enclosedExpr -> ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR $e1 QSTRING[$c.token, $c.text] $e2) ) ) ) | q= qname -> ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR enclosedExpr QSTRING[$q.text] ) ) ) )
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_enclosedExpr_in_iriConstruct16209);
                    e1=enclosedExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_enclosedExpr.add(e1.getTree());
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2730:9: (c= COLON (e2= enclosedExpr -> ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR $e1 QSTRING[$c.token, $c.text] $e2) ) ) ) | q= qname -> ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR enclosedExpr QSTRING[$q.text] ) ) ) )
                    int alt192=2;
                    switch ( input.LA(1) ) {
                    case COLON:
                        {
                        alt192=1;
                        }
                        break;
                    case NCNAME:
                    case PNAME_NS:
                    case PNAME_LN:
                    case A:
                    case FROM:
                    case TO:
                    case ITEM:
                    case COMMENT:
                    case ROW:
                        {
                        alt192=2;
                        }
                        break;
                    default:
                        if (state.backtracking>0) {state.failed=true; return retval;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 192, 0, input);

                        throw nvae;
                    }

                    switch (alt192) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2730:10: c= COLON (e2= enclosedExpr -> ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR $e1 QSTRING[$c.token, $c.text] $e2) ) ) )
                            {
                            _last = (CommonTree)input.LT(1);
                            c=(CommonTree)match(input,COLON,FOLLOW_COLON_in_iriConstruct16222); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_COLON.add(c);

                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2731:11: (e2= enclosedExpr -> ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR $e1 QSTRING[$c.token, $c.text] $e2) ) ) )
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2731:12: e2= enclosedExpr
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_enclosedExpr_in_iriConstruct16237);
                            e2=enclosedExpr();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_enclosedExpr.add(e2.getTree());


                            // AST REWRITE
                            // elements: e1, e2
                            // token labels: 
                            // rule labels: retval, e1, e2
                            // token list labels: 
                            // rule list labels: 
                            // wildcard labels: 
                            if ( state.backtracking==0 ) {
                            retval.tree = root_0;
                            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
                            RewriteRuleSubtreeStream stream_e1=new RewriteRuleSubtreeStream(adaptor,"rule e1",e1!=null?e1.tree:null);
                            RewriteRuleSubtreeStream stream_e2=new RewriteRuleSubtreeStream(adaptor,"rule e2",e2!=null?e2.tree:null);

                            root_0 = (CommonTree)adaptor.nil();
                            // 2732:13: -> ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR $e1 QSTRING[$c.token, $c.text] $e2) ) )
                            {
                                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2732:16: ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR $e1 QSTRING[$c.token, $c.text] $e2) ) )
                                {
                                CommonTree root_2 = (CommonTree)adaptor.nil();
                                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_2);

                                adaptor.addChild(root_2, (CommonTree)adaptor.create(NCNAME, serializeFunction));
                                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2734:18: ^( T_PARAMS ^( T_PAR $e1 QSTRING[$c.token, $c.text] $e2) )
                                {
                                CommonTree root_3 = (CommonTree)adaptor.nil();
                                root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_3);

                                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2734:29: ^( T_PAR $e1 QSTRING[$c.token, $c.text] $e2)
                                {
                                CommonTree root_4 = (CommonTree)adaptor.nil();
                                root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_4);

                                adaptor.addChild(root_4, stream_e1.nextTree());
                                adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, c.token, (c!=null?c.getText():null)));
                                adaptor.addChild(root_4, stream_e2.nextTree());

                                adaptor.addChild(root_3, root_4);
                                }

                                adaptor.addChild(root_2, root_3);
                                }

                                adaptor.addChild(root_1, root_2);
                                }

                            }

                            retval.tree = root_0;}
                            }


                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;
                        case 2 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2742:11: q= qname
                            {
                            _last = (CommonTree)input.LT(1);
                            pushFollow(FOLLOW_qname_in_iriConstruct16357);
                            q=qname();

                            state._fsp--;
                            if (state.failed) return retval;
                            if ( state.backtracking==0 ) stream_qname.add(q.getTree());


                            // AST REWRITE
                            // elements: enclosedExpr
                            // token labels: 
                            // rule labels: retval
                            // token list labels: 
                            // rule list labels: 
                            // wildcard labels: 
                            if ( state.backtracking==0 ) {
                            retval.tree = root_0;
                            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                            root_0 = (CommonTree)adaptor.nil();
                            // 2743:11: -> ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR enclosedExpr QSTRING[$q.text] ) ) )
                            {
                                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2743:14: ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR enclosedExpr QSTRING[$q.text] ) ) )
                                {
                                CommonTree root_2 = (CommonTree)adaptor.nil();
                                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_2);

                                adaptor.addChild(root_2, (CommonTree)adaptor.create(NCNAME, serializeFunction));
                                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2745:16: ^( T_PARAMS ^( T_PAR enclosedExpr QSTRING[$q.text] ) )
                                {
                                CommonTree root_3 = (CommonTree)adaptor.nil();
                                root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_3);

                                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2745:27: ^( T_PAR enclosedExpr QSTRING[$q.text] )
                                {
                                CommonTree root_4 = (CommonTree)adaptor.nil();
                                root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_4);

                                adaptor.addChild(root_4, stream_enclosedExpr.nextTree());
                                adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, (q!=null?(input.getTokenStream().toString(
                                  input.getTreeAdaptor().getTokenStartIndex(q.start),
                                  input.getTreeAdaptor().getTokenStopIndex(q.start))):null)));

                                adaptor.addChild(root_3, root_4);
                                }

                                adaptor.addChild(root_2, root_3);
                                }

                                adaptor.addChild(root_1, root_2);
                                }

                            }

                            retval.tree = root_0;}
                            }
                            break;

                    }


                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2748:9: q= qname c= COLON enclosedExpr
                    {
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_qname_in_iriConstruct16457);
                    q=qname();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_qname.add(q.getTree());
                    _last = (CommonTree)input.LT(1);
                    c=(CommonTree)match(input,COLON,FOLLOW_COLON_in_iriConstruct16461); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_COLON.add(c);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_enclosedExpr_in_iriConstruct16463);
                    enclosedExpr660=enclosedExpr();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_enclosedExpr.add(enclosedExpr660.getTree());


                    // AST REWRITE
                    // elements: enclosedExpr
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2749:7: -> ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$q.text] QSTRING[$c.token, $c.text] enclosedExpr ) ) )
                    {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2749:10: ^( T_FUNCTION_CALL NCNAME[serializeFunction] ^( T_PARAMS ^( T_PAR QSTRING[$q.text] QSTRING[$c.token, $c.text] enclosedExpr ) ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_2);

                        adaptor.addChild(root_2, (CommonTree)adaptor.create(NCNAME, serializeFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2751:12: ^( T_PARAMS ^( T_PAR QSTRING[$q.text] QSTRING[$c.token, $c.text] enclosedExpr ) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_3);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2751:23: ^( T_PAR QSTRING[$q.text] QSTRING[$c.token, $c.text] enclosedExpr )
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PAR, "T_PAR"), root_4);

                        adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, (q!=null?(input.getTokenStream().toString(
                          input.getTreeAdaptor().getTokenStartIndex(q.start),
                          input.getTreeAdaptor().getTokenStopIndex(q.start))):null)));
                        adaptor.addChild(root_4, (CommonTree)adaptor.create(QSTRING, c.token, (c!=null?c.getText():null)));
                        adaptor.addChild(root_4, stream_enclosedExpr.nextTree());

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }


            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "iriConstruct"

    public static class graphTerm_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "graphTerm"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2757:1: graphTerm : ( iRIref | rdfLiteral | sNumericLiteral | booleanLiteral );
    public final XSPARQLRewriter.graphTerm_return graphTerm() throws RecognitionException {
        XSPARQLRewriter.graphTerm_return retval = new XSPARQLRewriter.graphTerm_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.iRIref_return iRIref661 = null;

        XSPARQLRewriter.rdfLiteral_return rdfLiteral662 = null;

        XSPARQLRewriter.sNumericLiteral_return sNumericLiteral663 = null;

        XSPARQLRewriter.booleanLiteral_return booleanLiteral664 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2758:3: ( iRIref | rdfLiteral | sNumericLiteral | booleanLiteral )
            int alt194=4;
            switch ( input.LA(1) ) {
            case PNAME_NS:
            case PNAME_LN:
            case IRIREF:
                {
                alt194=1;
                }
                break;
            case QSTRING:
                {
                alt194=2;
                }
                break;
            case INTEGER:
                {
                alt194=3;
                }
                break;
            case TRUE:
            case FALSE:
                {
                alt194=4;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 194, 0, input);

                throw nvae;
            }

            switch (alt194) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2758:5: iRIref
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_iRIref_in_graphTerm16554);
                    iRIref661=iRIref();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, iRIref661.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2759:5: rdfLiteral
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_rdfLiteral_in_graphTerm16560);
                    rdfLiteral662=rdfLiteral();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, rdfLiteral662.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2760:5: sNumericLiteral
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_sNumericLiteral_in_graphTerm16566);
                    sNumericLiteral663=sNumericLiteral();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, sNumericLiteral663.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2761:5: booleanLiteral
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_booleanLiteral_in_graphTerm16572);
                    booleanLiteral664=booleanLiteral();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, booleanLiteral664.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "graphTerm"

    public static class blankConstruct_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "blankConstruct"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2764:1: blankConstruct : b= BNODE_CONSTRUCT enclosedExpr -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[$b.token, $b.text] enclosedExpr QSTRING[\"\"] QSTRING[\"\"] ) ) ;
    public final XSPARQLRewriter.blankConstruct_return blankConstruct() throws RecognitionException {
        XSPARQLRewriter.blankConstruct_return retval = new XSPARQLRewriter.blankConstruct_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree b=null;
        XSPARQLRewriter.enclosedExpr_return enclosedExpr665 = null;


        CommonTree b_tree=null;
        RewriteRuleNodeStream stream_BNODE_CONSTRUCT=new RewriteRuleNodeStream(adaptor,"token BNODE_CONSTRUCT");
        RewriteRuleSubtreeStream stream_enclosedExpr=new RewriteRuleSubtreeStream(adaptor,"rule enclosedExpr");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2765:3: (b= BNODE_CONSTRUCT enclosedExpr -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[$b.token, $b.text] enclosedExpr QSTRING[\"\"] QSTRING[\"\"] ) ) )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2765:5: b= BNODE_CONSTRUCT enclosedExpr
            {
            _last = (CommonTree)input.LT(1);
            b=(CommonTree)match(input,BNODE_CONSTRUCT,FOLLOW_BNODE_CONSTRUCT_in_blankConstruct16587); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_BNODE_CONSTRUCT.add(b);

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_enclosedExpr_in_blankConstruct16589);
            enclosedExpr665=enclosedExpr();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_enclosedExpr.add(enclosedExpr665.getTree());


            // AST REWRITE
            // elements: enclosedExpr
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 2766:3: -> ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[$b.token, $b.text] enclosedExpr QSTRING[\"\"] QSTRING[\"\"] ) )
            {
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2766:6: ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS QSTRING[$b.token, $b.text] enclosedExpr QSTRING[\"\"] QSTRING[\"\"] ) )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_1);

                adaptor.addChild(root_1, (CommonTree)adaptor.create(NCNAME, bindingTermFunction));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2768:8: ^( T_PARAMS QSTRING[$b.token, $b.text] enclosedExpr QSTRING[\"\"] QSTRING[\"\"] )
                {
                CommonTree root_2 = (CommonTree)adaptor.nil();
                root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_2);

                adaptor.addChild(root_2, (CommonTree)adaptor.create(QSTRING, b.token, (b!=null?b.getText():null)));
                adaptor.addChild(root_2, stream_enclosedExpr.nextTree());
                adaptor.addChild(root_2, (CommonTree)adaptor.create(QSTRING, ""));
                adaptor.addChild(root_2, (CommonTree)adaptor.create(QSTRING, ""));

                adaptor.addChild(root_1, root_2);
                }

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "blankConstruct"

    public static class expression_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "expression"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2777:1: expression : conditionalOrExpression ;
    public final XSPARQLRewriter.expression_return expression() throws RecognitionException {
        XSPARQLRewriter.expression_return retval = new XSPARQLRewriter.expression_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.conditionalOrExpression_return conditionalOrExpression666 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2778:3: ( conditionalOrExpression )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2778:5: conditionalOrExpression
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_conditionalOrExpression_in_expression16702);
            conditionalOrExpression666=conditionalOrExpression();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, conditionalOrExpression666.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "expression"

    public static class conditionalOrExpression_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "conditionalOrExpression"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2781:1: conditionalOrExpression : ( conditionalAndExpression | ^(o= ORSYMBOL conditionalOrExpression conditionalAndExpression ) -> conditionalOrExpression QSTRING[$o.token, \" \"+$o.text+\" \"] conditionalAndExpression );
    public final XSPARQLRewriter.conditionalOrExpression_return conditionalOrExpression() throws RecognitionException {
        XSPARQLRewriter.conditionalOrExpression_return retval = new XSPARQLRewriter.conditionalOrExpression_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree o=null;
        XSPARQLRewriter.conditionalAndExpression_return conditionalAndExpression667 = null;

        XSPARQLRewriter.conditionalOrExpression_return conditionalOrExpression668 = null;

        XSPARQLRewriter.conditionalAndExpression_return conditionalAndExpression669 = null;


        CommonTree o_tree=null;
        RewriteRuleNodeStream stream_ORSYMBOL=new RewriteRuleNodeStream(adaptor,"token ORSYMBOL");
        RewriteRuleSubtreeStream stream_conditionalAndExpression=new RewriteRuleSubtreeStream(adaptor,"rule conditionalAndExpression");
        RewriteRuleSubtreeStream stream_conditionalOrExpression=new RewriteRuleSubtreeStream(adaptor,"rule conditionalOrExpression");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2782:3: ( conditionalAndExpression | ^(o= ORSYMBOL conditionalOrExpression conditionalAndExpression ) -> conditionalOrExpression QSTRING[$o.token, \" \"+$o.text+\" \"] conditionalAndExpression )
            int alt195=2;
            switch ( input.LA(1) ) {
            case VAR:
            case INTEGER:
            case QSTRING:
            case SLASH:
            case LPAR:
            case STAR:
            case LESSTHAN:
            case GREATERTHAN:
            case PLUS:
            case MINUS:
            case GREATERTHANEQUALS:
            case LESSTHANEQUALS:
            case HAFENEQUALS:
            case EQUALS:
            case ANDSYMBOL:
            case NOT:
            case STR:
            case LANG:
            case LANGMATCHES:
            case DATATYPE:
            case BOUND:
            case ISIRI:
            case ISURI:
            case ISBLANK:
            case ISLITERAL:
            case REGEX:
            case TRUE:
            case FALSE:
            case T_FUNCTION_CALL:
                {
                alt195=1;
                }
                break;
            case ORSYMBOL:
                {
                alt195=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 195, 0, input);

                throw nvae;
            }

            switch (alt195) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2782:5: conditionalAndExpression
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_conditionalAndExpression_in_conditionalOrExpression16715);
                    conditionalAndExpression667=conditionalAndExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, conditionalAndExpression667.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2783:5: ^(o= ORSYMBOL conditionalOrExpression conditionalAndExpression )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    o=(CommonTree)match(input,ORSYMBOL,FOLLOW_ORSYMBOL_in_conditionalOrExpression16724); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_ORSYMBOL.add(o);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_conditionalOrExpression_in_conditionalOrExpression16726);
                    conditionalOrExpression668=conditionalOrExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_conditionalOrExpression.add(conditionalOrExpression668.getTree());
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_conditionalAndExpression_in_conditionalOrExpression16728);
                    conditionalAndExpression669=conditionalAndExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_conditionalAndExpression.add(conditionalAndExpression669.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: conditionalOrExpression, conditionalAndExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2784:3: -> conditionalOrExpression QSTRING[$o.token, \" \"+$o.text+\" \"] conditionalAndExpression
                    {
                        adaptor.addChild(root_0, stream_conditionalOrExpression.nextTree());
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, o.token, " "+(o!=null?o.getText():null)+" "));
                        adaptor.addChild(root_0, stream_conditionalAndExpression.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "conditionalOrExpression"

    public static class conditionalAndExpression_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "conditionalAndExpression"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2787:1: conditionalAndExpression : ( valueLogical | ^(a= ANDSYMBOL conditionalAndExpression valueLogical ) -> conditionalAndExpression QSTRING[$a.token, \" &amp;&amp; \"] valueLogical );
    public final XSPARQLRewriter.conditionalAndExpression_return conditionalAndExpression() throws RecognitionException {
        XSPARQLRewriter.conditionalAndExpression_return retval = new XSPARQLRewriter.conditionalAndExpression_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree a=null;
        XSPARQLRewriter.valueLogical_return valueLogical670 = null;

        XSPARQLRewriter.conditionalAndExpression_return conditionalAndExpression671 = null;

        XSPARQLRewriter.valueLogical_return valueLogical672 = null;


        CommonTree a_tree=null;
        RewriteRuleNodeStream stream_ANDSYMBOL=new RewriteRuleNodeStream(adaptor,"token ANDSYMBOL");
        RewriteRuleSubtreeStream stream_conditionalAndExpression=new RewriteRuleSubtreeStream(adaptor,"rule conditionalAndExpression");
        RewriteRuleSubtreeStream stream_valueLogical=new RewriteRuleSubtreeStream(adaptor,"rule valueLogical");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2788:3: ( valueLogical | ^(a= ANDSYMBOL conditionalAndExpression valueLogical ) -> conditionalAndExpression QSTRING[$a.token, \" &amp;&amp; \"] valueLogical )
            int alt196=2;
            switch ( input.LA(1) ) {
            case VAR:
            case INTEGER:
            case QSTRING:
            case SLASH:
            case LPAR:
            case STAR:
            case LESSTHAN:
            case GREATERTHAN:
            case PLUS:
            case MINUS:
            case GREATERTHANEQUALS:
            case LESSTHANEQUALS:
            case HAFENEQUALS:
            case EQUALS:
            case NOT:
            case STR:
            case LANG:
            case LANGMATCHES:
            case DATATYPE:
            case BOUND:
            case ISIRI:
            case ISURI:
            case ISBLANK:
            case ISLITERAL:
            case REGEX:
            case TRUE:
            case FALSE:
            case T_FUNCTION_CALL:
                {
                alt196=1;
                }
                break;
            case ANDSYMBOL:
                {
                alt196=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 196, 0, input);

                throw nvae;
            }

            switch (alt196) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2788:5: valueLogical
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_valueLogical_in_conditionalAndExpression16753);
                    valueLogical670=valueLogical();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, valueLogical670.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2789:5: ^(a= ANDSYMBOL conditionalAndExpression valueLogical )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
                    a=(CommonTree)match(input,ANDSYMBOL,FOLLOW_ANDSYMBOL_in_conditionalAndExpression16762); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_ANDSYMBOL.add(a);



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_conditionalAndExpression_in_conditionalAndExpression16764);
                    conditionalAndExpression671=conditionalAndExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_conditionalAndExpression.add(conditionalAndExpression671.getTree());
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_valueLogical_in_conditionalAndExpression16766);
                    valueLogical672=valueLogical();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_valueLogical.add(valueLogical672.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: valueLogical, conditionalAndExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2790:3: -> conditionalAndExpression QSTRING[$a.token, \" &amp;&amp; \"] valueLogical
                    {
                        adaptor.addChild(root_0, stream_conditionalAndExpression.nextTree());
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, a.token, " &amp;&amp; "));
                        adaptor.addChild(root_0, stream_valueLogical.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "conditionalAndExpression"

    public static class valueLogical_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "valueLogical"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2793:1: valueLogical : relationalExpression ;
    public final XSPARQLRewriter.valueLogical_return valueLogical() throws RecognitionException {
        XSPARQLRewriter.valueLogical_return retval = new XSPARQLRewriter.valueLogical_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.relationalExpression_return relationalExpression673 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2794:3: ( relationalExpression )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2794:5: relationalExpression
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_relationalExpression_in_valueLogical16791);
            relationalExpression673=relationalExpression();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, relationalExpression673.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "valueLogical"

    public static class relationalExpression_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "relationalExpression"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2797:1: relationalExpression : ( numericExpression | ^( (o= EQUALS | o= HAFENEQUALS | o= LESSTHAN | o= GREATERTHAN | o= LESSTHANEQUALS | o= GREATERTHANEQUALS ) numericExpression numericExpression ) -> numericExpression QSTRING[$o.token, $o.text] numericExpression );
    public final XSPARQLRewriter.relationalExpression_return relationalExpression() throws RecognitionException {
        XSPARQLRewriter.relationalExpression_return retval = new XSPARQLRewriter.relationalExpression_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree o=null;
        XSPARQLRewriter.numericExpression_return numericExpression674 = null;

        XSPARQLRewriter.numericExpression_return numericExpression675 = null;

        XSPARQLRewriter.numericExpression_return numericExpression676 = null;


        CommonTree o_tree=null;
        RewriteRuleNodeStream stream_LESSTHAN=new RewriteRuleNodeStream(adaptor,"token LESSTHAN");
        RewriteRuleNodeStream stream_EQUALS=new RewriteRuleNodeStream(adaptor,"token EQUALS");
        RewriteRuleNodeStream stream_HAFENEQUALS=new RewriteRuleNodeStream(adaptor,"token HAFENEQUALS");
        RewriteRuleNodeStream stream_LESSTHANEQUALS=new RewriteRuleNodeStream(adaptor,"token LESSTHANEQUALS");
        RewriteRuleNodeStream stream_GREATERTHANEQUALS=new RewriteRuleNodeStream(adaptor,"token GREATERTHANEQUALS");
        RewriteRuleNodeStream stream_GREATERTHAN=new RewriteRuleNodeStream(adaptor,"token GREATERTHAN");
        RewriteRuleSubtreeStream stream_numericExpression=new RewriteRuleSubtreeStream(adaptor,"rule numericExpression");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2798:3: ( numericExpression | ^( (o= EQUALS | o= HAFENEQUALS | o= LESSTHAN | o= GREATERTHAN | o= LESSTHANEQUALS | o= GREATERTHANEQUALS ) numericExpression numericExpression ) -> numericExpression QSTRING[$o.token, $o.text] numericExpression )
            int alt198=2;
            switch ( input.LA(1) ) {
            case VAR:
            case INTEGER:
            case QSTRING:
            case SLASH:
            case LPAR:
            case STAR:
            case PLUS:
            case MINUS:
            case NOT:
            case STR:
            case LANG:
            case LANGMATCHES:
            case DATATYPE:
            case BOUND:
            case ISIRI:
            case ISURI:
            case ISBLANK:
            case ISLITERAL:
            case REGEX:
            case TRUE:
            case FALSE:
            case T_FUNCTION_CALL:
                {
                alt198=1;
                }
                break;
            case LESSTHAN:
            case GREATERTHAN:
            case GREATERTHANEQUALS:
            case LESSTHANEQUALS:
            case HAFENEQUALS:
            case EQUALS:
                {
                alt198=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 198, 0, input);

                throw nvae;
            }

            switch (alt198) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2798:5: numericExpression
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_numericExpression_in_relationalExpression16804);
                    numericExpression674=numericExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, numericExpression674.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2799:5: ^( (o= EQUALS | o= HAFENEQUALS | o= LESSTHAN | o= GREATERTHAN | o= LESSTHANEQUALS | o= GREATERTHANEQUALS ) numericExpression numericExpression )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();// org/deri/xsparql/rewriter/XSPARQLRewriter.g:2799:7: (o= EQUALS | o= HAFENEQUALS | o= LESSTHAN | o= GREATERTHAN | o= LESSTHANEQUALS | o= GREATERTHANEQUALS )
                    int alt197=6;
                    switch ( input.LA(1) ) {
                    case EQUALS:
                        {
                        alt197=1;
                        }
                        break;
                    case HAFENEQUALS:
                        {
                        alt197=2;
                        }
                        break;
                    case LESSTHAN:
                        {
                        alt197=3;
                        }
                        break;
                    case GREATERTHAN:
                        {
                        alt197=4;
                        }
                        break;
                    case LESSTHANEQUALS:
                        {
                        alt197=5;
                        }
                        break;
                    case GREATERTHANEQUALS:
                        {
                        alt197=6;
                        }
                        break;
                    default:
                        if (state.backtracking>0) {state.failed=true; return retval;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 197, 0, input);

                        throw nvae;
                    }

                    switch (alt197) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2799:8: o= EQUALS
                            {
                            _last = (CommonTree)input.LT(1);
                            o=(CommonTree)match(input,EQUALS,FOLLOW_EQUALS_in_relationalExpression16814); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_EQUALS.add(o);


                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;
                        case 2 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2799:19: o= HAFENEQUALS
                            {
                            _last = (CommonTree)input.LT(1);
                            o=(CommonTree)match(input,HAFENEQUALS,FOLLOW_HAFENEQUALS_in_relationalExpression16820); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_HAFENEQUALS.add(o);


                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;
                        case 3 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2799:35: o= LESSTHAN
                            {
                            _last = (CommonTree)input.LT(1);
                            o=(CommonTree)match(input,LESSTHAN,FOLLOW_LESSTHAN_in_relationalExpression16826); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_LESSTHAN.add(o);


                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;
                        case 4 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2799:47: o= GREATERTHAN
                            {
                            _last = (CommonTree)input.LT(1);
                            o=(CommonTree)match(input,GREATERTHAN,FOLLOW_GREATERTHAN_in_relationalExpression16831); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_GREATERTHAN.add(o);


                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;
                        case 5 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2799:63: o= LESSTHANEQUALS
                            {
                            _last = (CommonTree)input.LT(1);
                            o=(CommonTree)match(input,LESSTHANEQUALS,FOLLOW_LESSTHANEQUALS_in_relationalExpression16837); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_LESSTHANEQUALS.add(o);


                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;
                        case 6 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2799:82: o= GREATERTHANEQUALS
                            {
                            _last = (CommonTree)input.LT(1);
                            o=(CommonTree)match(input,GREATERTHANEQUALS,FOLLOW_GREATERTHANEQUALS_in_relationalExpression16843); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_GREATERTHANEQUALS.add(o);


                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_numericExpression_in_relationalExpression16846);
                    numericExpression675=numericExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_numericExpression.add(numericExpression675.getTree());
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_numericExpression_in_relationalExpression16848);
                    numericExpression676=numericExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_numericExpression.add(numericExpression676.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: numericExpression, numericExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2800:3: -> numericExpression QSTRING[$o.token, $o.text] numericExpression
                    {
                        adaptor.addChild(root_0, stream_numericExpression.nextTree());
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, o.token, (o!=null?o.getText():null)));
                        adaptor.addChild(root_0, stream_numericExpression.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "relationalExpression"

    public static class numericExpression_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "numericExpression"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2803:1: numericExpression : additiveExpression ;
    public final XSPARQLRewriter.numericExpression_return numericExpression() throws RecognitionException {
        XSPARQLRewriter.numericExpression_return retval = new XSPARQLRewriter.numericExpression_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.additiveExpression_return additiveExpression677 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2804:3: ( additiveExpression )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2804:5: additiveExpression
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_additiveExpression_in_numericExpression16873);
            additiveExpression677=additiveExpression();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, additiveExpression677.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "numericExpression"

    public static class additiveExpression_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "additiveExpression"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2807:1: additiveExpression : ( multiplicativeExpression | ^( (o= PLUS | o= MINUS ) additiveExpression multiplicativeExpression ) -> additiveExpression QSTRING[$o.token, $o.text] multiplicativeExpression );
    public final XSPARQLRewriter.additiveExpression_return additiveExpression() throws RecognitionException {
        XSPARQLRewriter.additiveExpression_return retval = new XSPARQLRewriter.additiveExpression_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree o=null;
        XSPARQLRewriter.multiplicativeExpression_return multiplicativeExpression678 = null;

        XSPARQLRewriter.additiveExpression_return additiveExpression679 = null;

        XSPARQLRewriter.multiplicativeExpression_return multiplicativeExpression680 = null;


        CommonTree o_tree=null;
        RewriteRuleNodeStream stream_PLUS=new RewriteRuleNodeStream(adaptor,"token PLUS");
        RewriteRuleNodeStream stream_MINUS=new RewriteRuleNodeStream(adaptor,"token MINUS");
        RewriteRuleSubtreeStream stream_additiveExpression=new RewriteRuleSubtreeStream(adaptor,"rule additiveExpression");
        RewriteRuleSubtreeStream stream_multiplicativeExpression=new RewriteRuleSubtreeStream(adaptor,"rule multiplicativeExpression");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2808:3: ( multiplicativeExpression | ^( (o= PLUS | o= MINUS ) additiveExpression multiplicativeExpression ) -> additiveExpression QSTRING[$o.token, $o.text] multiplicativeExpression )
            int alt200=2;
            switch ( input.LA(1) ) {
            case VAR:
            case INTEGER:
            case QSTRING:
            case SLASH:
            case LPAR:
            case STAR:
            case NOT:
            case STR:
            case LANG:
            case LANGMATCHES:
            case DATATYPE:
            case BOUND:
            case ISIRI:
            case ISURI:
            case ISBLANK:
            case ISLITERAL:
            case REGEX:
            case TRUE:
            case FALSE:
            case T_FUNCTION_CALL:
                {
                alt200=1;
                }
                break;
            case PLUS:
                {
                switch ( input.LA(2) ) {
                case DOWN:
                    {
                    alt200=2;
                    }
                    break;
                case VAR:
                case INTEGER:
                case QSTRING:
                case LPAR:
                case STR:
                case LANG:
                case LANGMATCHES:
                case DATATYPE:
                case BOUND:
                case ISIRI:
                case ISURI:
                case ISBLANK:
                case ISLITERAL:
                case REGEX:
                case TRUE:
                case FALSE:
                case T_FUNCTION_CALL:
                    {
                    alt200=1;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 200, 2, input);

                    throw nvae;
                }

                }
                break;
            case MINUS:
                {
                switch ( input.LA(2) ) {
                case DOWN:
                    {
                    alt200=2;
                    }
                    break;
                case VAR:
                case INTEGER:
                case QSTRING:
                case LPAR:
                case STR:
                case LANG:
                case LANGMATCHES:
                case DATATYPE:
                case BOUND:
                case ISIRI:
                case ISURI:
                case ISBLANK:
                case ISLITERAL:
                case REGEX:
                case TRUE:
                case FALSE:
                case T_FUNCTION_CALL:
                    {
                    alt200=1;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 200, 3, input);

                    throw nvae;
                }

                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 200, 0, input);

                throw nvae;
            }

            switch (alt200) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2808:5: multiplicativeExpression
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_multiplicativeExpression_in_additiveExpression16886);
                    multiplicativeExpression678=multiplicativeExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, multiplicativeExpression678.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2809:5: ^( (o= PLUS | o= MINUS ) additiveExpression multiplicativeExpression )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();// org/deri/xsparql/rewriter/XSPARQLRewriter.g:2809:7: (o= PLUS | o= MINUS )
                    int alt199=2;
                    switch ( input.LA(1) ) {
                    case PLUS:
                        {
                        alt199=1;
                        }
                        break;
                    case MINUS:
                        {
                        alt199=2;
                        }
                        break;
                    default:
                        if (state.backtracking>0) {state.failed=true; return retval;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 199, 0, input);

                        throw nvae;
                    }

                    switch (alt199) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2809:8: o= PLUS
                            {
                            _last = (CommonTree)input.LT(1);
                            o=(CommonTree)match(input,PLUS,FOLLOW_PLUS_in_additiveExpression16896); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_PLUS.add(o);


                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;
                        case 2 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2809:17: o= MINUS
                            {
                            _last = (CommonTree)input.LT(1);
                            o=(CommonTree)match(input,MINUS,FOLLOW_MINUS_in_additiveExpression16902); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_MINUS.add(o);


                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_additiveExpression_in_additiveExpression16905);
                    additiveExpression679=additiveExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_additiveExpression.add(additiveExpression679.getTree());
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_multiplicativeExpression_in_additiveExpression16907);
                    multiplicativeExpression680=multiplicativeExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_multiplicativeExpression.add(multiplicativeExpression680.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: multiplicativeExpression, additiveExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2810:3: -> additiveExpression QSTRING[$o.token, $o.text] multiplicativeExpression
                    {
                        adaptor.addChild(root_0, stream_additiveExpression.nextTree());
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, o.token, (o!=null?o.getText():null)));
                        adaptor.addChild(root_0, stream_multiplicativeExpression.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "additiveExpression"

    public static class multiplicativeExpression_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "multiplicativeExpression"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2813:1: multiplicativeExpression : ( unaryExpression | ^( (o= STAR | o= SLASH ) multiplicativeExpression unaryExpression ) -> multiplicativeExpression QSTRING[$o.token, $o.text] unaryExpression );
    public final XSPARQLRewriter.multiplicativeExpression_return multiplicativeExpression() throws RecognitionException {
        XSPARQLRewriter.multiplicativeExpression_return retval = new XSPARQLRewriter.multiplicativeExpression_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree o=null;
        XSPARQLRewriter.unaryExpression_return unaryExpression681 = null;

        XSPARQLRewriter.multiplicativeExpression_return multiplicativeExpression682 = null;

        XSPARQLRewriter.unaryExpression_return unaryExpression683 = null;


        CommonTree o_tree=null;
        RewriteRuleNodeStream stream_STAR=new RewriteRuleNodeStream(adaptor,"token STAR");
        RewriteRuleNodeStream stream_SLASH=new RewriteRuleNodeStream(adaptor,"token SLASH");
        RewriteRuleSubtreeStream stream_unaryExpression=new RewriteRuleSubtreeStream(adaptor,"rule unaryExpression");
        RewriteRuleSubtreeStream stream_multiplicativeExpression=new RewriteRuleSubtreeStream(adaptor,"rule multiplicativeExpression");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2814:3: ( unaryExpression | ^( (o= STAR | o= SLASH ) multiplicativeExpression unaryExpression ) -> multiplicativeExpression QSTRING[$o.token, $o.text] unaryExpression )
            int alt202=2;
            switch ( input.LA(1) ) {
            case VAR:
            case INTEGER:
            case QSTRING:
            case LPAR:
            case PLUS:
            case MINUS:
            case NOT:
            case STR:
            case LANG:
            case LANGMATCHES:
            case DATATYPE:
            case BOUND:
            case ISIRI:
            case ISURI:
            case ISBLANK:
            case ISLITERAL:
            case REGEX:
            case TRUE:
            case FALSE:
            case T_FUNCTION_CALL:
                {
                alt202=1;
                }
                break;
            case SLASH:
            case STAR:
                {
                alt202=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 202, 0, input);

                throw nvae;
            }

            switch (alt202) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2814:5: unaryExpression
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_unaryExpression_in_multiplicativeExpression16933);
                    unaryExpression681=unaryExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, unaryExpression681.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2815:5: ^( (o= STAR | o= SLASH ) multiplicativeExpression unaryExpression )
                    {
                    _last = (CommonTree)input.LT(1);
                    {
                    CommonTree _save_last_1 = _last;
                    CommonTree _first_1 = null;
                    CommonTree root_1 = (CommonTree)adaptor.nil();// org/deri/xsparql/rewriter/XSPARQLRewriter.g:2815:7: (o= STAR | o= SLASH )
                    int alt201=2;
                    switch ( input.LA(1) ) {
                    case STAR:
                        {
                        alt201=1;
                        }
                        break;
                    case SLASH:
                        {
                        alt201=2;
                        }
                        break;
                    default:
                        if (state.backtracking>0) {state.failed=true; return retval;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 201, 0, input);

                        throw nvae;
                    }

                    switch (alt201) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2815:8: o= STAR
                            {
                            _last = (CommonTree)input.LT(1);
                            o=(CommonTree)match(input,STAR,FOLLOW_STAR_in_multiplicativeExpression16943); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_STAR.add(o);


                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;
                        case 2 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2815:17: o= SLASH
                            {
                            _last = (CommonTree)input.LT(1);
                            o=(CommonTree)match(input,SLASH,FOLLOW_SLASH_in_multiplicativeExpression16949); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_SLASH.add(o);


                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }



                    match(input, Token.DOWN, null); if (state.failed) return retval;
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_multiplicativeExpression_in_multiplicativeExpression16952);
                    multiplicativeExpression682=multiplicativeExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_multiplicativeExpression.add(multiplicativeExpression682.getTree());
                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_unaryExpression_in_multiplicativeExpression16954);
                    unaryExpression683=unaryExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_unaryExpression.add(unaryExpression683.getTree());

                    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
                    }



                    // AST REWRITE
                    // elements: unaryExpression, multiplicativeExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2816:3: -> multiplicativeExpression QSTRING[$o.token, $o.text] unaryExpression
                    {
                        adaptor.addChild(root_0, stream_multiplicativeExpression.nextTree());
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, o.token, (o!=null?o.getText():null)));
                        adaptor.addChild(root_0, stream_unaryExpression.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "multiplicativeExpression"

    public static class unaryExpression_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "unaryExpression"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2819:1: unaryExpression : (n= NOT primaryExpression -> QSTRING[$n.token, $n.text] primaryExpression | p= PLUS primaryExpression -> QSTRING[$p.token, $p.text] primaryExpression | m= MINUS primaryExpression -> QSTRING[$m.token, $m.text] primaryExpression | primaryExpression );
    public final XSPARQLRewriter.unaryExpression_return unaryExpression() throws RecognitionException {
        XSPARQLRewriter.unaryExpression_return retval = new XSPARQLRewriter.unaryExpression_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree n=null;
        CommonTree p=null;
        CommonTree m=null;
        XSPARQLRewriter.primaryExpression_return primaryExpression684 = null;

        XSPARQLRewriter.primaryExpression_return primaryExpression685 = null;

        XSPARQLRewriter.primaryExpression_return primaryExpression686 = null;

        XSPARQLRewriter.primaryExpression_return primaryExpression687 = null;


        CommonTree n_tree=null;
        CommonTree p_tree=null;
        CommonTree m_tree=null;
        RewriteRuleNodeStream stream_PLUS=new RewriteRuleNodeStream(adaptor,"token PLUS");
        RewriteRuleNodeStream stream_NOT=new RewriteRuleNodeStream(adaptor,"token NOT");
        RewriteRuleNodeStream stream_MINUS=new RewriteRuleNodeStream(adaptor,"token MINUS");
        RewriteRuleSubtreeStream stream_primaryExpression=new RewriteRuleSubtreeStream(adaptor,"rule primaryExpression");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2820:3: (n= NOT primaryExpression -> QSTRING[$n.token, $n.text] primaryExpression | p= PLUS primaryExpression -> QSTRING[$p.token, $p.text] primaryExpression | m= MINUS primaryExpression -> QSTRING[$m.token, $m.text] primaryExpression | primaryExpression )
            int alt203=4;
            switch ( input.LA(1) ) {
            case NOT:
                {
                alt203=1;
                }
                break;
            case PLUS:
                {
                alt203=2;
                }
                break;
            case MINUS:
                {
                alt203=3;
                }
                break;
            case VAR:
            case INTEGER:
            case QSTRING:
            case LPAR:
            case STR:
            case LANG:
            case LANGMATCHES:
            case DATATYPE:
            case BOUND:
            case ISIRI:
            case ISURI:
            case ISBLANK:
            case ISLITERAL:
            case REGEX:
            case TRUE:
            case FALSE:
            case T_FUNCTION_CALL:
                {
                alt203=4;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 203, 0, input);

                throw nvae;
            }

            switch (alt203) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2820:5: n= NOT primaryExpression
                    {
                    _last = (CommonTree)input.LT(1);
                    n=(CommonTree)match(input,NOT,FOLLOW_NOT_in_unaryExpression16981); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_NOT.add(n);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_primaryExpression_in_unaryExpression16983);
                    primaryExpression684=primaryExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_primaryExpression.add(primaryExpression684.getTree());


                    // AST REWRITE
                    // elements: primaryExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2821:3: -> QSTRING[$n.token, $n.text] primaryExpression
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, n.token, (n!=null?n.getText():null)));
                        adaptor.addChild(root_0, stream_primaryExpression.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2822:5: p= PLUS primaryExpression
                    {
                    _last = (CommonTree)input.LT(1);
                    p=(CommonTree)match(input,PLUS,FOLLOW_PLUS_in_unaryExpression17000); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_PLUS.add(p);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_primaryExpression_in_unaryExpression17002);
                    primaryExpression685=primaryExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_primaryExpression.add(primaryExpression685.getTree());


                    // AST REWRITE
                    // elements: primaryExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2823:5: -> QSTRING[$p.token, $p.text] primaryExpression
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, p.token, (p!=null?p.getText():null)));
                        adaptor.addChild(root_0, stream_primaryExpression.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2824:5: m= MINUS primaryExpression
                    {
                    _last = (CommonTree)input.LT(1);
                    m=(CommonTree)match(input,MINUS,FOLLOW_MINUS_in_unaryExpression17021); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_MINUS.add(m);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_primaryExpression_in_unaryExpression17023);
                    primaryExpression686=primaryExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_primaryExpression.add(primaryExpression686.getTree());


                    // AST REWRITE
                    // elements: primaryExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2825:5: -> QSTRING[$m.token, $m.text] primaryExpression
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, m.token, (m!=null?m.getText():null)));
                        adaptor.addChild(root_0, stream_primaryExpression.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2826:5: primaryExpression
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_primaryExpression_in_unaryExpression17040);
                    primaryExpression687=primaryExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, primaryExpression687.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "unaryExpression"

    public static class primaryExpression_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "primaryExpression"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2829:1: primaryExpression : ( brackettedExpression | builtInCall | iRIrefOrFunction | rdfLiteral | sNumericLiteral | booleanLiteral | var= VAR -> {isBoundEarlier($var.text, Types.SPARQL)}? ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS $var) ) -> {isBoundEarlier($var.text)}? ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $var) ) ) ) -> QSTRING[$var.token, $var.text ] );
    public final XSPARQLRewriter.primaryExpression_return primaryExpression() throws RecognitionException {
        XSPARQLRewriter.primaryExpression_return retval = new XSPARQLRewriter.primaryExpression_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree var=null;
        XSPARQLRewriter.brackettedExpression_return brackettedExpression688 = null;

        XSPARQLRewriter.builtInCall_return builtInCall689 = null;

        XSPARQLRewriter.iRIrefOrFunction_return iRIrefOrFunction690 = null;

        XSPARQLRewriter.rdfLiteral_return rdfLiteral691 = null;

        XSPARQLRewriter.sNumericLiteral_return sNumericLiteral692 = null;

        XSPARQLRewriter.booleanLiteral_return booleanLiteral693 = null;


        CommonTree var_tree=null;
        RewriteRuleNodeStream stream_VAR=new RewriteRuleNodeStream(adaptor,"token VAR");

         String rdftermvar = ""; 
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2831:3: ( brackettedExpression | builtInCall | iRIrefOrFunction | rdfLiteral | sNumericLiteral | booleanLiteral | var= VAR -> {isBoundEarlier($var.text, Types.SPARQL)}? ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS $var) ) -> {isBoundEarlier($var.text)}? ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $var) ) ) ) -> QSTRING[$var.token, $var.text ] )
            int alt204=7;
            switch ( input.LA(1) ) {
            case LPAR:
                {
                alt204=1;
                }
                break;
            case STR:
            case LANG:
            case LANGMATCHES:
            case DATATYPE:
            case BOUND:
            case ISIRI:
            case ISURI:
            case ISBLANK:
            case ISLITERAL:
            case REGEX:
                {
                alt204=2;
                }
                break;
            case T_FUNCTION_CALL:
                {
                alt204=3;
                }
                break;
            case QSTRING:
                {
                alt204=4;
                }
                break;
            case INTEGER:
                {
                alt204=5;
                }
                break;
            case TRUE:
            case FALSE:
                {
                alt204=6;
                }
                break;
            case VAR:
                {
                alt204=7;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 204, 0, input);

                throw nvae;
            }

            switch (alt204) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2831:5: brackettedExpression
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_brackettedExpression_in_primaryExpression17058);
                    brackettedExpression688=brackettedExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, brackettedExpression688.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2832:5: builtInCall
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_builtInCall_in_primaryExpression17064);
                    builtInCall689=builtInCall();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, builtInCall689.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2833:5: iRIrefOrFunction
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_iRIrefOrFunction_in_primaryExpression17070);
                    iRIrefOrFunction690=iRIrefOrFunction();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, iRIrefOrFunction690.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2834:5: rdfLiteral
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_rdfLiteral_in_primaryExpression17076);
                    rdfLiteral691=rdfLiteral();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, rdfLiteral691.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 5 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2835:5: sNumericLiteral
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_sNumericLiteral_in_primaryExpression17082);
                    sNumericLiteral692=sNumericLiteral();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, sNumericLiteral692.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 6 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2836:5: booleanLiteral
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_booleanLiteral_in_primaryExpression17088);
                    booleanLiteral693=booleanLiteral();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, booleanLiteral693.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 7 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2839:5: var= VAR
                    {
                    _last = (CommonTree)input.LT(1);
                    var=(CommonTree)match(input,VAR,FOLLOW_VAR_in_primaryExpression17102); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_VAR.add(var);



                    // AST REWRITE
                    // elements: var, var
                    // token labels: var
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleNodeStream stream_var=new RewriteRuleNodeStream(adaptor,"token var",var);
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2840:3: -> {isBoundEarlier($var.text, Types.SPARQL)}? ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS $var) )
                    if (isBoundEarlier((var!=null?var.getText():null), Types.SPARQL)) {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2840:49: ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS $var) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(NCNAME, rdfTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2840:91: ^( T_PARAMS $var)
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_2);

                        adaptor.addChild(root_2, stream_var.nextNode());

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }
                    else // 2841:3: -> {isBoundEarlier($var.text)}? ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $var) ) ) )
                    if (isBoundEarlier((var!=null?var.getText():null))) {
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2841:35: ^( T_FUNCTION_CALL NCNAME[rdfTermFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $var) ) ) )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_1);

                        adaptor.addChild(root_1, (CommonTree)adaptor.create(NCNAME, rdfTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2841:77: ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $var) ) )
                        {
                        CommonTree root_2 = (CommonTree)adaptor.nil();
                        root_2 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_2);

                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2841:88: ^( T_FUNCTION_CALL NCNAME[bindingTermFunction] ^( T_PARAMS $var) )
                        {
                        CommonTree root_3 = (CommonTree)adaptor.nil();
                        root_3 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_FUNCTION_CALL, "T_FUNCTION_CALL"), root_3);

                        adaptor.addChild(root_3, (CommonTree)adaptor.create(NCNAME, bindingTermFunction));
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2841:134: ^( T_PARAMS $var)
                        {
                        CommonTree root_4 = (CommonTree)adaptor.nil();
                        root_4 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(T_PARAMS, "T_PARAMS"), root_4);

                        adaptor.addChild(root_4, stream_var.nextNode());

                        adaptor.addChild(root_3, root_4);
                        }

                        adaptor.addChild(root_2, root_3);
                        }

                        adaptor.addChild(root_1, root_2);
                        }

                        adaptor.addChild(root_0, root_1);
                        }

                    }
                    else // 2842:3: -> QSTRING[$var.token, $var.text ]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, var.token, (var!=null?var.getText():null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "primaryExpression"

    public static class brackettedExpression_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "brackettedExpression"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2845:1: brackettedExpression : l= LPAR expression r= RPAR -> QSTRING[$l.token, $l.text] expression QSTRING[$r.token, $r.text] ;
    public final XSPARQLRewriter.brackettedExpression_return brackettedExpression() throws RecognitionException {
        XSPARQLRewriter.brackettedExpression_return retval = new XSPARQLRewriter.brackettedExpression_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree l=null;
        CommonTree r=null;
        XSPARQLRewriter.expression_return expression694 = null;


        CommonTree l_tree=null;
        CommonTree r_tree=null;
        RewriteRuleNodeStream stream_RPAR=new RewriteRuleNodeStream(adaptor,"token RPAR");
        RewriteRuleNodeStream stream_LPAR=new RewriteRuleNodeStream(adaptor,"token LPAR");
        RewriteRuleSubtreeStream stream_expression=new RewriteRuleSubtreeStream(adaptor,"rule expression");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2846:3: (l= LPAR expression r= RPAR -> QSTRING[$l.token, $l.text] expression QSTRING[$r.token, $r.text] )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2846:5: l= LPAR expression r= RPAR
            {
            _last = (CommonTree)input.LT(1);
            l=(CommonTree)match(input,LPAR,FOLLOW_LPAR_in_brackettedExpression17176); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_LPAR.add(l);

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_expression_in_brackettedExpression17178);
            expression694=expression();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_expression.add(expression694.getTree());
            _last = (CommonTree)input.LT(1);
            r=(CommonTree)match(input,RPAR,FOLLOW_RPAR_in_brackettedExpression17182); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_RPAR.add(r);



            // AST REWRITE
            // elements: expression
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 2847:3: -> QSTRING[$l.token, $l.text] expression QSTRING[$r.token, $r.text]
            {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, l.token, (l!=null?l.getText():null)));
                adaptor.addChild(root_0, stream_expression.nextTree());
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, r.token, (r!=null?r.getText():null)));

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "brackettedExpression"

    public static class builtInCall_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "builtInCall"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2850:1: builtInCall : (s= STR brackettedExpression -> QSTRING[$s.token, $s.text] brackettedExpression | l= LANG brackettedExpression -> QSTRING[$l.token, $l.text] brackettedExpression | lm= LANGMATCHES l1= LPAR e1= expression c= COMMA e2= expression r1= RPAR -> QSTRING[$lm.token, $lm.text] QSTRING[$l1.token, $l1.text] $e1 QSTRING[$c.token, $c.text] $e2 QSTRING[$r1.token, $r1.text] | d= DATATYPE brackettedExpression -> QSTRING[$d.token, $d.text] brackettedExpression | bo= BOUND l2= LPAR v= VAR r2= RPAR -> QSTRING[$bo.token, $bo.text] QSTRING[$l2.token, $l2.text] QSTRING[$v.token, $v.text] QSTRING[$r2.token, $r2.text] | i= ISIRI brackettedExpression -> QSTRING[$i.token, $i.text] brackettedExpression | u= ISURI brackettedExpression -> QSTRING[$u.token, $u.text] brackettedExpression | b= ISBLANK brackettedExpression -> QSTRING[$b.token, $b.text] brackettedExpression | lit= ISLITERAL brackettedExpression -> QSTRING[$lit.token, $lit.text] brackettedExpression | regexExpression );
    public final XSPARQLRewriter.builtInCall_return builtInCall() throws RecognitionException {
        XSPARQLRewriter.builtInCall_return retval = new XSPARQLRewriter.builtInCall_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree s=null;
        CommonTree l=null;
        CommonTree lm=null;
        CommonTree l1=null;
        CommonTree c=null;
        CommonTree r1=null;
        CommonTree d=null;
        CommonTree bo=null;
        CommonTree l2=null;
        CommonTree v=null;
        CommonTree r2=null;
        CommonTree i=null;
        CommonTree u=null;
        CommonTree b=null;
        CommonTree lit=null;
        XSPARQLRewriter.expression_return e1 = null;

        XSPARQLRewriter.expression_return e2 = null;

        XSPARQLRewriter.brackettedExpression_return brackettedExpression695 = null;

        XSPARQLRewriter.brackettedExpression_return brackettedExpression696 = null;

        XSPARQLRewriter.brackettedExpression_return brackettedExpression697 = null;

        XSPARQLRewriter.brackettedExpression_return brackettedExpression698 = null;

        XSPARQLRewriter.brackettedExpression_return brackettedExpression699 = null;

        XSPARQLRewriter.brackettedExpression_return brackettedExpression700 = null;

        XSPARQLRewriter.brackettedExpression_return brackettedExpression701 = null;

        XSPARQLRewriter.regexExpression_return regexExpression702 = null;


        CommonTree s_tree=null;
        CommonTree l_tree=null;
        CommonTree lm_tree=null;
        CommonTree l1_tree=null;
        CommonTree c_tree=null;
        CommonTree r1_tree=null;
        CommonTree d_tree=null;
        CommonTree bo_tree=null;
        CommonTree l2_tree=null;
        CommonTree v_tree=null;
        CommonTree r2_tree=null;
        CommonTree i_tree=null;
        CommonTree u_tree=null;
        CommonTree b_tree=null;
        CommonTree lit_tree=null;
        RewriteRuleNodeStream stream_ISURI=new RewriteRuleNodeStream(adaptor,"token ISURI");
        RewriteRuleNodeStream stream_STR=new RewriteRuleNodeStream(adaptor,"token STR");
        RewriteRuleNodeStream stream_ISLITERAL=new RewriteRuleNodeStream(adaptor,"token ISLITERAL");
        RewriteRuleNodeStream stream_LPAR=new RewriteRuleNodeStream(adaptor,"token LPAR");
        RewriteRuleNodeStream stream_COMMA=new RewriteRuleNodeStream(adaptor,"token COMMA");
        RewriteRuleNodeStream stream_LANGMATCHES=new RewriteRuleNodeStream(adaptor,"token LANGMATCHES");
        RewriteRuleNodeStream stream_RPAR=new RewriteRuleNodeStream(adaptor,"token RPAR");
        RewriteRuleNodeStream stream_DATATYPE=new RewriteRuleNodeStream(adaptor,"token DATATYPE");
        RewriteRuleNodeStream stream_VAR=new RewriteRuleNodeStream(adaptor,"token VAR");
        RewriteRuleNodeStream stream_BOUND=new RewriteRuleNodeStream(adaptor,"token BOUND");
        RewriteRuleNodeStream stream_ISBLANK=new RewriteRuleNodeStream(adaptor,"token ISBLANK");
        RewriteRuleNodeStream stream_LANG=new RewriteRuleNodeStream(adaptor,"token LANG");
        RewriteRuleNodeStream stream_ISIRI=new RewriteRuleNodeStream(adaptor,"token ISIRI");
        RewriteRuleSubtreeStream stream_expression=new RewriteRuleSubtreeStream(adaptor,"rule expression");
        RewriteRuleSubtreeStream stream_brackettedExpression=new RewriteRuleSubtreeStream(adaptor,"rule brackettedExpression");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2851:3: (s= STR brackettedExpression -> QSTRING[$s.token, $s.text] brackettedExpression | l= LANG brackettedExpression -> QSTRING[$l.token, $l.text] brackettedExpression | lm= LANGMATCHES l1= LPAR e1= expression c= COMMA e2= expression r1= RPAR -> QSTRING[$lm.token, $lm.text] QSTRING[$l1.token, $l1.text] $e1 QSTRING[$c.token, $c.text] $e2 QSTRING[$r1.token, $r1.text] | d= DATATYPE brackettedExpression -> QSTRING[$d.token, $d.text] brackettedExpression | bo= BOUND l2= LPAR v= VAR r2= RPAR -> QSTRING[$bo.token, $bo.text] QSTRING[$l2.token, $l2.text] QSTRING[$v.token, $v.text] QSTRING[$r2.token, $r2.text] | i= ISIRI brackettedExpression -> QSTRING[$i.token, $i.text] brackettedExpression | u= ISURI brackettedExpression -> QSTRING[$u.token, $u.text] brackettedExpression | b= ISBLANK brackettedExpression -> QSTRING[$b.token, $b.text] brackettedExpression | lit= ISLITERAL brackettedExpression -> QSTRING[$lit.token, $lit.text] brackettedExpression | regexExpression )
            int alt205=10;
            switch ( input.LA(1) ) {
            case STR:
                {
                alt205=1;
                }
                break;
            case LANG:
                {
                alt205=2;
                }
                break;
            case LANGMATCHES:
                {
                alt205=3;
                }
                break;
            case DATATYPE:
                {
                alt205=4;
                }
                break;
            case BOUND:
                {
                alt205=5;
                }
                break;
            case ISIRI:
                {
                alt205=6;
                }
                break;
            case ISURI:
                {
                alt205=7;
                }
                break;
            case ISBLANK:
                {
                alt205=8;
                }
                break;
            case ISLITERAL:
                {
                alt205=9;
                }
                break;
            case REGEX:
                {
                alt205=10;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 205, 0, input);

                throw nvae;
            }

            switch (alt205) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2851:5: s= STR brackettedExpression
                    {
                    _last = (CommonTree)input.LT(1);
                    s=(CommonTree)match(input,STR,FOLLOW_STR_in_builtInCall17209); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_STR.add(s);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_brackettedExpression_in_builtInCall17211);
                    brackettedExpression695=brackettedExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_brackettedExpression.add(brackettedExpression695.getTree());


                    // AST REWRITE
                    // elements: brackettedExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2852:3: -> QSTRING[$s.token, $s.text] brackettedExpression
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, s.token, (s!=null?s.getText():null)));
                        adaptor.addChild(root_0, stream_brackettedExpression.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2853:5: l= LANG brackettedExpression
                    {
                    _last = (CommonTree)input.LT(1);
                    l=(CommonTree)match(input,LANG,FOLLOW_LANG_in_builtInCall17228); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_LANG.add(l);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_brackettedExpression_in_builtInCall17230);
                    brackettedExpression696=brackettedExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_brackettedExpression.add(brackettedExpression696.getTree());


                    // AST REWRITE
                    // elements: brackettedExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2854:3: -> QSTRING[$l.token, $l.text] brackettedExpression
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, l.token, (l!=null?l.getText():null)));
                        adaptor.addChild(root_0, stream_brackettedExpression.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2855:5: lm= LANGMATCHES l1= LPAR e1= expression c= COMMA e2= expression r1= RPAR
                    {
                    _last = (CommonTree)input.LT(1);
                    lm=(CommonTree)match(input,LANGMATCHES,FOLLOW_LANGMATCHES_in_builtInCall17247); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_LANGMATCHES.add(lm);

                    _last = (CommonTree)input.LT(1);
                    l1=(CommonTree)match(input,LPAR,FOLLOW_LPAR_in_builtInCall17251); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_LPAR.add(l1);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_expression_in_builtInCall17255);
                    e1=expression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_expression.add(e1.getTree());
                    _last = (CommonTree)input.LT(1);
                    c=(CommonTree)match(input,COMMA,FOLLOW_COMMA_in_builtInCall17259); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_COMMA.add(c);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_expression_in_builtInCall17263);
                    e2=expression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_expression.add(e2.getTree());
                    _last = (CommonTree)input.LT(1);
                    r1=(CommonTree)match(input,RPAR,FOLLOW_RPAR_in_builtInCall17267); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_RPAR.add(r1);



                    // AST REWRITE
                    // elements: e2, e1
                    // token labels: 
                    // rule labels: retval, e1, e2
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
                    RewriteRuleSubtreeStream stream_e1=new RewriteRuleSubtreeStream(adaptor,"rule e1",e1!=null?e1.tree:null);
                    RewriteRuleSubtreeStream stream_e2=new RewriteRuleSubtreeStream(adaptor,"rule e2",e2!=null?e2.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2856:3: -> QSTRING[$lm.token, $lm.text] QSTRING[$l1.token, $l1.text] $e1 QSTRING[$c.token, $c.text] $e2 QSTRING[$r1.token, $r1.text]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, lm.token, (lm!=null?lm.getText():null)));
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, l1.token, (l1!=null?l1.getText():null)));
                        adaptor.addChild(root_0, stream_e1.nextTree());
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, c.token, (c!=null?c.getText():null)));
                        adaptor.addChild(root_0, stream_e2.nextTree());
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, r1.token, (r1!=null?r1.getText():null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2857:5: d= DATATYPE brackettedExpression
                    {
                    _last = (CommonTree)input.LT(1);
                    d=(CommonTree)match(input,DATATYPE,FOLLOW_DATATYPE_in_builtInCall17297); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_DATATYPE.add(d);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_brackettedExpression_in_builtInCall17299);
                    brackettedExpression697=brackettedExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_brackettedExpression.add(brackettedExpression697.getTree());


                    // AST REWRITE
                    // elements: brackettedExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2858:3: -> QSTRING[$d.token, $d.text] brackettedExpression
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, d.token, (d!=null?d.getText():null)));
                        adaptor.addChild(root_0, stream_brackettedExpression.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 5 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2859:5: bo= BOUND l2= LPAR v= VAR r2= RPAR
                    {
                    _last = (CommonTree)input.LT(1);
                    bo=(CommonTree)match(input,BOUND,FOLLOW_BOUND_in_builtInCall17316); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_BOUND.add(bo);

                    _last = (CommonTree)input.LT(1);
                    l2=(CommonTree)match(input,LPAR,FOLLOW_LPAR_in_builtInCall17320); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_LPAR.add(l2);

                    _last = (CommonTree)input.LT(1);
                    v=(CommonTree)match(input,VAR,FOLLOW_VAR_in_builtInCall17324); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_VAR.add(v);

                    _last = (CommonTree)input.LT(1);
                    r2=(CommonTree)match(input,RPAR,FOLLOW_RPAR_in_builtInCall17328); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_RPAR.add(r2);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2860:3: -> QSTRING[$bo.token, $bo.text] QSTRING[$l2.token, $l2.text] QSTRING[$v.token, $v.text] QSTRING[$r2.token, $r2.text]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, bo.token, (bo!=null?bo.getText():null)));
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, l2.token, (l2!=null?l2.getText():null)));
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, v.token, (v!=null?v.getText():null)));
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, r2.token, (r2!=null?r2.getText():null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 6 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2861:5: i= ISIRI brackettedExpression
                    {
                    _last = (CommonTree)input.LT(1);
                    i=(CommonTree)match(input,ISIRI,FOLLOW_ISIRI_in_builtInCall17352); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_ISIRI.add(i);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_brackettedExpression_in_builtInCall17354);
                    brackettedExpression698=brackettedExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_brackettedExpression.add(brackettedExpression698.getTree());


                    // AST REWRITE
                    // elements: brackettedExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2862:3: -> QSTRING[$i.token, $i.text] brackettedExpression
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, i.token, (i!=null?i.getText():null)));
                        adaptor.addChild(root_0, stream_brackettedExpression.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 7 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2863:5: u= ISURI brackettedExpression
                    {
                    _last = (CommonTree)input.LT(1);
                    u=(CommonTree)match(input,ISURI,FOLLOW_ISURI_in_builtInCall17371); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_ISURI.add(u);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_brackettedExpression_in_builtInCall17373);
                    brackettedExpression699=brackettedExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_brackettedExpression.add(brackettedExpression699.getTree());


                    // AST REWRITE
                    // elements: brackettedExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2864:3: -> QSTRING[$u.token, $u.text] brackettedExpression
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, u.token, (u!=null?u.getText():null)));
                        adaptor.addChild(root_0, stream_brackettedExpression.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 8 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2865:5: b= ISBLANK brackettedExpression
                    {
                    _last = (CommonTree)input.LT(1);
                    b=(CommonTree)match(input,ISBLANK,FOLLOW_ISBLANK_in_builtInCall17390); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_ISBLANK.add(b);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_brackettedExpression_in_builtInCall17392);
                    brackettedExpression700=brackettedExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_brackettedExpression.add(brackettedExpression700.getTree());


                    // AST REWRITE
                    // elements: brackettedExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2866:3: -> QSTRING[$b.token, $b.text] brackettedExpression
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, b.token, (b!=null?b.getText():null)));
                        adaptor.addChild(root_0, stream_brackettedExpression.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 9 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2867:5: lit= ISLITERAL brackettedExpression
                    {
                    _last = (CommonTree)input.LT(1);
                    lit=(CommonTree)match(input,ISLITERAL,FOLLOW_ISLITERAL_in_builtInCall17409); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_ISLITERAL.add(lit);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_brackettedExpression_in_builtInCall17411);
                    brackettedExpression701=brackettedExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_brackettedExpression.add(brackettedExpression701.getTree());


                    // AST REWRITE
                    // elements: brackettedExpression
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2868:3: -> QSTRING[$lit.token, $lit.text] brackettedExpression
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, lit.token, (lit!=null?lit.getText():null)));
                        adaptor.addChild(root_0, stream_brackettedExpression.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 10 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2869:5: regexExpression
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_regexExpression_in_builtInCall17426);
                    regexExpression702=regexExpression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, regexExpression702.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "builtInCall"

    public static class regexExpression_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "regexExpression"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2872:1: regexExpression : r= REGEX l= LPAR e1= expression c1= COMMA e2= expression (c2= COMMA e3= expression )? r1= RPAR -> QSTRING[$r.token, \" \" + $r.text] QSTRING[$l.token, $l.text] $e1 QSTRING[$c1.token, $c1.text] $e2 ( QSTRING[$c2.token, $c2.text] $e3)? QSTRING[$r1.token, $r1.text] ;
    public final XSPARQLRewriter.regexExpression_return regexExpression() throws RecognitionException {
        XSPARQLRewriter.regexExpression_return retval = new XSPARQLRewriter.regexExpression_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree r=null;
        CommonTree l=null;
        CommonTree c1=null;
        CommonTree c2=null;
        CommonTree r1=null;
        XSPARQLRewriter.expression_return e1 = null;

        XSPARQLRewriter.expression_return e2 = null;

        XSPARQLRewriter.expression_return e3 = null;


        CommonTree r_tree=null;
        CommonTree l_tree=null;
        CommonTree c1_tree=null;
        CommonTree c2_tree=null;
        CommonTree r1_tree=null;
        RewriteRuleNodeStream stream_REGEX=new RewriteRuleNodeStream(adaptor,"token REGEX");
        RewriteRuleNodeStream stream_RPAR=new RewriteRuleNodeStream(adaptor,"token RPAR");
        RewriteRuleNodeStream stream_LPAR=new RewriteRuleNodeStream(adaptor,"token LPAR");
        RewriteRuleNodeStream stream_COMMA=new RewriteRuleNodeStream(adaptor,"token COMMA");
        RewriteRuleSubtreeStream stream_expression=new RewriteRuleSubtreeStream(adaptor,"rule expression");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2873:3: (r= REGEX l= LPAR e1= expression c1= COMMA e2= expression (c2= COMMA e3= expression )? r1= RPAR -> QSTRING[$r.token, \" \" + $r.text] QSTRING[$l.token, $l.text] $e1 QSTRING[$c1.token, $c1.text] $e2 ( QSTRING[$c2.token, $c2.text] $e3)? QSTRING[$r1.token, $r1.text] )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2873:5: r= REGEX l= LPAR e1= expression c1= COMMA e2= expression (c2= COMMA e3= expression )? r1= RPAR
            {
            _last = (CommonTree)input.LT(1);
            r=(CommonTree)match(input,REGEX,FOLLOW_REGEX_in_regexExpression17441); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_REGEX.add(r);

            _last = (CommonTree)input.LT(1);
            l=(CommonTree)match(input,LPAR,FOLLOW_LPAR_in_regexExpression17445); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_LPAR.add(l);

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_expression_in_regexExpression17449);
            e1=expression();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_expression.add(e1.getTree());
            _last = (CommonTree)input.LT(1);
            c1=(CommonTree)match(input,COMMA,FOLLOW_COMMA_in_regexExpression17453); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_COMMA.add(c1);

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_expression_in_regexExpression17457);
            e2=expression();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_expression.add(e2.getTree());
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2873:57: (c2= COMMA e3= expression )?
            int alt206=2;
            switch ( input.LA(1) ) {
                case COMMA:
                    {
                    alt206=1;
                    }
                    break;
            }

            switch (alt206) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2873:58: c2= COMMA e3= expression
                    {
                    _last = (CommonTree)input.LT(1);
                    c2=(CommonTree)match(input,COMMA,FOLLOW_COMMA_in_regexExpression17462); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_COMMA.add(c2);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_expression_in_regexExpression17467);
                    e3=expression();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_expression.add(e3.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }

            _last = (CommonTree)input.LT(1);
            r1=(CommonTree)match(input,RPAR,FOLLOW_RPAR_in_regexExpression17473); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_RPAR.add(r1);



            // AST REWRITE
            // elements: e3, e2, e1
            // token labels: 
            // rule labels: e3, retval, e1, e2
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_e3=new RewriteRuleSubtreeStream(adaptor,"rule e3",e3!=null?e3.tree:null);
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);
            RewriteRuleSubtreeStream stream_e1=new RewriteRuleSubtreeStream(adaptor,"rule e1",e1!=null?e1.tree:null);
            RewriteRuleSubtreeStream stream_e2=new RewriteRuleSubtreeStream(adaptor,"rule e2",e2!=null?e2.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 2874:3: -> QSTRING[$r.token, \" \" + $r.text] QSTRING[$l.token, $l.text] $e1 QSTRING[$c1.token, $c1.text] $e2 ( QSTRING[$c2.token, $c2.text] $e3)? QSTRING[$r1.token, $r1.text]
            {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, r.token, " " + (r!=null?r.getText():null)));
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, l.token, (l!=null?l.getText():null)));
                adaptor.addChild(root_0, stream_e1.nextTree());
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, c1.token, (c1!=null?c1.getText():null)));
                adaptor.addChild(root_0, stream_e2.nextTree());
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2874:103: ( QSTRING[$c2.token, $c2.text] $e3)?
                if ( stream_e3.hasNext() ) {
                    adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, c2.token, (c2!=null?c2.getText():null)));
                    adaptor.addChild(root_0, stream_e3.nextTree());

                }
                stream_e3.reset();
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, r1.token, (r1!=null?r1.getText():null)));

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "regexExpression"

    public static class iRIrefOrFunction_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "iRIrefOrFunction"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2877:1: iRIrefOrFunction : ^( T_FUNCTION_CALL i= iRIref ^( T_PARAMS ( arglist )? ) ) -> QSTRING[$i.text] QSTRING[\"(\"] ( arglist )? QSTRING[\")\"] ;
    public final XSPARQLRewriter.iRIrefOrFunction_return iRIrefOrFunction() throws RecognitionException {
        XSPARQLRewriter.iRIrefOrFunction_return retval = new XSPARQLRewriter.iRIrefOrFunction_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_FUNCTION_CALL703=null;
        CommonTree T_PARAMS704=null;
        XSPARQLRewriter.iRIref_return i = null;

        XSPARQLRewriter.arglist_return arglist705 = null;


        CommonTree T_FUNCTION_CALL703_tree=null;
        CommonTree T_PARAMS704_tree=null;
        RewriteRuleNodeStream stream_T_FUNCTION_CALL=new RewriteRuleNodeStream(adaptor,"token T_FUNCTION_CALL");
        RewriteRuleNodeStream stream_T_PARAMS=new RewriteRuleNodeStream(adaptor,"token T_PARAMS");
        RewriteRuleSubtreeStream stream_arglist=new RewriteRuleSubtreeStream(adaptor,"rule arglist");
        RewriteRuleSubtreeStream stream_iRIref=new RewriteRuleSubtreeStream(adaptor,"rule iRIref");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2878:3: ( ^( T_FUNCTION_CALL i= iRIref ^( T_PARAMS ( arglist )? ) ) -> QSTRING[$i.text] QSTRING[\"(\"] ( arglist )? QSTRING[\")\"] )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2878:5: ^( T_FUNCTION_CALL i= iRIref ^( T_PARAMS ( arglist )? ) )
            {
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_1 = _last;
            CommonTree _first_1 = null;
            CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_FUNCTION_CALL703=(CommonTree)match(input,T_FUNCTION_CALL,FOLLOW_T_FUNCTION_CALL_in_iRIrefOrFunction17520); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_T_FUNCTION_CALL.add(T_FUNCTION_CALL703);



            match(input, Token.DOWN, null); if (state.failed) return retval;
            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_iRIref_in_iRIrefOrFunction17524);
            i=iRIref();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) stream_iRIref.add(i.getTree());
            _last = (CommonTree)input.LT(1);
            {
            CommonTree _save_last_2 = _last;
            CommonTree _first_2 = null;
            CommonTree root_2 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            T_PARAMS704=(CommonTree)match(input,T_PARAMS,FOLLOW_T_PARAMS_in_iRIrefOrFunction17527); if (state.failed) return retval; 
            if ( state.backtracking==0 ) stream_T_PARAMS.add(T_PARAMS704);



            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); if (state.failed) return retval;
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2878:43: ( arglist )?
                int alt207=2;
                switch ( input.LA(1) ) {
                    case VAR:
                    case INTEGER:
                    case QSTRING:
                    case SLASH:
                    case LPAR:
                    case STAR:
                    case LESSTHAN:
                    case GREATERTHAN:
                    case PLUS:
                    case MINUS:
                    case GREATERTHANEQUALS:
                    case LESSTHANEQUALS:
                    case HAFENEQUALS:
                    case EQUALS:
                    case ORSYMBOL:
                    case ANDSYMBOL:
                    case NOT:
                    case STR:
                    case LANG:
                    case LANGMATCHES:
                    case DATATYPE:
                    case BOUND:
                    case ISIRI:
                    case ISURI:
                    case ISBLANK:
                    case ISLITERAL:
                    case REGEX:
                    case TRUE:
                    case FALSE:
                    case T_FUNCTION_CALL:
                        {
                        alt207=1;
                        }
                        break;
                }

                switch (alt207) {
                    case 1 :
                        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:0:0: arglist
                        {
                        _last = (CommonTree)input.LT(1);
                        pushFollow(FOLLOW_arglist_in_iRIrefOrFunction17529);
                        arglist705=arglist();

                        state._fsp--;
                        if (state.failed) return retval;
                        if ( state.backtracking==0 ) stream_arglist.add(arglist705.getTree());

                        if ( state.backtracking==0 ) {
                        }
                        }
                        break;

                }


                match(input, Token.UP, null); if (state.failed) return retval;
            }adaptor.addChild(root_1, root_2);_last = _save_last_2;
            }


            match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            }



            // AST REWRITE
            // elements: arglist
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            if ( state.backtracking==0 ) {
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 2878:54: -> QSTRING[$i.text] QSTRING[\"(\"] ( arglist )? QSTRING[\")\"]
            {
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, (i!=null?(input.getTokenStream().toString(
                  input.getTreeAdaptor().getTokenStartIndex(i.start),
                  input.getTreeAdaptor().getTokenStopIndex(i.start))):null)));
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, "("));
                // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2878:87: ( arglist )?
                if ( stream_arglist.hasNext() ) {
                    adaptor.addChild(root_0, stream_arglist.nextTree());

                }
                stream_arglist.reset();
                adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, ")"));

            }

            retval.tree = root_0;}
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "iRIrefOrFunction"

    public static class rdfLiteral_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "rdfLiteral"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2881:1: rdfLiteral : (q= QSTRING -> QSTRING[$q.token, \"\\\"\\\"\"+$q.text+\"\\\"\\\"\"] | q= QSTRING AT qname -> QSTRING[$q.token, \"\\\"\\\"\"+$q.text+\"\\\"\\\"\"] AT qname | q= QSTRING c1= CARET c2= CARET (o= IRIREF | o= PNAME_LN ) -> QSTRING[$q.token, \"\\\"\\\"\"+$q.text+\"\\\"\\\"\"] QSTRING[$c1.token, \"^^\"] QSTRING[$o.token, $o.text] );
    public final XSPARQLRewriter.rdfLiteral_return rdfLiteral() throws RecognitionException {
        XSPARQLRewriter.rdfLiteral_return retval = new XSPARQLRewriter.rdfLiteral_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree q=null;
        CommonTree c1=null;
        CommonTree c2=null;
        CommonTree o=null;
        CommonTree AT706=null;
        XSPARQLRewriter.qname_return qname707 = null;


        CommonTree q_tree=null;
        CommonTree c1_tree=null;
        CommonTree c2_tree=null;
        CommonTree o_tree=null;
        CommonTree AT706_tree=null;
        RewriteRuleNodeStream stream_AT=new RewriteRuleNodeStream(adaptor,"token AT");
        RewriteRuleNodeStream stream_PNAME_LN=new RewriteRuleNodeStream(adaptor,"token PNAME_LN");
        RewriteRuleNodeStream stream_QSTRING=new RewriteRuleNodeStream(adaptor,"token QSTRING");
        RewriteRuleNodeStream stream_IRIREF=new RewriteRuleNodeStream(adaptor,"token IRIREF");
        RewriteRuleNodeStream stream_CARET=new RewriteRuleNodeStream(adaptor,"token CARET");
        RewriteRuleSubtreeStream stream_qname=new RewriteRuleSubtreeStream(adaptor,"rule qname");
        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2882:3: (q= QSTRING -> QSTRING[$q.token, \"\\\"\\\"\"+$q.text+\"\\\"\\\"\"] | q= QSTRING AT qname -> QSTRING[$q.token, \"\\\"\\\"\"+$q.text+\"\\\"\\\"\"] AT qname | q= QSTRING c1= CARET c2= CARET (o= IRIREF | o= PNAME_LN ) -> QSTRING[$q.token, \"\\\"\\\"\"+$q.text+\"\\\"\\\"\"] QSTRING[$c1.token, \"^^\"] QSTRING[$o.token, $o.text] )
            int alt209=3;
            switch ( input.LA(1) ) {
            case QSTRING:
                {
                switch ( input.LA(2) ) {
                case AT:
                    {
                    alt209=2;
                    }
                    break;
                case CARET:
                    {
                    alt209=3;
                    }
                    break;
                case EOF:
                case UP:
                case VAR:
                case INTEGER:
                case QSTRING:
                case COMMA:
                case SLASH:
                case LPAR:
                case RPAR:
                case STAR:
                case LESSTHAN:
                case GREATERTHAN:
                case PLUS:
                case MINUS:
                case GREATERTHANEQUALS:
                case LESSTHANEQUALS:
                case HAFENEQUALS:
                case EQUALS:
                case PNAME_NS:
                case PNAME_LN:
                case ORSYMBOL:
                case ANDSYMBOL:
                case NOT:
                case IRIREF:
                case STR:
                case LANG:
                case LANGMATCHES:
                case DATATYPE:
                case BOUND:
                case ISIRI:
                case ISURI:
                case ISBLANK:
                case ISLITERAL:
                case REGEX:
                case TRUE:
                case FALSE:
                case T_ANON_BLANK:
                case T_FUNCTION_CALL:
                case T_IRI_CONSTRUCT:
                    {
                    alt209=1;
                    }
                    break;
                default:
                    if (state.backtracking>0) {state.failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 209, 1, input);

                    throw nvae;
                }

                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 209, 0, input);

                throw nvae;
            }

            switch (alt209) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2882:5: q= QSTRING
                    {
                    _last = (CommonTree)input.LT(1);
                    q=(CommonTree)match(input,QSTRING,FOLLOW_QSTRING_in_rdfLiteral17561); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_QSTRING.add(q);



                    // AST REWRITE
                    // elements: QSTRING
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2882:15: -> QSTRING[$q.token, \"\\\"\\\"\"+$q.text+\"\\\"\\\"\"]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, q.token, "\"\""+(q!=null?q.getText():null)+"\"\""));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2883:5: q= QSTRING AT qname
                    {
                    _last = (CommonTree)input.LT(1);
                    q=(CommonTree)match(input,QSTRING,FOLLOW_QSTRING_in_rdfLiteral17574); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_QSTRING.add(q);

                    _last = (CommonTree)input.LT(1);
                    AT706=(CommonTree)match(input,AT,FOLLOW_AT_in_rdfLiteral17576); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_AT.add(AT706);

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_qname_in_rdfLiteral17578);
                    qname707=qname();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) stream_qname.add(qname707.getTree());


                    // AST REWRITE
                    // elements: qname, QSTRING, AT
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2883:24: -> QSTRING[$q.token, \"\\\"\\\"\"+$q.text+\"\\\"\\\"\"] AT qname
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, q.token, "\"\""+(q!=null?q.getText():null)+"\"\""));
                        adaptor.addChild(root_0, stream_AT.nextNode());
                        adaptor.addChild(root_0, stream_qname.nextTree());

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2884:5: q= QSTRING c1= CARET c2= CARET (o= IRIREF | o= PNAME_LN )
                    {
                    _last = (CommonTree)input.LT(1);
                    q=(CommonTree)match(input,QSTRING,FOLLOW_QSTRING_in_rdfLiteral17595); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_QSTRING.add(q);

                    _last = (CommonTree)input.LT(1);
                    c1=(CommonTree)match(input,CARET,FOLLOW_CARET_in_rdfLiteral17599); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_CARET.add(c1);

                    _last = (CommonTree)input.LT(1);
                    c2=(CommonTree)match(input,CARET,FOLLOW_CARET_in_rdfLiteral17603); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_CARET.add(c2);

                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2884:33: (o= IRIREF | o= PNAME_LN )
                    int alt208=2;
                    switch ( input.LA(1) ) {
                    case IRIREF:
                        {
                        alt208=1;
                        }
                        break;
                    case PNAME_LN:
                        {
                        alt208=2;
                        }
                        break;
                    default:
                        if (state.backtracking>0) {state.failed=true; return retval;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 208, 0, input);

                        throw nvae;
                    }

                    switch (alt208) {
                        case 1 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2884:35: o= IRIREF
                            {
                            _last = (CommonTree)input.LT(1);
                            o=(CommonTree)match(input,IRIREF,FOLLOW_IRIREF_in_rdfLiteral17609); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_IRIREF.add(o);


                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;
                        case 2 :
                            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2884:47: o= PNAME_LN
                            {
                            _last = (CommonTree)input.LT(1);
                            o=(CommonTree)match(input,PNAME_LN,FOLLOW_PNAME_LN_in_rdfLiteral17616); if (state.failed) return retval; 
                            if ( state.backtracking==0 ) stream_PNAME_LN.add(o);


                            if ( state.backtracking==0 ) {
                            }
                            }
                            break;

                    }



                    // AST REWRITE
                    // elements: QSTRING, QSTRING, QSTRING
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2885:3: -> QSTRING[$q.token, \"\\\"\\\"\"+$q.text+\"\\\"\\\"\"] QSTRING[$c1.token, \"^^\"] QSTRING[$o.token, $o.text]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, q.token, "\"\""+(q!=null?q.getText():null)+"\"\""));
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, c1.token, "^^"));
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, o.token, (o!=null?o.getText():null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "rdfLiteral"

    public static class sNumericLiteral_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "sNumericLiteral"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2888:1: sNumericLiteral : INTEGER ;
    public final XSPARQLRewriter.sNumericLiteral_return sNumericLiteral() throws RecognitionException {
        XSPARQLRewriter.sNumericLiteral_return retval = new XSPARQLRewriter.sNumericLiteral_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree INTEGER708=null;

        CommonTree INTEGER708_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2889:3: ( INTEGER )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2889:5: INTEGER
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            INTEGER708=(CommonTree)match(input,INTEGER,FOLLOW_INTEGER_in_sNumericLiteral17645); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            INTEGER708_tree = (CommonTree)adaptor.dupNode(INTEGER708);

            adaptor.addChild(root_0, INTEGER708_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "sNumericLiteral"

    public static class booleanLiteral_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "booleanLiteral"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2892:1: booleanLiteral : (t= TRUE -> QSTRING[$t.token, $t.text] | f= FALSE -> QSTRING[$f.token, $f.text] );
    public final XSPARQLRewriter.booleanLiteral_return booleanLiteral() throws RecognitionException {
        XSPARQLRewriter.booleanLiteral_return retval = new XSPARQLRewriter.booleanLiteral_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree t=null;
        CommonTree f=null;

        CommonTree t_tree=null;
        CommonTree f_tree=null;
        RewriteRuleNodeStream stream_FALSE=new RewriteRuleNodeStream(adaptor,"token FALSE");
        RewriteRuleNodeStream stream_TRUE=new RewriteRuleNodeStream(adaptor,"token TRUE");

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2893:3: (t= TRUE -> QSTRING[$t.token, $t.text] | f= FALSE -> QSTRING[$f.token, $f.text] )
            int alt210=2;
            switch ( input.LA(1) ) {
            case TRUE:
                {
                alt210=1;
                }
                break;
            case FALSE:
                {
                alt210=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 210, 0, input);

                throw nvae;
            }

            switch (alt210) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2893:5: t= TRUE
                    {
                    _last = (CommonTree)input.LT(1);
                    t=(CommonTree)match(input,TRUE,FOLLOW_TRUE_in_booleanLiteral17660); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_TRUE.add(t);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2893:12: -> QSTRING[$t.token, $t.text]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, t.token, (t!=null?t.getText():null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2894:5: f= FALSE
                    {
                    _last = (CommonTree)input.LT(1);
                    f=(CommonTree)match(input,FALSE,FOLLOW_FALSE_in_booleanLiteral17673); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_FALSE.add(f);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2894:13: -> QSTRING[$f.token, $f.text]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, f.token, (f!=null?f.getText():null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "booleanLiteral"

    public static class string_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "string"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2903:1: string : QSTRING ;
    public final XSPARQLRewriter.string_return string() throws RecognitionException {
        XSPARQLRewriter.string_return retval = new XSPARQLRewriter.string_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree QSTRING709=null;

        CommonTree QSTRING709_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2904:3: ( QSTRING )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2904:5: QSTRING
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            QSTRING709=(CommonTree)match(input,QSTRING,FOLLOW_QSTRING_in_string17697); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            QSTRING709_tree = (CommonTree)adaptor.dupNode(QSTRING709);

            adaptor.addChild(root_0, QSTRING709_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "string"

    public static class iRIref_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "iRIref"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2908:1: iRIref : ( IRIREF | prefixedName );
    public final XSPARQLRewriter.iRIref_return iRIref() throws RecognitionException {
        XSPARQLRewriter.iRIref_return retval = new XSPARQLRewriter.iRIref_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree IRIREF710=null;
        XSPARQLRewriter.prefixedName_return prefixedName711 = null;


        CommonTree IRIREF710_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2909:3: ( IRIREF | prefixedName )
            int alt211=2;
            switch ( input.LA(1) ) {
            case IRIREF:
                {
                alt211=1;
                }
                break;
            case PNAME_NS:
            case PNAME_LN:
                {
                alt211=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 211, 0, input);

                throw nvae;
            }

            switch (alt211) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2909:5: IRIREF
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    IRIREF710=(CommonTree)match(input,IRIREF,FOLLOW_IRIREF_in_iRIref17712); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    IRIREF710_tree = (CommonTree)adaptor.dupNode(IRIREF710);

                    adaptor.addChild(root_0, IRIREF710_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2910:5: prefixedName
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_prefixedName_in_iRIref17718);
                    prefixedName711=prefixedName();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, prefixedName711.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "iRIref"

    public static class prefixedName_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "prefixedName"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2913:1: prefixedName : ( PNAME_LN | PNAME_NS );
    public final XSPARQLRewriter.prefixedName_return prefixedName() throws RecognitionException {
        XSPARQLRewriter.prefixedName_return retval = new XSPARQLRewriter.prefixedName_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree set712=null;

        CommonTree set712_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2914:3: ( PNAME_LN | PNAME_NS )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            set712=(CommonTree)input.LT(1);
            if ( (input.LA(1)>=PNAME_NS && input.LA(1)<=PNAME_LN) ) {
                input.consume();

                if ( state.backtracking==0 ) {
                set712_tree = (CommonTree)adaptor.dupNode(set712);

                adaptor.addChild(root_0, set712_tree);
                }
                state.errorRecovery=false;state.failed=false;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return retval;}
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }

            if ( state.backtracking==0 ) {
            } 

            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "prefixedName"

    public static class blank_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "blank"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2918:1: blank : ( bnode | T_EMPTY_ANON_BLANK -> QSTRING[\"[]\"] );
    public final XSPARQLRewriter.blank_return blank() throws RecognitionException {
        XSPARQLRewriter.blank_return retval = new XSPARQLRewriter.blank_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_EMPTY_ANON_BLANK714=null;
        XSPARQLRewriter.bnode_return bnode713 = null;


        CommonTree T_EMPTY_ANON_BLANK714_tree=null;
        RewriteRuleNodeStream stream_T_EMPTY_ANON_BLANK=new RewriteRuleNodeStream(adaptor,"token T_EMPTY_ANON_BLANK");

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2919:3: ( bnode | T_EMPTY_ANON_BLANK -> QSTRING[\"[]\"] )
            int alt212=2;
            switch ( input.LA(1) ) {
            case BLANK_NODE_LABEL:
                {
                alt212=1;
                }
                break;
            case T_EMPTY_ANON_BLANK:
                {
                alt212=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 212, 0, input);

                throw nvae;
            }

            switch (alt212) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2919:5: bnode
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_bnode_in_blank17750);
                    bnode713=bnode();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, bnode713.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2920:5: T_EMPTY_ANON_BLANK
                    {
                    _last = (CommonTree)input.LT(1);
                    T_EMPTY_ANON_BLANK714=(CommonTree)match(input,T_EMPTY_ANON_BLANK,FOLLOW_T_EMPTY_ANON_BLANK_in_blank17756); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_T_EMPTY_ANON_BLANK.add(T_EMPTY_ANON_BLANK714);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2921:3: -> QSTRING[\"[]\"]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, "[]"));

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "blank"

    public static class predicateObjectList_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "predicateObjectList"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2937:1: predicateObjectList : ( ^( T_VERB verb objectList ) )+ ;
    public final XSPARQLRewriter.predicateObjectList_return predicateObjectList() throws RecognitionException {
        XSPARQLRewriter.predicateObjectList_return retval = new XSPARQLRewriter.predicateObjectList_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree T_VERB715=null;
        XSPARQLRewriter.verb_return verb716 = null;

        XSPARQLRewriter.objectList_return objectList717 = null;


        CommonTree T_VERB715_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2938:3: ( ( ^( T_VERB verb objectList ) )+ )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2938:5: ( ^( T_VERB verb objectList ) )+
            {
            root_0 = (CommonTree)adaptor.nil();

            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2938:5: ( ^( T_VERB verb objectList ) )+
            int cnt213=0;
            loop213:
            do {
                int alt213=2;
                switch ( input.LA(1) ) {
                case T_VERB:
                    {
                    alt213=1;
                    }
                    break;

                }

                switch (alt213) {
            	case 1 :
            	    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2938:6: ^( T_VERB verb objectList )
            	    {
            	    _last = (CommonTree)input.LT(1);
            	    {
            	    CommonTree _save_last_1 = _last;
            	    CommonTree _first_1 = null;
            	    CommonTree root_1 = (CommonTree)adaptor.nil();_last = (CommonTree)input.LT(1);
            	    T_VERB715=(CommonTree)match(input,T_VERB,FOLLOW_T_VERB_in_predicateObjectList17791); if (state.failed) return retval;
            	    if ( state.backtracking==0 ) {
            	    T_VERB715_tree = (CommonTree)adaptor.dupNode(T_VERB715);

            	    root_1 = (CommonTree)adaptor.becomeRoot(T_VERB715_tree, root_1);
            	    }


            	    match(input, Token.DOWN, null); if (state.failed) return retval;
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_verb_in_predicateObjectList17793);
            	    verb716=verb();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) 
            	    adaptor.addChild(root_1, verb716.getTree());
            	    _last = (CommonTree)input.LT(1);
            	    pushFollow(FOLLOW_objectList_in_predicateObjectList17795);
            	    objectList717=objectList();

            	    state._fsp--;
            	    if (state.failed) return retval;
            	    if ( state.backtracking==0 ) 
            	    adaptor.addChild(root_1, objectList717.getTree());

            	    match(input, Token.UP, null); if (state.failed) return retval;adaptor.addChild(root_0, root_1);_last = _save_last_1;
            	    }


            	    if ( state.backtracking==0 ) {
            	    }
            	    }
            	    break;

            	default :
            	    if ( cnt213 >= 1 ) break loop213;
            	    if (state.backtracking>0) {state.failed=true; return retval;}
                        EarlyExitException eee =
                            new EarlyExitException(213, input);
                        throw eee;
                }
                cnt213++;
            } while (true);


            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "predicateObjectList"

    public static class iri_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "iri"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2941:1: iri : (p= PNAME_LN -> QSTRING[$p.text] | i= IRIREF -> QSTRING[$i.text] | iriConstruct );
    public final XSPARQLRewriter.iri_return iri() throws RecognitionException {
        XSPARQLRewriter.iri_return retval = new XSPARQLRewriter.iri_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree p=null;
        CommonTree i=null;
        XSPARQLRewriter.iriConstruct_return iriConstruct718 = null;


        CommonTree p_tree=null;
        CommonTree i_tree=null;
        RewriteRuleNodeStream stream_PNAME_LN=new RewriteRuleNodeStream(adaptor,"token PNAME_LN");
        RewriteRuleNodeStream stream_IRIREF=new RewriteRuleNodeStream(adaptor,"token IRIREF");

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2942:3: (p= PNAME_LN -> QSTRING[$p.text] | i= IRIREF -> QSTRING[$i.text] | iriConstruct )
            int alt214=3;
            switch ( input.LA(1) ) {
            case PNAME_LN:
                {
                alt214=1;
                }
                break;
            case IRIREF:
                {
                alt214=2;
                }
                break;
            case T_IRI_CONSTRUCT:
                {
                alt214=3;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 214, 0, input);

                throw nvae;
            }

            switch (alt214) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2942:6: p= PNAME_LN
                    {
                    _last = (CommonTree)input.LT(1);
                    p=(CommonTree)match(input,PNAME_LN,FOLLOW_PNAME_LN_in_iri17814); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_PNAME_LN.add(p);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2942:18: -> QSTRING[$p.text]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, (p!=null?p.getText():null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2943:6: i= IRIREF
                    {
                    _last = (CommonTree)input.LT(1);
                    i=(CommonTree)match(input,IRIREF,FOLLOW_IRIREF_in_iri17829); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_IRIREF.add(i);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2943:18: -> QSTRING[$i.text]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, (i!=null?i.getText():null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2944:6: iriConstruct
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_iriConstruct_in_iri17844);
                    iriConstruct718=iriConstruct();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, iriConstruct718.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "iri"

    public static class resource__return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "resource_"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2947:1: resource_ : ( sparqlPrefixedName | VAR | IRIREF );
    public final XSPARQLRewriter.resource__return resource_() throws RecognitionException {
        XSPARQLRewriter.resource__return retval = new XSPARQLRewriter.resource__return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree VAR720=null;
        CommonTree IRIREF721=null;
        XSPARQLRewriter.sparqlPrefixedName_return sparqlPrefixedName719 = null;


        CommonTree VAR720_tree=null;
        CommonTree IRIREF721_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2948:3: ( sparqlPrefixedName | VAR | IRIREF )
            int alt215=3;
            switch ( input.LA(1) ) {
            case PNAME_NS:
            case PNAME_LN:
                {
                alt215=1;
                }
                break;
            case VAR:
                {
                alt215=2;
                }
                break;
            case IRIREF:
                {
                alt215=3;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 215, 0, input);

                throw nvae;
            }

            switch (alt215) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2948:5: sparqlPrefixedName
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_sparqlPrefixedName_in_resource_17857);
                    sparqlPrefixedName719=sparqlPrefixedName();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, sparqlPrefixedName719.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2949:5: VAR
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    VAR720=(CommonTree)match(input,VAR,FOLLOW_VAR_in_resource_17863); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    VAR720_tree = (CommonTree)adaptor.dupNode(VAR720);

                    adaptor.addChild(root_0, VAR720_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2950:5: IRIREF
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    IRIREF721=(CommonTree)match(input,IRIREF,FOLLOW_IRIREF_in_resource_17869); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    IRIREF721_tree = (CommonTree)adaptor.dupNode(IRIREF721);

                    adaptor.addChild(root_0, IRIREF721_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "resource_"

    public static class rdfPredicate__return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "rdfPredicate_"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2953:1: rdfPredicate_ : resource_ ;
    public final XSPARQLRewriter.rdfPredicate__return rdfPredicate_() throws RecognitionException {
        XSPARQLRewriter.rdfPredicate__return retval = new XSPARQLRewriter.rdfPredicate__return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.resource__return resource_722 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2954:3: ( resource_ )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2954:5: resource_
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_resource__in_rdfPredicate_17882);
            resource_722=resource_();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, resource_722.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "rdfPredicate_"

    public static class bnode_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "bnode"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2957:1: bnode : BLANK_NODE_LABEL ;
    public final XSPARQLRewriter.bnode_return bnode() throws RecognitionException {
        XSPARQLRewriter.bnode_return retval = new XSPARQLRewriter.bnode_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree BLANK_NODE_LABEL723=null;

        CommonTree BLANK_NODE_LABEL723_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2958:3: ( BLANK_NODE_LABEL )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2958:5: BLANK_NODE_LABEL
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            BLANK_NODE_LABEL723=(CommonTree)match(input,BLANK_NODE_LABEL,FOLLOW_BLANK_NODE_LABEL_in_bnode17895); if (state.failed) return retval;
            if ( state.backtracking==0 ) {
            BLANK_NODE_LABEL723_tree = (CommonTree)adaptor.dupNode(BLANK_NODE_LABEL723);

            adaptor.addChild(root_0, BLANK_NODE_LABEL723_tree);
            }

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "bnode"

    public static class sparqlPrefixedName_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "sparqlPrefixedName"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2961:1: sparqlPrefixedName : (p= PNAME_LN -> QSTRING[$p.token, $p.text] | p= PNAME_NS -> QSTRING[$p.token, $p.text] );
    public final XSPARQLRewriter.sparqlPrefixedName_return sparqlPrefixedName() throws RecognitionException {
        XSPARQLRewriter.sparqlPrefixedName_return retval = new XSPARQLRewriter.sparqlPrefixedName_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree p=null;

        CommonTree p_tree=null;
        RewriteRuleNodeStream stream_PNAME_NS=new RewriteRuleNodeStream(adaptor,"token PNAME_NS");
        RewriteRuleNodeStream stream_PNAME_LN=new RewriteRuleNodeStream(adaptor,"token PNAME_LN");

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2962:3: (p= PNAME_LN -> QSTRING[$p.token, $p.text] | p= PNAME_NS -> QSTRING[$p.token, $p.text] )
            int alt216=2;
            switch ( input.LA(1) ) {
            case PNAME_LN:
                {
                alt216=1;
                }
                break;
            case PNAME_NS:
                {
                alt216=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 216, 0, input);

                throw nvae;
            }

            switch (alt216) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2962:5: p= PNAME_LN
                    {
                    _last = (CommonTree)input.LT(1);
                    p=(CommonTree)match(input,PNAME_LN,FOLLOW_PNAME_LN_in_sparqlPrefixedName17910); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_PNAME_LN.add(p);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2962:17: -> QSTRING[$p.token, $p.text]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, p.token, (p!=null?p.getText():null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2963:5: p= PNAME_NS
                    {
                    _last = (CommonTree)input.LT(1);
                    p=(CommonTree)match(input,PNAME_NS,FOLLOW_PNAME_NS_in_sparqlPrefixedName17924); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_PNAME_NS.add(p);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2963:17: -> QSTRING[$p.token, $p.text]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(QSTRING, p.token, (p!=null?p.getText():null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "sparqlPrefixedName"

    public static class qname_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "qname"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2967:1: qname : ( prefixedName | unprefixedName );
    public final XSPARQLRewriter.qname_return qname() throws RecognitionException {
        XSPARQLRewriter.qname_return retval = new XSPARQLRewriter.qname_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.prefixedName_return prefixedName724 = null;

        XSPARQLRewriter.unprefixedName_return unprefixedName725 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2968:3: ( prefixedName | unprefixedName )
            int alt217=2;
            switch ( input.LA(1) ) {
            case PNAME_NS:
            case PNAME_LN:
                {
                alt217=1;
                }
                break;
            case NCNAME:
            case A:
            case FROM:
            case TO:
            case ITEM:
            case COMMENT:
            case ROW:
                {
                alt217=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 217, 0, input);

                throw nvae;
            }

            switch (alt217) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2968:5: prefixedName
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_prefixedName_in_qname17944);
                    prefixedName724=prefixedName();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, prefixedName724.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2969:5: unprefixedName
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_unprefixedName_in_qname17950);
                    unprefixedName725=unprefixedName();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, unprefixedName725.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "qname"

    public static class keyword_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "keyword"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2972:1: keyword : ( ITEM | TO | FROM | r= ROW -> NCNAME[$r.text] | c= COMMENT -> NCNAME[$c.text] | A );
    public final XSPARQLRewriter.keyword_return keyword() throws RecognitionException {
        XSPARQLRewriter.keyword_return retval = new XSPARQLRewriter.keyword_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree r=null;
        CommonTree c=null;
        CommonTree ITEM726=null;
        CommonTree TO727=null;
        CommonTree FROM728=null;
        CommonTree A729=null;

        CommonTree r_tree=null;
        CommonTree c_tree=null;
        CommonTree ITEM726_tree=null;
        CommonTree TO727_tree=null;
        CommonTree FROM728_tree=null;
        CommonTree A729_tree=null;
        RewriteRuleNodeStream stream_COMMENT=new RewriteRuleNodeStream(adaptor,"token COMMENT");
        RewriteRuleNodeStream stream_ROW=new RewriteRuleNodeStream(adaptor,"token ROW");

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2973:3: ( ITEM | TO | FROM | r= ROW -> NCNAME[$r.text] | c= COMMENT -> NCNAME[$c.text] | A )
            int alt218=6;
            switch ( input.LA(1) ) {
            case ITEM:
                {
                alt218=1;
                }
                break;
            case TO:
                {
                alt218=2;
                }
                break;
            case FROM:
                {
                alt218=3;
                }
                break;
            case ROW:
                {
                alt218=4;
                }
                break;
            case COMMENT:
                {
                alt218=5;
                }
                break;
            case A:
                {
                alt218=6;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 218, 0, input);

                throw nvae;
            }

            switch (alt218) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2973:5: ITEM
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    ITEM726=(CommonTree)match(input,ITEM,FOLLOW_ITEM_in_keyword17963); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    ITEM726_tree = (CommonTree)adaptor.dupNode(ITEM726);

                    adaptor.addChild(root_0, ITEM726_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2974:5: TO
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    TO727=(CommonTree)match(input,TO,FOLLOW_TO_in_keyword17969); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    TO727_tree = (CommonTree)adaptor.dupNode(TO727);

                    adaptor.addChild(root_0, TO727_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 3 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2975:5: FROM
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    FROM728=(CommonTree)match(input,FROM,FOLLOW_FROM_in_keyword17975); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    FROM728_tree = (CommonTree)adaptor.dupNode(FROM728);

                    adaptor.addChild(root_0, FROM728_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 4 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2976:5: r= ROW
                    {
                    _last = (CommonTree)input.LT(1);
                    r=(CommonTree)match(input,ROW,FOLLOW_ROW_in_keyword17983); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_ROW.add(r);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2976:11: -> NCNAME[$r.text]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(NCNAME, (r!=null?r.getText():null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 5 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2977:5: c= COMMENT
                    {
                    _last = (CommonTree)input.LT(1);
                    c=(CommonTree)match(input,COMMENT,FOLLOW_COMMENT_in_keyword17996); if (state.failed) return retval; 
                    if ( state.backtracking==0 ) stream_COMMENT.add(c);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    if ( state.backtracking==0 ) {
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 2977:15: -> NCNAME[$c.text]
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(NCNAME, (c!=null?c.getText():null)));

                    }

                    retval.tree = root_0;}
                    }
                    break;
                case 6 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2978:5: A
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    A729=(CommonTree)match(input,A,FOLLOW_A_in_keyword18007); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    A729_tree = (CommonTree)adaptor.dupNode(A729);

                    adaptor.addChild(root_0, A729_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "keyword"

    public static class unprefixedName_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "unprefixedName"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2980:1: unprefixedName : localPart ;
    public final XSPARQLRewriter.unprefixedName_return unprefixedName() throws RecognitionException {
        XSPARQLRewriter.unprefixedName_return retval = new XSPARQLRewriter.unprefixedName_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        XSPARQLRewriter.localPart_return localPart730 = null;



        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2981:3: ( localPart )
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2981:5: localPart
            {
            root_0 = (CommonTree)adaptor.nil();

            _last = (CommonTree)input.LT(1);
            pushFollow(FOLLOW_localPart_in_unprefixedName18018);
            localPart730=localPart();

            state._fsp--;
            if (state.failed) return retval;
            if ( state.backtracking==0 ) 
            adaptor.addChild(root_0, localPart730.getTree());

            if ( state.backtracking==0 ) {
            }
            }

            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "unprefixedName"

    public static class localPart_return extends TreeRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "localPart"
    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2984:1: localPart : ( NCNAME | keyword );
    public final XSPARQLRewriter.localPart_return localPart() throws RecognitionException {
        XSPARQLRewriter.localPart_return retval = new XSPARQLRewriter.localPart_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        CommonTree _first_0 = null;
        CommonTree _last = null;

        CommonTree NCNAME731=null;
        XSPARQLRewriter.keyword_return keyword732 = null;


        CommonTree NCNAME731_tree=null;

        try {
            // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2985:3: ( NCNAME | keyword )
            int alt219=2;
            switch ( input.LA(1) ) {
            case NCNAME:
                {
                alt219=1;
                }
                break;
            case A:
            case FROM:
            case TO:
            case ITEM:
            case COMMENT:
            case ROW:
                {
                alt219=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("", 219, 0, input);

                throw nvae;
            }

            switch (alt219) {
                case 1 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2985:5: NCNAME
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    NCNAME731=(CommonTree)match(input,NCNAME,FOLLOW_NCNAME_in_localPart18031); if (state.failed) return retval;
                    if ( state.backtracking==0 ) {
                    NCNAME731_tree = (CommonTree)adaptor.dupNode(NCNAME731);

                    adaptor.addChild(root_0, NCNAME731_tree);
                    }

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;
                case 2 :
                    // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2986:5: keyword
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    _last = (CommonTree)input.LT(1);
                    pushFollow(FOLLOW_keyword_in_localPart18037);
                    keyword732=keyword();

                    state._fsp--;
                    if (state.failed) return retval;
                    if ( state.backtracking==0 ) 
                    adaptor.addChild(root_0, keyword732.getTree());

                    if ( state.backtracking==0 ) {
                    }
                    }
                    break;

            }
            if ( state.backtracking==0 ) {

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "localPart"

    // $ANTLR start synpred41_XSPARQLRewriter
    public final void synpred41_XSPARQLRewriter_fragment() throws RecognitionException {   
        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:992:5: ( exprSingle )
        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:992:5: exprSingle
        {
        pushFollow(FOLLOW_exprSingle_in_synpred41_XSPARQLRewriter1987);
        exprSingle();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred41_XSPARQLRewriter

    // $ANTLR start synpred74_XSPARQLRewriter
    public final void synpred74_XSPARQLRewriter_fragment() throws RecognitionException {   
        XSPARQLRewriter.qname_return p1 = null;

        XSPARQLRewriter.qname_return q1 = null;


        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1266:5: (p1= qname DOT q1= qname )
        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1266:5: p1= qname DOT q1= qname
        {
        pushFollow(FOLLOW_qname_in_synpred74_XSPARQLRewriter4229);
        p1=qname();

        state._fsp--;
        if (state.failed) return ;
        match(input,DOT,FOLLOW_DOT_in_synpred74_XSPARQLRewriter4231); if (state.failed) return ;
        pushFollow(FOLLOW_qname_in_synpred74_XSPARQLRewriter4235);
        q1=qname();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred74_XSPARQLRewriter

    // $ANTLR start synpred77_XSPARQLRewriter
    public final void synpred77_XSPARQLRewriter_fragment() throws RecognitionException {   
        XSPARQLRewriter.sqlBooleanOp_return b = null;


        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1284:21: (b= sqlBooleanOp sqlWhereSpecList )
        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1284:21: b= sqlBooleanOp sqlWhereSpecList
        {
        pushFollow(FOLLOW_sqlBooleanOp_in_synpred77_XSPARQLRewriter4391);
        b=sqlBooleanOp();

        state._fsp--;
        if (state.failed) return ;
        pushFollow(FOLLOW_sqlWhereSpecList_in_synpred77_XSPARQLRewriter4393);
        sqlWhereSpecList();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred77_XSPARQLRewriter

    // $ANTLR start synpred93_XSPARQLRewriter
    public final void synpred93_XSPARQLRewriter_fragment() throws RecognitionException {   
        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1369:54: ( solutionmodifier )
        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:1369:54: solutionmodifier
        {
        pushFollow(FOLLOW_solutionmodifier_in_synpred93_XSPARQLRewriter4718);
        solutionmodifier();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred93_XSPARQLRewriter

    // $ANTLR start synpred253_XSPARQLRewriter
    public final void synpred253_XSPARQLRewriter_fragment() throws RecognitionException {   
        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2152:5: ( triplesSameSubject )
        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2152:5: triplesSameSubject
        {
        pushFollow(FOLLOW_triplesSameSubject_in_synpred253_XSPARQLRewriter9788);
        triplesSameSubject();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred253_XSPARQLRewriter

    // $ANTLR start synpred277_XSPARQLRewriter
    public final void synpred277_XSPARQLRewriter_fragment() throws RecognitionException {   
        List list_v=null;
        List list_o=null;
        RuleReturnScope v = null;
        RuleReturnScope o = null;
        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2415:38: ( ^( T_VERB v+= verb o+= objectList ) )
        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2415:38: ^( T_VERB v+= verb o+= objectList )
        {
        match(input,T_VERB,FOLLOW_T_VERB_in_synpred277_XSPARQLRewriter12864); if (state.failed) return ;

        match(input, Token.DOWN, null); if (state.failed) return ;
        pushFollow(FOLLOW_verb_in_synpred277_XSPARQLRewriter12868);
        v=verb();

        state._fsp--;
        if (state.failed) return ;
        if (list_v==null) list_v=new ArrayList();
        list_v.add(v);

        pushFollow(FOLLOW_objectList_in_synpred277_XSPARQLRewriter12872);
        o=objectList();

        state._fsp--;
        if (state.failed) return ;
        if (list_o==null) list_o=new ArrayList();
        list_o.add(o);


        match(input, Token.UP, null); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred277_XSPARQLRewriter

    // $ANTLR start synpred316_XSPARQLRewriter
    public final void synpred316_XSPARQLRewriter_fragment() throws RecognitionException {   
        CommonTree at=null;
        XSPARQLRewriter.enclosedExpr_return e1 = null;

        XSPARQLRewriter.enclosedExpr_return e2 = null;


        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2650:5: ( ^( T_LITERAL_CONSTRUCT e1= enclosedExpr at= AT e2= enclosedExpr ) )
        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2650:5: ^( T_LITERAL_CONSTRUCT e1= enclosedExpr at= AT e2= enclosedExpr )
        {
        match(input,T_LITERAL_CONSTRUCT,FOLLOW_T_LITERAL_CONSTRUCT_in_synpred316_XSPARQLRewriter15380); if (state.failed) return ;

        match(input, Token.DOWN, null); if (state.failed) return ;
        pushFollow(FOLLOW_enclosedExpr_in_synpred316_XSPARQLRewriter15384);
        e1=enclosedExpr();

        state._fsp--;
        if (state.failed) return ;
        at=(CommonTree)match(input,AT,FOLLOW_AT_in_synpred316_XSPARQLRewriter15388); if (state.failed) return ;
        pushFollow(FOLLOW_enclosedExpr_in_synpred316_XSPARQLRewriter15392);
        e2=enclosedExpr();

        state._fsp--;
        if (state.failed) return ;

        match(input, Token.UP, null); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred316_XSPARQLRewriter

    // $ANTLR start synpred317_XSPARQLRewriter
    public final void synpred317_XSPARQLRewriter_fragment() throws RecognitionException {   
        CommonTree c1=null;
        CommonTree c2=null;

        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2660:5: ( ^( T_LITERAL_CONSTRUCT enclosedExpr c1= CARET c2= CARET iri ) )
        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2660:5: ^( T_LITERAL_CONSTRUCT enclosedExpr c1= CARET c2= CARET iri )
        {
        match(input,T_LITERAL_CONSTRUCT,FOLLOW_T_LITERAL_CONSTRUCT_in_synpred317_XSPARQLRewriter15499); if (state.failed) return ;

        match(input, Token.DOWN, null); if (state.failed) return ;
        pushFollow(FOLLOW_enclosedExpr_in_synpred317_XSPARQLRewriter15501);
        enclosedExpr();

        state._fsp--;
        if (state.failed) return ;
        c1=(CommonTree)match(input,CARET,FOLLOW_CARET_in_synpred317_XSPARQLRewriter15505); if (state.failed) return ;
        c2=(CommonTree)match(input,CARET,FOLLOW_CARET_in_synpred317_XSPARQLRewriter15509); if (state.failed) return ;
        pushFollow(FOLLOW_iri_in_synpred317_XSPARQLRewriter15511);
        iri();

        state._fsp--;
        if (state.failed) return ;

        match(input, Token.UP, null); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred317_XSPARQLRewriter

    // $ANTLR start synpred318_XSPARQLRewriter
    public final void synpred318_XSPARQLRewriter_fragment() throws RecognitionException {   
        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2670:5: ( ^( T_LITERAL_CONSTRUCT INTEGER AT enclosedExpr ) )
        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2670:5: ^( T_LITERAL_CONSTRUCT INTEGER AT enclosedExpr )
        {
        match(input,T_LITERAL_CONSTRUCT,FOLLOW_T_LITERAL_CONSTRUCT_in_synpred318_XSPARQLRewriter15615); if (state.failed) return ;

        match(input, Token.DOWN, null); if (state.failed) return ;
        match(input,INTEGER,FOLLOW_INTEGER_in_synpred318_XSPARQLRewriter15617); if (state.failed) return ;
        match(input,AT,FOLLOW_AT_in_synpred318_XSPARQLRewriter15619); if (state.failed) return ;
        pushFollow(FOLLOW_enclosedExpr_in_synpred318_XSPARQLRewriter15621);
        enclosedExpr();

        state._fsp--;
        if (state.failed) return ;

        match(input, Token.UP, null); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred318_XSPARQLRewriter

    // $ANTLR start synpred319_XSPARQLRewriter
    public final void synpred319_XSPARQLRewriter_fragment() throws RecognitionException {   
        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2680:5: ( ^( T_LITERAL_CONSTRUCT INTEGER CARET CARET iriConstruct ) )
        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2680:5: ^( T_LITERAL_CONSTRUCT INTEGER CARET CARET iriConstruct )
        {
        match(input,T_LITERAL_CONSTRUCT,FOLLOW_T_LITERAL_CONSTRUCT_in_synpred319_XSPARQLRewriter15727); if (state.failed) return ;

        match(input, Token.DOWN, null); if (state.failed) return ;
        match(input,INTEGER,FOLLOW_INTEGER_in_synpred319_XSPARQLRewriter15729); if (state.failed) return ;
        match(input,CARET,FOLLOW_CARET_in_synpred319_XSPARQLRewriter15731); if (state.failed) return ;
        match(input,CARET,FOLLOW_CARET_in_synpred319_XSPARQLRewriter15733); if (state.failed) return ;
        pushFollow(FOLLOW_iriConstruct_in_synpred319_XSPARQLRewriter15735);
        iriConstruct();

        state._fsp--;
        if (state.failed) return ;

        match(input, Token.UP, null); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred319_XSPARQLRewriter

    // $ANTLR start synpred320_XSPARQLRewriter
    public final void synpred320_XSPARQLRewriter_fragment() throws RecognitionException {   
        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2691:5: ( ^( T_LITERAL_CONSTRUCT QSTRING AT enclosedExpr ) )
        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2691:5: ^( T_LITERAL_CONSTRUCT QSTRING AT enclosedExpr )
        {
        match(input,T_LITERAL_CONSTRUCT,FOLLOW_T_LITERAL_CONSTRUCT_in_synpred320_XSPARQLRewriter15840); if (state.failed) return ;

        match(input, Token.DOWN, null); if (state.failed) return ;
        match(input,QSTRING,FOLLOW_QSTRING_in_synpred320_XSPARQLRewriter15842); if (state.failed) return ;
        match(input,AT,FOLLOW_AT_in_synpred320_XSPARQLRewriter15844); if (state.failed) return ;
        pushFollow(FOLLOW_enclosedExpr_in_synpred320_XSPARQLRewriter15846);
        enclosedExpr();

        state._fsp--;
        if (state.failed) return ;

        match(input, Token.UP, null); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred320_XSPARQLRewriter

    // $ANTLR start synpred321_XSPARQLRewriter
    public final void synpred321_XSPARQLRewriter_fragment() throws RecognitionException {   
        CommonTree c1=null;
        CommonTree c2=null;

        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2701:5: ( ^( T_LITERAL_CONSTRUCT QSTRING c1= CARET c2= CARET iriConstruct ) )
        // org/deri/xsparql/rewriter/XSPARQLRewriter.g:2701:5: ^( T_LITERAL_CONSTRUCT QSTRING c1= CARET c2= CARET iriConstruct )
        {
        match(input,T_LITERAL_CONSTRUCT,FOLLOW_T_LITERAL_CONSTRUCT_in_synpred321_XSPARQLRewriter15951); if (state.failed) return ;

        match(input, Token.DOWN, null); if (state.failed) return ;
        match(input,QSTRING,FOLLOW_QSTRING_in_synpred321_XSPARQLRewriter15953); if (state.failed) return ;
        c1=(CommonTree)match(input,CARET,FOLLOW_CARET_in_synpred321_XSPARQLRewriter15957); if (state.failed) return ;
        c2=(CommonTree)match(input,CARET,FOLLOW_CARET_in_synpred321_XSPARQLRewriter15961); if (state.failed) return ;
        pushFollow(FOLLOW_iriConstruct_in_synpred321_XSPARQLRewriter15963);
        iriConstruct();

        state._fsp--;
        if (state.failed) return ;

        match(input, Token.UP, null); if (state.failed) return ;

        }
    }
    // $ANTLR end synpred321_XSPARQLRewriter

    // Delegated rules

    public final boolean synpred316_XSPARQLRewriter() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred316_XSPARQLRewriter_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred277_XSPARQLRewriter() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred277_XSPARQLRewriter_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred41_XSPARQLRewriter() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred41_XSPARQLRewriter_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred318_XSPARQLRewriter() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred318_XSPARQLRewriter_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred319_XSPARQLRewriter() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred319_XSPARQLRewriter_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred320_XSPARQLRewriter() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred320_XSPARQLRewriter_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred77_XSPARQLRewriter() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred77_XSPARQLRewriter_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred253_XSPARQLRewriter() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred253_XSPARQLRewriter_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred321_XSPARQLRewriter() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred321_XSPARQLRewriter_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred93_XSPARQLRewriter() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred93_XSPARQLRewriter_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred317_XSPARQLRewriter() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred317_XSPARQLRewriter_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred74_XSPARQLRewriter() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred74_XSPARQLRewriter_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }


    protected DFA24 dfa24 = new DFA24(this);
    protected DFA41 dfa41 = new DFA41(this);
    protected DFA46 dfa46 = new DFA46(this);
    protected DFA49 dfa49 = new DFA49(this);
    protected DFA166 dfa166 = new DFA166(this);
    static final String DFA24_eotS =
        "\73\uffff";
    static final String DFA24_eofS =
        "\1\1\72\uffff";
    static final String DFA24_minS =
        "\1\3\1\uffff\2\0\4\uffff\1\0\1\uffff\21\0\40\uffff";
    static final String DFA24_maxS =
        "\1\u00f3\1\uffff\2\0\4\uffff\1\0\1\uffff\21\0\40\uffff";
    static final String DFA24_acceptS =
        "\1\uffff\1\2\70\uffff\1\1";
    static final String DFA24_specialS =
        "\2\uffff\1\0\1\1\4\uffff\1\2\1\uffff\1\3\1\4\1\5\1\6\1\7\1\10\1"+
        "\11\1\12\1\13\1\14\1\15\1\16\1\17\1\20\1\21\1\22\1\23\40\uffff}>";
    static final String[] DFA24_transitionS = {
            "\2\1\2\uffff\1\10\2\1\2\uffff\1\1\1\uffff\1\1\1\uffff\1\1\1"+
            "\uffff\3\1\1\uffff\1\1\1\uffff\1\26\2\uffff\2\2\2\15\1\25\1"+
            "\uffff\1\30\4\2\7\uffff\2\1\2\uffff\1\1\5\uffff\1\1\2\uffff"+
            "\1\1\7\30\1\uffff\1\1\10\uffff\2\1\1\uffff\1\32\7\uffff\1\1"+
            "\2\uffff\1\1\16\uffff\1\1\4\uffff\1\3\1\31\1\27\3\26\1\25\2"+
            "\24\5\uffff\11\1\21\uffff\1\30\4\uffff\1\1\4\uffff\1\12\24\uffff"+
            "\2\1\3\uffff\1\23\1\uffff\1\20\1\21\1\22\25\uffff\1\1\7\uffff"+
            "\1\1\1\13\1\14\1\uffff\1\17\1\13\17\uffff\1\16\1\uffff\1\1",
            "",
            "\1\uffff",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "\1\uffff",
            "",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA24_eot = DFA.unpackEncodedString(DFA24_eotS);
    static final short[] DFA24_eof = DFA.unpackEncodedString(DFA24_eofS);
    static final char[] DFA24_min = DFA.unpackEncodedStringToUnsignedChars(DFA24_minS);
    static final char[] DFA24_max = DFA.unpackEncodedStringToUnsignedChars(DFA24_maxS);
    static final short[] DFA24_accept = DFA.unpackEncodedString(DFA24_acceptS);
    static final short[] DFA24_special = DFA.unpackEncodedString(DFA24_specialS);
    static final short[][] DFA24_transition;

    static {
        int numStates = DFA24_transitionS.length;
        DFA24_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA24_transition[i] = DFA.unpackEncodedString(DFA24_transitionS[i]);
        }
    }

    class DFA24 extends DFA {

        public DFA24(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 24;
            this.eot = DFA24_eot;
            this.eof = DFA24_eof;
            this.min = DFA24_min;
            this.max = DFA24_max;
            this.accept = DFA24_accept;
            this.special = DFA24_special;
            this.transition = DFA24_transition;
        }
        public String getDescription() {
            return "()+ loopback of 992:5: ( exprSingle )+";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TreeNodeStream input = (TreeNodeStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA24_2 = input.LA(1);

                         
                        int index24_2 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_XSPARQLRewriter()) ) {s = 58;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index24_2);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA24_3 = input.LA(1);

                         
                        int index24_3 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_XSPARQLRewriter()) ) {s = 58;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index24_3);
                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA24_8 = input.LA(1);

                         
                        int index24_8 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_XSPARQLRewriter()) ) {s = 58;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index24_8);
                        if ( s>=0 ) return s;
                        break;
                    case 3 : 
                        int LA24_10 = input.LA(1);

                         
                        int index24_10 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_XSPARQLRewriter()) ) {s = 58;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index24_10);
                        if ( s>=0 ) return s;
                        break;
                    case 4 : 
                        int LA24_11 = input.LA(1);

                         
                        int index24_11 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_XSPARQLRewriter()) ) {s = 58;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index24_11);
                        if ( s>=0 ) return s;
                        break;
                    case 5 : 
                        int LA24_12 = input.LA(1);

                         
                        int index24_12 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_XSPARQLRewriter()) ) {s = 58;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index24_12);
                        if ( s>=0 ) return s;
                        break;
                    case 6 : 
                        int LA24_13 = input.LA(1);

                         
                        int index24_13 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_XSPARQLRewriter()) ) {s = 58;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index24_13);
                        if ( s>=0 ) return s;
                        break;
                    case 7 : 
                        int LA24_14 = input.LA(1);

                         
                        int index24_14 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_XSPARQLRewriter()) ) {s = 58;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index24_14);
                        if ( s>=0 ) return s;
                        break;
                    case 8 : 
                        int LA24_15 = input.LA(1);

                         
                        int index24_15 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_XSPARQLRewriter()) ) {s = 58;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index24_15);
                        if ( s>=0 ) return s;
                        break;
                    case 9 : 
                        int LA24_16 = input.LA(1);

                         
                        int index24_16 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_XSPARQLRewriter()) ) {s = 58;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index24_16);
                        if ( s>=0 ) return s;
                        break;
                    case 10 : 
                        int LA24_17 = input.LA(1);

                         
                        int index24_17 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_XSPARQLRewriter()) ) {s = 58;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index24_17);
                        if ( s>=0 ) return s;
                        break;
                    case 11 : 
                        int LA24_18 = input.LA(1);

                         
                        int index24_18 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_XSPARQLRewriter()) ) {s = 58;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index24_18);
                        if ( s>=0 ) return s;
                        break;
                    case 12 : 
                        int LA24_19 = input.LA(1);

                         
                        int index24_19 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_XSPARQLRewriter()) ) {s = 58;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index24_19);
                        if ( s>=0 ) return s;
                        break;
                    case 13 : 
                        int LA24_20 = input.LA(1);

                         
                        int index24_20 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_XSPARQLRewriter()) ) {s = 58;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index24_20);
                        if ( s>=0 ) return s;
                        break;
                    case 14 : 
                        int LA24_21 = input.LA(1);

                         
                        int index24_21 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_XSPARQLRewriter()) ) {s = 58;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index24_21);
                        if ( s>=0 ) return s;
                        break;
                    case 15 : 
                        int LA24_22 = input.LA(1);

                         
                        int index24_22 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_XSPARQLRewriter()) ) {s = 58;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index24_22);
                        if ( s>=0 ) return s;
                        break;
                    case 16 : 
                        int LA24_23 = input.LA(1);

                         
                        int index24_23 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_XSPARQLRewriter()) ) {s = 58;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index24_23);
                        if ( s>=0 ) return s;
                        break;
                    case 17 : 
                        int LA24_24 = input.LA(1);

                         
                        int index24_24 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_XSPARQLRewriter()) ) {s = 58;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index24_24);
                        if ( s>=0 ) return s;
                        break;
                    case 18 : 
                        int LA24_25 = input.LA(1);

                         
                        int index24_25 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_XSPARQLRewriter()) ) {s = 58;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index24_25);
                        if ( s>=0 ) return s;
                        break;
                    case 19 : 
                        int LA24_26 = input.LA(1);

                         
                        int index24_26 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred41_XSPARQLRewriter()) ) {s = 58;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index24_26);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 24, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String DFA41_eotS =
        "\15\uffff";
    static final String DFA41_eofS =
        "\15\uffff";
    static final String DFA41_minS =
        "\1\u00ad\1\2\2\21\1\4\2\uffff\1\3\1\u00af\1\2\1\u00b1\2\uffff";
    static final String DFA41_maxS =
        "\1\u00ad\1\2\2\u00b0\1\4\2\uffff\1\3\1\u00af\1\2\1\u00c2\2\uffff";
    static final String DFA41_acceptS =
        "\5\uffff\1\2\1\1\4\uffff\1\3\1\4";
    static final String DFA41_specialS =
        "\15\uffff}>";
    static final String[] DFA41_transitionS = {
            "\1\1",
            "\1\2",
            "\1\6\3\uffff\1\6\2\uffff\1\5\176\uffff\1\3\3\uffff\1\4\24\uffff"+
            "\1\6",
            "\1\6\3\uffff\1\6\2\uffff\1\5\u0082\uffff\1\4\24\uffff\1\6",
            "\1\7",
            "",
            "",
            "\1\10",
            "\1\11",
            "\1\12",
            "\1\14\20\uffff\1\13",
            "",
            ""
    };

    static final short[] DFA41_eot = DFA.unpackEncodedString(DFA41_eotS);
    static final short[] DFA41_eof = DFA.unpackEncodedString(DFA41_eofS);
    static final char[] DFA41_min = DFA.unpackEncodedStringToUnsignedChars(DFA41_minS);
    static final char[] DFA41_max = DFA.unpackEncodedStringToUnsignedChars(DFA41_maxS);
    static final short[] DFA41_accept = DFA.unpackEncodedString(DFA41_acceptS);
    static final short[] DFA41_special = DFA.unpackEncodedString(DFA41_specialS);
    static final short[][] DFA41_transition;

    static {
        int numStates = DFA41_transitionS.length;
        DFA41_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA41_transition[i] = DFA.unpackEncodedString(DFA41_transitionS[i]);
        }
    }

    class DFA41 extends DFA {

        public DFA41(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 41;
            this.eot = DFA41_eot;
            this.eof = DFA41_eof;
            this.min = DFA41_min;
            this.max = DFA41_max;
            this.accept = DFA41_accept;
            this.special = DFA41_special;
            this.transition = DFA41_transition;
        }
        public String getDescription() {
            return "1063:1: sqlForClause : ( ^(fo= T_SQL_FOR ( distinct )? (var+= sqlVarOrFunction )+ ) relationClause ( sqlWhereClause )? -> COMMENT[$fo.token, \"SQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? ( $var)+ relationClause ( sqlWhereClause )? ) ) ) ) ) ^( T_FOR VAR[auxResult] ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) ) ) ( ^( REWRITEVNODE[$fo.token, auxResult] $var) )+ | ^(fo= T_SQL_FOR ( distinct )? s= STAR ) relationClause ( sqlWhereClause )? -> COMMENT[$fo.token, \"SQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? QSTRING[concat($sqlForClause::relations, \", \")+\" \"] relationClause ( sqlWhereClause )? ) ) ) ) ) ^( T_FOR VAR[auxResult] ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) ) ) | ^(fo= T_SQL_FOR ( distinct )? ROW v= VAR ) ^( T_SQL_FROM ^( T_FUNCTION_CALL qname ^( T_PARAMS sqlVarOrString ) ) ) -> COMMENT[$fo.token, \"SQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS sqlVarOrString ) ) ) ^( T_FOR $v ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) ) ) | ^(fo= T_SQL_FOR ( distinct )? ROW v= VAR ) relationClause ( sqlWhereClause )? -> COMMENT[$fo.token, \"SQL FOR from \" + $fo.line + \":\" + $fo.pos] ^( T_LET VAR[auxResults] ^( T_FUNCTION_CALL NCNAME[SQLevaluationFunction] ^( T_PARAMS ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS QSTRING[\" SELECT \"] ( distinct )? QSTRING[\" * \"] relationClause ( sqlWhereClause )? ) ) ) ) ) ^( T_FOR $v ^( AT VAR[auxResultPos] ) ^( IN ^( T_FUNCTION_CALL NCNAME[SQLiterationFunction] ^( T_PARAMS VAR[auxResults] ) ) ) ) );";
        }
    }
    static final String DFA46_eotS =
        "\17\uffff";
    static final String DFA46_eofS =
        "\17\uffff";
    static final String DFA46_minS =
        "\1\21\1\2\1\uffff\2\11\10\3\2\uffff";
    static final String DFA46_maxS =
        "\1\u00b0\1\2\1\uffff\2\u009b\10\4\2\uffff";
    static final String DFA46_acceptS =
        "\2\uffff\1\3\12\uffff\1\2\1\1";
    static final String DFA46_specialS =
        "\17\uffff}>";
    static final String[] DFA46_transitionS = {
            "\1\2\3\uffff\1\2\u009a\uffff\1\1",
            "\1\3",
            "",
            "\1\6\7\uffff\1\4\33\uffff\2\5\13\uffff\1\14\10\uffff\1\11\54"+
            "\uffff\1\10\14\uffff\1\7\3\uffff\1\13\31\uffff\1\12",
            "\1\6\43\uffff\2\5\13\uffff\1\14\10\uffff\1\11\54\uffff\1\10"+
            "\14\uffff\1\7\3\uffff\1\13\31\uffff\1\12",
            "\1\16\1\15",
            "\1\16\1\15",
            "\1\16\1\15",
            "\1\16\1\15",
            "\1\16\1\15",
            "\1\16\1\15",
            "\1\16\1\15",
            "\1\16\1\15",
            "",
            ""
    };

    static final short[] DFA46_eot = DFA.unpackEncodedString(DFA46_eotS);
    static final short[] DFA46_eof = DFA.unpackEncodedString(DFA46_eofS);
    static final char[] DFA46_min = DFA.unpackEncodedStringToUnsignedChars(DFA46_minS);
    static final char[] DFA46_max = DFA.unpackEncodedStringToUnsignedChars(DFA46_maxS);
    static final short[] DFA46_accept = DFA.unpackEncodedString(DFA46_acceptS);
    static final short[] DFA46_special = DFA.unpackEncodedString(DFA46_specialS);
    static final short[][] DFA46_transition;

    static {
        int numStates = DFA46_transitionS.length;
        DFA46_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA46_transition[i] = DFA.unpackEncodedString(DFA46_transitionS[i]);
        }
    }

    class DFA46 extends DFA {

        public DFA46(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 46;
            this.eot = DFA46_eot;
            this.eof = DFA46_eof;
            this.min = DFA46_min;
            this.max = DFA46_max;
            this.accept = DFA46_accept;
            this.special = DFA46_special;
            this.transition = DFA46_transition;
        }
        public String getDescription() {
            return "1243:1: sqlVarOrFunction : ( ^( T_VAR ( COMMA )? q= qname ) -> ^( T_VAR ( COMMA )? QSTRING[$q.text] VAR[\"\\$\"+$q.text] ) | ^( T_VAR ( COMMA )? q= qname v2= VAR ) -> ^( T_VAR ( COMMA )? QSTRING[$q.text] VAR ) | ( COMMA )? LPAR functionCall AS v3= VAR RPAR );";
        }
    }
    static final String DFA49_eotS =
        "\26\uffff";
    static final String DFA49_eofS =
        "\26\uffff";
    static final String DFA49_minS =
        "\1\4\11\3\1\4\2\uffff\10\0\1\uffff";
    static final String DFA49_maxS =
        "\13\u009b\2\uffff\10\0\1\uffff";
    static final String DFA49_acceptS =
        "\13\uffff\1\2\1\3\10\uffff\1\1";
    static final String DFA49_specialS =
        "\15\uffff\1\5\1\6\1\7\1\2\1\4\1\3\1\0\1\1\1\uffff}>";
    static final String[] DFA49_transitionS = {
            "\1\11\4\uffff\1\2\43\uffff\2\1\13\uffff\1\10\10\uffff\1\5\54"+
            "\uffff\1\4\14\uffff\1\3\3\uffff\1\7\31\uffff\1\6",
            "\2\13\4\uffff\1\13\1\uffff\1\12\41\uffff\2\13\13\uffff\1\13"+
            "\10\uffff\1\13\54\uffff\1\13\14\uffff\1\13\3\uffff\1\13\31\uffff"+
            "\1\13",
            "\2\13\4\uffff\1\13\1\uffff\1\12\41\uffff\2\13\13\uffff\1\13"+
            "\10\uffff\1\13\54\uffff\1\13\14\uffff\1\13\3\uffff\1\13\31\uffff"+
            "\1\13",
            "\2\13\4\uffff\1\13\1\uffff\1\12\41\uffff\2\13\13\uffff\1\13"+
            "\10\uffff\1\13\54\uffff\1\13\14\uffff\1\13\3\uffff\1\13\31\uffff"+
            "\1\13",
            "\2\13\4\uffff\1\13\1\uffff\1\12\41\uffff\2\13\13\uffff\1\13"+
            "\10\uffff\1\13\54\uffff\1\13\14\uffff\1\13\3\uffff\1\13\31\uffff"+
            "\1\13",
            "\2\13\4\uffff\1\13\1\uffff\1\12\41\uffff\2\13\13\uffff\1\13"+
            "\10\uffff\1\13\54\uffff\1\13\14\uffff\1\13\3\uffff\1\13\31\uffff"+
            "\1\13",
            "\2\13\4\uffff\1\13\1\uffff\1\12\41\uffff\2\13\13\uffff\1\13"+
            "\10\uffff\1\13\54\uffff\1\13\14\uffff\1\13\3\uffff\1\13\31\uffff"+
            "\1\13",
            "\2\13\4\uffff\1\13\1\uffff\1\12\41\uffff\2\13\13\uffff\1\13"+
            "\10\uffff\1\13\54\uffff\1\13\14\uffff\1\13\3\uffff\1\13\31\uffff"+
            "\1\13",
            "\2\13\4\uffff\1\13\1\uffff\1\12\41\uffff\2\13\13\uffff\1\13"+
            "\10\uffff\1\13\54\uffff\1\13\14\uffff\1\13\3\uffff\1\13\31\uffff"+
            "\1\13",
            "\2\13\4\uffff\1\13\1\uffff\1\14\41\uffff\2\13\13\uffff\1\13"+
            "\10\uffff\1\13\54\uffff\1\13\14\uffff\1\13\3\uffff\1\13\31\uffff"+
            "\1\13",
            "\1\14\4\uffff\1\16\43\uffff\2\15\13\uffff\1\24\10\uffff\1\21"+
            "\54\uffff\1\20\14\uffff\1\17\3\uffff\1\23\31\uffff\1\22",
            "",
            "",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            ""
    };

    static final short[] DFA49_eot = DFA.unpackEncodedString(DFA49_eotS);
    static final short[] DFA49_eof = DFA.unpackEncodedString(DFA49_eofS);
    static final char[] DFA49_min = DFA.unpackEncodedStringToUnsignedChars(DFA49_minS);
    static final char[] DFA49_max = DFA.unpackEncodedStringToUnsignedChars(DFA49_maxS);
    static final short[] DFA49_accept = DFA.unpackEncodedString(DFA49_acceptS);
    static final short[] DFA49_special = DFA.unpackEncodedString(DFA49_specialS);
    static final short[][] DFA49_transition;

    static {
        int numStates = DFA49_transitionS.length;
        DFA49_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA49_transition[i] = DFA.unpackEncodedString(DFA49_transitionS[i]);
        }
    }

    class DFA49 extends DFA {

        public DFA49(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 49;
            this.eot = DFA49_eot;
            this.eof = DFA49_eof;
            this.min = DFA49_min;
            this.max = DFA49_max;
            this.accept = DFA49_accept;
            this.special = DFA49_special;
            this.transition = DFA49_transition;
        }
        public String getDescription() {
            return "1264:1: relationSchemaName : (p1= qname DOT q1= qname -> QSTRING[\"\\\"\\\"\"+$p1.text+\"\\\"\\\".\\\"\\\"\"+$q1.text+\"\\\"\\\"\"] | relationAlias | p2= relationAlias DOT q2= relationAlias -> ^( T_FUNCTION_CALL NCNAME[\"fn:concat\"] ^( T_PARAMS $p2 QSTRING[\".\"] $q2) ) );";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TreeNodeStream input = (TreeNodeStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA49_19 = input.LA(1);

                         
                        int index49_19 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred74_XSPARQLRewriter()) ) {s = 21;}

                        else if ( (true) ) {s = 12;}

                         
                        input.seek(index49_19);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA49_20 = input.LA(1);

                         
                        int index49_20 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred74_XSPARQLRewriter()) ) {s = 21;}

                        else if ( (true) ) {s = 12;}

                         
                        input.seek(index49_20);
                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA49_16 = input.LA(1);

                         
                        int index49_16 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred74_XSPARQLRewriter()) ) {s = 21;}

                        else if ( (true) ) {s = 12;}

                         
                        input.seek(index49_16);
                        if ( s>=0 ) return s;
                        break;
                    case 3 : 
                        int LA49_18 = input.LA(1);

                         
                        int index49_18 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred74_XSPARQLRewriter()) ) {s = 21;}

                        else if ( (true) ) {s = 12;}

                         
                        input.seek(index49_18);
                        if ( s>=0 ) return s;
                        break;
                    case 4 : 
                        int LA49_17 = input.LA(1);

                         
                        int index49_17 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred74_XSPARQLRewriter()) ) {s = 21;}

                        else if ( (true) ) {s = 12;}

                         
                        input.seek(index49_17);
                        if ( s>=0 ) return s;
                        break;
                    case 5 : 
                        int LA49_13 = input.LA(1);

                         
                        int index49_13 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred74_XSPARQLRewriter()) ) {s = 21;}

                        else if ( (true) ) {s = 12;}

                         
                        input.seek(index49_13);
                        if ( s>=0 ) return s;
                        break;
                    case 6 : 
                        int LA49_14 = input.LA(1);

                         
                        int index49_14 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred74_XSPARQLRewriter()) ) {s = 21;}

                        else if ( (true) ) {s = 12;}

                         
                        input.seek(index49_14);
                        if ( s>=0 ) return s;
                        break;
                    case 7 : 
                        int LA49_15 = input.LA(1);

                         
                        int index49_15 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred74_XSPARQLRewriter()) ) {s = 21;}

                        else if ( (true) ) {s = 12;}

                         
                        input.seek(index49_15);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 49, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String DFA166_eotS =
        "\17\uffff";
    static final String DFA166_eofS =
        "\1\1\16\uffff";
    static final String DFA166_minS =
        "\1\3\2\uffff\1\0\13\uffff";
    static final String DFA166_maxS =
        "\1\u00b6\2\uffff\1\0\13\uffff";
    static final String DFA166_acceptS =
        "\1\uffff\1\2\14\uffff\1\1";
    static final String DFA166_specialS =
        "\3\uffff\1\0\13\uffff}>";
    static final String[] DFA166_transitionS = {
            "\2\1\1\uffff\1\1\3\uffff\1\1\12\uffff\2\1\26\uffff\2\1\10\uffff"+
            "\1\1\133\uffff\2\1\36\uffff\1\1\2\uffff\1\3",
            "",
            "",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA166_eot = DFA.unpackEncodedString(DFA166_eotS);
    static final short[] DFA166_eof = DFA.unpackEncodedString(DFA166_eofS);
    static final char[] DFA166_min = DFA.unpackEncodedStringToUnsignedChars(DFA166_minS);
    static final char[] DFA166_max = DFA.unpackEncodedStringToUnsignedChars(DFA166_maxS);
    static final short[] DFA166_accept = DFA.unpackEncodedString(DFA166_acceptS);
    static final short[] DFA166_special = DFA.unpackEncodedString(DFA166_specialS);
    static final short[][] DFA166_transition;

    static {
        int numStates = DFA166_transitionS.length;
        DFA166_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA166_transition[i] = DFA.unpackEncodedString(DFA166_transitionS[i]);
        }
    }

    class DFA166 extends DFA {

        public DFA166(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 166;
            this.eot = DFA166_eot;
            this.eof = DFA166_eof;
            this.min = DFA166_min;
            this.max = DFA166_max;
            this.accept = DFA166_accept;
            this.special = DFA166_special;
            this.transition = DFA166_transition;
        }
        public String getDescription() {
            return "()* loopback of 2415:37: ( ^( T_VERB v+= verb o+= objectList ) )*";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TreeNodeStream input = (TreeNodeStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA166_3 = input.LA(1);

                         
                        int index166_3 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred277_XSPARQLRewriter()) ) {s = 14;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index166_3);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 166, _s, input);
            error(nvae);
            throw nvae;
        }
    }
 

    public static final BitSet FOLLOW_versionDecl_in_root924 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0100000000000000L,0x0000002000000000L});
    public static final BitSet FOLLOW_libraryModule_in_root928 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_mainModule_in_root932 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_VERSION_in_versionDecl947 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_stringliteral_in_versionDecl949 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000002000000L});
    public static final BitSet FOLLOW_ENCODING_in_versionDecl952 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_stringliteral_in_versionDecl954 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_MAIN_in_mainModule982 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_prolog_in_mainModule984 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000800000000000L});
    public static final BitSet FOLLOW_queryBody_in_mainModule986 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_moduleDecl_in_libraryModule1001 = new BitSet(new long[]{0x0000000000000000L,0x0000004000000000L,0x8000000210000000L,0x00007F8000400003L});
    public static final BitSet FOLLOW_prolog_in_libraryModule1003 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_MODULE_DECL_in_moduleDecl1017 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_NCNAME_in_moduleDecl1019 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_uriliteral_in_moduleDecl1021 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_baseDecl_in_prolog1035 = new BitSet(new long[]{0x0000000000000002L,0x0000004000000000L,0x8000000210000000L,0x00007F8000400003L});
    public static final BitSet FOLLOW_prolog1_in_prolog1042 = new BitSet(new long[]{0x0000000000000002L,0x0000004000000000L,0x8000000210000000L,0x00007F8000400003L});
    public static final BitSet FOLLOW_prolog2_in_prolog1049 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x8000000200000000L,0x0000000000000003L});
    public static final BitSet FOLLOW_defaultNamespaceDecl_in_prolog11177 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_namespaceDecl_in_prolog11183 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_setter_in_prolog11189 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_importa_in_prolog11195 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_prefixDecl_in_prolog11201 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_varDecl_in_prolog21214 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_functionDecl_in_prolog21220 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_optionDecl_in_prolog21226 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_boundarySpaceDecl_in_setter1239 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_defaultCollationDecl_in_setter1245 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_baseURIDecl_in_setter1251 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_constructionDecl_in_setter1257 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_orderingModeDecl_in_setter1263 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_emptyOrderDecl_in_setter1269 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_copyNamespacesDecl_in_setter1275 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_schemaImport_in_importa1288 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_moduleImport_in_importa1292 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_NAMESPACE_in_namespaceDecl1306 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_NCNAME_in_namespaceDecl1310 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_QSTRING_in_namespaceDecl1314 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_BOUNDARYSPACE_DECL_in_boundarySpaceDecl1331 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_set_in_boundarySpaceDecl1333 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_DEFAULT_DECL_in_defaultNamespaceDecl1352 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_set_in_defaultNamespaceDecl1354 = new BitSet(new long[]{0x0000000000000000L,0x0000008000000000L});
    public static final BitSet FOLLOW_NAMESPACE_in_defaultNamespaceDecl1360 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_QSTRING_in_defaultNamespaceDecl1364 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_OPTION_DECL_in_optionDecl1381 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_qname_in_optionDecl1383 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_stringliteral_in_optionDecl1385 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_ORDER_DECL_in_orderingModeDecl1400 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_set_in_orderingModeDecl1402 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_EMPTY_ORDER_DECL_in_emptyOrderDecl1421 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_set_in_emptyOrderDecl1423 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_COPYNAMESPACES_in_copyNamespacesDecl1442 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_preserveMode_in_copyNamespacesDecl1444 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000060000L});
    public static final BitSet FOLLOW_inheritMode_in_copyNamespacesDecl1446 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_set_in_preserveMode0 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_inheritMode0 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_DEFAULT_COLLATION_DECL_in_defaultCollationDecl1499 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_uriliteral_in_defaultCollationDecl1501 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_BASEURI_DECL_in_baseURIDecl1516 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_QSTRING_in_baseURIDecl1518 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_SCHEMA_IMPORT_in_schemaImport1533 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_SCHEMA_in_schemaImport1536 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_schemaPrefix_in_schemaImport1538 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_uriliteral_in_schemaImport1542 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_AT_in_schemaImport1545 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_uriliteral_in_schemaImport1547 = new BitSet(new long[]{0x0000000000000408L});
    public static final BitSet FOLLOW_set_in_schemaPrefix0 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_MODULE_IMPORT_in_moduleImport1583 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_NAMESPACE_in_moduleImport1586 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_NCNAME_in_moduleImport1588 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_uriliteral_in_moduleImport1592 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_AT_in_moduleImport1595 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_uriliteral_in_moduleImport1597 = new BitSet(new long[]{0x0000000000000408L});
    public static final BitSet FOLLOW_T_VARIABLE_DECL_in_varDecl1614 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_VAR_in_varDecl1618 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0800000000000000L});
    public static final BitSet FOLLOW_T_TYPE_in_varDecl1623 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_typeDeclaration_in_varDecl1625 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_exprSingle_in_varDecl1629 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_EXTERNAL_VARIABLE_DECL_in_varDecl1637 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_VAR_in_varDecl1641 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0800000000000000L});
    public static final BitSet FOLLOW_T_TYPE_in_varDecl1646 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_typeDeclaration_in_varDecl1648 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_DECLARE_in_constructionDecl1664 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000008000L});
    public static final BitSet FOLLOW_CONSTRUCTION_in_constructionDecl1666 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000004200L});
    public static final BitSet FOLLOW_set_in_constructionDecl1668 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_FUNCTION_DECL_in_functionDecl1699 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_qname_in_functionDecl1701 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000400000000L});
    public static final BitSet FOLLOW_T_PARAMS_in_functionDecl1704 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_paramList_in_functionDecl1706 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_AS_in_functionDecl1712 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_sequenceType_in_functionDecl1714 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_enclosedExpr_in_functionDecl1720 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_EXTERNAL_in_functionDecl1724 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_param_in_paramList1739 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000000000000L,0x0000000000000008L});
    public static final BitSet FOLLOW_T_PARAM_in_param1754 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_VAR_in_param1758 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0800000000000000L});
    public static final BitSet FOLLOW_T_TYPE_in_param1761 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_typeDeclaration_in_param1763 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_expr_in_enclosedExpr1781 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LCURLY_in_enclosedExpr_1794 = new BitSet(new long[]{0xF800003EF9000080L,0x007FC00000008003L,0x7400000100400000L,0x0002000360000000L});
    public static final BitSet FOLLOW_expr_in_enclosedExpr_1796 = new BitSet(new long[]{0x0000000000000100L});
    public static final BitSet FOLLOW_RCURLY_in_enclosedExpr_1798 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_QUERY_BODY_in_queryBody1812 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_T_BODY_PART_in_queryBody1816 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_exprSingle_in_queryBody1818 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_epilogue_in_queryBody1823 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_EPILOGUE_in_epilogue1948 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_exprSingle_in_expr1987 = new BitSet(new long[]{0xF800003EF9000082L,0x007FC00000008003L,0x7400000100400000L,0x0002000360000000L});
    public static final BitSet FOLLOW_flworExpr_in_exprSingle2018 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_quantifiedExpr_in_exprSingle2024 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_typeSwitchExpr_in_exprSingle2030 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_orExpr_in_exprSingle2036 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ifExpr_in_exprSingle2042 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_FLWOR_in_flworExpr2066 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_forletClause_in_flworExpr2068 = new BitSet(new long[]{0x0000000000000008L,0x0000000000000000L,0x00000A0000000000L});
    public static final BitSet FOLLOW_returnClause_in_flworExpr2077 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_RETURN_in_returnClause2109 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_exprSingle_in_returnClause2111 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_CONSTRUCT_in_returnClause2131 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_constructTemplate_in_returnClause2134 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_forClause_in_forletClause2234 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000041000000000L});
    public static final BitSet FOLLOW_T_WHERE_in_forletClause2238 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_whereClause_in_forletClause2240 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_ORDER_in_forletClause2247 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_orderByClause_in_forletClause2249 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_sparqlForClause_in_forletClause2258 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_sqlForClause_in_forletClause2264 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_letClause_in_forletClause2270 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000041000000000L});
    public static final BitSet FOLLOW_T_WHERE_in_forletClause2274 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_whereClause_in_forletClause2276 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_ORDER_in_forletClause2283 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_orderByClause_in_forletClause2285 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_DISTINCT_in_distinct2301 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_SQL_FOR_in_sqlForClause2338 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_distinct_in_sqlForClause2340 = new BitSet(new long[]{0x0000000000220000L,0x0000000000000000L,0x0001000000000000L});
    public static final BitSet FOLLOW_sqlVarOrFunction_in_sqlForClause2345 = new BitSet(new long[]{0x0000000000220008L,0x0000000000000000L,0x0001000000000000L});
    public static final BitSet FOLLOW_relationClause_in_sqlForClause2359 = new BitSet(new long[]{0x0000000000000002L,0x0000000000100000L});
    public static final BitSet FOLLOW_sqlWhereClause_in_sqlForClause2361 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_SQL_FOR_in_sqlForClause2793 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_distinct_in_sqlForClause2795 = new BitSet(new long[]{0x0000000001000000L});
    public static final BitSet FOLLOW_STAR_in_sqlForClause2800 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_relationClause_in_sqlForClause2804 = new BitSet(new long[]{0x0000000000000002L,0x0000000000100000L});
    public static final BitSet FOLLOW_sqlWhereClause_in_sqlForClause2806 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_SQL_FOR_in_sqlForClause3232 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_distinct_in_sqlForClause3234 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000008000000L});
    public static final BitSet FOLLOW_ROW_in_sqlForClause3237 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_VAR_in_sqlForClause3241 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_SQL_FROM_in_sqlForClause3255 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_T_FUNCTION_CALL_in_sqlForClause3258 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_qname_in_sqlForClause3260 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000400000000L});
    public static final BitSet FOLLOW_T_PARAMS_in_sqlForClause3263 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_sqlVarOrString_in_sqlForClause3265 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_SQL_FOR_in_sqlForClause3526 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_distinct_in_sqlForClause3528 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000008000000L});
    public static final BitSet FOLLOW_ROW_in_sqlForClause3531 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_VAR_in_sqlForClause3535 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_relationClause_in_sqlForClause3550 = new BitSet(new long[]{0x0000000000000002L,0x0000000000100000L});
    public static final BitSet FOLLOW_sqlWhereClause_in_sqlForClause3552 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_TABLE_in_sqlVarOrString3968 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_sqlQuerySpec_in_sqlVarOrString3972 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_qname_in_sqlQuerySpec3998 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_VAR_in_sqlQuerySpec4009 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_VAR_in_sqlVarOrFunction4031 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_COMMA_in_sqlVarOrFunction4033 = new BitSet(new long[]{0x0400600000000200L,0x2001000000000008L,0x0000000008000002L});
    public static final BitSet FOLLOW_qname_in_sqlVarOrFunction4038 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_VAR_in_sqlVarOrFunction4066 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_COMMA_in_sqlVarOrFunction4068 = new BitSet(new long[]{0x0400600000000200L,0x2001000000000008L,0x0000000008000002L});
    public static final BitSet FOLLOW_qname_in_sqlVarOrFunction4073 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_VAR_in_sqlVarOrFunction4077 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_COMMA_in_sqlVarOrFunction4103 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_LPAR_in_sqlVarOrFunction4106 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000004L});
    public static final BitSet FOLLOW_functionCall_in_sqlVarOrFunction4108 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_AS_in_sqlVarOrFunction4110 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_VAR_in_sqlVarOrFunction4114 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_RPAR_in_sqlVarOrFunction4116 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_SQL_FROM_in_relationClause4129 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_rdbSourceSelector_in_relationClause4131 = new BitSet(new long[]{0x0000000000020008L});
    public static final BitSet FOLLOW_COMMA_in_relationClause4134 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0002000000000000L});
    public static final BitSet FOLLOW_rdbSourceSelector_in_relationClause4136 = new BitSet(new long[]{0x0000000000020008L});
    public static final BitSet FOLLOW_T_TABLE_in_rdbSourceSelector4173 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_relationSchemaName_in_rdbSourceSelector4177 = new BitSet(new long[]{0x0400600000000218L,0x2001000000000008L,0x0000000008000002L});
    public static final BitSet FOLLOW_relationAlias_in_rdbSourceSelector4181 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_qname_in_relationSchemaName4229 = new BitSet(new long[]{0x0000000000000800L});
    public static final BitSet FOLLOW_DOT_in_relationSchemaName4231 = new BitSet(new long[]{0x0400600000000200L,0x2001000000000008L,0x0000000008000002L});
    public static final BitSet FOLLOW_qname_in_relationSchemaName4235 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_relationAlias_in_relationSchemaName4246 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_relationAlias_in_relationSchemaName4257 = new BitSet(new long[]{0x0000000000000800L});
    public static final BitSet FOLLOW_DOT_in_relationSchemaName4259 = new BitSet(new long[]{0x0400600000000210L,0x2001000000000008L,0x0000000008000002L});
    public static final BitSet FOLLOW_relationAlias_in_relationSchemaName4263 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_qname_in_relationAlias4307 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_VAR_in_relationAlias4320 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_WHERE_in_sqlWhereClause4359 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_sqlWhereSpecList_in_sqlWhereClause4361 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_sqlAttrSpecList_in_sqlWhereSpecList4386 = new BitSet(new long[]{0x0000000000000002L,0x0000C00000000000L});
    public static final BitSet FOLLOW_sqlBooleanOp_in_sqlWhereSpecList4391 = new BitSet(new long[]{0xFC00603EF92006D0L,0x207FC0000000800BL,0x7400000108400002L,0x0022000360000000L});
    public static final BitSet FOLLOW_sqlWhereSpecList_in_sqlWhereSpecList4393 = new BitSet(new long[]{0x0000000000000002L,0x0000C00000000000L});
    public static final BitSet FOLLOW_sqlAttrSpec_in_sqlAttrSpecList4431 = new BitSet(new long[]{0x0000003C18000000L});
    public static final BitSet FOLLOW_generalComp_in_sqlAttrSpecList4435 = new BitSet(new long[]{0xFC00603EF90006D0L,0x207FC0000000800BL,0x7400000108400002L,0x0022000360000000L});
    public static final BitSet FOLLOW_sqlAttrSpec_in_sqlAttrSpecList4437 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LPAR_in_sqlAttrSpecList4462 = new BitSet(new long[]{0xFC00603EF92006D0L,0x207FC0000000800BL,0x7400000108400002L,0x0022000360000000L});
    public static final BitSet FOLLOW_sqlWhereSpecList_in_sqlAttrSpecList4464 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_RPAR_in_sqlAttrSpecList4468 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_sqlBooleanOp0 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_qname_in_sqlAttrSpec4513 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_VAR_in_sqlAttrSpec4524 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_numericliteral_in_sqlAttrSpec4589 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_stringliteral_in_sqlAttrSpec4602 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_enclosedExpr_in_sqlAttrSpec4613 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_generalComp0 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_SPARQL_FOR_in_sparqlForClause4689 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_distinct_in_sparqlForClause4691 = new BitSet(new long[]{0x0000000000200010L});
    public static final BitSet FOLLOW_varOrFunction_in_sparqlForClause4696 = new BitSet(new long[]{0x0000000000200018L});
    public static final BitSet FOLLOW_datasetClause_in_sparqlForClause4708 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000008L,0x0000004004000000L});
    public static final BitSet FOLLOW_endpointClause_in_sparqlForClause4713 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000004004000000L});
    public static final BitSet FOLLOW_sWhereClause_in_sparqlForClause4716 = new BitSet(new long[]{0x0000000000000000L,0x00000000000000B0L,0x0000000000000000L,0x00000000000000C0L});
    public static final BitSet FOLLOW_solutionmodifier_in_sparqlForClause4718 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ENDPOINT_in_endpointClause6368 = new BitSet(new long[]{0x0080000000000010L});
    public static final BitSet FOLLOW_sourceSelector_in_endpointClause6372 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_VAR_in_varOrFunction6389 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LPAR_in_varOrFunction6412 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000000000004L});
    public static final BitSet FOLLOW_functionCall_in_varOrFunction6414 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_AS_in_varOrFunction6416 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_VAR_in_varOrFunction6420 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_RPAR_in_varOrFunction6422 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_singleForClause_in_forClause6448 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000008000000000L});
    public static final BitSet FOLLOW_T_FOR_in_singleForClause6463 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_VAR_in_singleForClause6467 = new BitSet(new long[]{0x0000000000001000L,0x0000000000000400L,0x0800000000000000L});
    public static final BitSet FOLLOW_T_TYPE_in_singleForClause6471 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_typeDeclaration_in_singleForClause6473 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_optionalPosClause_in_singleForClause6478 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_IN_in_optionalPosClause6497 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_exprSingle_in_optionalPosClause6499 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_AT_in_optionalPosClause6528 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_positionalVar_in_optionalPosClause6532 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_IN_in_optionalPosClause6536 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_exprSingle_in_optionalPosClause6538 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_VAR_in_positionalVar6572 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_singleLetClause_in_letClause6586 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000010000000000L});
    public static final BitSet FOLLOW_T_LET_in_singleLetClause6602 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_VAR_in_singleLetClause6614 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_typeDeclaration_in_singleLetClause6616 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_exprSingle_in_singleLetClause6626 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_WHERE_in_whereClause6730 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_exprSingle_in_whereClause6732 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_ORDER_BY_in_orderByClause6751 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_orderSpecList_in_orderByClause6753 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_STABLE_ORDER_BY_in_orderByClause6761 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_orderSpecList_in_orderByClause6763 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_orderSpec_in_orderSpecList6777 = new BitSet(new long[]{0xF800003EF9000082L,0x007FC00000008003L,0x7400000100400000L,0x0002000360000000L});
    public static final BitSet FOLLOW_exprSingle_in_orderSpec6792 = new BitSet(new long[]{0x0000000000000000L,0x0000000000803000L,0x0000000000000000L,0x0000000000100000L});
    public static final BitSet FOLLOW_orderModifier_in_orderSpec6794 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_orderModifier6807 = new BitSet(new long[]{0x0000000000000002L,0x0000000000800000L,0x0000000000000000L,0x0000000000100000L});
    public static final BitSet FOLLOW_EMPTY_in_orderModifier6817 = new BitSet(new long[]{0x0000000000000000L,0x0000000000600000L});
    public static final BitSet FOLLOW_set_in_orderModifier6819 = new BitSet(new long[]{0x0000000000000002L,0x0000000000800000L});
    public static final BitSet FOLLOW_COLLATION_in_orderModifier6830 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_uriliteral_in_orderModifier6832 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_quantifiedExpr6848 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_T_VAR_in_quantifiedExpr6856 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_VAR_in_quantifiedExpr6858 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000400L,0x0800000000000000L});
    public static final BitSet FOLLOW_T_TYPE_in_quantifiedExpr6862 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_typeDeclaration_in_quantifiedExpr6864 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_IN_in_quantifiedExpr6870 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_exprSingle_in_quantifiedExpr6872 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_SATISFIES_in_quantifiedExpr6879 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_exprSingle_in_quantifiedExpr6881 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_TYPESWITCH_in_typeSwitchExpr6897 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_expr_in_typeSwitchExpr6899 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000000000000L,0x0000000010000000L});
    public static final BitSet FOLLOW_caseClause_in_typeSwitchExpr6901 = new BitSet(new long[]{0xF800003EF9000090L,0x007FC00000008003L,0x7400000100400000L,0x0002000370000000L});
    public static final BitSet FOLLOW_VAR_in_typeSwitchExpr6904 = new BitSet(new long[]{0xF800003EF9000080L,0x007FC00000008003L,0x7400000100400000L,0x0002000360000000L});
    public static final BitSet FOLLOW_exprSingle_in_typeSwitchExpr6907 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_CASE_in_caseClause6921 = new BitSet(new long[]{0x0400600000000210L,0xF001020004000008L,0x000000000800001FL});
    public static final BitSet FOLLOW_VAR_in_caseClause6924 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_AS_in_caseClause6926 = new BitSet(new long[]{0x0400600000000210L,0xF001020004000008L,0x000000000800001FL});
    public static final BitSet FOLLOW_sequenceType_in_caseClause6930 = new BitSet(new long[]{0x0000000000000000L,0x0000000000040000L});
    public static final BitSet FOLLOW_RETURN_in_caseClause6932 = new BitSet(new long[]{0xF800003EF9000080L,0x007FC00000008003L,0x7400000100400000L,0x0002000360000000L});
    public static final BitSet FOLLOW_exprSingle_in_caseClause6934 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IF_in_ifExpr6949 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_exprSingle_in_ifExpr6951 = new BitSet(new long[]{0xF800003EF9000080L,0x007FC00000008003L,0x7400000100400000L,0x0002000360000000L});
    public static final BitSet FOLLOW_exprSingle_in_ifExpr6953 = new BitSet(new long[]{0xF800003EF9000080L,0x007FC00000008003L,0x7400000100400000L,0x0002000360000000L});
    public static final BitSet FOLLOW_exprSingle_in_ifExpr6955 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_andExpr_in_orExpr6969 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_OR_in_orExpr6976 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_orExpr_in_orExpr6978 = new BitSet(new long[]{0xF800003EF9000080L,0x007F400000000003L,0x7400000000400000L,0x0002000100000000L});
    public static final BitSet FOLLOW_andExpr_in_orExpr6980 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_comparisonExpr_in_andExpr6994 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_AND_in_andExpr7001 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_andExpr_in_andExpr7003 = new BitSet(new long[]{0xF800003EF9000080L,0x007F000000000003L,0x7400000000400000L,0x0002000100000000L});
    public static final BitSet FOLLOW_comparisonExpr_in_andExpr7005 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_rangeExpr_in_comparisonExpr7019 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_comparisonExpr7033 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_rangeExpr_in_comparisonExpr7191 = new BitSet(new long[]{0x00000000E1000080L,0x007F000000000000L,0x7400000000000000L,0x0002000100000000L});
    public static final BitSet FOLLOW_rangeExpr_in_comparisonExpr7193 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_additiveExpr_in_rangeExpr7212 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_TO_in_rangeExpr7219 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_rangeExpr_in_rangeExpr7221 = new BitSet(new long[]{0x00000000E1000080L,0x007E000000000000L,0x7400000000000000L,0x0002000100000000L});
    public static final BitSet FOLLOW_additiveExpr_in_rangeExpr7223 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_multiplicativeExpr_in_additiveExpr7237 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_additiveExpr7244 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_additiveExpr_in_additiveExpr7250 = new BitSet(new long[]{0x00000000E1000080L,0x007E000000000000L,0x7400000000000000L,0x0002000100000000L});
    public static final BitSet FOLLOW_multiplicativeExpr_in_additiveExpr7252 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_unionExpr_in_multiplicativeExpr7263 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_multiplicativeExpr7270 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_multiplicativeExpr_in_multiplicativeExpr7286 = new BitSet(new long[]{0x00000000E0000080L,0x0070000000000000L,0x7400000000000000L,0x0002000100000000L});
    public static final BitSet FOLLOW_unionExpr_in_multiplicativeExpr7288 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_intersectExceptExpr_in_unionExpr7302 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_unionExpr7309 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_unionExpr_in_unionExpr7317 = new BitSet(new long[]{0x0000000060000080L,0x0060000000000000L,0x7400000000000000L,0x0002000100000000L});
    public static final BitSet FOLLOW_intersectExceptExpr_in_unionExpr7319 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_instanceOfExpr_in_intersectExceptExpr7333 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_intersectExceptExpr7340 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_intersectExceptExpr_in_intersectExceptExpr7348 = new BitSet(new long[]{0x0000000060000080L,0x0000000000000000L,0x7400000000000000L,0x0002000100000000L});
    public static final BitSet FOLLOW_instanceOfExpr_in_intersectExceptExpr7350 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_treatExpr_in_instanceOfExpr7364 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_INSTANCEOF_in_instanceOfExpr7371 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_instanceOfExpr_in_instanceOfExpr7373 = new BitSet(new long[]{0x0400600000000210L,0xF001020004000008L,0x000000000800001FL});
    public static final BitSet FOLLOW_sequenceType_in_instanceOfExpr7375 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_castableExpr_in_treatExpr7389 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_TREATAS_in_treatExpr7396 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_treatExpr_in_treatExpr7398 = new BitSet(new long[]{0x0400600000000210L,0xF001020004000008L,0x000000000800001FL});
    public static final BitSet FOLLOW_sequenceType_in_treatExpr7400 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_castExpr_in_castableExpr7414 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_CASTABLEAS_in_castableExpr7421 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_castableExpr_in_castableExpr7423 = new BitSet(new long[]{0x0400600000000200L,0x2001000000000008L,0x0000000008000002L});
    public static final BitSet FOLLOW_singleType_in_castableExpr7425 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_unaryExpr_in_castExpr7439 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_CASTAS_in_castExpr7446 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_castExpr_in_castExpr7448 = new BitSet(new long[]{0x0400600000000200L,0x2001000000000008L,0x0000000008000002L});
    public static final BitSet FOLLOW_singleType_in_castExpr7450 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_set_in_unaryExpr7464 = new BitSet(new long[]{0x0000000060000080L,0x0000000000000000L,0x0000000000000000L,0x0002000100000000L});
    public static final BitSet FOLLOW_valueExpr_in_unaryExpr7473 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_pathExpr_in_valueExpr7486 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_validateExpr_in_valueExpr7492 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_extensionExpr_in_valueExpr7498 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_VALIDATE_in_validateExpr7511 = new BitSet(new long[]{0xF800003EF9000080L,0x007FC00000008003L,0x7400000100400000L,0x0002000768000000L});
    public static final BitSet FOLLOW_validationMode_in_validateExpr7513 = new BitSet(new long[]{0xF800003EF9000080L,0x007FC00000008003L,0x7400000100400000L,0x0002000360000000L});
    public static final BitSet FOLLOW_expr_in_validateExpr7516 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_validationMode0 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LCURLY_in_extensionExpr7553 = new BitSet(new long[]{0xF800003EF9000180L,0x007FC00000008003L,0x7400000100400000L,0x0002000360000000L});
    public static final BitSet FOLLOW_expr_in_extensionExpr7555 = new BitSet(new long[]{0x0000000000000100L});
    public static final BitSet FOLLOW_RCURLY_in_extensionExpr7558 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_XPATH_in_pathExpr7572 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_SLASH_in_pathExpr7574 = new BitSet(new long[]{0x0000000000040000L});
    public static final BitSet FOLLOW_SLASH_in_pathExpr7576 = new BitSet(new long[]{0x0400600003001E50L,0xF001023FFF000008L,0x020000002800003FL,0x0020000000000004L});
    public static final BitSet FOLLOW_relativePathExpr_in_pathExpr7578 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_XPATH_in_pathExpr7586 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_SLASH_in_pathExpr7588 = new BitSet(new long[]{0x0400600003001E50L,0xF001023FFF000008L,0x020000002800003FL,0x0020000000000004L});
    public static final BitSet FOLLOW_relativePathExpr_in_pathExpr7590 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_XPATH_in_pathExpr7598 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_SLASH_in_pathExpr7600 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_XPATH_in_pathExpr7608 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_relativePathExpr_in_pathExpr7610 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_stepExpr_in_relativePathExpr7633 = new BitSet(new long[]{0x0000000000040002L});
    public static final BitSet FOLLOW_SLASH_in_relativePathExpr7636 = new BitSet(new long[]{0x0400600003041E50L,0xF001023FFF000008L,0x020000002800003FL,0x0020000000000004L});
    public static final BitSet FOLLOW_SLASH_in_relativePathExpr7638 = new BitSet(new long[]{0x0400600003001E50L,0xF001023FFF000008L,0x020000002800003FL,0x0020000000000004L});
    public static final BitSet FOLLOW_stepExpr_in_relativePathExpr7641 = new BitSet(new long[]{0x0000000000040002L});
    public static final BitSet FOLLOW_filterExpr_in_stepExpr7659 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_axisStep_in_stepExpr7665 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_reverseStep_in_axisStep7679 = new BitSet(new long[]{0x0000000000080000L});
    public static final BitSet FOLLOW_forwardStep_in_axisStep7683 = new BitSet(new long[]{0x0000000000080000L});
    public static final BitSet FOLLOW_predicateList_in_axisStep7686 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_forwardAxis_in_forwardStep7699 = new BitSet(new long[]{0x0400600003001E50L,0xF001023FFF000008L,0x020000002800003FL,0x0020000000000004L});
    public static final BitSet FOLLOW_nodeTest_in_forwardStep7701 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_abbrevForwardStep_in_forwardStep7707 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_CHILD_in_forwardAxis7720 = new BitSet(new long[]{0x0000004000000000L});
    public static final BitSet FOLLOW_COLONCOLON_in_forwardAxis7722 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DESCENDANT_in_forwardAxis7728 = new BitSet(new long[]{0x0000004000000000L});
    public static final BitSet FOLLOW_COLONCOLON_in_forwardAxis7730 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ATTRIBUTE_in_forwardAxis7736 = new BitSet(new long[]{0x0000004000000000L});
    public static final BitSet FOLLOW_COLONCOLON_in_forwardAxis7738 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_SELF_in_forwardAxis7744 = new BitSet(new long[]{0x0000004000000000L});
    public static final BitSet FOLLOW_COLONCOLON_in_forwardAxis7746 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DESCENDANTORSELF_in_forwardAxis7752 = new BitSet(new long[]{0x0000004000000000L});
    public static final BitSet FOLLOW_COLONCOLON_in_forwardAxis7754 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FOLLOWINGSIBLING_in_forwardAxis7760 = new BitSet(new long[]{0x0000004000000000L});
    public static final BitSet FOLLOW_COLONCOLON_in_forwardAxis7762 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FOLLOWING_in_forwardAxis7768 = new BitSet(new long[]{0x0000004000000000L});
    public static final BitSet FOLLOW_COLONCOLON_in_forwardAxis7770 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_AT_in_abbrevForwardStep7783 = new BitSet(new long[]{0x0400600003001E50L,0xF001023FFF000008L,0x020000002800003FL,0x0020000000000004L});
    public static final BitSet FOLLOW_nodeTest_in_abbrevForwardStep7786 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_reverseAxis_in_reverseStep7799 = new BitSet(new long[]{0x0400600003001E50L,0xF001023FFF000008L,0x020000002800003FL,0x0020000000000004L});
    public static final BitSet FOLLOW_nodeTest_in_reverseStep7801 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_abbrevReverseStep_in_reverseStep7807 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PARENT_in_reverseAxis7820 = new BitSet(new long[]{0x0000004000000000L});
    public static final BitSet FOLLOW_COLONCOLON_in_reverseAxis7822 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ANCESTOR_in_reverseAxis7828 = new BitSet(new long[]{0x0000004000000000L});
    public static final BitSet FOLLOW_COLONCOLON_in_reverseAxis7830 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PRECEDINGSIBLING_in_reverseAxis7836 = new BitSet(new long[]{0x0000004000000000L});
    public static final BitSet FOLLOW_COLONCOLON_in_reverseAxis7838 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PRECEDING_in_reverseAxis7844 = new BitSet(new long[]{0x0000004000000000L});
    public static final BitSet FOLLOW_COLONCOLON_in_reverseAxis7846 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ANCESTORORSELF_in_reverseAxis7852 = new BitSet(new long[]{0x0000004000000000L});
    public static final BitSet FOLLOW_COLONCOLON_in_reverseAxis7854 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DOTDOT_in_abbrevReverseStep7867 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_kindTest_in_nodeTest7880 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_nameTest_in_nodeTest7886 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_qname_in_nameTest7899 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_wildCard_in_nameTest7905 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STAR_in_wildCard7918 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STAR_in_wildCard7924 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_COLON_in_wildCard7926 = new BitSet(new long[]{0x0000000000000200L});
    public static final BitSet FOLLOW_NCNAME_in_wildCard7928 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_NCNAME_in_wildCard7934 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_COLON_in_wildCard7936 = new BitSet(new long[]{0x0000000001000000L});
    public static final BitSet FOLLOW_STAR_in_wildCard7938 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_primaryExpr_in_filterExpr7951 = new BitSet(new long[]{0x0000000000080000L});
    public static final BitSet FOLLOW_predicateList_in_filterExpr7953 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_predicate_in_predicateList7966 = new BitSet(new long[]{0x0000000000080002L});
    public static final BitSet FOLLOW_LBRACKET_in_predicate7980 = new BitSet(new long[]{0xF800003EF9000080L,0x007FC00000008003L,0x7400000100400000L,0x0002000360000000L});
    public static final BitSet FOLLOW_expr_in_predicate7982 = new BitSet(new long[]{0x0000000000100000L});
    public static final BitSet FOLLOW_RBRACKET_in_predicate7984 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_varRef_in_primaryExpr7997 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_literal_in_primaryExpr8003 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_parenthesizedExpr_in_primaryExpr8009 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_contextItemExpr_in_primaryExpr8015 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_functionCall_in_primaryExpr8021 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_orderedExpr_in_primaryExpr8027 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_unorderedExpr_in_primaryExpr8033 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_constructor_in_primaryExpr8039 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_numericliteral_in_literal8052 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_stringliteral_in_literal8058 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_integerLiteral_in_numericliteral8071 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_decimalLiteral_in_numericliteral8077 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_VAR_in_varRef8096 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_qname_in_varName8143 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_PAR_in_parenthesizedExpr8157 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_expr_in_parenthesizedExpr8159 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_DOT_in_contextItemExpr8174 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ORDERED_in_orderedExpr8187 = new BitSet(new long[]{0xF800003EF9000080L,0x007FC00000008003L,0x7400000100400000L,0x0002000360000000L});
    public static final BitSet FOLLOW_expr_in_orderedExpr8189 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_UNORDERED_in_unorderedExpr8202 = new BitSet(new long[]{0xF800003EF9000080L,0x007FC00000008003L,0x7400000100400000L,0x0002000360000000L});
    public static final BitSet FOLLOW_expr_in_unorderedExpr8204 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_FUNCTION_CALL_in_functionCall8219 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_qname_in_functionCall8221 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000400000000L});
    public static final BitSet FOLLOW_T_PARAMS_in_functionCall8224 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_exprSingle_in_functionCall8226 = new BitSet(new long[]{0xF800003EF9000088L,0x007FC00000008003L,0x7400000100400000L,0x0002000360000000L});
    public static final BitSet FOLLOW_directConstructor_in_constructor8242 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_computedConstructor_in_constructor8248 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_dirElemConstructor_in_directConstructor8261 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_XML_ELEMENT_in_dirElemConstructor8277 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_qname_in_dirElemConstructor8279 = new BitSet(new long[]{0x0000000000000008L,0x0000000000000000L,0x00000000C0000000L});
    public static final BitSet FOLLOW_dirAttributeList_in_dirElemConstructor8281 = new BitSet(new long[]{0x0000000000000008L,0x0000000000000000L,0x0000000040000000L});
    public static final BitSet FOLLOW_T_XML_CONTENT_in_dirElemConstructor8286 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_dirElemContent_in_dirElemConstructor8288 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_dirAttribute_in_dirAttributeList8307 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0000000080000000L});
    public static final BitSet FOLLOW_T_XML_ATTRIBUTE_in_dirAttribute8322 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_qname_in_dirAttribute8324 = new BitSet(new long[]{0xFC00603EF90006D0L,0x207FC0000000800BL,0x7400000108400002L,0x0022000360000000L});
    public static final BitSet FOLLOW_dirAttributeValue_in_dirAttribute8326 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_enclosedExpr_in_dirAttributeValue8340 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_QSTRING_in_dirAttributeValue8346 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_directConstructor_in_dirElemContent8359 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_commonContent_in_dirElemContent8365 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_WHITESPACE_in_dirElemContent8371 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_NCNAMEELM_in_dirElemContent8378 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_cDataSection_in_dirElemContent8385 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LCURLY_in_commonContent8398 = new BitSet(new long[]{0xF800003EF9000080L,0x007FC00000008003L,0x7400000100400000L,0x0002000360000000L});
    public static final BitSet FOLLOW_expr_in_commonContent8400 = new BitSet(new long[]{0x0000000000000100L});
    public static final BitSet FOLLOW_RCURLY_in_commonContent8402 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LCURLY_in_commonContent8416 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_LCURLY_in_commonContent8418 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_RCURLY_in_commonContent8424 = new BitSet(new long[]{0x0000000000000100L});
    public static final BitSet FOLLOW_RCURLY_in_commonContent8426 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_CDATASTART_in_cDataSection8439 = new BitSet(new long[]{0x0001000000000000L});
    public static final BitSet FOLLOW_CDATAELMEND_in_cDataSection8441 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_compDocConstructor_in_computedConstructor8454 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_compElemConstructor_in_computedConstructor8460 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_compAttrConstructor_in_computedConstructor8466 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_compTextConstructor_in_computedConstructor8472 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_compCommentConstructor_in_computedConstructor8478 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_compPIConstructor_in_computedConstructor8484 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DOCUMENT_in_compDocConstructor8497 = new BitSet(new long[]{0xFC00603EF90006D0L,0x207FC0000000800BL,0x7400000108400002L,0x0022000360000000L});
    public static final BitSet FOLLOW_enclosedExpr_in_compDocConstructor8499 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ELEMENT_in_compElemConstructor8512 = new BitSet(new long[]{0x0400600000000280L,0x2001000000000008L,0x0000000008000002L});
    public static final BitSet FOLLOW_qname_in_compElemConstructor8516 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_enclosedExpr__in_compElemConstructor8520 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_LCURLY_in_compElemConstructor8523 = new BitSet(new long[]{0xF800003EF9000180L,0x007FC00000008003L,0x7400000100400000L,0x0002000360000000L});
    public static final BitSet FOLLOW_contentExpr_in_compElemConstructor8525 = new BitSet(new long[]{0x0000000000000100L});
    public static final BitSet FOLLOW_RCURLY_in_compElemConstructor8528 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_expr_in_contentExpr8541 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ATTRIBUTE_in_compAttrConstructor8554 = new BitSet(new long[]{0xFC00603EF90006D0L,0x207FC0000000800BL,0x7400000108400002L,0x0022000360000000L});
    public static final BitSet FOLLOW_qname_in_compAttrConstructor8557 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_enclosedExpr_in_compAttrConstructor8561 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_LCURLY_in_compAttrConstructor8564 = new BitSet(new long[]{0xF800003EF9000180L,0x007FC00000008003L,0x7400000100400000L,0x0002000360000000L});
    public static final BitSet FOLLOW_expr_in_compAttrConstructor8566 = new BitSet(new long[]{0x0000000000000100L});
    public static final BitSet FOLLOW_RCURLY_in_compAttrConstructor8569 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_TEXT_in_compTextConstructor8582 = new BitSet(new long[]{0x0400600000000280L,0x2001000000000008L,0x0000000008000002L});
    public static final BitSet FOLLOW_enclosedExpr__in_compTextConstructor8584 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_COMMENT_in_compCommentConstructor8597 = new BitSet(new long[]{0xFC00603EF90006D0L,0x207FC0000000800BL,0x7400000108400002L,0x0022000360000000L});
    public static final BitSet FOLLOW_enclosedExpr_in_compCommentConstructor8599 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PROCESSINGINSTRUCTION_in_compPIConstructor8612 = new BitSet(new long[]{0xFC00603EF90006D0L,0x207FC0000000800BL,0x7400000108400002L,0x0022000360000000L});
    public static final BitSet FOLLOW_NCNAME_in_compPIConstructor8616 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_enclosedExpr_in_compPIConstructor8620 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_LCURLY_in_compPIConstructor8623 = new BitSet(new long[]{0xF800003EF9000180L,0x007FC00000008003L,0x7400000100400000L,0x0002000360000000L});
    public static final BitSet FOLLOW_expr_in_compPIConstructor8625 = new BitSet(new long[]{0x0000000000000100L});
    public static final BitSet FOLLOW_RCURLY_in_compPIConstructor8628 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_atomicType_in_singleType8641 = new BitSet(new long[]{0x0000000100000002L});
    public static final BitSet FOLLOW_QUESTIONMARK_in_singleType8643 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_sequenceType_in_typeDeclaration8657 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_EMPTYSEQUENCE_in_sequenceType8670 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_LPAR_in_sequenceType8672 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_RPAR_in_sequenceType8674 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_itemType_in_sequenceType8680 = new BitSet(new long[]{0x0000000121000002L});
    public static final BitSet FOLLOW_occurrenceIndicator_in_sequenceType8682 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_occurrenceIndicator0 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ITEM_in_itemType8717 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_LPAR_in_itemType8719 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_RPAR_in_itemType8721 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_atomicType_in_itemType8727 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_kindTest_in_itemType8733 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_qname_in_atomicType8746 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_documentTest_in_kindTest8759 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_elementTest_in_kindTest8765 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_attributeTest_in_kindTest8771 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_schemaElementTest_in_kindTest8777 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_schemaAttributeTest_in_kindTest8783 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_piTest_in_kindTest8789 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_commentTest_in_kindTest8795 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_textTest_in_kindTest8801 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_anyKindTest_in_kindTest8807 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_NODE_in_anyKindTest8820 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_LPAR_in_anyKindTest8822 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_RPAR_in_anyKindTest8824 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DOCUMENTNODE_in_documentTest8837 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_LPAR_in_documentTest8839 = new BitSet(new long[]{0x0000000000400000L,0x0000020000000000L,0x0000000000000010L});
    public static final BitSet FOLLOW_elementTest_in_documentTest8842 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_schemaElementTest_in_documentTest8846 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_RPAR_in_documentTest8850 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_TEXT_in_textTest8863 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_LPAR_in_textTest8865 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_RPAR_in_textTest8867 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_COMMENT_in_commentTest8880 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_LPAR_in_commentTest8882 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_RPAR_in_commentTest8884 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PROCESSINGINSTRUCTION_in_piTest8897 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_LPAR_in_piTest8899 = new BitSet(new long[]{0x0000000000400600L});
    public static final BitSet FOLLOW_NCNAME_in_piTest8902 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_stringliteral_in_piTest8906 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_RPAR_in_piTest8910 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ATTRIBUTE_in_attributeTest8923 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_LPAR_in_attributeTest8925 = new BitSet(new long[]{0x0400600001400200L,0x2001000000000008L,0x0000000008000002L});
    public static final BitSet FOLLOW_attributeNameOrWildcard_in_attributeTest8928 = new BitSet(new long[]{0x0000000000420000L});
    public static final BitSet FOLLOW_COMMA_in_attributeTest8931 = new BitSet(new long[]{0x0400600000000200L,0x2001000000000008L,0x0000000008000002L});
    public static final BitSet FOLLOW_typeName_in_attributeTest8933 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_RPAR_in_attributeTest8939 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_attributeName_in_attributeNameOrWildcard8952 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STAR_in_attributeNameOrWildcard8956 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_SCHEMAATTRIBUTE_in_schemaAttributeTest8969 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_LPAR_in_schemaAttributeTest8971 = new BitSet(new long[]{0x0400600000000200L,0x2001000000000008L,0x0000000008000002L});
    public static final BitSet FOLLOW_attributeDeclaration_in_schemaAttributeTest8973 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_RPAR_in_schemaAttributeTest8975 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_attributeName_in_attributeDeclaration8988 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ELEMENT_in_elementTest9001 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_LPAR_in_elementTest9003 = new BitSet(new long[]{0x0400600001400200L,0x2001000000000008L,0x0000000008000002L});
    public static final BitSet FOLLOW_elementNameOrWildcard_in_elementTest9006 = new BitSet(new long[]{0x0000000000420000L});
    public static final BitSet FOLLOW_COMMA_in_elementTest9009 = new BitSet(new long[]{0x0400600000000200L,0x2001000000000008L,0x0000000008000002L});
    public static final BitSet FOLLOW_typeName_in_elementTest9011 = new BitSet(new long[]{0x0000000100400000L});
    public static final BitSet FOLLOW_QUESTIONMARK_in_elementTest9013 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_RPAR_in_elementTest9020 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_elementName_in_elementNameOrWildcard9033 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STAR_in_elementNameOrWildcard9037 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_SCHEMAELEMENT_in_schemaElementTest9050 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_LPAR_in_schemaElementTest9052 = new BitSet(new long[]{0x0400600000000200L,0x2001000000000008L,0x0000000008000002L});
    public static final BitSet FOLLOW_elementDeclaration_in_schemaElementTest9054 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_RPAR_in_schemaElementTest9056 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_elementName_in_elementDeclaration9069 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_qname_in_attributeName9082 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_qname_in_elementName9095 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_qname_in_typeName9108 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_stringliteral_in_uriliteral9121 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_INTEGER_in_integerLiteral9134 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DECIMAL_in_decimalLiteral9147 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_QSTRING_in_stringliteral9160 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_NAMESPACE_in_baseDecl9190 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_DEFAULT_in_baseDecl9192 = new BitSet(new long[]{0x0080000000000000L});
    public static final BitSet FOLLOW_IRIREF_in_baseDecl9196 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_NAMESPACE_in_prefixDecl9213 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_DEFAULT_in_prefixDecl9215 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_QSTRING_in_prefixDecl9219 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_NAMESPACE_in_prefixDecl9232 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_PNAME_NS_in_prefixDecl9236 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_QSTRING_in_prefixDecl9240 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_FROM_in_datasetClause9272 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_defaultGraphClause_in_datasetClause9279 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_namedGraphClause_in_datasetClause9285 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_sourceSelector_in_defaultGraphClause9316 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_NAMED_in_namedGraphClause9331 = new BitSet(new long[]{0x0080000000000010L});
    public static final BitSet FOLLOW_sourceSelector_in_namedGraphClause9333 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IRIREF_in_sourceSelector9357 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_VAR_in_sourceSelector9372 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_SPARQL_WHERE_in_sWhereClause9473 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_groupGraphPattern_in_sWhereClause9475 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_orderclause_in_solutionmodifier9503 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000030L});
    public static final BitSet FOLLOW_limitoffsetclauses_in_solutionmodifier9505 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_groupBy_in_solutionmodifier9512 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000030L,0x0000000000000000L,0x0000000000000080L});
    public static final BitSet FOLLOW_having_in_solutionmodifier9515 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000030L});
    public static final BitSet FOLLOW_limitoffsetclauses_in_solutionmodifier9518 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_GROUP_BY_in_groupBy9534 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_VAR_in_groupBy9536 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_HAVING_in_having9551 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_exprSingle_in_having9553 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_limitclause_in_limitoffsetclauses9567 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000030L});
    public static final BitSet FOLLOW_offsetclause_in_limitoffsetclauses9569 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_offsetclause_in_limitoffsetclauses9576 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000010L});
    public static final BitSet FOLLOW_limitclause_in_limitoffsetclauses9578 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ORDER_in_orderclause9595 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_orderCondition_in_orderclause9597 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_set_in_orderCondition9620 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_brackettedExpression_in_orderCondition9628 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_constraint_in_orderCondition9634 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_VAR_in_orderCondition9642 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LIMIT_in_limitclause9663 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_INTEGER_in_limitclause9667 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_OFFSET_in_offsetclause9691 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_INTEGER_in_offsetclause9695 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_singleGroupGraphPattern_in_groupGraphPattern9725 = new BitSet(new long[]{0x0000000000000002L,0x0010000000000000L,0x0020000000200180L});
    public static final BitSet FOLLOW_triplesBlock_in_singleGroupGraphPattern9761 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_graphPatternNotTriples_in_singleGroupGraphPattern9767 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_filter_in_singleGroupGraphPattern9773 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_triplesSameSubject_in_triplesBlock9788 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0020000000000000L});
    public static final BitSet FOLLOW_optionalGraphPattern_in_graphPatternNotTriples9802 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_groupOrUnionGraphPattern_in_graphPatternNotTriples9808 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_graphGraphPattern_in_graphPatternNotTriples9814 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_OPTIONAL_in_optionalGraphPattern9830 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_groupGraphPattern_in_optionalGraphPattern9832 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_GRAPH_in_graphGraphPattern9858 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_varOrIRIref_in_graphGraphPattern9860 = new BitSet(new long[]{0x0000000000000000L,0x0010000000000000L,0x0020000000200180L});
    public static final BitSet FOLLOW_groupGraphPattern_in_graphGraphPattern9862 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_UNION_in_groupOrUnionGraphPattern9890 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_T_UNION_in_groupOrUnionGraphPattern9893 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_groupGraphPattern_in_groupOrUnionGraphPattern9897 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_UNION_in_groupOrUnionGraphPattern9902 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_groupGraphPattern_in_groupOrUnionGraphPattern9906 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_FILTER_in_filter9948 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_constraint_in_filter9950 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_brackettedExpression_in_constraint9973 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_builtInCall_in_constraint9979 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_sFunctionCall_in_constraint9985 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_iRIref_in_sFunctionCall9998 = new BitSet(new long[]{0x0038003C79240452L,0x0000000000000000L,0x00000000001FFE00L,0x0000000000000004L});
    public static final BitSet FOLLOW_arglist_in_sFunctionCall10000 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_expression_in_arglist10024 = new BitSet(new long[]{0x0038003C79240452L,0x0000000000000000L,0x00000000001FFE00L,0x0000000000000004L});
    public static final BitSet FOLLOW_expression_in_arglist10028 = new BitSet(new long[]{0x0038003C79240452L,0x0000000000000000L,0x00000000001FFE00L,0x0000000000000004L});
    public static final BitSet FOLLOW_constructTriples_in_constructTemplate10056 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_triplesSameSubject__in_constructTriples10071 = new BitSet(new long[]{0xFC00603EF90006D2L,0x207FC0000000800BL,0x7420000108400002L,0x0022000360000000L});
    public static final BitSet FOLLOW_enclosedExpr_in_constructTriples10075 = new BitSet(new long[]{0xFC00603EF90006D2L,0x207FC0000000800BL,0x7420000108400002L,0x0022000360000000L});
    public static final BitSet FOLLOW_T_SUBJECT_in_triplesSameSubject10095 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_subject_in_triplesSameSubject10097 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0040000000000000L});
    public static final BitSet FOLLOW_propertyListNotEmpty_in_triplesSameSubject10099 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_SUBJECT_in_triplesSameSubject10122 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_triplesNode_in_triplesSameSubject10124 = new BitSet(new long[]{0x0000000000000008L,0x0000000000000000L,0x0040000000000000L});
    public static final BitSet FOLLOW_propertyListNotEmpty_in_triplesSameSubject10126 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_SUBJECT_in_triplesSameSubject_10172 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_subject__in_triplesSameSubject_10184 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0040000000000000L});
    public static final BitSet FOLLOW_propertyListNotEmpty__in_triplesSameSubject_10192 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_bnode_in_triplesSameSubject_10214 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0040000000000000L});
    public static final BitSet FOLLOW_propertyListNotEmpty__in_triplesSameSubject_10222 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_blankConstruct_in_triplesSameSubject_10729 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0040000000000000L});
    public static final BitSet FOLLOW_propertyListNotEmpty__in_triplesSameSubject_10735 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_constructVar_in_triplesSameSubject_10963 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0040000000000000L});
    public static final BitSet FOLLOW_propertyListNotEmpty__in_triplesSameSubject_10976 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_enclosedExpr_in_triplesSameSubject_11202 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0040000000000000L});
    public static final BitSet FOLLOW_propertyListNotEmpty__in_triplesSameSubject_11224 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_iriConstruct_in_triplesSameSubject_11523 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0040000000000000L});
    public static final BitSet FOLLOW_propertyListNotEmpty__in_triplesSameSubject_11545 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_collection_in_triplesSameSubject_11869 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0040000000000000L});
    public static final BitSet FOLLOW_propertyListNotEmpty__in_triplesSameSubject_11885 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_ANON_BLANK_in_triplesSameSubject_11900 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0040000000000000L});
    public static final BitSet FOLLOW_T_EMPTY_ANON_BLANK_in_triplesSameSubject_11904 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0040000000000000L});
    public static final BitSet FOLLOW_propertyListNotEmpty__in_triplesSameSubject_11909 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_VAR_in_constructVar12218 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_verbObjectList__in_propertyListNotEmpty_12296 = new BitSet(new long[]{0x0000000000000002L,0x0000000000000000L,0x0040000000000000L});
    public static final BitSet FOLLOW_T_VERB_in_verbObjectList_12328 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_verb__in_verbObjectList_12332 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0080000000000000L});
    public static final BitSet FOLLOW_objectList__in_verbObjectList_12336 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_VERB_in_verbObjectList_12351 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_iriConstruct_in_verbObjectList_12355 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0080000000000000L});
    public static final BitSet FOLLOW_objectList__in_verbObjectList_12359 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_VERB_in_verbObjectList_12604 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_constructVar_in_verbObjectList_12608 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0080000000000000L});
    public static final BitSet FOLLOW_objectList__in_verbObjectList_12612 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_VERB_in_propertyListNotEmpty12851 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_verb_in_propertyListNotEmpty12855 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0080000000000000L});
    public static final BitSet FOLLOW_objectList_in_propertyListNotEmpty12859 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_VERB_in_propertyListNotEmpty12864 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_verb_in_propertyListNotEmpty12868 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0080000000000000L});
    public static final BitSet FOLLOW_objectList_in_propertyListNotEmpty12872 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_propertyListNotEmpty_in_propertyList12918 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_propertyListNotEmpty__in_propertyList_12932 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_OBJECT_in_objectList_12947 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_object__in_objectList_12951 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_OBJECT_in_objectList_12956 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_object__in_objectList_12960 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_OBJECT_in_objectList12990 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_object_in_objectList12994 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_OBJECT_in_objectList12999 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_object_in_objectList13003 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_verb__in_subject_13045 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_resource_in_subject13063 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IRIREF_in_subject13071 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_blank_in_subject13084 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PNAME_LN_in_resource13111 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PNAME_NS_in_resource13126 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_VAR_in_resource13141 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_resource_in_verb13229 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_A_in_verb13237 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_sparqlPrefixedName_in_verb_13255 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IRIREF_in_verb_13263 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_A_in_verb_13276 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_verb__in_object_13304 = new BitSet(new long[]{0x0080400000000002L,0x0000000000000000L,0x0000000000000000L,0x0008000000000000L});
    public static final BitSet FOLLOW_namedGraph_in_object_13308 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_constructVar_in_object_13344 = new BitSet(new long[]{0x0080400000000002L,0x0000000000000000L,0x0000000000000000L,0x0008000000000000L});
    public static final BitSet FOLLOW_namedGraph_in_object_13348 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_bnode_in_object_13759 = new BitSet(new long[]{0x0080400000000002L,0x0000000000000000L,0x0000000000000000L,0x0008000000000000L});
    public static final BitSet FOLLOW_namedGraph_in_object_13763 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rdfLiteral_in_object_14213 = new BitSet(new long[]{0x0080400000000002L,0x0000000000000000L,0x0000000000000000L,0x0008000000000000L});
    public static final BitSet FOLLOW_namedGraph_in_object_14217 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_sNumericLiteral_in_object_14251 = new BitSet(new long[]{0x0080400000000002L,0x0000000000000000L,0x0000000000000000L,0x0008000000000000L});
    public static final BitSet FOLLOW_namedGraph_in_object_14255 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_blankConstruct_in_object_14291 = new BitSet(new long[]{0x0080400000000002L,0x0000000000000000L,0x0000000000000000L,0x0008000000000000L});
    public static final BitSet FOLLOW_namedGraph_in_object_14295 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_literalConstruct_in_object_14427 = new BitSet(new long[]{0x0080400000000002L,0x0000000000000000L,0x0000000000000000L,0x0008000000000000L});
    public static final BitSet FOLLOW_namedGraph_in_object_14431 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_iriConstruct_in_object_14630 = new BitSet(new long[]{0x0080400000000002L,0x0000000000000000L,0x0000000000000000L,0x0008000000000000L});
    public static final BitSet FOLLOW_namedGraph_in_object_14634 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_collection_in_object_14915 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_ANON_BLANK_in_object_14941 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0040000000000000L});
    public static final BitSet FOLLOW_propertyListNotEmpty__in_object_14943 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_EMPTY_ANON_BLANK_in_object_15020 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0040000000000000L});
    public static final BitSet FOLLOW_propertyListNotEmpty__in_object_15022 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_iri_in_namedGraph15062 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_resource_in_object15199 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_blank_in_object15205 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rdfLiteral_in_object15218 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_sNumericLiteral_in_object15224 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_triplesNode_in_object15230 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_collection_in_triplesNode15243 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_blankNodePropertyList_in_triplesNode15249 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_collection_in_triplesNode_15262 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_blankNodePropertyList__in_triplesNode_15268 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_ANON_BLANK_in_blankNodePropertyList15281 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0040000000000000L});
    public static final BitSet FOLLOW_propertyListNotEmpty_in_blankNodePropertyList15283 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_ANON_BLANK_in_blankNodePropertyList_15308 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0040000000000000L});
    public static final BitSet FOLLOW_propertyListNotEmpty__in_blankNodePropertyList_15310 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LPAR_in_collection15323 = new BitSet(new long[]{0x0080600000200450L,0x0000000000000000L,0x0008000000180000L});
    public static final BitSet FOLLOW_graphNode_in_collection15325 = new BitSet(new long[]{0x0080600000600450L,0x0000000000000000L,0x0008000000180000L});
    public static final BitSet FOLLOW_RPAR_in_collection15328 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_varOrTerm_in_graphNode15341 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_triplesNode_in_graphNode15347 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_VAR_in_varOrTerm15360 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_graphTerm_in_varOrTerm15366 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_LITERAL_CONSTRUCT_in_literalConstruct15380 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_enclosedExpr_in_literalConstruct15384 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_AT_in_literalConstruct15388 = new BitSet(new long[]{0xFC00603EF90006D0L,0x207FC0000000800BL,0x7400000108400002L,0x0022000360000000L});
    public static final BitSet FOLLOW_enclosedExpr_in_literalConstruct15392 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_LITERAL_CONSTRUCT_in_literalConstruct15499 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_enclosedExpr_in_literalConstruct15501 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_CARET_in_literalConstruct15505 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_CARET_in_literalConstruct15509 = new BitSet(new long[]{0x0080400000000000L,0x0000000000000000L,0x0000000000000000L,0x0008000000000000L});
    public static final BitSet FOLLOW_iri_in_literalConstruct15511 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_LITERAL_CONSTRUCT_in_literalConstruct15615 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_INTEGER_in_literalConstruct15617 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_AT_in_literalConstruct15619 = new BitSet(new long[]{0xFC00603EF90006D0L,0x207FC0000000800BL,0x7400000108400002L,0x0022000360000000L});
    public static final BitSet FOLLOW_enclosedExpr_in_literalConstruct15621 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_LITERAL_CONSTRUCT_in_literalConstruct15727 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_INTEGER_in_literalConstruct15729 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_CARET_in_literalConstruct15731 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_CARET_in_literalConstruct15733 = new BitSet(new long[]{0x0080400000000000L,0x0000000000000000L,0x0000000000000000L,0x0008000000000000L});
    public static final BitSet FOLLOW_iriConstruct_in_literalConstruct15735 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_LITERAL_CONSTRUCT_in_literalConstruct15840 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_QSTRING_in_literalConstruct15842 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_AT_in_literalConstruct15844 = new BitSet(new long[]{0xFC00603EF90006D0L,0x207FC0000000800BL,0x7400000108400002L,0x0022000360000000L});
    public static final BitSet FOLLOW_enclosedExpr_in_literalConstruct15846 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_LITERAL_CONSTRUCT_in_literalConstruct15951 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_QSTRING_in_literalConstruct15953 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_CARET_in_literalConstruct15957 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_CARET_in_literalConstruct15961 = new BitSet(new long[]{0x0080400000000000L,0x0000000000000000L,0x0000000000000000L,0x0008000000000000L});
    public static final BitSet FOLLOW_iriConstruct_in_literalConstruct15963 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_LITERAL_CONSTRUCT_in_literalConstruct16069 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_enclosedExpr_in_literalConstruct16071 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_VAR_in_varOrIRIref16145 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_iRIref_in_varOrIRIref16151 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_IRI_CONSTRUCT_in_iriConstruct16165 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_LESSTHANLCURLY_in_iriConstruct16176 = new BitSet(new long[]{0xF800003EF9000080L,0x007FC00000008003L,0x7400000100400000L,0x0002000360000000L});
    public static final BitSet FOLLOW_expr_in_iriConstruct16178 = new BitSet(new long[]{0x0002000000000000L});
    public static final BitSet FOLLOW_RCURLYGREATERTHAN_in_iriConstruct16182 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_enclosedExpr_in_iriConstruct16209 = new BitSet(new long[]{0x0400600000010200L,0x2001000000000008L,0x0000000008000002L});
    public static final BitSet FOLLOW_COLON_in_iriConstruct16222 = new BitSet(new long[]{0xFC00603EF90006D0L,0x207FC0000000800BL,0x7400000108400002L,0x0022000360000000L});
    public static final BitSet FOLLOW_enclosedExpr_in_iriConstruct16237 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_qname_in_iriConstruct16357 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_qname_in_iriConstruct16457 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_COLON_in_iriConstruct16461 = new BitSet(new long[]{0xFC00603EF90006D0L,0x207FC0000000800BL,0x7400000108400002L,0x0022000360000000L});
    public static final BitSet FOLLOW_enclosedExpr_in_iriConstruct16463 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_iRIref_in_graphTerm16554 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rdfLiteral_in_graphTerm16560 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_sNumericLiteral_in_graphTerm16566 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_booleanLiteral_in_graphTerm16572 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_BNODE_CONSTRUCT_in_blankConstruct16587 = new BitSet(new long[]{0xFC00603EF90006D0L,0x207FC0000000800BL,0x7400000108400002L,0x0022000360000000L});
    public static final BitSet FOLLOW_enclosedExpr_in_blankConstruct16589 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_conditionalOrExpression_in_expression16702 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_conditionalAndExpression_in_conditionalOrExpression16715 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ORSYMBOL_in_conditionalOrExpression16724 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_conditionalOrExpression_in_conditionalOrExpression16726 = new BitSet(new long[]{0x0030003C79240450L,0x0000000000000000L,0x00000000001FFE00L,0x0000000000000004L});
    public static final BitSet FOLLOW_conditionalAndExpression_in_conditionalOrExpression16728 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_valueLogical_in_conditionalAndExpression16753 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ANDSYMBOL_in_conditionalAndExpression16762 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_conditionalAndExpression_in_conditionalAndExpression16764 = new BitSet(new long[]{0x0020003C79240450L,0x0000000000000000L,0x00000000001FFE00L,0x0000000000000004L});
    public static final BitSet FOLLOW_valueLogical_in_conditionalAndExpression16766 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_relationalExpression_in_valueLogical16791 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_numericExpression_in_relationalExpression16804 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_EQUALS_in_relationalExpression16814 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_HAFENEQUALS_in_relationalExpression16820 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_LESSTHAN_in_relationalExpression16826 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_GREATERTHAN_in_relationalExpression16831 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_LESSTHANEQUALS_in_relationalExpression16837 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_GREATERTHANEQUALS_in_relationalExpression16843 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_numericExpression_in_relationalExpression16846 = new BitSet(new long[]{0x0020000061240450L,0x0000000000000000L,0x00000000001FFE00L,0x0000000000000004L});
    public static final BitSet FOLLOW_numericExpression_in_relationalExpression16848 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_additiveExpression_in_numericExpression16873 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_multiplicativeExpression_in_additiveExpression16886 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PLUS_in_additiveExpression16896 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_MINUS_in_additiveExpression16902 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_additiveExpression_in_additiveExpression16905 = new BitSet(new long[]{0x0020000061240450L,0x0000000000000000L,0x00000000001FFE00L,0x0000000000000004L});
    public static final BitSet FOLLOW_multiplicativeExpression_in_additiveExpression16907 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_unaryExpression_in_multiplicativeExpression16933 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STAR_in_multiplicativeExpression16943 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_SLASH_in_multiplicativeExpression16949 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_multiplicativeExpression_in_multiplicativeExpression16952 = new BitSet(new long[]{0x0020000060200450L,0x0000000000000000L,0x00000000001FFE00L,0x0000000000000004L});
    public static final BitSet FOLLOW_unaryExpression_in_multiplicativeExpression16954 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_NOT_in_unaryExpression16981 = new BitSet(new long[]{0x0020000060200450L,0x0000000000000000L,0x00000000001FFE00L,0x0000000000000004L});
    public static final BitSet FOLLOW_primaryExpression_in_unaryExpression16983 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PLUS_in_unaryExpression17000 = new BitSet(new long[]{0x0020000060200450L,0x0000000000000000L,0x00000000001FFE00L,0x0000000000000004L});
    public static final BitSet FOLLOW_primaryExpression_in_unaryExpression17002 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_MINUS_in_unaryExpression17021 = new BitSet(new long[]{0x0020000060200450L,0x0000000000000000L,0x00000000001FFE00L,0x0000000000000004L});
    public static final BitSet FOLLOW_primaryExpression_in_unaryExpression17023 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_primaryExpression_in_unaryExpression17040 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_brackettedExpression_in_primaryExpression17058 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_builtInCall_in_primaryExpression17064 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_iRIrefOrFunction_in_primaryExpression17070 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rdfLiteral_in_primaryExpression17076 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_sNumericLiteral_in_primaryExpression17082 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_booleanLiteral_in_primaryExpression17088 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_VAR_in_primaryExpression17102 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LPAR_in_brackettedExpression17176 = new BitSet(new long[]{0x0038003C79240450L,0x0000000000000000L,0x00000000001FFE00L,0x0000000000000004L});
    public static final BitSet FOLLOW_expression_in_brackettedExpression17178 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_RPAR_in_brackettedExpression17182 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STR_in_builtInCall17209 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_brackettedExpression_in_builtInCall17211 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LANG_in_builtInCall17228 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_brackettedExpression_in_builtInCall17230 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LANGMATCHES_in_builtInCall17247 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_LPAR_in_builtInCall17251 = new BitSet(new long[]{0x0038003C79240450L,0x0000000000000000L,0x00000000001FFE00L,0x0000000000000004L});
    public static final BitSet FOLLOW_expression_in_builtInCall17255 = new BitSet(new long[]{0x0000000000020000L});
    public static final BitSet FOLLOW_COMMA_in_builtInCall17259 = new BitSet(new long[]{0x0038003C79240450L,0x0000000000000000L,0x00000000001FFE00L,0x0000000000000004L});
    public static final BitSet FOLLOW_expression_in_builtInCall17263 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_RPAR_in_builtInCall17267 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DATATYPE_in_builtInCall17297 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_brackettedExpression_in_builtInCall17299 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_BOUND_in_builtInCall17316 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_LPAR_in_builtInCall17320 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_VAR_in_builtInCall17324 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_RPAR_in_builtInCall17328 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ISIRI_in_builtInCall17352 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_brackettedExpression_in_builtInCall17354 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ISURI_in_builtInCall17371 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_brackettedExpression_in_builtInCall17373 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ISBLANK_in_builtInCall17390 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_brackettedExpression_in_builtInCall17392 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ISLITERAL_in_builtInCall17409 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_brackettedExpression_in_builtInCall17411 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_regexExpression_in_builtInCall17426 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_REGEX_in_regexExpression17441 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_LPAR_in_regexExpression17445 = new BitSet(new long[]{0x0038003C79240450L,0x0000000000000000L,0x00000000001FFE00L,0x0000000000000004L});
    public static final BitSet FOLLOW_expression_in_regexExpression17449 = new BitSet(new long[]{0x0000000000020000L});
    public static final BitSet FOLLOW_COMMA_in_regexExpression17453 = new BitSet(new long[]{0x0038003C79240450L,0x0000000000000000L,0x00000000001FFE00L,0x0000000000000004L});
    public static final BitSet FOLLOW_expression_in_regexExpression17457 = new BitSet(new long[]{0x0000000000420000L});
    public static final BitSet FOLLOW_COMMA_in_regexExpression17462 = new BitSet(new long[]{0x0038003C79240450L,0x0000000000000000L,0x00000000001FFE00L,0x0000000000000004L});
    public static final BitSet FOLLOW_expression_in_regexExpression17467 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_RPAR_in_regexExpression17473 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_FUNCTION_CALL_in_iRIrefOrFunction17520 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_iRIref_in_iRIrefOrFunction17524 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0000000400000000L});
    public static final BitSet FOLLOW_T_PARAMS_in_iRIrefOrFunction17527 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_arglist_in_iRIrefOrFunction17529 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_QSTRING_in_rdfLiteral17561 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_QSTRING_in_rdfLiteral17574 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_AT_in_rdfLiteral17576 = new BitSet(new long[]{0x0400600000000200L,0x2001000000000008L,0x0000000008000002L});
    public static final BitSet FOLLOW_qname_in_rdfLiteral17578 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_QSTRING_in_rdfLiteral17595 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_CARET_in_rdfLiteral17599 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_CARET_in_rdfLiteral17603 = new BitSet(new long[]{0x0080400000000000L});
    public static final BitSet FOLLOW_IRIREF_in_rdfLiteral17609 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PNAME_LN_in_rdfLiteral17616 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_INTEGER_in_sNumericLiteral17645 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_TRUE_in_booleanLiteral17660 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FALSE_in_booleanLiteral17673 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_QSTRING_in_string17697 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IRIREF_in_iRIref17712 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_prefixedName_in_iRIref17718 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_prefixedName0 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_bnode_in_blank17750 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_EMPTY_ANON_BLANK_in_blank17756 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_VERB_in_predicateObjectList17791 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_verb_in_predicateObjectList17793 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0080000000000000L});
    public static final BitSet FOLLOW_objectList_in_predicateObjectList17795 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_PNAME_LN_in_iri17814 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IRIREF_in_iri17829 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_iriConstruct_in_iri17844 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_sparqlPrefixedName_in_resource_17857 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_VAR_in_resource_17863 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IRIREF_in_resource_17869 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_resource__in_rdfPredicate_17882 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_BLANK_NODE_LABEL_in_bnode17895 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PNAME_LN_in_sparqlPrefixedName17910 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PNAME_NS_in_sparqlPrefixedName17924 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_prefixedName_in_qname17944 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_unprefixedName_in_qname17950 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ITEM_in_keyword17963 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_TO_in_keyword17969 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FROM_in_keyword17975 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ROW_in_keyword17983 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_COMMENT_in_keyword17996 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_A_in_keyword18007 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_localPart_in_unprefixedName18018 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_NCNAME_in_localPart18031 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_keyword_in_localPart18037 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_exprSingle_in_synpred41_XSPARQLRewriter1987 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_qname_in_synpred74_XSPARQLRewriter4229 = new BitSet(new long[]{0x0000000000000800L});
    public static final BitSet FOLLOW_DOT_in_synpred74_XSPARQLRewriter4231 = new BitSet(new long[]{0x0400600000000200L,0x2001000000000008L,0x0000000008000002L});
    public static final BitSet FOLLOW_qname_in_synpred74_XSPARQLRewriter4235 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_sqlBooleanOp_in_synpred77_XSPARQLRewriter4391 = new BitSet(new long[]{0xFC00603EF92006D0L,0x207FC0000000800BL,0x7400000108400002L,0x0022000360000000L});
    public static final BitSet FOLLOW_sqlWhereSpecList_in_synpred77_XSPARQLRewriter4393 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_solutionmodifier_in_synpred93_XSPARQLRewriter4718 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_triplesSameSubject_in_synpred253_XSPARQLRewriter9788 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_T_VERB_in_synpred277_XSPARQLRewriter12864 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_verb_in_synpred277_XSPARQLRewriter12868 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000000L,0x0080000000000000L});
    public static final BitSet FOLLOW_objectList_in_synpred277_XSPARQLRewriter12872 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_LITERAL_CONSTRUCT_in_synpred316_XSPARQLRewriter15380 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_enclosedExpr_in_synpred316_XSPARQLRewriter15384 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_AT_in_synpred316_XSPARQLRewriter15388 = new BitSet(new long[]{0xFC00603EF90006D0L,0x207FC0000000800BL,0x7400000108400002L,0x0022000360000000L});
    public static final BitSet FOLLOW_enclosedExpr_in_synpred316_XSPARQLRewriter15392 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_LITERAL_CONSTRUCT_in_synpred317_XSPARQLRewriter15499 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_enclosedExpr_in_synpred317_XSPARQLRewriter15501 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_CARET_in_synpred317_XSPARQLRewriter15505 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_CARET_in_synpred317_XSPARQLRewriter15509 = new BitSet(new long[]{0x0080400000000000L,0x0000000000000000L,0x0000000000000000L,0x0008000000000000L});
    public static final BitSet FOLLOW_iri_in_synpred317_XSPARQLRewriter15511 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_LITERAL_CONSTRUCT_in_synpred318_XSPARQLRewriter15615 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_INTEGER_in_synpred318_XSPARQLRewriter15617 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_AT_in_synpred318_XSPARQLRewriter15619 = new BitSet(new long[]{0xFC00603EF90006D0L,0x207FC0000000800BL,0x7400000108400002L,0x0022000360000000L});
    public static final BitSet FOLLOW_enclosedExpr_in_synpred318_XSPARQLRewriter15621 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_LITERAL_CONSTRUCT_in_synpred319_XSPARQLRewriter15727 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_INTEGER_in_synpred319_XSPARQLRewriter15729 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_CARET_in_synpred319_XSPARQLRewriter15731 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_CARET_in_synpred319_XSPARQLRewriter15733 = new BitSet(new long[]{0x0080400000000000L,0x0000000000000000L,0x0000000000000000L,0x0008000000000000L});
    public static final BitSet FOLLOW_iriConstruct_in_synpred319_XSPARQLRewriter15735 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_LITERAL_CONSTRUCT_in_synpred320_XSPARQLRewriter15840 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_QSTRING_in_synpred320_XSPARQLRewriter15842 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_AT_in_synpred320_XSPARQLRewriter15844 = new BitSet(new long[]{0xFC00603EF90006D0L,0x207FC0000000800BL,0x7400000108400002L,0x0022000360000000L});
    public static final BitSet FOLLOW_enclosedExpr_in_synpred320_XSPARQLRewriter15846 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_T_LITERAL_CONSTRUCT_in_synpred321_XSPARQLRewriter15951 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_QSTRING_in_synpred321_XSPARQLRewriter15953 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_CARET_in_synpred321_XSPARQLRewriter15957 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_CARET_in_synpred321_XSPARQLRewriter15961 = new BitSet(new long[]{0x0080400000000000L,0x0000000000000000L,0x0000000000000000L,0x0008000000000000L});
    public static final BitSet FOLLOW_iriConstruct_in_synpred321_XSPARQLRewriter15963 = new BitSet(new long[]{0x0000000000000008L});

}